from object_library import all_couplings,Coupling 
from cmath import exp 
from function_library import complexconjugate,re,im,csc,sec,acsc,asec 
 
 
GC_1 = Coupling(name = 'GC_1',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(ZA11**2 - ZA12**2)*(vd*ZH11 - vu*ZH12)', 
	 order = {'QED':1} ) 
 
GC_2 = Coupling(name = 'GC_2',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(ZA11**2 - ZA12**2)*(vd*ZH21 - vu*ZH22)', 
	 order = {'QED':1} ) 
 
GC_3 = Coupling(name = 'GC_3',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(ZA11*ZA21 - ZA12*ZA22)*(vd*ZH11 - vu*ZH12)', 
	 order = {'QED':1} ) 
 
GC_4 = Coupling(name = 'GC_4',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(ZA11*ZA21 - ZA12*ZA22)*(vd*ZH21 - vu*ZH22)', 
	 order = {'QED':1} ) 
 
GC_5 = Coupling(name = 'GC_5',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(ZA21**2 - ZA22**2)*(vd*ZH11 - vu*ZH12)', 
	 order = {'QED':1} ) 
 
GC_6 = Coupling(name = 'GC_6',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(ZA21**2 - ZA22**2)*(vd*ZH21 - vu*ZH22)', 
	 order = {'QED':1} ) 
 
GC_7 = Coupling(name = 'GC_7',
	 value = '(g2**2*(vu*ZA11 + vd*ZA12)*(ZP12*ZP21 - ZP11*ZP22))/4.', 
	 order = {'QED':1} ) 
 
GC_8 = Coupling(name = 'GC_8',
	 value = '(g2**2*(vu*ZA11 + vd*ZA12)*(-(ZP12*ZP21) + ZP11*ZP22))/4.', 
	 order = {'QED':1} ) 
 
GC_9 = Coupling(name = 'GC_9',
	 value = '(g2**2*(vu*ZA21 + vd*ZA22)*(ZP12*ZP21 - ZP11*ZP22))/4.', 
	 order = {'QED':1} ) 
 
GC_10 = Coupling(name = 'GC_10',
	 value = '(g2**2*(vu*ZA21 + vd*ZA22)*(-(ZP12*ZP21) + ZP11*ZP22))/4.', 
	 order = {'QED':1} ) 
 
GC_11 = Coupling(name = 'GC_11',
	 value = '(ZA11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD11) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD12) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD13)) - ZA11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA12*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_12 = Coupling(name = 'GC_12',
	 value = '(ZA11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD11) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD12) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD13)) - ZA11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA12*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_13 = Coupling(name = 'GC_13',
	 value = '(ZA11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD11) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD12) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD13)) - ZA11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA12*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_14 = Coupling(name = 'GC_14',
	 value = '(ZA11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD11) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD12) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD13)) - ZA11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA12*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_15 = Coupling(name = 'GC_15',
	 value = '(ZA11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD11) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD12) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD13)) - ZA11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA12*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_16 = Coupling(name = 'GC_16',
	 value = '(ZA11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD11) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD12) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD13)) - ZA11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA12*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_17 = Coupling(name = 'GC_17',
	 value = '(ZA11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD21) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD22) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD23)) - ZA11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA12*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_18 = Coupling(name = 'GC_18',
	 value = '(ZA11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD21) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD22) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD23)) - ZA11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA12*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_19 = Coupling(name = 'GC_19',
	 value = '(ZA11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD21) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD22) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD23)) - ZA11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA12*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_20 = Coupling(name = 'GC_20',
	 value = '(ZA11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD21) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD22) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD23)) - ZA11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA12*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_21 = Coupling(name = 'GC_21',
	 value = '(ZA11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD21) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD22) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD23)) - ZA11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA12*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_22 = Coupling(name = 'GC_22',
	 value = '(ZA11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD21) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD22) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD23)) - ZA11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA12*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_23 = Coupling(name = 'GC_23',
	 value = '(ZA11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD31) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD32) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD33)) - ZA11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA12*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_24 = Coupling(name = 'GC_24',
	 value = '(ZA11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD31) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD32) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD33)) - ZA11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA12*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_25 = Coupling(name = 'GC_25',
	 value = '(ZA11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD31) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD32) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD33)) - ZA11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA12*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_26 = Coupling(name = 'GC_26',
	 value = '(ZA11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD31) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD32) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD33)) - ZA11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA12*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_27 = Coupling(name = 'GC_27',
	 value = '(ZA11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD31) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD32) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD33)) - ZA11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA12*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_28 = Coupling(name = 'GC_28',
	 value = '(ZA11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD31) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD32) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD33)) - ZA11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA12*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_29 = Coupling(name = 'GC_29',
	 value = '(ZA11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD41) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD42) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD43)) - ZA11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA12*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD41) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD42) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_30 = Coupling(name = 'GC_30',
	 value = '(ZA11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD41) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD42) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD43)) - ZA11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA12*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD41) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD42) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_31 = Coupling(name = 'GC_31',
	 value = '(ZA11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD41) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD42) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD43)) - ZA11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA12*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD41) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD42) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_32 = Coupling(name = 'GC_32',
	 value = '(ZA11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD41) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD42) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD43)) - ZA11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA12*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD41) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD42) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_33 = Coupling(name = 'GC_33',
	 value = '(ZA11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD41) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD42) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD43)) - ZA11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA12*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD41) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD42) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_34 = Coupling(name = 'GC_34',
	 value = '(ZA11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD41) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD42) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD43)) - ZA11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA12*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD41) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD42) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_35 = Coupling(name = 'GC_35',
	 value = '(ZA11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD51) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD52) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD53)) - ZA11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA12*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD51) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD52) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_36 = Coupling(name = 'GC_36',
	 value = '(ZA11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD51) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD52) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD53)) - ZA11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA12*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD51) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD52) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_37 = Coupling(name = 'GC_37',
	 value = '(ZA11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD51) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD52) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD53)) - ZA11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA12*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD51) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD52) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_38 = Coupling(name = 'GC_38',
	 value = '(ZA11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD51) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD52) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD53)) - ZA11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA12*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD51) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD52) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_39 = Coupling(name = 'GC_39',
	 value = '(ZA11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD51) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD52) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD53)) - ZA11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA12*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD51) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD52) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_40 = Coupling(name = 'GC_40',
	 value = '(ZA11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD51) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD52) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD53)) - ZA11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA12*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD51) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD52) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_41 = Coupling(name = 'GC_41',
	 value = '(ZA11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD61) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD62) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD63)) - ZA11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA12*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD61) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD62) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_42 = Coupling(name = 'GC_42',
	 value = '(ZA11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD61) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD62) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD63)) - ZA11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA12*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD61) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD62) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_43 = Coupling(name = 'GC_43',
	 value = '(ZA11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD61) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD62) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD63)) - ZA11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA12*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD61) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD62) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_44 = Coupling(name = 'GC_44',
	 value = '(ZA11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD61) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD62) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD63)) - ZA11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA12*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD61) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD62) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_45 = Coupling(name = 'GC_45',
	 value = '(ZA11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD61) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD62) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD63)) - ZA11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA12*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD61) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD62) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_46 = Coupling(name = 'GC_46',
	 value = '(ZA11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD61) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD62) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD63)) - ZA11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA12*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD61) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD62) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_47 = Coupling(name = 'GC_47',
	 value = '(ZA21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD11) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD12) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD13)) - ZA21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA22*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_48 = Coupling(name = 'GC_48',
	 value = '(ZA21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD11) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD12) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD13)) - ZA21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA22*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_49 = Coupling(name = 'GC_49',
	 value = '(ZA21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD11) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD12) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD13)) - ZA21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA22*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_50 = Coupling(name = 'GC_50',
	 value = '(ZA21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD11) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD12) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD13)) - ZA21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA22*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_51 = Coupling(name = 'GC_51',
	 value = '(ZA21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD11) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD12) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD13)) - ZA21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA22*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_52 = Coupling(name = 'GC_52',
	 value = '(ZA21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD11) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD12) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD13)) - ZA21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + ZA22*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD13)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_53 = Coupling(name = 'GC_53',
	 value = '(ZA21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD21) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD22) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD23)) - ZA21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA22*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_54 = Coupling(name = 'GC_54',
	 value = '(ZA21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD21) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD22) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD23)) - ZA21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA22*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_55 = Coupling(name = 'GC_55',
	 value = '(ZA21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD21) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD22) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD23)) - ZA21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA22*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_56 = Coupling(name = 'GC_56',
	 value = '(ZA21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD21) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD22) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD23)) - ZA21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA22*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_57 = Coupling(name = 'GC_57',
	 value = '(ZA21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD21) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD22) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD23)) - ZA21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA22*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_58 = Coupling(name = 'GC_58',
	 value = '(ZA21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD21) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD22) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD23)) - ZA21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + ZA22*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD23)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_59 = Coupling(name = 'GC_59',
	 value = '(ZA21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD31) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD32) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD33)) - ZA21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA22*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_60 = Coupling(name = 'GC_60',
	 value = '(ZA21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD31) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD32) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD33)) - ZA21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA22*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_61 = Coupling(name = 'GC_61',
	 value = '(ZA21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD31) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD32) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD33)) - ZA21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA22*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_62 = Coupling(name = 'GC_62',
	 value = '(ZA21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD31) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD32) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD33)) - ZA21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA22*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_63 = Coupling(name = 'GC_63',
	 value = '(ZA21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD31) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD32) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD33)) - ZA21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA22*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_64 = Coupling(name = 'GC_64',
	 value = '(ZA21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD31) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD32) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD33)) - ZA21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + ZA22*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD33)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_65 = Coupling(name = 'GC_65',
	 value = '(ZA21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD41) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD42) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD43)) - ZA21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA22*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD41) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD42) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_66 = Coupling(name = 'GC_66',
	 value = '(ZA21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD41) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD42) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD43)) - ZA21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA22*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD41) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD42) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_67 = Coupling(name = 'GC_67',
	 value = '(ZA21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD41) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD42) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD43)) - ZA21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA22*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD41) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD42) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_68 = Coupling(name = 'GC_68',
	 value = '(ZA21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD41) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD42) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD43)) - ZA21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA22*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD41) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD42) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_69 = Coupling(name = 'GC_69',
	 value = '(ZA21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD41) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD42) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD43)) - ZA21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA22*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD41) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD42) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_70 = Coupling(name = 'GC_70',
	 value = '(ZA21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD41) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD42) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD43)) - ZA21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + ZA22*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD41) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD42) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD43)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_71 = Coupling(name = 'GC_71',
	 value = '(ZA21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD51) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD52) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD53)) - ZA21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA22*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD51) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD52) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_72 = Coupling(name = 'GC_72',
	 value = '(ZA21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD51) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD52) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD53)) - ZA21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA22*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD51) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD52) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_73 = Coupling(name = 'GC_73',
	 value = '(ZA21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD51) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD52) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD53)) - ZA21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA22*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD51) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD52) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_74 = Coupling(name = 'GC_74',
	 value = '(ZA21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD51) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD52) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD53)) - ZA21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA22*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD51) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD52) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_75 = Coupling(name = 'GC_75',
	 value = '(ZA21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD51) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD52) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD53)) - ZA21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA22*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD51) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD52) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_76 = Coupling(name = 'GC_76',
	 value = '(ZA21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD51) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD52) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD53)) - ZA21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + ZA22*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD51) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD52) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD53)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_77 = Coupling(name = 'GC_77',
	 value = '(ZA21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD61) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD62) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD63)) - ZA21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA22*(Mu*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD61) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD62) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_78 = Coupling(name = 'GC_78',
	 value = '(ZA21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD61) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD62) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD63)) - ZA21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA22*(Mu*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD61) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD62) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_79 = Coupling(name = 'GC_79',
	 value = '(ZA21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD61) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD62) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD63)) - ZA21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA22*(Mu*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD61) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD62) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_80 = Coupling(name = 'GC_80',
	 value = '(ZA21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD61) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD62) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD63)) - ZA21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA22*(Mu*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD61) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD62) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_81 = Coupling(name = 'GC_81',
	 value = '(ZA21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD61) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD62) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD63)) - ZA21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA22*(Mu*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD61) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD62) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_82 = Coupling(name = 'GC_82',
	 value = '(ZA21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD61) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD62) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD63)) - ZA21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + ZA22*(Mu*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD61) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD62) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD63)) - complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_83 = Coupling(name = 'GC_83',
	 value = '(ZA11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE11) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE12) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE13)) - ZA11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA12*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_84 = Coupling(name = 'GC_84',
	 value = '(ZA11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE11) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE12) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE13)) - ZA11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA12*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_85 = Coupling(name = 'GC_85',
	 value = '(ZA11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE11) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE12) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE13)) - ZA11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA12*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_86 = Coupling(name = 'GC_86',
	 value = '(ZA11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE11) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE12) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE13)) - ZA11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA12*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_87 = Coupling(name = 'GC_87',
	 value = '(ZA11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE11) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE12) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE13)) - ZA11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA12*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_88 = Coupling(name = 'GC_88',
	 value = '(ZA11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE11) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE12) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE13)) - ZA11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA12*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_89 = Coupling(name = 'GC_89',
	 value = '(ZA11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE21) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE22) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE23)) - ZA11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA12*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_90 = Coupling(name = 'GC_90',
	 value = '(ZA11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE21) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE22) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE23)) - ZA11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA12*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_91 = Coupling(name = 'GC_91',
	 value = '(ZA11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE21) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE22) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE23)) - ZA11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA12*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_92 = Coupling(name = 'GC_92',
	 value = '(ZA11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE21) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE22) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE23)) - ZA11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA12*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_93 = Coupling(name = 'GC_93',
	 value = '(ZA11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE21) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE22) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE23)) - ZA11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA12*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_94 = Coupling(name = 'GC_94',
	 value = '(ZA11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE21) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE22) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE23)) - ZA11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA12*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_95 = Coupling(name = 'GC_95',
	 value = '(ZA11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE31) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE32) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE33)) - ZA11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA12*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_96 = Coupling(name = 'GC_96',
	 value = '(ZA11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE31) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE32) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE33)) - ZA11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA12*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_97 = Coupling(name = 'GC_97',
	 value = '(ZA11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE31) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE32) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE33)) - ZA11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA12*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_98 = Coupling(name = 'GC_98',
	 value = '(ZA11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE31) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE32) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE33)) - ZA11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA12*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_99 = Coupling(name = 'GC_99',
	 value = '(ZA11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE31) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE32) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE33)) - ZA11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA12*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_100 = Coupling(name = 'GC_100',
	 value = '(ZA11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE31) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE32) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE33)) - ZA11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA12*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_101 = Coupling(name = 'GC_101',
	 value = '(ZA11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE41) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE42) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE43)) - ZA11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA12*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE41) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE42) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_102 = Coupling(name = 'GC_102',
	 value = '(ZA11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE41) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE42) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE43)) - ZA11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA12*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE41) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE42) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_103 = Coupling(name = 'GC_103',
	 value = '(ZA11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE41) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE42) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE43)) - ZA11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA12*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE41) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE42) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_104 = Coupling(name = 'GC_104',
	 value = '(ZA11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE41) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE42) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE43)) - ZA11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA12*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE41) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE42) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_105 = Coupling(name = 'GC_105',
	 value = '(ZA11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE41) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE42) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE43)) - ZA11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA12*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE41) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE42) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_106 = Coupling(name = 'GC_106',
	 value = '(ZA11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE41) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE42) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE43)) - ZA11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA12*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE41) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE42) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_107 = Coupling(name = 'GC_107',
	 value = '(ZA11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE51) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE52) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE53)) - ZA11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA12*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE51) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE52) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_108 = Coupling(name = 'GC_108',
	 value = '(ZA11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE51) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE52) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE53)) - ZA11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA12*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE51) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE52) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_109 = Coupling(name = 'GC_109',
	 value = '(ZA11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE51) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE52) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE53)) - ZA11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA12*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE51) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE52) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_110 = Coupling(name = 'GC_110',
	 value = '(ZA11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE51) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE52) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE53)) - ZA11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA12*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE51) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE52) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_111 = Coupling(name = 'GC_111',
	 value = '(ZA11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE51) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE52) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE53)) - ZA11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA12*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE51) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE52) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_112 = Coupling(name = 'GC_112',
	 value = '(ZA11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE51) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE52) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE53)) - ZA11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA12*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE51) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE52) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_113 = Coupling(name = 'GC_113',
	 value = '(ZA11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE61) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE62) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE63)) - ZA11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA12*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE61) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE62) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_114 = Coupling(name = 'GC_114',
	 value = '(ZA11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE61) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE62) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE63)) - ZA11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA12*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE61) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE62) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_115 = Coupling(name = 'GC_115',
	 value = '(ZA11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE61) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE62) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE63)) - ZA11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA12*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE61) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE62) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_116 = Coupling(name = 'GC_116',
	 value = '(ZA11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE61) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE62) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE63)) - ZA11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA12*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE61) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE62) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_117 = Coupling(name = 'GC_117',
	 value = '(ZA11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE61) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE62) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE63)) - ZA11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA12*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE61) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE62) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_118 = Coupling(name = 'GC_118',
	 value = '(ZA11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE61) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE62) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE63)) - ZA11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA12*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE61) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE62) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_119 = Coupling(name = 'GC_119',
	 value = '(ZA21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE11) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE12) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE13)) - ZA21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA22*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_120 = Coupling(name = 'GC_120',
	 value = '(ZA21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE11) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE12) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE13)) - ZA21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA22*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_121 = Coupling(name = 'GC_121',
	 value = '(ZA21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE11) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE12) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE13)) - ZA21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA22*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_122 = Coupling(name = 'GC_122',
	 value = '(ZA21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE11) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE12) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE13)) - ZA21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA22*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_123 = Coupling(name = 'GC_123',
	 value = '(ZA21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE11) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE12) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE13)) - ZA21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA22*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_124 = Coupling(name = 'GC_124',
	 value = '(ZA21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE11) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE12) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE13)) - ZA21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + ZA22*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE13)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_125 = Coupling(name = 'GC_125',
	 value = '(ZA21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE21) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE22) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE23)) - ZA21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA22*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_126 = Coupling(name = 'GC_126',
	 value = '(ZA21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE21) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE22) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE23)) - ZA21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA22*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_127 = Coupling(name = 'GC_127',
	 value = '(ZA21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE21) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE22) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE23)) - ZA21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA22*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_128 = Coupling(name = 'GC_128',
	 value = '(ZA21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE21) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE22) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE23)) - ZA21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA22*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_129 = Coupling(name = 'GC_129',
	 value = '(ZA21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE21) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE22) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE23)) - ZA21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA22*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_130 = Coupling(name = 'GC_130',
	 value = '(ZA21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE21) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE22) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE23)) - ZA21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + ZA22*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE23)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_131 = Coupling(name = 'GC_131',
	 value = '(ZA21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE31) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE32) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE33)) - ZA21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA22*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_132 = Coupling(name = 'GC_132',
	 value = '(ZA21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE31) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE32) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE33)) - ZA21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA22*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_133 = Coupling(name = 'GC_133',
	 value = '(ZA21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE31) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE32) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE33)) - ZA21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA22*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_134 = Coupling(name = 'GC_134',
	 value = '(ZA21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE31) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE32) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE33)) - ZA21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA22*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_135 = Coupling(name = 'GC_135',
	 value = '(ZA21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE31) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE32) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE33)) - ZA21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA22*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_136 = Coupling(name = 'GC_136',
	 value = '(ZA21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE31) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE32) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE33)) - ZA21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + ZA22*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE33)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_137 = Coupling(name = 'GC_137',
	 value = '(ZA21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE41) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE42) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE43)) - ZA21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA22*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE41) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE42) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_138 = Coupling(name = 'GC_138',
	 value = '(ZA21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE41) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE42) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE43)) - ZA21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA22*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE41) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE42) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_139 = Coupling(name = 'GC_139',
	 value = '(ZA21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE41) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE42) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE43)) - ZA21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA22*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE41) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE42) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_140 = Coupling(name = 'GC_140',
	 value = '(ZA21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE41) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE42) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE43)) - ZA21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA22*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE41) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE42) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_141 = Coupling(name = 'GC_141',
	 value = '(ZA21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE41) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE42) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE43)) - ZA21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA22*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE41) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE42) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_142 = Coupling(name = 'GC_142',
	 value = '(ZA21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE41) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE42) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE43)) - ZA21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + ZA22*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE41) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE42) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE43)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_143 = Coupling(name = 'GC_143',
	 value = '(ZA21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE51) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE52) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE53)) - ZA21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA22*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE51) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE52) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_144 = Coupling(name = 'GC_144',
	 value = '(ZA21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE51) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE52) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE53)) - ZA21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA22*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE51) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE52) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_145 = Coupling(name = 'GC_145',
	 value = '(ZA21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE51) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE52) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE53)) - ZA21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA22*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE51) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE52) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_146 = Coupling(name = 'GC_146',
	 value = '(ZA21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE51) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE52) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE53)) - ZA21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA22*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE51) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE52) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_147 = Coupling(name = 'GC_147',
	 value = '(ZA21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE51) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE52) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE53)) - ZA21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA22*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE51) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE52) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_148 = Coupling(name = 'GC_148',
	 value = '(ZA21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE51) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE52) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE53)) - ZA21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + ZA22*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE51) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE52) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE53)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_149 = Coupling(name = 'GC_149',
	 value = '(ZA21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE61) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE62) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE63)) - ZA21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA22*(Mu*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE61) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE62) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_150 = Coupling(name = 'GC_150',
	 value = '(ZA21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE61) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE62) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE63)) - ZA21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA22*(Mu*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE61) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE62) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_151 = Coupling(name = 'GC_151',
	 value = '(ZA21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE61) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE62) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE63)) - ZA21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA22*(Mu*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE61) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE62) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_152 = Coupling(name = 'GC_152',
	 value = '(ZA21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE61) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE62) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE63)) - ZA21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA22*(Mu*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE61) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE62) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_153 = Coupling(name = 'GC_153',
	 value = '(ZA21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE61) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE62) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE63)) - ZA21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA22*(Mu*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE61) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE62) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_154 = Coupling(name = 'GC_154',
	 value = '(ZA21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE61) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE62) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE63)) - ZA21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + ZA22*(Mu*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE61) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE62) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE63)) - complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_155 = Coupling(name = 'GC_155',
	 value = '(Mu*ZA11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU13)) + ZA12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU11) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU12) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU13) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_156 = Coupling(name = 'GC_156',
	 value = '(Mu*ZA11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU13)) + ZA12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU11) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU12) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU13) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_157 = Coupling(name = 'GC_157',
	 value = '(Mu*ZA11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU13)) + ZA12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU11) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU12) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU13) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_158 = Coupling(name = 'GC_158',
	 value = '(Mu*ZA11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU13)) + ZA12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU11) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU12) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU13) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_159 = Coupling(name = 'GC_159',
	 value = '(Mu*ZA11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU13)) + ZA12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU11) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU12) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU13) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_160 = Coupling(name = 'GC_160',
	 value = '(Mu*ZA11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU13)) + ZA12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU11) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU12) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU13) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_161 = Coupling(name = 'GC_161',
	 value = '(Mu*ZA11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU23)) + ZA12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU21) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU22) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU23) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_162 = Coupling(name = 'GC_162',
	 value = '(Mu*ZA11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU23)) + ZA12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU21) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU22) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU23) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_163 = Coupling(name = 'GC_163',
	 value = '(Mu*ZA11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU23)) + ZA12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU21) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU22) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU23) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_164 = Coupling(name = 'GC_164',
	 value = '(Mu*ZA11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU23)) + ZA12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU21) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU22) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU23) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_165 = Coupling(name = 'GC_165',
	 value = '(Mu*ZA11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU23)) + ZA12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU21) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU22) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU23) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_166 = Coupling(name = 'GC_166',
	 value = '(Mu*ZA11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU23)) + ZA12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU21) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU22) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU23) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_167 = Coupling(name = 'GC_167',
	 value = '(Mu*ZA11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU33)) + ZA12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU31) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU32) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU33) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_168 = Coupling(name = 'GC_168',
	 value = '(Mu*ZA11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU33)) + ZA12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU31) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU32) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU33) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_169 = Coupling(name = 'GC_169',
	 value = '(Mu*ZA11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU33)) + ZA12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU31) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU32) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU33) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_170 = Coupling(name = 'GC_170',
	 value = '(Mu*ZA11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU33)) + ZA12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU31) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU32) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU33) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_171 = Coupling(name = 'GC_171',
	 value = '(Mu*ZA11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU33)) + ZA12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU31) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU32) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU33) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_172 = Coupling(name = 'GC_172',
	 value = '(Mu*ZA11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU33)) + ZA12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU31) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU32) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU33) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_173 = Coupling(name = 'GC_173',
	 value = '(Mu*ZA11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU41) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU42) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU43)) + ZA12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU41) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU42) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU43) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_174 = Coupling(name = 'GC_174',
	 value = '(Mu*ZA11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU41) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU42) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU43)) + ZA12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU41) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU42) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU43) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_175 = Coupling(name = 'GC_175',
	 value = '(Mu*ZA11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU41) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU42) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU43)) + ZA12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU41) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU42) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU43) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_176 = Coupling(name = 'GC_176',
	 value = '(Mu*ZA11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU41) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU42) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU43)) + ZA12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU41) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU42) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU43) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_177 = Coupling(name = 'GC_177',
	 value = '(Mu*ZA11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU41) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU42) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU43)) + ZA12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU41) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU42) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU43) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_178 = Coupling(name = 'GC_178',
	 value = '(Mu*ZA11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU41) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU42) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU43)) + ZA12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU41) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU42) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU43) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_179 = Coupling(name = 'GC_179',
	 value = '(Mu*ZA11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU51) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU52) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU53)) + ZA12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU51) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU52) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU53) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_180 = Coupling(name = 'GC_180',
	 value = '(Mu*ZA11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU51) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU52) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU53)) + ZA12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU51) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU52) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU53) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_181 = Coupling(name = 'GC_181',
	 value = '(Mu*ZA11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU51) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU52) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU53)) + ZA12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU51) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU52) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU53) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_182 = Coupling(name = 'GC_182',
	 value = '(Mu*ZA11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU51) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU52) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU53)) + ZA12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU51) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU52) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU53) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_183 = Coupling(name = 'GC_183',
	 value = '(Mu*ZA11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU51) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU52) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU53)) + ZA12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU51) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU52) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU53) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_184 = Coupling(name = 'GC_184',
	 value = '(Mu*ZA11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU51) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU52) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU53)) + ZA12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU51) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU52) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU53) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_185 = Coupling(name = 'GC_185',
	 value = '(Mu*ZA11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU61) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU62) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU63)) + ZA12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU61) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU62) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU63) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_186 = Coupling(name = 'GC_186',
	 value = '(Mu*ZA11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU61) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU62) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU63)) + ZA12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU61) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU62) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU63) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_187 = Coupling(name = 'GC_187',
	 value = '(Mu*ZA11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU61) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU62) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU63)) + ZA12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU61) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU62) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU63) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_188 = Coupling(name = 'GC_188',
	 value = '(Mu*ZA11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU61) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU62) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU63)) + ZA12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU61) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU62) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU63) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_189 = Coupling(name = 'GC_189',
	 value = '(Mu*ZA11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU61) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU62) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU63)) + ZA12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU61) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU62) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU63) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_190 = Coupling(name = 'GC_190',
	 value = '(Mu*ZA11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU61) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU62) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU63)) + ZA12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU61) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU62) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU63) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_191 = Coupling(name = 'GC_191',
	 value = '(Mu*ZA21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU13)) + ZA22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU11) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU12) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU13) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_192 = Coupling(name = 'GC_192',
	 value = '(Mu*ZA21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU13)) + ZA22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU11) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU12) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU13) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_193 = Coupling(name = 'GC_193',
	 value = '(Mu*ZA21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU13)) + ZA22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU11) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU12) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU13) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_194 = Coupling(name = 'GC_194',
	 value = '(Mu*ZA21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU13)) + ZA22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU11) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU12) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU13) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_195 = Coupling(name = 'GC_195',
	 value = '(Mu*ZA21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU13)) + ZA22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU11) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU12) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU13) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_196 = Coupling(name = 'GC_196',
	 value = '(Mu*ZA21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU13)) + ZA22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU11) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU12) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU13) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - ZA21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_197 = Coupling(name = 'GC_197',
	 value = '(Mu*ZA21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU23)) + ZA22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU21) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU22) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU23) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_198 = Coupling(name = 'GC_198',
	 value = '(Mu*ZA21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU23)) + ZA22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU21) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU22) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU23) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_199 = Coupling(name = 'GC_199',
	 value = '(Mu*ZA21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU23)) + ZA22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU21) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU22) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU23) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_200 = Coupling(name = 'GC_200',
	 value = '(Mu*ZA21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU23)) + ZA22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU21) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU22) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU23) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_201 = Coupling(name = 'GC_201',
	 value = '(Mu*ZA21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU23)) + ZA22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU21) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU22) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU23) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_202 = Coupling(name = 'GC_202',
	 value = '(Mu*ZA21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU23)) + ZA22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU21) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU22) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU23) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - ZA21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_203 = Coupling(name = 'GC_203',
	 value = '(Mu*ZA21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU33)) + ZA22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU31) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU32) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU33) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_204 = Coupling(name = 'GC_204',
	 value = '(Mu*ZA21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU33)) + ZA22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU31) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU32) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU33) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_205 = Coupling(name = 'GC_205',
	 value = '(Mu*ZA21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU33)) + ZA22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU31) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU32) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU33) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_206 = Coupling(name = 'GC_206',
	 value = '(Mu*ZA21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU33)) + ZA22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU31) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU32) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU33) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_207 = Coupling(name = 'GC_207',
	 value = '(Mu*ZA21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU33)) + ZA22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU31) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU32) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU33) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_208 = Coupling(name = 'GC_208',
	 value = '(Mu*ZA21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU33)) + ZA22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU31) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU32) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU33) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - ZA21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_209 = Coupling(name = 'GC_209',
	 value = '(Mu*ZA21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU41) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU42) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU43)) + ZA22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU41) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU42) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU43) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_210 = Coupling(name = 'GC_210',
	 value = '(Mu*ZA21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU41) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU42) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU43)) + ZA22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU41) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU42) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU43) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_211 = Coupling(name = 'GC_211',
	 value = '(Mu*ZA21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU41) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU42) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU43)) + ZA22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU41) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU42) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU43) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_212 = Coupling(name = 'GC_212',
	 value = '(Mu*ZA21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU41) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU42) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU43)) + ZA22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU41) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU42) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU43) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_213 = Coupling(name = 'GC_213',
	 value = '(Mu*ZA21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU41) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU42) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU43)) + ZA22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU41) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU42) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU43) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_214 = Coupling(name = 'GC_214',
	 value = '(Mu*ZA21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU41) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU42) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU43)) + ZA22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU41) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU42) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU43) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - ZA21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_215 = Coupling(name = 'GC_215',
	 value = '(Mu*ZA21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU51) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU52) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU53)) + ZA22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU51) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU52) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU53) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_216 = Coupling(name = 'GC_216',
	 value = '(Mu*ZA21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU51) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU52) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU53)) + ZA22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU51) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU52) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU53) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_217 = Coupling(name = 'GC_217',
	 value = '(Mu*ZA21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU51) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU52) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU53)) + ZA22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU51) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU52) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU53) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_218 = Coupling(name = 'GC_218',
	 value = '(Mu*ZA21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU51) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU52) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU53)) + ZA22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU51) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU52) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU53) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_219 = Coupling(name = 'GC_219',
	 value = '(Mu*ZA21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU51) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU52) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU53)) + ZA22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU51) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU52) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU53) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_220 = Coupling(name = 'GC_220',
	 value = '(Mu*ZA21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU51) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU52) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU53)) + ZA22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU51) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU52) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU53) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - ZA21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_221 = Coupling(name = 'GC_221',
	 value = '(Mu*ZA21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU61) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU62) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU63)) + ZA22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU61) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU62) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU63) - ZU11*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU12*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU13*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_222 = Coupling(name = 'GC_222',
	 value = '(Mu*ZA21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU61) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU62) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU63)) + ZA22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU61) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU62) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU63) - ZU21*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU22*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU23*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_223 = Coupling(name = 'GC_223',
	 value = '(Mu*ZA21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU61) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU62) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU63)) + ZA22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU61) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU62) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU63) - ZU31*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU32*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU33*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_224 = Coupling(name = 'GC_224',
	 value = '(Mu*ZA21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU61) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU62) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU63)) + ZA22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU61) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU62) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU63) - ZU41*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU42*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU43*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_225 = Coupling(name = 'GC_225',
	 value = '(Mu*ZA21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU61) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU62) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU63)) + ZA22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU61) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU62) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU63) - ZU51*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU52*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU53*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_226 = Coupling(name = 'GC_226',
	 value = '(Mu*ZA21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU61) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU62) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU63)) + ZA22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU61) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU62) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU63) - ZU61*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) - ZU62*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) - ZU63*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - ZA21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_227 = Coupling(name = 'GC_227',
	 value = '1./4.*complex(0,1)*(g1**2 + g2**2)*(ZH12*(ZH11*(vu*ZH11 + vd*ZH12) + ZH12*(vd*ZH11 - 3*vu*ZH12)) + ZH11*(ZH12*(vu*ZH11 + vd*ZH12) + ZH11*(-3*vd*ZH11 + vu*ZH12)))', 
	 order = {'QED':1} ) 
 
GC_228 = Coupling(name = 'GC_228',
	 value = '1./4.*complex(0,1)*(g1**2 + g2**2)*(ZH12*(ZH11*(vu*ZH21 + vd*ZH22) + ZH12*(vd*ZH21 - 3*vu*ZH22)) + ZH11*(ZH12*(vu*ZH21 + vd*ZH22) + ZH11*(-3*vd*ZH21 + vu*ZH22)))', 
	 order = {'QED':1} ) 
 
GC_229 = Coupling(name = 'GC_229',
	 value = '1./4.*complex(0,1)*(g1**2 + g2**2)*(ZH12*(ZH21*(vu*ZH21 + vd*ZH22) + ZH22*(vd*ZH21 - 3*vu*ZH22)) + ZH11*(ZH22*(vu*ZH21 + vd*ZH22) + ZH21*(-3*vd*ZH21 + vu*ZH22)))', 
	 order = {'QED':1} ) 
 
GC_230 = Coupling(name = 'GC_230',
	 value = '1./4.*complex(0,1)*(g1**2 + g2**2)*(ZH22*(ZH21*(vu*ZH21 + vd*ZH22) + ZH22*(vd*ZH21 - 3*vu*ZH22)) + ZH21*(ZH22*(vu*ZH21 + vd*ZH22) + ZH21*(-3*vd*ZH21 + vu*ZH22)))', 
	 order = {'QED':1} ) 
 
GC_231 = Coupling(name = 'GC_231',
	 value = '-1./4.*complex(0,1)*(ZH11*(ZP12*(g2**2*vu*ZP11 + (-g1**2 + g2**2)*vd*ZP12) + ZP11*((g1**2 + g2**2)*vd*ZP11 + g2**2*vu*ZP12)) + ZH12*(ZP11*((-g1**2 + g2**2)*vu*ZP11 + g2**2*vd*ZP12) + ZP12*(g2**2*vd*ZP11 + (g1**2 + g2**2)*vu*ZP12)))', 
	 order = {'QED':1} ) 
 
GC_232 = Coupling(name = 'GC_232',
	 value = '-1./4.*complex(0,1)*(ZH11*(ZP12*(g2**2*vu*ZP21 + (-g1**2 + g2**2)*vd*ZP22) + ZP11*((g1**2 + g2**2)*vd*ZP21 + g2**2*vu*ZP22)) + ZH12*(ZP11*((-g1**2 + g2**2)*vu*ZP21 + g2**2*vd*ZP22) + ZP12*(g2**2*vd*ZP21 + (g1**2 + g2**2)*vu*ZP22)))', 
	 order = {'QED':1} ) 
 
GC_233 = Coupling(name = 'GC_233',
	 value = '-1./4.*complex(0,1)*(ZH11*(((g1**2 + g2**2)*vd*ZP11 + g2**2*vu*ZP12)*ZP21 + (g2**2*vu*ZP11 + (-g1**2 + g2**2)*vd*ZP12)*ZP22) + ZH12*(((-g1**2 + g2**2)*vu*ZP11 + g2**2*vd*ZP12)*ZP21 + (g2**2*vd*ZP11 + (g1**2 + g2**2)*vu*ZP12)*ZP22))', 
	 order = {'QED':1} ) 
 
GC_234 = Coupling(name = 'GC_234',
	 value = '-1./4.*complex(0,1)*(ZH11*(ZP22*(g2**2*vu*ZP21 + (-g1**2 + g2**2)*vd*ZP22) + ZP21*((g1**2 + g2**2)*vd*ZP21 + g2**2*vu*ZP22)) + ZH12*(ZP21*((-g1**2 + g2**2)*vu*ZP21 + g2**2*vd*ZP22) + ZP22*(g2**2*vd*ZP21 + (g1**2 + g2**2)*vu*ZP22)))', 
	 order = {'QED':1} ) 
 
GC_235 = Coupling(name = 'GC_235',
	 value = '-1./4.*complex(0,1)*(ZH21*(ZP12*(g2**2*vu*ZP11 + (-g1**2 + g2**2)*vd*ZP12) + ZP11*((g1**2 + g2**2)*vd*ZP11 + g2**2*vu*ZP12)) + ZH22*(ZP11*((-g1**2 + g2**2)*vu*ZP11 + g2**2*vd*ZP12) + ZP12*(g2**2*vd*ZP11 + (g1**2 + g2**2)*vu*ZP12)))', 
	 order = {'QED':1} ) 
 
GC_236 = Coupling(name = 'GC_236',
	 value = '-1./4.*complex(0,1)*(ZH21*(ZP12*(g2**2*vu*ZP21 + (-g1**2 + g2**2)*vd*ZP22) + ZP11*((g1**2 + g2**2)*vd*ZP21 + g2**2*vu*ZP22)) + ZH22*(ZP11*((-g1**2 + g2**2)*vu*ZP21 + g2**2*vd*ZP22) + ZP12*(g2**2*vd*ZP21 + (g1**2 + g2**2)*vu*ZP22)))', 
	 order = {'QED':1} ) 
 
GC_237 = Coupling(name = 'GC_237',
	 value = '-1./4.*complex(0,1)*(ZH21*(((g1**2 + g2**2)*vd*ZP11 + g2**2*vu*ZP12)*ZP21 + (g2**2*vu*ZP11 + (-g1**2 + g2**2)*vd*ZP12)*ZP22) + ZH22*(((-g1**2 + g2**2)*vu*ZP11 + g2**2*vd*ZP12)*ZP21 + (g2**2*vd*ZP11 + (g1**2 + g2**2)*vu*ZP12)*ZP22))', 
	 order = {'QED':1} ) 
 
GC_238 = Coupling(name = 'GC_238',
	 value = '-1./4.*complex(0,1)*(ZH21*(ZP22*(g2**2*vu*ZP21 + (-g1**2 + g2**2)*vd*ZP22) + ZP21*((g1**2 + g2**2)*vd*ZP21 + g2**2*vu*ZP22)) + ZH22*(ZP21*((-g1**2 + g2**2)*vu*ZP21 + g2**2*vd*ZP22) + ZP22*(g2**2*vd*ZP21 + (g1**2 + g2**2)*vu*ZP22)))', 
	 order = {'QED':1} ) 
 
GC_239 = Coupling(name = 'GC_239',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD11) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD12) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD13)) + 2*vd*ZH11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH11*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_240 = Coupling(name = 'GC_240',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD11) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD12) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD13)) + 2*vd*ZH11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH11*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_241 = Coupling(name = 'GC_241',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD11) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD12) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD13)) + 2*vd*ZH11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH11*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_242 = Coupling(name = 'GC_242',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD11) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD12) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD13)) + 2*vd*ZH11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH11*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_243 = Coupling(name = 'GC_243',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD11) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD12) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD13)) + 2*vd*ZH11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH11*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_244 = Coupling(name = 'GC_244',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD11) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD12) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD13)) + 2*vd*ZH11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH11*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_245 = Coupling(name = 'GC_245',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD21) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD22) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD23)) + 2*vd*ZH11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH11*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_246 = Coupling(name = 'GC_246',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD21) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD22) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD23)) + 2*vd*ZH11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH11*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_247 = Coupling(name = 'GC_247',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD21) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD22) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD23)) + 2*vd*ZH11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH11*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_248 = Coupling(name = 'GC_248',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD21) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD22) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD23)) + 2*vd*ZH11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH11*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_249 = Coupling(name = 'GC_249',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD21) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD22) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD23)) + 2*vd*ZH11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH11*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_250 = Coupling(name = 'GC_250',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD21) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD22) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD23)) + 2*vd*ZH11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH11*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_251 = Coupling(name = 'GC_251',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD31) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD32) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD33)) + 2*vd*ZH11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH11*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_252 = Coupling(name = 'GC_252',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD31) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD32) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD33)) + 2*vd*ZH11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH11*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_253 = Coupling(name = 'GC_253',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD31) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD32) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD33)) + 2*vd*ZH11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH11*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_254 = Coupling(name = 'GC_254',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD31) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD32) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD33)) + 2*vd*ZH11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH11*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_255 = Coupling(name = 'GC_255',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD31) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD32) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD33)) + 2*vd*ZH11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH11*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_256 = Coupling(name = 'GC_256',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD31) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD32) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD33)) + 2*vd*ZH11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH11*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_257 = Coupling(name = 'GC_257',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD41) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD42) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD41) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD42) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD43)) + 2*vd*ZH11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH11*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_258 = Coupling(name = 'GC_258',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD41) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD42) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD41) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD42) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD43)) + 2*vd*ZH11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH11*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_259 = Coupling(name = 'GC_259',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD41) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD42) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD41) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD42) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD43)) + 2*vd*ZH11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH11*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_260 = Coupling(name = 'GC_260',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD41) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD42) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD41) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD42) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD43)) + 2*vd*ZH11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH11*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_261 = Coupling(name = 'GC_261',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD41) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD42) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD41) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD42) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD43)) + 2*vd*ZH11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH11*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_262 = Coupling(name = 'GC_262',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD41) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD42) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD41) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD42) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD43)) + 2*vd*ZH11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH11*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_263 = Coupling(name = 'GC_263',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD51) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD52) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD51) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD52) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD53)) + 2*vd*ZH11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH11*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_264 = Coupling(name = 'GC_264',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD51) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD52) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD51) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD52) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD53)) + 2*vd*ZH11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH11*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_265 = Coupling(name = 'GC_265',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD51) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD52) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD51) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD52) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD53)) + 2*vd*ZH11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH11*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_266 = Coupling(name = 'GC_266',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD51) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD52) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD51) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD52) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD53)) + 2*vd*ZH11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH11*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_267 = Coupling(name = 'GC_267',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD51) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD52) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD51) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD52) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD53)) + 2*vd*ZH11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH11*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_268 = Coupling(name = 'GC_268',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD51) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD52) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD51) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD52) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD53)) + 2*vd*ZH11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH11*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_269 = Coupling(name = 'GC_269',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD61) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD62) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD61) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD62) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD63)) + 2*vd*ZH11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH11*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH11*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_270 = Coupling(name = 'GC_270',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD61) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD62) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD61) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD62) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD63)) + 2*vd*ZH11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH11*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH11*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_271 = Coupling(name = 'GC_271',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD61) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD62) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD61) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD62) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD63)) + 2*vd*ZH11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH11*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH11*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_272 = Coupling(name = 'GC_272',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD61) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD62) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD61) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD62) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD63)) + 2*vd*ZH11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH11*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH11*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_273 = Coupling(name = 'GC_273',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD61) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD62) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD61) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD62) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD63)) + 2*vd*ZH11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH11*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH11*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_274 = Coupling(name = 'GC_274',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH11 - vu*ZH12)*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD61) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD62) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD61) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD62) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD63)) + 2*vd*ZH11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH11*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH11*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_275 = Coupling(name = 'GC_275',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD11) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD12) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD13)) + 2*vd*ZH21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH21*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_276 = Coupling(name = 'GC_276',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD11) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD12) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD13)) + 2*vd*ZH21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH21*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_277 = Coupling(name = 'GC_277',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD11) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD12) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD13)) + 2*vd*ZH21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH21*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_278 = Coupling(name = 'GC_278',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD11) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD12) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD13)) + 2*vd*ZH21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH21*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_279 = Coupling(name = 'GC_279',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD11) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD12) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD13)) + 2*vd*ZH21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH21*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_280 = Coupling(name = 'GC_280',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD11) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD12) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD13)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD13)) + 2*vd*ZH21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + 2*vd*ZH21*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*ZH21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))))', 
	 order = {'QED':1} ) 
 
GC_281 = Coupling(name = 'GC_281',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD21) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD22) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD23)) + 2*vd*ZH21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH21*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_282 = Coupling(name = 'GC_282',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD21) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD22) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD23)) + 2*vd*ZH21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH21*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_283 = Coupling(name = 'GC_283',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD21) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD22) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD23)) + 2*vd*ZH21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH21*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_284 = Coupling(name = 'GC_284',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD21) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD22) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD23)) + 2*vd*ZH21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH21*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_285 = Coupling(name = 'GC_285',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD21) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD22) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD23)) + 2*vd*ZH21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH21*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_286 = Coupling(name = 'GC_286',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD21) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD22) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD23)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD23)) + 2*vd*ZH21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + 2*vd*ZH21*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*ZH21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))))', 
	 order = {'QED':1} ) 
 
GC_287 = Coupling(name = 'GC_287',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD31) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD32) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD33)) + 2*vd*ZH21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH21*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_288 = Coupling(name = 'GC_288',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD31) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD32) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD33)) + 2*vd*ZH21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH21*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_289 = Coupling(name = 'GC_289',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD31) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD32) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD33)) + 2*vd*ZH21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH21*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_290 = Coupling(name = 'GC_290',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD31) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD32) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD33)) + 2*vd*ZH21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH21*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_291 = Coupling(name = 'GC_291',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD31) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD32) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD33)) + 2*vd*ZH21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH21*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_292 = Coupling(name = 'GC_292',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD31) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD32) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD33)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD33)) + 2*vd*ZH21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + 2*vd*ZH21*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*ZH21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))))', 
	 order = {'QED':1} ) 
 
GC_293 = Coupling(name = 'GC_293',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD41) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD42) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD41) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD42) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD43)) + 2*vd*ZH21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH21*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_294 = Coupling(name = 'GC_294',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD41) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD42) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD41) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD42) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD43)) + 2*vd*ZH21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH21*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_295 = Coupling(name = 'GC_295',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD41) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD42) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD41) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD42) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD43)) + 2*vd*ZH21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH21*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_296 = Coupling(name = 'GC_296',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD41) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD42) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD41) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD42) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD43)) + 2*vd*ZH21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH21*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_297 = Coupling(name = 'GC_297',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD41) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD42) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD41) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD42) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD43)) + 2*vd*ZH21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH21*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_298 = Coupling(name = 'GC_298',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD41) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD42) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD43)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD41) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD42) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD43)) + 2*vd*ZH21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + 2*vd*ZH21*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*ZH21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))))', 
	 order = {'QED':1} ) 
 
GC_299 = Coupling(name = 'GC_299',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD51) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD52) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD51) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD52) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD53)) + 2*vd*ZH21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH21*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_300 = Coupling(name = 'GC_300',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD51) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD52) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD51) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD52) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD53)) + 2*vd*ZH21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH21*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_301 = Coupling(name = 'GC_301',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD51) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD52) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD51) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD52) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD53)) + 2*vd*ZH21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH21*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_302 = Coupling(name = 'GC_302',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD51) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD52) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD51) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD52) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD53)) + 2*vd*ZH21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH21*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_303 = Coupling(name = 'GC_303',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD51) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD52) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD51) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD52) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD53)) + 2*vd*ZH21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH21*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_304 = Coupling(name = 'GC_304',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD51) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD52) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD53)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD51) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD52) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD53)) + 2*vd*ZH21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + 2*vd*ZH21*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*ZH21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))))', 
	 order = {'QED':1} ) 
 
GC_305 = Coupling(name = 'GC_305',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZD61) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZD62) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZD61) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZD62) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZD63)) + 2*vd*ZH21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH21*((ZD14*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD15*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD16*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD14*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD15*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD16*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD14*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD15*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD16*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH21*(ZD11*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_306 = Coupling(name = 'GC_306',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZD61) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZD62) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZD61) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZD62) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZD63)) + 2*vd*ZH21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH21*((ZD24*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD25*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD26*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD24*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD25*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD26*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD24*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD25*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD26*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH21*(ZD21*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_307 = Coupling(name = 'GC_307',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZD61) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZD62) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZD61) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZD62) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZD63)) + 2*vd*ZH21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH21*((ZD34*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD35*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD36*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD34*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD35*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD36*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD34*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD35*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD36*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH21*(ZD31*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_308 = Coupling(name = 'GC_308',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZD61) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZD62) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZD61) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZD62) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZD63)) + 2*vd*ZH21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH21*((ZD44*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD45*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD46*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD44*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD45*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD46*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD44*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD45*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD46*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH21*(ZD41*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD41*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD42*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD43*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_309 = Coupling(name = 'GC_309',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZD61) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZD62) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZD61) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZD62) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZD63)) + 2*vd*ZH21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH21*((ZD54*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD55*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD56*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD54*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD55*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD56*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD54*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD55*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD56*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH21*(ZD51*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD51*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD52*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD53*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_310 = Coupling(name = 'GC_310',
	 value = '1./12.*complex(0,1)*((g1**2 + 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63)) + 2*(g1**2*(vd*ZH21 - vu*ZH22)*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66)) - 3*(cmath.sqrt(2)*ZH21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZD61) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZD62) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZD63)) - cmath.sqrt(2)*Mu*ZH22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZD61) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZD62) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZD63)) + 2*vd*ZH21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + 2*vd*ZH21*((ZD64*(Yd11*complexconjugate(Yd11) + Yd12*complexconjugate(Yd12) + Yd13*complexconjugate(Yd13)) + ZD65*(Yd21*complexconjugate(Yd11) + Yd22*complexconjugate(Yd12) + Yd23*complexconjugate(Yd13)) + ZD66*(Yd31*complexconjugate(Yd11) + Yd32*complexconjugate(Yd12) + Yd33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZD64*(Yd11*complexconjugate(Yd21) + Yd12*complexconjugate(Yd22) + Yd13*complexconjugate(Yd23)) + ZD65*(Yd21*complexconjugate(Yd21) + Yd22*complexconjugate(Yd22) + Yd23*complexconjugate(Yd23)) + ZD66*(Yd31*complexconjugate(Yd21) + Yd32*complexconjugate(Yd22) + Yd33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZD64*(Yd11*complexconjugate(Yd31) + Yd12*complexconjugate(Yd32) + Yd13*complexconjugate(Yd33)) + ZD65*(Yd21*complexconjugate(Yd31) + Yd22*complexconjugate(Yd32) + Yd23*complexconjugate(Yd33)) + ZD66*(Yd31*complexconjugate(Yd31) + Yd32*complexconjugate(Yd32) + Yd33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*ZH21*(ZD61*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZD61*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZD62*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZD63*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))))', 
	 order = {'QED':1} ) 
 
GC_311 = Coupling(name = 'GC_311',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE11) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE12) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE13)) + 2*vd*ZH11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE14*complexconjugate(ZE14) + ZE15*complexconjugate(ZE15) + ZE16*complexconjugate(ZE16)) + 2*vd*ZH11*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_312 = Coupling(name = 'GC_312',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE11) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE12) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE13)) + 2*vd*ZH11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE24*complexconjugate(ZE14) + ZE25*complexconjugate(ZE15) + ZE26*complexconjugate(ZE16)) + 2*vd*ZH11*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_313 = Coupling(name = 'GC_313',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE11) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE12) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE13)) + 2*vd*ZH11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE34*complexconjugate(ZE14) + ZE35*complexconjugate(ZE15) + ZE36*complexconjugate(ZE16)) + 2*vd*ZH11*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_314 = Coupling(name = 'GC_314',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE11) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE12) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE13)) + 2*vd*ZH11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE44*complexconjugate(ZE14) + ZE45*complexconjugate(ZE15) + ZE46*complexconjugate(ZE16)) + 2*vd*ZH11*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_315 = Coupling(name = 'GC_315',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE11) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE12) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE13)) + 2*vd*ZH11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE54*complexconjugate(ZE14) + ZE55*complexconjugate(ZE15) + ZE56*complexconjugate(ZE16)) + 2*vd*ZH11*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_316 = Coupling(name = 'GC_316',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE11) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE12) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE13)) + 2*vd*ZH11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE64*complexconjugate(ZE14) + ZE65*complexconjugate(ZE15) + ZE66*complexconjugate(ZE16)) + 2*vd*ZH11*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_317 = Coupling(name = 'GC_317',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE21) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE22) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE23)) + 2*vd*ZH11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE14*complexconjugate(ZE24) + ZE15*complexconjugate(ZE25) + ZE16*complexconjugate(ZE26)) + 2*vd*ZH11*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_318 = Coupling(name = 'GC_318',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE21) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE22) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE23)) + 2*vd*ZH11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE24*complexconjugate(ZE24) + ZE25*complexconjugate(ZE25) + ZE26*complexconjugate(ZE26)) + 2*vd*ZH11*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_319 = Coupling(name = 'GC_319',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE21) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE22) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE23)) + 2*vd*ZH11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE34*complexconjugate(ZE24) + ZE35*complexconjugate(ZE25) + ZE36*complexconjugate(ZE26)) + 2*vd*ZH11*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_320 = Coupling(name = 'GC_320',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE21) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE22) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE23)) + 2*vd*ZH11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE44*complexconjugate(ZE24) + ZE45*complexconjugate(ZE25) + ZE46*complexconjugate(ZE26)) + 2*vd*ZH11*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_321 = Coupling(name = 'GC_321',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE21) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE22) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE23)) + 2*vd*ZH11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE54*complexconjugate(ZE24) + ZE55*complexconjugate(ZE25) + ZE56*complexconjugate(ZE26)) + 2*vd*ZH11*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_322 = Coupling(name = 'GC_322',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE21) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE22) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE23)) + 2*vd*ZH11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE64*complexconjugate(ZE24) + ZE65*complexconjugate(ZE25) + ZE66*complexconjugate(ZE26)) + 2*vd*ZH11*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_323 = Coupling(name = 'GC_323',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE31) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE32) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE33)) + 2*vd*ZH11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE14*complexconjugate(ZE34) + ZE15*complexconjugate(ZE35) + ZE16*complexconjugate(ZE36)) + 2*vd*ZH11*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_324 = Coupling(name = 'GC_324',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE31) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE32) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE33)) + 2*vd*ZH11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE24*complexconjugate(ZE34) + ZE25*complexconjugate(ZE35) + ZE26*complexconjugate(ZE36)) + 2*vd*ZH11*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_325 = Coupling(name = 'GC_325',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE31) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE32) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE33)) + 2*vd*ZH11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE34*complexconjugate(ZE34) + ZE35*complexconjugate(ZE35) + ZE36*complexconjugate(ZE36)) + 2*vd*ZH11*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_326 = Coupling(name = 'GC_326',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE31) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE32) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE33)) + 2*vd*ZH11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE44*complexconjugate(ZE34) + ZE45*complexconjugate(ZE35) + ZE46*complexconjugate(ZE36)) + 2*vd*ZH11*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_327 = Coupling(name = 'GC_327',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE31) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE32) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE33)) + 2*vd*ZH11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE54*complexconjugate(ZE34) + ZE55*complexconjugate(ZE35) + ZE56*complexconjugate(ZE36)) + 2*vd*ZH11*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_328 = Coupling(name = 'GC_328',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE31) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE32) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE33)) + 2*vd*ZH11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE64*complexconjugate(ZE34) + ZE65*complexconjugate(ZE35) + ZE66*complexconjugate(ZE36)) + 2*vd*ZH11*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_329 = Coupling(name = 'GC_329',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE41) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE42) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE41) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE42) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE43)) + 2*vd*ZH11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE14*complexconjugate(ZE44) + ZE15*complexconjugate(ZE45) + ZE16*complexconjugate(ZE46)) + 2*vd*ZH11*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_330 = Coupling(name = 'GC_330',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE41) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE42) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE41) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE42) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE43)) + 2*vd*ZH11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE24*complexconjugate(ZE44) + ZE25*complexconjugate(ZE45) + ZE26*complexconjugate(ZE46)) + 2*vd*ZH11*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_331 = Coupling(name = 'GC_331',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE41) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE42) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE41) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE42) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE43)) + 2*vd*ZH11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE34*complexconjugate(ZE44) + ZE35*complexconjugate(ZE45) + ZE36*complexconjugate(ZE46)) + 2*vd*ZH11*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_332 = Coupling(name = 'GC_332',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE41) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE42) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE41) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE42) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE43)) + 2*vd*ZH11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE44*complexconjugate(ZE44) + ZE45*complexconjugate(ZE45) + ZE46*complexconjugate(ZE46)) + 2*vd*ZH11*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_333 = Coupling(name = 'GC_333',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE41) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE42) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE41) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE42) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE43)) + 2*vd*ZH11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE54*complexconjugate(ZE44) + ZE55*complexconjugate(ZE45) + ZE56*complexconjugate(ZE46)) + 2*vd*ZH11*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_334 = Coupling(name = 'GC_334',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE41) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE42) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE41) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE42) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE43)) + 2*vd*ZH11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE64*complexconjugate(ZE44) + ZE65*complexconjugate(ZE45) + ZE66*complexconjugate(ZE46)) + 2*vd*ZH11*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_335 = Coupling(name = 'GC_335',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE51) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE52) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE51) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE52) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE53)) + 2*vd*ZH11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE14*complexconjugate(ZE54) + ZE15*complexconjugate(ZE55) + ZE16*complexconjugate(ZE56)) + 2*vd*ZH11*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_336 = Coupling(name = 'GC_336',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE51) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE52) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE51) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE52) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE53)) + 2*vd*ZH11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE24*complexconjugate(ZE54) + ZE25*complexconjugate(ZE55) + ZE26*complexconjugate(ZE56)) + 2*vd*ZH11*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_337 = Coupling(name = 'GC_337',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE51) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE52) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE51) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE52) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE53)) + 2*vd*ZH11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE34*complexconjugate(ZE54) + ZE35*complexconjugate(ZE55) + ZE36*complexconjugate(ZE56)) + 2*vd*ZH11*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_338 = Coupling(name = 'GC_338',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE51) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE52) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE51) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE52) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE53)) + 2*vd*ZH11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE44*complexconjugate(ZE54) + ZE45*complexconjugate(ZE55) + ZE46*complexconjugate(ZE56)) + 2*vd*ZH11*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_339 = Coupling(name = 'GC_339',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE51) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE52) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE51) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE52) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE53)) + 2*vd*ZH11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE54*complexconjugate(ZE54) + ZE55*complexconjugate(ZE55) + ZE56*complexconjugate(ZE56)) + 2*vd*ZH11*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_340 = Coupling(name = 'GC_340',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE51) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE52) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE51) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE52) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE53)) + 2*vd*ZH11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE64*complexconjugate(ZE54) + ZE65*complexconjugate(ZE55) + ZE66*complexconjugate(ZE56)) + 2*vd*ZH11*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_341 = Coupling(name = 'GC_341',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE61) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE62) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE61) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE62) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE63)) + 2*vd*ZH11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE14*complexconjugate(ZE64) + ZE15*complexconjugate(ZE65) + ZE16*complexconjugate(ZE66)) + 2*vd*ZH11*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH11*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_342 = Coupling(name = 'GC_342',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE61) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE62) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE61) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE62) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE63)) + 2*vd*ZH11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE24*complexconjugate(ZE64) + ZE25*complexconjugate(ZE65) + ZE26*complexconjugate(ZE66)) + 2*vd*ZH11*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH11*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_343 = Coupling(name = 'GC_343',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE61) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE62) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE61) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE62) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE63)) + 2*vd*ZH11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE34*complexconjugate(ZE64) + ZE35*complexconjugate(ZE65) + ZE36*complexconjugate(ZE66)) + 2*vd*ZH11*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH11*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_344 = Coupling(name = 'GC_344',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE61) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE62) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE61) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE62) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE63)) + 2*vd*ZH11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE44*complexconjugate(ZE64) + ZE45*complexconjugate(ZE65) + ZE46*complexconjugate(ZE66)) + 2*vd*ZH11*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH11*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_345 = Coupling(name = 'GC_345',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE61) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE62) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE61) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE62) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE63)) + 2*vd*ZH11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE54*complexconjugate(ZE64) + ZE55*complexconjugate(ZE65) + ZE56*complexconjugate(ZE66)) + 2*vd*ZH11*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH11*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_346 = Coupling(name = 'GC_346',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH11 - vu*ZH12)*(ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE61) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE62) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE61) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE62) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE63)) + 2*vd*ZH11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH11) + vu*ZH12)*(ZE64*complexconjugate(ZE64) + ZE65*complexconjugate(ZE65) + ZE66*complexconjugate(ZE66)) + 2*vd*ZH11*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH11*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH12*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_347 = Coupling(name = 'GC_347',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE11) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE12) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE13)) + 2*vd*ZH21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE14*complexconjugate(ZE14) + ZE15*complexconjugate(ZE15) + ZE16*complexconjugate(ZE16)) + 2*vd*ZH21*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_348 = Coupling(name = 'GC_348',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE11) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE12) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE13)) + 2*vd*ZH21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE24*complexconjugate(ZE14) + ZE25*complexconjugate(ZE15) + ZE26*complexconjugate(ZE16)) + 2*vd*ZH21*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_349 = Coupling(name = 'GC_349',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE11) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE12) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE13)) + 2*vd*ZH21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE34*complexconjugate(ZE14) + ZE35*complexconjugate(ZE15) + ZE36*complexconjugate(ZE16)) + 2*vd*ZH21*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_350 = Coupling(name = 'GC_350',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE11) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE12) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE13)) + 2*vd*ZH21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE44*complexconjugate(ZE14) + ZE45*complexconjugate(ZE15) + ZE46*complexconjugate(ZE16)) + 2*vd*ZH21*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_351 = Coupling(name = 'GC_351',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE11) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE12) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE13)) + 2*vd*ZH21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE54*complexconjugate(ZE14) + ZE55*complexconjugate(ZE15) + ZE56*complexconjugate(ZE16)) + 2*vd*ZH21*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_352 = Coupling(name = 'GC_352',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE11) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE12) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE13)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE13)) + 2*vd*ZH21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE64*complexconjugate(ZE14) + ZE65*complexconjugate(ZE15) + ZE66*complexconjugate(ZE16)) + 2*vd*ZH21*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE14) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE15) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE16)) + cmath.sqrt(2)*ZH21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_353 = Coupling(name = 'GC_353',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE21) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE22) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE23)) + 2*vd*ZH21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE14*complexconjugate(ZE24) + ZE15*complexconjugate(ZE25) + ZE16*complexconjugate(ZE26)) + 2*vd*ZH21*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_354 = Coupling(name = 'GC_354',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE21) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE22) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE23)) + 2*vd*ZH21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE24*complexconjugate(ZE24) + ZE25*complexconjugate(ZE25) + ZE26*complexconjugate(ZE26)) + 2*vd*ZH21*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_355 = Coupling(name = 'GC_355',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE21) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE22) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE23)) + 2*vd*ZH21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE34*complexconjugate(ZE24) + ZE35*complexconjugate(ZE25) + ZE36*complexconjugate(ZE26)) + 2*vd*ZH21*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_356 = Coupling(name = 'GC_356',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE21) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE22) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE23)) + 2*vd*ZH21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE44*complexconjugate(ZE24) + ZE45*complexconjugate(ZE25) + ZE46*complexconjugate(ZE26)) + 2*vd*ZH21*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_357 = Coupling(name = 'GC_357',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE21) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE22) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE23)) + 2*vd*ZH21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE54*complexconjugate(ZE24) + ZE55*complexconjugate(ZE25) + ZE56*complexconjugate(ZE26)) + 2*vd*ZH21*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_358 = Coupling(name = 'GC_358',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE21) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE22) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE23)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE23)) + 2*vd*ZH21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE64*complexconjugate(ZE24) + ZE65*complexconjugate(ZE25) + ZE66*complexconjugate(ZE26)) + 2*vd*ZH21*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE24) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE25) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE26)) + cmath.sqrt(2)*ZH21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_359 = Coupling(name = 'GC_359',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE31) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE32) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE33)) + 2*vd*ZH21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE14*complexconjugate(ZE34) + ZE15*complexconjugate(ZE35) + ZE16*complexconjugate(ZE36)) + 2*vd*ZH21*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_360 = Coupling(name = 'GC_360',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE31) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE32) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE33)) + 2*vd*ZH21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE24*complexconjugate(ZE34) + ZE25*complexconjugate(ZE35) + ZE26*complexconjugate(ZE36)) + 2*vd*ZH21*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_361 = Coupling(name = 'GC_361',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE31) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE32) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE33)) + 2*vd*ZH21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE34*complexconjugate(ZE34) + ZE35*complexconjugate(ZE35) + ZE36*complexconjugate(ZE36)) + 2*vd*ZH21*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_362 = Coupling(name = 'GC_362',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE31) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE32) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE33)) + 2*vd*ZH21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE44*complexconjugate(ZE34) + ZE45*complexconjugate(ZE35) + ZE46*complexconjugate(ZE36)) + 2*vd*ZH21*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_363 = Coupling(name = 'GC_363',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE31) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE32) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE33)) + 2*vd*ZH21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE54*complexconjugate(ZE34) + ZE55*complexconjugate(ZE35) + ZE56*complexconjugate(ZE36)) + 2*vd*ZH21*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_364 = Coupling(name = 'GC_364',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE31) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE32) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE33)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE33)) + 2*vd*ZH21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE64*complexconjugate(ZE34) + ZE65*complexconjugate(ZE35) + ZE66*complexconjugate(ZE36)) + 2*vd*ZH21*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE34) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE35) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE36)) + cmath.sqrt(2)*ZH21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_365 = Coupling(name = 'GC_365',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE41) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE42) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE41) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE42) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE43)) + 2*vd*ZH21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE14*complexconjugate(ZE44) + ZE15*complexconjugate(ZE45) + ZE16*complexconjugate(ZE46)) + 2*vd*ZH21*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_366 = Coupling(name = 'GC_366',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE41) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE42) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE41) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE42) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE43)) + 2*vd*ZH21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE24*complexconjugate(ZE44) + ZE25*complexconjugate(ZE45) + ZE26*complexconjugate(ZE46)) + 2*vd*ZH21*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_367 = Coupling(name = 'GC_367',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE41) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE42) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE41) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE42) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE43)) + 2*vd*ZH21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE34*complexconjugate(ZE44) + ZE35*complexconjugate(ZE45) + ZE36*complexconjugate(ZE46)) + 2*vd*ZH21*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_368 = Coupling(name = 'GC_368',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE41) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE42) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE41) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE42) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE43)) + 2*vd*ZH21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE44*complexconjugate(ZE44) + ZE45*complexconjugate(ZE45) + ZE46*complexconjugate(ZE46)) + 2*vd*ZH21*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_369 = Coupling(name = 'GC_369',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE41) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE42) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE41) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE42) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE43)) + 2*vd*ZH21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE54*complexconjugate(ZE44) + ZE55*complexconjugate(ZE45) + ZE56*complexconjugate(ZE46)) + 2*vd*ZH21*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_370 = Coupling(name = 'GC_370',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE41) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE42) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE43)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE41) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE42) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE43)) + 2*vd*ZH21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE64*complexconjugate(ZE44) + ZE65*complexconjugate(ZE45) + ZE66*complexconjugate(ZE46)) + 2*vd*ZH21*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE44) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE45) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE46)) + cmath.sqrt(2)*ZH21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_371 = Coupling(name = 'GC_371',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE51) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE52) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE51) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE52) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE53)) + 2*vd*ZH21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE14*complexconjugate(ZE54) + ZE15*complexconjugate(ZE55) + ZE16*complexconjugate(ZE56)) + 2*vd*ZH21*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_372 = Coupling(name = 'GC_372',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE51) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE52) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE51) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE52) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE53)) + 2*vd*ZH21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE24*complexconjugate(ZE54) + ZE25*complexconjugate(ZE55) + ZE26*complexconjugate(ZE56)) + 2*vd*ZH21*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_373 = Coupling(name = 'GC_373',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE51) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE52) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE51) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE52) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE53)) + 2*vd*ZH21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE34*complexconjugate(ZE54) + ZE35*complexconjugate(ZE55) + ZE36*complexconjugate(ZE56)) + 2*vd*ZH21*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_374 = Coupling(name = 'GC_374',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE51) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE52) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE51) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE52) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE53)) + 2*vd*ZH21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE44*complexconjugate(ZE54) + ZE45*complexconjugate(ZE55) + ZE46*complexconjugate(ZE56)) + 2*vd*ZH21*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_375 = Coupling(name = 'GC_375',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE51) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE52) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE51) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE52) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE53)) + 2*vd*ZH21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE54*complexconjugate(ZE54) + ZE55*complexconjugate(ZE55) + ZE56*complexconjugate(ZE56)) + 2*vd*ZH21*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_376 = Coupling(name = 'GC_376',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE51) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE52) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE53)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE51) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE52) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE53)) + 2*vd*ZH21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE64*complexconjugate(ZE54) + ZE65*complexconjugate(ZE55) + ZE66*complexconjugate(ZE56)) + 2*vd*ZH21*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE54) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE55) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE56)) + cmath.sqrt(2)*ZH21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_377 = Coupling(name = 'GC_377',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZE61) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZE62) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZE61) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZE62) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZE63)) + 2*vd*ZH21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE14*complexconjugate(ZE64) + ZE15*complexconjugate(ZE65) + ZE16*complexconjugate(ZE66)) + 2*vd*ZH21*((ZE14*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE15*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE16*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE14*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE15*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE16*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE14*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE15*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE16*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH21*(ZE11*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_378 = Coupling(name = 'GC_378',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZE61) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZE62) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZE61) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZE62) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZE63)) + 2*vd*ZH21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE24*complexconjugate(ZE64) + ZE25*complexconjugate(ZE65) + ZE26*complexconjugate(ZE66)) + 2*vd*ZH21*((ZE24*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE25*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE26*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE24*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE25*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE26*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE24*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE25*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE26*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH21*(ZE21*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_379 = Coupling(name = 'GC_379',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZE61) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZE62) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZE61) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZE62) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZE63)) + 2*vd*ZH21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE34*complexconjugate(ZE64) + ZE35*complexconjugate(ZE65) + ZE36*complexconjugate(ZE66)) + 2*vd*ZH21*((ZE34*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE35*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE36*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE34*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE35*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE36*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE34*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE35*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE36*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH21*(ZE31*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_380 = Coupling(name = 'GC_380',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZE61) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZE62) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZE61) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZE62) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZE63)) + 2*vd*ZH21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE44*complexconjugate(ZE64) + ZE45*complexconjugate(ZE65) + ZE46*complexconjugate(ZE66)) + 2*vd*ZH21*((ZE44*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE45*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE46*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE44*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE45*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE46*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE44*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE45*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE46*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH21*(ZE41*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE41*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE42*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE43*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_381 = Coupling(name = 'GC_381',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZE61) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZE62) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZE61) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZE62) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZE63)) + 2*vd*ZH21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE54*complexconjugate(ZE64) + ZE55*complexconjugate(ZE65) + ZE56*complexconjugate(ZE66)) + 2*vd*ZH21*((ZE54*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE55*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE56*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE54*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE55*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE56*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE54*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE55*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE56*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH21*(ZE51*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE51*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE52*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE53*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_382 = Coupling(name = 'GC_382',
	 value = '-1./4.*complex(0,1)*((g1**2 - g2**2)*(vd*ZH21 - vu*ZH22)*(ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63)) + 2*(cmath.sqrt(2)*ZH21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZE61) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZE62) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZE63)) - cmath.sqrt(2)*Mu*ZH22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZE61) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZE62) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZE63)) + 2*vd*ZH21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + g1**2*(-(vd*ZH21) + vu*ZH22)*(ZE64*complexconjugate(ZE64) + ZE65*complexconjugate(ZE65) + ZE66*complexconjugate(ZE66)) + 2*vd*ZH21*((ZE64*(Ye11*complexconjugate(Ye11) + Ye12*complexconjugate(Ye12) + Ye13*complexconjugate(Ye13)) + ZE65*(Ye21*complexconjugate(Ye11) + Ye22*complexconjugate(Ye12) + Ye23*complexconjugate(Ye13)) + ZE66*(Ye31*complexconjugate(Ye11) + Ye32*complexconjugate(Ye12) + Ye33*complexconjugate(Ye13)))*complexconjugate(ZE64) + (ZE64*(Ye11*complexconjugate(Ye21) + Ye12*complexconjugate(Ye22) + Ye13*complexconjugate(Ye23)) + ZE65*(Ye21*complexconjugate(Ye21) + Ye22*complexconjugate(Ye22) + Ye23*complexconjugate(Ye23)) + ZE66*(Ye31*complexconjugate(Ye21) + Ye32*complexconjugate(Ye22) + Ye33*complexconjugate(Ye23)))*complexconjugate(ZE65) + (ZE64*(Ye11*complexconjugate(Ye31) + Ye12*complexconjugate(Ye32) + Ye13*complexconjugate(Ye33)) + ZE65*(Ye21*complexconjugate(Ye31) + Ye22*complexconjugate(Ye32) + Ye23*complexconjugate(Ye33)) + ZE66*(Ye31*complexconjugate(Ye31) + Ye32*complexconjugate(Ye32) + Ye33*complexconjugate(Ye33)))*complexconjugate(ZE66)) + cmath.sqrt(2)*ZH21*(ZE61*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) - cmath.sqrt(2)*ZH22*complexconjugate(Mu)*(ZE61*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZE62*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZE63*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_383 = Coupling(name = 'GC_383',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU11) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU12) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU13)) + 6*vu*ZH12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16)) + 6*vu*ZH12*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH12*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_384 = Coupling(name = 'GC_384',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU11) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU12) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU13)) + 6*vu*ZH12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16)) + 6*vu*ZH12*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH12*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_385 = Coupling(name = 'GC_385',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU11) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU12) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU13)) + 6*vu*ZH12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16)) + 6*vu*ZH12*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH12*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_386 = Coupling(name = 'GC_386',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU11) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU12) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU13)) + 6*vu*ZH12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16)) + 6*vu*ZH12*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH12*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_387 = Coupling(name = 'GC_387',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU11) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU12) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU13)) + 6*vu*ZH12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16)) + 6*vu*ZH12*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH12*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_388 = Coupling(name = 'GC_388',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU11) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU12) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU13)) + 6*vu*ZH12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16)) + 6*vu*ZH12*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH12*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_389 = Coupling(name = 'GC_389',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU21) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU22) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU23)) + 6*vu*ZH12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26)) + 6*vu*ZH12*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH12*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_390 = Coupling(name = 'GC_390',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU21) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU22) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU23)) + 6*vu*ZH12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26)) + 6*vu*ZH12*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH12*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_391 = Coupling(name = 'GC_391',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU21) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU22) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU23)) + 6*vu*ZH12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26)) + 6*vu*ZH12*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH12*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_392 = Coupling(name = 'GC_392',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU21) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU22) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU23)) + 6*vu*ZH12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26)) + 6*vu*ZH12*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH12*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_393 = Coupling(name = 'GC_393',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU21) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU22) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU23)) + 6*vu*ZH12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26)) + 6*vu*ZH12*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH12*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_394 = Coupling(name = 'GC_394',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU21) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU22) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU23)) + 6*vu*ZH12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26)) + 6*vu*ZH12*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH12*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_395 = Coupling(name = 'GC_395',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU31) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU32) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU33)) + 6*vu*ZH12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36)) + 6*vu*ZH12*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH12*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_396 = Coupling(name = 'GC_396',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU31) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU32) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU33)) + 6*vu*ZH12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36)) + 6*vu*ZH12*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH12*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_397 = Coupling(name = 'GC_397',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU31) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU32) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU33)) + 6*vu*ZH12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36)) + 6*vu*ZH12*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH12*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_398 = Coupling(name = 'GC_398',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU31) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU32) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU33)) + 6*vu*ZH12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36)) + 6*vu*ZH12*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH12*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_399 = Coupling(name = 'GC_399',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU31) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU32) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU33)) + 6*vu*ZH12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36)) + 6*vu*ZH12*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH12*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_400 = Coupling(name = 'GC_400',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU31) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU32) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU33)) + 6*vu*ZH12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36)) + 6*vu*ZH12*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH12*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_401 = Coupling(name = 'GC_401',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU41) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU42) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU41) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU42) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU43)) + 6*vu*ZH12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46)) + 6*vu*ZH12*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH12*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_402 = Coupling(name = 'GC_402',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU41) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU42) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU41) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU42) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU43)) + 6*vu*ZH12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46)) + 6*vu*ZH12*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH12*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_403 = Coupling(name = 'GC_403',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU41) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU42) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU41) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU42) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU43)) + 6*vu*ZH12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46)) + 6*vu*ZH12*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH12*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_404 = Coupling(name = 'GC_404',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU41) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU42) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU41) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU42) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU43)) + 6*vu*ZH12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46)) + 6*vu*ZH12*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH12*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_405 = Coupling(name = 'GC_405',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU41) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU42) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU41) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU42) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU43)) + 6*vu*ZH12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46)) + 6*vu*ZH12*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH12*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_406 = Coupling(name = 'GC_406',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU41) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU42) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU41) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU42) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU43)) + 6*vu*ZH12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46)) + 6*vu*ZH12*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH12*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_407 = Coupling(name = 'GC_407',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU51) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU52) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU51) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU52) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU53)) + 6*vu*ZH12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56)) + 6*vu*ZH12*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH12*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_408 = Coupling(name = 'GC_408',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU51) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU52) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU51) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU52) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU53)) + 6*vu*ZH12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56)) + 6*vu*ZH12*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH12*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_409 = Coupling(name = 'GC_409',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU51) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU52) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU51) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU52) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU53)) + 6*vu*ZH12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56)) + 6*vu*ZH12*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH12*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_410 = Coupling(name = 'GC_410',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU51) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU52) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU51) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU52) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU53)) + 6*vu*ZH12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56)) + 6*vu*ZH12*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH12*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_411 = Coupling(name = 'GC_411',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU51) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU52) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU51) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU52) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU53)) + 6*vu*ZH12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56)) + 6*vu*ZH12*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH12*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_412 = Coupling(name = 'GC_412',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU51) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU52) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU51) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU52) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU53)) + 6*vu*ZH12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56)) + 6*vu*ZH12*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH12*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_413 = Coupling(name = 'GC_413',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU61) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU62) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU61) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU62) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU63)) + 6*vu*ZH12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66)) + 6*vu*ZH12*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH12*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_414 = Coupling(name = 'GC_414',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU61) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU62) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU61) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU62) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU63)) + 6*vu*ZH12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66)) + 6*vu*ZH12*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH12*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_415 = Coupling(name = 'GC_415',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU61) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU62) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU61) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU62) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU63)) + 6*vu*ZH12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66)) + 6*vu*ZH12*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH12*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_416 = Coupling(name = 'GC_416',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU61) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU62) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU61) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU62) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU63)) + 6*vu*ZH12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66)) + 6*vu*ZH12*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH12*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_417 = Coupling(name = 'GC_417',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU61) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU62) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU61) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU62) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU63)) + 6*vu*ZH12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66)) + 6*vu*ZH12*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH12*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_418 = Coupling(name = 'GC_418',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH11 - vu*ZH12)*(ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU61) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU62) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU61) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU62) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU63)) + 6*vu*ZH12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH11 - vu*ZH12)*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66)) + 6*vu*ZH12*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH12*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH11*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_419 = Coupling(name = 'GC_419',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU11) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU12) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU13)) + 6*vu*ZH22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16)) + 6*vu*ZH22*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH22*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_420 = Coupling(name = 'GC_420',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU11) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU12) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU13)) + 6*vu*ZH22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16)) + 6*vu*ZH22*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH22*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_421 = Coupling(name = 'GC_421',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU11) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU12) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU13)) + 6*vu*ZH22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16)) + 6*vu*ZH22*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH22*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_422 = Coupling(name = 'GC_422',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU11) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU12) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU13)) + 6*vu*ZH22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16)) + 6*vu*ZH22*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH22*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_423 = Coupling(name = 'GC_423',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU11) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU12) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU13)) + 6*vu*ZH22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16)) + 6*vu*ZH22*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH22*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_424 = Coupling(name = 'GC_424',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU11) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU12) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU13)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU13)) + 6*vu*ZH22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16)) + 6*vu*ZH22*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 3*cmath.sqrt(2)*ZH22*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_425 = Coupling(name = 'GC_425',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU21) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU22) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU23)) + 6*vu*ZH22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26)) + 6*vu*ZH22*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH22*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_426 = Coupling(name = 'GC_426',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU21) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU22) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU23)) + 6*vu*ZH22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26)) + 6*vu*ZH22*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH22*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_427 = Coupling(name = 'GC_427',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU21) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU22) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU23)) + 6*vu*ZH22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26)) + 6*vu*ZH22*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH22*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_428 = Coupling(name = 'GC_428',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU21) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU22) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU23)) + 6*vu*ZH22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26)) + 6*vu*ZH22*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH22*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_429 = Coupling(name = 'GC_429',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU21) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU22) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU23)) + 6*vu*ZH22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26)) + 6*vu*ZH22*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH22*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_430 = Coupling(name = 'GC_430',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU21) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU22) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU23)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU23)) + 6*vu*ZH22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26)) + 6*vu*ZH22*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 3*cmath.sqrt(2)*ZH22*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_431 = Coupling(name = 'GC_431',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU31) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU32) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU33)) + 6*vu*ZH22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36)) + 6*vu*ZH22*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH22*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_432 = Coupling(name = 'GC_432',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU31) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU32) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU33)) + 6*vu*ZH22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36)) + 6*vu*ZH22*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH22*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_433 = Coupling(name = 'GC_433',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU31) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU32) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU33)) + 6*vu*ZH22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36)) + 6*vu*ZH22*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH22*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_434 = Coupling(name = 'GC_434',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU31) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU32) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU33)) + 6*vu*ZH22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36)) + 6*vu*ZH22*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH22*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_435 = Coupling(name = 'GC_435',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU31) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU32) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU33)) + 6*vu*ZH22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36)) + 6*vu*ZH22*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH22*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_436 = Coupling(name = 'GC_436',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU31) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU32) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU33)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU33)) + 6*vu*ZH22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36)) + 6*vu*ZH22*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 3*cmath.sqrt(2)*ZH22*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_437 = Coupling(name = 'GC_437',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU41) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU42) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU41) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU42) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU43)) + 6*vu*ZH22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46)) + 6*vu*ZH22*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH22*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_438 = Coupling(name = 'GC_438',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU41) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU42) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU41) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU42) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU43)) + 6*vu*ZH22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46)) + 6*vu*ZH22*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH22*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_439 = Coupling(name = 'GC_439',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU41) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU42) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU41) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU42) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU43)) + 6*vu*ZH22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46)) + 6*vu*ZH22*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH22*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_440 = Coupling(name = 'GC_440',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU41) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU42) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU41) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU42) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU43)) + 6*vu*ZH22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46)) + 6*vu*ZH22*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH22*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_441 = Coupling(name = 'GC_441',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU41) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU42) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU41) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU42) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU43)) + 6*vu*ZH22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46)) + 6*vu*ZH22*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH22*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_442 = Coupling(name = 'GC_442',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU41) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU42) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU43)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU41) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU42) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU43)) + 6*vu*ZH22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46)) + 6*vu*ZH22*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 3*cmath.sqrt(2)*ZH22*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_443 = Coupling(name = 'GC_443',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU51) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU52) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU51) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU52) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU53)) + 6*vu*ZH22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56)) + 6*vu*ZH22*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH22*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_444 = Coupling(name = 'GC_444',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU51) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU52) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU51) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU52) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU53)) + 6*vu*ZH22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56)) + 6*vu*ZH22*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH22*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_445 = Coupling(name = 'GC_445',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU51) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU52) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU51) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU52) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU53)) + 6*vu*ZH22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56)) + 6*vu*ZH22*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH22*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_446 = Coupling(name = 'GC_446',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU51) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU52) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU51) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU52) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU53)) + 6*vu*ZH22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56)) + 6*vu*ZH22*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH22*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_447 = Coupling(name = 'GC_447',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU51) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU52) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU51) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU52) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU53)) + 6*vu*ZH22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56)) + 6*vu*ZH22*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH22*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_448 = Coupling(name = 'GC_448',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU51) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU52) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU53)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU51) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU52) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU53)) + 6*vu*ZH22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56)) + 6*vu*ZH22*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 3*cmath.sqrt(2)*ZH22*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_449 = Coupling(name = 'GC_449',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZU61) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZU62) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZU61) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZU62) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZU63)) + 6*vu*ZH22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66)) + 6*vu*ZH22*((ZU14*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU15*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU16*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU14*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU15*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU16*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU14*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU15*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU16*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH22*(ZU11*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU12*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU13*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_450 = Coupling(name = 'GC_450',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZU61) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZU62) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZU61) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZU62) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZU63)) + 6*vu*ZH22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66)) + 6*vu*ZH22*((ZU24*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU25*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU26*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU24*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU25*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU26*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU24*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU25*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU26*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH22*(ZU21*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU22*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU23*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_451 = Coupling(name = 'GC_451',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZU61) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZU62) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZU61) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZU62) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZU63)) + 6*vu*ZH22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66)) + 6*vu*ZH22*((ZU34*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU35*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU36*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU34*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU35*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU36*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU34*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU35*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU36*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH22*(ZU31*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU32*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU33*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_452 = Coupling(name = 'GC_452',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZU61) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZU62) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZU61) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZU62) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZU63)) + 6*vu*ZH22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66)) + 6*vu*ZH22*((ZU44*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU45*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU46*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU44*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU45*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU46*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU44*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU45*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU46*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH22*(ZU41*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU42*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU43*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU41*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU42*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU43*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_453 = Coupling(name = 'GC_453',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZU61) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZU62) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZU61) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZU62) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZU63)) + 6*vu*ZH22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66)) + 6*vu*ZH22*((ZU54*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU55*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU56*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU54*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU55*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU56*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU54*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU55*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU56*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH22*(ZU51*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU52*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU53*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU51*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU52*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU53*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_454 = Coupling(name = 'GC_454',
	 value = '1./12.*complex(0,1)*((g1**2 - 3*g2**2)*(vd*ZH21 - vu*ZH22)*(ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63)) - 2*(3*cmath.sqrt(2)*ZH22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZU61) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZU62) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZU63)) - 3*cmath.sqrt(2)*Mu*ZH21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZU61) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZU62) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZU63)) + 6*vu*ZH22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + 2*g1**2*(vd*ZH21 - vu*ZH22)*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66)) + 6*vu*ZH22*((ZU64*(Yu11*complexconjugate(Yu11) + Yu12*complexconjugate(Yu12) + Yu13*complexconjugate(Yu13)) + ZU65*(Yu21*complexconjugate(Yu11) + Yu22*complexconjugate(Yu12) + Yu23*complexconjugate(Yu13)) + ZU66*(Yu31*complexconjugate(Yu11) + Yu32*complexconjugate(Yu12) + Yu33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZU64*(Yu11*complexconjugate(Yu21) + Yu12*complexconjugate(Yu22) + Yu13*complexconjugate(Yu23)) + ZU65*(Yu21*complexconjugate(Yu21) + Yu22*complexconjugate(Yu22) + Yu23*complexconjugate(Yu23)) + ZU66*(Yu31*complexconjugate(Yu21) + Yu32*complexconjugate(Yu22) + Yu33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZU64*(Yu11*complexconjugate(Yu31) + Yu12*complexconjugate(Yu32) + Yu13*complexconjugate(Yu33)) + ZU65*(Yu21*complexconjugate(Yu31) + Yu22*complexconjugate(Yu32) + Yu23*complexconjugate(Yu33)) + ZU66*(Yu31*complexconjugate(Yu31) + Yu32*complexconjugate(Yu32) + Yu33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 3*cmath.sqrt(2)*ZH22*(ZU61*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZU62*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZU63*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) - 3*cmath.sqrt(2)*ZH21*complexconjugate(Mu)*(ZU61*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZU62*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZU63*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_455 = Coupling(name = 'GC_455',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(vd*ZH11 - vu*ZH12)', 
	 order = {'QED':1} ) 
 
GC_456 = Coupling(name = 'GC_456',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(vd*ZH11 - vu*ZH12)', 
	 order = {'QED':1} ) 
 
GC_457 = Coupling(name = 'GC_457',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(vd*ZH11 - vu*ZH12)', 
	 order = {'QED':1} ) 
 
GC_458 = Coupling(name = 'GC_458',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(vd*ZH21 - vu*ZH22)', 
	 order = {'QED':1} ) 
 
GC_459 = Coupling(name = 'GC_459',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(vd*ZH21 - vu*ZH22)', 
	 order = {'QED':1} ) 
 
GC_460 = Coupling(name = 'GC_460',
	 value = '-1./4.*complex(0,1)*(g1**2 + g2**2)*(vd*ZH21 - vu*ZH22)', 
	 order = {'QED':1} ) 
 
GC_461 = Coupling(name = 'GC_461',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD11*complexconjugate(ZU11) + ZD12*complexconjugate(ZU12) + ZD13*complexconjugate(ZU13)) - 2*(2*ZP11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU11) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU12) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU13)) + 2*Mu*ZP12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP12*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP11*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP12*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP12*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP11*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_462 = Coupling(name = 'GC_462',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD21*complexconjugate(ZU11) + ZD22*complexconjugate(ZU12) + ZD23*complexconjugate(ZU13)) - 2*(2*ZP11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU11) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU12) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU13)) + 2*Mu*ZP12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP12*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP11*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP12*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP12*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP11*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_463 = Coupling(name = 'GC_463',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD31*complexconjugate(ZU11) + ZD32*complexconjugate(ZU12) + ZD33*complexconjugate(ZU13)) - 2*(2*ZP11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU11) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU12) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU13)) + 2*Mu*ZP12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP12*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP11*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP12*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP12*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP11*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_464 = Coupling(name = 'GC_464',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD41*complexconjugate(ZU11) + ZD42*complexconjugate(ZU12) + ZD43*complexconjugate(ZU13)) - 2*(2*ZP11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU11) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU12) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU13)) + 2*Mu*ZP12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP12*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP11*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP12*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP12*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP11*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_465 = Coupling(name = 'GC_465',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD51*complexconjugate(ZU11) + ZD52*complexconjugate(ZU12) + ZD53*complexconjugate(ZU13)) - 2*(2*ZP11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU11) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU12) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU13)) + 2*Mu*ZP12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP12*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP11*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP12*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP12*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP11*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_466 = Coupling(name = 'GC_466',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD61*complexconjugate(ZU11) + ZD62*complexconjugate(ZU12) + ZD63*complexconjugate(ZU13)) - 2*(2*ZP11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU11) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU12) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU13)) + 2*Mu*ZP12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP12*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP11*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP12*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP12*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP11*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_467 = Coupling(name = 'GC_467',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD11*complexconjugate(ZU21) + ZD12*complexconjugate(ZU22) + ZD13*complexconjugate(ZU23)) - 2*(2*ZP11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU21) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU22) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU23)) + 2*Mu*ZP12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP12*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP11*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP12*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP12*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP11*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_468 = Coupling(name = 'GC_468',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD21*complexconjugate(ZU21) + ZD22*complexconjugate(ZU22) + ZD23*complexconjugate(ZU23)) - 2*(2*ZP11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU21) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU22) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU23)) + 2*Mu*ZP12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP12*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP11*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP12*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP12*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP11*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_469 = Coupling(name = 'GC_469',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD31*complexconjugate(ZU21) + ZD32*complexconjugate(ZU22) + ZD33*complexconjugate(ZU23)) - 2*(2*ZP11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU21) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU22) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU23)) + 2*Mu*ZP12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP12*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP11*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP12*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP12*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP11*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_470 = Coupling(name = 'GC_470',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD41*complexconjugate(ZU21) + ZD42*complexconjugate(ZU22) + ZD43*complexconjugate(ZU23)) - 2*(2*ZP11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU21) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU22) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU23)) + 2*Mu*ZP12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP12*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP11*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP12*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP12*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP11*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_471 = Coupling(name = 'GC_471',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD51*complexconjugate(ZU21) + ZD52*complexconjugate(ZU22) + ZD53*complexconjugate(ZU23)) - 2*(2*ZP11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU21) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU22) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU23)) + 2*Mu*ZP12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP12*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP11*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP12*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP12*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP11*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_472 = Coupling(name = 'GC_472',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD61*complexconjugate(ZU21) + ZD62*complexconjugate(ZU22) + ZD63*complexconjugate(ZU23)) - 2*(2*ZP11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU21) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU22) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU23)) + 2*Mu*ZP12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP12*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP11*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP12*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP12*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP11*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_473 = Coupling(name = 'GC_473',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD11*complexconjugate(ZU31) + ZD12*complexconjugate(ZU32) + ZD13*complexconjugate(ZU33)) - 2*(2*ZP11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU31) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU32) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU33)) + 2*Mu*ZP12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP12*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP11*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP12*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP12*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP11*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_474 = Coupling(name = 'GC_474',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD21*complexconjugate(ZU31) + ZD22*complexconjugate(ZU32) + ZD23*complexconjugate(ZU33)) - 2*(2*ZP11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU31) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU32) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU33)) + 2*Mu*ZP12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP12*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP11*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP12*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP12*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP11*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_475 = Coupling(name = 'GC_475',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD31*complexconjugate(ZU31) + ZD32*complexconjugate(ZU32) + ZD33*complexconjugate(ZU33)) - 2*(2*ZP11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU31) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU32) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU33)) + 2*Mu*ZP12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP12*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP11*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP12*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP12*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP11*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_476 = Coupling(name = 'GC_476',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD41*complexconjugate(ZU31) + ZD42*complexconjugate(ZU32) + ZD43*complexconjugate(ZU33)) - 2*(2*ZP11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU31) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU32) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU33)) + 2*Mu*ZP12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP12*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP11*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP12*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP12*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP11*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_477 = Coupling(name = 'GC_477',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD51*complexconjugate(ZU31) + ZD52*complexconjugate(ZU32) + ZD53*complexconjugate(ZU33)) - 2*(2*ZP11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU31) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU32) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU33)) + 2*Mu*ZP12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP12*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP11*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP12*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP12*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP11*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_478 = Coupling(name = 'GC_478',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD61*complexconjugate(ZU31) + ZD62*complexconjugate(ZU32) + ZD63*complexconjugate(ZU33)) - 2*(2*ZP11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU31) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU32) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU33)) + 2*Mu*ZP12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP12*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP11*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP12*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP12*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP11*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_479 = Coupling(name = 'GC_479',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD11*complexconjugate(ZU41) + ZD12*complexconjugate(ZU42) + ZD13*complexconjugate(ZU43)) - 2*(2*ZP11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU41) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU42) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU43)) + 2*Mu*ZP12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU41) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU42) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP12*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP11*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP12*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP12*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP11*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_480 = Coupling(name = 'GC_480',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD21*complexconjugate(ZU41) + ZD22*complexconjugate(ZU42) + ZD23*complexconjugate(ZU43)) - 2*(2*ZP11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU41) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU42) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU43)) + 2*Mu*ZP12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU41) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU42) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP12*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP11*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP12*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP12*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP11*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_481 = Coupling(name = 'GC_481',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD31*complexconjugate(ZU41) + ZD32*complexconjugate(ZU42) + ZD33*complexconjugate(ZU43)) - 2*(2*ZP11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU41) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU42) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU43)) + 2*Mu*ZP12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU41) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU42) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP12*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP11*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP12*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP12*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP11*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_482 = Coupling(name = 'GC_482',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD41*complexconjugate(ZU41) + ZD42*complexconjugate(ZU42) + ZD43*complexconjugate(ZU43)) - 2*(2*ZP11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU41) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU42) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU43)) + 2*Mu*ZP12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU41) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU42) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP12*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP11*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP12*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP12*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP11*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_483 = Coupling(name = 'GC_483',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD51*complexconjugate(ZU41) + ZD52*complexconjugate(ZU42) + ZD53*complexconjugate(ZU43)) - 2*(2*ZP11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU41) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU42) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU43)) + 2*Mu*ZP12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU41) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU42) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP12*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP11*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP12*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP12*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP11*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_484 = Coupling(name = 'GC_484',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD61*complexconjugate(ZU41) + ZD62*complexconjugate(ZU42) + ZD63*complexconjugate(ZU43)) - 2*(2*ZP11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU41) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU42) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU43)) + 2*Mu*ZP12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU41) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU42) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP12*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP11*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP12*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP12*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP11*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_485 = Coupling(name = 'GC_485',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD11*complexconjugate(ZU51) + ZD12*complexconjugate(ZU52) + ZD13*complexconjugate(ZU53)) - 2*(2*ZP11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU51) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU52) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU53)) + 2*Mu*ZP12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU51) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU52) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP12*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP11*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP12*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP12*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP11*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_486 = Coupling(name = 'GC_486',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD21*complexconjugate(ZU51) + ZD22*complexconjugate(ZU52) + ZD23*complexconjugate(ZU53)) - 2*(2*ZP11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU51) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU52) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU53)) + 2*Mu*ZP12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU51) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU52) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP12*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP11*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP12*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP12*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP11*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_487 = Coupling(name = 'GC_487',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD31*complexconjugate(ZU51) + ZD32*complexconjugate(ZU52) + ZD33*complexconjugate(ZU53)) - 2*(2*ZP11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU51) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU52) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU53)) + 2*Mu*ZP12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU51) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU52) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP12*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP11*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP12*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP12*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP11*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_488 = Coupling(name = 'GC_488',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD41*complexconjugate(ZU51) + ZD42*complexconjugate(ZU52) + ZD43*complexconjugate(ZU53)) - 2*(2*ZP11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU51) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU52) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU53)) + 2*Mu*ZP12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU51) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU52) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP12*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP11*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP12*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP12*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP11*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_489 = Coupling(name = 'GC_489',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD51*complexconjugate(ZU51) + ZD52*complexconjugate(ZU52) + ZD53*complexconjugate(ZU53)) - 2*(2*ZP11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU51) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU52) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU53)) + 2*Mu*ZP12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU51) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU52) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP12*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP11*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP12*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP12*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP11*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_490 = Coupling(name = 'GC_490',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD61*complexconjugate(ZU51) + ZD62*complexconjugate(ZU52) + ZD63*complexconjugate(ZU53)) - 2*(2*ZP11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU51) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU52) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU53)) + 2*Mu*ZP12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU51) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU52) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP12*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP11*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP12*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP12*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP11*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_491 = Coupling(name = 'GC_491',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD11*complexconjugate(ZU61) + ZD12*complexconjugate(ZU62) + ZD13*complexconjugate(ZU63)) - 2*(2*ZP11*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU61) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU62) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU63)) + 2*Mu*ZP12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU61) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU62) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP11*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP12*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP11*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP12*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP12*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP11*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_492 = Coupling(name = 'GC_492',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD21*complexconjugate(ZU61) + ZD22*complexconjugate(ZU62) + ZD23*complexconjugate(ZU63)) - 2*(2*ZP11*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU61) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU62) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU63)) + 2*Mu*ZP12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU61) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU62) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP11*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP12*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP11*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP12*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP12*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP11*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_493 = Coupling(name = 'GC_493',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD31*complexconjugate(ZU61) + ZD32*complexconjugate(ZU62) + ZD33*complexconjugate(ZU63)) - 2*(2*ZP11*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU61) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU62) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU63)) + 2*Mu*ZP12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU61) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU62) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP11*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP12*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP11*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP12*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP12*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP11*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_494 = Coupling(name = 'GC_494',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD41*complexconjugate(ZU61) + ZD42*complexconjugate(ZU62) + ZD43*complexconjugate(ZU63)) - 2*(2*ZP11*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU61) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU62) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU63)) + 2*Mu*ZP12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU61) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU62) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP11*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP12*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP11*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP12*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP12*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP11*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_495 = Coupling(name = 'GC_495',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD51*complexconjugate(ZU61) + ZD52*complexconjugate(ZU62) + ZD53*complexconjugate(ZU63)) - 2*(2*ZP11*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU61) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU62) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU63)) + 2*Mu*ZP12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU61) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU62) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP11*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP12*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP11*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP12*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP12*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP11*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_496 = Coupling(name = 'GC_496',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZD61*complexconjugate(ZU61) + ZD62*complexconjugate(ZU62) + ZD63*complexconjugate(ZU63)) - 2*(2*ZP11*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU61) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU62) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU63)) + 2*Mu*ZP12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU61) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU62) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP11*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP12*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP11*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP12*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP12*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP11*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_497 = Coupling(name = 'GC_497',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD11*complexconjugate(ZU11) + ZD12*complexconjugate(ZU12) + ZD13*complexconjugate(ZU13)) - 2*(2*ZP21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU11) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU12) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU13)) + 2*Mu*ZP22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP22*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP21*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP22*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP22*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP21*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_498 = Coupling(name = 'GC_498',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD21*complexconjugate(ZU11) + ZD22*complexconjugate(ZU12) + ZD23*complexconjugate(ZU13)) - 2*(2*ZP21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU11) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU12) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU13)) + 2*Mu*ZP22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP22*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP21*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP22*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP22*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP21*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_499 = Coupling(name = 'GC_499',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD31*complexconjugate(ZU11) + ZD32*complexconjugate(ZU12) + ZD33*complexconjugate(ZU13)) - 2*(2*ZP21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU11) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU12) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU13)) + 2*Mu*ZP22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP22*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP21*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP22*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP22*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP21*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_500 = Coupling(name = 'GC_500',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD41*complexconjugate(ZU11) + ZD42*complexconjugate(ZU12) + ZD43*complexconjugate(ZU13)) - 2*(2*ZP21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU11) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU12) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU13)) + 2*Mu*ZP22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP22*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP21*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP22*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP22*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP21*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_501 = Coupling(name = 'GC_501',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD51*complexconjugate(ZU11) + ZD52*complexconjugate(ZU12) + ZD53*complexconjugate(ZU13)) - 2*(2*ZP21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU11) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU12) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU13)) + 2*Mu*ZP22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP22*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP21*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP22*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP22*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP21*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_502 = Coupling(name = 'GC_502',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD61*complexconjugate(ZU11) + ZD62*complexconjugate(ZU12) + ZD63*complexconjugate(ZU13)) - 2*(2*ZP21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU11) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU12) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU13)) + 2*Mu*ZP22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU13)) + cmath.sqrt(2)*vd*ZP21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU13)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU13)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP22*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU13)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU13)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU13))) + cmath.sqrt(2)*vu*ZP21*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + cmath.sqrt(2)*vd*ZP22*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU14) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU15) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU16)) + 2*ZP22*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU14) + complexconjugate(Tu21)*complexconjugate(ZU15) + complexconjugate(Tu31)*complexconjugate(ZU16)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU14) + complexconjugate(Tu22)*complexconjugate(ZU15) + complexconjugate(Tu32)*complexconjugate(ZU16)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU14) + complexconjugate(Tu23)*complexconjugate(ZU15) + complexconjugate(Tu33)*complexconjugate(ZU16))) + 2*ZP21*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16)))))', 
	 order = {'QED':1} ) 
 
GC_503 = Coupling(name = 'GC_503',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD11*complexconjugate(ZU21) + ZD12*complexconjugate(ZU22) + ZD13*complexconjugate(ZU23)) - 2*(2*ZP21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU21) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU22) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU23)) + 2*Mu*ZP22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP22*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP21*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP22*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP22*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP21*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_504 = Coupling(name = 'GC_504',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD21*complexconjugate(ZU21) + ZD22*complexconjugate(ZU22) + ZD23*complexconjugate(ZU23)) - 2*(2*ZP21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU21) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU22) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU23)) + 2*Mu*ZP22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP22*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP21*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP22*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP22*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP21*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_505 = Coupling(name = 'GC_505',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD31*complexconjugate(ZU21) + ZD32*complexconjugate(ZU22) + ZD33*complexconjugate(ZU23)) - 2*(2*ZP21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU21) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU22) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU23)) + 2*Mu*ZP22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP22*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP21*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP22*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP22*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP21*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_506 = Coupling(name = 'GC_506',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD41*complexconjugate(ZU21) + ZD42*complexconjugate(ZU22) + ZD43*complexconjugate(ZU23)) - 2*(2*ZP21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU21) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU22) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU23)) + 2*Mu*ZP22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP22*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP21*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP22*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP22*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP21*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_507 = Coupling(name = 'GC_507',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD51*complexconjugate(ZU21) + ZD52*complexconjugate(ZU22) + ZD53*complexconjugate(ZU23)) - 2*(2*ZP21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU21) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU22) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU23)) + 2*Mu*ZP22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP22*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP21*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP22*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP22*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP21*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_508 = Coupling(name = 'GC_508',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD61*complexconjugate(ZU21) + ZD62*complexconjugate(ZU22) + ZD63*complexconjugate(ZU23)) - 2*(2*ZP21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU21) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU22) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU23)) + 2*Mu*ZP22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU23)) + cmath.sqrt(2)*vd*ZP21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU23)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU23)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP22*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU23)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU23)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU23))) + cmath.sqrt(2)*vu*ZP21*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + cmath.sqrt(2)*vd*ZP22*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU24) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU25) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU26)) + 2*ZP22*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU24) + complexconjugate(Tu21)*complexconjugate(ZU25) + complexconjugate(Tu31)*complexconjugate(ZU26)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU24) + complexconjugate(Tu22)*complexconjugate(ZU25) + complexconjugate(Tu32)*complexconjugate(ZU26)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU24) + complexconjugate(Tu23)*complexconjugate(ZU25) + complexconjugate(Tu33)*complexconjugate(ZU26))) + 2*ZP21*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26)))))', 
	 order = {'QED':1} ) 
 
GC_509 = Coupling(name = 'GC_509',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD11*complexconjugate(ZU31) + ZD12*complexconjugate(ZU32) + ZD13*complexconjugate(ZU33)) - 2*(2*ZP21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU31) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU32) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU33)) + 2*Mu*ZP22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP22*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP21*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP22*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP22*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP21*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_510 = Coupling(name = 'GC_510',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD21*complexconjugate(ZU31) + ZD22*complexconjugate(ZU32) + ZD23*complexconjugate(ZU33)) - 2*(2*ZP21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU31) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU32) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU33)) + 2*Mu*ZP22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP22*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP21*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP22*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP22*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP21*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_511 = Coupling(name = 'GC_511',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD31*complexconjugate(ZU31) + ZD32*complexconjugate(ZU32) + ZD33*complexconjugate(ZU33)) - 2*(2*ZP21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU31) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU32) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU33)) + 2*Mu*ZP22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP22*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP21*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP22*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP22*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP21*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_512 = Coupling(name = 'GC_512',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD41*complexconjugate(ZU31) + ZD42*complexconjugate(ZU32) + ZD43*complexconjugate(ZU33)) - 2*(2*ZP21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU31) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU32) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU33)) + 2*Mu*ZP22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP22*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP21*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP22*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP22*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP21*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_513 = Coupling(name = 'GC_513',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD51*complexconjugate(ZU31) + ZD52*complexconjugate(ZU32) + ZD53*complexconjugate(ZU33)) - 2*(2*ZP21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU31) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU32) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU33)) + 2*Mu*ZP22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP22*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP21*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP22*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP22*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP21*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_514 = Coupling(name = 'GC_514',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD61*complexconjugate(ZU31) + ZD62*complexconjugate(ZU32) + ZD63*complexconjugate(ZU33)) - 2*(2*ZP21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU31) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU32) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU33)) + 2*Mu*ZP22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU33)) + cmath.sqrt(2)*vd*ZP21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU33)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU33)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP22*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU33)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU33)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU33))) + cmath.sqrt(2)*vu*ZP21*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + cmath.sqrt(2)*vd*ZP22*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU34) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU35) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU36)) + 2*ZP22*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU34) + complexconjugate(Tu21)*complexconjugate(ZU35) + complexconjugate(Tu31)*complexconjugate(ZU36)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU34) + complexconjugate(Tu22)*complexconjugate(ZU35) + complexconjugate(Tu32)*complexconjugate(ZU36)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU34) + complexconjugate(Tu23)*complexconjugate(ZU35) + complexconjugate(Tu33)*complexconjugate(ZU36))) + 2*ZP21*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36)))))', 
	 order = {'QED':1} ) 
 
GC_515 = Coupling(name = 'GC_515',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD11*complexconjugate(ZU41) + ZD12*complexconjugate(ZU42) + ZD13*complexconjugate(ZU43)) - 2*(2*ZP21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU41) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU42) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU43)) + 2*Mu*ZP22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU41) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU42) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP22*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP21*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP22*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP22*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP21*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_516 = Coupling(name = 'GC_516',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD21*complexconjugate(ZU41) + ZD22*complexconjugate(ZU42) + ZD23*complexconjugate(ZU43)) - 2*(2*ZP21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU41) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU42) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU43)) + 2*Mu*ZP22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU41) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU42) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP22*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP21*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP22*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP22*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP21*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_517 = Coupling(name = 'GC_517',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD31*complexconjugate(ZU41) + ZD32*complexconjugate(ZU42) + ZD33*complexconjugate(ZU43)) - 2*(2*ZP21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU41) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU42) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU43)) + 2*Mu*ZP22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU41) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU42) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP22*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP21*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP22*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP22*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP21*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_518 = Coupling(name = 'GC_518',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD41*complexconjugate(ZU41) + ZD42*complexconjugate(ZU42) + ZD43*complexconjugate(ZU43)) - 2*(2*ZP21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU41) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU42) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU43)) + 2*Mu*ZP22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU41) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU42) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP22*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP21*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP22*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP22*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP21*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_519 = Coupling(name = 'GC_519',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD51*complexconjugate(ZU41) + ZD52*complexconjugate(ZU42) + ZD53*complexconjugate(ZU43)) - 2*(2*ZP21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU41) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU42) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU43)) + 2*Mu*ZP22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU41) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU42) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP22*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP21*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP22*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP22*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP21*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_520 = Coupling(name = 'GC_520',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD61*complexconjugate(ZU41) + ZD62*complexconjugate(ZU42) + ZD63*complexconjugate(ZU43)) - 2*(2*ZP21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU41) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU42) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU43)) + 2*Mu*ZP22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU41) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU42) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU43)) + cmath.sqrt(2)*vd*ZP21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU43)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU43)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP22*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU43)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU43)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU43))) + cmath.sqrt(2)*vu*ZP21*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + cmath.sqrt(2)*vd*ZP22*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU44) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU45) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU46)) + 2*ZP22*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU44) + complexconjugate(Tu21)*complexconjugate(ZU45) + complexconjugate(Tu31)*complexconjugate(ZU46)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU44) + complexconjugate(Tu22)*complexconjugate(ZU45) + complexconjugate(Tu32)*complexconjugate(ZU46)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU44) + complexconjugate(Tu23)*complexconjugate(ZU45) + complexconjugate(Tu33)*complexconjugate(ZU46))) + 2*ZP21*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46)))))', 
	 order = {'QED':1} ) 
 
GC_521 = Coupling(name = 'GC_521',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD11*complexconjugate(ZU51) + ZD12*complexconjugate(ZU52) + ZD13*complexconjugate(ZU53)) - 2*(2*ZP21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU51) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU52) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU53)) + 2*Mu*ZP22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU51) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU52) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP22*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP21*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP22*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP22*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP21*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_522 = Coupling(name = 'GC_522',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD21*complexconjugate(ZU51) + ZD22*complexconjugate(ZU52) + ZD23*complexconjugate(ZU53)) - 2*(2*ZP21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU51) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU52) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU53)) + 2*Mu*ZP22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU51) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU52) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP22*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP21*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP22*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP22*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP21*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_523 = Coupling(name = 'GC_523',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD31*complexconjugate(ZU51) + ZD32*complexconjugate(ZU52) + ZD33*complexconjugate(ZU53)) - 2*(2*ZP21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU51) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU52) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU53)) + 2*Mu*ZP22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU51) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU52) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP22*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP21*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP22*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP22*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP21*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_524 = Coupling(name = 'GC_524',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD41*complexconjugate(ZU51) + ZD42*complexconjugate(ZU52) + ZD43*complexconjugate(ZU53)) - 2*(2*ZP21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU51) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU52) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU53)) + 2*Mu*ZP22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU51) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU52) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP22*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP21*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP22*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP22*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP21*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_525 = Coupling(name = 'GC_525',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD51*complexconjugate(ZU51) + ZD52*complexconjugate(ZU52) + ZD53*complexconjugate(ZU53)) - 2*(2*ZP21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU51) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU52) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU53)) + 2*Mu*ZP22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU51) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU52) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP22*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP21*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP22*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP22*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP21*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_526 = Coupling(name = 'GC_526',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD61*complexconjugate(ZU51) + ZD62*complexconjugate(ZU52) + ZD63*complexconjugate(ZU53)) - 2*(2*ZP21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU51) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU52) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU53)) + 2*Mu*ZP22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU51) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU52) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU53)) + cmath.sqrt(2)*vd*ZP21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU53)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU53)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP22*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU53)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU53)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU53))) + cmath.sqrt(2)*vu*ZP21*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + cmath.sqrt(2)*vd*ZP22*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU54) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU55) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU56)) + 2*ZP22*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU54) + complexconjugate(Tu21)*complexconjugate(ZU55) + complexconjugate(Tu31)*complexconjugate(ZU56)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU54) + complexconjugate(Tu22)*complexconjugate(ZU55) + complexconjugate(Tu32)*complexconjugate(ZU56)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU54) + complexconjugate(Tu23)*complexconjugate(ZU55) + complexconjugate(Tu33)*complexconjugate(ZU56))) + 2*ZP21*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56)))))', 
	 order = {'QED':1} ) 
 
GC_527 = Coupling(name = 'GC_527',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD11*complexconjugate(ZU61) + ZD12*complexconjugate(ZU62) + ZD13*complexconjugate(ZU63)) - 2*(2*ZP21*((Td11*ZD14 + Td21*ZD15 + Td31*ZD16)*complexconjugate(ZU61) + (Td12*ZD14 + Td22*ZD15 + Td32*ZD16)*complexconjugate(ZU62) + (Td13*ZD14 + Td23*ZD15 + Td33*ZD16)*complexconjugate(ZU63)) + 2*Mu*ZP22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZU61) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZU62) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP21*(ZD11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP22*(ZD11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP21*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP22*((ZD14*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD15*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD16*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD14*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD15*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD16*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD14*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD15*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD16*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP22*(ZD11*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD12*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD13*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP21*complexconjugate(Mu)*(ZD11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_528 = Coupling(name = 'GC_528',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD21*complexconjugate(ZU61) + ZD22*complexconjugate(ZU62) + ZD23*complexconjugate(ZU63)) - 2*(2*ZP21*((Td11*ZD24 + Td21*ZD25 + Td31*ZD26)*complexconjugate(ZU61) + (Td12*ZD24 + Td22*ZD25 + Td32*ZD26)*complexconjugate(ZU62) + (Td13*ZD24 + Td23*ZD25 + Td33*ZD26)*complexconjugate(ZU63)) + 2*Mu*ZP22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZU61) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZU62) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP21*(ZD21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP22*(ZD21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP21*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP22*((ZD24*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD25*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD26*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD24*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD25*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD26*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD24*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD25*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD26*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP22*(ZD21*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD22*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD23*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP21*complexconjugate(Mu)*(ZD21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_529 = Coupling(name = 'GC_529',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD31*complexconjugate(ZU61) + ZD32*complexconjugate(ZU62) + ZD33*complexconjugate(ZU63)) - 2*(2*ZP21*((Td11*ZD34 + Td21*ZD35 + Td31*ZD36)*complexconjugate(ZU61) + (Td12*ZD34 + Td22*ZD35 + Td32*ZD36)*complexconjugate(ZU62) + (Td13*ZD34 + Td23*ZD35 + Td33*ZD36)*complexconjugate(ZU63)) + 2*Mu*ZP22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZU61) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZU62) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP21*(ZD31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP22*(ZD31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP21*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP22*((ZD34*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD35*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD36*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD34*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD35*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD36*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD34*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD35*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD36*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP22*(ZD31*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD32*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD33*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP21*complexconjugate(Mu)*(ZD31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_530 = Coupling(name = 'GC_530',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD41*complexconjugate(ZU61) + ZD42*complexconjugate(ZU62) + ZD43*complexconjugate(ZU63)) - 2*(2*ZP21*((Td11*ZD44 + Td21*ZD45 + Td31*ZD46)*complexconjugate(ZU61) + (Td12*ZD44 + Td22*ZD45 + Td32*ZD46)*complexconjugate(ZU62) + (Td13*ZD44 + Td23*ZD45 + Td33*ZD46)*complexconjugate(ZU63)) + 2*Mu*ZP22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZU61) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZU62) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP21*(ZD41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP22*(ZD41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP21*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP22*((ZD44*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD45*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD46*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD44*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD45*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD46*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD44*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD45*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD46*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP22*(ZD41*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD42*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD43*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP21*complexconjugate(Mu)*(ZD41*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD42*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD43*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_531 = Coupling(name = 'GC_531',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD51*complexconjugate(ZU61) + ZD52*complexconjugate(ZU62) + ZD53*complexconjugate(ZU63)) - 2*(2*ZP21*((Td11*ZD54 + Td21*ZD55 + Td31*ZD56)*complexconjugate(ZU61) + (Td12*ZD54 + Td22*ZD55 + Td32*ZD56)*complexconjugate(ZU62) + (Td13*ZD54 + Td23*ZD55 + Td33*ZD56)*complexconjugate(ZU63)) + 2*Mu*ZP22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZU61) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZU62) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP21*(ZD51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP22*(ZD51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP21*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP22*((ZD54*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD55*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD56*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD54*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD55*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD56*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD54*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD55*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD56*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP22*(ZD51*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD52*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD53*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP21*complexconjugate(Mu)*(ZD51*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD52*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD53*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_532 = Coupling(name = 'GC_532',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZD61*complexconjugate(ZU61) + ZD62*complexconjugate(ZU62) + ZD63*complexconjugate(ZU63)) - 2*(2*ZP21*((Td11*ZD64 + Td21*ZD65 + Td31*ZD66)*complexconjugate(ZU61) + (Td12*ZD64 + Td22*ZD65 + Td32*ZD66)*complexconjugate(ZU62) + (Td13*ZD64 + Td23*ZD65 + Td33*ZD66)*complexconjugate(ZU63)) + 2*Mu*ZP22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZU61) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZU62) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZU63)) + cmath.sqrt(2)*vd*ZP21*(ZD61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZU63)) + ZD62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZU63)) + ZD63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZU61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZU62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP22*(ZD61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZU63)) + ZD62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZU63)) + ZD63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZU61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZU62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZU63))) + cmath.sqrt(2)*vu*ZP21*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + cmath.sqrt(2)*vd*ZP22*((ZD64*(Yd11*complexconjugate(Yu11) + Yd12*complexconjugate(Yu12) + Yd13*complexconjugate(Yu13)) + ZD65*(Yd21*complexconjugate(Yu11) + Yd22*complexconjugate(Yu12) + Yd23*complexconjugate(Yu13)) + ZD66*(Yd31*complexconjugate(Yu11) + Yd32*complexconjugate(Yu12) + Yd33*complexconjugate(Yu13)))*complexconjugate(ZU64) + (ZD64*(Yd11*complexconjugate(Yu21) + Yd12*complexconjugate(Yu22) + Yd13*complexconjugate(Yu23)) + ZD65*(Yd21*complexconjugate(Yu21) + Yd22*complexconjugate(Yu22) + Yd23*complexconjugate(Yu23)) + ZD66*(Yd31*complexconjugate(Yu21) + Yd32*complexconjugate(Yu22) + Yd33*complexconjugate(Yu23)))*complexconjugate(ZU65) + (ZD64*(Yd11*complexconjugate(Yu31) + Yd12*complexconjugate(Yu32) + Yd13*complexconjugate(Yu33)) + ZD65*(Yd21*complexconjugate(Yu31) + Yd22*complexconjugate(Yu32) + Yd23*complexconjugate(Yu33)) + ZD66*(Yd31*complexconjugate(Yu31) + Yd32*complexconjugate(Yu32) + Yd33*complexconjugate(Yu33)))*complexconjugate(ZU66)) + 2*ZP22*(ZD61*(complexconjugate(Tu11)*complexconjugate(ZU64) + complexconjugate(Tu21)*complexconjugate(ZU65) + complexconjugate(Tu31)*complexconjugate(ZU66)) + ZD62*(complexconjugate(Tu12)*complexconjugate(ZU64) + complexconjugate(Tu22)*complexconjugate(ZU65) + complexconjugate(Tu32)*complexconjugate(ZU66)) + ZD63*(complexconjugate(Tu13)*complexconjugate(ZU64) + complexconjugate(Tu23)*complexconjugate(ZU65) + complexconjugate(Tu33)*complexconjugate(ZU66))) + 2*ZP21*complexconjugate(Mu)*(ZD61*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZD62*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZD63*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66)))))', 
	 order = {'QED':1} ) 
 
GC_533 = Coupling(name = 'GC_533',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE11*complexconjugate(ZV11) + ZE12*complexconjugate(ZV12) + ZE13*complexconjugate(ZV13)) - 2*(2*ZP11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZV11) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZV12) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZV13)) + 2*Mu*ZP12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZV11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZV12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_534 = Coupling(name = 'GC_534',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE21*complexconjugate(ZV11) + ZE22*complexconjugate(ZV12) + ZE23*complexconjugate(ZV13)) - 2*(2*ZP11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZV11) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZV12) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZV13)) + 2*Mu*ZP12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZV11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZV12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_535 = Coupling(name = 'GC_535',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE31*complexconjugate(ZV11) + ZE32*complexconjugate(ZV12) + ZE33*complexconjugate(ZV13)) - 2*(2*ZP11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZV11) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZV12) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZV13)) + 2*Mu*ZP12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZV11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZV12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_536 = Coupling(name = 'GC_536',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE41*complexconjugate(ZV11) + ZE42*complexconjugate(ZV12) + ZE43*complexconjugate(ZV13)) - 2*(2*ZP11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZV11) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZV12) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZV13)) + 2*Mu*ZP12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZV11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZV12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_537 = Coupling(name = 'GC_537',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE51*complexconjugate(ZV11) + ZE52*complexconjugate(ZV12) + ZE53*complexconjugate(ZV13)) - 2*(2*ZP11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZV11) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZV12) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZV13)) + 2*Mu*ZP12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZV11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZV12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_538 = Coupling(name = 'GC_538',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE61*complexconjugate(ZV11) + ZE62*complexconjugate(ZV12) + ZE63*complexconjugate(ZV13)) - 2*(2*ZP11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZV11) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZV12) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZV13)) + 2*Mu*ZP12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZV11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZV12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_539 = Coupling(name = 'GC_539',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE11*complexconjugate(ZV21) + ZE12*complexconjugate(ZV22) + ZE13*complexconjugate(ZV23)) - 2*(2*ZP11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZV21) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZV22) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZV23)) + 2*Mu*ZP12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZV21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZV22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_540 = Coupling(name = 'GC_540',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE21*complexconjugate(ZV21) + ZE22*complexconjugate(ZV22) + ZE23*complexconjugate(ZV23)) - 2*(2*ZP11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZV21) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZV22) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZV23)) + 2*Mu*ZP12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZV21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZV22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_541 = Coupling(name = 'GC_541',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE31*complexconjugate(ZV21) + ZE32*complexconjugate(ZV22) + ZE33*complexconjugate(ZV23)) - 2*(2*ZP11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZV21) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZV22) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZV23)) + 2*Mu*ZP12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZV21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZV22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_542 = Coupling(name = 'GC_542',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE41*complexconjugate(ZV21) + ZE42*complexconjugate(ZV22) + ZE43*complexconjugate(ZV23)) - 2*(2*ZP11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZV21) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZV22) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZV23)) + 2*Mu*ZP12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZV21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZV22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_543 = Coupling(name = 'GC_543',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE51*complexconjugate(ZV21) + ZE52*complexconjugate(ZV22) + ZE53*complexconjugate(ZV23)) - 2*(2*ZP11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZV21) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZV22) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZV23)) + 2*Mu*ZP12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZV21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZV22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_544 = Coupling(name = 'GC_544',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE61*complexconjugate(ZV21) + ZE62*complexconjugate(ZV22) + ZE63*complexconjugate(ZV23)) - 2*(2*ZP11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZV21) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZV22) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZV23)) + 2*Mu*ZP12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZV21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZV22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_545 = Coupling(name = 'GC_545',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE11*complexconjugate(ZV31) + ZE12*complexconjugate(ZV32) + ZE13*complexconjugate(ZV33)) - 2*(2*ZP11*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZV31) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZV32) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZV33)) + 2*Mu*ZP12*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZV31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZV32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP11*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_546 = Coupling(name = 'GC_546',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE21*complexconjugate(ZV31) + ZE22*complexconjugate(ZV32) + ZE23*complexconjugate(ZV33)) - 2*(2*ZP11*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZV31) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZV32) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZV33)) + 2*Mu*ZP12*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZV31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZV32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP11*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_547 = Coupling(name = 'GC_547',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE31*complexconjugate(ZV31) + ZE32*complexconjugate(ZV32) + ZE33*complexconjugate(ZV33)) - 2*(2*ZP11*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZV31) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZV32) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZV33)) + 2*Mu*ZP12*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZV31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZV32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP11*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_548 = Coupling(name = 'GC_548',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE41*complexconjugate(ZV31) + ZE42*complexconjugate(ZV32) + ZE43*complexconjugate(ZV33)) - 2*(2*ZP11*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZV31) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZV32) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZV33)) + 2*Mu*ZP12*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZV31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZV32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP11*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_549 = Coupling(name = 'GC_549',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE51*complexconjugate(ZV31) + ZE52*complexconjugate(ZV32) + ZE53*complexconjugate(ZV33)) - 2*(2*ZP11*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZV31) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZV32) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZV33)) + 2*Mu*ZP12*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZV31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZV32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP11*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_550 = Coupling(name = 'GC_550',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZE61*complexconjugate(ZV31) + ZE62*complexconjugate(ZV32) + ZE63*complexconjugate(ZV33)) - 2*(2*ZP11*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZV31) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZV32) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZV33)) + 2*Mu*ZP12*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZV31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZV32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP11*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_551 = Coupling(name = 'GC_551',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE11*complexconjugate(ZV11) + ZE12*complexconjugate(ZV12) + ZE13*complexconjugate(ZV13)) - 2*(2*ZP21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZV11) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZV12) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZV13)) + 2*Mu*ZP22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZV11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZV12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_552 = Coupling(name = 'GC_552',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE21*complexconjugate(ZV11) + ZE22*complexconjugate(ZV12) + ZE23*complexconjugate(ZV13)) - 2*(2*ZP21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZV11) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZV12) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZV13)) + 2*Mu*ZP22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZV11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZV12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_553 = Coupling(name = 'GC_553',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE31*complexconjugate(ZV11) + ZE32*complexconjugate(ZV12) + ZE33*complexconjugate(ZV13)) - 2*(2*ZP21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZV11) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZV12) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZV13)) + 2*Mu*ZP22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZV11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZV12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_554 = Coupling(name = 'GC_554',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE41*complexconjugate(ZV11) + ZE42*complexconjugate(ZV12) + ZE43*complexconjugate(ZV13)) - 2*(2*ZP21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZV11) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZV12) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZV13)) + 2*Mu*ZP22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZV11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZV12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_555 = Coupling(name = 'GC_555',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE51*complexconjugate(ZV11) + ZE52*complexconjugate(ZV12) + ZE53*complexconjugate(ZV13)) - 2*(2*ZP21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZV11) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZV12) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZV13)) + 2*Mu*ZP22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZV11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZV12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_556 = Coupling(name = 'GC_556',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE61*complexconjugate(ZV11) + ZE62*complexconjugate(ZV12) + ZE63*complexconjugate(ZV13)) - 2*(2*ZP21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZV11) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZV12) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZV13)) + 2*Mu*ZP22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZV11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZV12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZV13)) + cmath.sqrt(2)*vd*ZP21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV13)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV13)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV13)))))', 
	 order = {'QED':1} ) 
 
GC_557 = Coupling(name = 'GC_557',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE11*complexconjugate(ZV21) + ZE12*complexconjugate(ZV22) + ZE13*complexconjugate(ZV23)) - 2*(2*ZP21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZV21) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZV22) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZV23)) + 2*Mu*ZP22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZV21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZV22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_558 = Coupling(name = 'GC_558',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE21*complexconjugate(ZV21) + ZE22*complexconjugate(ZV22) + ZE23*complexconjugate(ZV23)) - 2*(2*ZP21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZV21) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZV22) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZV23)) + 2*Mu*ZP22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZV21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZV22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_559 = Coupling(name = 'GC_559',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE31*complexconjugate(ZV21) + ZE32*complexconjugate(ZV22) + ZE33*complexconjugate(ZV23)) - 2*(2*ZP21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZV21) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZV22) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZV23)) + 2*Mu*ZP22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZV21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZV22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_560 = Coupling(name = 'GC_560',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE41*complexconjugate(ZV21) + ZE42*complexconjugate(ZV22) + ZE43*complexconjugate(ZV23)) - 2*(2*ZP21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZV21) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZV22) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZV23)) + 2*Mu*ZP22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZV21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZV22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_561 = Coupling(name = 'GC_561',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE51*complexconjugate(ZV21) + ZE52*complexconjugate(ZV22) + ZE53*complexconjugate(ZV23)) - 2*(2*ZP21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZV21) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZV22) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZV23)) + 2*Mu*ZP22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZV21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZV22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_562 = Coupling(name = 'GC_562',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE61*complexconjugate(ZV21) + ZE62*complexconjugate(ZV22) + ZE63*complexconjugate(ZV23)) - 2*(2*ZP21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZV21) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZV22) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZV23)) + 2*Mu*ZP22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZV21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZV22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZV23)) + cmath.sqrt(2)*vd*ZP21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV23)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV23)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV23)))))', 
	 order = {'QED':1} ) 
 
GC_563 = Coupling(name = 'GC_563',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE11*complexconjugate(ZV31) + ZE12*complexconjugate(ZV32) + ZE13*complexconjugate(ZV33)) - 2*(2*ZP21*((Te11*ZE14 + Te21*ZE15 + Te31*ZE16)*complexconjugate(ZV31) + (Te12*ZE14 + Te22*ZE15 + Te32*ZE16)*complexconjugate(ZV32) + (Te13*ZE14 + Te23*ZE15 + Te33*ZE16)*complexconjugate(ZV33)) + 2*Mu*ZP22*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZV31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZV32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP21*(ZE11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_564 = Coupling(name = 'GC_564',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE21*complexconjugate(ZV31) + ZE22*complexconjugate(ZV32) + ZE23*complexconjugate(ZV33)) - 2*(2*ZP21*((Te11*ZE24 + Te21*ZE25 + Te31*ZE26)*complexconjugate(ZV31) + (Te12*ZE24 + Te22*ZE25 + Te32*ZE26)*complexconjugate(ZV32) + (Te13*ZE24 + Te23*ZE25 + Te33*ZE26)*complexconjugate(ZV33)) + 2*Mu*ZP22*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZV31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZV32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP21*(ZE21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_565 = Coupling(name = 'GC_565',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE31*complexconjugate(ZV31) + ZE32*complexconjugate(ZV32) + ZE33*complexconjugate(ZV33)) - 2*(2*ZP21*((Te11*ZE34 + Te21*ZE35 + Te31*ZE36)*complexconjugate(ZV31) + (Te12*ZE34 + Te22*ZE35 + Te32*ZE36)*complexconjugate(ZV32) + (Te13*ZE34 + Te23*ZE35 + Te33*ZE36)*complexconjugate(ZV33)) + 2*Mu*ZP22*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZV31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZV32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP21*(ZE31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_566 = Coupling(name = 'GC_566',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE41*complexconjugate(ZV31) + ZE42*complexconjugate(ZV32) + ZE43*complexconjugate(ZV33)) - 2*(2*ZP21*((Te11*ZE44 + Te21*ZE45 + Te31*ZE46)*complexconjugate(ZV31) + (Te12*ZE44 + Te22*ZE45 + Te32*ZE46)*complexconjugate(ZV32) + (Te13*ZE44 + Te23*ZE45 + Te33*ZE46)*complexconjugate(ZV33)) + 2*Mu*ZP22*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZV31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZV32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP21*(ZE41*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE42*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE43*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_567 = Coupling(name = 'GC_567',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE51*complexconjugate(ZV31) + ZE52*complexconjugate(ZV32) + ZE53*complexconjugate(ZV33)) - 2*(2*ZP21*((Te11*ZE54 + Te21*ZE55 + Te31*ZE56)*complexconjugate(ZV31) + (Te12*ZE54 + Te22*ZE55 + Te32*ZE56)*complexconjugate(ZV32) + (Te13*ZE54 + Te23*ZE55 + Te33*ZE56)*complexconjugate(ZV33)) + 2*Mu*ZP22*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZV31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZV32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP21*(ZE51*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE52*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE53*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_568 = Coupling(name = 'GC_568',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZE61*complexconjugate(ZV31) + ZE62*complexconjugate(ZV32) + ZE63*complexconjugate(ZV33)) - 2*(2*ZP21*((Te11*ZE64 + Te21*ZE65 + Te31*ZE66)*complexconjugate(ZV31) + (Te12*ZE64 + Te22*ZE65 + Te32*ZE66)*complexconjugate(ZV32) + (Te13*ZE64 + Te23*ZE65 + Te33*ZE66)*complexconjugate(ZV33)) + 2*Mu*ZP22*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZV31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZV32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZV33)) + cmath.sqrt(2)*vd*ZP21*(ZE61*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZV33)) + ZE62*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZV33)) + ZE63*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZV31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZV32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZV33)))))', 
	 order = {'QED':1} ) 
 
GC_569 = Coupling(name = 'GC_569',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU11*complexconjugate(ZD11) + ZU12*complexconjugate(ZD12) + ZU13*complexconjugate(ZD13)) - 2*(2*ZP12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD11) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD12) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD13)) + 2*Mu*ZP11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP11*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP11*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP12*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP11*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP12*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_570 = Coupling(name = 'GC_570',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU21*complexconjugate(ZD11) + ZU22*complexconjugate(ZD12) + ZU23*complexconjugate(ZD13)) - 2*(2*ZP12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD11) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD12) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD13)) + 2*Mu*ZP11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP11*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP11*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP12*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP11*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP12*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_571 = Coupling(name = 'GC_571',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU31*complexconjugate(ZD11) + ZU32*complexconjugate(ZD12) + ZU33*complexconjugate(ZD13)) - 2*(2*ZP12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD11) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD12) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD13)) + 2*Mu*ZP11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP11*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP11*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP12*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP11*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP12*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_572 = Coupling(name = 'GC_572',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU41*complexconjugate(ZD11) + ZU42*complexconjugate(ZD12) + ZU43*complexconjugate(ZD13)) - 2*(2*ZP12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD11) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD12) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD13)) + 2*Mu*ZP11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP11*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP11*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP12*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP11*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP12*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_573 = Coupling(name = 'GC_573',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU51*complexconjugate(ZD11) + ZU52*complexconjugate(ZD12) + ZU53*complexconjugate(ZD13)) - 2*(2*ZP12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD11) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD12) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD13)) + 2*Mu*ZP11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP11*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP11*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP12*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP11*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP12*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_574 = Coupling(name = 'GC_574',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU61*complexconjugate(ZD11) + ZU62*complexconjugate(ZD12) + ZU63*complexconjugate(ZD13)) - 2*(2*ZP12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD11) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD12) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD13)) + 2*Mu*ZP11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP11*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP11*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP12*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP11*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP12*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_575 = Coupling(name = 'GC_575',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU11*complexconjugate(ZD11) + ZU12*complexconjugate(ZD12) + ZU13*complexconjugate(ZD13)) - 2*(2*ZP22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD11) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD12) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD13)) + 2*Mu*ZP21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP21*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP21*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP22*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP21*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP22*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_576 = Coupling(name = 'GC_576',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU21*complexconjugate(ZD11) + ZU22*complexconjugate(ZD12) + ZU23*complexconjugate(ZD13)) - 2*(2*ZP22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD11) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD12) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD13)) + 2*Mu*ZP21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP21*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP21*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP22*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP21*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP22*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_577 = Coupling(name = 'GC_577',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU31*complexconjugate(ZD11) + ZU32*complexconjugate(ZD12) + ZU33*complexconjugate(ZD13)) - 2*(2*ZP22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD11) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD12) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD13)) + 2*Mu*ZP21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP21*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP21*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP22*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP21*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP22*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_578 = Coupling(name = 'GC_578',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU41*complexconjugate(ZD11) + ZU42*complexconjugate(ZD12) + ZU43*complexconjugate(ZD13)) - 2*(2*ZP22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD11) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD12) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD13)) + 2*Mu*ZP21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP21*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP21*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP22*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP21*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP22*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_579 = Coupling(name = 'GC_579',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU51*complexconjugate(ZD11) + ZU52*complexconjugate(ZD12) + ZU53*complexconjugate(ZD13)) - 2*(2*ZP22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD11) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD12) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD13)) + 2*Mu*ZP21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP21*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP21*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP22*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP21*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP22*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_580 = Coupling(name = 'GC_580',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU61*complexconjugate(ZD11) + ZU62*complexconjugate(ZD12) + ZU63*complexconjugate(ZD13)) - 2*(2*ZP22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD11) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD12) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD13)) + 2*Mu*ZP21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD13)) + cmath.sqrt(2)*vd*ZP21*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD13)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD13)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD11) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD12) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD13)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD13)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD11) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD12) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD13))) + cmath.sqrt(2)*vu*ZP21*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + cmath.sqrt(2)*vd*ZP22*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD14) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD15) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD16)) + 2*ZP21*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD14) + complexconjugate(Td21)*complexconjugate(ZD15) + complexconjugate(Td31)*complexconjugate(ZD16)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD14) + complexconjugate(Td22)*complexconjugate(ZD15) + complexconjugate(Td32)*complexconjugate(ZD16)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD14) + complexconjugate(Td23)*complexconjugate(ZD15) + complexconjugate(Td33)*complexconjugate(ZD16))) + 2*ZP22*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))))', 
	 order = {'QED':1} ) 
 
GC_581 = Coupling(name = 'GC_581',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU11*complexconjugate(ZD21) + ZU12*complexconjugate(ZD22) + ZU13*complexconjugate(ZD23)) - 2*(2*ZP12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD21) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD22) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD23)) + 2*Mu*ZP11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP11*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP11*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP12*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP11*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP12*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_582 = Coupling(name = 'GC_582',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU21*complexconjugate(ZD21) + ZU22*complexconjugate(ZD22) + ZU23*complexconjugate(ZD23)) - 2*(2*ZP12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD21) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD22) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD23)) + 2*Mu*ZP11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP11*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP11*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP12*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP11*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP12*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_583 = Coupling(name = 'GC_583',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU31*complexconjugate(ZD21) + ZU32*complexconjugate(ZD22) + ZU33*complexconjugate(ZD23)) - 2*(2*ZP12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD21) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD22) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD23)) + 2*Mu*ZP11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP11*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP11*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP12*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP11*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP12*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_584 = Coupling(name = 'GC_584',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU41*complexconjugate(ZD21) + ZU42*complexconjugate(ZD22) + ZU43*complexconjugate(ZD23)) - 2*(2*ZP12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD21) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD22) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD23)) + 2*Mu*ZP11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP11*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP11*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP12*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP11*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP12*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_585 = Coupling(name = 'GC_585',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU51*complexconjugate(ZD21) + ZU52*complexconjugate(ZD22) + ZU53*complexconjugate(ZD23)) - 2*(2*ZP12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD21) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD22) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD23)) + 2*Mu*ZP11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP11*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP11*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP12*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP11*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP12*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_586 = Coupling(name = 'GC_586',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU61*complexconjugate(ZD21) + ZU62*complexconjugate(ZD22) + ZU63*complexconjugate(ZD23)) - 2*(2*ZP12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD21) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD22) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD23)) + 2*Mu*ZP11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP11*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP11*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP12*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP11*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP12*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_587 = Coupling(name = 'GC_587',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU11*complexconjugate(ZD21) + ZU12*complexconjugate(ZD22) + ZU13*complexconjugate(ZD23)) - 2*(2*ZP22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD21) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD22) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD23)) + 2*Mu*ZP21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP21*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP21*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP22*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP21*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP22*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_588 = Coupling(name = 'GC_588',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU21*complexconjugate(ZD21) + ZU22*complexconjugate(ZD22) + ZU23*complexconjugate(ZD23)) - 2*(2*ZP22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD21) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD22) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD23)) + 2*Mu*ZP21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP21*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP21*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP22*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP21*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP22*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_589 = Coupling(name = 'GC_589',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU31*complexconjugate(ZD21) + ZU32*complexconjugate(ZD22) + ZU33*complexconjugate(ZD23)) - 2*(2*ZP22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD21) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD22) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD23)) + 2*Mu*ZP21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP21*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP21*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP22*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP21*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP22*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_590 = Coupling(name = 'GC_590',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU41*complexconjugate(ZD21) + ZU42*complexconjugate(ZD22) + ZU43*complexconjugate(ZD23)) - 2*(2*ZP22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD21) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD22) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD23)) + 2*Mu*ZP21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP21*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP21*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP22*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP21*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP22*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_591 = Coupling(name = 'GC_591',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU51*complexconjugate(ZD21) + ZU52*complexconjugate(ZD22) + ZU53*complexconjugate(ZD23)) - 2*(2*ZP22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD21) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD22) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD23)) + 2*Mu*ZP21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP21*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP21*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP22*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP21*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP22*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_592 = Coupling(name = 'GC_592',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU61*complexconjugate(ZD21) + ZU62*complexconjugate(ZD22) + ZU63*complexconjugate(ZD23)) - 2*(2*ZP22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD21) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD22) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD23)) + 2*Mu*ZP21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD23)) + cmath.sqrt(2)*vd*ZP21*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD23)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD23)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD21) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD22) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD23)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD23)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD21) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD22) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD23))) + cmath.sqrt(2)*vu*ZP21*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + cmath.sqrt(2)*vd*ZP22*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD24) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD25) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD26)) + 2*ZP21*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD24) + complexconjugate(Td21)*complexconjugate(ZD25) + complexconjugate(Td31)*complexconjugate(ZD26)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD24) + complexconjugate(Td22)*complexconjugate(ZD25) + complexconjugate(Td32)*complexconjugate(ZD26)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD24) + complexconjugate(Td23)*complexconjugate(ZD25) + complexconjugate(Td33)*complexconjugate(ZD26))) + 2*ZP22*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))))', 
	 order = {'QED':1} ) 
 
GC_593 = Coupling(name = 'GC_593',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU11*complexconjugate(ZD31) + ZU12*complexconjugate(ZD32) + ZU13*complexconjugate(ZD33)) - 2*(2*ZP12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD31) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD32) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD33)) + 2*Mu*ZP11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP11*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP11*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP12*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP11*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP12*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_594 = Coupling(name = 'GC_594',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU21*complexconjugate(ZD31) + ZU22*complexconjugate(ZD32) + ZU23*complexconjugate(ZD33)) - 2*(2*ZP12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD31) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD32) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD33)) + 2*Mu*ZP11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP11*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP11*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP12*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP11*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP12*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_595 = Coupling(name = 'GC_595',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU31*complexconjugate(ZD31) + ZU32*complexconjugate(ZD32) + ZU33*complexconjugate(ZD33)) - 2*(2*ZP12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD31) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD32) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD33)) + 2*Mu*ZP11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP11*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP11*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP12*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP11*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP12*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_596 = Coupling(name = 'GC_596',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU41*complexconjugate(ZD31) + ZU42*complexconjugate(ZD32) + ZU43*complexconjugate(ZD33)) - 2*(2*ZP12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD31) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD32) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD33)) + 2*Mu*ZP11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP11*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP11*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP12*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP11*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP12*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_597 = Coupling(name = 'GC_597',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU51*complexconjugate(ZD31) + ZU52*complexconjugate(ZD32) + ZU53*complexconjugate(ZD33)) - 2*(2*ZP12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD31) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD32) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD33)) + 2*Mu*ZP11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP11*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP11*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP12*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP11*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP12*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_598 = Coupling(name = 'GC_598',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU61*complexconjugate(ZD31) + ZU62*complexconjugate(ZD32) + ZU63*complexconjugate(ZD33)) - 2*(2*ZP12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD31) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD32) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD33)) + 2*Mu*ZP11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP11*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP11*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP12*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP11*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP12*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_599 = Coupling(name = 'GC_599',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU11*complexconjugate(ZD31) + ZU12*complexconjugate(ZD32) + ZU13*complexconjugate(ZD33)) - 2*(2*ZP22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD31) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD32) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD33)) + 2*Mu*ZP21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP21*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP21*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP22*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP21*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP22*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_600 = Coupling(name = 'GC_600',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU21*complexconjugate(ZD31) + ZU22*complexconjugate(ZD32) + ZU23*complexconjugate(ZD33)) - 2*(2*ZP22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD31) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD32) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD33)) + 2*Mu*ZP21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP21*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP21*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP22*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP21*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP22*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_601 = Coupling(name = 'GC_601',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU31*complexconjugate(ZD31) + ZU32*complexconjugate(ZD32) + ZU33*complexconjugate(ZD33)) - 2*(2*ZP22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD31) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD32) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD33)) + 2*Mu*ZP21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP21*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP21*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP22*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP21*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP22*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_602 = Coupling(name = 'GC_602',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU41*complexconjugate(ZD31) + ZU42*complexconjugate(ZD32) + ZU43*complexconjugate(ZD33)) - 2*(2*ZP22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD31) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD32) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD33)) + 2*Mu*ZP21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP21*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP21*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP22*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP21*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP22*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_603 = Coupling(name = 'GC_603',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU51*complexconjugate(ZD31) + ZU52*complexconjugate(ZD32) + ZU53*complexconjugate(ZD33)) - 2*(2*ZP22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD31) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD32) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD33)) + 2*Mu*ZP21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP21*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP21*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP22*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP21*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP22*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_604 = Coupling(name = 'GC_604',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU61*complexconjugate(ZD31) + ZU62*complexconjugate(ZD32) + ZU63*complexconjugate(ZD33)) - 2*(2*ZP22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD31) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD32) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD33)) + 2*Mu*ZP21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD33)) + cmath.sqrt(2)*vd*ZP21*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD33)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD33)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD31) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD32) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD33)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD33)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD31) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD32) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD33))) + cmath.sqrt(2)*vu*ZP21*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + cmath.sqrt(2)*vd*ZP22*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD34) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD35) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD36)) + 2*ZP21*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD34) + complexconjugate(Td21)*complexconjugate(ZD35) + complexconjugate(Td31)*complexconjugate(ZD36)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD34) + complexconjugate(Td22)*complexconjugate(ZD35) + complexconjugate(Td32)*complexconjugate(ZD36)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD34) + complexconjugate(Td23)*complexconjugate(ZD35) + complexconjugate(Td33)*complexconjugate(ZD36))) + 2*ZP22*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))))', 
	 order = {'QED':1} ) 
 
GC_605 = Coupling(name = 'GC_605',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU11*complexconjugate(ZD41) + ZU12*complexconjugate(ZD42) + ZU13*complexconjugate(ZD43)) - 2*(2*ZP12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD41) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD42) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD43)) + 2*Mu*ZP11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD41) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD42) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP11*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP11*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP12*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP11*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP12*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_606 = Coupling(name = 'GC_606',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU21*complexconjugate(ZD41) + ZU22*complexconjugate(ZD42) + ZU23*complexconjugate(ZD43)) - 2*(2*ZP12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD41) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD42) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD43)) + 2*Mu*ZP11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD41) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD42) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP11*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP11*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP12*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP11*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP12*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_607 = Coupling(name = 'GC_607',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU31*complexconjugate(ZD41) + ZU32*complexconjugate(ZD42) + ZU33*complexconjugate(ZD43)) - 2*(2*ZP12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD41) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD42) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD43)) + 2*Mu*ZP11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD41) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD42) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP11*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP11*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP12*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP11*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP12*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_608 = Coupling(name = 'GC_608',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU41*complexconjugate(ZD41) + ZU42*complexconjugate(ZD42) + ZU43*complexconjugate(ZD43)) - 2*(2*ZP12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD41) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD42) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD43)) + 2*Mu*ZP11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD41) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD42) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP11*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP11*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP12*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP11*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP12*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_609 = Coupling(name = 'GC_609',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU51*complexconjugate(ZD41) + ZU52*complexconjugate(ZD42) + ZU53*complexconjugate(ZD43)) - 2*(2*ZP12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD41) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD42) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD43)) + 2*Mu*ZP11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD41) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD42) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP11*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP11*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP12*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP11*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP12*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_610 = Coupling(name = 'GC_610',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU61*complexconjugate(ZD41) + ZU62*complexconjugate(ZD42) + ZU63*complexconjugate(ZD43)) - 2*(2*ZP12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD41) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD42) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD43)) + 2*Mu*ZP11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD41) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD42) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP11*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP11*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP12*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP11*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP12*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_611 = Coupling(name = 'GC_611',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU11*complexconjugate(ZD41) + ZU12*complexconjugate(ZD42) + ZU13*complexconjugate(ZD43)) - 2*(2*ZP22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD41) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD42) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD43)) + 2*Mu*ZP21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD41) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD42) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP21*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP21*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP22*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP21*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP22*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_612 = Coupling(name = 'GC_612',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU21*complexconjugate(ZD41) + ZU22*complexconjugate(ZD42) + ZU23*complexconjugate(ZD43)) - 2*(2*ZP22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD41) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD42) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD43)) + 2*Mu*ZP21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD41) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD42) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP21*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP21*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP22*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP21*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP22*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_613 = Coupling(name = 'GC_613',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU31*complexconjugate(ZD41) + ZU32*complexconjugate(ZD42) + ZU33*complexconjugate(ZD43)) - 2*(2*ZP22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD41) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD42) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD43)) + 2*Mu*ZP21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD41) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD42) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP21*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP21*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP22*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP21*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP22*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_614 = Coupling(name = 'GC_614',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU41*complexconjugate(ZD41) + ZU42*complexconjugate(ZD42) + ZU43*complexconjugate(ZD43)) - 2*(2*ZP22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD41) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD42) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD43)) + 2*Mu*ZP21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD41) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD42) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP21*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP21*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP22*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP21*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP22*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_615 = Coupling(name = 'GC_615',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU51*complexconjugate(ZD41) + ZU52*complexconjugate(ZD42) + ZU53*complexconjugate(ZD43)) - 2*(2*ZP22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD41) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD42) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD43)) + 2*Mu*ZP21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD41) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD42) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP21*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP21*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP22*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP21*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP22*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_616 = Coupling(name = 'GC_616',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU61*complexconjugate(ZD41) + ZU62*complexconjugate(ZD42) + ZU63*complexconjugate(ZD43)) - 2*(2*ZP22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD41) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD42) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD43)) + 2*Mu*ZP21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD41) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD42) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD43)) + cmath.sqrt(2)*vd*ZP21*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD43)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD43)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD41) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD42) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD43)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD43)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD41) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD42) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD43))) + cmath.sqrt(2)*vu*ZP21*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + cmath.sqrt(2)*vd*ZP22*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD44) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD45) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD46)) + 2*ZP21*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD44) + complexconjugate(Td21)*complexconjugate(ZD45) + complexconjugate(Td31)*complexconjugate(ZD46)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD44) + complexconjugate(Td22)*complexconjugate(ZD45) + complexconjugate(Td32)*complexconjugate(ZD46)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD44) + complexconjugate(Td23)*complexconjugate(ZD45) + complexconjugate(Td33)*complexconjugate(ZD46))) + 2*ZP22*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))))', 
	 order = {'QED':1} ) 
 
GC_617 = Coupling(name = 'GC_617',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU11*complexconjugate(ZD51) + ZU12*complexconjugate(ZD52) + ZU13*complexconjugate(ZD53)) - 2*(2*ZP12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD51) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD52) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD53)) + 2*Mu*ZP11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD51) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD52) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP11*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP11*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP12*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP11*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP12*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_618 = Coupling(name = 'GC_618',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU21*complexconjugate(ZD51) + ZU22*complexconjugate(ZD52) + ZU23*complexconjugate(ZD53)) - 2*(2*ZP12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD51) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD52) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD53)) + 2*Mu*ZP11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD51) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD52) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP11*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP11*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP12*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP11*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP12*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_619 = Coupling(name = 'GC_619',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU31*complexconjugate(ZD51) + ZU32*complexconjugate(ZD52) + ZU33*complexconjugate(ZD53)) - 2*(2*ZP12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD51) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD52) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD53)) + 2*Mu*ZP11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD51) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD52) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP11*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP11*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP12*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP11*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP12*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_620 = Coupling(name = 'GC_620',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU41*complexconjugate(ZD51) + ZU42*complexconjugate(ZD52) + ZU43*complexconjugate(ZD53)) - 2*(2*ZP12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD51) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD52) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD53)) + 2*Mu*ZP11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD51) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD52) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP11*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP11*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP12*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP11*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP12*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_621 = Coupling(name = 'GC_621',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU51*complexconjugate(ZD51) + ZU52*complexconjugate(ZD52) + ZU53*complexconjugate(ZD53)) - 2*(2*ZP12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD51) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD52) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD53)) + 2*Mu*ZP11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD51) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD52) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP11*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP11*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP12*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP11*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP12*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_622 = Coupling(name = 'GC_622',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU61*complexconjugate(ZD51) + ZU62*complexconjugate(ZD52) + ZU63*complexconjugate(ZD53)) - 2*(2*ZP12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD51) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD52) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD53)) + 2*Mu*ZP11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD51) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD52) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP11*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP11*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP12*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP11*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP12*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_623 = Coupling(name = 'GC_623',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU11*complexconjugate(ZD51) + ZU12*complexconjugate(ZD52) + ZU13*complexconjugate(ZD53)) - 2*(2*ZP22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD51) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD52) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD53)) + 2*Mu*ZP21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD51) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD52) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP21*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP21*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP22*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP21*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP22*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_624 = Coupling(name = 'GC_624',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU21*complexconjugate(ZD51) + ZU22*complexconjugate(ZD52) + ZU23*complexconjugate(ZD53)) - 2*(2*ZP22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD51) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD52) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD53)) + 2*Mu*ZP21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD51) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD52) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP21*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP21*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP22*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP21*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP22*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_625 = Coupling(name = 'GC_625',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU31*complexconjugate(ZD51) + ZU32*complexconjugate(ZD52) + ZU33*complexconjugate(ZD53)) - 2*(2*ZP22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD51) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD52) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD53)) + 2*Mu*ZP21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD51) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD52) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP21*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP21*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP22*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP21*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP22*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_626 = Coupling(name = 'GC_626',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU41*complexconjugate(ZD51) + ZU42*complexconjugate(ZD52) + ZU43*complexconjugate(ZD53)) - 2*(2*ZP22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD51) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD52) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD53)) + 2*Mu*ZP21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD51) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD52) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP21*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP21*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP22*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP21*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP22*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_627 = Coupling(name = 'GC_627',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU51*complexconjugate(ZD51) + ZU52*complexconjugate(ZD52) + ZU53*complexconjugate(ZD53)) - 2*(2*ZP22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD51) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD52) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD53)) + 2*Mu*ZP21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD51) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD52) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP21*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP21*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP22*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP21*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP22*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_628 = Coupling(name = 'GC_628',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU61*complexconjugate(ZD51) + ZU62*complexconjugate(ZD52) + ZU63*complexconjugate(ZD53)) - 2*(2*ZP22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD51) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD52) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD53)) + 2*Mu*ZP21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD51) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD52) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD53)) + cmath.sqrt(2)*vd*ZP21*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD53)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD53)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD51) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD52) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD53)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD53)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD51) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD52) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD53))) + cmath.sqrt(2)*vu*ZP21*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + cmath.sqrt(2)*vd*ZP22*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD54) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD55) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD56)) + 2*ZP21*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD54) + complexconjugate(Td21)*complexconjugate(ZD55) + complexconjugate(Td31)*complexconjugate(ZD56)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD54) + complexconjugate(Td22)*complexconjugate(ZD55) + complexconjugate(Td32)*complexconjugate(ZD56)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD54) + complexconjugate(Td23)*complexconjugate(ZD55) + complexconjugate(Td33)*complexconjugate(ZD56))) + 2*ZP22*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))))', 
	 order = {'QED':1} ) 
 
GC_629 = Coupling(name = 'GC_629',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU11*complexconjugate(ZD61) + ZU12*complexconjugate(ZD62) + ZU13*complexconjugate(ZD63)) - 2*(2*ZP12*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD61) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD62) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD63)) + 2*Mu*ZP11*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD61) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD62) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP11*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP12*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP11*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP12*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP11*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP12*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_630 = Coupling(name = 'GC_630',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU21*complexconjugate(ZD61) + ZU22*complexconjugate(ZD62) + ZU23*complexconjugate(ZD63)) - 2*(2*ZP12*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD61) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD62) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD63)) + 2*Mu*ZP11*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD61) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD62) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP11*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP12*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP11*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP12*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP11*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP12*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_631 = Coupling(name = 'GC_631',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU31*complexconjugate(ZD61) + ZU32*complexconjugate(ZD62) + ZU33*complexconjugate(ZD63)) - 2*(2*ZP12*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD61) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD62) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD63)) + 2*Mu*ZP11*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD61) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD62) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP11*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP12*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP11*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP12*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP11*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP12*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_632 = Coupling(name = 'GC_632',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU41*complexconjugate(ZD61) + ZU42*complexconjugate(ZD62) + ZU43*complexconjugate(ZD63)) - 2*(2*ZP12*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD61) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD62) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD63)) + 2*Mu*ZP11*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD61) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD62) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP11*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP12*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP11*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP12*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP11*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP12*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_633 = Coupling(name = 'GC_633',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU51*complexconjugate(ZD61) + ZU52*complexconjugate(ZD62) + ZU53*complexconjugate(ZD63)) - 2*(2*ZP12*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD61) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD62) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD63)) + 2*Mu*ZP11*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD61) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD62) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP11*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP12*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP11*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP12*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP11*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP12*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_634 = Coupling(name = 'GC_634',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZU61*complexconjugate(ZD61) + ZU62*complexconjugate(ZD62) + ZU63*complexconjugate(ZD63)) - 2*(2*ZP12*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD61) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD62) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD63)) + 2*Mu*ZP11*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD61) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD62) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP11*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP12*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP11*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP12*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP11*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP12*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_635 = Coupling(name = 'GC_635',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU11*complexconjugate(ZD61) + ZU12*complexconjugate(ZD62) + ZU13*complexconjugate(ZD63)) - 2*(2*ZP22*((Tu11*ZU14 + Tu21*ZU15 + Tu31*ZU16)*complexconjugate(ZD61) + (Tu12*ZU14 + Tu22*ZU15 + Tu32*ZU16)*complexconjugate(ZD62) + (Tu13*ZU14 + Tu23*ZU15 + Tu33*ZU16)*complexconjugate(ZD63)) + 2*Mu*ZP21*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZD61) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZD62) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP21*(ZU11*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU12*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU13*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP22*(ZU11*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU12*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU13*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP21*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP22*((ZU14*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU15*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU16*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU14*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU15*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU16*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU14*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU15*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU16*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP21*(ZU11*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU12*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU13*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP22*complexconjugate(Mu)*(ZU11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_636 = Coupling(name = 'GC_636',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU21*complexconjugate(ZD61) + ZU22*complexconjugate(ZD62) + ZU23*complexconjugate(ZD63)) - 2*(2*ZP22*((Tu11*ZU24 + Tu21*ZU25 + Tu31*ZU26)*complexconjugate(ZD61) + (Tu12*ZU24 + Tu22*ZU25 + Tu32*ZU26)*complexconjugate(ZD62) + (Tu13*ZU24 + Tu23*ZU25 + Tu33*ZU26)*complexconjugate(ZD63)) + 2*Mu*ZP21*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZD61) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZD62) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP21*(ZU21*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU22*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU23*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP22*(ZU21*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU22*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU23*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP21*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP22*((ZU24*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU25*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU26*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU24*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU25*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU26*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU24*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU25*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU26*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP21*(ZU21*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU22*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU23*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP22*complexconjugate(Mu)*(ZU21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_637 = Coupling(name = 'GC_637',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU31*complexconjugate(ZD61) + ZU32*complexconjugate(ZD62) + ZU33*complexconjugate(ZD63)) - 2*(2*ZP22*((Tu11*ZU34 + Tu21*ZU35 + Tu31*ZU36)*complexconjugate(ZD61) + (Tu12*ZU34 + Tu22*ZU35 + Tu32*ZU36)*complexconjugate(ZD62) + (Tu13*ZU34 + Tu23*ZU35 + Tu33*ZU36)*complexconjugate(ZD63)) + 2*Mu*ZP21*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZD61) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZD62) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP21*(ZU31*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU32*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU33*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP22*(ZU31*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU32*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU33*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP21*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP22*((ZU34*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU35*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU36*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU34*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU35*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU36*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU34*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU35*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU36*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP21*(ZU31*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU32*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU33*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP22*complexconjugate(Mu)*(ZU31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_638 = Coupling(name = 'GC_638',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU41*complexconjugate(ZD61) + ZU42*complexconjugate(ZD62) + ZU43*complexconjugate(ZD63)) - 2*(2*ZP22*((Tu11*ZU44 + Tu21*ZU45 + Tu31*ZU46)*complexconjugate(ZD61) + (Tu12*ZU44 + Tu22*ZU45 + Tu32*ZU46)*complexconjugate(ZD62) + (Tu13*ZU44 + Tu23*ZU45 + Tu33*ZU46)*complexconjugate(ZD63)) + 2*Mu*ZP21*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZD61) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZD62) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP21*(ZU41*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU42*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU43*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP22*(ZU41*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU42*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU43*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP21*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP22*((ZU44*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU45*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU46*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU44*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU45*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU46*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU44*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU45*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU46*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP21*(ZU41*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU42*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU43*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP22*complexconjugate(Mu)*(ZU41*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU42*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU43*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_639 = Coupling(name = 'GC_639',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU51*complexconjugate(ZD61) + ZU52*complexconjugate(ZD62) + ZU53*complexconjugate(ZD63)) - 2*(2*ZP22*((Tu11*ZU54 + Tu21*ZU55 + Tu31*ZU56)*complexconjugate(ZD61) + (Tu12*ZU54 + Tu22*ZU55 + Tu32*ZU56)*complexconjugate(ZD62) + (Tu13*ZU54 + Tu23*ZU55 + Tu33*ZU56)*complexconjugate(ZD63)) + 2*Mu*ZP21*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZD61) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZD62) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP21*(ZU51*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU52*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU53*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP22*(ZU51*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU52*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU53*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP21*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP22*((ZU54*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU55*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU56*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU54*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU55*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU56*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU54*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU55*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU56*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP21*(ZU51*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU52*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU53*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP22*complexconjugate(Mu)*(ZU51*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU52*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU53*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_640 = Coupling(name = 'GC_640',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZU61*complexconjugate(ZD61) + ZU62*complexconjugate(ZD62) + ZU63*complexconjugate(ZD63)) - 2*(2*ZP22*((Tu11*ZU64 + Tu21*ZU65 + Tu31*ZU66)*complexconjugate(ZD61) + (Tu12*ZU64 + Tu22*ZU65 + Tu32*ZU66)*complexconjugate(ZD62) + (Tu13*ZU64 + Tu23*ZU65 + Tu33*ZU66)*complexconjugate(ZD63)) + 2*Mu*ZP21*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZD61) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZD62) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZD63)) + cmath.sqrt(2)*vd*ZP21*(ZU61*((Yd11*complexconjugate(Yd11) + Yd21*complexconjugate(Yd21) + Yd31*complexconjugate(Yd31))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd11) + Yd22*complexconjugate(Yd21) + Yd32*complexconjugate(Yd31))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd11) + Yd23*complexconjugate(Yd21) + Yd33*complexconjugate(Yd31))*complexconjugate(ZD63)) + ZU62*((Yd11*complexconjugate(Yd12) + Yd21*complexconjugate(Yd22) + Yd31*complexconjugate(Yd32))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd12) + Yd22*complexconjugate(Yd22) + Yd32*complexconjugate(Yd32))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd12) + Yd23*complexconjugate(Yd22) + Yd33*complexconjugate(Yd32))*complexconjugate(ZD63)) + ZU63*((Yd11*complexconjugate(Yd13) + Yd21*complexconjugate(Yd23) + Yd31*complexconjugate(Yd33))*complexconjugate(ZD61) + (Yd12*complexconjugate(Yd13) + Yd22*complexconjugate(Yd23) + Yd32*complexconjugate(Yd33))*complexconjugate(ZD62) + (Yd13*complexconjugate(Yd13) + Yd23*complexconjugate(Yd23) + Yd33*complexconjugate(Yd33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP22*(ZU61*((Yu11*complexconjugate(Yu11) + Yu21*complexconjugate(Yu21) + Yu31*complexconjugate(Yu31))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu11) + Yu22*complexconjugate(Yu21) + Yu32*complexconjugate(Yu31))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu11) + Yu23*complexconjugate(Yu21) + Yu33*complexconjugate(Yu31))*complexconjugate(ZD63)) + ZU62*((Yu11*complexconjugate(Yu12) + Yu21*complexconjugate(Yu22) + Yu31*complexconjugate(Yu32))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu12) + Yu22*complexconjugate(Yu22) + Yu32*complexconjugate(Yu32))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu12) + Yu23*complexconjugate(Yu22) + Yu33*complexconjugate(Yu32))*complexconjugate(ZD63)) + ZU63*((Yu11*complexconjugate(Yu13) + Yu21*complexconjugate(Yu23) + Yu31*complexconjugate(Yu33))*complexconjugate(ZD61) + (Yu12*complexconjugate(Yu13) + Yu22*complexconjugate(Yu23) + Yu32*complexconjugate(Yu33))*complexconjugate(ZD62) + (Yu13*complexconjugate(Yu13) + Yu23*complexconjugate(Yu23) + Yu33*complexconjugate(Yu33))*complexconjugate(ZD63))) + cmath.sqrt(2)*vu*ZP21*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + cmath.sqrt(2)*vd*ZP22*((ZU64*(Yu11*complexconjugate(Yd11) + Yu12*complexconjugate(Yd12) + Yu13*complexconjugate(Yd13)) + ZU65*(Yu21*complexconjugate(Yd11) + Yu22*complexconjugate(Yd12) + Yu23*complexconjugate(Yd13)) + ZU66*(Yu31*complexconjugate(Yd11) + Yu32*complexconjugate(Yd12) + Yu33*complexconjugate(Yd13)))*complexconjugate(ZD64) + (ZU64*(Yu11*complexconjugate(Yd21) + Yu12*complexconjugate(Yd22) + Yu13*complexconjugate(Yd23)) + ZU65*(Yu21*complexconjugate(Yd21) + Yu22*complexconjugate(Yd22) + Yu23*complexconjugate(Yd23)) + ZU66*(Yu31*complexconjugate(Yd21) + Yu32*complexconjugate(Yd22) + Yu33*complexconjugate(Yd23)))*complexconjugate(ZD65) + (ZU64*(Yu11*complexconjugate(Yd31) + Yu12*complexconjugate(Yd32) + Yu13*complexconjugate(Yd33)) + ZU65*(Yu21*complexconjugate(Yd31) + Yu22*complexconjugate(Yd32) + Yu23*complexconjugate(Yd33)) + ZU66*(Yu31*complexconjugate(Yd31) + Yu32*complexconjugate(Yd32) + Yu33*complexconjugate(Yd33)))*complexconjugate(ZD66)) + 2*ZP21*(ZU61*(complexconjugate(Td11)*complexconjugate(ZD64) + complexconjugate(Td21)*complexconjugate(ZD65) + complexconjugate(Td31)*complexconjugate(ZD66)) + ZU62*(complexconjugate(Td12)*complexconjugate(ZD64) + complexconjugate(Td22)*complexconjugate(ZD65) + complexconjugate(Td32)*complexconjugate(ZD66)) + ZU63*(complexconjugate(Td13)*complexconjugate(ZD64) + complexconjugate(Td23)*complexconjugate(ZD65) + complexconjugate(Td33)*complexconjugate(ZD66))) + 2*ZP22*complexconjugate(Mu)*(ZU61*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZU62*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZU63*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))))', 
	 order = {'QED':1} ) 
 
GC_641 = Coupling(name = 'GC_641',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV11*complexconjugate(ZE11) + ZV12*complexconjugate(ZE12) + ZV13*complexconjugate(ZE13)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + 2*ZP11*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + 2*ZP12*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_642 = Coupling(name = 'GC_642',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV21*complexconjugate(ZE11) + ZV22*complexconjugate(ZE12) + ZV23*complexconjugate(ZE13)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + 2*ZP11*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + 2*ZP12*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_643 = Coupling(name = 'GC_643',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV31*complexconjugate(ZE11) + ZV32*complexconjugate(ZE12) + ZV33*complexconjugate(ZE13)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + 2*ZP11*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + 2*ZP12*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_644 = Coupling(name = 'GC_644',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV11*complexconjugate(ZE11) + ZV12*complexconjugate(ZE12) + ZV13*complexconjugate(ZE13)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + 2*ZP21*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + 2*ZP22*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_645 = Coupling(name = 'GC_645',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV21*complexconjugate(ZE11) + ZV22*complexconjugate(ZE12) + ZV23*complexconjugate(ZE13)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + 2*ZP21*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + 2*ZP22*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_646 = Coupling(name = 'GC_646',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV31*complexconjugate(ZE11) + ZV32*complexconjugate(ZE12) + ZV33*complexconjugate(ZE13)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE13)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE13)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE11) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE12) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE13))) + 2*ZP21*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE14) + complexconjugate(Te21)*complexconjugate(ZE15) + complexconjugate(Te31)*complexconjugate(ZE16)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE14) + complexconjugate(Te22)*complexconjugate(ZE15) + complexconjugate(Te32)*complexconjugate(ZE16)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE14) + complexconjugate(Te23)*complexconjugate(ZE15) + complexconjugate(Te33)*complexconjugate(ZE16))) + 2*ZP22*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))))', 
	 order = {'QED':1} ) 
 
GC_647 = Coupling(name = 'GC_647',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV11*complexconjugate(ZE21) + ZV12*complexconjugate(ZE22) + ZV13*complexconjugate(ZE23)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + 2*ZP11*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + 2*ZP12*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_648 = Coupling(name = 'GC_648',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV21*complexconjugate(ZE21) + ZV22*complexconjugate(ZE22) + ZV23*complexconjugate(ZE23)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + 2*ZP11*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + 2*ZP12*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_649 = Coupling(name = 'GC_649',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV31*complexconjugate(ZE21) + ZV32*complexconjugate(ZE22) + ZV33*complexconjugate(ZE23)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + 2*ZP11*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + 2*ZP12*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_650 = Coupling(name = 'GC_650',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV11*complexconjugate(ZE21) + ZV12*complexconjugate(ZE22) + ZV13*complexconjugate(ZE23)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + 2*ZP21*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + 2*ZP22*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_651 = Coupling(name = 'GC_651',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV21*complexconjugate(ZE21) + ZV22*complexconjugate(ZE22) + ZV23*complexconjugate(ZE23)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + 2*ZP21*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + 2*ZP22*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_652 = Coupling(name = 'GC_652',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV31*complexconjugate(ZE21) + ZV32*complexconjugate(ZE22) + ZV33*complexconjugate(ZE23)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE23)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE23)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE21) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE22) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE23))) + 2*ZP21*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE24) + complexconjugate(Te21)*complexconjugate(ZE25) + complexconjugate(Te31)*complexconjugate(ZE26)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE24) + complexconjugate(Te22)*complexconjugate(ZE25) + complexconjugate(Te32)*complexconjugate(ZE26)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE24) + complexconjugate(Te23)*complexconjugate(ZE25) + complexconjugate(Te33)*complexconjugate(ZE26))) + 2*ZP22*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))))', 
	 order = {'QED':1} ) 
 
GC_653 = Coupling(name = 'GC_653',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV11*complexconjugate(ZE31) + ZV12*complexconjugate(ZE32) + ZV13*complexconjugate(ZE33)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + 2*ZP11*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + 2*ZP12*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_654 = Coupling(name = 'GC_654',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV21*complexconjugate(ZE31) + ZV22*complexconjugate(ZE32) + ZV23*complexconjugate(ZE33)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + 2*ZP11*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + 2*ZP12*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_655 = Coupling(name = 'GC_655',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV31*complexconjugate(ZE31) + ZV32*complexconjugate(ZE32) + ZV33*complexconjugate(ZE33)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + 2*ZP11*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + 2*ZP12*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_656 = Coupling(name = 'GC_656',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV11*complexconjugate(ZE31) + ZV12*complexconjugate(ZE32) + ZV13*complexconjugate(ZE33)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + 2*ZP21*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + 2*ZP22*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_657 = Coupling(name = 'GC_657',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV21*complexconjugate(ZE31) + ZV22*complexconjugate(ZE32) + ZV23*complexconjugate(ZE33)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + 2*ZP21*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + 2*ZP22*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_658 = Coupling(name = 'GC_658',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV31*complexconjugate(ZE31) + ZV32*complexconjugate(ZE32) + ZV33*complexconjugate(ZE33)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE33)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE33)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE31) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE32) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE33))) + 2*ZP21*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE34) + complexconjugate(Te21)*complexconjugate(ZE35) + complexconjugate(Te31)*complexconjugate(ZE36)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE34) + complexconjugate(Te22)*complexconjugate(ZE35) + complexconjugate(Te32)*complexconjugate(ZE36)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE34) + complexconjugate(Te23)*complexconjugate(ZE35) + complexconjugate(Te33)*complexconjugate(ZE36))) + 2*ZP22*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))))', 
	 order = {'QED':1} ) 
 
GC_659 = Coupling(name = 'GC_659',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV11*complexconjugate(ZE41) + ZV12*complexconjugate(ZE42) + ZV13*complexconjugate(ZE43)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + 2*ZP11*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + 2*ZP12*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_660 = Coupling(name = 'GC_660',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV21*complexconjugate(ZE41) + ZV22*complexconjugate(ZE42) + ZV23*complexconjugate(ZE43)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + 2*ZP11*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + 2*ZP12*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_661 = Coupling(name = 'GC_661',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV31*complexconjugate(ZE41) + ZV32*complexconjugate(ZE42) + ZV33*complexconjugate(ZE43)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + 2*ZP11*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + 2*ZP12*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_662 = Coupling(name = 'GC_662',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV11*complexconjugate(ZE41) + ZV12*complexconjugate(ZE42) + ZV13*complexconjugate(ZE43)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + 2*ZP21*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + 2*ZP22*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_663 = Coupling(name = 'GC_663',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV21*complexconjugate(ZE41) + ZV22*complexconjugate(ZE42) + ZV23*complexconjugate(ZE43)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + 2*ZP21*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + 2*ZP22*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_664 = Coupling(name = 'GC_664',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV31*complexconjugate(ZE41) + ZV32*complexconjugate(ZE42) + ZV33*complexconjugate(ZE43)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE43)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE43)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE41) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE42) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE43))) + 2*ZP21*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE44) + complexconjugate(Te21)*complexconjugate(ZE45) + complexconjugate(Te31)*complexconjugate(ZE46)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE44) + complexconjugate(Te22)*complexconjugate(ZE45) + complexconjugate(Te32)*complexconjugate(ZE46)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE44) + complexconjugate(Te23)*complexconjugate(ZE45) + complexconjugate(Te33)*complexconjugate(ZE46))) + 2*ZP22*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))))', 
	 order = {'QED':1} ) 
 
GC_665 = Coupling(name = 'GC_665',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV11*complexconjugate(ZE51) + ZV12*complexconjugate(ZE52) + ZV13*complexconjugate(ZE53)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + 2*ZP11*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + 2*ZP12*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_666 = Coupling(name = 'GC_666',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV21*complexconjugate(ZE51) + ZV22*complexconjugate(ZE52) + ZV23*complexconjugate(ZE53)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + 2*ZP11*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + 2*ZP12*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_667 = Coupling(name = 'GC_667',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV31*complexconjugate(ZE51) + ZV32*complexconjugate(ZE52) + ZV33*complexconjugate(ZE53)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + 2*ZP11*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + 2*ZP12*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_668 = Coupling(name = 'GC_668',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV11*complexconjugate(ZE51) + ZV12*complexconjugate(ZE52) + ZV13*complexconjugate(ZE53)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + 2*ZP21*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + 2*ZP22*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_669 = Coupling(name = 'GC_669',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV21*complexconjugate(ZE51) + ZV22*complexconjugate(ZE52) + ZV23*complexconjugate(ZE53)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + 2*ZP21*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + 2*ZP22*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_670 = Coupling(name = 'GC_670',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV31*complexconjugate(ZE51) + ZV32*complexconjugate(ZE52) + ZV33*complexconjugate(ZE53)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE53)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE53)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE51) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE52) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE53))) + 2*ZP21*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE54) + complexconjugate(Te21)*complexconjugate(ZE55) + complexconjugate(Te31)*complexconjugate(ZE56)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE54) + complexconjugate(Te22)*complexconjugate(ZE55) + complexconjugate(Te32)*complexconjugate(ZE56)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE54) + complexconjugate(Te23)*complexconjugate(ZE55) + complexconjugate(Te33)*complexconjugate(ZE56))) + 2*ZP22*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))))', 
	 order = {'QED':1} ) 
 
GC_671 = Coupling(name = 'GC_671',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV11*complexconjugate(ZE61) + ZV12*complexconjugate(ZE62) + ZV13*complexconjugate(ZE63)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + 2*ZP11*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + 2*ZP12*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_672 = Coupling(name = 'GC_672',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV21*complexconjugate(ZE61) + ZV22*complexconjugate(ZE62) + ZV23*complexconjugate(ZE63)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + 2*ZP11*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + 2*ZP12*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_673 = Coupling(name = 'GC_673',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP11 + vu*ZP12)*(ZV31*complexconjugate(ZE61) + ZV32*complexconjugate(ZE62) + ZV33*complexconjugate(ZE63)) - 2*(cmath.sqrt(2)*vd*ZP11*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + 2*ZP11*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + 2*ZP12*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_674 = Coupling(name = 'GC_674',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV11*complexconjugate(ZE61) + ZV12*complexconjugate(ZE62) + ZV13*complexconjugate(ZE63)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV11*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZV12*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZV13*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + 2*ZP21*(ZV11*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZV12*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZV13*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + 2*ZP22*complexconjugate(Mu)*(ZV11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZV12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZV13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_675 = Coupling(name = 'GC_675',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV21*complexconjugate(ZE61) + ZV22*complexconjugate(ZE62) + ZV23*complexconjugate(ZE63)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV21*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZV22*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZV23*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + 2*ZP21*(ZV21*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZV22*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZV23*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + 2*ZP22*complexconjugate(Mu)*(ZV21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZV22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZV23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_676 = Coupling(name = 'GC_676',
	 value = '-1./4.*complex(0,1)*(cmath.sqrt(2)*g2**2*(vd*ZP21 + vu*ZP22)*(ZV31*complexconjugate(ZE61) + ZV32*complexconjugate(ZE62) + ZV33*complexconjugate(ZE63)) - 2*(cmath.sqrt(2)*vd*ZP21*(ZV31*((Ye11*complexconjugate(Ye11) + Ye21*complexconjugate(Ye21) + Ye31*complexconjugate(Ye31))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye11) + Ye22*complexconjugate(Ye21) + Ye32*complexconjugate(Ye31))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye11) + Ye23*complexconjugate(Ye21) + Ye33*complexconjugate(Ye31))*complexconjugate(ZE63)) + ZV32*((Ye11*complexconjugate(Ye12) + Ye21*complexconjugate(Ye22) + Ye31*complexconjugate(Ye32))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye12) + Ye22*complexconjugate(Ye22) + Ye32*complexconjugate(Ye32))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye12) + Ye23*complexconjugate(Ye22) + Ye33*complexconjugate(Ye32))*complexconjugate(ZE63)) + ZV33*((Ye11*complexconjugate(Ye13) + Ye21*complexconjugate(Ye23) + Ye31*complexconjugate(Ye33))*complexconjugate(ZE61) + (Ye12*complexconjugate(Ye13) + Ye22*complexconjugate(Ye23) + Ye32*complexconjugate(Ye33))*complexconjugate(ZE62) + (Ye13*complexconjugate(Ye13) + Ye23*complexconjugate(Ye23) + Ye33*complexconjugate(Ye33))*complexconjugate(ZE63))) + 2*ZP21*(ZV31*(complexconjugate(Te11)*complexconjugate(ZE64) + complexconjugate(Te21)*complexconjugate(ZE65) + complexconjugate(Te31)*complexconjugate(ZE66)) + ZV32*(complexconjugate(Te12)*complexconjugate(ZE64) + complexconjugate(Te22)*complexconjugate(ZE65) + complexconjugate(Te32)*complexconjugate(ZE66)) + ZV33*(complexconjugate(Te13)*complexconjugate(ZE64) + complexconjugate(Te23)*complexconjugate(ZE65) + complexconjugate(Te33)*complexconjugate(ZE66))) + 2*ZP22*complexconjugate(Mu)*(ZV31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZV32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZV33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))))', 
	 order = {'QED':1} ) 
 
GC_677 = Coupling(name = 'GC_677',
	 value = '1./2.*complex(0,1)*g2**2*(ZA11**2 + ZA12**2)', 
	 order = {'QED':2} ) 
 
GC_678 = Coupling(name = 'GC_678',
	 value = '1./2.*complex(0,1)*g2**2*(ZA11*ZA21 + ZA12*ZA22)', 
	 order = {'QED':2} ) 
 
GC_679 = Coupling(name = 'GC_679',
	 value = '1./2.*complex(0,1)*g2**2*(ZA21**2 + ZA22**2)', 
	 order = {'QED':2} ) 
 
GC_680 = Coupling(name = 'GC_680',
	 value = '1./2.*complex(0,1)*(ZA11**2 + ZA12**2)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_681 = Coupling(name = 'GC_681',
	 value = '1./2.*complex(0,1)*(ZA11*ZA21 + ZA12*ZA22)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_682 = Coupling(name = 'GC_682',
	 value = '1./2.*complex(0,1)*(ZA21**2 + ZA22**2)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_683 = Coupling(name = 'GC_683',
	 value = '-(g1*g2*(ZA11*ZP11 + ZA12*ZP12)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_684 = Coupling(name = 'GC_684',
	 value = '-(g1*g2*(ZA11*ZP21 + ZA12*ZP22)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_685 = Coupling(name = 'GC_685',
	 value = '-(g1*g2*(ZA21*ZP11 + ZA22*ZP12)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_686 = Coupling(name = 'GC_686',
	 value = '-(g1*g2*(ZA21*ZP21 + ZA22*ZP22)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_687 = Coupling(name = 'GC_687',
	 value = '(g1*g2*(ZA11*ZP11 + ZA12*ZP12)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_688 = Coupling(name = 'GC_688',
	 value = '(g1*g2*(ZA11*ZP21 + ZA12*ZP22)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_689 = Coupling(name = 'GC_689',
	 value = '(g1*g2*(ZA21*ZP11 + ZA22*ZP12)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_690 = Coupling(name = 'GC_690',
	 value = '(g1*g2*(ZA21*ZP21 + ZA22*ZP22)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_691 = Coupling(name = 'GC_691',
	 value = '(g1*g2*(ZA11*ZP11 + ZA12*ZP12)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_692 = Coupling(name = 'GC_692',
	 value = '(g1*g2*(ZA11*ZP21 + ZA12*ZP22)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_693 = Coupling(name = 'GC_693',
	 value = '(g1*g2*(ZA21*ZP11 + ZA22*ZP12)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_694 = Coupling(name = 'GC_694',
	 value = '(g1*g2*(ZA21*ZP21 + ZA22*ZP22)*cmath.cos(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_695 = Coupling(name = 'GC_695',
	 value = '-(g1*g2*(ZA11*ZP11 + ZA12*ZP12)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_696 = Coupling(name = 'GC_696',
	 value = '-(g1*g2*(ZA11*ZP21 + ZA12*ZP22)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_697 = Coupling(name = 'GC_697',
	 value = '-(g1*g2*(ZA21*ZP11 + ZA22*ZP12)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_698 = Coupling(name = 'GC_698',
	 value = '-(g1*g2*(ZA21*ZP21 + ZA22*ZP22)*cmath.sin(TW))/2.', 
	 order = {'QED':2} ) 
 
GC_699 = Coupling(name = 'GC_699',
	 value = '1./2.*complex(0,1)*g2**2*(ZH11**2 + ZH12**2)', 
	 order = {'QED':2} ) 
 
GC_700 = Coupling(name = 'GC_700',
	 value = '1./2.*complex(0,1)*g2**2*(ZH11*ZH21 + ZH12*ZH22)', 
	 order = {'QED':2} ) 
 
GC_701 = Coupling(name = 'GC_701',
	 value = '1./2.*complex(0,1)*g2**2*(ZH21**2 + ZH22**2)', 
	 order = {'QED':2} ) 
 
GC_702 = Coupling(name = 'GC_702',
	 value = '1./2.*complex(0,1)*(ZH11**2 + ZH12**2)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_703 = Coupling(name = 'GC_703',
	 value = '1./2.*complex(0,1)*(ZH11*ZH21 + ZH12*ZH22)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_704 = Coupling(name = 'GC_704',
	 value = '1./2.*complex(0,1)*(ZH21**2 + ZH22**2)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_705 = Coupling(name = 'GC_705',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH11*ZP11 - ZH12*ZP12)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_706 = Coupling(name = 'GC_706',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH11*ZP21 - ZH12*ZP22)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_707 = Coupling(name = 'GC_707',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH21*ZP11 - ZH22*ZP12)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_708 = Coupling(name = 'GC_708',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH21*ZP21 - ZH22*ZP22)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_709 = Coupling(name = 'GC_709',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH11*ZP11 - ZH12*ZP12)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_710 = Coupling(name = 'GC_710',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH11*ZP21 - ZH12*ZP22)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_711 = Coupling(name = 'GC_711',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH21*ZP11 - ZH22*ZP12)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_712 = Coupling(name = 'GC_712',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH21*ZP21 - ZH22*ZP22)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_713 = Coupling(name = 'GC_713',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH11*ZP11 - ZH12*ZP12)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_714 = Coupling(name = 'GC_714',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH11*ZP21 - ZH12*ZP22)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_715 = Coupling(name = 'GC_715',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH21*ZP11 - ZH22*ZP12)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_716 = Coupling(name = 'GC_716',
	 value = '-1./2.*complex(0,1)*g1*g2*(ZH21*ZP21 - ZH22*ZP22)*cmath.cos(TW)', 
	 order = {'QED':2} ) 
 
GC_717 = Coupling(name = 'GC_717',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH11*ZP11 - ZH12*ZP12)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_718 = Coupling(name = 'GC_718',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH11*ZP21 - ZH12*ZP22)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_719 = Coupling(name = 'GC_719',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH21*ZP11 - ZH22*ZP12)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_720 = Coupling(name = 'GC_720',
	 value = '1./2.*complex(0,1)*g1*g2*(ZH21*ZP21 - ZH22*ZP22)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_721 = Coupling(name = 'GC_721',
	 value = '1./2.*complex(0,1)*(ZP11**2 + ZP12**2)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_722 = Coupling(name = 'GC_722',
	 value = '1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_723 = Coupling(name = 'GC_723',
	 value = '1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_724 = Coupling(name = 'GC_724',
	 value = '1./2.*complex(0,1)*(ZP21**2 + ZP22**2)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_725 = Coupling(name = 'GC_725',
	 value = '-1./4.*complex(0,1)*(ZP11**2 + ZP12**2)*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW))', 
	 order = {'QED':2} ) 
 
GC_726 = Coupling(name = 'GC_726',
	 value = '-1./4.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW))', 
	 order = {'QED':2} ) 
 
GC_727 = Coupling(name = 'GC_727',
	 value = '-1./4.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW))', 
	 order = {'QED':2} ) 
 
GC_728 = Coupling(name = 'GC_728',
	 value = '-1./4.*complex(0,1)*(ZP21**2 + ZP22**2)*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW))', 
	 order = {'QED':2} ) 
 
GC_729 = Coupling(name = 'GC_729',
	 value = '1./2.*complex(0,1)*g2**2*(ZP11**2 + ZP12**2)', 
	 order = {'QED':2} ) 
 
GC_730 = Coupling(name = 'GC_730',
	 value = '1./2.*complex(0,1)*g2**2*(ZP11*ZP21 + ZP12*ZP22)', 
	 order = {'QED':2} ) 
 
GC_731 = Coupling(name = 'GC_731',
	 value = '1./2.*complex(0,1)*g2**2*(ZP11*ZP21 + ZP12*ZP22)', 
	 order = {'QED':2} ) 
 
GC_732 = Coupling(name = 'GC_732',
	 value = '1./2.*complex(0,1)*g2**2*(ZP21**2 + ZP22**2)', 
	 order = {'QED':2} ) 
 
GC_733 = Coupling(name = 'GC_733',
	 value = '1./2.*complex(0,1)*(ZP11**2 + ZP12**2)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_734 = Coupling(name = 'GC_734',
	 value = '1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_735 = Coupling(name = 'GC_735',
	 value = '1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_736 = Coupling(name = 'GC_736',
	 value = '1./2.*complex(0,1)*(ZP21**2 + ZP22**2)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_737 = Coupling(name = 'GC_737',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_738 = Coupling(name = 'GC_738',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_739 = Coupling(name = 'GC_739',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_740 = Coupling(name = 'GC_740',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_741 = Coupling(name = 'GC_741',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_742 = Coupling(name = 'GC_742',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_743 = Coupling(name = 'GC_743',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_744 = Coupling(name = 'GC_744',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_745 = Coupling(name = 'GC_745',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_746 = Coupling(name = 'GC_746',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_747 = Coupling(name = 'GC_747',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_748 = Coupling(name = 'GC_748',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_749 = Coupling(name = 'GC_749',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16))*cmath.cos(TW) + (ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_750 = Coupling(name = 'GC_750',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16))*cmath.cos(TW) + (ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_751 = Coupling(name = 'GC_751',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16))*cmath.cos(TW) + (ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_752 = Coupling(name = 'GC_752',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16))*cmath.cos(TW) + (ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_753 = Coupling(name = 'GC_753',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16))*cmath.cos(TW) + (ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_754 = Coupling(name = 'GC_754',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16))*cmath.cos(TW) + (ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_755 = Coupling(name = 'GC_755',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26))*cmath.cos(TW) + (ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_756 = Coupling(name = 'GC_756',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26))*cmath.cos(TW) + (ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_757 = Coupling(name = 'GC_757',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26))*cmath.cos(TW) + (ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_758 = Coupling(name = 'GC_758',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26))*cmath.cos(TW) + (ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_759 = Coupling(name = 'GC_759',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26))*cmath.cos(TW) + (ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_760 = Coupling(name = 'GC_760',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26))*cmath.cos(TW) + (ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_761 = Coupling(name = 'GC_761',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36))*cmath.cos(TW) + (ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_762 = Coupling(name = 'GC_762',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36))*cmath.cos(TW) + (ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_763 = Coupling(name = 'GC_763',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36))*cmath.cos(TW) + (ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_764 = Coupling(name = 'GC_764',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36))*cmath.cos(TW) + (ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_765 = Coupling(name = 'GC_765',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36))*cmath.cos(TW) + (ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_766 = Coupling(name = 'GC_766',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36))*cmath.cos(TW) + (ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_767 = Coupling(name = 'GC_767',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46))*cmath.cos(TW) + (ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_768 = Coupling(name = 'GC_768',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46))*cmath.cos(TW) + (ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_769 = Coupling(name = 'GC_769',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46))*cmath.cos(TW) + (ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_770 = Coupling(name = 'GC_770',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46))*cmath.cos(TW) + (ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_771 = Coupling(name = 'GC_771',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46))*cmath.cos(TW) + (ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_772 = Coupling(name = 'GC_772',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46))*cmath.cos(TW) + (ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_773 = Coupling(name = 'GC_773',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56))*cmath.cos(TW) + (ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_774 = Coupling(name = 'GC_774',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56))*cmath.cos(TW) + (ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_775 = Coupling(name = 'GC_775',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56))*cmath.cos(TW) + (ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_776 = Coupling(name = 'GC_776',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56))*cmath.cos(TW) + (ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_777 = Coupling(name = 'GC_777',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56))*cmath.cos(TW) + (ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_778 = Coupling(name = 'GC_778',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56))*cmath.cos(TW) + (ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_779 = Coupling(name = 'GC_779',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66))*cmath.cos(TW) + (ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_780 = Coupling(name = 'GC_780',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66))*cmath.cos(TW) + (ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_781 = Coupling(name = 'GC_781',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66))*cmath.cos(TW) + (ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_782 = Coupling(name = 'GC_782',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66))*cmath.cos(TW) + (ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_783 = Coupling(name = 'GC_783',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66))*cmath.cos(TW) + (ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_784 = Coupling(name = 'GC_784',
	 value = '1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66))*cmath.cos(TW) + (ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_785 = Coupling(name = 'GC_785',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16))*cmath.sin(TW) + (ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_786 = Coupling(name = 'GC_786',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16))*cmath.sin(TW) + (ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_787 = Coupling(name = 'GC_787',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16))*cmath.sin(TW) + (ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_788 = Coupling(name = 'GC_788',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16))*cmath.sin(TW) + (ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_789 = Coupling(name = 'GC_789',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16))*cmath.sin(TW) + (ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_790 = Coupling(name = 'GC_790',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16))*cmath.sin(TW) + (ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_791 = Coupling(name = 'GC_791',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26))*cmath.sin(TW) + (ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_792 = Coupling(name = 'GC_792',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26))*cmath.sin(TW) + (ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_793 = Coupling(name = 'GC_793',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26))*cmath.sin(TW) + (ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_794 = Coupling(name = 'GC_794',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26))*cmath.sin(TW) + (ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_795 = Coupling(name = 'GC_795',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26))*cmath.sin(TW) + (ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_796 = Coupling(name = 'GC_796',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26))*cmath.sin(TW) + (ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_797 = Coupling(name = 'GC_797',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36))*cmath.sin(TW) + (ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_798 = Coupling(name = 'GC_798',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36))*cmath.sin(TW) + (ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_799 = Coupling(name = 'GC_799',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36))*cmath.sin(TW) + (ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_800 = Coupling(name = 'GC_800',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36))*cmath.sin(TW) + (ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_801 = Coupling(name = 'GC_801',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36))*cmath.sin(TW) + (ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_802 = Coupling(name = 'GC_802',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36))*cmath.sin(TW) + (ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_803 = Coupling(name = 'GC_803',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46))*cmath.sin(TW) + (ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_804 = Coupling(name = 'GC_804',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46))*cmath.sin(TW) + (ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_805 = Coupling(name = 'GC_805',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46))*cmath.sin(TW) + (ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_806 = Coupling(name = 'GC_806',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46))*cmath.sin(TW) + (ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_807 = Coupling(name = 'GC_807',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46))*cmath.sin(TW) + (ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_808 = Coupling(name = 'GC_808',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46))*cmath.sin(TW) + (ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_809 = Coupling(name = 'GC_809',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56))*cmath.sin(TW) + (ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_810 = Coupling(name = 'GC_810',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56))*cmath.sin(TW) + (ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_811 = Coupling(name = 'GC_811',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56))*cmath.sin(TW) + (ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_812 = Coupling(name = 'GC_812',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56))*cmath.sin(TW) + (ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_813 = Coupling(name = 'GC_813',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56))*cmath.sin(TW) + (ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_814 = Coupling(name = 'GC_814',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56))*cmath.sin(TW) + (ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_815 = Coupling(name = 'GC_815',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66))*cmath.sin(TW) + (ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_816 = Coupling(name = 'GC_816',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66))*cmath.sin(TW) + (ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_817 = Coupling(name = 'GC_817',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66))*cmath.sin(TW) + (ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_818 = Coupling(name = 'GC_818',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66))*cmath.sin(TW) + (ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_819 = Coupling(name = 'GC_819',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66))*cmath.sin(TW) + (ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_820 = Coupling(name = 'GC_820',
	 value = '-1./3.*complex(0,1)*G*(-2*g1*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66))*cmath.sin(TW) + (ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_821 = Coupling(name = 'GC_821',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU11*complexconjugate(ZD11) + ZU12*complexconjugate(ZD12) + ZU13*complexconjugate(ZD13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_822 = Coupling(name = 'GC_822',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU21*complexconjugate(ZD11) + ZU22*complexconjugate(ZD12) + ZU23*complexconjugate(ZD13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_823 = Coupling(name = 'GC_823',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU31*complexconjugate(ZD11) + ZU32*complexconjugate(ZD12) + ZU33*complexconjugate(ZD13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_824 = Coupling(name = 'GC_824',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU41*complexconjugate(ZD11) + ZU42*complexconjugate(ZD12) + ZU43*complexconjugate(ZD13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_825 = Coupling(name = 'GC_825',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU51*complexconjugate(ZD11) + ZU52*complexconjugate(ZD12) + ZU53*complexconjugate(ZD13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_826 = Coupling(name = 'GC_826',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU61*complexconjugate(ZD11) + ZU62*complexconjugate(ZD12) + ZU63*complexconjugate(ZD13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_827 = Coupling(name = 'GC_827',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU11*complexconjugate(ZD21) + ZU12*complexconjugate(ZD22) + ZU13*complexconjugate(ZD23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_828 = Coupling(name = 'GC_828',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU21*complexconjugate(ZD21) + ZU22*complexconjugate(ZD22) + ZU23*complexconjugate(ZD23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_829 = Coupling(name = 'GC_829',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU31*complexconjugate(ZD21) + ZU32*complexconjugate(ZD22) + ZU33*complexconjugate(ZD23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_830 = Coupling(name = 'GC_830',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU41*complexconjugate(ZD21) + ZU42*complexconjugate(ZD22) + ZU43*complexconjugate(ZD23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_831 = Coupling(name = 'GC_831',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU51*complexconjugate(ZD21) + ZU52*complexconjugate(ZD22) + ZU53*complexconjugate(ZD23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_832 = Coupling(name = 'GC_832',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU61*complexconjugate(ZD21) + ZU62*complexconjugate(ZD22) + ZU63*complexconjugate(ZD23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_833 = Coupling(name = 'GC_833',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU11*complexconjugate(ZD31) + ZU12*complexconjugate(ZD32) + ZU13*complexconjugate(ZD33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_834 = Coupling(name = 'GC_834',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU21*complexconjugate(ZD31) + ZU22*complexconjugate(ZD32) + ZU23*complexconjugate(ZD33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_835 = Coupling(name = 'GC_835',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU31*complexconjugate(ZD31) + ZU32*complexconjugate(ZD32) + ZU33*complexconjugate(ZD33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_836 = Coupling(name = 'GC_836',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU41*complexconjugate(ZD31) + ZU42*complexconjugate(ZD32) + ZU43*complexconjugate(ZD33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_837 = Coupling(name = 'GC_837',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU51*complexconjugate(ZD31) + ZU52*complexconjugate(ZD32) + ZU53*complexconjugate(ZD33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_838 = Coupling(name = 'GC_838',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU61*complexconjugate(ZD31) + ZU62*complexconjugate(ZD32) + ZU63*complexconjugate(ZD33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_839 = Coupling(name = 'GC_839',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU11*complexconjugate(ZD41) + ZU12*complexconjugate(ZD42) + ZU13*complexconjugate(ZD43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_840 = Coupling(name = 'GC_840',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU21*complexconjugate(ZD41) + ZU22*complexconjugate(ZD42) + ZU23*complexconjugate(ZD43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_841 = Coupling(name = 'GC_841',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU31*complexconjugate(ZD41) + ZU32*complexconjugate(ZD42) + ZU33*complexconjugate(ZD43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_842 = Coupling(name = 'GC_842',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU41*complexconjugate(ZD41) + ZU42*complexconjugate(ZD42) + ZU43*complexconjugate(ZD43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_843 = Coupling(name = 'GC_843',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU51*complexconjugate(ZD41) + ZU52*complexconjugate(ZD42) + ZU53*complexconjugate(ZD43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_844 = Coupling(name = 'GC_844',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU61*complexconjugate(ZD41) + ZU62*complexconjugate(ZD42) + ZU63*complexconjugate(ZD43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_845 = Coupling(name = 'GC_845',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU11*complexconjugate(ZD51) + ZU12*complexconjugate(ZD52) + ZU13*complexconjugate(ZD53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_846 = Coupling(name = 'GC_846',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU21*complexconjugate(ZD51) + ZU22*complexconjugate(ZD52) + ZU23*complexconjugate(ZD53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_847 = Coupling(name = 'GC_847',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU31*complexconjugate(ZD51) + ZU32*complexconjugate(ZD52) + ZU33*complexconjugate(ZD53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_848 = Coupling(name = 'GC_848',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU41*complexconjugate(ZD51) + ZU42*complexconjugate(ZD52) + ZU43*complexconjugate(ZD53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_849 = Coupling(name = 'GC_849',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU51*complexconjugate(ZD51) + ZU52*complexconjugate(ZD52) + ZU53*complexconjugate(ZD53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_850 = Coupling(name = 'GC_850',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU61*complexconjugate(ZD51) + ZU62*complexconjugate(ZD52) + ZU63*complexconjugate(ZD53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_851 = Coupling(name = 'GC_851',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU11*complexconjugate(ZD61) + ZU12*complexconjugate(ZD62) + ZU13*complexconjugate(ZD63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_852 = Coupling(name = 'GC_852',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU21*complexconjugate(ZD61) + ZU22*complexconjugate(ZD62) + ZU23*complexconjugate(ZD63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_853 = Coupling(name = 'GC_853',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU31*complexconjugate(ZD61) + ZU32*complexconjugate(ZD62) + ZU33*complexconjugate(ZD63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_854 = Coupling(name = 'GC_854',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU41*complexconjugate(ZD61) + ZU42*complexconjugate(ZD62) + ZU43*complexconjugate(ZD63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_855 = Coupling(name = 'GC_855',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU51*complexconjugate(ZD61) + ZU52*complexconjugate(ZD62) + ZU53*complexconjugate(ZD63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_856 = Coupling(name = 'GC_856',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZU61*complexconjugate(ZD61) + ZU62*complexconjugate(ZD62) + ZU63*complexconjugate(ZD63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_857 = Coupling(name = 'GC_857',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16))*cmath.cos(TW)**2 + (ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_858 = Coupling(name = 'GC_858',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16))*cmath.cos(TW)**2 + (ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_859 = Coupling(name = 'GC_859',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16))*cmath.cos(TW)**2 + (ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_860 = Coupling(name = 'GC_860',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16))*cmath.cos(TW)**2 + (ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_861 = Coupling(name = 'GC_861',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16))*cmath.cos(TW)**2 + (ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_862 = Coupling(name = 'GC_862',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16))*cmath.cos(TW)**2 + (ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_863 = Coupling(name = 'GC_863',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26))*cmath.cos(TW)**2 + (ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_864 = Coupling(name = 'GC_864',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26))*cmath.cos(TW)**2 + (ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_865 = Coupling(name = 'GC_865',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26))*cmath.cos(TW)**2 + (ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_866 = Coupling(name = 'GC_866',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26))*cmath.cos(TW)**2 + (ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_867 = Coupling(name = 'GC_867',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26))*cmath.cos(TW)**2 + (ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_868 = Coupling(name = 'GC_868',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26))*cmath.cos(TW)**2 + (ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_869 = Coupling(name = 'GC_869',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36))*cmath.cos(TW)**2 + (ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_870 = Coupling(name = 'GC_870',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36))*cmath.cos(TW)**2 + (ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_871 = Coupling(name = 'GC_871',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36))*cmath.cos(TW)**2 + (ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_872 = Coupling(name = 'GC_872',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36))*cmath.cos(TW)**2 + (ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_873 = Coupling(name = 'GC_873',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36))*cmath.cos(TW)**2 + (ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_874 = Coupling(name = 'GC_874',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36))*cmath.cos(TW)**2 + (ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_875 = Coupling(name = 'GC_875',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46))*cmath.cos(TW)**2 + (ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_876 = Coupling(name = 'GC_876',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46))*cmath.cos(TW)**2 + (ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_877 = Coupling(name = 'GC_877',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46))*cmath.cos(TW)**2 + (ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_878 = Coupling(name = 'GC_878',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46))*cmath.cos(TW)**2 + (ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_879 = Coupling(name = 'GC_879',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46))*cmath.cos(TW)**2 + (ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_880 = Coupling(name = 'GC_880',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46))*cmath.cos(TW)**2 + (ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_881 = Coupling(name = 'GC_881',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56))*cmath.cos(TW)**2 + (ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_882 = Coupling(name = 'GC_882',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56))*cmath.cos(TW)**2 + (ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_883 = Coupling(name = 'GC_883',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56))*cmath.cos(TW)**2 + (ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_884 = Coupling(name = 'GC_884',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56))*cmath.cos(TW)**2 + (ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_885 = Coupling(name = 'GC_885',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56))*cmath.cos(TW)**2 + (ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_886 = Coupling(name = 'GC_886',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56))*cmath.cos(TW)**2 + (ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_887 = Coupling(name = 'GC_887',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66))*cmath.cos(TW)**2 + (ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_888 = Coupling(name = 'GC_888',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66))*cmath.cos(TW)**2 + (ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_889 = Coupling(name = 'GC_889',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66))*cmath.cos(TW)**2 + (ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_890 = Coupling(name = 'GC_890',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66))*cmath.cos(TW)**2 + (ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_891 = Coupling(name = 'GC_891',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66))*cmath.cos(TW)**2 + (ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_892 = Coupling(name = 'GC_892',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66))*cmath.cos(TW)**2 + (ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_893 = Coupling(name = 'GC_893',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16))*cmath.sin(2*TW) + (ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_894 = Coupling(name = 'GC_894',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16))*cmath.sin(2*TW) + (ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_895 = Coupling(name = 'GC_895',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16))*cmath.sin(2*TW) + (ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_896 = Coupling(name = 'GC_896',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16))*cmath.sin(2*TW) + (ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_897 = Coupling(name = 'GC_897',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16))*cmath.sin(2*TW) + (ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_898 = Coupling(name = 'GC_898',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16))*cmath.sin(2*TW) + (ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_899 = Coupling(name = 'GC_899',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26))*cmath.sin(2*TW) + (ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_900 = Coupling(name = 'GC_900',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26))*cmath.sin(2*TW) + (ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_901 = Coupling(name = 'GC_901',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26))*cmath.sin(2*TW) + (ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_902 = Coupling(name = 'GC_902',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26))*cmath.sin(2*TW) + (ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_903 = Coupling(name = 'GC_903',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26))*cmath.sin(2*TW) + (ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_904 = Coupling(name = 'GC_904',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26))*cmath.sin(2*TW) + (ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_905 = Coupling(name = 'GC_905',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36))*cmath.sin(2*TW) + (ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_906 = Coupling(name = 'GC_906',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36))*cmath.sin(2*TW) + (ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_907 = Coupling(name = 'GC_907',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36))*cmath.sin(2*TW) + (ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_908 = Coupling(name = 'GC_908',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36))*cmath.sin(2*TW) + (ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_909 = Coupling(name = 'GC_909',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36))*cmath.sin(2*TW) + (ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_910 = Coupling(name = 'GC_910',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36))*cmath.sin(2*TW) + (ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_911 = Coupling(name = 'GC_911',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46))*cmath.sin(2*TW) + (ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_912 = Coupling(name = 'GC_912',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46))*cmath.sin(2*TW) + (ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_913 = Coupling(name = 'GC_913',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46))*cmath.sin(2*TW) + (ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_914 = Coupling(name = 'GC_914',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46))*cmath.sin(2*TW) + (ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_915 = Coupling(name = 'GC_915',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46))*cmath.sin(2*TW) + (ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_916 = Coupling(name = 'GC_916',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46))*cmath.sin(2*TW) + (ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_917 = Coupling(name = 'GC_917',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56))*cmath.sin(2*TW) + (ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_918 = Coupling(name = 'GC_918',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56))*cmath.sin(2*TW) + (ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_919 = Coupling(name = 'GC_919',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56))*cmath.sin(2*TW) + (ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_920 = Coupling(name = 'GC_920',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56))*cmath.sin(2*TW) + (ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_921 = Coupling(name = 'GC_921',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56))*cmath.sin(2*TW) + (ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_922 = Coupling(name = 'GC_922',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56))*cmath.sin(2*TW) + (ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_923 = Coupling(name = 'GC_923',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66))*cmath.sin(2*TW) + (ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_924 = Coupling(name = 'GC_924',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66))*cmath.sin(2*TW) + (ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_925 = Coupling(name = 'GC_925',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66))*cmath.sin(2*TW) + (ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_926 = Coupling(name = 'GC_926',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66))*cmath.sin(2*TW) + (ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_927 = Coupling(name = 'GC_927',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66))*cmath.sin(2*TW) + (ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_928 = Coupling(name = 'GC_928',
	 value = '-1./36.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66))*cmath.sin(2*TW) + (ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))*(6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_929 = Coupling(name = 'GC_929',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD11) + ZU12*complexconjugate(ZD12) + ZU13*complexconjugate(ZD13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_930 = Coupling(name = 'GC_930',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD11) + ZU22*complexconjugate(ZD12) + ZU23*complexconjugate(ZD13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_931 = Coupling(name = 'GC_931',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD11) + ZU32*complexconjugate(ZD12) + ZU33*complexconjugate(ZD13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_932 = Coupling(name = 'GC_932',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD11) + ZU42*complexconjugate(ZD12) + ZU43*complexconjugate(ZD13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_933 = Coupling(name = 'GC_933',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD11) + ZU52*complexconjugate(ZD12) + ZU53*complexconjugate(ZD13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_934 = Coupling(name = 'GC_934',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD11) + ZU62*complexconjugate(ZD12) + ZU63*complexconjugate(ZD13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_935 = Coupling(name = 'GC_935',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD21) + ZU12*complexconjugate(ZD22) + ZU13*complexconjugate(ZD23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_936 = Coupling(name = 'GC_936',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD21) + ZU22*complexconjugate(ZD22) + ZU23*complexconjugate(ZD23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_937 = Coupling(name = 'GC_937',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD21) + ZU32*complexconjugate(ZD22) + ZU33*complexconjugate(ZD23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_938 = Coupling(name = 'GC_938',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD21) + ZU42*complexconjugate(ZD22) + ZU43*complexconjugate(ZD23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_939 = Coupling(name = 'GC_939',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD21) + ZU52*complexconjugate(ZD22) + ZU53*complexconjugate(ZD23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_940 = Coupling(name = 'GC_940',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD21) + ZU62*complexconjugate(ZD22) + ZU63*complexconjugate(ZD23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_941 = Coupling(name = 'GC_941',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD31) + ZU12*complexconjugate(ZD32) + ZU13*complexconjugate(ZD33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_942 = Coupling(name = 'GC_942',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD31) + ZU22*complexconjugate(ZD32) + ZU23*complexconjugate(ZD33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_943 = Coupling(name = 'GC_943',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD31) + ZU32*complexconjugate(ZD32) + ZU33*complexconjugate(ZD33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_944 = Coupling(name = 'GC_944',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD31) + ZU42*complexconjugate(ZD32) + ZU43*complexconjugate(ZD33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_945 = Coupling(name = 'GC_945',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD31) + ZU52*complexconjugate(ZD32) + ZU53*complexconjugate(ZD33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_946 = Coupling(name = 'GC_946',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD31) + ZU62*complexconjugate(ZD32) + ZU63*complexconjugate(ZD33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_947 = Coupling(name = 'GC_947',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD41) + ZU12*complexconjugate(ZD42) + ZU13*complexconjugate(ZD43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_948 = Coupling(name = 'GC_948',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD41) + ZU22*complexconjugate(ZD42) + ZU23*complexconjugate(ZD43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_949 = Coupling(name = 'GC_949',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD41) + ZU32*complexconjugate(ZD42) + ZU33*complexconjugate(ZD43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_950 = Coupling(name = 'GC_950',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD41) + ZU42*complexconjugate(ZD42) + ZU43*complexconjugate(ZD43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_951 = Coupling(name = 'GC_951',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD41) + ZU52*complexconjugate(ZD42) + ZU53*complexconjugate(ZD43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_952 = Coupling(name = 'GC_952',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD41) + ZU62*complexconjugate(ZD42) + ZU63*complexconjugate(ZD43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_953 = Coupling(name = 'GC_953',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD51) + ZU12*complexconjugate(ZD52) + ZU13*complexconjugate(ZD53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_954 = Coupling(name = 'GC_954',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD51) + ZU22*complexconjugate(ZD52) + ZU23*complexconjugate(ZD53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_955 = Coupling(name = 'GC_955',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD51) + ZU32*complexconjugate(ZD52) + ZU33*complexconjugate(ZD53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_956 = Coupling(name = 'GC_956',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD51) + ZU42*complexconjugate(ZD52) + ZU43*complexconjugate(ZD53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_957 = Coupling(name = 'GC_957',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD51) + ZU52*complexconjugate(ZD52) + ZU53*complexconjugate(ZD53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_958 = Coupling(name = 'GC_958',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD51) + ZU62*complexconjugate(ZD52) + ZU63*complexconjugate(ZD53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_959 = Coupling(name = 'GC_959',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD61) + ZU12*complexconjugate(ZD62) + ZU13*complexconjugate(ZD63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_960 = Coupling(name = 'GC_960',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD61) + ZU22*complexconjugate(ZD62) + ZU23*complexconjugate(ZD63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_961 = Coupling(name = 'GC_961',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD61) + ZU32*complexconjugate(ZD62) + ZU33*complexconjugate(ZD63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_962 = Coupling(name = 'GC_962',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD61) + ZU42*complexconjugate(ZD62) + ZU43*complexconjugate(ZD63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_963 = Coupling(name = 'GC_963',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD61) + ZU52*complexconjugate(ZD62) + ZU53*complexconjugate(ZD63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_964 = Coupling(name = 'GC_964',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD61) + ZU62*complexconjugate(ZD62) + ZU63*complexconjugate(ZD63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_965 = Coupling(name = 'GC_965',
	 value = '1./2.*complex(0,1)*g2**2*(ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))', 
	 order = {'QED':2} ) 
 
GC_966 = Coupling(name = 'GC_966',
	 value = '1./2.*complex(0,1)*g2**2*(ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))', 
	 order = {'QED':2} ) 
 
GC_967 = Coupling(name = 'GC_967',
	 value = '1./2.*complex(0,1)*g2**2*(ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))', 
	 order = {'QED':2} ) 
 
GC_968 = Coupling(name = 'GC_968',
	 value = '1./2.*complex(0,1)*g2**2*(ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))', 
	 order = {'QED':2} ) 
 
GC_969 = Coupling(name = 'GC_969',
	 value = '1./2.*complex(0,1)*g2**2*(ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))', 
	 order = {'QED':2} ) 
 
GC_970 = Coupling(name = 'GC_970',
	 value = '1./2.*complex(0,1)*g2**2*(ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))', 
	 order = {'QED':2} ) 
 
GC_971 = Coupling(name = 'GC_971',
	 value = '1./2.*complex(0,1)*g2**2*(ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))', 
	 order = {'QED':2} ) 
 
GC_972 = Coupling(name = 'GC_972',
	 value = '1./2.*complex(0,1)*g2**2*(ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))', 
	 order = {'QED':2} ) 
 
GC_973 = Coupling(name = 'GC_973',
	 value = '1./2.*complex(0,1)*g2**2*(ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))', 
	 order = {'QED':2} ) 
 
GC_974 = Coupling(name = 'GC_974',
	 value = '1./2.*complex(0,1)*g2**2*(ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))', 
	 order = {'QED':2} ) 
 
GC_975 = Coupling(name = 'GC_975',
	 value = '1./2.*complex(0,1)*g2**2*(ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))', 
	 order = {'QED':2} ) 
 
GC_976 = Coupling(name = 'GC_976',
	 value = '1./2.*complex(0,1)*g2**2*(ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))', 
	 order = {'QED':2} ) 
 
GC_977 = Coupling(name = 'GC_977',
	 value = '1./2.*complex(0,1)*g2**2*(ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))', 
	 order = {'QED':2} ) 
 
GC_978 = Coupling(name = 'GC_978',
	 value = '1./2.*complex(0,1)*g2**2*(ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))', 
	 order = {'QED':2} ) 
 
GC_979 = Coupling(name = 'GC_979',
	 value = '1./2.*complex(0,1)*g2**2*(ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))', 
	 order = {'QED':2} ) 
 
GC_980 = Coupling(name = 'GC_980',
	 value = '1./2.*complex(0,1)*g2**2*(ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))', 
	 order = {'QED':2} ) 
 
GC_981 = Coupling(name = 'GC_981',
	 value = '1./2.*complex(0,1)*g2**2*(ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))', 
	 order = {'QED':2} ) 
 
GC_982 = Coupling(name = 'GC_982',
	 value = '1./2.*complex(0,1)*g2**2*(ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))', 
	 order = {'QED':2} ) 
 
GC_983 = Coupling(name = 'GC_983',
	 value = '1./2.*complex(0,1)*g2**2*(ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))', 
	 order = {'QED':2} ) 
 
GC_984 = Coupling(name = 'GC_984',
	 value = '1./2.*complex(0,1)*g2**2*(ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))', 
	 order = {'QED':2} ) 
 
GC_985 = Coupling(name = 'GC_985',
	 value = '1./2.*complex(0,1)*g2**2*(ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))', 
	 order = {'QED':2} ) 
 
GC_986 = Coupling(name = 'GC_986',
	 value = '1./2.*complex(0,1)*g2**2*(ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))', 
	 order = {'QED':2} ) 
 
GC_987 = Coupling(name = 'GC_987',
	 value = '1./2.*complex(0,1)*g2**2*(ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))', 
	 order = {'QED':2} ) 
 
GC_988 = Coupling(name = 'GC_988',
	 value = '1./2.*complex(0,1)*g2**2*(ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))', 
	 order = {'QED':2} ) 
 
GC_989 = Coupling(name = 'GC_989',
	 value = '1./2.*complex(0,1)*g2**2*(ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))', 
	 order = {'QED':2} ) 
 
GC_990 = Coupling(name = 'GC_990',
	 value = '1./2.*complex(0,1)*g2**2*(ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))', 
	 order = {'QED':2} ) 
 
GC_991 = Coupling(name = 'GC_991',
	 value = '1./2.*complex(0,1)*g2**2*(ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))', 
	 order = {'QED':2} ) 
 
GC_992 = Coupling(name = 'GC_992',
	 value = '1./2.*complex(0,1)*g2**2*(ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))', 
	 order = {'QED':2} ) 
 
GC_993 = Coupling(name = 'GC_993',
	 value = '1./2.*complex(0,1)*g2**2*(ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))', 
	 order = {'QED':2} ) 
 
GC_994 = Coupling(name = 'GC_994',
	 value = '1./2.*complex(0,1)*g2**2*(ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))', 
	 order = {'QED':2} ) 
 
GC_995 = Coupling(name = 'GC_995',
	 value = '1./2.*complex(0,1)*g2**2*(ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))', 
	 order = {'QED':2} ) 
 
GC_996 = Coupling(name = 'GC_996',
	 value = '1./2.*complex(0,1)*g2**2*(ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))', 
	 order = {'QED':2} ) 
 
GC_997 = Coupling(name = 'GC_997',
	 value = '1./2.*complex(0,1)*g2**2*(ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))', 
	 order = {'QED':2} ) 
 
GC_998 = Coupling(name = 'GC_998',
	 value = '1./2.*complex(0,1)*g2**2*(ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))', 
	 order = {'QED':2} ) 
 
GC_999 = Coupling(name = 'GC_999',
	 value = '1./2.*complex(0,1)*g2**2*(ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))', 
	 order = {'QED':2} ) 
 
GC_1000 = Coupling(name = 'GC_1000',
	 value = '1./2.*complex(0,1)*g2**2*(ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))', 
	 order = {'QED':2} ) 
 
GC_1001 = Coupling(name = 'GC_1001',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16))*cmath.sin(TW)**2 + (ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1002 = Coupling(name = 'GC_1002',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16))*cmath.sin(TW)**2 + (ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1003 = Coupling(name = 'GC_1003',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16))*cmath.sin(TW)**2 + (ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1004 = Coupling(name = 'GC_1004',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16))*cmath.sin(TW)**2 + (ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1005 = Coupling(name = 'GC_1005',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16))*cmath.sin(TW)**2 + (ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1006 = Coupling(name = 'GC_1006',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16))*cmath.sin(TW)**2 + (ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1007 = Coupling(name = 'GC_1007',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26))*cmath.sin(TW)**2 + (ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1008 = Coupling(name = 'GC_1008',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26))*cmath.sin(TW)**2 + (ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1009 = Coupling(name = 'GC_1009',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26))*cmath.sin(TW)**2 + (ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1010 = Coupling(name = 'GC_1010',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26))*cmath.sin(TW)**2 + (ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1011 = Coupling(name = 'GC_1011',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26))*cmath.sin(TW)**2 + (ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1012 = Coupling(name = 'GC_1012',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26))*cmath.sin(TW)**2 + (ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1013 = Coupling(name = 'GC_1013',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36))*cmath.sin(TW)**2 + (ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1014 = Coupling(name = 'GC_1014',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36))*cmath.sin(TW)**2 + (ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1015 = Coupling(name = 'GC_1015',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36))*cmath.sin(TW)**2 + (ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1016 = Coupling(name = 'GC_1016',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36))*cmath.sin(TW)**2 + (ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1017 = Coupling(name = 'GC_1017',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36))*cmath.sin(TW)**2 + (ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1018 = Coupling(name = 'GC_1018',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36))*cmath.sin(TW)**2 + (ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1019 = Coupling(name = 'GC_1019',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46))*cmath.sin(TW)**2 + (ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1020 = Coupling(name = 'GC_1020',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46))*cmath.sin(TW)**2 + (ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1021 = Coupling(name = 'GC_1021',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46))*cmath.sin(TW)**2 + (ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1022 = Coupling(name = 'GC_1022',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46))*cmath.sin(TW)**2 + (ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1023 = Coupling(name = 'GC_1023',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46))*cmath.sin(TW)**2 + (ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1024 = Coupling(name = 'GC_1024',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46))*cmath.sin(TW)**2 + (ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1025 = Coupling(name = 'GC_1025',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56))*cmath.sin(TW)**2 + (ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1026 = Coupling(name = 'GC_1026',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56))*cmath.sin(TW)**2 + (ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1027 = Coupling(name = 'GC_1027',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56))*cmath.sin(TW)**2 + (ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1028 = Coupling(name = 'GC_1028',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56))*cmath.sin(TW)**2 + (ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1029 = Coupling(name = 'GC_1029',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56))*cmath.sin(TW)**2 + (ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1030 = Coupling(name = 'GC_1030',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56))*cmath.sin(TW)**2 + (ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1031 = Coupling(name = 'GC_1031',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66))*cmath.sin(TW)**2 + (ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1032 = Coupling(name = 'GC_1032',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66))*cmath.sin(TW)**2 + (ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1033 = Coupling(name = 'GC_1033',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66))*cmath.sin(TW)**2 + (ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1034 = Coupling(name = 'GC_1034',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66))*cmath.sin(TW)**2 + (ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1035 = Coupling(name = 'GC_1035',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66))*cmath.sin(TW)**2 + (ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1036 = Coupling(name = 'GC_1036',
	 value = '1./18.*complex(0,1)*(4*g1**2*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66))*cmath.sin(TW)**2 + (ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1037 = Coupling(name = 'GC_1037',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD11) + ZU12*complexconjugate(ZD12) + ZU13*complexconjugate(ZD13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1038 = Coupling(name = 'GC_1038',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD11) + ZU22*complexconjugate(ZD12) + ZU23*complexconjugate(ZD13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1039 = Coupling(name = 'GC_1039',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD11) + ZU32*complexconjugate(ZD12) + ZU33*complexconjugate(ZD13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1040 = Coupling(name = 'GC_1040',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD11) + ZU42*complexconjugate(ZD12) + ZU43*complexconjugate(ZD13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1041 = Coupling(name = 'GC_1041',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD11) + ZU52*complexconjugate(ZD12) + ZU53*complexconjugate(ZD13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1042 = Coupling(name = 'GC_1042',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD11) + ZU62*complexconjugate(ZD12) + ZU63*complexconjugate(ZD13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1043 = Coupling(name = 'GC_1043',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD21) + ZU12*complexconjugate(ZD22) + ZU13*complexconjugate(ZD23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1044 = Coupling(name = 'GC_1044',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD21) + ZU22*complexconjugate(ZD22) + ZU23*complexconjugate(ZD23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1045 = Coupling(name = 'GC_1045',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD21) + ZU32*complexconjugate(ZD22) + ZU33*complexconjugate(ZD23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1046 = Coupling(name = 'GC_1046',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD21) + ZU42*complexconjugate(ZD22) + ZU43*complexconjugate(ZD23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1047 = Coupling(name = 'GC_1047',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD21) + ZU52*complexconjugate(ZD22) + ZU53*complexconjugate(ZD23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1048 = Coupling(name = 'GC_1048',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD21) + ZU62*complexconjugate(ZD22) + ZU63*complexconjugate(ZD23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1049 = Coupling(name = 'GC_1049',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD31) + ZU12*complexconjugate(ZD32) + ZU13*complexconjugate(ZD33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1050 = Coupling(name = 'GC_1050',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD31) + ZU22*complexconjugate(ZD32) + ZU23*complexconjugate(ZD33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1051 = Coupling(name = 'GC_1051',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD31) + ZU32*complexconjugate(ZD32) + ZU33*complexconjugate(ZD33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1052 = Coupling(name = 'GC_1052',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD31) + ZU42*complexconjugate(ZD32) + ZU43*complexconjugate(ZD33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1053 = Coupling(name = 'GC_1053',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD31) + ZU52*complexconjugate(ZD32) + ZU53*complexconjugate(ZD33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1054 = Coupling(name = 'GC_1054',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD31) + ZU62*complexconjugate(ZD32) + ZU63*complexconjugate(ZD33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1055 = Coupling(name = 'GC_1055',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD41) + ZU12*complexconjugate(ZD42) + ZU13*complexconjugate(ZD43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1056 = Coupling(name = 'GC_1056',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD41) + ZU22*complexconjugate(ZD42) + ZU23*complexconjugate(ZD43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1057 = Coupling(name = 'GC_1057',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD41) + ZU32*complexconjugate(ZD42) + ZU33*complexconjugate(ZD43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1058 = Coupling(name = 'GC_1058',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD41) + ZU42*complexconjugate(ZD42) + ZU43*complexconjugate(ZD43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1059 = Coupling(name = 'GC_1059',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD41) + ZU52*complexconjugate(ZD42) + ZU53*complexconjugate(ZD43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1060 = Coupling(name = 'GC_1060',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD41) + ZU62*complexconjugate(ZD42) + ZU63*complexconjugate(ZD43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1061 = Coupling(name = 'GC_1061',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD51) + ZU12*complexconjugate(ZD52) + ZU13*complexconjugate(ZD53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1062 = Coupling(name = 'GC_1062',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD51) + ZU22*complexconjugate(ZD52) + ZU23*complexconjugate(ZD53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1063 = Coupling(name = 'GC_1063',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD51) + ZU32*complexconjugate(ZD52) + ZU33*complexconjugate(ZD53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1064 = Coupling(name = 'GC_1064',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD51) + ZU42*complexconjugate(ZD52) + ZU43*complexconjugate(ZD53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1065 = Coupling(name = 'GC_1065',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD51) + ZU52*complexconjugate(ZD52) + ZU53*complexconjugate(ZD53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1066 = Coupling(name = 'GC_1066',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD51) + ZU62*complexconjugate(ZD52) + ZU63*complexconjugate(ZD53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1067 = Coupling(name = 'GC_1067',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU11*complexconjugate(ZD61) + ZU12*complexconjugate(ZD62) + ZU13*complexconjugate(ZD63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1068 = Coupling(name = 'GC_1068',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU21*complexconjugate(ZD61) + ZU22*complexconjugate(ZD62) + ZU23*complexconjugate(ZD63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1069 = Coupling(name = 'GC_1069',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU31*complexconjugate(ZD61) + ZU32*complexconjugate(ZD62) + ZU33*complexconjugate(ZD63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1070 = Coupling(name = 'GC_1070',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU41*complexconjugate(ZD61) + ZU42*complexconjugate(ZD62) + ZU43*complexconjugate(ZD63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1071 = Coupling(name = 'GC_1071',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU51*complexconjugate(ZD61) + ZU52*complexconjugate(ZD62) + ZU53*complexconjugate(ZD63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1072 = Coupling(name = 'GC_1072',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZU61*complexconjugate(ZD61) + ZU62*complexconjugate(ZD62) + ZU63*complexconjugate(ZD63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1073 = Coupling(name = 'GC_1073',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE14) + ZE15*complexconjugate(ZE15) + ZE16*complexconjugate(ZE16))*cmath.cos(TW)**2 + (ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1074 = Coupling(name = 'GC_1074',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE14) + ZE25*complexconjugate(ZE15) + ZE26*complexconjugate(ZE16))*cmath.cos(TW)**2 + (ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1075 = Coupling(name = 'GC_1075',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE14) + ZE35*complexconjugate(ZE15) + ZE36*complexconjugate(ZE16))*cmath.cos(TW)**2 + (ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1076 = Coupling(name = 'GC_1076',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE14) + ZE45*complexconjugate(ZE15) + ZE46*complexconjugate(ZE16))*cmath.cos(TW)**2 + (ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1077 = Coupling(name = 'GC_1077',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE14) + ZE55*complexconjugate(ZE15) + ZE56*complexconjugate(ZE16))*cmath.cos(TW)**2 + (ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1078 = Coupling(name = 'GC_1078',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE14) + ZE65*complexconjugate(ZE15) + ZE66*complexconjugate(ZE16))*cmath.cos(TW)**2 + (ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1079 = Coupling(name = 'GC_1079',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE24) + ZE15*complexconjugate(ZE25) + ZE16*complexconjugate(ZE26))*cmath.cos(TW)**2 + (ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1080 = Coupling(name = 'GC_1080',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE24) + ZE25*complexconjugate(ZE25) + ZE26*complexconjugate(ZE26))*cmath.cos(TW)**2 + (ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1081 = Coupling(name = 'GC_1081',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE24) + ZE35*complexconjugate(ZE25) + ZE36*complexconjugate(ZE26))*cmath.cos(TW)**2 + (ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1082 = Coupling(name = 'GC_1082',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE24) + ZE45*complexconjugate(ZE25) + ZE46*complexconjugate(ZE26))*cmath.cos(TW)**2 + (ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1083 = Coupling(name = 'GC_1083',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE24) + ZE55*complexconjugate(ZE25) + ZE56*complexconjugate(ZE26))*cmath.cos(TW)**2 + (ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1084 = Coupling(name = 'GC_1084',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE24) + ZE65*complexconjugate(ZE25) + ZE66*complexconjugate(ZE26))*cmath.cos(TW)**2 + (ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1085 = Coupling(name = 'GC_1085',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE34) + ZE15*complexconjugate(ZE35) + ZE16*complexconjugate(ZE36))*cmath.cos(TW)**2 + (ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1086 = Coupling(name = 'GC_1086',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE34) + ZE25*complexconjugate(ZE35) + ZE26*complexconjugate(ZE36))*cmath.cos(TW)**2 + (ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1087 = Coupling(name = 'GC_1087',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE34) + ZE35*complexconjugate(ZE35) + ZE36*complexconjugate(ZE36))*cmath.cos(TW)**2 + (ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1088 = Coupling(name = 'GC_1088',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE34) + ZE45*complexconjugate(ZE35) + ZE46*complexconjugate(ZE36))*cmath.cos(TW)**2 + (ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1089 = Coupling(name = 'GC_1089',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE34) + ZE55*complexconjugate(ZE35) + ZE56*complexconjugate(ZE36))*cmath.cos(TW)**2 + (ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1090 = Coupling(name = 'GC_1090',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE34) + ZE65*complexconjugate(ZE35) + ZE66*complexconjugate(ZE36))*cmath.cos(TW)**2 + (ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1091 = Coupling(name = 'GC_1091',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE44) + ZE15*complexconjugate(ZE45) + ZE16*complexconjugate(ZE46))*cmath.cos(TW)**2 + (ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1092 = Coupling(name = 'GC_1092',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE44) + ZE25*complexconjugate(ZE45) + ZE26*complexconjugate(ZE46))*cmath.cos(TW)**2 + (ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1093 = Coupling(name = 'GC_1093',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE44) + ZE35*complexconjugate(ZE45) + ZE36*complexconjugate(ZE46))*cmath.cos(TW)**2 + (ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1094 = Coupling(name = 'GC_1094',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE44) + ZE45*complexconjugate(ZE45) + ZE46*complexconjugate(ZE46))*cmath.cos(TW)**2 + (ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1095 = Coupling(name = 'GC_1095',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE44) + ZE55*complexconjugate(ZE45) + ZE56*complexconjugate(ZE46))*cmath.cos(TW)**2 + (ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1096 = Coupling(name = 'GC_1096',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE44) + ZE65*complexconjugate(ZE45) + ZE66*complexconjugate(ZE46))*cmath.cos(TW)**2 + (ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1097 = Coupling(name = 'GC_1097',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE54) + ZE15*complexconjugate(ZE55) + ZE16*complexconjugate(ZE56))*cmath.cos(TW)**2 + (ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1098 = Coupling(name = 'GC_1098',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE54) + ZE25*complexconjugate(ZE55) + ZE26*complexconjugate(ZE56))*cmath.cos(TW)**2 + (ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1099 = Coupling(name = 'GC_1099',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE54) + ZE35*complexconjugate(ZE55) + ZE36*complexconjugate(ZE56))*cmath.cos(TW)**2 + (ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1100 = Coupling(name = 'GC_1100',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE54) + ZE45*complexconjugate(ZE55) + ZE46*complexconjugate(ZE56))*cmath.cos(TW)**2 + (ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1101 = Coupling(name = 'GC_1101',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE54) + ZE55*complexconjugate(ZE55) + ZE56*complexconjugate(ZE56))*cmath.cos(TW)**2 + (ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1102 = Coupling(name = 'GC_1102',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE54) + ZE65*complexconjugate(ZE55) + ZE66*complexconjugate(ZE56))*cmath.cos(TW)**2 + (ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1103 = Coupling(name = 'GC_1103',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE64) + ZE15*complexconjugate(ZE65) + ZE16*complexconjugate(ZE66))*cmath.cos(TW)**2 + (ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1104 = Coupling(name = 'GC_1104',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE64) + ZE25*complexconjugate(ZE65) + ZE26*complexconjugate(ZE66))*cmath.cos(TW)**2 + (ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1105 = Coupling(name = 'GC_1105',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE64) + ZE35*complexconjugate(ZE65) + ZE36*complexconjugate(ZE66))*cmath.cos(TW)**2 + (ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1106 = Coupling(name = 'GC_1106',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE64) + ZE45*complexconjugate(ZE65) + ZE46*complexconjugate(ZE66))*cmath.cos(TW)**2 + (ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1107 = Coupling(name = 'GC_1107',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE64) + ZE55*complexconjugate(ZE65) + ZE56*complexconjugate(ZE66))*cmath.cos(TW)**2 + (ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1108 = Coupling(name = 'GC_1108',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE64) + ZE65*complexconjugate(ZE65) + ZE66*complexconjugate(ZE66))*cmath.cos(TW)**2 + (ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1109 = Coupling(name = 'GC_1109',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE14) + ZE15*complexconjugate(ZE15) + ZE16*complexconjugate(ZE16))*cmath.sin(2*TW) + (ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1110 = Coupling(name = 'GC_1110',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE14) + ZE25*complexconjugate(ZE15) + ZE26*complexconjugate(ZE16))*cmath.sin(2*TW) + (ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1111 = Coupling(name = 'GC_1111',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE14) + ZE35*complexconjugate(ZE15) + ZE36*complexconjugate(ZE16))*cmath.sin(2*TW) + (ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1112 = Coupling(name = 'GC_1112',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE14) + ZE45*complexconjugate(ZE15) + ZE46*complexconjugate(ZE16))*cmath.sin(2*TW) + (ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1113 = Coupling(name = 'GC_1113',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE14) + ZE55*complexconjugate(ZE15) + ZE56*complexconjugate(ZE16))*cmath.sin(2*TW) + (ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1114 = Coupling(name = 'GC_1114',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE14) + ZE65*complexconjugate(ZE15) + ZE66*complexconjugate(ZE16))*cmath.sin(2*TW) + (ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1115 = Coupling(name = 'GC_1115',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE24) + ZE15*complexconjugate(ZE25) + ZE16*complexconjugate(ZE26))*cmath.sin(2*TW) + (ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1116 = Coupling(name = 'GC_1116',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE24) + ZE25*complexconjugate(ZE25) + ZE26*complexconjugate(ZE26))*cmath.sin(2*TW) + (ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1117 = Coupling(name = 'GC_1117',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE24) + ZE35*complexconjugate(ZE25) + ZE36*complexconjugate(ZE26))*cmath.sin(2*TW) + (ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1118 = Coupling(name = 'GC_1118',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE24) + ZE45*complexconjugate(ZE25) + ZE46*complexconjugate(ZE26))*cmath.sin(2*TW) + (ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1119 = Coupling(name = 'GC_1119',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE24) + ZE55*complexconjugate(ZE25) + ZE56*complexconjugate(ZE26))*cmath.sin(2*TW) + (ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1120 = Coupling(name = 'GC_1120',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE24) + ZE65*complexconjugate(ZE25) + ZE66*complexconjugate(ZE26))*cmath.sin(2*TW) + (ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1121 = Coupling(name = 'GC_1121',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE34) + ZE15*complexconjugate(ZE35) + ZE16*complexconjugate(ZE36))*cmath.sin(2*TW) + (ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1122 = Coupling(name = 'GC_1122',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE34) + ZE25*complexconjugate(ZE35) + ZE26*complexconjugate(ZE36))*cmath.sin(2*TW) + (ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1123 = Coupling(name = 'GC_1123',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE34) + ZE35*complexconjugate(ZE35) + ZE36*complexconjugate(ZE36))*cmath.sin(2*TW) + (ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1124 = Coupling(name = 'GC_1124',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE34) + ZE45*complexconjugate(ZE35) + ZE46*complexconjugate(ZE36))*cmath.sin(2*TW) + (ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1125 = Coupling(name = 'GC_1125',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE34) + ZE55*complexconjugate(ZE35) + ZE56*complexconjugate(ZE36))*cmath.sin(2*TW) + (ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1126 = Coupling(name = 'GC_1126',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE34) + ZE65*complexconjugate(ZE35) + ZE66*complexconjugate(ZE36))*cmath.sin(2*TW) + (ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1127 = Coupling(name = 'GC_1127',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE44) + ZE15*complexconjugate(ZE45) + ZE16*complexconjugate(ZE46))*cmath.sin(2*TW) + (ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1128 = Coupling(name = 'GC_1128',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE44) + ZE25*complexconjugate(ZE45) + ZE26*complexconjugate(ZE46))*cmath.sin(2*TW) + (ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1129 = Coupling(name = 'GC_1129',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE44) + ZE35*complexconjugate(ZE45) + ZE36*complexconjugate(ZE46))*cmath.sin(2*TW) + (ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1130 = Coupling(name = 'GC_1130',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE44) + ZE45*complexconjugate(ZE45) + ZE46*complexconjugate(ZE46))*cmath.sin(2*TW) + (ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1131 = Coupling(name = 'GC_1131',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE44) + ZE55*complexconjugate(ZE45) + ZE56*complexconjugate(ZE46))*cmath.sin(2*TW) + (ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1132 = Coupling(name = 'GC_1132',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE44) + ZE65*complexconjugate(ZE45) + ZE66*complexconjugate(ZE46))*cmath.sin(2*TW) + (ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1133 = Coupling(name = 'GC_1133',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE54) + ZE15*complexconjugate(ZE55) + ZE16*complexconjugate(ZE56))*cmath.sin(2*TW) + (ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1134 = Coupling(name = 'GC_1134',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE54) + ZE25*complexconjugate(ZE55) + ZE26*complexconjugate(ZE56))*cmath.sin(2*TW) + (ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1135 = Coupling(name = 'GC_1135',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE54) + ZE35*complexconjugate(ZE55) + ZE36*complexconjugate(ZE56))*cmath.sin(2*TW) + (ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1136 = Coupling(name = 'GC_1136',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE54) + ZE45*complexconjugate(ZE55) + ZE46*complexconjugate(ZE56))*cmath.sin(2*TW) + (ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1137 = Coupling(name = 'GC_1137',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE54) + ZE55*complexconjugate(ZE55) + ZE56*complexconjugate(ZE56))*cmath.sin(2*TW) + (ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1138 = Coupling(name = 'GC_1138',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE54) + ZE65*complexconjugate(ZE55) + ZE66*complexconjugate(ZE56))*cmath.sin(2*TW) + (ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1139 = Coupling(name = 'GC_1139',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE64) + ZE15*complexconjugate(ZE65) + ZE16*complexconjugate(ZE66))*cmath.sin(2*TW) + (ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1140 = Coupling(name = 'GC_1140',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE64) + ZE25*complexconjugate(ZE65) + ZE26*complexconjugate(ZE66))*cmath.sin(2*TW) + (ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1141 = Coupling(name = 'GC_1141',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE64) + ZE35*complexconjugate(ZE65) + ZE36*complexconjugate(ZE66))*cmath.sin(2*TW) + (ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1142 = Coupling(name = 'GC_1142',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE64) + ZE45*complexconjugate(ZE65) + ZE46*complexconjugate(ZE66))*cmath.sin(2*TW) + (ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1143 = Coupling(name = 'GC_1143',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE64) + ZE55*complexconjugate(ZE65) + ZE56*complexconjugate(ZE66))*cmath.sin(2*TW) + (ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1144 = Coupling(name = 'GC_1144',
	 value = '-1./4.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE64) + ZE65*complexconjugate(ZE65) + ZE66*complexconjugate(ZE66))*cmath.sin(2*TW) + (ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63))*(-2*g1*g2*cmath.cos(2*TW) + (g1**2 - g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1145 = Coupling(name = 'GC_1145',
	 value = '(-1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE11) + ZV12*complexconjugate(ZE12) + ZV13*complexconjugate(ZE13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1146 = Coupling(name = 'GC_1146',
	 value = '(-1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE11) + ZV22*complexconjugate(ZE12) + ZV23*complexconjugate(ZE13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1147 = Coupling(name = 'GC_1147',
	 value = '(-1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE11) + ZV32*complexconjugate(ZE12) + ZV33*complexconjugate(ZE13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1148 = Coupling(name = 'GC_1148',
	 value = '(-1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE21) + ZV12*complexconjugate(ZE22) + ZV13*complexconjugate(ZE23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1149 = Coupling(name = 'GC_1149',
	 value = '(-1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE21) + ZV22*complexconjugate(ZE22) + ZV23*complexconjugate(ZE23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1150 = Coupling(name = 'GC_1150',
	 value = '(-1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE21) + ZV32*complexconjugate(ZE22) + ZV33*complexconjugate(ZE23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1151 = Coupling(name = 'GC_1151',
	 value = '(-1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE31) + ZV12*complexconjugate(ZE32) + ZV13*complexconjugate(ZE33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1152 = Coupling(name = 'GC_1152',
	 value = '(-1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE31) + ZV22*complexconjugate(ZE32) + ZV23*complexconjugate(ZE33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1153 = Coupling(name = 'GC_1153',
	 value = '(-1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE31) + ZV32*complexconjugate(ZE32) + ZV33*complexconjugate(ZE33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1154 = Coupling(name = 'GC_1154',
	 value = '(-1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE41) + ZV12*complexconjugate(ZE42) + ZV13*complexconjugate(ZE43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1155 = Coupling(name = 'GC_1155',
	 value = '(-1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE41) + ZV22*complexconjugate(ZE42) + ZV23*complexconjugate(ZE43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1156 = Coupling(name = 'GC_1156',
	 value = '(-1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE41) + ZV32*complexconjugate(ZE42) + ZV33*complexconjugate(ZE43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1157 = Coupling(name = 'GC_1157',
	 value = '(-1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE51) + ZV12*complexconjugate(ZE52) + ZV13*complexconjugate(ZE53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1158 = Coupling(name = 'GC_1158',
	 value = '(-1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE51) + ZV22*complexconjugate(ZE52) + ZV23*complexconjugate(ZE53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1159 = Coupling(name = 'GC_1159',
	 value = '(-1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE51) + ZV32*complexconjugate(ZE52) + ZV33*complexconjugate(ZE53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1160 = Coupling(name = 'GC_1160',
	 value = '(-1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE61) + ZV12*complexconjugate(ZE62) + ZV13*complexconjugate(ZE63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1161 = Coupling(name = 'GC_1161',
	 value = '(-1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE61) + ZV22*complexconjugate(ZE62) + ZV23*complexconjugate(ZE63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1162 = Coupling(name = 'GC_1162',
	 value = '(-1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE61) + ZV32*complexconjugate(ZE62) + ZV33*complexconjugate(ZE63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1163 = Coupling(name = 'GC_1163',
	 value = '1./2.*complex(0,1)*g2**2*(ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13))', 
	 order = {'QED':2} ) 
 
GC_1164 = Coupling(name = 'GC_1164',
	 value = '1./2.*complex(0,1)*g2**2*(ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13))', 
	 order = {'QED':2} ) 
 
GC_1165 = Coupling(name = 'GC_1165',
	 value = '1./2.*complex(0,1)*g2**2*(ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13))', 
	 order = {'QED':2} ) 
 
GC_1166 = Coupling(name = 'GC_1166',
	 value = '1./2.*complex(0,1)*g2**2*(ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13))', 
	 order = {'QED':2} ) 
 
GC_1167 = Coupling(name = 'GC_1167',
	 value = '1./2.*complex(0,1)*g2**2*(ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13))', 
	 order = {'QED':2} ) 
 
GC_1168 = Coupling(name = 'GC_1168',
	 value = '1./2.*complex(0,1)*g2**2*(ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13))', 
	 order = {'QED':2} ) 
 
GC_1169 = Coupling(name = 'GC_1169',
	 value = '1./2.*complex(0,1)*g2**2*(ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23))', 
	 order = {'QED':2} ) 
 
GC_1170 = Coupling(name = 'GC_1170',
	 value = '1./2.*complex(0,1)*g2**2*(ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23))', 
	 order = {'QED':2} ) 
 
GC_1171 = Coupling(name = 'GC_1171',
	 value = '1./2.*complex(0,1)*g2**2*(ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23))', 
	 order = {'QED':2} ) 
 
GC_1172 = Coupling(name = 'GC_1172',
	 value = '1./2.*complex(0,1)*g2**2*(ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23))', 
	 order = {'QED':2} ) 
 
GC_1173 = Coupling(name = 'GC_1173',
	 value = '1./2.*complex(0,1)*g2**2*(ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23))', 
	 order = {'QED':2} ) 
 
GC_1174 = Coupling(name = 'GC_1174',
	 value = '1./2.*complex(0,1)*g2**2*(ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23))', 
	 order = {'QED':2} ) 
 
GC_1175 = Coupling(name = 'GC_1175',
	 value = '1./2.*complex(0,1)*g2**2*(ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33))', 
	 order = {'QED':2} ) 
 
GC_1176 = Coupling(name = 'GC_1176',
	 value = '1./2.*complex(0,1)*g2**2*(ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33))', 
	 order = {'QED':2} ) 
 
GC_1177 = Coupling(name = 'GC_1177',
	 value = '1./2.*complex(0,1)*g2**2*(ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33))', 
	 order = {'QED':2} ) 
 
GC_1178 = Coupling(name = 'GC_1178',
	 value = '1./2.*complex(0,1)*g2**2*(ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33))', 
	 order = {'QED':2} ) 
 
GC_1179 = Coupling(name = 'GC_1179',
	 value = '1./2.*complex(0,1)*g2**2*(ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33))', 
	 order = {'QED':2} ) 
 
GC_1180 = Coupling(name = 'GC_1180',
	 value = '1./2.*complex(0,1)*g2**2*(ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33))', 
	 order = {'QED':2} ) 
 
GC_1181 = Coupling(name = 'GC_1181',
	 value = '1./2.*complex(0,1)*g2**2*(ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43))', 
	 order = {'QED':2} ) 
 
GC_1182 = Coupling(name = 'GC_1182',
	 value = '1./2.*complex(0,1)*g2**2*(ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43))', 
	 order = {'QED':2} ) 
 
GC_1183 = Coupling(name = 'GC_1183',
	 value = '1./2.*complex(0,1)*g2**2*(ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43))', 
	 order = {'QED':2} ) 
 
GC_1184 = Coupling(name = 'GC_1184',
	 value = '1./2.*complex(0,1)*g2**2*(ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43))', 
	 order = {'QED':2} ) 
 
GC_1185 = Coupling(name = 'GC_1185',
	 value = '1./2.*complex(0,1)*g2**2*(ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43))', 
	 order = {'QED':2} ) 
 
GC_1186 = Coupling(name = 'GC_1186',
	 value = '1./2.*complex(0,1)*g2**2*(ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43))', 
	 order = {'QED':2} ) 
 
GC_1187 = Coupling(name = 'GC_1187',
	 value = '1./2.*complex(0,1)*g2**2*(ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53))', 
	 order = {'QED':2} ) 
 
GC_1188 = Coupling(name = 'GC_1188',
	 value = '1./2.*complex(0,1)*g2**2*(ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53))', 
	 order = {'QED':2} ) 
 
GC_1189 = Coupling(name = 'GC_1189',
	 value = '1./2.*complex(0,1)*g2**2*(ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53))', 
	 order = {'QED':2} ) 
 
GC_1190 = Coupling(name = 'GC_1190',
	 value = '1./2.*complex(0,1)*g2**2*(ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53))', 
	 order = {'QED':2} ) 
 
GC_1191 = Coupling(name = 'GC_1191',
	 value = '1./2.*complex(0,1)*g2**2*(ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53))', 
	 order = {'QED':2} ) 
 
GC_1192 = Coupling(name = 'GC_1192',
	 value = '1./2.*complex(0,1)*g2**2*(ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53))', 
	 order = {'QED':2} ) 
 
GC_1193 = Coupling(name = 'GC_1193',
	 value = '1./2.*complex(0,1)*g2**2*(ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63))', 
	 order = {'QED':2} ) 
 
GC_1194 = Coupling(name = 'GC_1194',
	 value = '1./2.*complex(0,1)*g2**2*(ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63))', 
	 order = {'QED':2} ) 
 
GC_1195 = Coupling(name = 'GC_1195',
	 value = '1./2.*complex(0,1)*g2**2*(ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63))', 
	 order = {'QED':2} ) 
 
GC_1196 = Coupling(name = 'GC_1196',
	 value = '1./2.*complex(0,1)*g2**2*(ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63))', 
	 order = {'QED':2} ) 
 
GC_1197 = Coupling(name = 'GC_1197',
	 value = '1./2.*complex(0,1)*g2**2*(ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63))', 
	 order = {'QED':2} ) 
 
GC_1198 = Coupling(name = 'GC_1198',
	 value = '1./2.*complex(0,1)*g2**2*(ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63))', 
	 order = {'QED':2} ) 
 
GC_1199 = Coupling(name = 'GC_1199',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE14) + ZE15*complexconjugate(ZE15) + ZE16*complexconjugate(ZE16))*cmath.sin(TW)**2 + (ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1200 = Coupling(name = 'GC_1200',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE14) + ZE25*complexconjugate(ZE15) + ZE26*complexconjugate(ZE16))*cmath.sin(TW)**2 + (ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1201 = Coupling(name = 'GC_1201',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE14) + ZE35*complexconjugate(ZE15) + ZE36*complexconjugate(ZE16))*cmath.sin(TW)**2 + (ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1202 = Coupling(name = 'GC_1202',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE14) + ZE45*complexconjugate(ZE15) + ZE46*complexconjugate(ZE16))*cmath.sin(TW)**2 + (ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1203 = Coupling(name = 'GC_1203',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE14) + ZE55*complexconjugate(ZE15) + ZE56*complexconjugate(ZE16))*cmath.sin(TW)**2 + (ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1204 = Coupling(name = 'GC_1204',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE14) + ZE65*complexconjugate(ZE15) + ZE66*complexconjugate(ZE16))*cmath.sin(TW)**2 + (ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1205 = Coupling(name = 'GC_1205',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE24) + ZE15*complexconjugate(ZE25) + ZE16*complexconjugate(ZE26))*cmath.sin(TW)**2 + (ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1206 = Coupling(name = 'GC_1206',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE24) + ZE25*complexconjugate(ZE25) + ZE26*complexconjugate(ZE26))*cmath.sin(TW)**2 + (ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1207 = Coupling(name = 'GC_1207',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE24) + ZE35*complexconjugate(ZE25) + ZE36*complexconjugate(ZE26))*cmath.sin(TW)**2 + (ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1208 = Coupling(name = 'GC_1208',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE24) + ZE45*complexconjugate(ZE25) + ZE46*complexconjugate(ZE26))*cmath.sin(TW)**2 + (ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1209 = Coupling(name = 'GC_1209',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE24) + ZE55*complexconjugate(ZE25) + ZE56*complexconjugate(ZE26))*cmath.sin(TW)**2 + (ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1210 = Coupling(name = 'GC_1210',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE24) + ZE65*complexconjugate(ZE25) + ZE66*complexconjugate(ZE26))*cmath.sin(TW)**2 + (ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1211 = Coupling(name = 'GC_1211',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE34) + ZE15*complexconjugate(ZE35) + ZE16*complexconjugate(ZE36))*cmath.sin(TW)**2 + (ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1212 = Coupling(name = 'GC_1212',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE34) + ZE25*complexconjugate(ZE35) + ZE26*complexconjugate(ZE36))*cmath.sin(TW)**2 + (ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1213 = Coupling(name = 'GC_1213',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE34) + ZE35*complexconjugate(ZE35) + ZE36*complexconjugate(ZE36))*cmath.sin(TW)**2 + (ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1214 = Coupling(name = 'GC_1214',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE34) + ZE45*complexconjugate(ZE35) + ZE46*complexconjugate(ZE36))*cmath.sin(TW)**2 + (ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1215 = Coupling(name = 'GC_1215',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE34) + ZE55*complexconjugate(ZE35) + ZE56*complexconjugate(ZE36))*cmath.sin(TW)**2 + (ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1216 = Coupling(name = 'GC_1216',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE34) + ZE65*complexconjugate(ZE35) + ZE66*complexconjugate(ZE36))*cmath.sin(TW)**2 + (ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1217 = Coupling(name = 'GC_1217',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE44) + ZE15*complexconjugate(ZE45) + ZE16*complexconjugate(ZE46))*cmath.sin(TW)**2 + (ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1218 = Coupling(name = 'GC_1218',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE44) + ZE25*complexconjugate(ZE45) + ZE26*complexconjugate(ZE46))*cmath.sin(TW)**2 + (ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1219 = Coupling(name = 'GC_1219',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE44) + ZE35*complexconjugate(ZE45) + ZE36*complexconjugate(ZE46))*cmath.sin(TW)**2 + (ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1220 = Coupling(name = 'GC_1220',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE44) + ZE45*complexconjugate(ZE45) + ZE46*complexconjugate(ZE46))*cmath.sin(TW)**2 + (ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1221 = Coupling(name = 'GC_1221',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE44) + ZE55*complexconjugate(ZE45) + ZE56*complexconjugate(ZE46))*cmath.sin(TW)**2 + (ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1222 = Coupling(name = 'GC_1222',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE44) + ZE65*complexconjugate(ZE45) + ZE66*complexconjugate(ZE46))*cmath.sin(TW)**2 + (ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1223 = Coupling(name = 'GC_1223',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE54) + ZE15*complexconjugate(ZE55) + ZE16*complexconjugate(ZE56))*cmath.sin(TW)**2 + (ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1224 = Coupling(name = 'GC_1224',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE54) + ZE25*complexconjugate(ZE55) + ZE26*complexconjugate(ZE56))*cmath.sin(TW)**2 + (ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1225 = Coupling(name = 'GC_1225',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE54) + ZE35*complexconjugate(ZE55) + ZE36*complexconjugate(ZE56))*cmath.sin(TW)**2 + (ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1226 = Coupling(name = 'GC_1226',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE54) + ZE45*complexconjugate(ZE55) + ZE46*complexconjugate(ZE56))*cmath.sin(TW)**2 + (ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1227 = Coupling(name = 'GC_1227',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE54) + ZE55*complexconjugate(ZE55) + ZE56*complexconjugate(ZE56))*cmath.sin(TW)**2 + (ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1228 = Coupling(name = 'GC_1228',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE54) + ZE65*complexconjugate(ZE55) + ZE66*complexconjugate(ZE56))*cmath.sin(TW)**2 + (ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1229 = Coupling(name = 'GC_1229',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE14*complexconjugate(ZE64) + ZE15*complexconjugate(ZE65) + ZE16*complexconjugate(ZE66))*cmath.sin(TW)**2 + (ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1230 = Coupling(name = 'GC_1230',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE24*complexconjugate(ZE64) + ZE25*complexconjugate(ZE65) + ZE26*complexconjugate(ZE66))*cmath.sin(TW)**2 + (ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1231 = Coupling(name = 'GC_1231',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE34*complexconjugate(ZE64) + ZE35*complexconjugate(ZE65) + ZE36*complexconjugate(ZE66))*cmath.sin(TW)**2 + (ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1232 = Coupling(name = 'GC_1232',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE44*complexconjugate(ZE64) + ZE45*complexconjugate(ZE65) + ZE46*complexconjugate(ZE66))*cmath.sin(TW)**2 + (ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1233 = Coupling(name = 'GC_1233',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE54*complexconjugate(ZE64) + ZE55*complexconjugate(ZE65) + ZE56*complexconjugate(ZE66))*cmath.sin(TW)**2 + (ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1234 = Coupling(name = 'GC_1234',
	 value = '1./2.*complex(0,1)*(4*g1**2*(ZE64*complexconjugate(ZE64) + ZE65*complexconjugate(ZE65) + ZE66*complexconjugate(ZE66))*cmath.sin(TW)**2 + (ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1235 = Coupling(name = 'GC_1235',
	 value = '(1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE11) + ZV12*complexconjugate(ZE12) + ZV13*complexconjugate(ZE13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1236 = Coupling(name = 'GC_1236',
	 value = '(1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE11) + ZV22*complexconjugate(ZE12) + ZV23*complexconjugate(ZE13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1237 = Coupling(name = 'GC_1237',
	 value = '(1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE11) + ZV32*complexconjugate(ZE12) + ZV33*complexconjugate(ZE13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1238 = Coupling(name = 'GC_1238',
	 value = '(1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE21) + ZV12*complexconjugate(ZE22) + ZV13*complexconjugate(ZE23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1239 = Coupling(name = 'GC_1239',
	 value = '(1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE21) + ZV22*complexconjugate(ZE22) + ZV23*complexconjugate(ZE23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1240 = Coupling(name = 'GC_1240',
	 value = '(1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE21) + ZV32*complexconjugate(ZE22) + ZV33*complexconjugate(ZE23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1241 = Coupling(name = 'GC_1241',
	 value = '(1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE31) + ZV12*complexconjugate(ZE32) + ZV13*complexconjugate(ZE33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1242 = Coupling(name = 'GC_1242',
	 value = '(1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE31) + ZV22*complexconjugate(ZE32) + ZV23*complexconjugate(ZE33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1243 = Coupling(name = 'GC_1243',
	 value = '(1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE31) + ZV32*complexconjugate(ZE32) + ZV33*complexconjugate(ZE33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1244 = Coupling(name = 'GC_1244',
	 value = '(1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE41) + ZV12*complexconjugate(ZE42) + ZV13*complexconjugate(ZE43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1245 = Coupling(name = 'GC_1245',
	 value = '(1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE41) + ZV22*complexconjugate(ZE42) + ZV23*complexconjugate(ZE43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1246 = Coupling(name = 'GC_1246',
	 value = '(1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE41) + ZV32*complexconjugate(ZE42) + ZV33*complexconjugate(ZE43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1247 = Coupling(name = 'GC_1247',
	 value = '(1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE51) + ZV12*complexconjugate(ZE52) + ZV13*complexconjugate(ZE53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1248 = Coupling(name = 'GC_1248',
	 value = '(1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE51) + ZV22*complexconjugate(ZE52) + ZV23*complexconjugate(ZE53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1249 = Coupling(name = 'GC_1249',
	 value = '(1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE51) + ZV32*complexconjugate(ZE52) + ZV33*complexconjugate(ZE53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1250 = Coupling(name = 'GC_1250',
	 value = '(1*complex(0,1)*g1*g2*(ZV11*complexconjugate(ZE61) + ZV12*complexconjugate(ZE62) + ZV13*complexconjugate(ZE63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1251 = Coupling(name = 'GC_1251',
	 value = '(1*complex(0,1)*g1*g2*(ZV21*complexconjugate(ZE61) + ZV22*complexconjugate(ZE62) + ZV23*complexconjugate(ZE63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1252 = Coupling(name = 'GC_1252',
	 value = '(1*complex(0,1)*g1*g2*(ZV31*complexconjugate(ZE61) + ZV32*complexconjugate(ZE62) + ZV33*complexconjugate(ZE63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1253 = Coupling(name = 'GC_1253',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1254 = Coupling(name = 'GC_1254',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1255 = Coupling(name = 'GC_1255',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1256 = Coupling(name = 'GC_1256',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1257 = Coupling(name = 'GC_1257',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1258 = Coupling(name = 'GC_1258',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1259 = Coupling(name = 'GC_1259',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1260 = Coupling(name = 'GC_1260',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1261 = Coupling(name = 'GC_1261',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1262 = Coupling(name = 'GC_1262',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1263 = Coupling(name = 'GC_1263',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1264 = Coupling(name = 'GC_1264',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_1265 = Coupling(name = 'GC_1265',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16))*cmath.cos(TW) + (ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1266 = Coupling(name = 'GC_1266',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16))*cmath.cos(TW) + (ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1267 = Coupling(name = 'GC_1267',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16))*cmath.cos(TW) + (ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1268 = Coupling(name = 'GC_1268',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16))*cmath.cos(TW) + (ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1269 = Coupling(name = 'GC_1269',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16))*cmath.cos(TW) + (ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1270 = Coupling(name = 'GC_1270',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16))*cmath.cos(TW) + (ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1271 = Coupling(name = 'GC_1271',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26))*cmath.cos(TW) + (ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1272 = Coupling(name = 'GC_1272',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26))*cmath.cos(TW) + (ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1273 = Coupling(name = 'GC_1273',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26))*cmath.cos(TW) + (ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1274 = Coupling(name = 'GC_1274',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26))*cmath.cos(TW) + (ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1275 = Coupling(name = 'GC_1275',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26))*cmath.cos(TW) + (ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1276 = Coupling(name = 'GC_1276',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26))*cmath.cos(TW) + (ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1277 = Coupling(name = 'GC_1277',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36))*cmath.cos(TW) + (ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1278 = Coupling(name = 'GC_1278',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36))*cmath.cos(TW) + (ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1279 = Coupling(name = 'GC_1279',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36))*cmath.cos(TW) + (ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1280 = Coupling(name = 'GC_1280',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36))*cmath.cos(TW) + (ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1281 = Coupling(name = 'GC_1281',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36))*cmath.cos(TW) + (ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1282 = Coupling(name = 'GC_1282',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36))*cmath.cos(TW) + (ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1283 = Coupling(name = 'GC_1283',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46))*cmath.cos(TW) + (ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1284 = Coupling(name = 'GC_1284',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46))*cmath.cos(TW) + (ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1285 = Coupling(name = 'GC_1285',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46))*cmath.cos(TW) + (ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1286 = Coupling(name = 'GC_1286',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46))*cmath.cos(TW) + (ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1287 = Coupling(name = 'GC_1287',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46))*cmath.cos(TW) + (ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1288 = Coupling(name = 'GC_1288',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46))*cmath.cos(TW) + (ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1289 = Coupling(name = 'GC_1289',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56))*cmath.cos(TW) + (ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1290 = Coupling(name = 'GC_1290',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56))*cmath.cos(TW) + (ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1291 = Coupling(name = 'GC_1291',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56))*cmath.cos(TW) + (ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1292 = Coupling(name = 'GC_1292',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56))*cmath.cos(TW) + (ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1293 = Coupling(name = 'GC_1293',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56))*cmath.cos(TW) + (ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1294 = Coupling(name = 'GC_1294',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56))*cmath.cos(TW) + (ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1295 = Coupling(name = 'GC_1295',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66))*cmath.cos(TW) + (ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1296 = Coupling(name = 'GC_1296',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66))*cmath.cos(TW) + (ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1297 = Coupling(name = 'GC_1297',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66))*cmath.cos(TW) + (ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1298 = Coupling(name = 'GC_1298',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66))*cmath.cos(TW) + (ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1299 = Coupling(name = 'GC_1299',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66))*cmath.cos(TW) + (ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1300 = Coupling(name = 'GC_1300',
	 value = '1./3.*complex(0,1)*G*(4*g1*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66))*cmath.cos(TW) + (ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1301 = Coupling(name = 'GC_1301',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD11*complexconjugate(ZU11) + ZD12*complexconjugate(ZU12) + ZD13*complexconjugate(ZU13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1302 = Coupling(name = 'GC_1302',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD21*complexconjugate(ZU11) + ZD22*complexconjugate(ZU12) + ZD23*complexconjugate(ZU13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1303 = Coupling(name = 'GC_1303',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD31*complexconjugate(ZU11) + ZD32*complexconjugate(ZU12) + ZD33*complexconjugate(ZU13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1304 = Coupling(name = 'GC_1304',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD41*complexconjugate(ZU11) + ZD42*complexconjugate(ZU12) + ZD43*complexconjugate(ZU13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1305 = Coupling(name = 'GC_1305',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD51*complexconjugate(ZU11) + ZD52*complexconjugate(ZU12) + ZD53*complexconjugate(ZU13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1306 = Coupling(name = 'GC_1306',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD61*complexconjugate(ZU11) + ZD62*complexconjugate(ZU12) + ZD63*complexconjugate(ZU13))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1307 = Coupling(name = 'GC_1307',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD11*complexconjugate(ZU21) + ZD12*complexconjugate(ZU22) + ZD13*complexconjugate(ZU23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1308 = Coupling(name = 'GC_1308',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD21*complexconjugate(ZU21) + ZD22*complexconjugate(ZU22) + ZD23*complexconjugate(ZU23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1309 = Coupling(name = 'GC_1309',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD31*complexconjugate(ZU21) + ZD32*complexconjugate(ZU22) + ZD33*complexconjugate(ZU23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1310 = Coupling(name = 'GC_1310',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD41*complexconjugate(ZU21) + ZD42*complexconjugate(ZU22) + ZD43*complexconjugate(ZU23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1311 = Coupling(name = 'GC_1311',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD51*complexconjugate(ZU21) + ZD52*complexconjugate(ZU22) + ZD53*complexconjugate(ZU23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1312 = Coupling(name = 'GC_1312',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD61*complexconjugate(ZU21) + ZD62*complexconjugate(ZU22) + ZD63*complexconjugate(ZU23))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1313 = Coupling(name = 'GC_1313',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD11*complexconjugate(ZU31) + ZD12*complexconjugate(ZU32) + ZD13*complexconjugate(ZU33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1314 = Coupling(name = 'GC_1314',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD21*complexconjugate(ZU31) + ZD22*complexconjugate(ZU32) + ZD23*complexconjugate(ZU33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1315 = Coupling(name = 'GC_1315',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD31*complexconjugate(ZU31) + ZD32*complexconjugate(ZU32) + ZD33*complexconjugate(ZU33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1316 = Coupling(name = 'GC_1316',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD41*complexconjugate(ZU31) + ZD42*complexconjugate(ZU32) + ZD43*complexconjugate(ZU33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1317 = Coupling(name = 'GC_1317',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD51*complexconjugate(ZU31) + ZD52*complexconjugate(ZU32) + ZD53*complexconjugate(ZU33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1318 = Coupling(name = 'GC_1318',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD61*complexconjugate(ZU31) + ZD62*complexconjugate(ZU32) + ZD63*complexconjugate(ZU33))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1319 = Coupling(name = 'GC_1319',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD11*complexconjugate(ZU41) + ZD12*complexconjugate(ZU42) + ZD13*complexconjugate(ZU43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1320 = Coupling(name = 'GC_1320',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD21*complexconjugate(ZU41) + ZD22*complexconjugate(ZU42) + ZD23*complexconjugate(ZU43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1321 = Coupling(name = 'GC_1321',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD31*complexconjugate(ZU41) + ZD32*complexconjugate(ZU42) + ZD33*complexconjugate(ZU43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1322 = Coupling(name = 'GC_1322',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD41*complexconjugate(ZU41) + ZD42*complexconjugate(ZU42) + ZD43*complexconjugate(ZU43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1323 = Coupling(name = 'GC_1323',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD51*complexconjugate(ZU41) + ZD52*complexconjugate(ZU42) + ZD53*complexconjugate(ZU43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1324 = Coupling(name = 'GC_1324',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD61*complexconjugate(ZU41) + ZD62*complexconjugate(ZU42) + ZD63*complexconjugate(ZU43))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1325 = Coupling(name = 'GC_1325',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD11*complexconjugate(ZU51) + ZD12*complexconjugate(ZU52) + ZD13*complexconjugate(ZU53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1326 = Coupling(name = 'GC_1326',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD21*complexconjugate(ZU51) + ZD22*complexconjugate(ZU52) + ZD23*complexconjugate(ZU53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1327 = Coupling(name = 'GC_1327',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD31*complexconjugate(ZU51) + ZD32*complexconjugate(ZU52) + ZD33*complexconjugate(ZU53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1328 = Coupling(name = 'GC_1328',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD41*complexconjugate(ZU51) + ZD42*complexconjugate(ZU52) + ZD43*complexconjugate(ZU53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1329 = Coupling(name = 'GC_1329',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD51*complexconjugate(ZU51) + ZD52*complexconjugate(ZU52) + ZD53*complexconjugate(ZU53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1330 = Coupling(name = 'GC_1330',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD61*complexconjugate(ZU51) + ZD62*complexconjugate(ZU52) + ZD63*complexconjugate(ZU53))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1331 = Coupling(name = 'GC_1331',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD11*complexconjugate(ZU61) + ZD12*complexconjugate(ZU62) + ZD13*complexconjugate(ZU63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1332 = Coupling(name = 'GC_1332',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD21*complexconjugate(ZU61) + ZD22*complexconjugate(ZU62) + ZD23*complexconjugate(ZU63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1333 = Coupling(name = 'GC_1333',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD31*complexconjugate(ZU61) + ZD32*complexconjugate(ZU62) + ZD33*complexconjugate(ZU63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1334 = Coupling(name = 'GC_1334',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD41*complexconjugate(ZU61) + ZD42*complexconjugate(ZU62) + ZD43*complexconjugate(ZU63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1335 = Coupling(name = 'GC_1335',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD51*complexconjugate(ZU61) + ZD52*complexconjugate(ZU62) + ZD53*complexconjugate(ZU63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1336 = Coupling(name = 'GC_1336',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*g2*(ZD61*complexconjugate(ZU61) + ZD62*complexconjugate(ZU62) + ZD63*complexconjugate(ZU63))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1337 = Coupling(name = 'GC_1337',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16))*cmath.sin(TW) + (ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1338 = Coupling(name = 'GC_1338',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16))*cmath.sin(TW) + (ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1339 = Coupling(name = 'GC_1339',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16))*cmath.sin(TW) + (ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1340 = Coupling(name = 'GC_1340',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16))*cmath.sin(TW) + (ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1341 = Coupling(name = 'GC_1341',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16))*cmath.sin(TW) + (ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1342 = Coupling(name = 'GC_1342',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16))*cmath.sin(TW) + (ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1343 = Coupling(name = 'GC_1343',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26))*cmath.sin(TW) + (ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1344 = Coupling(name = 'GC_1344',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26))*cmath.sin(TW) + (ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1345 = Coupling(name = 'GC_1345',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26))*cmath.sin(TW) + (ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1346 = Coupling(name = 'GC_1346',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26))*cmath.sin(TW) + (ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1347 = Coupling(name = 'GC_1347',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26))*cmath.sin(TW) + (ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1348 = Coupling(name = 'GC_1348',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26))*cmath.sin(TW) + (ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1349 = Coupling(name = 'GC_1349',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36))*cmath.sin(TW) + (ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1350 = Coupling(name = 'GC_1350',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36))*cmath.sin(TW) + (ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1351 = Coupling(name = 'GC_1351',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36))*cmath.sin(TW) + (ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1352 = Coupling(name = 'GC_1352',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36))*cmath.sin(TW) + (ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1353 = Coupling(name = 'GC_1353',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36))*cmath.sin(TW) + (ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1354 = Coupling(name = 'GC_1354',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36))*cmath.sin(TW) + (ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1355 = Coupling(name = 'GC_1355',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46))*cmath.sin(TW) + (ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1356 = Coupling(name = 'GC_1356',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46))*cmath.sin(TW) + (ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1357 = Coupling(name = 'GC_1357',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46))*cmath.sin(TW) + (ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1358 = Coupling(name = 'GC_1358',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46))*cmath.sin(TW) + (ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1359 = Coupling(name = 'GC_1359',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46))*cmath.sin(TW) + (ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1360 = Coupling(name = 'GC_1360',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46))*cmath.sin(TW) + (ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1361 = Coupling(name = 'GC_1361',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56))*cmath.sin(TW) + (ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1362 = Coupling(name = 'GC_1362',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56))*cmath.sin(TW) + (ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1363 = Coupling(name = 'GC_1363',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56))*cmath.sin(TW) + (ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1364 = Coupling(name = 'GC_1364',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56))*cmath.sin(TW) + (ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1365 = Coupling(name = 'GC_1365',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56))*cmath.sin(TW) + (ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1366 = Coupling(name = 'GC_1366',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56))*cmath.sin(TW) + (ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1367 = Coupling(name = 'GC_1367',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66))*cmath.sin(TW) + (ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1368 = Coupling(name = 'GC_1368',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66))*cmath.sin(TW) + (ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1369 = Coupling(name = 'GC_1369',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66))*cmath.sin(TW) + (ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1370 = Coupling(name = 'GC_1370',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66))*cmath.sin(TW) + (ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1371 = Coupling(name = 'GC_1371',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66))*cmath.sin(TW) + (ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1372 = Coupling(name = 'GC_1372',
	 value = '1./3.*complex(0,1)*G*(-4*g1*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66))*cmath.sin(TW) + (ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1, 'QCD':1} ) 
 
GC_1373 = Coupling(name = 'GC_1373',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16))*cmath.cos(TW)**2 + (ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1374 = Coupling(name = 'GC_1374',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16))*cmath.cos(TW)**2 + (ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1375 = Coupling(name = 'GC_1375',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16))*cmath.cos(TW)**2 + (ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1376 = Coupling(name = 'GC_1376',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16))*cmath.cos(TW)**2 + (ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1377 = Coupling(name = 'GC_1377',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16))*cmath.cos(TW)**2 + (ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1378 = Coupling(name = 'GC_1378',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16))*cmath.cos(TW)**2 + (ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1379 = Coupling(name = 'GC_1379',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26))*cmath.cos(TW)**2 + (ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1380 = Coupling(name = 'GC_1380',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26))*cmath.cos(TW)**2 + (ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1381 = Coupling(name = 'GC_1381',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26))*cmath.cos(TW)**2 + (ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1382 = Coupling(name = 'GC_1382',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26))*cmath.cos(TW)**2 + (ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1383 = Coupling(name = 'GC_1383',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26))*cmath.cos(TW)**2 + (ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1384 = Coupling(name = 'GC_1384',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26))*cmath.cos(TW)**2 + (ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1385 = Coupling(name = 'GC_1385',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36))*cmath.cos(TW)**2 + (ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1386 = Coupling(name = 'GC_1386',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36))*cmath.cos(TW)**2 + (ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1387 = Coupling(name = 'GC_1387',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36))*cmath.cos(TW)**2 + (ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1388 = Coupling(name = 'GC_1388',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36))*cmath.cos(TW)**2 + (ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1389 = Coupling(name = 'GC_1389',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36))*cmath.cos(TW)**2 + (ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1390 = Coupling(name = 'GC_1390',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36))*cmath.cos(TW)**2 + (ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1391 = Coupling(name = 'GC_1391',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46))*cmath.cos(TW)**2 + (ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1392 = Coupling(name = 'GC_1392',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46))*cmath.cos(TW)**2 + (ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1393 = Coupling(name = 'GC_1393',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46))*cmath.cos(TW)**2 + (ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1394 = Coupling(name = 'GC_1394',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46))*cmath.cos(TW)**2 + (ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1395 = Coupling(name = 'GC_1395',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46))*cmath.cos(TW)**2 + (ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1396 = Coupling(name = 'GC_1396',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46))*cmath.cos(TW)**2 + (ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1397 = Coupling(name = 'GC_1397',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56))*cmath.cos(TW)**2 + (ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1398 = Coupling(name = 'GC_1398',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56))*cmath.cos(TW)**2 + (ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1399 = Coupling(name = 'GC_1399',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56))*cmath.cos(TW)**2 + (ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1400 = Coupling(name = 'GC_1400',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56))*cmath.cos(TW)**2 + (ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1401 = Coupling(name = 'GC_1401',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56))*cmath.cos(TW)**2 + (ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1402 = Coupling(name = 'GC_1402',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56))*cmath.cos(TW)**2 + (ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1403 = Coupling(name = 'GC_1403',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66))*cmath.cos(TW)**2 + (ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1404 = Coupling(name = 'GC_1404',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66))*cmath.cos(TW)**2 + (ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1405 = Coupling(name = 'GC_1405',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66))*cmath.cos(TW)**2 + (ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1406 = Coupling(name = 'GC_1406',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66))*cmath.cos(TW)**2 + (ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1407 = Coupling(name = 'GC_1407',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66))*cmath.cos(TW)**2 + (ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1408 = Coupling(name = 'GC_1408',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66))*cmath.cos(TW)**2 + (ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1409 = Coupling(name = 'GC_1409',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU11) + ZD12*complexconjugate(ZU12) + ZD13*complexconjugate(ZU13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1410 = Coupling(name = 'GC_1410',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU11) + ZD22*complexconjugate(ZU12) + ZD23*complexconjugate(ZU13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1411 = Coupling(name = 'GC_1411',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU11) + ZD32*complexconjugate(ZU12) + ZD33*complexconjugate(ZU13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1412 = Coupling(name = 'GC_1412',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU11) + ZD42*complexconjugate(ZU12) + ZD43*complexconjugate(ZU13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1413 = Coupling(name = 'GC_1413',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU11) + ZD52*complexconjugate(ZU12) + ZD53*complexconjugate(ZU13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1414 = Coupling(name = 'GC_1414',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU11) + ZD62*complexconjugate(ZU12) + ZD63*complexconjugate(ZU13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1415 = Coupling(name = 'GC_1415',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU21) + ZD12*complexconjugate(ZU22) + ZD13*complexconjugate(ZU23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1416 = Coupling(name = 'GC_1416',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU21) + ZD22*complexconjugate(ZU22) + ZD23*complexconjugate(ZU23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1417 = Coupling(name = 'GC_1417',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU21) + ZD32*complexconjugate(ZU22) + ZD33*complexconjugate(ZU23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1418 = Coupling(name = 'GC_1418',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU21) + ZD42*complexconjugate(ZU22) + ZD43*complexconjugate(ZU23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1419 = Coupling(name = 'GC_1419',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU21) + ZD52*complexconjugate(ZU22) + ZD53*complexconjugate(ZU23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1420 = Coupling(name = 'GC_1420',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU21) + ZD62*complexconjugate(ZU22) + ZD63*complexconjugate(ZU23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1421 = Coupling(name = 'GC_1421',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU31) + ZD12*complexconjugate(ZU32) + ZD13*complexconjugate(ZU33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1422 = Coupling(name = 'GC_1422',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU31) + ZD22*complexconjugate(ZU32) + ZD23*complexconjugate(ZU33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1423 = Coupling(name = 'GC_1423',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU31) + ZD32*complexconjugate(ZU32) + ZD33*complexconjugate(ZU33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1424 = Coupling(name = 'GC_1424',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU31) + ZD42*complexconjugate(ZU32) + ZD43*complexconjugate(ZU33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1425 = Coupling(name = 'GC_1425',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU31) + ZD52*complexconjugate(ZU32) + ZD53*complexconjugate(ZU33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1426 = Coupling(name = 'GC_1426',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU31) + ZD62*complexconjugate(ZU32) + ZD63*complexconjugate(ZU33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1427 = Coupling(name = 'GC_1427',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU41) + ZD12*complexconjugate(ZU42) + ZD13*complexconjugate(ZU43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1428 = Coupling(name = 'GC_1428',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU41) + ZD22*complexconjugate(ZU42) + ZD23*complexconjugate(ZU43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1429 = Coupling(name = 'GC_1429',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU41) + ZD32*complexconjugate(ZU42) + ZD33*complexconjugate(ZU43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1430 = Coupling(name = 'GC_1430',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU41) + ZD42*complexconjugate(ZU42) + ZD43*complexconjugate(ZU43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1431 = Coupling(name = 'GC_1431',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU41) + ZD52*complexconjugate(ZU42) + ZD53*complexconjugate(ZU43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1432 = Coupling(name = 'GC_1432',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU41) + ZD62*complexconjugate(ZU42) + ZD63*complexconjugate(ZU43))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1433 = Coupling(name = 'GC_1433',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU51) + ZD12*complexconjugate(ZU52) + ZD13*complexconjugate(ZU53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1434 = Coupling(name = 'GC_1434',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU51) + ZD22*complexconjugate(ZU52) + ZD23*complexconjugate(ZU53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1435 = Coupling(name = 'GC_1435',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU51) + ZD32*complexconjugate(ZU52) + ZD33*complexconjugate(ZU53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1436 = Coupling(name = 'GC_1436',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU51) + ZD42*complexconjugate(ZU52) + ZD43*complexconjugate(ZU53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1437 = Coupling(name = 'GC_1437',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU51) + ZD52*complexconjugate(ZU52) + ZD53*complexconjugate(ZU53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1438 = Coupling(name = 'GC_1438',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU51) + ZD62*complexconjugate(ZU52) + ZD63*complexconjugate(ZU53))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1439 = Coupling(name = 'GC_1439',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU61) + ZD12*complexconjugate(ZU62) + ZD13*complexconjugate(ZU63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1440 = Coupling(name = 'GC_1440',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU61) + ZD22*complexconjugate(ZU62) + ZD23*complexconjugate(ZU63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1441 = Coupling(name = 'GC_1441',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU61) + ZD32*complexconjugate(ZU62) + ZD33*complexconjugate(ZU63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1442 = Coupling(name = 'GC_1442',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU61) + ZD42*complexconjugate(ZU62) + ZD43*complexconjugate(ZU63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1443 = Coupling(name = 'GC_1443',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU61) + ZD52*complexconjugate(ZU62) + ZD53*complexconjugate(ZU63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1444 = Coupling(name = 'GC_1444',
	 value = '(1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU61) + ZD62*complexconjugate(ZU62) + ZD63*complexconjugate(ZU63))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1445 = Coupling(name = 'GC_1445',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16))*cmath.sin(2*TW) + (ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1446 = Coupling(name = 'GC_1446',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16))*cmath.sin(2*TW) + (ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1447 = Coupling(name = 'GC_1447',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16))*cmath.sin(2*TW) + (ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1448 = Coupling(name = 'GC_1448',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16))*cmath.sin(2*TW) + (ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1449 = Coupling(name = 'GC_1449',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16))*cmath.sin(2*TW) + (ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1450 = Coupling(name = 'GC_1450',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16))*cmath.sin(2*TW) + (ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1451 = Coupling(name = 'GC_1451',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26))*cmath.sin(2*TW) + (ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1452 = Coupling(name = 'GC_1452',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26))*cmath.sin(2*TW) + (ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1453 = Coupling(name = 'GC_1453',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26))*cmath.sin(2*TW) + (ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1454 = Coupling(name = 'GC_1454',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26))*cmath.sin(2*TW) + (ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1455 = Coupling(name = 'GC_1455',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26))*cmath.sin(2*TW) + (ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1456 = Coupling(name = 'GC_1456',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26))*cmath.sin(2*TW) + (ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1457 = Coupling(name = 'GC_1457',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36))*cmath.sin(2*TW) + (ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1458 = Coupling(name = 'GC_1458',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36))*cmath.sin(2*TW) + (ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1459 = Coupling(name = 'GC_1459',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36))*cmath.sin(2*TW) + (ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1460 = Coupling(name = 'GC_1460',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36))*cmath.sin(2*TW) + (ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1461 = Coupling(name = 'GC_1461',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36))*cmath.sin(2*TW) + (ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1462 = Coupling(name = 'GC_1462',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36))*cmath.sin(2*TW) + (ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1463 = Coupling(name = 'GC_1463',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46))*cmath.sin(2*TW) + (ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1464 = Coupling(name = 'GC_1464',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46))*cmath.sin(2*TW) + (ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1465 = Coupling(name = 'GC_1465',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46))*cmath.sin(2*TW) + (ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1466 = Coupling(name = 'GC_1466',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46))*cmath.sin(2*TW) + (ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1467 = Coupling(name = 'GC_1467',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46))*cmath.sin(2*TW) + (ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1468 = Coupling(name = 'GC_1468',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46))*cmath.sin(2*TW) + (ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1469 = Coupling(name = 'GC_1469',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56))*cmath.sin(2*TW) + (ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1470 = Coupling(name = 'GC_1470',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56))*cmath.sin(2*TW) + (ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1471 = Coupling(name = 'GC_1471',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56))*cmath.sin(2*TW) + (ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1472 = Coupling(name = 'GC_1472',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56))*cmath.sin(2*TW) + (ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1473 = Coupling(name = 'GC_1473',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56))*cmath.sin(2*TW) + (ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1474 = Coupling(name = 'GC_1474',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56))*cmath.sin(2*TW) + (ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1475 = Coupling(name = 'GC_1475',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66))*cmath.sin(2*TW) + (ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1476 = Coupling(name = 'GC_1476',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66))*cmath.sin(2*TW) + (ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1477 = Coupling(name = 'GC_1477',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66))*cmath.sin(2*TW) + (ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1478 = Coupling(name = 'GC_1478',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66))*cmath.sin(2*TW) + (ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1479 = Coupling(name = 'GC_1479',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66))*cmath.sin(2*TW) + (ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1480 = Coupling(name = 'GC_1480',
	 value = '-1./36.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66))*cmath.sin(2*TW) + (ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))*(-6*g1*g2*cmath.cos(2*TW) + (g1**2 - 9*g2**2)*cmath.sin(2*TW)))', 
	 order = {'QED':2} ) 
 
GC_1481 = Coupling(name = 'GC_1481',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU11) + ZD12*complexconjugate(ZU12) + ZD13*complexconjugate(ZU13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1482 = Coupling(name = 'GC_1482',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU11) + ZD22*complexconjugate(ZU12) + ZD23*complexconjugate(ZU13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1483 = Coupling(name = 'GC_1483',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU11) + ZD32*complexconjugate(ZU12) + ZD33*complexconjugate(ZU13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1484 = Coupling(name = 'GC_1484',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU11) + ZD42*complexconjugate(ZU12) + ZD43*complexconjugate(ZU13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1485 = Coupling(name = 'GC_1485',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU11) + ZD52*complexconjugate(ZU12) + ZD53*complexconjugate(ZU13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1486 = Coupling(name = 'GC_1486',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU11) + ZD62*complexconjugate(ZU12) + ZD63*complexconjugate(ZU13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1487 = Coupling(name = 'GC_1487',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU21) + ZD12*complexconjugate(ZU22) + ZD13*complexconjugate(ZU23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1488 = Coupling(name = 'GC_1488',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU21) + ZD22*complexconjugate(ZU22) + ZD23*complexconjugate(ZU23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1489 = Coupling(name = 'GC_1489',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU21) + ZD32*complexconjugate(ZU22) + ZD33*complexconjugate(ZU23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1490 = Coupling(name = 'GC_1490',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU21) + ZD42*complexconjugate(ZU22) + ZD43*complexconjugate(ZU23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1491 = Coupling(name = 'GC_1491',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU21) + ZD52*complexconjugate(ZU22) + ZD53*complexconjugate(ZU23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1492 = Coupling(name = 'GC_1492',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU21) + ZD62*complexconjugate(ZU22) + ZD63*complexconjugate(ZU23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1493 = Coupling(name = 'GC_1493',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU31) + ZD12*complexconjugate(ZU32) + ZD13*complexconjugate(ZU33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1494 = Coupling(name = 'GC_1494',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU31) + ZD22*complexconjugate(ZU32) + ZD23*complexconjugate(ZU33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1495 = Coupling(name = 'GC_1495',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU31) + ZD32*complexconjugate(ZU32) + ZD33*complexconjugate(ZU33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1496 = Coupling(name = 'GC_1496',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU31) + ZD42*complexconjugate(ZU32) + ZD43*complexconjugate(ZU33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1497 = Coupling(name = 'GC_1497',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU31) + ZD52*complexconjugate(ZU32) + ZD53*complexconjugate(ZU33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1498 = Coupling(name = 'GC_1498',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU31) + ZD62*complexconjugate(ZU32) + ZD63*complexconjugate(ZU33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1499 = Coupling(name = 'GC_1499',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU41) + ZD12*complexconjugate(ZU42) + ZD13*complexconjugate(ZU43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1500 = Coupling(name = 'GC_1500',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU41) + ZD22*complexconjugate(ZU42) + ZD23*complexconjugate(ZU43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1501 = Coupling(name = 'GC_1501',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU41) + ZD32*complexconjugate(ZU42) + ZD33*complexconjugate(ZU43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1502 = Coupling(name = 'GC_1502',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU41) + ZD42*complexconjugate(ZU42) + ZD43*complexconjugate(ZU43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1503 = Coupling(name = 'GC_1503',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU41) + ZD52*complexconjugate(ZU42) + ZD53*complexconjugate(ZU43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1504 = Coupling(name = 'GC_1504',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU41) + ZD62*complexconjugate(ZU42) + ZD63*complexconjugate(ZU43))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1505 = Coupling(name = 'GC_1505',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU51) + ZD12*complexconjugate(ZU52) + ZD13*complexconjugate(ZU53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1506 = Coupling(name = 'GC_1506',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU51) + ZD22*complexconjugate(ZU52) + ZD23*complexconjugate(ZU53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1507 = Coupling(name = 'GC_1507',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU51) + ZD32*complexconjugate(ZU52) + ZD33*complexconjugate(ZU53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1508 = Coupling(name = 'GC_1508',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU51) + ZD42*complexconjugate(ZU52) + ZD43*complexconjugate(ZU53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1509 = Coupling(name = 'GC_1509',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU51) + ZD52*complexconjugate(ZU52) + ZD53*complexconjugate(ZU53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1510 = Coupling(name = 'GC_1510',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU51) + ZD62*complexconjugate(ZU52) + ZD63*complexconjugate(ZU53))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1511 = Coupling(name = 'GC_1511',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD11*complexconjugate(ZU61) + ZD12*complexconjugate(ZU62) + ZD13*complexconjugate(ZU63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1512 = Coupling(name = 'GC_1512',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD21*complexconjugate(ZU61) + ZD22*complexconjugate(ZU62) + ZD23*complexconjugate(ZU63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1513 = Coupling(name = 'GC_1513',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD31*complexconjugate(ZU61) + ZD32*complexconjugate(ZU62) + ZD33*complexconjugate(ZU63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1514 = Coupling(name = 'GC_1514',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD41*complexconjugate(ZU61) + ZD42*complexconjugate(ZU62) + ZD43*complexconjugate(ZU63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1515 = Coupling(name = 'GC_1515',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD51*complexconjugate(ZU61) + ZD52*complexconjugate(ZU62) + ZD53*complexconjugate(ZU63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1516 = Coupling(name = 'GC_1516',
	 value = '(-1./3.*complex(0,1)*g1*g2*(ZD61*complexconjugate(ZU61) + ZD62*complexconjugate(ZU62) + ZD63*complexconjugate(ZU63))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1517 = Coupling(name = 'GC_1517',
	 value = '1./2.*complex(0,1)*g2**2*(ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))', 
	 order = {'QED':2} ) 
 
GC_1518 = Coupling(name = 'GC_1518',
	 value = '1./2.*complex(0,1)*g2**2*(ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))', 
	 order = {'QED':2} ) 
 
GC_1519 = Coupling(name = 'GC_1519',
	 value = '1./2.*complex(0,1)*g2**2*(ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))', 
	 order = {'QED':2} ) 
 
GC_1520 = Coupling(name = 'GC_1520',
	 value = '1./2.*complex(0,1)*g2**2*(ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))', 
	 order = {'QED':2} ) 
 
GC_1521 = Coupling(name = 'GC_1521',
	 value = '1./2.*complex(0,1)*g2**2*(ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))', 
	 order = {'QED':2} ) 
 
GC_1522 = Coupling(name = 'GC_1522',
	 value = '1./2.*complex(0,1)*g2**2*(ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))', 
	 order = {'QED':2} ) 
 
GC_1523 = Coupling(name = 'GC_1523',
	 value = '1./2.*complex(0,1)*g2**2*(ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))', 
	 order = {'QED':2} ) 
 
GC_1524 = Coupling(name = 'GC_1524',
	 value = '1./2.*complex(0,1)*g2**2*(ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))', 
	 order = {'QED':2} ) 
 
GC_1525 = Coupling(name = 'GC_1525',
	 value = '1./2.*complex(0,1)*g2**2*(ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))', 
	 order = {'QED':2} ) 
 
GC_1526 = Coupling(name = 'GC_1526',
	 value = '1./2.*complex(0,1)*g2**2*(ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))', 
	 order = {'QED':2} ) 
 
GC_1527 = Coupling(name = 'GC_1527',
	 value = '1./2.*complex(0,1)*g2**2*(ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))', 
	 order = {'QED':2} ) 
 
GC_1528 = Coupling(name = 'GC_1528',
	 value = '1./2.*complex(0,1)*g2**2*(ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))', 
	 order = {'QED':2} ) 
 
GC_1529 = Coupling(name = 'GC_1529',
	 value = '1./2.*complex(0,1)*g2**2*(ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))', 
	 order = {'QED':2} ) 
 
GC_1530 = Coupling(name = 'GC_1530',
	 value = '1./2.*complex(0,1)*g2**2*(ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))', 
	 order = {'QED':2} ) 
 
GC_1531 = Coupling(name = 'GC_1531',
	 value = '1./2.*complex(0,1)*g2**2*(ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))', 
	 order = {'QED':2} ) 
 
GC_1532 = Coupling(name = 'GC_1532',
	 value = '1./2.*complex(0,1)*g2**2*(ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))', 
	 order = {'QED':2} ) 
 
GC_1533 = Coupling(name = 'GC_1533',
	 value = '1./2.*complex(0,1)*g2**2*(ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))', 
	 order = {'QED':2} ) 
 
GC_1534 = Coupling(name = 'GC_1534',
	 value = '1./2.*complex(0,1)*g2**2*(ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))', 
	 order = {'QED':2} ) 
 
GC_1535 = Coupling(name = 'GC_1535',
	 value = '1./2.*complex(0,1)*g2**2*(ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))', 
	 order = {'QED':2} ) 
 
GC_1536 = Coupling(name = 'GC_1536',
	 value = '1./2.*complex(0,1)*g2**2*(ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))', 
	 order = {'QED':2} ) 
 
GC_1537 = Coupling(name = 'GC_1537',
	 value = '1./2.*complex(0,1)*g2**2*(ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))', 
	 order = {'QED':2} ) 
 
GC_1538 = Coupling(name = 'GC_1538',
	 value = '1./2.*complex(0,1)*g2**2*(ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))', 
	 order = {'QED':2} ) 
 
GC_1539 = Coupling(name = 'GC_1539',
	 value = '1./2.*complex(0,1)*g2**2*(ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))', 
	 order = {'QED':2} ) 
 
GC_1540 = Coupling(name = 'GC_1540',
	 value = '1./2.*complex(0,1)*g2**2*(ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))', 
	 order = {'QED':2} ) 
 
GC_1541 = Coupling(name = 'GC_1541',
	 value = '1./2.*complex(0,1)*g2**2*(ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))', 
	 order = {'QED':2} ) 
 
GC_1542 = Coupling(name = 'GC_1542',
	 value = '1./2.*complex(0,1)*g2**2*(ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))', 
	 order = {'QED':2} ) 
 
GC_1543 = Coupling(name = 'GC_1543',
	 value = '1./2.*complex(0,1)*g2**2*(ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))', 
	 order = {'QED':2} ) 
 
GC_1544 = Coupling(name = 'GC_1544',
	 value = '1./2.*complex(0,1)*g2**2*(ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))', 
	 order = {'QED':2} ) 
 
GC_1545 = Coupling(name = 'GC_1545',
	 value = '1./2.*complex(0,1)*g2**2*(ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))', 
	 order = {'QED':2} ) 
 
GC_1546 = Coupling(name = 'GC_1546',
	 value = '1./2.*complex(0,1)*g2**2*(ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))', 
	 order = {'QED':2} ) 
 
GC_1547 = Coupling(name = 'GC_1547',
	 value = '1./2.*complex(0,1)*g2**2*(ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))', 
	 order = {'QED':2} ) 
 
GC_1548 = Coupling(name = 'GC_1548',
	 value = '1./2.*complex(0,1)*g2**2*(ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))', 
	 order = {'QED':2} ) 
 
GC_1549 = Coupling(name = 'GC_1549',
	 value = '1./2.*complex(0,1)*g2**2*(ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))', 
	 order = {'QED':2} ) 
 
GC_1550 = Coupling(name = 'GC_1550',
	 value = '1./2.*complex(0,1)*g2**2*(ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))', 
	 order = {'QED':2} ) 
 
GC_1551 = Coupling(name = 'GC_1551',
	 value = '1./2.*complex(0,1)*g2**2*(ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))', 
	 order = {'QED':2} ) 
 
GC_1552 = Coupling(name = 'GC_1552',
	 value = '1./2.*complex(0,1)*g2**2*(ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))', 
	 order = {'QED':2} ) 
 
GC_1553 = Coupling(name = 'GC_1553',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16))*cmath.sin(TW)**2 + (ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1554 = Coupling(name = 'GC_1554',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16))*cmath.sin(TW)**2 + (ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1555 = Coupling(name = 'GC_1555',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16))*cmath.sin(TW)**2 + (ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1556 = Coupling(name = 'GC_1556',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16))*cmath.sin(TW)**2 + (ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1557 = Coupling(name = 'GC_1557',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16))*cmath.sin(TW)**2 + (ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1558 = Coupling(name = 'GC_1558',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16))*cmath.sin(TW)**2 + (ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1559 = Coupling(name = 'GC_1559',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26))*cmath.sin(TW)**2 + (ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1560 = Coupling(name = 'GC_1560',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26))*cmath.sin(TW)**2 + (ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1561 = Coupling(name = 'GC_1561',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26))*cmath.sin(TW)**2 + (ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1562 = Coupling(name = 'GC_1562',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26))*cmath.sin(TW)**2 + (ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1563 = Coupling(name = 'GC_1563',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26))*cmath.sin(TW)**2 + (ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1564 = Coupling(name = 'GC_1564',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26))*cmath.sin(TW)**2 + (ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1565 = Coupling(name = 'GC_1565',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36))*cmath.sin(TW)**2 + (ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1566 = Coupling(name = 'GC_1566',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36))*cmath.sin(TW)**2 + (ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1567 = Coupling(name = 'GC_1567',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36))*cmath.sin(TW)**2 + (ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1568 = Coupling(name = 'GC_1568',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36))*cmath.sin(TW)**2 + (ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1569 = Coupling(name = 'GC_1569',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36))*cmath.sin(TW)**2 + (ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1570 = Coupling(name = 'GC_1570',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36))*cmath.sin(TW)**2 + (ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1571 = Coupling(name = 'GC_1571',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46))*cmath.sin(TW)**2 + (ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1572 = Coupling(name = 'GC_1572',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46))*cmath.sin(TW)**2 + (ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1573 = Coupling(name = 'GC_1573',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46))*cmath.sin(TW)**2 + (ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1574 = Coupling(name = 'GC_1574',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46))*cmath.sin(TW)**2 + (ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1575 = Coupling(name = 'GC_1575',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46))*cmath.sin(TW)**2 + (ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1576 = Coupling(name = 'GC_1576',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46))*cmath.sin(TW)**2 + (ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1577 = Coupling(name = 'GC_1577',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56))*cmath.sin(TW)**2 + (ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1578 = Coupling(name = 'GC_1578',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56))*cmath.sin(TW)**2 + (ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1579 = Coupling(name = 'GC_1579',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56))*cmath.sin(TW)**2 + (ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1580 = Coupling(name = 'GC_1580',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56))*cmath.sin(TW)**2 + (ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1581 = Coupling(name = 'GC_1581',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56))*cmath.sin(TW)**2 + (ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1582 = Coupling(name = 'GC_1582',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56))*cmath.sin(TW)**2 + (ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1583 = Coupling(name = 'GC_1583',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66))*cmath.sin(TW)**2 + (ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1584 = Coupling(name = 'GC_1584',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66))*cmath.sin(TW)**2 + (ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1585 = Coupling(name = 'GC_1585',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66))*cmath.sin(TW)**2 + (ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1586 = Coupling(name = 'GC_1586',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66))*cmath.sin(TW)**2 + (ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1587 = Coupling(name = 'GC_1587',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66))*cmath.sin(TW)**2 + (ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1588 = Coupling(name = 'GC_1588',
	 value = '1./18.*complex(0,1)*(16*g1**2*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66))*cmath.sin(TW)**2 + (ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))*(-3*g2*cmath.cos(TW) + g1*cmath.sin(TW))**2)', 
	 order = {'QED':2} ) 
 
GC_1589 = Coupling(name = 'GC_1589',
	 value = '(-1*complex(0,1)*g1*g2*(ZE11*complexconjugate(ZV11) + ZE12*complexconjugate(ZV12) + ZE13*complexconjugate(ZV13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1590 = Coupling(name = 'GC_1590',
	 value = '(-1*complex(0,1)*g1*g2*(ZE21*complexconjugate(ZV11) + ZE22*complexconjugate(ZV12) + ZE23*complexconjugate(ZV13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1591 = Coupling(name = 'GC_1591',
	 value = '(-1*complex(0,1)*g1*g2*(ZE31*complexconjugate(ZV11) + ZE32*complexconjugate(ZV12) + ZE33*complexconjugate(ZV13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1592 = Coupling(name = 'GC_1592',
	 value = '(-1*complex(0,1)*g1*g2*(ZE41*complexconjugate(ZV11) + ZE42*complexconjugate(ZV12) + ZE43*complexconjugate(ZV13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1593 = Coupling(name = 'GC_1593',
	 value = '(-1*complex(0,1)*g1*g2*(ZE51*complexconjugate(ZV11) + ZE52*complexconjugate(ZV12) + ZE53*complexconjugate(ZV13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1594 = Coupling(name = 'GC_1594',
	 value = '(-1*complex(0,1)*g1*g2*(ZE61*complexconjugate(ZV11) + ZE62*complexconjugate(ZV12) + ZE63*complexconjugate(ZV13))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1595 = Coupling(name = 'GC_1595',
	 value = '(-1*complex(0,1)*g1*g2*(ZE11*complexconjugate(ZV21) + ZE12*complexconjugate(ZV22) + ZE13*complexconjugate(ZV23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1596 = Coupling(name = 'GC_1596',
	 value = '(-1*complex(0,1)*g1*g2*(ZE21*complexconjugate(ZV21) + ZE22*complexconjugate(ZV22) + ZE23*complexconjugate(ZV23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1597 = Coupling(name = 'GC_1597',
	 value = '(-1*complex(0,1)*g1*g2*(ZE31*complexconjugate(ZV21) + ZE32*complexconjugate(ZV22) + ZE33*complexconjugate(ZV23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1598 = Coupling(name = 'GC_1598',
	 value = '(-1*complex(0,1)*g1*g2*(ZE41*complexconjugate(ZV21) + ZE42*complexconjugate(ZV22) + ZE43*complexconjugate(ZV23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1599 = Coupling(name = 'GC_1599',
	 value = '(-1*complex(0,1)*g1*g2*(ZE51*complexconjugate(ZV21) + ZE52*complexconjugate(ZV22) + ZE53*complexconjugate(ZV23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1600 = Coupling(name = 'GC_1600',
	 value = '(-1*complex(0,1)*g1*g2*(ZE61*complexconjugate(ZV21) + ZE62*complexconjugate(ZV22) + ZE63*complexconjugate(ZV23))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1601 = Coupling(name = 'GC_1601',
	 value = '(-1*complex(0,1)*g1*g2*(ZE11*complexconjugate(ZV31) + ZE12*complexconjugate(ZV32) + ZE13*complexconjugate(ZV33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1602 = Coupling(name = 'GC_1602',
	 value = '(-1*complex(0,1)*g1*g2*(ZE21*complexconjugate(ZV31) + ZE22*complexconjugate(ZV32) + ZE23*complexconjugate(ZV33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1603 = Coupling(name = 'GC_1603',
	 value = '(-1*complex(0,1)*g1*g2*(ZE31*complexconjugate(ZV31) + ZE32*complexconjugate(ZV32) + ZE33*complexconjugate(ZV33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1604 = Coupling(name = 'GC_1604',
	 value = '(-1*complex(0,1)*g1*g2*(ZE41*complexconjugate(ZV31) + ZE42*complexconjugate(ZV32) + ZE43*complexconjugate(ZV33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1605 = Coupling(name = 'GC_1605',
	 value = '(-1*complex(0,1)*g1*g2*(ZE51*complexconjugate(ZV31) + ZE52*complexconjugate(ZV32) + ZE53*complexconjugate(ZV33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1606 = Coupling(name = 'GC_1606',
	 value = '(-1*complex(0,1)*g1*g2*(ZE61*complexconjugate(ZV31) + ZE62*complexconjugate(ZV32) + ZE63*complexconjugate(ZV33))*cmath.cos(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1607 = Coupling(name = 'GC_1607',
	 value = '(1*complex(0,1)*g1*g2*(ZE11*complexconjugate(ZV11) + ZE12*complexconjugate(ZV12) + ZE13*complexconjugate(ZV13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1608 = Coupling(name = 'GC_1608',
	 value = '(1*complex(0,1)*g1*g2*(ZE21*complexconjugate(ZV11) + ZE22*complexconjugate(ZV12) + ZE23*complexconjugate(ZV13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1609 = Coupling(name = 'GC_1609',
	 value = '(1*complex(0,1)*g1*g2*(ZE31*complexconjugate(ZV11) + ZE32*complexconjugate(ZV12) + ZE33*complexconjugate(ZV13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1610 = Coupling(name = 'GC_1610',
	 value = '(1*complex(0,1)*g1*g2*(ZE41*complexconjugate(ZV11) + ZE42*complexconjugate(ZV12) + ZE43*complexconjugate(ZV13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1611 = Coupling(name = 'GC_1611',
	 value = '(1*complex(0,1)*g1*g2*(ZE51*complexconjugate(ZV11) + ZE52*complexconjugate(ZV12) + ZE53*complexconjugate(ZV13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1612 = Coupling(name = 'GC_1612',
	 value = '(1*complex(0,1)*g1*g2*(ZE61*complexconjugate(ZV11) + ZE62*complexconjugate(ZV12) + ZE63*complexconjugate(ZV13))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1613 = Coupling(name = 'GC_1613',
	 value = '(1*complex(0,1)*g1*g2*(ZE11*complexconjugate(ZV21) + ZE12*complexconjugate(ZV22) + ZE13*complexconjugate(ZV23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1614 = Coupling(name = 'GC_1614',
	 value = '(1*complex(0,1)*g1*g2*(ZE21*complexconjugate(ZV21) + ZE22*complexconjugate(ZV22) + ZE23*complexconjugate(ZV23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1615 = Coupling(name = 'GC_1615',
	 value = '(1*complex(0,1)*g1*g2*(ZE31*complexconjugate(ZV21) + ZE32*complexconjugate(ZV22) + ZE33*complexconjugate(ZV23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1616 = Coupling(name = 'GC_1616',
	 value = '(1*complex(0,1)*g1*g2*(ZE41*complexconjugate(ZV21) + ZE42*complexconjugate(ZV22) + ZE43*complexconjugate(ZV23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1617 = Coupling(name = 'GC_1617',
	 value = '(1*complex(0,1)*g1*g2*(ZE51*complexconjugate(ZV21) + ZE52*complexconjugate(ZV22) + ZE53*complexconjugate(ZV23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1618 = Coupling(name = 'GC_1618',
	 value = '(1*complex(0,1)*g1*g2*(ZE61*complexconjugate(ZV21) + ZE62*complexconjugate(ZV22) + ZE63*complexconjugate(ZV23))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1619 = Coupling(name = 'GC_1619',
	 value = '(1*complex(0,1)*g1*g2*(ZE11*complexconjugate(ZV31) + ZE12*complexconjugate(ZV32) + ZE13*complexconjugate(ZV33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1620 = Coupling(name = 'GC_1620',
	 value = '(1*complex(0,1)*g1*g2*(ZE21*complexconjugate(ZV31) + ZE22*complexconjugate(ZV32) + ZE23*complexconjugate(ZV33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1621 = Coupling(name = 'GC_1621',
	 value = '(1*complex(0,1)*g1*g2*(ZE31*complexconjugate(ZV31) + ZE32*complexconjugate(ZV32) + ZE33*complexconjugate(ZV33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1622 = Coupling(name = 'GC_1622',
	 value = '(1*complex(0,1)*g1*g2*(ZE41*complexconjugate(ZV31) + ZE42*complexconjugate(ZV32) + ZE43*complexconjugate(ZV33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1623 = Coupling(name = 'GC_1623',
	 value = '(1*complex(0,1)*g1*g2*(ZE51*complexconjugate(ZV31) + ZE52*complexconjugate(ZV32) + ZE53*complexconjugate(ZV33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1624 = Coupling(name = 'GC_1624',
	 value = '(1*complex(0,1)*g1*g2*(ZE61*complexconjugate(ZV31) + ZE62*complexconjugate(ZV32) + ZE63*complexconjugate(ZV33))*cmath.sin(TW))/cmath.sqrt(2)', 
	 order = {'QED':2} ) 
 
GC_1625 = Coupling(name = 'GC_1625',
	 value = '1./2.*complex(0,1)*g2**2', 
	 order = {'QED':2} ) 
 
GC_1626 = Coupling(name = 'GC_1626',
	 value = '1./2.*complex(0,1)*g2**2', 
	 order = {'QED':2} ) 
 
GC_1627 = Coupling(name = 'GC_1627',
	 value = '1./2.*complex(0,1)*g2**2', 
	 order = {'QED':2} ) 
 
GC_1628 = Coupling(name = 'GC_1628',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_1629 = Coupling(name = 'GC_1629',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_1630 = Coupling(name = 'GC_1630',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':2} ) 
 
GC_1631 = Coupling(name = 'GC_1631',
	 value = '-((ZA11*ZH11 - ZA12*ZH12)*(g2*cmath.cos(TW) + g1*cmath.sin(TW)))/2.', 
	 order = {'QED':1} ) 
 
GC_1632 = Coupling(name = 'GC_1632',
	 value = '-((ZA11*ZH21 - ZA12*ZH22)*(g2*cmath.cos(TW) + g1*cmath.sin(TW)))/2.', 
	 order = {'QED':1} ) 
 
GC_1633 = Coupling(name = 'GC_1633',
	 value = '-((ZA21*ZH11 - ZA22*ZH12)*(g2*cmath.cos(TW) + g1*cmath.sin(TW)))/2.', 
	 order = {'QED':1} ) 
 
GC_1634 = Coupling(name = 'GC_1634',
	 value = '-((ZA21*ZH21 - ZA22*ZH22)*(g2*cmath.cos(TW) + g1*cmath.sin(TW)))/2.', 
	 order = {'QED':1} ) 
 
GC_1635 = Coupling(name = 'GC_1635',
	 value = '-(g2*(ZA11*ZP11 + ZA12*ZP12))/2.', 
	 order = {'QED':1} ) 
 
GC_1636 = Coupling(name = 'GC_1636',
	 value = '-(g2*(ZA11*ZP21 + ZA12*ZP22))/2.', 
	 order = {'QED':1} ) 
 
GC_1637 = Coupling(name = 'GC_1637',
	 value = '-(g2*(ZA21*ZP11 + ZA22*ZP12))/2.', 
	 order = {'QED':1} ) 
 
GC_1638 = Coupling(name = 'GC_1638',
	 value = '-(g2*(ZA21*ZP21 + ZA22*ZP22))/2.', 
	 order = {'QED':1} ) 
 
GC_1639 = Coupling(name = 'GC_1639',
	 value = '-(g2*(ZA11*ZP11 + ZA12*ZP12))/2.', 
	 order = {'QED':1} ) 
 
GC_1640 = Coupling(name = 'GC_1640',
	 value = '-(g2*(ZA11*ZP21 + ZA12*ZP22))/2.', 
	 order = {'QED':1} ) 
 
GC_1641 = Coupling(name = 'GC_1641',
	 value = '-(g2*(ZA21*ZP11 + ZA22*ZP12))/2.', 
	 order = {'QED':1} ) 
 
GC_1642 = Coupling(name = 'GC_1642',
	 value = '-(g2*(ZA21*ZP21 + ZA22*ZP22))/2.', 
	 order = {'QED':1} ) 
 
GC_1643 = Coupling(name = 'GC_1643',
	 value = '-1./2.*complex(0,1)*g2*(ZH11*ZP11 - ZH12*ZP12)', 
	 order = {'QED':1} ) 
 
GC_1644 = Coupling(name = 'GC_1644',
	 value = '-1./2.*complex(0,1)*g2*(ZH11*ZP21 - ZH12*ZP22)', 
	 order = {'QED':1} ) 
 
GC_1645 = Coupling(name = 'GC_1645',
	 value = '-1./2.*complex(0,1)*g2*(ZH21*ZP11 - ZH22*ZP12)', 
	 order = {'QED':1} ) 
 
GC_1646 = Coupling(name = 'GC_1646',
	 value = '-1./2.*complex(0,1)*g2*(ZH21*ZP21 - ZH22*ZP22)', 
	 order = {'QED':1} ) 
 
GC_1647 = Coupling(name = 'GC_1647',
	 value = '1./2.*complex(0,1)*g2*(ZH11*ZP11 - ZH12*ZP12)', 
	 order = {'QED':1} ) 
 
GC_1648 = Coupling(name = 'GC_1648',
	 value = '1./2.*complex(0,1)*g2*(ZH11*ZP21 - ZH12*ZP22)', 
	 order = {'QED':1} ) 
 
GC_1649 = Coupling(name = 'GC_1649',
	 value = '1./2.*complex(0,1)*g2*(ZH21*ZP11 - ZH22*ZP12)', 
	 order = {'QED':1} ) 
 
GC_1650 = Coupling(name = 'GC_1650',
	 value = '1./2.*complex(0,1)*g2*(ZH21*ZP21 - ZH22*ZP22)', 
	 order = {'QED':1} ) 
 
GC_1651 = Coupling(name = 'GC_1651',
	 value = '-1./2.*complex(0,1)*(ZP11**2 + ZP12**2)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1652 = Coupling(name = 'GC_1652',
	 value = '-1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1653 = Coupling(name = 'GC_1653',
	 value = '-1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1654 = Coupling(name = 'GC_1654',
	 value = '-1./2.*complex(0,1)*(ZP21**2 + ZP22**2)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1655 = Coupling(name = 'GC_1655',
	 value = '-1./2.*complex(0,1)*(ZP11**2 + ZP12**2)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1656 = Coupling(name = 'GC_1656',
	 value = '-1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1657 = Coupling(name = 'GC_1657',
	 value = '-1./2.*complex(0,1)*(ZP11*ZP21 + ZP12*ZP22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1658 = Coupling(name = 'GC_1658',
	 value = '-1./2.*complex(0,1)*(ZP21**2 + ZP22**2)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1659 = Coupling(name = 'GC_1659',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1660 = Coupling(name = 'GC_1660',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1661 = Coupling(name = 'GC_1661',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1662 = Coupling(name = 'GC_1662',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1663 = Coupling(name = 'GC_1663',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1664 = Coupling(name = 'GC_1664',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1665 = Coupling(name = 'GC_1665',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16))*cmath.cos(TW) + (ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1666 = Coupling(name = 'GC_1666',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16))*cmath.cos(TW) + (ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1667 = Coupling(name = 'GC_1667',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16))*cmath.cos(TW) + (ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1668 = Coupling(name = 'GC_1668',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16))*cmath.cos(TW) + (ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1669 = Coupling(name = 'GC_1669',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16))*cmath.cos(TW) + (ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1670 = Coupling(name = 'GC_1670',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16))*cmath.cos(TW) + (ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1671 = Coupling(name = 'GC_1671',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26))*cmath.cos(TW) + (ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1672 = Coupling(name = 'GC_1672',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26))*cmath.cos(TW) + (ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1673 = Coupling(name = 'GC_1673',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26))*cmath.cos(TW) + (ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1674 = Coupling(name = 'GC_1674',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26))*cmath.cos(TW) + (ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1675 = Coupling(name = 'GC_1675',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26))*cmath.cos(TW) + (ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1676 = Coupling(name = 'GC_1676',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26))*cmath.cos(TW) + (ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1677 = Coupling(name = 'GC_1677',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36))*cmath.cos(TW) + (ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1678 = Coupling(name = 'GC_1678',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36))*cmath.cos(TW) + (ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1679 = Coupling(name = 'GC_1679',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36))*cmath.cos(TW) + (ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1680 = Coupling(name = 'GC_1680',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36))*cmath.cos(TW) + (ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1681 = Coupling(name = 'GC_1681',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36))*cmath.cos(TW) + (ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1682 = Coupling(name = 'GC_1682',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36))*cmath.cos(TW) + (ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1683 = Coupling(name = 'GC_1683',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46))*cmath.cos(TW) + (ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1684 = Coupling(name = 'GC_1684',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46))*cmath.cos(TW) + (ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1685 = Coupling(name = 'GC_1685',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46))*cmath.cos(TW) + (ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1686 = Coupling(name = 'GC_1686',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46))*cmath.cos(TW) + (ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1687 = Coupling(name = 'GC_1687',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46))*cmath.cos(TW) + (ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1688 = Coupling(name = 'GC_1688',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46))*cmath.cos(TW) + (ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1689 = Coupling(name = 'GC_1689',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56))*cmath.cos(TW) + (ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1690 = Coupling(name = 'GC_1690',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56))*cmath.cos(TW) + (ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1691 = Coupling(name = 'GC_1691',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56))*cmath.cos(TW) + (ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1692 = Coupling(name = 'GC_1692',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56))*cmath.cos(TW) + (ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1693 = Coupling(name = 'GC_1693',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56))*cmath.cos(TW) + (ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1694 = Coupling(name = 'GC_1694',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56))*cmath.cos(TW) + (ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1695 = Coupling(name = 'GC_1695',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66))*cmath.cos(TW) + (ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1696 = Coupling(name = 'GC_1696',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66))*cmath.cos(TW) + (ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1697 = Coupling(name = 'GC_1697',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66))*cmath.cos(TW) + (ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1698 = Coupling(name = 'GC_1698',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66))*cmath.cos(TW) + (ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1699 = Coupling(name = 'GC_1699',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66))*cmath.cos(TW) + (ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1700 = Coupling(name = 'GC_1700',
	 value = '1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66))*cmath.cos(TW) + (ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1701 = Coupling(name = 'GC_1701',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD14) + ZD15*complexconjugate(ZD15) + ZD16*complexconjugate(ZD16))*cmath.sin(TW) + (ZD11*complexconjugate(ZD11) + ZD12*complexconjugate(ZD12) + ZD13*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1702 = Coupling(name = 'GC_1702',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD14) + ZD25*complexconjugate(ZD15) + ZD26*complexconjugate(ZD16))*cmath.sin(TW) + (ZD21*complexconjugate(ZD11) + ZD22*complexconjugate(ZD12) + ZD23*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1703 = Coupling(name = 'GC_1703',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD14) + ZD35*complexconjugate(ZD15) + ZD36*complexconjugate(ZD16))*cmath.sin(TW) + (ZD31*complexconjugate(ZD11) + ZD32*complexconjugate(ZD12) + ZD33*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1704 = Coupling(name = 'GC_1704',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD14) + ZD45*complexconjugate(ZD15) + ZD46*complexconjugate(ZD16))*cmath.sin(TW) + (ZD41*complexconjugate(ZD11) + ZD42*complexconjugate(ZD12) + ZD43*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1705 = Coupling(name = 'GC_1705',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD14) + ZD55*complexconjugate(ZD15) + ZD56*complexconjugate(ZD16))*cmath.sin(TW) + (ZD51*complexconjugate(ZD11) + ZD52*complexconjugate(ZD12) + ZD53*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1706 = Coupling(name = 'GC_1706',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD14) + ZD65*complexconjugate(ZD15) + ZD66*complexconjugate(ZD16))*cmath.sin(TW) + (ZD61*complexconjugate(ZD11) + ZD62*complexconjugate(ZD12) + ZD63*complexconjugate(ZD13))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1707 = Coupling(name = 'GC_1707',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD24) + ZD15*complexconjugate(ZD25) + ZD16*complexconjugate(ZD26))*cmath.sin(TW) + (ZD11*complexconjugate(ZD21) + ZD12*complexconjugate(ZD22) + ZD13*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1708 = Coupling(name = 'GC_1708',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD24) + ZD25*complexconjugate(ZD25) + ZD26*complexconjugate(ZD26))*cmath.sin(TW) + (ZD21*complexconjugate(ZD21) + ZD22*complexconjugate(ZD22) + ZD23*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1709 = Coupling(name = 'GC_1709',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD24) + ZD35*complexconjugate(ZD25) + ZD36*complexconjugate(ZD26))*cmath.sin(TW) + (ZD31*complexconjugate(ZD21) + ZD32*complexconjugate(ZD22) + ZD33*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1710 = Coupling(name = 'GC_1710',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD24) + ZD45*complexconjugate(ZD25) + ZD46*complexconjugate(ZD26))*cmath.sin(TW) + (ZD41*complexconjugate(ZD21) + ZD42*complexconjugate(ZD22) + ZD43*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1711 = Coupling(name = 'GC_1711',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD24) + ZD55*complexconjugate(ZD25) + ZD56*complexconjugate(ZD26))*cmath.sin(TW) + (ZD51*complexconjugate(ZD21) + ZD52*complexconjugate(ZD22) + ZD53*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1712 = Coupling(name = 'GC_1712',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD24) + ZD65*complexconjugate(ZD25) + ZD66*complexconjugate(ZD26))*cmath.sin(TW) + (ZD61*complexconjugate(ZD21) + ZD62*complexconjugate(ZD22) + ZD63*complexconjugate(ZD23))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1713 = Coupling(name = 'GC_1713',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD34) + ZD15*complexconjugate(ZD35) + ZD16*complexconjugate(ZD36))*cmath.sin(TW) + (ZD11*complexconjugate(ZD31) + ZD12*complexconjugate(ZD32) + ZD13*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1714 = Coupling(name = 'GC_1714',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD34) + ZD25*complexconjugate(ZD35) + ZD26*complexconjugate(ZD36))*cmath.sin(TW) + (ZD21*complexconjugate(ZD31) + ZD22*complexconjugate(ZD32) + ZD23*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1715 = Coupling(name = 'GC_1715',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD34) + ZD35*complexconjugate(ZD35) + ZD36*complexconjugate(ZD36))*cmath.sin(TW) + (ZD31*complexconjugate(ZD31) + ZD32*complexconjugate(ZD32) + ZD33*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1716 = Coupling(name = 'GC_1716',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD34) + ZD45*complexconjugate(ZD35) + ZD46*complexconjugate(ZD36))*cmath.sin(TW) + (ZD41*complexconjugate(ZD31) + ZD42*complexconjugate(ZD32) + ZD43*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1717 = Coupling(name = 'GC_1717',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD34) + ZD55*complexconjugate(ZD35) + ZD56*complexconjugate(ZD36))*cmath.sin(TW) + (ZD51*complexconjugate(ZD31) + ZD52*complexconjugate(ZD32) + ZD53*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1718 = Coupling(name = 'GC_1718',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD34) + ZD65*complexconjugate(ZD35) + ZD66*complexconjugate(ZD36))*cmath.sin(TW) + (ZD61*complexconjugate(ZD31) + ZD62*complexconjugate(ZD32) + ZD63*complexconjugate(ZD33))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1719 = Coupling(name = 'GC_1719',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD44) + ZD15*complexconjugate(ZD45) + ZD16*complexconjugate(ZD46))*cmath.sin(TW) + (ZD11*complexconjugate(ZD41) + ZD12*complexconjugate(ZD42) + ZD13*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1720 = Coupling(name = 'GC_1720',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD44) + ZD25*complexconjugate(ZD45) + ZD26*complexconjugate(ZD46))*cmath.sin(TW) + (ZD21*complexconjugate(ZD41) + ZD22*complexconjugate(ZD42) + ZD23*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1721 = Coupling(name = 'GC_1721',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD44) + ZD35*complexconjugate(ZD45) + ZD36*complexconjugate(ZD46))*cmath.sin(TW) + (ZD31*complexconjugate(ZD41) + ZD32*complexconjugate(ZD42) + ZD33*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1722 = Coupling(name = 'GC_1722',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD44) + ZD45*complexconjugate(ZD45) + ZD46*complexconjugate(ZD46))*cmath.sin(TW) + (ZD41*complexconjugate(ZD41) + ZD42*complexconjugate(ZD42) + ZD43*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1723 = Coupling(name = 'GC_1723',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD44) + ZD55*complexconjugate(ZD45) + ZD56*complexconjugate(ZD46))*cmath.sin(TW) + (ZD51*complexconjugate(ZD41) + ZD52*complexconjugate(ZD42) + ZD53*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1724 = Coupling(name = 'GC_1724',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD44) + ZD65*complexconjugate(ZD45) + ZD66*complexconjugate(ZD46))*cmath.sin(TW) + (ZD61*complexconjugate(ZD41) + ZD62*complexconjugate(ZD42) + ZD63*complexconjugate(ZD43))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1725 = Coupling(name = 'GC_1725',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD54) + ZD15*complexconjugate(ZD55) + ZD16*complexconjugate(ZD56))*cmath.sin(TW) + (ZD11*complexconjugate(ZD51) + ZD12*complexconjugate(ZD52) + ZD13*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1726 = Coupling(name = 'GC_1726',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD54) + ZD25*complexconjugate(ZD55) + ZD26*complexconjugate(ZD56))*cmath.sin(TW) + (ZD21*complexconjugate(ZD51) + ZD22*complexconjugate(ZD52) + ZD23*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1727 = Coupling(name = 'GC_1727',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD54) + ZD35*complexconjugate(ZD55) + ZD36*complexconjugate(ZD56))*cmath.sin(TW) + (ZD31*complexconjugate(ZD51) + ZD32*complexconjugate(ZD52) + ZD33*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1728 = Coupling(name = 'GC_1728',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD54) + ZD45*complexconjugate(ZD55) + ZD46*complexconjugate(ZD56))*cmath.sin(TW) + (ZD41*complexconjugate(ZD51) + ZD42*complexconjugate(ZD52) + ZD43*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1729 = Coupling(name = 'GC_1729',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD54) + ZD55*complexconjugate(ZD55) + ZD56*complexconjugate(ZD56))*cmath.sin(TW) + (ZD51*complexconjugate(ZD51) + ZD52*complexconjugate(ZD52) + ZD53*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1730 = Coupling(name = 'GC_1730',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD54) + ZD65*complexconjugate(ZD55) + ZD66*complexconjugate(ZD56))*cmath.sin(TW) + (ZD61*complexconjugate(ZD51) + ZD62*complexconjugate(ZD52) + ZD63*complexconjugate(ZD53))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1731 = Coupling(name = 'GC_1731',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD14*complexconjugate(ZD64) + ZD15*complexconjugate(ZD65) + ZD16*complexconjugate(ZD66))*cmath.sin(TW) + (ZD11*complexconjugate(ZD61) + ZD12*complexconjugate(ZD62) + ZD13*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1732 = Coupling(name = 'GC_1732',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD24*complexconjugate(ZD64) + ZD25*complexconjugate(ZD65) + ZD26*complexconjugate(ZD66))*cmath.sin(TW) + (ZD21*complexconjugate(ZD61) + ZD22*complexconjugate(ZD62) + ZD23*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1733 = Coupling(name = 'GC_1733',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD34*complexconjugate(ZD64) + ZD35*complexconjugate(ZD65) + ZD36*complexconjugate(ZD66))*cmath.sin(TW) + (ZD31*complexconjugate(ZD61) + ZD32*complexconjugate(ZD62) + ZD33*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1734 = Coupling(name = 'GC_1734',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD44*complexconjugate(ZD64) + ZD45*complexconjugate(ZD65) + ZD46*complexconjugate(ZD66))*cmath.sin(TW) + (ZD41*complexconjugate(ZD61) + ZD42*complexconjugate(ZD62) + ZD43*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1735 = Coupling(name = 'GC_1735',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD54*complexconjugate(ZD64) + ZD55*complexconjugate(ZD65) + ZD56*complexconjugate(ZD66))*cmath.sin(TW) + (ZD51*complexconjugate(ZD61) + ZD52*complexconjugate(ZD62) + ZD53*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1736 = Coupling(name = 'GC_1736',
	 value = '-1./6.*complex(0,1)*(-2*g1*(ZD64*complexconjugate(ZD64) + ZD65*complexconjugate(ZD65) + ZD66*complexconjugate(ZD66))*cmath.sin(TW) + (ZD61*complexconjugate(ZD61) + ZD62*complexconjugate(ZD62) + ZD63*complexconjugate(ZD63))*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1737 = Coupling(name = 'GC_1737',
	 value = '(1*complex(0,1)*g2*(ZU11*complexconjugate(ZD11) + ZU12*complexconjugate(ZD12) + ZU13*complexconjugate(ZD13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1738 = Coupling(name = 'GC_1738',
	 value = '(1*complex(0,1)*g2*(ZU21*complexconjugate(ZD11) + ZU22*complexconjugate(ZD12) + ZU23*complexconjugate(ZD13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1739 = Coupling(name = 'GC_1739',
	 value = '(1*complex(0,1)*g2*(ZU31*complexconjugate(ZD11) + ZU32*complexconjugate(ZD12) + ZU33*complexconjugate(ZD13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1740 = Coupling(name = 'GC_1740',
	 value = '(1*complex(0,1)*g2*(ZU41*complexconjugate(ZD11) + ZU42*complexconjugate(ZD12) + ZU43*complexconjugate(ZD13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1741 = Coupling(name = 'GC_1741',
	 value = '(1*complex(0,1)*g2*(ZU51*complexconjugate(ZD11) + ZU52*complexconjugate(ZD12) + ZU53*complexconjugate(ZD13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1742 = Coupling(name = 'GC_1742',
	 value = '(1*complex(0,1)*g2*(ZU61*complexconjugate(ZD11) + ZU62*complexconjugate(ZD12) + ZU63*complexconjugate(ZD13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1743 = Coupling(name = 'GC_1743',
	 value = '(1*complex(0,1)*g2*(ZU11*complexconjugate(ZD21) + ZU12*complexconjugate(ZD22) + ZU13*complexconjugate(ZD23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1744 = Coupling(name = 'GC_1744',
	 value = '(1*complex(0,1)*g2*(ZU21*complexconjugate(ZD21) + ZU22*complexconjugate(ZD22) + ZU23*complexconjugate(ZD23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1745 = Coupling(name = 'GC_1745',
	 value = '(1*complex(0,1)*g2*(ZU31*complexconjugate(ZD21) + ZU32*complexconjugate(ZD22) + ZU33*complexconjugate(ZD23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1746 = Coupling(name = 'GC_1746',
	 value = '(1*complex(0,1)*g2*(ZU41*complexconjugate(ZD21) + ZU42*complexconjugate(ZD22) + ZU43*complexconjugate(ZD23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1747 = Coupling(name = 'GC_1747',
	 value = '(1*complex(0,1)*g2*(ZU51*complexconjugate(ZD21) + ZU52*complexconjugate(ZD22) + ZU53*complexconjugate(ZD23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1748 = Coupling(name = 'GC_1748',
	 value = '(1*complex(0,1)*g2*(ZU61*complexconjugate(ZD21) + ZU62*complexconjugate(ZD22) + ZU63*complexconjugate(ZD23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1749 = Coupling(name = 'GC_1749',
	 value = '(1*complex(0,1)*g2*(ZU11*complexconjugate(ZD31) + ZU12*complexconjugate(ZD32) + ZU13*complexconjugate(ZD33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1750 = Coupling(name = 'GC_1750',
	 value = '(1*complex(0,1)*g2*(ZU21*complexconjugate(ZD31) + ZU22*complexconjugate(ZD32) + ZU23*complexconjugate(ZD33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1751 = Coupling(name = 'GC_1751',
	 value = '(1*complex(0,1)*g2*(ZU31*complexconjugate(ZD31) + ZU32*complexconjugate(ZD32) + ZU33*complexconjugate(ZD33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1752 = Coupling(name = 'GC_1752',
	 value = '(1*complex(0,1)*g2*(ZU41*complexconjugate(ZD31) + ZU42*complexconjugate(ZD32) + ZU43*complexconjugate(ZD33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1753 = Coupling(name = 'GC_1753',
	 value = '(1*complex(0,1)*g2*(ZU51*complexconjugate(ZD31) + ZU52*complexconjugate(ZD32) + ZU53*complexconjugate(ZD33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1754 = Coupling(name = 'GC_1754',
	 value = '(1*complex(0,1)*g2*(ZU61*complexconjugate(ZD31) + ZU62*complexconjugate(ZD32) + ZU63*complexconjugate(ZD33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1755 = Coupling(name = 'GC_1755',
	 value = '(1*complex(0,1)*g2*(ZU11*complexconjugate(ZD41) + ZU12*complexconjugate(ZD42) + ZU13*complexconjugate(ZD43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1756 = Coupling(name = 'GC_1756',
	 value = '(1*complex(0,1)*g2*(ZU21*complexconjugate(ZD41) + ZU22*complexconjugate(ZD42) + ZU23*complexconjugate(ZD43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1757 = Coupling(name = 'GC_1757',
	 value = '(1*complex(0,1)*g2*(ZU31*complexconjugate(ZD41) + ZU32*complexconjugate(ZD42) + ZU33*complexconjugate(ZD43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1758 = Coupling(name = 'GC_1758',
	 value = '(1*complex(0,1)*g2*(ZU41*complexconjugate(ZD41) + ZU42*complexconjugate(ZD42) + ZU43*complexconjugate(ZD43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1759 = Coupling(name = 'GC_1759',
	 value = '(1*complex(0,1)*g2*(ZU51*complexconjugate(ZD41) + ZU52*complexconjugate(ZD42) + ZU53*complexconjugate(ZD43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1760 = Coupling(name = 'GC_1760',
	 value = '(1*complex(0,1)*g2*(ZU61*complexconjugate(ZD41) + ZU62*complexconjugate(ZD42) + ZU63*complexconjugate(ZD43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1761 = Coupling(name = 'GC_1761',
	 value = '(1*complex(0,1)*g2*(ZU11*complexconjugate(ZD51) + ZU12*complexconjugate(ZD52) + ZU13*complexconjugate(ZD53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1762 = Coupling(name = 'GC_1762',
	 value = '(1*complex(0,1)*g2*(ZU21*complexconjugate(ZD51) + ZU22*complexconjugate(ZD52) + ZU23*complexconjugate(ZD53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1763 = Coupling(name = 'GC_1763',
	 value = '(1*complex(0,1)*g2*(ZU31*complexconjugate(ZD51) + ZU32*complexconjugate(ZD52) + ZU33*complexconjugate(ZD53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1764 = Coupling(name = 'GC_1764',
	 value = '(1*complex(0,1)*g2*(ZU41*complexconjugate(ZD51) + ZU42*complexconjugate(ZD52) + ZU43*complexconjugate(ZD53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1765 = Coupling(name = 'GC_1765',
	 value = '(1*complex(0,1)*g2*(ZU51*complexconjugate(ZD51) + ZU52*complexconjugate(ZD52) + ZU53*complexconjugate(ZD53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1766 = Coupling(name = 'GC_1766',
	 value = '(1*complex(0,1)*g2*(ZU61*complexconjugate(ZD51) + ZU62*complexconjugate(ZD52) + ZU63*complexconjugate(ZD53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1767 = Coupling(name = 'GC_1767',
	 value = '(1*complex(0,1)*g2*(ZU11*complexconjugate(ZD61) + ZU12*complexconjugate(ZD62) + ZU13*complexconjugate(ZD63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1768 = Coupling(name = 'GC_1768',
	 value = '(1*complex(0,1)*g2*(ZU21*complexconjugate(ZD61) + ZU22*complexconjugate(ZD62) + ZU23*complexconjugate(ZD63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1769 = Coupling(name = 'GC_1769',
	 value = '(1*complex(0,1)*g2*(ZU31*complexconjugate(ZD61) + ZU32*complexconjugate(ZD62) + ZU33*complexconjugate(ZD63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1770 = Coupling(name = 'GC_1770',
	 value = '(1*complex(0,1)*g2*(ZU41*complexconjugate(ZD61) + ZU42*complexconjugate(ZD62) + ZU43*complexconjugate(ZD63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1771 = Coupling(name = 'GC_1771',
	 value = '(1*complex(0,1)*g2*(ZU51*complexconjugate(ZD61) + ZU52*complexconjugate(ZD62) + ZU53*complexconjugate(ZD63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1772 = Coupling(name = 'GC_1772',
	 value = '(1*complex(0,1)*g2*(ZU61*complexconjugate(ZD61) + ZU62*complexconjugate(ZD62) + ZU63*complexconjugate(ZD63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1773 = Coupling(name = 'GC_1773',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE14*complexconjugate(ZE14) + ZE15*complexconjugate(ZE15) + ZE16*complexconjugate(ZE16))*cmath.cos(TW) + (ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1774 = Coupling(name = 'GC_1774',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE24*complexconjugate(ZE14) + ZE25*complexconjugate(ZE15) + ZE26*complexconjugate(ZE16))*cmath.cos(TW) + (ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1775 = Coupling(name = 'GC_1775',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE34*complexconjugate(ZE14) + ZE35*complexconjugate(ZE15) + ZE36*complexconjugate(ZE16))*cmath.cos(TW) + (ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1776 = Coupling(name = 'GC_1776',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE44*complexconjugate(ZE14) + ZE45*complexconjugate(ZE15) + ZE46*complexconjugate(ZE16))*cmath.cos(TW) + (ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1777 = Coupling(name = 'GC_1777',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE54*complexconjugate(ZE14) + ZE55*complexconjugate(ZE15) + ZE56*complexconjugate(ZE16))*cmath.cos(TW) + (ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1778 = Coupling(name = 'GC_1778',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE64*complexconjugate(ZE14) + ZE65*complexconjugate(ZE15) + ZE66*complexconjugate(ZE16))*cmath.cos(TW) + (ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1779 = Coupling(name = 'GC_1779',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE14*complexconjugate(ZE24) + ZE15*complexconjugate(ZE25) + ZE16*complexconjugate(ZE26))*cmath.cos(TW) + (ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1780 = Coupling(name = 'GC_1780',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE24*complexconjugate(ZE24) + ZE25*complexconjugate(ZE25) + ZE26*complexconjugate(ZE26))*cmath.cos(TW) + (ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1781 = Coupling(name = 'GC_1781',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE34*complexconjugate(ZE24) + ZE35*complexconjugate(ZE25) + ZE36*complexconjugate(ZE26))*cmath.cos(TW) + (ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1782 = Coupling(name = 'GC_1782',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE44*complexconjugate(ZE24) + ZE45*complexconjugate(ZE25) + ZE46*complexconjugate(ZE26))*cmath.cos(TW) + (ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1783 = Coupling(name = 'GC_1783',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE54*complexconjugate(ZE24) + ZE55*complexconjugate(ZE25) + ZE56*complexconjugate(ZE26))*cmath.cos(TW) + (ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1784 = Coupling(name = 'GC_1784',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE64*complexconjugate(ZE24) + ZE65*complexconjugate(ZE25) + ZE66*complexconjugate(ZE26))*cmath.cos(TW) + (ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1785 = Coupling(name = 'GC_1785',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE14*complexconjugate(ZE34) + ZE15*complexconjugate(ZE35) + ZE16*complexconjugate(ZE36))*cmath.cos(TW) + (ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1786 = Coupling(name = 'GC_1786',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE24*complexconjugate(ZE34) + ZE25*complexconjugate(ZE35) + ZE26*complexconjugate(ZE36))*cmath.cos(TW) + (ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1787 = Coupling(name = 'GC_1787',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE34*complexconjugate(ZE34) + ZE35*complexconjugate(ZE35) + ZE36*complexconjugate(ZE36))*cmath.cos(TW) + (ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1788 = Coupling(name = 'GC_1788',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE44*complexconjugate(ZE34) + ZE45*complexconjugate(ZE35) + ZE46*complexconjugate(ZE36))*cmath.cos(TW) + (ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1789 = Coupling(name = 'GC_1789',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE54*complexconjugate(ZE34) + ZE55*complexconjugate(ZE35) + ZE56*complexconjugate(ZE36))*cmath.cos(TW) + (ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1790 = Coupling(name = 'GC_1790',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE64*complexconjugate(ZE34) + ZE65*complexconjugate(ZE35) + ZE66*complexconjugate(ZE36))*cmath.cos(TW) + (ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1791 = Coupling(name = 'GC_1791',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE14*complexconjugate(ZE44) + ZE15*complexconjugate(ZE45) + ZE16*complexconjugate(ZE46))*cmath.cos(TW) + (ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1792 = Coupling(name = 'GC_1792',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE24*complexconjugate(ZE44) + ZE25*complexconjugate(ZE45) + ZE26*complexconjugate(ZE46))*cmath.cos(TW) + (ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1793 = Coupling(name = 'GC_1793',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE34*complexconjugate(ZE44) + ZE35*complexconjugate(ZE45) + ZE36*complexconjugate(ZE46))*cmath.cos(TW) + (ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1794 = Coupling(name = 'GC_1794',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE44*complexconjugate(ZE44) + ZE45*complexconjugate(ZE45) + ZE46*complexconjugate(ZE46))*cmath.cos(TW) + (ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1795 = Coupling(name = 'GC_1795',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE54*complexconjugate(ZE44) + ZE55*complexconjugate(ZE45) + ZE56*complexconjugate(ZE46))*cmath.cos(TW) + (ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1796 = Coupling(name = 'GC_1796',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE64*complexconjugate(ZE44) + ZE65*complexconjugate(ZE45) + ZE66*complexconjugate(ZE46))*cmath.cos(TW) + (ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1797 = Coupling(name = 'GC_1797',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE14*complexconjugate(ZE54) + ZE15*complexconjugate(ZE55) + ZE16*complexconjugate(ZE56))*cmath.cos(TW) + (ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1798 = Coupling(name = 'GC_1798',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE24*complexconjugate(ZE54) + ZE25*complexconjugate(ZE55) + ZE26*complexconjugate(ZE56))*cmath.cos(TW) + (ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1799 = Coupling(name = 'GC_1799',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE34*complexconjugate(ZE54) + ZE35*complexconjugate(ZE55) + ZE36*complexconjugate(ZE56))*cmath.cos(TW) + (ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1800 = Coupling(name = 'GC_1800',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE44*complexconjugate(ZE54) + ZE45*complexconjugate(ZE55) + ZE46*complexconjugate(ZE56))*cmath.cos(TW) + (ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1801 = Coupling(name = 'GC_1801',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE54*complexconjugate(ZE54) + ZE55*complexconjugate(ZE55) + ZE56*complexconjugate(ZE56))*cmath.cos(TW) + (ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1802 = Coupling(name = 'GC_1802',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE64*complexconjugate(ZE54) + ZE65*complexconjugate(ZE55) + ZE66*complexconjugate(ZE56))*cmath.cos(TW) + (ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1803 = Coupling(name = 'GC_1803',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE14*complexconjugate(ZE64) + ZE15*complexconjugate(ZE65) + ZE16*complexconjugate(ZE66))*cmath.cos(TW) + (ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1804 = Coupling(name = 'GC_1804',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE24*complexconjugate(ZE64) + ZE25*complexconjugate(ZE65) + ZE26*complexconjugate(ZE66))*cmath.cos(TW) + (ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1805 = Coupling(name = 'GC_1805',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE34*complexconjugate(ZE64) + ZE35*complexconjugate(ZE65) + ZE36*complexconjugate(ZE66))*cmath.cos(TW) + (ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1806 = Coupling(name = 'GC_1806',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE44*complexconjugate(ZE64) + ZE45*complexconjugate(ZE65) + ZE46*complexconjugate(ZE66))*cmath.cos(TW) + (ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1807 = Coupling(name = 'GC_1807',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE54*complexconjugate(ZE64) + ZE55*complexconjugate(ZE65) + ZE56*complexconjugate(ZE66))*cmath.cos(TW) + (ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1808 = Coupling(name = 'GC_1808',
	 value = '-1./2.*complex(0,1)*(2*g1*(ZE64*complexconjugate(ZE64) + ZE65*complexconjugate(ZE65) + ZE66*complexconjugate(ZE66))*cmath.cos(TW) + (ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63))*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1809 = Coupling(name = 'GC_1809',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE14*complexconjugate(ZE14) + ZE15*complexconjugate(ZE15) + ZE16*complexconjugate(ZE16))*cmath.sin(TW) + (ZE11*complexconjugate(ZE11) + ZE12*complexconjugate(ZE12) + ZE13*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1810 = Coupling(name = 'GC_1810',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE24*complexconjugate(ZE14) + ZE25*complexconjugate(ZE15) + ZE26*complexconjugate(ZE16))*cmath.sin(TW) + (ZE21*complexconjugate(ZE11) + ZE22*complexconjugate(ZE12) + ZE23*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1811 = Coupling(name = 'GC_1811',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE34*complexconjugate(ZE14) + ZE35*complexconjugate(ZE15) + ZE36*complexconjugate(ZE16))*cmath.sin(TW) + (ZE31*complexconjugate(ZE11) + ZE32*complexconjugate(ZE12) + ZE33*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1812 = Coupling(name = 'GC_1812',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE44*complexconjugate(ZE14) + ZE45*complexconjugate(ZE15) + ZE46*complexconjugate(ZE16))*cmath.sin(TW) + (ZE41*complexconjugate(ZE11) + ZE42*complexconjugate(ZE12) + ZE43*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1813 = Coupling(name = 'GC_1813',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE54*complexconjugate(ZE14) + ZE55*complexconjugate(ZE15) + ZE56*complexconjugate(ZE16))*cmath.sin(TW) + (ZE51*complexconjugate(ZE11) + ZE52*complexconjugate(ZE12) + ZE53*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1814 = Coupling(name = 'GC_1814',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE64*complexconjugate(ZE14) + ZE65*complexconjugate(ZE15) + ZE66*complexconjugate(ZE16))*cmath.sin(TW) + (ZE61*complexconjugate(ZE11) + ZE62*complexconjugate(ZE12) + ZE63*complexconjugate(ZE13))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1815 = Coupling(name = 'GC_1815',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE14*complexconjugate(ZE24) + ZE15*complexconjugate(ZE25) + ZE16*complexconjugate(ZE26))*cmath.sin(TW) + (ZE11*complexconjugate(ZE21) + ZE12*complexconjugate(ZE22) + ZE13*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1816 = Coupling(name = 'GC_1816',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE24*complexconjugate(ZE24) + ZE25*complexconjugate(ZE25) + ZE26*complexconjugate(ZE26))*cmath.sin(TW) + (ZE21*complexconjugate(ZE21) + ZE22*complexconjugate(ZE22) + ZE23*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1817 = Coupling(name = 'GC_1817',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE34*complexconjugate(ZE24) + ZE35*complexconjugate(ZE25) + ZE36*complexconjugate(ZE26))*cmath.sin(TW) + (ZE31*complexconjugate(ZE21) + ZE32*complexconjugate(ZE22) + ZE33*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1818 = Coupling(name = 'GC_1818',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE44*complexconjugate(ZE24) + ZE45*complexconjugate(ZE25) + ZE46*complexconjugate(ZE26))*cmath.sin(TW) + (ZE41*complexconjugate(ZE21) + ZE42*complexconjugate(ZE22) + ZE43*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1819 = Coupling(name = 'GC_1819',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE54*complexconjugate(ZE24) + ZE55*complexconjugate(ZE25) + ZE56*complexconjugate(ZE26))*cmath.sin(TW) + (ZE51*complexconjugate(ZE21) + ZE52*complexconjugate(ZE22) + ZE53*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1820 = Coupling(name = 'GC_1820',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE64*complexconjugate(ZE24) + ZE65*complexconjugate(ZE25) + ZE66*complexconjugate(ZE26))*cmath.sin(TW) + (ZE61*complexconjugate(ZE21) + ZE62*complexconjugate(ZE22) + ZE63*complexconjugate(ZE23))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1821 = Coupling(name = 'GC_1821',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE14*complexconjugate(ZE34) + ZE15*complexconjugate(ZE35) + ZE16*complexconjugate(ZE36))*cmath.sin(TW) + (ZE11*complexconjugate(ZE31) + ZE12*complexconjugate(ZE32) + ZE13*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1822 = Coupling(name = 'GC_1822',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE24*complexconjugate(ZE34) + ZE25*complexconjugate(ZE35) + ZE26*complexconjugate(ZE36))*cmath.sin(TW) + (ZE21*complexconjugate(ZE31) + ZE22*complexconjugate(ZE32) + ZE23*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1823 = Coupling(name = 'GC_1823',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE34*complexconjugate(ZE34) + ZE35*complexconjugate(ZE35) + ZE36*complexconjugate(ZE36))*cmath.sin(TW) + (ZE31*complexconjugate(ZE31) + ZE32*complexconjugate(ZE32) + ZE33*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1824 = Coupling(name = 'GC_1824',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE44*complexconjugate(ZE34) + ZE45*complexconjugate(ZE35) + ZE46*complexconjugate(ZE36))*cmath.sin(TW) + (ZE41*complexconjugate(ZE31) + ZE42*complexconjugate(ZE32) + ZE43*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1825 = Coupling(name = 'GC_1825',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE54*complexconjugate(ZE34) + ZE55*complexconjugate(ZE35) + ZE56*complexconjugate(ZE36))*cmath.sin(TW) + (ZE51*complexconjugate(ZE31) + ZE52*complexconjugate(ZE32) + ZE53*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1826 = Coupling(name = 'GC_1826',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE64*complexconjugate(ZE34) + ZE65*complexconjugate(ZE35) + ZE66*complexconjugate(ZE36))*cmath.sin(TW) + (ZE61*complexconjugate(ZE31) + ZE62*complexconjugate(ZE32) + ZE63*complexconjugate(ZE33))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1827 = Coupling(name = 'GC_1827',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE14*complexconjugate(ZE44) + ZE15*complexconjugate(ZE45) + ZE16*complexconjugate(ZE46))*cmath.sin(TW) + (ZE11*complexconjugate(ZE41) + ZE12*complexconjugate(ZE42) + ZE13*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1828 = Coupling(name = 'GC_1828',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE24*complexconjugate(ZE44) + ZE25*complexconjugate(ZE45) + ZE26*complexconjugate(ZE46))*cmath.sin(TW) + (ZE21*complexconjugate(ZE41) + ZE22*complexconjugate(ZE42) + ZE23*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1829 = Coupling(name = 'GC_1829',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE34*complexconjugate(ZE44) + ZE35*complexconjugate(ZE45) + ZE36*complexconjugate(ZE46))*cmath.sin(TW) + (ZE31*complexconjugate(ZE41) + ZE32*complexconjugate(ZE42) + ZE33*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1830 = Coupling(name = 'GC_1830',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE44*complexconjugate(ZE44) + ZE45*complexconjugate(ZE45) + ZE46*complexconjugate(ZE46))*cmath.sin(TW) + (ZE41*complexconjugate(ZE41) + ZE42*complexconjugate(ZE42) + ZE43*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1831 = Coupling(name = 'GC_1831',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE54*complexconjugate(ZE44) + ZE55*complexconjugate(ZE45) + ZE56*complexconjugate(ZE46))*cmath.sin(TW) + (ZE51*complexconjugate(ZE41) + ZE52*complexconjugate(ZE42) + ZE53*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1832 = Coupling(name = 'GC_1832',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE64*complexconjugate(ZE44) + ZE65*complexconjugate(ZE45) + ZE66*complexconjugate(ZE46))*cmath.sin(TW) + (ZE61*complexconjugate(ZE41) + ZE62*complexconjugate(ZE42) + ZE63*complexconjugate(ZE43))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1833 = Coupling(name = 'GC_1833',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE14*complexconjugate(ZE54) + ZE15*complexconjugate(ZE55) + ZE16*complexconjugate(ZE56))*cmath.sin(TW) + (ZE11*complexconjugate(ZE51) + ZE12*complexconjugate(ZE52) + ZE13*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1834 = Coupling(name = 'GC_1834',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE24*complexconjugate(ZE54) + ZE25*complexconjugate(ZE55) + ZE26*complexconjugate(ZE56))*cmath.sin(TW) + (ZE21*complexconjugate(ZE51) + ZE22*complexconjugate(ZE52) + ZE23*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1835 = Coupling(name = 'GC_1835',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE34*complexconjugate(ZE54) + ZE35*complexconjugate(ZE55) + ZE36*complexconjugate(ZE56))*cmath.sin(TW) + (ZE31*complexconjugate(ZE51) + ZE32*complexconjugate(ZE52) + ZE33*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1836 = Coupling(name = 'GC_1836',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE44*complexconjugate(ZE54) + ZE45*complexconjugate(ZE55) + ZE46*complexconjugate(ZE56))*cmath.sin(TW) + (ZE41*complexconjugate(ZE51) + ZE42*complexconjugate(ZE52) + ZE43*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1837 = Coupling(name = 'GC_1837',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE54*complexconjugate(ZE54) + ZE55*complexconjugate(ZE55) + ZE56*complexconjugate(ZE56))*cmath.sin(TW) + (ZE51*complexconjugate(ZE51) + ZE52*complexconjugate(ZE52) + ZE53*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1838 = Coupling(name = 'GC_1838',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE64*complexconjugate(ZE54) + ZE65*complexconjugate(ZE55) + ZE66*complexconjugate(ZE56))*cmath.sin(TW) + (ZE61*complexconjugate(ZE51) + ZE62*complexconjugate(ZE52) + ZE63*complexconjugate(ZE53))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1839 = Coupling(name = 'GC_1839',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE14*complexconjugate(ZE64) + ZE15*complexconjugate(ZE65) + ZE16*complexconjugate(ZE66))*cmath.sin(TW) + (ZE11*complexconjugate(ZE61) + ZE12*complexconjugate(ZE62) + ZE13*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1840 = Coupling(name = 'GC_1840',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE24*complexconjugate(ZE64) + ZE25*complexconjugate(ZE65) + ZE26*complexconjugate(ZE66))*cmath.sin(TW) + (ZE21*complexconjugate(ZE61) + ZE22*complexconjugate(ZE62) + ZE23*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1841 = Coupling(name = 'GC_1841',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE34*complexconjugate(ZE64) + ZE35*complexconjugate(ZE65) + ZE36*complexconjugate(ZE66))*cmath.sin(TW) + (ZE31*complexconjugate(ZE61) + ZE32*complexconjugate(ZE62) + ZE33*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1842 = Coupling(name = 'GC_1842',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE44*complexconjugate(ZE64) + ZE45*complexconjugate(ZE65) + ZE46*complexconjugate(ZE66))*cmath.sin(TW) + (ZE41*complexconjugate(ZE61) + ZE42*complexconjugate(ZE62) + ZE43*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1843 = Coupling(name = 'GC_1843',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE54*complexconjugate(ZE64) + ZE55*complexconjugate(ZE65) + ZE56*complexconjugate(ZE66))*cmath.sin(TW) + (ZE51*complexconjugate(ZE61) + ZE52*complexconjugate(ZE62) + ZE53*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1844 = Coupling(name = 'GC_1844',
	 value = '-1./2.*complex(0,1)*(-2*g1*(ZE64*complexconjugate(ZE64) + ZE65*complexconjugate(ZE65) + ZE66*complexconjugate(ZE66))*cmath.sin(TW) + (ZE61*complexconjugate(ZE61) + ZE62*complexconjugate(ZE62) + ZE63*complexconjugate(ZE63))*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1845 = Coupling(name = 'GC_1845',
	 value = '(1*complex(0,1)*g2*(ZV11*complexconjugate(ZE11) + ZV12*complexconjugate(ZE12) + ZV13*complexconjugate(ZE13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1846 = Coupling(name = 'GC_1846',
	 value = '(1*complex(0,1)*g2*(ZV21*complexconjugate(ZE11) + ZV22*complexconjugate(ZE12) + ZV23*complexconjugate(ZE13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1847 = Coupling(name = 'GC_1847',
	 value = '(1*complex(0,1)*g2*(ZV31*complexconjugate(ZE11) + ZV32*complexconjugate(ZE12) + ZV33*complexconjugate(ZE13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1848 = Coupling(name = 'GC_1848',
	 value = '(1*complex(0,1)*g2*(ZV11*complexconjugate(ZE21) + ZV12*complexconjugate(ZE22) + ZV13*complexconjugate(ZE23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1849 = Coupling(name = 'GC_1849',
	 value = '(1*complex(0,1)*g2*(ZV21*complexconjugate(ZE21) + ZV22*complexconjugate(ZE22) + ZV23*complexconjugate(ZE23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1850 = Coupling(name = 'GC_1850',
	 value = '(1*complex(0,1)*g2*(ZV31*complexconjugate(ZE21) + ZV32*complexconjugate(ZE22) + ZV33*complexconjugate(ZE23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1851 = Coupling(name = 'GC_1851',
	 value = '(1*complex(0,1)*g2*(ZV11*complexconjugate(ZE31) + ZV12*complexconjugate(ZE32) + ZV13*complexconjugate(ZE33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1852 = Coupling(name = 'GC_1852',
	 value = '(1*complex(0,1)*g2*(ZV21*complexconjugate(ZE31) + ZV22*complexconjugate(ZE32) + ZV23*complexconjugate(ZE33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1853 = Coupling(name = 'GC_1853',
	 value = '(1*complex(0,1)*g2*(ZV31*complexconjugate(ZE31) + ZV32*complexconjugate(ZE32) + ZV33*complexconjugate(ZE33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1854 = Coupling(name = 'GC_1854',
	 value = '(1*complex(0,1)*g2*(ZV11*complexconjugate(ZE41) + ZV12*complexconjugate(ZE42) + ZV13*complexconjugate(ZE43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1855 = Coupling(name = 'GC_1855',
	 value = '(1*complex(0,1)*g2*(ZV21*complexconjugate(ZE41) + ZV22*complexconjugate(ZE42) + ZV23*complexconjugate(ZE43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1856 = Coupling(name = 'GC_1856',
	 value = '(1*complex(0,1)*g2*(ZV31*complexconjugate(ZE41) + ZV32*complexconjugate(ZE42) + ZV33*complexconjugate(ZE43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1857 = Coupling(name = 'GC_1857',
	 value = '(1*complex(0,1)*g2*(ZV11*complexconjugate(ZE51) + ZV12*complexconjugate(ZE52) + ZV13*complexconjugate(ZE53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1858 = Coupling(name = 'GC_1858',
	 value = '(1*complex(0,1)*g2*(ZV21*complexconjugate(ZE51) + ZV22*complexconjugate(ZE52) + ZV23*complexconjugate(ZE53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1859 = Coupling(name = 'GC_1859',
	 value = '(1*complex(0,1)*g2*(ZV31*complexconjugate(ZE51) + ZV32*complexconjugate(ZE52) + ZV33*complexconjugate(ZE53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1860 = Coupling(name = 'GC_1860',
	 value = '(1*complex(0,1)*g2*(ZV11*complexconjugate(ZE61) + ZV12*complexconjugate(ZE62) + ZV13*complexconjugate(ZE63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1861 = Coupling(name = 'GC_1861',
	 value = '(1*complex(0,1)*g2*(ZV21*complexconjugate(ZE61) + ZV22*complexconjugate(ZE62) + ZV23*complexconjugate(ZE63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1862 = Coupling(name = 'GC_1862',
	 value = '(1*complex(0,1)*g2*(ZV31*complexconjugate(ZE61) + ZV32*complexconjugate(ZE62) + ZV33*complexconjugate(ZE63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1863 = Coupling(name = 'GC_1863',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1864 = Coupling(name = 'GC_1864',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1865 = Coupling(name = 'GC_1865',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1866 = Coupling(name = 'GC_1866',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1867 = Coupling(name = 'GC_1867',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1868 = Coupling(name = 'GC_1868',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_1869 = Coupling(name = 'GC_1869',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16))*cmath.cos(TW) + (ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1870 = Coupling(name = 'GC_1870',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16))*cmath.cos(TW) + (ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1871 = Coupling(name = 'GC_1871',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16))*cmath.cos(TW) + (ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1872 = Coupling(name = 'GC_1872',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16))*cmath.cos(TW) + (ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1873 = Coupling(name = 'GC_1873',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16))*cmath.cos(TW) + (ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1874 = Coupling(name = 'GC_1874',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16))*cmath.cos(TW) + (ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1875 = Coupling(name = 'GC_1875',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26))*cmath.cos(TW) + (ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1876 = Coupling(name = 'GC_1876',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26))*cmath.cos(TW) + (ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1877 = Coupling(name = 'GC_1877',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26))*cmath.cos(TW) + (ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1878 = Coupling(name = 'GC_1878',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26))*cmath.cos(TW) + (ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1879 = Coupling(name = 'GC_1879',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26))*cmath.cos(TW) + (ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1880 = Coupling(name = 'GC_1880',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26))*cmath.cos(TW) + (ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1881 = Coupling(name = 'GC_1881',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36))*cmath.cos(TW) + (ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1882 = Coupling(name = 'GC_1882',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36))*cmath.cos(TW) + (ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1883 = Coupling(name = 'GC_1883',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36))*cmath.cos(TW) + (ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1884 = Coupling(name = 'GC_1884',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36))*cmath.cos(TW) + (ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1885 = Coupling(name = 'GC_1885',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36))*cmath.cos(TW) + (ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1886 = Coupling(name = 'GC_1886',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36))*cmath.cos(TW) + (ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1887 = Coupling(name = 'GC_1887',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46))*cmath.cos(TW) + (ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1888 = Coupling(name = 'GC_1888',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46))*cmath.cos(TW) + (ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1889 = Coupling(name = 'GC_1889',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46))*cmath.cos(TW) + (ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1890 = Coupling(name = 'GC_1890',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46))*cmath.cos(TW) + (ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1891 = Coupling(name = 'GC_1891',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46))*cmath.cos(TW) + (ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1892 = Coupling(name = 'GC_1892',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46))*cmath.cos(TW) + (ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1893 = Coupling(name = 'GC_1893',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56))*cmath.cos(TW) + (ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1894 = Coupling(name = 'GC_1894',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56))*cmath.cos(TW) + (ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1895 = Coupling(name = 'GC_1895',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56))*cmath.cos(TW) + (ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1896 = Coupling(name = 'GC_1896',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56))*cmath.cos(TW) + (ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1897 = Coupling(name = 'GC_1897',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56))*cmath.cos(TW) + (ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1898 = Coupling(name = 'GC_1898',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56))*cmath.cos(TW) + (ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1899 = Coupling(name = 'GC_1899',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66))*cmath.cos(TW) + (ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1900 = Coupling(name = 'GC_1900',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66))*cmath.cos(TW) + (ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1901 = Coupling(name = 'GC_1901',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66))*cmath.cos(TW) + (ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1902 = Coupling(name = 'GC_1902',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66))*cmath.cos(TW) + (ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1903 = Coupling(name = 'GC_1903',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66))*cmath.cos(TW) + (ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1904 = Coupling(name = 'GC_1904',
	 value = '1./6.*complex(0,1)*(4*g1*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66))*cmath.cos(TW) + (ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1905 = Coupling(name = 'GC_1905',
	 value = '(1*complex(0,1)*g2*(ZD11*complexconjugate(ZU11) + ZD12*complexconjugate(ZU12) + ZD13*complexconjugate(ZU13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1906 = Coupling(name = 'GC_1906',
	 value = '(1*complex(0,1)*g2*(ZD21*complexconjugate(ZU11) + ZD22*complexconjugate(ZU12) + ZD23*complexconjugate(ZU13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1907 = Coupling(name = 'GC_1907',
	 value = '(1*complex(0,1)*g2*(ZD31*complexconjugate(ZU11) + ZD32*complexconjugate(ZU12) + ZD33*complexconjugate(ZU13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1908 = Coupling(name = 'GC_1908',
	 value = '(1*complex(0,1)*g2*(ZD41*complexconjugate(ZU11) + ZD42*complexconjugate(ZU12) + ZD43*complexconjugate(ZU13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1909 = Coupling(name = 'GC_1909',
	 value = '(1*complex(0,1)*g2*(ZD51*complexconjugate(ZU11) + ZD52*complexconjugate(ZU12) + ZD53*complexconjugate(ZU13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1910 = Coupling(name = 'GC_1910',
	 value = '(1*complex(0,1)*g2*(ZD61*complexconjugate(ZU11) + ZD62*complexconjugate(ZU12) + ZD63*complexconjugate(ZU13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1911 = Coupling(name = 'GC_1911',
	 value = '(1*complex(0,1)*g2*(ZD11*complexconjugate(ZU21) + ZD12*complexconjugate(ZU22) + ZD13*complexconjugate(ZU23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1912 = Coupling(name = 'GC_1912',
	 value = '(1*complex(0,1)*g2*(ZD21*complexconjugate(ZU21) + ZD22*complexconjugate(ZU22) + ZD23*complexconjugate(ZU23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1913 = Coupling(name = 'GC_1913',
	 value = '(1*complex(0,1)*g2*(ZD31*complexconjugate(ZU21) + ZD32*complexconjugate(ZU22) + ZD33*complexconjugate(ZU23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1914 = Coupling(name = 'GC_1914',
	 value = '(1*complex(0,1)*g2*(ZD41*complexconjugate(ZU21) + ZD42*complexconjugate(ZU22) + ZD43*complexconjugate(ZU23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1915 = Coupling(name = 'GC_1915',
	 value = '(1*complex(0,1)*g2*(ZD51*complexconjugate(ZU21) + ZD52*complexconjugate(ZU22) + ZD53*complexconjugate(ZU23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1916 = Coupling(name = 'GC_1916',
	 value = '(1*complex(0,1)*g2*(ZD61*complexconjugate(ZU21) + ZD62*complexconjugate(ZU22) + ZD63*complexconjugate(ZU23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1917 = Coupling(name = 'GC_1917',
	 value = '(1*complex(0,1)*g2*(ZD11*complexconjugate(ZU31) + ZD12*complexconjugate(ZU32) + ZD13*complexconjugate(ZU33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1918 = Coupling(name = 'GC_1918',
	 value = '(1*complex(0,1)*g2*(ZD21*complexconjugate(ZU31) + ZD22*complexconjugate(ZU32) + ZD23*complexconjugate(ZU33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1919 = Coupling(name = 'GC_1919',
	 value = '(1*complex(0,1)*g2*(ZD31*complexconjugate(ZU31) + ZD32*complexconjugate(ZU32) + ZD33*complexconjugate(ZU33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1920 = Coupling(name = 'GC_1920',
	 value = '(1*complex(0,1)*g2*(ZD41*complexconjugate(ZU31) + ZD42*complexconjugate(ZU32) + ZD43*complexconjugate(ZU33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1921 = Coupling(name = 'GC_1921',
	 value = '(1*complex(0,1)*g2*(ZD51*complexconjugate(ZU31) + ZD52*complexconjugate(ZU32) + ZD53*complexconjugate(ZU33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1922 = Coupling(name = 'GC_1922',
	 value = '(1*complex(0,1)*g2*(ZD61*complexconjugate(ZU31) + ZD62*complexconjugate(ZU32) + ZD63*complexconjugate(ZU33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1923 = Coupling(name = 'GC_1923',
	 value = '(1*complex(0,1)*g2*(ZD11*complexconjugate(ZU41) + ZD12*complexconjugate(ZU42) + ZD13*complexconjugate(ZU43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1924 = Coupling(name = 'GC_1924',
	 value = '(1*complex(0,1)*g2*(ZD21*complexconjugate(ZU41) + ZD22*complexconjugate(ZU42) + ZD23*complexconjugate(ZU43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1925 = Coupling(name = 'GC_1925',
	 value = '(1*complex(0,1)*g2*(ZD31*complexconjugate(ZU41) + ZD32*complexconjugate(ZU42) + ZD33*complexconjugate(ZU43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1926 = Coupling(name = 'GC_1926',
	 value = '(1*complex(0,1)*g2*(ZD41*complexconjugate(ZU41) + ZD42*complexconjugate(ZU42) + ZD43*complexconjugate(ZU43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1927 = Coupling(name = 'GC_1927',
	 value = '(1*complex(0,1)*g2*(ZD51*complexconjugate(ZU41) + ZD52*complexconjugate(ZU42) + ZD53*complexconjugate(ZU43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1928 = Coupling(name = 'GC_1928',
	 value = '(1*complex(0,1)*g2*(ZD61*complexconjugate(ZU41) + ZD62*complexconjugate(ZU42) + ZD63*complexconjugate(ZU43)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1929 = Coupling(name = 'GC_1929',
	 value = '(1*complex(0,1)*g2*(ZD11*complexconjugate(ZU51) + ZD12*complexconjugate(ZU52) + ZD13*complexconjugate(ZU53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1930 = Coupling(name = 'GC_1930',
	 value = '(1*complex(0,1)*g2*(ZD21*complexconjugate(ZU51) + ZD22*complexconjugate(ZU52) + ZD23*complexconjugate(ZU53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1931 = Coupling(name = 'GC_1931',
	 value = '(1*complex(0,1)*g2*(ZD31*complexconjugate(ZU51) + ZD32*complexconjugate(ZU52) + ZD33*complexconjugate(ZU53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1932 = Coupling(name = 'GC_1932',
	 value = '(1*complex(0,1)*g2*(ZD41*complexconjugate(ZU51) + ZD42*complexconjugate(ZU52) + ZD43*complexconjugate(ZU53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1933 = Coupling(name = 'GC_1933',
	 value = '(1*complex(0,1)*g2*(ZD51*complexconjugate(ZU51) + ZD52*complexconjugate(ZU52) + ZD53*complexconjugate(ZU53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1934 = Coupling(name = 'GC_1934',
	 value = '(1*complex(0,1)*g2*(ZD61*complexconjugate(ZU51) + ZD62*complexconjugate(ZU52) + ZD63*complexconjugate(ZU53)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1935 = Coupling(name = 'GC_1935',
	 value = '(1*complex(0,1)*g2*(ZD11*complexconjugate(ZU61) + ZD12*complexconjugate(ZU62) + ZD13*complexconjugate(ZU63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1936 = Coupling(name = 'GC_1936',
	 value = '(1*complex(0,1)*g2*(ZD21*complexconjugate(ZU61) + ZD22*complexconjugate(ZU62) + ZD23*complexconjugate(ZU63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1937 = Coupling(name = 'GC_1937',
	 value = '(1*complex(0,1)*g2*(ZD31*complexconjugate(ZU61) + ZD32*complexconjugate(ZU62) + ZD33*complexconjugate(ZU63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1938 = Coupling(name = 'GC_1938',
	 value = '(1*complex(0,1)*g2*(ZD41*complexconjugate(ZU61) + ZD42*complexconjugate(ZU62) + ZD43*complexconjugate(ZU63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1939 = Coupling(name = 'GC_1939',
	 value = '(1*complex(0,1)*g2*(ZD51*complexconjugate(ZU61) + ZD52*complexconjugate(ZU62) + ZD53*complexconjugate(ZU63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1940 = Coupling(name = 'GC_1940',
	 value = '(1*complex(0,1)*g2*(ZD61*complexconjugate(ZU61) + ZD62*complexconjugate(ZU62) + ZD63*complexconjugate(ZU63)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1941 = Coupling(name = 'GC_1941',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU14*complexconjugate(ZU14) + ZU15*complexconjugate(ZU15) + ZU16*complexconjugate(ZU16))*cmath.sin(TW) + (ZU11*complexconjugate(ZU11) + ZU12*complexconjugate(ZU12) + ZU13*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1942 = Coupling(name = 'GC_1942',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU24*complexconjugate(ZU14) + ZU25*complexconjugate(ZU15) + ZU26*complexconjugate(ZU16))*cmath.sin(TW) + (ZU21*complexconjugate(ZU11) + ZU22*complexconjugate(ZU12) + ZU23*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1943 = Coupling(name = 'GC_1943',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU34*complexconjugate(ZU14) + ZU35*complexconjugate(ZU15) + ZU36*complexconjugate(ZU16))*cmath.sin(TW) + (ZU31*complexconjugate(ZU11) + ZU32*complexconjugate(ZU12) + ZU33*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1944 = Coupling(name = 'GC_1944',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU44*complexconjugate(ZU14) + ZU45*complexconjugate(ZU15) + ZU46*complexconjugate(ZU16))*cmath.sin(TW) + (ZU41*complexconjugate(ZU11) + ZU42*complexconjugate(ZU12) + ZU43*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1945 = Coupling(name = 'GC_1945',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU54*complexconjugate(ZU14) + ZU55*complexconjugate(ZU15) + ZU56*complexconjugate(ZU16))*cmath.sin(TW) + (ZU51*complexconjugate(ZU11) + ZU52*complexconjugate(ZU12) + ZU53*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1946 = Coupling(name = 'GC_1946',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU64*complexconjugate(ZU14) + ZU65*complexconjugate(ZU15) + ZU66*complexconjugate(ZU16))*cmath.sin(TW) + (ZU61*complexconjugate(ZU11) + ZU62*complexconjugate(ZU12) + ZU63*complexconjugate(ZU13))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1947 = Coupling(name = 'GC_1947',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU14*complexconjugate(ZU24) + ZU15*complexconjugate(ZU25) + ZU16*complexconjugate(ZU26))*cmath.sin(TW) + (ZU11*complexconjugate(ZU21) + ZU12*complexconjugate(ZU22) + ZU13*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1948 = Coupling(name = 'GC_1948',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU24*complexconjugate(ZU24) + ZU25*complexconjugate(ZU25) + ZU26*complexconjugate(ZU26))*cmath.sin(TW) + (ZU21*complexconjugate(ZU21) + ZU22*complexconjugate(ZU22) + ZU23*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1949 = Coupling(name = 'GC_1949',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU34*complexconjugate(ZU24) + ZU35*complexconjugate(ZU25) + ZU36*complexconjugate(ZU26))*cmath.sin(TW) + (ZU31*complexconjugate(ZU21) + ZU32*complexconjugate(ZU22) + ZU33*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1950 = Coupling(name = 'GC_1950',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU44*complexconjugate(ZU24) + ZU45*complexconjugate(ZU25) + ZU46*complexconjugate(ZU26))*cmath.sin(TW) + (ZU41*complexconjugate(ZU21) + ZU42*complexconjugate(ZU22) + ZU43*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1951 = Coupling(name = 'GC_1951',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU54*complexconjugate(ZU24) + ZU55*complexconjugate(ZU25) + ZU56*complexconjugate(ZU26))*cmath.sin(TW) + (ZU51*complexconjugate(ZU21) + ZU52*complexconjugate(ZU22) + ZU53*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1952 = Coupling(name = 'GC_1952',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU64*complexconjugate(ZU24) + ZU65*complexconjugate(ZU25) + ZU66*complexconjugate(ZU26))*cmath.sin(TW) + (ZU61*complexconjugate(ZU21) + ZU62*complexconjugate(ZU22) + ZU63*complexconjugate(ZU23))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1953 = Coupling(name = 'GC_1953',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU14*complexconjugate(ZU34) + ZU15*complexconjugate(ZU35) + ZU16*complexconjugate(ZU36))*cmath.sin(TW) + (ZU11*complexconjugate(ZU31) + ZU12*complexconjugate(ZU32) + ZU13*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1954 = Coupling(name = 'GC_1954',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU24*complexconjugate(ZU34) + ZU25*complexconjugate(ZU35) + ZU26*complexconjugate(ZU36))*cmath.sin(TW) + (ZU21*complexconjugate(ZU31) + ZU22*complexconjugate(ZU32) + ZU23*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1955 = Coupling(name = 'GC_1955',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU34*complexconjugate(ZU34) + ZU35*complexconjugate(ZU35) + ZU36*complexconjugate(ZU36))*cmath.sin(TW) + (ZU31*complexconjugate(ZU31) + ZU32*complexconjugate(ZU32) + ZU33*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1956 = Coupling(name = 'GC_1956',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU44*complexconjugate(ZU34) + ZU45*complexconjugate(ZU35) + ZU46*complexconjugate(ZU36))*cmath.sin(TW) + (ZU41*complexconjugate(ZU31) + ZU42*complexconjugate(ZU32) + ZU43*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1957 = Coupling(name = 'GC_1957',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU54*complexconjugate(ZU34) + ZU55*complexconjugate(ZU35) + ZU56*complexconjugate(ZU36))*cmath.sin(TW) + (ZU51*complexconjugate(ZU31) + ZU52*complexconjugate(ZU32) + ZU53*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1958 = Coupling(name = 'GC_1958',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU64*complexconjugate(ZU34) + ZU65*complexconjugate(ZU35) + ZU66*complexconjugate(ZU36))*cmath.sin(TW) + (ZU61*complexconjugate(ZU31) + ZU62*complexconjugate(ZU32) + ZU63*complexconjugate(ZU33))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1959 = Coupling(name = 'GC_1959',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU14*complexconjugate(ZU44) + ZU15*complexconjugate(ZU45) + ZU16*complexconjugate(ZU46))*cmath.sin(TW) + (ZU11*complexconjugate(ZU41) + ZU12*complexconjugate(ZU42) + ZU13*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1960 = Coupling(name = 'GC_1960',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU24*complexconjugate(ZU44) + ZU25*complexconjugate(ZU45) + ZU26*complexconjugate(ZU46))*cmath.sin(TW) + (ZU21*complexconjugate(ZU41) + ZU22*complexconjugate(ZU42) + ZU23*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1961 = Coupling(name = 'GC_1961',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU34*complexconjugate(ZU44) + ZU35*complexconjugate(ZU45) + ZU36*complexconjugate(ZU46))*cmath.sin(TW) + (ZU31*complexconjugate(ZU41) + ZU32*complexconjugate(ZU42) + ZU33*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1962 = Coupling(name = 'GC_1962',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU44*complexconjugate(ZU44) + ZU45*complexconjugate(ZU45) + ZU46*complexconjugate(ZU46))*cmath.sin(TW) + (ZU41*complexconjugate(ZU41) + ZU42*complexconjugate(ZU42) + ZU43*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1963 = Coupling(name = 'GC_1963',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU54*complexconjugate(ZU44) + ZU55*complexconjugate(ZU45) + ZU56*complexconjugate(ZU46))*cmath.sin(TW) + (ZU51*complexconjugate(ZU41) + ZU52*complexconjugate(ZU42) + ZU53*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1964 = Coupling(name = 'GC_1964',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU64*complexconjugate(ZU44) + ZU65*complexconjugate(ZU45) + ZU66*complexconjugate(ZU46))*cmath.sin(TW) + (ZU61*complexconjugate(ZU41) + ZU62*complexconjugate(ZU42) + ZU63*complexconjugate(ZU43))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1965 = Coupling(name = 'GC_1965',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU14*complexconjugate(ZU54) + ZU15*complexconjugate(ZU55) + ZU16*complexconjugate(ZU56))*cmath.sin(TW) + (ZU11*complexconjugate(ZU51) + ZU12*complexconjugate(ZU52) + ZU13*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1966 = Coupling(name = 'GC_1966',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU24*complexconjugate(ZU54) + ZU25*complexconjugate(ZU55) + ZU26*complexconjugate(ZU56))*cmath.sin(TW) + (ZU21*complexconjugate(ZU51) + ZU22*complexconjugate(ZU52) + ZU23*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1967 = Coupling(name = 'GC_1967',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU34*complexconjugate(ZU54) + ZU35*complexconjugate(ZU55) + ZU36*complexconjugate(ZU56))*cmath.sin(TW) + (ZU31*complexconjugate(ZU51) + ZU32*complexconjugate(ZU52) + ZU33*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1968 = Coupling(name = 'GC_1968',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU44*complexconjugate(ZU54) + ZU45*complexconjugate(ZU55) + ZU46*complexconjugate(ZU56))*cmath.sin(TW) + (ZU41*complexconjugate(ZU51) + ZU42*complexconjugate(ZU52) + ZU43*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1969 = Coupling(name = 'GC_1969',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU54*complexconjugate(ZU54) + ZU55*complexconjugate(ZU55) + ZU56*complexconjugate(ZU56))*cmath.sin(TW) + (ZU51*complexconjugate(ZU51) + ZU52*complexconjugate(ZU52) + ZU53*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1970 = Coupling(name = 'GC_1970',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU64*complexconjugate(ZU54) + ZU65*complexconjugate(ZU55) + ZU66*complexconjugate(ZU56))*cmath.sin(TW) + (ZU61*complexconjugate(ZU51) + ZU62*complexconjugate(ZU52) + ZU63*complexconjugate(ZU53))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1971 = Coupling(name = 'GC_1971',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU14*complexconjugate(ZU64) + ZU15*complexconjugate(ZU65) + ZU16*complexconjugate(ZU66))*cmath.sin(TW) + (ZU11*complexconjugate(ZU61) + ZU12*complexconjugate(ZU62) + ZU13*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1972 = Coupling(name = 'GC_1972',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU24*complexconjugate(ZU64) + ZU25*complexconjugate(ZU65) + ZU26*complexconjugate(ZU66))*cmath.sin(TW) + (ZU21*complexconjugate(ZU61) + ZU22*complexconjugate(ZU62) + ZU23*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1973 = Coupling(name = 'GC_1973',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU34*complexconjugate(ZU64) + ZU35*complexconjugate(ZU65) + ZU36*complexconjugate(ZU66))*cmath.sin(TW) + (ZU31*complexconjugate(ZU61) + ZU32*complexconjugate(ZU62) + ZU33*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1974 = Coupling(name = 'GC_1974',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU44*complexconjugate(ZU64) + ZU45*complexconjugate(ZU65) + ZU46*complexconjugate(ZU66))*cmath.sin(TW) + (ZU41*complexconjugate(ZU61) + ZU42*complexconjugate(ZU62) + ZU43*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1975 = Coupling(name = 'GC_1975',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU54*complexconjugate(ZU64) + ZU55*complexconjugate(ZU65) + ZU56*complexconjugate(ZU66))*cmath.sin(TW) + (ZU51*complexconjugate(ZU61) + ZU52*complexconjugate(ZU62) + ZU53*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1976 = Coupling(name = 'GC_1976',
	 value = '1./6.*complex(0,1)*(-4*g1*(ZU64*complexconjugate(ZU64) + ZU65*complexconjugate(ZU65) + ZU66*complexconjugate(ZU66))*cmath.sin(TW) + (ZU61*complexconjugate(ZU61) + ZU62*complexconjugate(ZU62) + ZU63*complexconjugate(ZU63))*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_1977 = Coupling(name = 'GC_1977',
	 value = '(1*complex(0,1)*g2*(ZE11*complexconjugate(ZV11) + ZE12*complexconjugate(ZV12) + ZE13*complexconjugate(ZV13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1978 = Coupling(name = 'GC_1978',
	 value = '(1*complex(0,1)*g2*(ZE21*complexconjugate(ZV11) + ZE22*complexconjugate(ZV12) + ZE23*complexconjugate(ZV13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1979 = Coupling(name = 'GC_1979',
	 value = '(1*complex(0,1)*g2*(ZE31*complexconjugate(ZV11) + ZE32*complexconjugate(ZV12) + ZE33*complexconjugate(ZV13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1980 = Coupling(name = 'GC_1980',
	 value = '(1*complex(0,1)*g2*(ZE41*complexconjugate(ZV11) + ZE42*complexconjugate(ZV12) + ZE43*complexconjugate(ZV13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1981 = Coupling(name = 'GC_1981',
	 value = '(1*complex(0,1)*g2*(ZE51*complexconjugate(ZV11) + ZE52*complexconjugate(ZV12) + ZE53*complexconjugate(ZV13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1982 = Coupling(name = 'GC_1982',
	 value = '(1*complex(0,1)*g2*(ZE61*complexconjugate(ZV11) + ZE62*complexconjugate(ZV12) + ZE63*complexconjugate(ZV13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1983 = Coupling(name = 'GC_1983',
	 value = '(1*complex(0,1)*g2*(ZE11*complexconjugate(ZV21) + ZE12*complexconjugate(ZV22) + ZE13*complexconjugate(ZV23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1984 = Coupling(name = 'GC_1984',
	 value = '(1*complex(0,1)*g2*(ZE21*complexconjugate(ZV21) + ZE22*complexconjugate(ZV22) + ZE23*complexconjugate(ZV23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1985 = Coupling(name = 'GC_1985',
	 value = '(1*complex(0,1)*g2*(ZE31*complexconjugate(ZV21) + ZE32*complexconjugate(ZV22) + ZE33*complexconjugate(ZV23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1986 = Coupling(name = 'GC_1986',
	 value = '(1*complex(0,1)*g2*(ZE41*complexconjugate(ZV21) + ZE42*complexconjugate(ZV22) + ZE43*complexconjugate(ZV23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1987 = Coupling(name = 'GC_1987',
	 value = '(1*complex(0,1)*g2*(ZE51*complexconjugate(ZV21) + ZE52*complexconjugate(ZV22) + ZE53*complexconjugate(ZV23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1988 = Coupling(name = 'GC_1988',
	 value = '(1*complex(0,1)*g2*(ZE61*complexconjugate(ZV21) + ZE62*complexconjugate(ZV22) + ZE63*complexconjugate(ZV23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1989 = Coupling(name = 'GC_1989',
	 value = '(1*complex(0,1)*g2*(ZE11*complexconjugate(ZV31) + ZE12*complexconjugate(ZV32) + ZE13*complexconjugate(ZV33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1990 = Coupling(name = 'GC_1990',
	 value = '(1*complex(0,1)*g2*(ZE21*complexconjugate(ZV31) + ZE22*complexconjugate(ZV32) + ZE23*complexconjugate(ZV33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1991 = Coupling(name = 'GC_1991',
	 value = '(1*complex(0,1)*g2*(ZE31*complexconjugate(ZV31) + ZE32*complexconjugate(ZV32) + ZE33*complexconjugate(ZV33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1992 = Coupling(name = 'GC_1992',
	 value = '(1*complex(0,1)*g2*(ZE41*complexconjugate(ZV31) + ZE42*complexconjugate(ZV32) + ZE43*complexconjugate(ZV33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1993 = Coupling(name = 'GC_1993',
	 value = '(1*complex(0,1)*g2*(ZE51*complexconjugate(ZV31) + ZE52*complexconjugate(ZV32) + ZE53*complexconjugate(ZV33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1994 = Coupling(name = 'GC_1994',
	 value = '(1*complex(0,1)*g2*(ZE61*complexconjugate(ZV31) + ZE62*complexconjugate(ZV32) + ZE63*complexconjugate(ZV33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_1995 = Coupling(name = 'GC_1995',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1996 = Coupling(name = 'GC_1996',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1997 = Coupling(name = 'GC_1997',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_1998 = Coupling(name = 'GC_1998',
	 value = '1./2.*complex(0,1)*g2**2*(vd*ZH11 + vu*ZH12)', 
	 order = {'QED':1} ) 
 
GC_1999 = Coupling(name = 'GC_1999',
	 value = '1./2.*complex(0,1)*g2**2*(vd*ZH21 + vu*ZH22)', 
	 order = {'QED':1} ) 
 
GC_2000 = Coupling(name = 'GC_2000',
	 value = '1./2.*complex(0,1)*(vd*ZH11 + vu*ZH12)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':1} ) 
 
GC_2001 = Coupling(name = 'GC_2001',
	 value = '1./2.*complex(0,1)*(vd*ZH21 + vu*ZH22)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))**2', 
	 order = {'QED':1} ) 
 
GC_2002 = Coupling(name = 'GC_2002',
	 value = '-1./2.*complex(0,1)*g1*g2*(vd*ZP11 - vu*ZP12)*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_2003 = Coupling(name = 'GC_2003',
	 value = '-1./2.*complex(0,1)*g1*g2*(vd*ZP21 - vu*ZP22)*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_2004 = Coupling(name = 'GC_2004',
	 value = '1./2.*complex(0,1)*g1*g2*(vd*ZP11 - vu*ZP12)*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_2005 = Coupling(name = 'GC_2005',
	 value = '1./2.*complex(0,1)*g1*g2*(vd*ZP21 - vu*ZP22)*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_2006 = Coupling(name = 'GC_2006',
	 value = '-1./2.*complex(0,1)*g1*g2*(vd*ZP11 - vu*ZP12)*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_2007 = Coupling(name = 'GC_2007',
	 value = '-1./2.*complex(0,1)*g1*g2*(vd*ZP21 - vu*ZP22)*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_2008 = Coupling(name = 'GC_2008',
	 value = '1./2.*complex(0,1)*g1*g2*(vd*ZP11 - vu*ZP12)*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_2009 = Coupling(name = 'GC_2009',
	 value = '1./2.*complex(0,1)*g1*g2*(vd*ZP21 - vu*ZP22)*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_2010 = Coupling(name = 'GC_2010',
	 value = '-((g2*(UM12*UP11*ZA11 + UM11*UP12*ZA12))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2011 = Coupling(name = 'GC_2011',
	 value = '(g2*(ZA11*complexconjugate(UM12)*complexconjugate(UP11) + ZA12*complexconjugate(UM11)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2012 = Coupling(name = 'GC_2012',
	 value = '-((g2*(UM12*UP11*ZA21 + UM11*UP12*ZA22))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2013 = Coupling(name = 'GC_2013',
	 value = '(g2*(ZA21*complexconjugate(UM12)*complexconjugate(UP11) + ZA22*complexconjugate(UM11)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2014 = Coupling(name = 'GC_2014',
	 value = '-((g2*(UM22*UP11*ZA11 + UM21*UP12*ZA12))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2015 = Coupling(name = 'GC_2015',
	 value = '(g2*(ZA11*complexconjugate(UM12)*complexconjugate(UP21) + ZA12*complexconjugate(UM11)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2016 = Coupling(name = 'GC_2016',
	 value = '-((g2*(UM22*UP11*ZA21 + UM21*UP12*ZA22))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2017 = Coupling(name = 'GC_2017',
	 value = '(g2*(ZA21*complexconjugate(UM12)*complexconjugate(UP21) + ZA22*complexconjugate(UM11)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2018 = Coupling(name = 'GC_2018',
	 value = '-((g2*(UM12*UP21*ZA11 + UM11*UP22*ZA12))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2019 = Coupling(name = 'GC_2019',
	 value = '(g2*(ZA11*complexconjugate(UM22)*complexconjugate(UP11) + ZA12*complexconjugate(UM21)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2020 = Coupling(name = 'GC_2020',
	 value = '-((g2*(UM12*UP21*ZA21 + UM11*UP22*ZA22))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2021 = Coupling(name = 'GC_2021',
	 value = '(g2*(ZA21*complexconjugate(UM22)*complexconjugate(UP11) + ZA22*complexconjugate(UM21)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2022 = Coupling(name = 'GC_2022',
	 value = '-((g2*(UM22*UP21*ZA11 + UM21*UP22*ZA12))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2023 = Coupling(name = 'GC_2023',
	 value = '(g2*(ZA11*complexconjugate(UM22)*complexconjugate(UP21) + ZA12*complexconjugate(UM21)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2024 = Coupling(name = 'GC_2024',
	 value = '-((g2*(UM22*UP21*ZA21 + UM21*UP22*ZA22))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2025 = Coupling(name = 'GC_2025',
	 value = '(g2*(ZA21*complexconjugate(UM22)*complexconjugate(UP21) + ZA22*complexconjugate(UM21)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2026 = Coupling(name = 'GC_2026',
	 value = '(-(g2*ZA11*ZN12*ZN13) + ZA11*(g1*ZN11 - g2*ZN12)*ZN13 - g1*ZA12*ZN11*ZN14 + 2*g2*ZA12*ZN12*ZN14 + g1*ZN11*(ZA11*ZN13 - ZA12*ZN14))/2.', 
	 order = {'QED':1} ) 
 
GC_2027 = Coupling(name = 'GC_2027',
	 value = '(2*ZA11*(-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN13) + 2*ZA12*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN14))/2.', 
	 order = {'QED':1} ) 
 
GC_2028 = Coupling(name = 'GC_2028',
	 value = '(-(g2*ZA21*ZN12*ZN13) + ZA21*(g1*ZN11 - g2*ZN12)*ZN13 - g1*ZA22*ZN11*ZN14 + 2*g2*ZA22*ZN12*ZN14 + g1*ZN11*(ZA21*ZN13 - ZA22*ZN14))/2.', 
	 order = {'QED':1} ) 
 
GC_2029 = Coupling(name = 'GC_2029',
	 value = '(2*ZA21*(-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN13) + 2*ZA22*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN14))/2.', 
	 order = {'QED':1} ) 
 
GC_2030 = Coupling(name = 'GC_2030',
	 value = '(-(g1*ZA12*ZN14*ZN21) + g2*ZA12*ZN14*ZN22 + ZA11*ZN13*(g1*ZN21 - g2*ZN22) - g2*ZA11*ZN12*ZN23 + g2*ZA12*ZN12*ZN24 + g1*ZN11*(ZA11*ZN23 - ZA12*ZN24))/2.', 
	 order = {'QED':1} ) 
 
GC_2031 = Coupling(name = 'GC_2031',
	 value = '(ZA11*(complexconjugate(ZN13)*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN23)) + ZA12*(complexconjugate(ZN14)*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN24)))/2.', 
	 order = {'QED':1} ) 
 
GC_2032 = Coupling(name = 'GC_2032',
	 value = '(-(g1*ZA22*ZN14*ZN21) + g2*ZA22*ZN14*ZN22 + ZA21*ZN13*(g1*ZN21 - g2*ZN22) - g2*ZA21*ZN12*ZN23 + g2*ZA22*ZN12*ZN24 + g1*ZN11*(ZA21*ZN23 - ZA22*ZN24))/2.', 
	 order = {'QED':1} ) 
 
GC_2033 = Coupling(name = 'GC_2033',
	 value = '(ZA21*(complexconjugate(ZN13)*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN23)) + ZA22*(complexconjugate(ZN14)*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN24)))/2.', 
	 order = {'QED':1} ) 
 
GC_2034 = Coupling(name = 'GC_2034',
	 value = '(-(g1*ZA12*ZN14*ZN31) + g2*ZA12*ZN14*ZN32 + ZA11*ZN13*(g1*ZN31 - g2*ZN32) - g2*ZA11*ZN12*ZN33 + g2*ZA12*ZN12*ZN34 + g1*ZN11*(ZA11*ZN33 - ZA12*ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2035 = Coupling(name = 'GC_2035',
	 value = '(ZA11*(complexconjugate(ZN13)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN33)) + ZA12*(complexconjugate(ZN14)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN34)))/2.', 
	 order = {'QED':1} ) 
 
GC_2036 = Coupling(name = 'GC_2036',
	 value = '(-(g1*ZA22*ZN14*ZN31) + g2*ZA22*ZN14*ZN32 + ZA21*ZN13*(g1*ZN31 - g2*ZN32) - g2*ZA21*ZN12*ZN33 + g2*ZA22*ZN12*ZN34 + g1*ZN11*(ZA21*ZN33 - ZA22*ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2037 = Coupling(name = 'GC_2037',
	 value = '(ZA21*(complexconjugate(ZN13)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN33)) + ZA22*(complexconjugate(ZN14)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN34)))/2.', 
	 order = {'QED':1} ) 
 
GC_2038 = Coupling(name = 'GC_2038',
	 value = '(-(g1*ZA12*ZN14*ZN41) + g2*ZA12*ZN14*ZN42 + ZA11*ZN13*(g1*ZN41 - g2*ZN42) - g2*ZA11*ZN12*ZN43 + g2*ZA12*ZN12*ZN44 + g1*ZN11*(ZA11*ZN43 - ZA12*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2039 = Coupling(name = 'GC_2039',
	 value = '(ZA11*(complexconjugate(ZN13)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN43)) + ZA12*(complexconjugate(ZN14)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN44)))/2.', 
	 order = {'QED':1} ) 
 
GC_2040 = Coupling(name = 'GC_2040',
	 value = '(-(g1*ZA22*ZN14*ZN41) + g2*ZA22*ZN14*ZN42 + ZA21*ZN13*(g1*ZN41 - g2*ZN42) - g2*ZA21*ZN12*ZN43 + g2*ZA22*ZN12*ZN44 + g1*ZN11*(ZA21*ZN43 - ZA22*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2041 = Coupling(name = 'GC_2041',
	 value = '(ZA21*(complexconjugate(ZN13)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN43)) + ZA22*(complexconjugate(ZN14)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN44)))/2.', 
	 order = {'QED':1} ) 
 
GC_2042 = Coupling(name = 'GC_2042',
	 value = '(-(g2*ZA11*ZN22*ZN23) + ZA11*(g1*ZN21 - g2*ZN22)*ZN23 - g1*ZA12*ZN21*ZN24 + 2*g2*ZA12*ZN22*ZN24 + g1*ZN21*(ZA11*ZN23 - ZA12*ZN24))/2.', 
	 order = {'QED':1} ) 
 
GC_2043 = Coupling(name = 'GC_2043',
	 value = '(2*ZA11*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN23) + 2*ZA12*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN24))/2.', 
	 order = {'QED':1} ) 
 
GC_2044 = Coupling(name = 'GC_2044',
	 value = '(-(g2*ZA21*ZN22*ZN23) + ZA21*(g1*ZN21 - g2*ZN22)*ZN23 - g1*ZA22*ZN21*ZN24 + 2*g2*ZA22*ZN22*ZN24 + g1*ZN21*(ZA21*ZN23 - ZA22*ZN24))/2.', 
	 order = {'QED':1} ) 
 
GC_2045 = Coupling(name = 'GC_2045',
	 value = '(2*ZA21*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN23) + 2*ZA22*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN24))/2.', 
	 order = {'QED':1} ) 
 
GC_2046 = Coupling(name = 'GC_2046',
	 value = '(-(g1*ZA12*ZN24*ZN31) + g2*ZA12*ZN24*ZN32 + ZA11*ZN23*(g1*ZN31 - g2*ZN32) - g2*ZA11*ZN22*ZN33 + g2*ZA12*ZN22*ZN34 + g1*ZN21*(ZA11*ZN33 - ZA12*ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2047 = Coupling(name = 'GC_2047',
	 value = '(ZA11*(complexconjugate(ZN23)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN33)) + ZA12*(complexconjugate(ZN24)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN34)))/2.', 
	 order = {'QED':1} ) 
 
GC_2048 = Coupling(name = 'GC_2048',
	 value = '(-(g1*ZA22*ZN24*ZN31) + g2*ZA22*ZN24*ZN32 + ZA21*ZN23*(g1*ZN31 - g2*ZN32) - g2*ZA21*ZN22*ZN33 + g2*ZA22*ZN22*ZN34 + g1*ZN21*(ZA21*ZN33 - ZA22*ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2049 = Coupling(name = 'GC_2049',
	 value = '(ZA21*(complexconjugate(ZN23)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN33)) + ZA22*(complexconjugate(ZN24)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN34)))/2.', 
	 order = {'QED':1} ) 
 
GC_2050 = Coupling(name = 'GC_2050',
	 value = '(-(g1*ZA12*ZN24*ZN41) + g2*ZA12*ZN24*ZN42 + ZA11*ZN23*(g1*ZN41 - g2*ZN42) - g2*ZA11*ZN22*ZN43 + g2*ZA12*ZN22*ZN44 + g1*ZN21*(ZA11*ZN43 - ZA12*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2051 = Coupling(name = 'GC_2051',
	 value = '(ZA11*(complexconjugate(ZN23)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN43)) + ZA12*(complexconjugate(ZN24)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN44)))/2.', 
	 order = {'QED':1} ) 
 
GC_2052 = Coupling(name = 'GC_2052',
	 value = '(-(g1*ZA22*ZN24*ZN41) + g2*ZA22*ZN24*ZN42 + ZA21*ZN23*(g1*ZN41 - g2*ZN42) - g2*ZA21*ZN22*ZN43 + g2*ZA22*ZN22*ZN44 + g1*ZN21*(ZA21*ZN43 - ZA22*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2053 = Coupling(name = 'GC_2053',
	 value = '(ZA21*(complexconjugate(ZN23)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN43)) + ZA22*(complexconjugate(ZN24)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN44)))/2.', 
	 order = {'QED':1} ) 
 
GC_2054 = Coupling(name = 'GC_2054',
	 value = '(-(g2*ZA11*ZN32*ZN33) + ZA11*(g1*ZN31 - g2*ZN32)*ZN33 - g1*ZA12*ZN31*ZN34 + 2*g2*ZA12*ZN32*ZN34 + g1*ZN31*(ZA11*ZN33 - ZA12*ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2055 = Coupling(name = 'GC_2055',
	 value = '(2*ZA11*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN33) + 2*ZA12*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2056 = Coupling(name = 'GC_2056',
	 value = '(-(g2*ZA21*ZN32*ZN33) + ZA21*(g1*ZN31 - g2*ZN32)*ZN33 - g1*ZA22*ZN31*ZN34 + 2*g2*ZA22*ZN32*ZN34 + g1*ZN31*(ZA21*ZN33 - ZA22*ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2057 = Coupling(name = 'GC_2057',
	 value = '(2*ZA21*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN33) + 2*ZA22*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN34))/2.', 
	 order = {'QED':1} ) 
 
GC_2058 = Coupling(name = 'GC_2058',
	 value = '(-(g1*ZA12*ZN34*ZN41) + g2*ZA12*ZN34*ZN42 + ZA11*ZN33*(g1*ZN41 - g2*ZN42) - g2*ZA11*ZN32*ZN43 + g2*ZA12*ZN32*ZN44 + g1*ZN31*(ZA11*ZN43 - ZA12*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2059 = Coupling(name = 'GC_2059',
	 value = '(ZA11*(complexconjugate(ZN33)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN43)) + ZA12*(complexconjugate(ZN34)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN44)))/2.', 
	 order = {'QED':1} ) 
 
GC_2060 = Coupling(name = 'GC_2060',
	 value = '(-(g1*ZA22*ZN34*ZN41) + g2*ZA22*ZN34*ZN42 + ZA21*ZN33*(g1*ZN41 - g2*ZN42) - g2*ZA21*ZN32*ZN43 + g2*ZA22*ZN32*ZN44 + g1*ZN31*(ZA21*ZN43 - ZA22*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2061 = Coupling(name = 'GC_2061',
	 value = '(ZA21*(complexconjugate(ZN33)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN43)) + ZA22*(complexconjugate(ZN34)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN44)))/2.', 
	 order = {'QED':1} ) 
 
GC_2062 = Coupling(name = 'GC_2062',
	 value = '(-(g2*ZA11*ZN42*ZN43) + ZA11*(g1*ZN41 - g2*ZN42)*ZN43 - g1*ZA12*ZN41*ZN44 + 2*g2*ZA12*ZN42*ZN44 + g1*ZN41*(ZA11*ZN43 - ZA12*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2063 = Coupling(name = 'GC_2063',
	 value = '(2*ZA11*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42))*complexconjugate(ZN43) + 2*ZA12*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42))*complexconjugate(ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2064 = Coupling(name = 'GC_2064',
	 value = '(-(g2*ZA21*ZN42*ZN43) + ZA21*(g1*ZN41 - g2*ZN42)*ZN43 - g1*ZA22*ZN41*ZN44 + 2*g2*ZA22*ZN42*ZN44 + g1*ZN41*(ZA21*ZN43 - ZA22*ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2065 = Coupling(name = 'GC_2065',
	 value = '(2*ZA21*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42))*complexconjugate(ZN43) + 2*ZA22*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42))*complexconjugate(ZN44))/2.', 
	 order = {'QED':1} ) 
 
GC_2066 = Coupling(name = 'GC_2066',
	 value = '(ZA11*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2067 = Coupling(name = 'GC_2067',
	 value = '-((ZA11*(ZDL11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2068 = Coupling(name = 'GC_2068',
	 value = '(ZA21*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2069 = Coupling(name = 'GC_2069',
	 value = '-((ZA21*(ZDL11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2070 = Coupling(name = 'GC_2070',
	 value = '(ZA11*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2071 = Coupling(name = 'GC_2071',
	 value = '-((ZA11*(ZDL11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2072 = Coupling(name = 'GC_2072',
	 value = '(ZA21*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2073 = Coupling(name = 'GC_2073',
	 value = '-((ZA21*(ZDL11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2074 = Coupling(name = 'GC_2074',
	 value = '(ZA11*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2075 = Coupling(name = 'GC_2075',
	 value = '-((ZA11*(ZDL11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2076 = Coupling(name = 'GC_2076',
	 value = '(ZA21*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2077 = Coupling(name = 'GC_2077',
	 value = '-((ZA21*(ZDL11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2078 = Coupling(name = 'GC_2078',
	 value = '(ZA11*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2079 = Coupling(name = 'GC_2079',
	 value = '-((ZA11*(ZDL21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2080 = Coupling(name = 'GC_2080',
	 value = '(ZA21*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2081 = Coupling(name = 'GC_2081',
	 value = '-((ZA21*(ZDL21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2082 = Coupling(name = 'GC_2082',
	 value = '(ZA11*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2083 = Coupling(name = 'GC_2083',
	 value = '-((ZA11*(ZDL21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2084 = Coupling(name = 'GC_2084',
	 value = '(ZA21*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2085 = Coupling(name = 'GC_2085',
	 value = '-((ZA21*(ZDL21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2086 = Coupling(name = 'GC_2086',
	 value = '(ZA11*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2087 = Coupling(name = 'GC_2087',
	 value = '-((ZA11*(ZDL21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2088 = Coupling(name = 'GC_2088',
	 value = '(ZA21*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2089 = Coupling(name = 'GC_2089',
	 value = '-((ZA21*(ZDL21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2090 = Coupling(name = 'GC_2090',
	 value = '(ZA11*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2091 = Coupling(name = 'GC_2091',
	 value = '-((ZA11*(ZDL31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2092 = Coupling(name = 'GC_2092',
	 value = '(ZA21*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2093 = Coupling(name = 'GC_2093',
	 value = '-((ZA21*(ZDL31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2094 = Coupling(name = 'GC_2094',
	 value = '(ZA11*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2095 = Coupling(name = 'GC_2095',
	 value = '-((ZA11*(ZDL31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2096 = Coupling(name = 'GC_2096',
	 value = '(ZA21*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2097 = Coupling(name = 'GC_2097',
	 value = '-((ZA21*(ZDL31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2098 = Coupling(name = 'GC_2098',
	 value = '(ZA11*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2099 = Coupling(name = 'GC_2099',
	 value = '-((ZA11*(ZDL31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2100 = Coupling(name = 'GC_2100',
	 value = '(ZA21*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2101 = Coupling(name = 'GC_2101',
	 value = '-((ZA21*(ZDL31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2102 = Coupling(name = 'GC_2102',
	 value = '(ZA11*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2103 = Coupling(name = 'GC_2103',
	 value = '-((ZA11*(ZEL11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2104 = Coupling(name = 'GC_2104',
	 value = '(ZA21*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2105 = Coupling(name = 'GC_2105',
	 value = '-((ZA21*(ZEL11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2106 = Coupling(name = 'GC_2106',
	 value = '(ZA11*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2107 = Coupling(name = 'GC_2107',
	 value = '-((ZA11*(ZEL11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2108 = Coupling(name = 'GC_2108',
	 value = '(ZA21*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2109 = Coupling(name = 'GC_2109',
	 value = '-((ZA21*(ZEL11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2110 = Coupling(name = 'GC_2110',
	 value = '(ZA11*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2111 = Coupling(name = 'GC_2111',
	 value = '-((ZA11*(ZEL11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2112 = Coupling(name = 'GC_2112',
	 value = '(ZA21*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2113 = Coupling(name = 'GC_2113',
	 value = '-((ZA21*(ZEL11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2114 = Coupling(name = 'GC_2114',
	 value = '(ZA11*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2115 = Coupling(name = 'GC_2115',
	 value = '-((ZA11*(ZEL21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2116 = Coupling(name = 'GC_2116',
	 value = '(ZA21*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2117 = Coupling(name = 'GC_2117',
	 value = '-((ZA21*(ZEL21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2118 = Coupling(name = 'GC_2118',
	 value = '(ZA11*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2119 = Coupling(name = 'GC_2119',
	 value = '-((ZA11*(ZEL21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2120 = Coupling(name = 'GC_2120',
	 value = '(ZA21*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2121 = Coupling(name = 'GC_2121',
	 value = '-((ZA21*(ZEL21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2122 = Coupling(name = 'GC_2122',
	 value = '(ZA11*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2123 = Coupling(name = 'GC_2123',
	 value = '-((ZA11*(ZEL21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2124 = Coupling(name = 'GC_2124',
	 value = '(ZA21*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2125 = Coupling(name = 'GC_2125',
	 value = '-((ZA21*(ZEL21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2126 = Coupling(name = 'GC_2126',
	 value = '(ZA11*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2127 = Coupling(name = 'GC_2127',
	 value = '-((ZA11*(ZEL31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2128 = Coupling(name = 'GC_2128',
	 value = '(ZA21*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2129 = Coupling(name = 'GC_2129',
	 value = '-((ZA21*(ZEL31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2130 = Coupling(name = 'GC_2130',
	 value = '(ZA11*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2131 = Coupling(name = 'GC_2131',
	 value = '-((ZA11*(ZEL31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2132 = Coupling(name = 'GC_2132',
	 value = '(ZA21*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2133 = Coupling(name = 'GC_2133',
	 value = '-((ZA21*(ZEL31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2134 = Coupling(name = 'GC_2134',
	 value = '(ZA11*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2135 = Coupling(name = 'GC_2135',
	 value = '-((ZA11*(ZEL31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2136 = Coupling(name = 'GC_2136',
	 value = '(ZA21*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2137 = Coupling(name = 'GC_2137',
	 value = '-((ZA21*(ZEL31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2138 = Coupling(name = 'GC_2138',
	 value = '(ZA12*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2139 = Coupling(name = 'GC_2139',
	 value = '-((ZA12*(ZUL11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2140 = Coupling(name = 'GC_2140',
	 value = '(ZA22*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2141 = Coupling(name = 'GC_2141',
	 value = '-((ZA22*(ZUL11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2142 = Coupling(name = 'GC_2142',
	 value = '(ZA12*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2143 = Coupling(name = 'GC_2143',
	 value = '-((ZA12*(ZUL11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2144 = Coupling(name = 'GC_2144',
	 value = '(ZA22*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2145 = Coupling(name = 'GC_2145',
	 value = '-((ZA22*(ZUL11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2146 = Coupling(name = 'GC_2146',
	 value = '(ZA12*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2147 = Coupling(name = 'GC_2147',
	 value = '-((ZA12*(ZUL11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2148 = Coupling(name = 'GC_2148',
	 value = '(ZA22*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2149 = Coupling(name = 'GC_2149',
	 value = '-((ZA22*(ZUL11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2150 = Coupling(name = 'GC_2150',
	 value = '(ZA12*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2151 = Coupling(name = 'GC_2151',
	 value = '-((ZA12*(ZUL21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2152 = Coupling(name = 'GC_2152',
	 value = '(ZA22*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2153 = Coupling(name = 'GC_2153',
	 value = '-((ZA22*(ZUL21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2154 = Coupling(name = 'GC_2154',
	 value = '(ZA12*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2155 = Coupling(name = 'GC_2155',
	 value = '-((ZA12*(ZUL21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2156 = Coupling(name = 'GC_2156',
	 value = '(ZA22*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2157 = Coupling(name = 'GC_2157',
	 value = '-((ZA22*(ZUL21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2158 = Coupling(name = 'GC_2158',
	 value = '(ZA12*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2159 = Coupling(name = 'GC_2159',
	 value = '-((ZA12*(ZUL21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2160 = Coupling(name = 'GC_2160',
	 value = '(ZA22*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2161 = Coupling(name = 'GC_2161',
	 value = '-((ZA22*(ZUL21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2162 = Coupling(name = 'GC_2162',
	 value = '(ZA12*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2163 = Coupling(name = 'GC_2163',
	 value = '-((ZA12*(ZUL31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2164 = Coupling(name = 'GC_2164',
	 value = '(ZA22*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2165 = Coupling(name = 'GC_2165',
	 value = '-((ZA22*(ZUL31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2166 = Coupling(name = 'GC_2166',
	 value = '(ZA12*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2167 = Coupling(name = 'GC_2167',
	 value = '-((ZA12*(ZUL31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2168 = Coupling(name = 'GC_2168',
	 value = '(ZA22*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2169 = Coupling(name = 'GC_2169',
	 value = '-((ZA22*(ZUL31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2170 = Coupling(name = 'GC_2170',
	 value = '(ZA12*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2171 = Coupling(name = 'GC_2171',
	 value = '-((ZA12*(ZUL31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2172 = Coupling(name = 'GC_2172',
	 value = '(ZA22*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2173 = Coupling(name = 'GC_2173',
	 value = '-((ZA22*(ZUL31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2))', 
	 order = {'QED':1} ) 
 
GC_2174 = Coupling(name = 'GC_2174',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN11 + g2*ZN12) - 2*g2*UM11*ZN13)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2175 = Coupling(name = 'GC_2175',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2176 = Coupling(name = 'GC_2176',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN11 + g2*ZN12) - 2*g2*UM11*ZN13)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2177 = Coupling(name = 'GC_2177',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2178 = Coupling(name = 'GC_2178',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN11 + g2*ZN12) - 2*g2*UM21*ZN13)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2179 = Coupling(name = 'GC_2179',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2180 = Coupling(name = 'GC_2180',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN11 + g2*ZN12) - 2*g2*UM21*ZN13)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2181 = Coupling(name = 'GC_2181',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2182 = Coupling(name = 'GC_2182',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN21 + g2*ZN22) - 2*g2*UM11*ZN23)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2183 = Coupling(name = 'GC_2183',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2184 = Coupling(name = 'GC_2184',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN21 + g2*ZN22) - 2*g2*UM11*ZN23)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2185 = Coupling(name = 'GC_2185',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2186 = Coupling(name = 'GC_2186',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN21 + g2*ZN22) - 2*g2*UM21*ZN23)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2187 = Coupling(name = 'GC_2187',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2188 = Coupling(name = 'GC_2188',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN21 + g2*ZN22) - 2*g2*UM21*ZN23)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2189 = Coupling(name = 'GC_2189',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2190 = Coupling(name = 'GC_2190',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN31 + g2*ZN32) - 2*g2*UM11*ZN33)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2191 = Coupling(name = 'GC_2191',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2192 = Coupling(name = 'GC_2192',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN31 + g2*ZN32) - 2*g2*UM11*ZN33)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2193 = Coupling(name = 'GC_2193',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2194 = Coupling(name = 'GC_2194',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN31 + g2*ZN32) - 2*g2*UM21*ZN33)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2195 = Coupling(name = 'GC_2195',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2196 = Coupling(name = 'GC_2196',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN31 + g2*ZN32) - 2*g2*UM21*ZN33)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2197 = Coupling(name = 'GC_2197',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2198 = Coupling(name = 'GC_2198',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN41 + g2*ZN42) - 2*g2*UM11*ZN43)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2199 = Coupling(name = 'GC_2199',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2200 = Coupling(name = 'GC_2200',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM12*(g1*ZN41 + g2*ZN42) - 2*g2*UM11*ZN43)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2201 = Coupling(name = 'GC_2201',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP12)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) + 2*g2*complexconjugate(UP11)*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2202 = Coupling(name = 'GC_2202',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN41 + g2*ZN42) - 2*g2*UM21*ZN43)*ZP11', 
	 order = {'QED':1} ) 
 
GC_2203 = Coupling(name = 'GC_2203',
	 value = '-1./2.*complex(0,1)*ZP12*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2204 = Coupling(name = 'GC_2204',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*UM22*(g1*ZN41 + g2*ZN42) - 2*g2*UM21*ZN43)*ZP21', 
	 order = {'QED':1} ) 
 
GC_2205 = Coupling(name = 'GC_2205',
	 value = '-1./2.*complex(0,1)*ZP22*(cmath.sqrt(2)*complexconjugate(UP22)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) + 2*g2*complexconjugate(UP21)*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2206 = Coupling(name = 'GC_2206',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD11*complexconjugate(ZUL11) + ZD12*complexconjugate(ZUL12) + ZD13*complexconjugate(ZUL13)) - UM12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZUL11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZUL12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2207 = Coupling(name = 'GC_2207',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2208 = Coupling(name = 'GC_2208',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD21*complexconjugate(ZUL11) + ZD22*complexconjugate(ZUL12) + ZD23*complexconjugate(ZUL13)) - UM12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZUL11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZUL12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2209 = Coupling(name = 'GC_2209',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2210 = Coupling(name = 'GC_2210',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD31*complexconjugate(ZUL11) + ZD32*complexconjugate(ZUL12) + ZD33*complexconjugate(ZUL13)) - UM12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZUL11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZUL12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2211 = Coupling(name = 'GC_2211',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2212 = Coupling(name = 'GC_2212',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD41*complexconjugate(ZUL11) + ZD42*complexconjugate(ZUL12) + ZD43*complexconjugate(ZUL13)) - UM12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZUL11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZUL12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2213 = Coupling(name = 'GC_2213',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD41*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD42*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD43*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2214 = Coupling(name = 'GC_2214',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD51*complexconjugate(ZUL11) + ZD52*complexconjugate(ZUL12) + ZD53*complexconjugate(ZUL13)) - UM12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZUL11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZUL12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2215 = Coupling(name = 'GC_2215',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD51*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD52*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD53*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2216 = Coupling(name = 'GC_2216',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD61*complexconjugate(ZUL11) + ZD62*complexconjugate(ZUL12) + ZD63*complexconjugate(ZUL13)) - UM12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZUL11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZUL12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2217 = Coupling(name = 'GC_2217',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD61*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD62*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD63*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2218 = Coupling(name = 'GC_2218',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD11*complexconjugate(ZUL21) + ZD12*complexconjugate(ZUL22) + ZD13*complexconjugate(ZUL23)) - UM12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZUL21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZUL22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2219 = Coupling(name = 'GC_2219',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2220 = Coupling(name = 'GC_2220',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD21*complexconjugate(ZUL21) + ZD22*complexconjugate(ZUL22) + ZD23*complexconjugate(ZUL23)) - UM12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZUL21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZUL22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2221 = Coupling(name = 'GC_2221',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2222 = Coupling(name = 'GC_2222',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD31*complexconjugate(ZUL21) + ZD32*complexconjugate(ZUL22) + ZD33*complexconjugate(ZUL23)) - UM12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZUL21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZUL22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2223 = Coupling(name = 'GC_2223',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2224 = Coupling(name = 'GC_2224',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD41*complexconjugate(ZUL21) + ZD42*complexconjugate(ZUL22) + ZD43*complexconjugate(ZUL23)) - UM12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZUL21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZUL22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2225 = Coupling(name = 'GC_2225',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD41*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD42*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD43*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2226 = Coupling(name = 'GC_2226',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD51*complexconjugate(ZUL21) + ZD52*complexconjugate(ZUL22) + ZD53*complexconjugate(ZUL23)) - UM12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZUL21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZUL22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2227 = Coupling(name = 'GC_2227',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD51*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD52*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD53*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2228 = Coupling(name = 'GC_2228',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD61*complexconjugate(ZUL21) + ZD62*complexconjugate(ZUL22) + ZD63*complexconjugate(ZUL23)) - UM12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZUL21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZUL22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2229 = Coupling(name = 'GC_2229',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD61*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD62*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD63*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2230 = Coupling(name = 'GC_2230',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD11*complexconjugate(ZUL31) + ZD12*complexconjugate(ZUL32) + ZD13*complexconjugate(ZUL33)) - UM12*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZUL31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZUL32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2231 = Coupling(name = 'GC_2231',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2232 = Coupling(name = 'GC_2232',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD21*complexconjugate(ZUL31) + ZD22*complexconjugate(ZUL32) + ZD23*complexconjugate(ZUL33)) - UM12*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZUL31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZUL32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2233 = Coupling(name = 'GC_2233',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2234 = Coupling(name = 'GC_2234',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD31*complexconjugate(ZUL31) + ZD32*complexconjugate(ZUL32) + ZD33*complexconjugate(ZUL33)) - UM12*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZUL31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZUL32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2235 = Coupling(name = 'GC_2235',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2236 = Coupling(name = 'GC_2236',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD41*complexconjugate(ZUL31) + ZD42*complexconjugate(ZUL32) + ZD43*complexconjugate(ZUL33)) - UM12*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZUL31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZUL32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2237 = Coupling(name = 'GC_2237',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD41*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD42*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD43*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2238 = Coupling(name = 'GC_2238',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD51*complexconjugate(ZUL31) + ZD52*complexconjugate(ZUL32) + ZD53*complexconjugate(ZUL33)) - UM12*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZUL31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZUL32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2239 = Coupling(name = 'GC_2239',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD51*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD52*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD53*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2240 = Coupling(name = 'GC_2240',
	 value = '-1*complex(0,1)*(g2*UM11*(ZD61*complexconjugate(ZUL31) + ZD62*complexconjugate(ZUL32) + ZD63*complexconjugate(ZUL33)) - UM12*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZUL31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZUL32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2241 = Coupling(name = 'GC_2241',
	 value = '1*complex(0,1)*complexconjugate(UP12)*(ZD61*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD62*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD63*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2242 = Coupling(name = 'GC_2242',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD11*complexconjugate(ZUL11) + ZD12*complexconjugate(ZUL12) + ZD13*complexconjugate(ZUL13)) - UM22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZUL11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZUL12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2243 = Coupling(name = 'GC_2243',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2244 = Coupling(name = 'GC_2244',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD21*complexconjugate(ZUL11) + ZD22*complexconjugate(ZUL12) + ZD23*complexconjugate(ZUL13)) - UM22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZUL11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZUL12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2245 = Coupling(name = 'GC_2245',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2246 = Coupling(name = 'GC_2246',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD31*complexconjugate(ZUL11) + ZD32*complexconjugate(ZUL12) + ZD33*complexconjugate(ZUL13)) - UM22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZUL11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZUL12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2247 = Coupling(name = 'GC_2247',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2248 = Coupling(name = 'GC_2248',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD41*complexconjugate(ZUL11) + ZD42*complexconjugate(ZUL12) + ZD43*complexconjugate(ZUL13)) - UM22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZUL11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZUL12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2249 = Coupling(name = 'GC_2249',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD41*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD42*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD43*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2250 = Coupling(name = 'GC_2250',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD51*complexconjugate(ZUL11) + ZD52*complexconjugate(ZUL12) + ZD53*complexconjugate(ZUL13)) - UM22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZUL11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZUL12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2251 = Coupling(name = 'GC_2251',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD51*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD52*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD53*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2252 = Coupling(name = 'GC_2252',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD61*complexconjugate(ZUL11) + ZD62*complexconjugate(ZUL12) + ZD63*complexconjugate(ZUL13)) - UM22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZUL11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZUL12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2253 = Coupling(name = 'GC_2253',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD61*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZD62*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZD63*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2254 = Coupling(name = 'GC_2254',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD11*complexconjugate(ZUL21) + ZD12*complexconjugate(ZUL22) + ZD13*complexconjugate(ZUL23)) - UM22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZUL21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZUL22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2255 = Coupling(name = 'GC_2255',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2256 = Coupling(name = 'GC_2256',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD21*complexconjugate(ZUL21) + ZD22*complexconjugate(ZUL22) + ZD23*complexconjugate(ZUL23)) - UM22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZUL21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZUL22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2257 = Coupling(name = 'GC_2257',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2258 = Coupling(name = 'GC_2258',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD31*complexconjugate(ZUL21) + ZD32*complexconjugate(ZUL22) + ZD33*complexconjugate(ZUL23)) - UM22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZUL21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZUL22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2259 = Coupling(name = 'GC_2259',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2260 = Coupling(name = 'GC_2260',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD41*complexconjugate(ZUL21) + ZD42*complexconjugate(ZUL22) + ZD43*complexconjugate(ZUL23)) - UM22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZUL21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZUL22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2261 = Coupling(name = 'GC_2261',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD41*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD42*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD43*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2262 = Coupling(name = 'GC_2262',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD51*complexconjugate(ZUL21) + ZD52*complexconjugate(ZUL22) + ZD53*complexconjugate(ZUL23)) - UM22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZUL21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZUL22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2263 = Coupling(name = 'GC_2263',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD51*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD52*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD53*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2264 = Coupling(name = 'GC_2264',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD61*complexconjugate(ZUL21) + ZD62*complexconjugate(ZUL22) + ZD63*complexconjugate(ZUL23)) - UM22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZUL21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZUL22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2265 = Coupling(name = 'GC_2265',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD61*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZD62*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZD63*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2266 = Coupling(name = 'GC_2266',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD11*complexconjugate(ZUL31) + ZD12*complexconjugate(ZUL32) + ZD13*complexconjugate(ZUL33)) - UM22*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZUL31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZUL32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2267 = Coupling(name = 'GC_2267',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2268 = Coupling(name = 'GC_2268',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD21*complexconjugate(ZUL31) + ZD22*complexconjugate(ZUL32) + ZD23*complexconjugate(ZUL33)) - UM22*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZUL31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZUL32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2269 = Coupling(name = 'GC_2269',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2270 = Coupling(name = 'GC_2270',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD31*complexconjugate(ZUL31) + ZD32*complexconjugate(ZUL32) + ZD33*complexconjugate(ZUL33)) - UM22*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZUL31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZUL32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2271 = Coupling(name = 'GC_2271',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2272 = Coupling(name = 'GC_2272',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD41*complexconjugate(ZUL31) + ZD42*complexconjugate(ZUL32) + ZD43*complexconjugate(ZUL33)) - UM22*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZUL31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZUL32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2273 = Coupling(name = 'GC_2273',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD41*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD42*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD43*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2274 = Coupling(name = 'GC_2274',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD51*complexconjugate(ZUL31) + ZD52*complexconjugate(ZUL32) + ZD53*complexconjugate(ZUL33)) - UM22*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZUL31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZUL32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2275 = Coupling(name = 'GC_2275',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD51*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD52*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD53*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2276 = Coupling(name = 'GC_2276',
	 value = '-1*complex(0,1)*(g2*UM21*(ZD61*complexconjugate(ZUL31) + ZD62*complexconjugate(ZUL32) + ZD63*complexconjugate(ZUL33)) - UM22*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZUL31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZUL32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2277 = Coupling(name = 'GC_2277',
	 value = '1*complex(0,1)*complexconjugate(UP22)*(ZD61*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZD62*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZD63*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_2278 = Coupling(name = 'GC_2278',
	 value = '1*complex(0,1)*(UM12*(Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16) - g2*UM11*complexconjugate(ZE11))', 
	 order = {'QED':1} ) 
 
GC_2279 = Coupling(name = 'GC_2279',
	 value = '1*complex(0,1)*(UM12*(Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26) - g2*UM11*complexconjugate(ZE21))', 
	 order = {'QED':1} ) 
 
GC_2280 = Coupling(name = 'GC_2280',
	 value = '1*complex(0,1)*(UM12*(Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36) - g2*UM11*complexconjugate(ZE31))', 
	 order = {'QED':1} ) 
 
GC_2281 = Coupling(name = 'GC_2281',
	 value = '1*complex(0,1)*(UM12*(Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46) - g2*UM11*complexconjugate(ZE41))', 
	 order = {'QED':1} ) 
 
GC_2282 = Coupling(name = 'GC_2282',
	 value = '1*complex(0,1)*(UM12*(Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56) - g2*UM11*complexconjugate(ZE51))', 
	 order = {'QED':1} ) 
 
GC_2283 = Coupling(name = 'GC_2283',
	 value = '1*complex(0,1)*(UM12*(Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66) - g2*UM11*complexconjugate(ZE61))', 
	 order = {'QED':1} ) 
 
GC_2284 = Coupling(name = 'GC_2284',
	 value = '1*complex(0,1)*(UM12*(Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16) - g2*UM11*complexconjugate(ZE12))', 
	 order = {'QED':1} ) 
 
GC_2285 = Coupling(name = 'GC_2285',
	 value = '1*complex(0,1)*(UM12*(Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26) - g2*UM11*complexconjugate(ZE22))', 
	 order = {'QED':1} ) 
 
GC_2286 = Coupling(name = 'GC_2286',
	 value = '1*complex(0,1)*(UM12*(Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36) - g2*UM11*complexconjugate(ZE32))', 
	 order = {'QED':1} ) 
 
GC_2287 = Coupling(name = 'GC_2287',
	 value = '1*complex(0,1)*(UM12*(Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46) - g2*UM11*complexconjugate(ZE42))', 
	 order = {'QED':1} ) 
 
GC_2288 = Coupling(name = 'GC_2288',
	 value = '1*complex(0,1)*(UM12*(Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56) - g2*UM11*complexconjugate(ZE52))', 
	 order = {'QED':1} ) 
 
GC_2289 = Coupling(name = 'GC_2289',
	 value = '1*complex(0,1)*(UM12*(Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66) - g2*UM11*complexconjugate(ZE62))', 
	 order = {'QED':1} ) 
 
GC_2290 = Coupling(name = 'GC_2290',
	 value = '1*complex(0,1)*(UM12*(Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16) - g2*UM11*complexconjugate(ZE13))', 
	 order = {'QED':1} ) 
 
GC_2291 = Coupling(name = 'GC_2291',
	 value = '1*complex(0,1)*(UM12*(Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26) - g2*UM11*complexconjugate(ZE23))', 
	 order = {'QED':1} ) 
 
GC_2292 = Coupling(name = 'GC_2292',
	 value = '1*complex(0,1)*(UM12*(Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36) - g2*UM11*complexconjugate(ZE33))', 
	 order = {'QED':1} ) 
 
GC_2293 = Coupling(name = 'GC_2293',
	 value = '1*complex(0,1)*(UM12*(Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46) - g2*UM11*complexconjugate(ZE43))', 
	 order = {'QED':1} ) 
 
GC_2294 = Coupling(name = 'GC_2294',
	 value = '1*complex(0,1)*(UM12*(Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56) - g2*UM11*complexconjugate(ZE53))', 
	 order = {'QED':1} ) 
 
GC_2295 = Coupling(name = 'GC_2295',
	 value = '1*complex(0,1)*(UM12*(Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66) - g2*UM11*complexconjugate(ZE63))', 
	 order = {'QED':1} ) 
 
GC_2296 = Coupling(name = 'GC_2296',
	 value = '1*complex(0,1)*(UM22*(Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16) - g2*UM21*complexconjugate(ZE11))', 
	 order = {'QED':1} ) 
 
GC_2297 = Coupling(name = 'GC_2297',
	 value = '1*complex(0,1)*(UM22*(Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26) - g2*UM21*complexconjugate(ZE21))', 
	 order = {'QED':1} ) 
 
GC_2298 = Coupling(name = 'GC_2298',
	 value = '1*complex(0,1)*(UM22*(Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36) - g2*UM21*complexconjugate(ZE31))', 
	 order = {'QED':1} ) 
 
GC_2299 = Coupling(name = 'GC_2299',
	 value = '1*complex(0,1)*(UM22*(Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46) - g2*UM21*complexconjugate(ZE41))', 
	 order = {'QED':1} ) 
 
GC_2300 = Coupling(name = 'GC_2300',
	 value = '1*complex(0,1)*(UM22*(Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56) - g2*UM21*complexconjugate(ZE51))', 
	 order = {'QED':1} ) 
 
GC_2301 = Coupling(name = 'GC_2301',
	 value = '1*complex(0,1)*(UM22*(Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66) - g2*UM21*complexconjugate(ZE61))', 
	 order = {'QED':1} ) 
 
GC_2302 = Coupling(name = 'GC_2302',
	 value = '1*complex(0,1)*(UM22*(Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16) - g2*UM21*complexconjugate(ZE12))', 
	 order = {'QED':1} ) 
 
GC_2303 = Coupling(name = 'GC_2303',
	 value = '1*complex(0,1)*(UM22*(Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26) - g2*UM21*complexconjugate(ZE22))', 
	 order = {'QED':1} ) 
 
GC_2304 = Coupling(name = 'GC_2304',
	 value = '1*complex(0,1)*(UM22*(Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36) - g2*UM21*complexconjugate(ZE32))', 
	 order = {'QED':1} ) 
 
GC_2305 = Coupling(name = 'GC_2305',
	 value = '1*complex(0,1)*(UM22*(Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46) - g2*UM21*complexconjugate(ZE42))', 
	 order = {'QED':1} ) 
 
GC_2306 = Coupling(name = 'GC_2306',
	 value = '1*complex(0,1)*(UM22*(Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56) - g2*UM21*complexconjugate(ZE52))', 
	 order = {'QED':1} ) 
 
GC_2307 = Coupling(name = 'GC_2307',
	 value = '1*complex(0,1)*(UM22*(Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66) - g2*UM21*complexconjugate(ZE62))', 
	 order = {'QED':1} ) 
 
GC_2308 = Coupling(name = 'GC_2308',
	 value = '1*complex(0,1)*(UM22*(Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16) - g2*UM21*complexconjugate(ZE13))', 
	 order = {'QED':1} ) 
 
GC_2309 = Coupling(name = 'GC_2309',
	 value = '1*complex(0,1)*(UM22*(Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26) - g2*UM21*complexconjugate(ZE23))', 
	 order = {'QED':1} ) 
 
GC_2310 = Coupling(name = 'GC_2310',
	 value = '1*complex(0,1)*(UM22*(Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36) - g2*UM21*complexconjugate(ZE33))', 
	 order = {'QED':1} ) 
 
GC_2311 = Coupling(name = 'GC_2311',
	 value = '1*complex(0,1)*(UM22*(Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46) - g2*UM21*complexconjugate(ZE43))', 
	 order = {'QED':1} ) 
 
GC_2312 = Coupling(name = 'GC_2312',
	 value = '1*complex(0,1)*(UM22*(Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56) - g2*UM21*complexconjugate(ZE53))', 
	 order = {'QED':1} ) 
 
GC_2313 = Coupling(name = 'GC_2313',
	 value = '1*complex(0,1)*(UM22*(Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66) - g2*UM21*complexconjugate(ZE63))', 
	 order = {'QED':1} ) 
 
GC_2314 = Coupling(name = 'GC_2314',
	 value = '(-1*complex(0,1)*g2*(UM12*UP11*ZH11 + UM11*UP12*ZH12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2315 = Coupling(name = 'GC_2315',
	 value = '(-1*complex(0,1)*g2*(ZH11*complexconjugate(UM12)*complexconjugate(UP11) + ZH12*complexconjugate(UM11)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2316 = Coupling(name = 'GC_2316',
	 value = '(-1*complex(0,1)*g2*(UM12*UP11*ZH21 + UM11*UP12*ZH22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2317 = Coupling(name = 'GC_2317',
	 value = '(-1*complex(0,1)*g2*(ZH21*complexconjugate(UM12)*complexconjugate(UP11) + ZH22*complexconjugate(UM11)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2318 = Coupling(name = 'GC_2318',
	 value = '(-1*complex(0,1)*g2*(UM22*UP11*ZH11 + UM21*UP12*ZH12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2319 = Coupling(name = 'GC_2319',
	 value = '(-1*complex(0,1)*g2*(ZH11*complexconjugate(UM12)*complexconjugate(UP21) + ZH12*complexconjugate(UM11)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2320 = Coupling(name = 'GC_2320',
	 value = '(-1*complex(0,1)*g2*(UM22*UP11*ZH21 + UM21*UP12*ZH22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2321 = Coupling(name = 'GC_2321',
	 value = '(-1*complex(0,1)*g2*(ZH21*complexconjugate(UM12)*complexconjugate(UP21) + ZH22*complexconjugate(UM11)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2322 = Coupling(name = 'GC_2322',
	 value = '(-1*complex(0,1)*g2*(UM12*UP21*ZH11 + UM11*UP22*ZH12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2323 = Coupling(name = 'GC_2323',
	 value = '(-1*complex(0,1)*g2*(ZH11*complexconjugate(UM22)*complexconjugate(UP11) + ZH12*complexconjugate(UM21)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2324 = Coupling(name = 'GC_2324',
	 value = '(-1*complex(0,1)*g2*(UM12*UP21*ZH21 + UM11*UP22*ZH22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2325 = Coupling(name = 'GC_2325',
	 value = '(-1*complex(0,1)*g2*(ZH21*complexconjugate(UM22)*complexconjugate(UP11) + ZH22*complexconjugate(UM21)*complexconjugate(UP12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2326 = Coupling(name = 'GC_2326',
	 value = '(-1*complex(0,1)*g2*(UM22*UP21*ZH11 + UM21*UP22*ZH12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2327 = Coupling(name = 'GC_2327',
	 value = '(-1*complex(0,1)*g2*(ZH11*complexconjugate(UM22)*complexconjugate(UP21) + ZH12*complexconjugate(UM21)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2328 = Coupling(name = 'GC_2328',
	 value = '(-1*complex(0,1)*g2*(UM22*UP21*ZH21 + UM21*UP22*ZH22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2329 = Coupling(name = 'GC_2329',
	 value = '(-1*complex(0,1)*g2*(ZH21*complexconjugate(UM22)*complexconjugate(UP21) + ZH22*complexconjugate(UM21)*complexconjugate(UP22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2330 = Coupling(name = 'GC_2330',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU11) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU12) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU13))', 
	 order = {'QED':1} ) 
 
GC_2331 = Coupling(name = 'GC_2331',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL11*complexconjugate(ZU11) + ZDL12*complexconjugate(ZU12) + ZDL13*complexconjugate(ZU13)) - complexconjugate(UP12)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_2332 = Coupling(name = 'GC_2332',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU21) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU22) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU23))', 
	 order = {'QED':1} ) 
 
GC_2333 = Coupling(name = 'GC_2333',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL11*complexconjugate(ZU21) + ZDL12*complexconjugate(ZU22) + ZDL13*complexconjugate(ZU23)) - complexconjugate(UP12)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_2334 = Coupling(name = 'GC_2334',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU31) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU32) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU33))', 
	 order = {'QED':1} ) 
 
GC_2335 = Coupling(name = 'GC_2335',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL11*complexconjugate(ZU31) + ZDL12*complexconjugate(ZU32) + ZDL13*complexconjugate(ZU33)) - complexconjugate(UP12)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_2336 = Coupling(name = 'GC_2336',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU41) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU42) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU43))', 
	 order = {'QED':1} ) 
 
GC_2337 = Coupling(name = 'GC_2337',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL11*complexconjugate(ZU41) + ZDL12*complexconjugate(ZU42) + ZDL13*complexconjugate(ZU43)) - complexconjugate(UP12)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_2338 = Coupling(name = 'GC_2338',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU51) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU52) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU53))', 
	 order = {'QED':1} ) 
 
GC_2339 = Coupling(name = 'GC_2339',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL11*complexconjugate(ZU51) + ZDL12*complexconjugate(ZU52) + ZDL13*complexconjugate(ZU53)) - complexconjugate(UP12)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_2340 = Coupling(name = 'GC_2340',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU61) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU62) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU63))', 
	 order = {'QED':1} ) 
 
GC_2341 = Coupling(name = 'GC_2341',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL11*complexconjugate(ZU61) + ZDL12*complexconjugate(ZU62) + ZDL13*complexconjugate(ZU63)) - complexconjugate(UP12)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_2342 = Coupling(name = 'GC_2342',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU11) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU12) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU13))', 
	 order = {'QED':1} ) 
 
GC_2343 = Coupling(name = 'GC_2343',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL11*complexconjugate(ZU11) + ZDL12*complexconjugate(ZU12) + ZDL13*complexconjugate(ZU13)) - complexconjugate(UP22)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_2344 = Coupling(name = 'GC_2344',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU21) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU22) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU23))', 
	 order = {'QED':1} ) 
 
GC_2345 = Coupling(name = 'GC_2345',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL11*complexconjugate(ZU21) + ZDL12*complexconjugate(ZU22) + ZDL13*complexconjugate(ZU23)) - complexconjugate(UP22)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_2346 = Coupling(name = 'GC_2346',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU31) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU32) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU33))', 
	 order = {'QED':1} ) 
 
GC_2347 = Coupling(name = 'GC_2347',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL11*complexconjugate(ZU31) + ZDL12*complexconjugate(ZU32) + ZDL13*complexconjugate(ZU33)) - complexconjugate(UP22)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_2348 = Coupling(name = 'GC_2348',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU41) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU42) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU43))', 
	 order = {'QED':1} ) 
 
GC_2349 = Coupling(name = 'GC_2349',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL11*complexconjugate(ZU41) + ZDL12*complexconjugate(ZU42) + ZDL13*complexconjugate(ZU43)) - complexconjugate(UP22)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_2350 = Coupling(name = 'GC_2350',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU51) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU52) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU53))', 
	 order = {'QED':1} ) 
 
GC_2351 = Coupling(name = 'GC_2351',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL11*complexconjugate(ZU51) + ZDL12*complexconjugate(ZU52) + ZDL13*complexconjugate(ZU53)) - complexconjugate(UP22)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_2352 = Coupling(name = 'GC_2352',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZU61) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZU62) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZU63))', 
	 order = {'QED':1} ) 
 
GC_2353 = Coupling(name = 'GC_2353',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL11*complexconjugate(ZU61) + ZDL12*complexconjugate(ZU62) + ZDL13*complexconjugate(ZU63)) - complexconjugate(UP22)*(ZDL11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZDL12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZDL13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_2354 = Coupling(name = 'GC_2354',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU11) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU12) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU13))', 
	 order = {'QED':1} ) 
 
GC_2355 = Coupling(name = 'GC_2355',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL21*complexconjugate(ZU11) + ZDL22*complexconjugate(ZU12) + ZDL23*complexconjugate(ZU13)) - complexconjugate(UP12)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_2356 = Coupling(name = 'GC_2356',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU21) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU22) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU23))', 
	 order = {'QED':1} ) 
 
GC_2357 = Coupling(name = 'GC_2357',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL21*complexconjugate(ZU21) + ZDL22*complexconjugate(ZU22) + ZDL23*complexconjugate(ZU23)) - complexconjugate(UP12)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_2358 = Coupling(name = 'GC_2358',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU31) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU32) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU33))', 
	 order = {'QED':1} ) 
 
GC_2359 = Coupling(name = 'GC_2359',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL21*complexconjugate(ZU31) + ZDL22*complexconjugate(ZU32) + ZDL23*complexconjugate(ZU33)) - complexconjugate(UP12)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_2360 = Coupling(name = 'GC_2360',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU41) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU42) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU43))', 
	 order = {'QED':1} ) 
 
GC_2361 = Coupling(name = 'GC_2361',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL21*complexconjugate(ZU41) + ZDL22*complexconjugate(ZU42) + ZDL23*complexconjugate(ZU43)) - complexconjugate(UP12)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_2362 = Coupling(name = 'GC_2362',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU51) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU52) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU53))', 
	 order = {'QED':1} ) 
 
GC_2363 = Coupling(name = 'GC_2363',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL21*complexconjugate(ZU51) + ZDL22*complexconjugate(ZU52) + ZDL23*complexconjugate(ZU53)) - complexconjugate(UP12)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_2364 = Coupling(name = 'GC_2364',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU61) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU62) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU63))', 
	 order = {'QED':1} ) 
 
GC_2365 = Coupling(name = 'GC_2365',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL21*complexconjugate(ZU61) + ZDL22*complexconjugate(ZU62) + ZDL23*complexconjugate(ZU63)) - complexconjugate(UP12)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_2366 = Coupling(name = 'GC_2366',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU11) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU12) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU13))', 
	 order = {'QED':1} ) 
 
GC_2367 = Coupling(name = 'GC_2367',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL21*complexconjugate(ZU11) + ZDL22*complexconjugate(ZU12) + ZDL23*complexconjugate(ZU13)) - complexconjugate(UP22)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_2368 = Coupling(name = 'GC_2368',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU21) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU22) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU23))', 
	 order = {'QED':1} ) 
 
GC_2369 = Coupling(name = 'GC_2369',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL21*complexconjugate(ZU21) + ZDL22*complexconjugate(ZU22) + ZDL23*complexconjugate(ZU23)) - complexconjugate(UP22)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_2370 = Coupling(name = 'GC_2370',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU31) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU32) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU33))', 
	 order = {'QED':1} ) 
 
GC_2371 = Coupling(name = 'GC_2371',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL21*complexconjugate(ZU31) + ZDL22*complexconjugate(ZU32) + ZDL23*complexconjugate(ZU33)) - complexconjugate(UP22)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_2372 = Coupling(name = 'GC_2372',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU41) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU42) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU43))', 
	 order = {'QED':1} ) 
 
GC_2373 = Coupling(name = 'GC_2373',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL21*complexconjugate(ZU41) + ZDL22*complexconjugate(ZU42) + ZDL23*complexconjugate(ZU43)) - complexconjugate(UP22)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_2374 = Coupling(name = 'GC_2374',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU51) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU52) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU53))', 
	 order = {'QED':1} ) 
 
GC_2375 = Coupling(name = 'GC_2375',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL21*complexconjugate(ZU51) + ZDL22*complexconjugate(ZU52) + ZDL23*complexconjugate(ZU53)) - complexconjugate(UP22)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_2376 = Coupling(name = 'GC_2376',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZU61) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZU62) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZU63))', 
	 order = {'QED':1} ) 
 
GC_2377 = Coupling(name = 'GC_2377',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL21*complexconjugate(ZU61) + ZDL22*complexconjugate(ZU62) + ZDL23*complexconjugate(ZU63)) - complexconjugate(UP22)*(ZDL21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZDL22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZDL23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_2378 = Coupling(name = 'GC_2378',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU11) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU12) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU13))', 
	 order = {'QED':1} ) 
 
GC_2379 = Coupling(name = 'GC_2379',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL31*complexconjugate(ZU11) + ZDL32*complexconjugate(ZU12) + ZDL33*complexconjugate(ZU13)) - complexconjugate(UP12)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_2380 = Coupling(name = 'GC_2380',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU21) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU22) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU23))', 
	 order = {'QED':1} ) 
 
GC_2381 = Coupling(name = 'GC_2381',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL31*complexconjugate(ZU21) + ZDL32*complexconjugate(ZU22) + ZDL33*complexconjugate(ZU23)) - complexconjugate(UP12)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_2382 = Coupling(name = 'GC_2382',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU31) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU32) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU33))', 
	 order = {'QED':1} ) 
 
GC_2383 = Coupling(name = 'GC_2383',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL31*complexconjugate(ZU31) + ZDL32*complexconjugate(ZU32) + ZDL33*complexconjugate(ZU33)) - complexconjugate(UP12)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_2384 = Coupling(name = 'GC_2384',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU41) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU42) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU43))', 
	 order = {'QED':1} ) 
 
GC_2385 = Coupling(name = 'GC_2385',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL31*complexconjugate(ZU41) + ZDL32*complexconjugate(ZU42) + ZDL33*complexconjugate(ZU43)) - complexconjugate(UP12)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_2386 = Coupling(name = 'GC_2386',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU51) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU52) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU53))', 
	 order = {'QED':1} ) 
 
GC_2387 = Coupling(name = 'GC_2387',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL31*complexconjugate(ZU51) + ZDL32*complexconjugate(ZU52) + ZDL33*complexconjugate(ZU53)) - complexconjugate(UP12)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_2388 = Coupling(name = 'GC_2388',
	 value = '1*complex(0,1)*UM12*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU61) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU62) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU63))', 
	 order = {'QED':1} ) 
 
GC_2389 = Coupling(name = 'GC_2389',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP11)*(ZDL31*complexconjugate(ZU61) + ZDL32*complexconjugate(ZU62) + ZDL33*complexconjugate(ZU63)) - complexconjugate(UP12)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_2390 = Coupling(name = 'GC_2390',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU11) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU12) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU13))', 
	 order = {'QED':1} ) 
 
GC_2391 = Coupling(name = 'GC_2391',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL31*complexconjugate(ZU11) + ZDL32*complexconjugate(ZU12) + ZDL33*complexconjugate(ZU13)) - complexconjugate(UP22)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_2392 = Coupling(name = 'GC_2392',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU21) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU22) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU23))', 
	 order = {'QED':1} ) 
 
GC_2393 = Coupling(name = 'GC_2393',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL31*complexconjugate(ZU21) + ZDL32*complexconjugate(ZU22) + ZDL33*complexconjugate(ZU23)) - complexconjugate(UP22)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_2394 = Coupling(name = 'GC_2394',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU31) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU32) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU33))', 
	 order = {'QED':1} ) 
 
GC_2395 = Coupling(name = 'GC_2395',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL31*complexconjugate(ZU31) + ZDL32*complexconjugate(ZU32) + ZDL33*complexconjugate(ZU33)) - complexconjugate(UP22)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_2396 = Coupling(name = 'GC_2396',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU41) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU42) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU43))', 
	 order = {'QED':1} ) 
 
GC_2397 = Coupling(name = 'GC_2397',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL31*complexconjugate(ZU41) + ZDL32*complexconjugate(ZU42) + ZDL33*complexconjugate(ZU43)) - complexconjugate(UP22)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_2398 = Coupling(name = 'GC_2398',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU51) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU52) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU53))', 
	 order = {'QED':1} ) 
 
GC_2399 = Coupling(name = 'GC_2399',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL31*complexconjugate(ZU51) + ZDL32*complexconjugate(ZU52) + ZDL33*complexconjugate(ZU53)) - complexconjugate(UP22)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_2400 = Coupling(name = 'GC_2400',
	 value = '1*complex(0,1)*UM22*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZU61) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZU62) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZU63))', 
	 order = {'QED':1} ) 
 
GC_2401 = Coupling(name = 'GC_2401',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UP21)*(ZDL31*complexconjugate(ZU61) + ZDL32*complexconjugate(ZU62) + ZDL33*complexconjugate(ZU63)) - complexconjugate(UP22)*(ZDL31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZDL32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZDL33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_2402 = Coupling(name = 'GC_2402',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))*complexconjugate(ZV11) + (Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))*complexconjugate(ZV12) + (Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2403 = Coupling(name = 'GC_2403',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL11*complexconjugate(ZV11) + ZEL12*complexconjugate(ZV12) + ZEL13*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2404 = Coupling(name = 'GC_2404',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))*complexconjugate(ZV21) + (Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))*complexconjugate(ZV22) + (Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2405 = Coupling(name = 'GC_2405',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL11*complexconjugate(ZV21) + ZEL12*complexconjugate(ZV22) + ZEL13*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2406 = Coupling(name = 'GC_2406',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))*complexconjugate(ZV31) + (Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))*complexconjugate(ZV32) + (Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2407 = Coupling(name = 'GC_2407',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL11*complexconjugate(ZV31) + ZEL12*complexconjugate(ZV32) + ZEL13*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2408 = Coupling(name = 'GC_2408',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))*complexconjugate(ZV11) + (Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))*complexconjugate(ZV12) + (Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2409 = Coupling(name = 'GC_2409',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL11*complexconjugate(ZV11) + ZEL12*complexconjugate(ZV12) + ZEL13*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2410 = Coupling(name = 'GC_2410',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))*complexconjugate(ZV21) + (Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))*complexconjugate(ZV22) + (Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2411 = Coupling(name = 'GC_2411',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL11*complexconjugate(ZV21) + ZEL12*complexconjugate(ZV22) + ZEL13*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2412 = Coupling(name = 'GC_2412',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))*complexconjugate(ZV31) + (Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))*complexconjugate(ZV32) + (Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2413 = Coupling(name = 'GC_2413',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL11*complexconjugate(ZV31) + ZEL12*complexconjugate(ZV32) + ZEL13*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2414 = Coupling(name = 'GC_2414',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))*complexconjugate(ZV11) + (Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))*complexconjugate(ZV12) + (Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2415 = Coupling(name = 'GC_2415',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL21*complexconjugate(ZV11) + ZEL22*complexconjugate(ZV12) + ZEL23*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2416 = Coupling(name = 'GC_2416',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))*complexconjugate(ZV21) + (Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))*complexconjugate(ZV22) + (Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2417 = Coupling(name = 'GC_2417',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL21*complexconjugate(ZV21) + ZEL22*complexconjugate(ZV22) + ZEL23*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2418 = Coupling(name = 'GC_2418',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))*complexconjugate(ZV31) + (Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))*complexconjugate(ZV32) + (Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2419 = Coupling(name = 'GC_2419',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL21*complexconjugate(ZV31) + ZEL22*complexconjugate(ZV32) + ZEL23*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2420 = Coupling(name = 'GC_2420',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))*complexconjugate(ZV11) + (Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))*complexconjugate(ZV12) + (Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2421 = Coupling(name = 'GC_2421',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL21*complexconjugate(ZV11) + ZEL22*complexconjugate(ZV12) + ZEL23*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2422 = Coupling(name = 'GC_2422',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))*complexconjugate(ZV21) + (Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))*complexconjugate(ZV22) + (Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2423 = Coupling(name = 'GC_2423',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL21*complexconjugate(ZV21) + ZEL22*complexconjugate(ZV22) + ZEL23*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2424 = Coupling(name = 'GC_2424',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))*complexconjugate(ZV31) + (Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))*complexconjugate(ZV32) + (Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2425 = Coupling(name = 'GC_2425',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL21*complexconjugate(ZV31) + ZEL22*complexconjugate(ZV32) + ZEL23*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2426 = Coupling(name = 'GC_2426',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))*complexconjugate(ZV11) + (Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))*complexconjugate(ZV12) + (Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2427 = Coupling(name = 'GC_2427',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL31*complexconjugate(ZV11) + ZEL32*complexconjugate(ZV12) + ZEL33*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2428 = Coupling(name = 'GC_2428',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))*complexconjugate(ZV21) + (Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))*complexconjugate(ZV22) + (Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2429 = Coupling(name = 'GC_2429',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL31*complexconjugate(ZV21) + ZEL32*complexconjugate(ZV22) + ZEL33*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2430 = Coupling(name = 'GC_2430',
	 value = '1*complex(0,1)*UM12*((Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))*complexconjugate(ZV31) + (Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))*complexconjugate(ZV32) + (Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2431 = Coupling(name = 'GC_2431',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP11)*(ZEL31*complexconjugate(ZV31) + ZEL32*complexconjugate(ZV32) + ZEL33*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2432 = Coupling(name = 'GC_2432',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))*complexconjugate(ZV11) + (Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))*complexconjugate(ZV12) + (Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2433 = Coupling(name = 'GC_2433',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL31*complexconjugate(ZV11) + ZEL32*complexconjugate(ZV12) + ZEL33*complexconjugate(ZV13))', 
	 order = {'QED':1} ) 
 
GC_2434 = Coupling(name = 'GC_2434',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))*complexconjugate(ZV21) + (Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))*complexconjugate(ZV22) + (Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2435 = Coupling(name = 'GC_2435',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL31*complexconjugate(ZV21) + ZEL32*complexconjugate(ZV22) + ZEL33*complexconjugate(ZV23))', 
	 order = {'QED':1} ) 
 
GC_2436 = Coupling(name = 'GC_2436',
	 value = '1*complex(0,1)*UM22*((Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))*complexconjugate(ZV31) + (Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))*complexconjugate(ZV32) + (Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2437 = Coupling(name = 'GC_2437',
	 value = '-1*complex(0,1)*g2*complexconjugate(UP21)*(ZEL31*complexconjugate(ZV31) + ZEL32*complexconjugate(ZV32) + ZEL33*complexconjugate(ZV33))', 
	 order = {'QED':1} ) 
 
GC_2438 = Coupling(name = 'GC_2438',
	 value = '1./2.*complex(0,1)*(-(g2*ZH11*ZN12*ZN13) + ZH11*(g1*ZN11 - g2*ZN12)*ZN13 - g1*ZH12*ZN11*ZN14 + 2*g2*ZH12*ZN12*ZN14 + g1*ZN11*(ZH11*ZN13 - ZH12*ZN14))', 
	 order = {'QED':1} ) 
 
GC_2439 = Coupling(name = 'GC_2439',
	 value = '1./2.*complex(0,1)*(2*ZH11*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN13) + 2*ZH12*(-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2440 = Coupling(name = 'GC_2440',
	 value = '1./2.*complex(0,1)*(-(g2*ZH21*ZN12*ZN13) + ZH21*(g1*ZN11 - g2*ZN12)*ZN13 - g1*ZH22*ZN11*ZN14 + 2*g2*ZH22*ZN12*ZN14 + g1*ZN11*(ZH21*ZN13 - ZH22*ZN14))', 
	 order = {'QED':1} ) 
 
GC_2441 = Coupling(name = 'GC_2441',
	 value = '1./2.*complex(0,1)*(2*ZH21*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN13) + 2*ZH22*(-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2442 = Coupling(name = 'GC_2442',
	 value = '1./2.*complex(0,1)*(-(g1*ZH12*ZN14*ZN21) + g2*ZH12*ZN14*ZN22 + ZH11*ZN13*(g1*ZN21 - g2*ZN22) - g2*ZH11*ZN12*ZN23 + g2*ZH12*ZN12*ZN24 + g1*ZN11*(ZH11*ZN23 - ZH12*ZN24))', 
	 order = {'QED':1} ) 
 
GC_2443 = Coupling(name = 'GC_2443',
	 value = '1./2.*complex(0,1)*(ZH11*(complexconjugate(ZN13)*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN23)) + ZH12*(complexconjugate(ZN14)*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN24)))', 
	 order = {'QED':1} ) 
 
GC_2444 = Coupling(name = 'GC_2444',
	 value = '1./2.*complex(0,1)*(-(g1*ZH22*ZN14*ZN21) + g2*ZH22*ZN14*ZN22 + ZH21*ZN13*(g1*ZN21 - g2*ZN22) - g2*ZH21*ZN12*ZN23 + g2*ZH22*ZN12*ZN24 + g1*ZN11*(ZH21*ZN23 - ZH22*ZN24))', 
	 order = {'QED':1} ) 
 
GC_2445 = Coupling(name = 'GC_2445',
	 value = '1./2.*complex(0,1)*(ZH21*(complexconjugate(ZN13)*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN23)) + ZH22*(complexconjugate(ZN14)*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN24)))', 
	 order = {'QED':1} ) 
 
GC_2446 = Coupling(name = 'GC_2446',
	 value = '1./2.*complex(0,1)*(-(g1*ZH12*ZN14*ZN31) + g2*ZH12*ZN14*ZN32 + ZH11*ZN13*(g1*ZN31 - g2*ZN32) - g2*ZH11*ZN12*ZN33 + g2*ZH12*ZN12*ZN34 + g1*ZN11*(ZH11*ZN33 - ZH12*ZN34))', 
	 order = {'QED':1} ) 
 
GC_2447 = Coupling(name = 'GC_2447',
	 value = '1./2.*complex(0,1)*(ZH11*(complexconjugate(ZN13)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN33)) + ZH12*(complexconjugate(ZN14)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN34)))', 
	 order = {'QED':1} ) 
 
GC_2448 = Coupling(name = 'GC_2448',
	 value = '1./2.*complex(0,1)*(-(g1*ZH22*ZN14*ZN31) + g2*ZH22*ZN14*ZN32 + ZH21*ZN13*(g1*ZN31 - g2*ZN32) - g2*ZH21*ZN12*ZN33 + g2*ZH22*ZN12*ZN34 + g1*ZN11*(ZH21*ZN33 - ZH22*ZN34))', 
	 order = {'QED':1} ) 
 
GC_2449 = Coupling(name = 'GC_2449',
	 value = '1./2.*complex(0,1)*(ZH21*(complexconjugate(ZN13)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN33)) + ZH22*(complexconjugate(ZN14)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN34)))', 
	 order = {'QED':1} ) 
 
GC_2450 = Coupling(name = 'GC_2450',
	 value = '1./2.*complex(0,1)*(-(g1*ZH12*ZN14*ZN41) + g2*ZH12*ZN14*ZN42 + ZH11*ZN13*(g1*ZN41 - g2*ZN42) - g2*ZH11*ZN12*ZN43 + g2*ZH12*ZN12*ZN44 + g1*ZN11*(ZH11*ZN43 - ZH12*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2451 = Coupling(name = 'GC_2451',
	 value = '1./2.*complex(0,1)*(ZH11*(complexconjugate(ZN13)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN43)) + ZH12*(complexconjugate(ZN14)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN44)))', 
	 order = {'QED':1} ) 
 
GC_2452 = Coupling(name = 'GC_2452',
	 value = '1./2.*complex(0,1)*(-(g1*ZH22*ZN14*ZN41) + g2*ZH22*ZN14*ZN42 + ZH21*ZN13*(g1*ZN41 - g2*ZN42) - g2*ZH21*ZN12*ZN43 + g2*ZH22*ZN12*ZN44 + g1*ZN11*(ZH21*ZN43 - ZH22*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2453 = Coupling(name = 'GC_2453',
	 value = '1./2.*complex(0,1)*(ZH21*(complexconjugate(ZN13)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12))*complexconjugate(ZN43)) + ZH22*(complexconjugate(ZN14)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN11)) + g2*complexconjugate(ZN12))*complexconjugate(ZN44)))', 
	 order = {'QED':1} ) 
 
GC_2454 = Coupling(name = 'GC_2454',
	 value = '1./2.*complex(0,1)*(-(g2*ZH11*ZN22*ZN23) + ZH11*(g1*ZN21 - g2*ZN22)*ZN23 - g1*ZH12*ZN21*ZN24 + 2*g2*ZH12*ZN22*ZN24 + g1*ZN21*(ZH11*ZN23 - ZH12*ZN24))', 
	 order = {'QED':1} ) 
 
GC_2455 = Coupling(name = 'GC_2455',
	 value = '1./2.*complex(0,1)*(2*ZH11*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN23) + 2*ZH12*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2456 = Coupling(name = 'GC_2456',
	 value = '1./2.*complex(0,1)*(-(g2*ZH21*ZN22*ZN23) + ZH21*(g1*ZN21 - g2*ZN22)*ZN23 - g1*ZH22*ZN21*ZN24 + 2*g2*ZH22*ZN22*ZN24 + g1*ZN21*(ZH21*ZN23 - ZH22*ZN24))', 
	 order = {'QED':1} ) 
 
GC_2457 = Coupling(name = 'GC_2457',
	 value = '1./2.*complex(0,1)*(2*ZH21*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN23) + 2*ZH22*(-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2458 = Coupling(name = 'GC_2458',
	 value = '1./2.*complex(0,1)*(-(g1*ZH12*ZN24*ZN31) + g2*ZH12*ZN24*ZN32 + ZH11*ZN23*(g1*ZN31 - g2*ZN32) - g2*ZH11*ZN22*ZN33 + g2*ZH12*ZN22*ZN34 + g1*ZN21*(ZH11*ZN33 - ZH12*ZN34))', 
	 order = {'QED':1} ) 
 
GC_2459 = Coupling(name = 'GC_2459',
	 value = '1./2.*complex(0,1)*(ZH11*(complexconjugate(ZN23)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN33)) + ZH12*(complexconjugate(ZN24)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN34)))', 
	 order = {'QED':1} ) 
 
GC_2460 = Coupling(name = 'GC_2460',
	 value = '1./2.*complex(0,1)*(-(g1*ZH22*ZN24*ZN31) + g2*ZH22*ZN24*ZN32 + ZH21*ZN23*(g1*ZN31 - g2*ZN32) - g2*ZH21*ZN22*ZN33 + g2*ZH22*ZN22*ZN34 + g1*ZN21*(ZH21*ZN33 - ZH22*ZN34))', 
	 order = {'QED':1} ) 
 
GC_2461 = Coupling(name = 'GC_2461',
	 value = '1./2.*complex(0,1)*(ZH21*(complexconjugate(ZN23)*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN33)) + ZH22*(complexconjugate(ZN24)*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN34)))', 
	 order = {'QED':1} ) 
 
GC_2462 = Coupling(name = 'GC_2462',
	 value = '1./2.*complex(0,1)*(-(g1*ZH12*ZN24*ZN41) + g2*ZH12*ZN24*ZN42 + ZH11*ZN23*(g1*ZN41 - g2*ZN42) - g2*ZH11*ZN22*ZN43 + g2*ZH12*ZN22*ZN44 + g1*ZN21*(ZH11*ZN43 - ZH12*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2463 = Coupling(name = 'GC_2463',
	 value = '1./2.*complex(0,1)*(ZH11*(complexconjugate(ZN23)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN43)) + ZH12*(complexconjugate(ZN24)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN44)))', 
	 order = {'QED':1} ) 
 
GC_2464 = Coupling(name = 'GC_2464',
	 value = '1./2.*complex(0,1)*(-(g1*ZH22*ZN24*ZN41) + g2*ZH22*ZN24*ZN42 + ZH21*ZN23*(g1*ZN41 - g2*ZN42) - g2*ZH21*ZN22*ZN43 + g2*ZH22*ZN22*ZN44 + g1*ZN21*(ZH21*ZN43 - ZH22*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2465 = Coupling(name = 'GC_2465',
	 value = '1./2.*complex(0,1)*(ZH21*(complexconjugate(ZN23)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22))*complexconjugate(ZN43)) + ZH22*(complexconjugate(ZN24)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN21)) + g2*complexconjugate(ZN22))*complexconjugate(ZN44)))', 
	 order = {'QED':1} ) 
 
GC_2466 = Coupling(name = 'GC_2466',
	 value = '1./2.*complex(0,1)*(-(g2*ZH11*ZN32*ZN33) + ZH11*(g1*ZN31 - g2*ZN32)*ZN33 - g1*ZH12*ZN31*ZN34 + 2*g2*ZH12*ZN32*ZN34 + g1*ZN31*(ZH11*ZN33 - ZH12*ZN34))', 
	 order = {'QED':1} ) 
 
GC_2467 = Coupling(name = 'GC_2467',
	 value = '1./2.*complex(0,1)*(2*ZH11*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN33) + 2*ZH12*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2468 = Coupling(name = 'GC_2468',
	 value = '1./2.*complex(0,1)*(-(g2*ZH21*ZN32*ZN33) + ZH21*(g1*ZN31 - g2*ZN32)*ZN33 - g1*ZH22*ZN31*ZN34 + 2*g2*ZH22*ZN32*ZN34 + g1*ZN31*(ZH21*ZN33 - ZH22*ZN34))', 
	 order = {'QED':1} ) 
 
GC_2469 = Coupling(name = 'GC_2469',
	 value = '1./2.*complex(0,1)*(2*ZH21*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN33) + 2*ZH22*(-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2470 = Coupling(name = 'GC_2470',
	 value = '1./2.*complex(0,1)*(-(g1*ZH12*ZN34*ZN41) + g2*ZH12*ZN34*ZN42 + ZH11*ZN33*(g1*ZN41 - g2*ZN42) - g2*ZH11*ZN32*ZN43 + g2*ZH12*ZN32*ZN44 + g1*ZN31*(ZH11*ZN43 - ZH12*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2471 = Coupling(name = 'GC_2471',
	 value = '1./2.*complex(0,1)*(ZH11*(complexconjugate(ZN33)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN43)) + ZH12*(complexconjugate(ZN34)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN44)))', 
	 order = {'QED':1} ) 
 
GC_2472 = Coupling(name = 'GC_2472',
	 value = '1./2.*complex(0,1)*(-(g1*ZH22*ZN34*ZN41) + g2*ZH22*ZN34*ZN42 + ZH21*ZN33*(g1*ZN41 - g2*ZN42) - g2*ZH21*ZN32*ZN43 + g2*ZH22*ZN32*ZN44 + g1*ZN31*(ZH21*ZN43 - ZH22*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2473 = Coupling(name = 'GC_2473',
	 value = '1./2.*complex(0,1)*(ZH21*(complexconjugate(ZN33)*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)) + (g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32))*complexconjugate(ZN43)) + ZH22*(complexconjugate(ZN34)*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42)) + (-(g1*complexconjugate(ZN31)) + g2*complexconjugate(ZN32))*complexconjugate(ZN44)))', 
	 order = {'QED':1} ) 
 
GC_2474 = Coupling(name = 'GC_2474',
	 value = '1./2.*complex(0,1)*(-(g2*ZH11*ZN42*ZN43) + ZH11*(g1*ZN41 - g2*ZN42)*ZN43 - g1*ZH12*ZN41*ZN44 + 2*g2*ZH12*ZN42*ZN44 + g1*ZN41*(ZH11*ZN43 - ZH12*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2475 = Coupling(name = 'GC_2475',
	 value = '1./2.*complex(0,1)*(2*ZH11*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42))*complexconjugate(ZN43) + 2*ZH12*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2476 = Coupling(name = 'GC_2476',
	 value = '1./2.*complex(0,1)*(-(g2*ZH21*ZN42*ZN43) + ZH21*(g1*ZN41 - g2*ZN42)*ZN43 - g1*ZH22*ZN41*ZN44 + 2*g2*ZH22*ZN42*ZN44 + g1*ZN41*(ZH21*ZN43 - ZH22*ZN44))', 
	 order = {'QED':1} ) 
 
GC_2477 = Coupling(name = 'GC_2477',
	 value = '1./2.*complex(0,1)*(2*ZH21*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42))*complexconjugate(ZN43) + 2*ZH22*(-(g1*complexconjugate(ZN41)) + g2*complexconjugate(ZN42))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2478 = Coupling(name = 'GC_2478',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) + 6*ZN13*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2479 = Coupling(name = 'GC_2479',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR11 + ZD15*ZDR12 + ZD16*ZDR13)*complexconjugate(ZN11) + 3*(ZD11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2480 = Coupling(name = 'GC_2480',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) + 6*ZN13*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2481 = Coupling(name = 'GC_2481',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR11 + ZD25*ZDR12 + ZD26*ZDR13)*complexconjugate(ZN11) + 3*(ZD21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2482 = Coupling(name = 'GC_2482',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) + 6*ZN13*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2483 = Coupling(name = 'GC_2483',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR11 + ZD35*ZDR12 + ZD36*ZDR13)*complexconjugate(ZN11) + 3*(ZD31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2484 = Coupling(name = 'GC_2484',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) + 6*ZN13*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2485 = Coupling(name = 'GC_2485',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR11 + ZD45*ZDR12 + ZD46*ZDR13)*complexconjugate(ZN11) + 3*(ZD41*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD42*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD43*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2486 = Coupling(name = 'GC_2486',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) + 6*ZN13*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2487 = Coupling(name = 'GC_2487',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR11 + ZD55*ZDR12 + ZD56*ZDR13)*complexconjugate(ZN11) + 3*(ZD51*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD52*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD53*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2488 = Coupling(name = 'GC_2488',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) + 6*ZN13*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2489 = Coupling(name = 'GC_2489',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR11 + ZD65*ZDR12 + ZD66*ZDR13)*complexconjugate(ZN11) + 3*(ZD61*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD62*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD63*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2490 = Coupling(name = 'GC_2490',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) + 6*ZN13*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2491 = Coupling(name = 'GC_2491',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR21 + ZD15*ZDR22 + ZD16*ZDR23)*complexconjugate(ZN11) + 3*(ZD11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2492 = Coupling(name = 'GC_2492',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) + 6*ZN13*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2493 = Coupling(name = 'GC_2493',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR21 + ZD25*ZDR22 + ZD26*ZDR23)*complexconjugate(ZN11) + 3*(ZD21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2494 = Coupling(name = 'GC_2494',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) + 6*ZN13*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2495 = Coupling(name = 'GC_2495',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR21 + ZD35*ZDR22 + ZD36*ZDR23)*complexconjugate(ZN11) + 3*(ZD31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2496 = Coupling(name = 'GC_2496',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) + 6*ZN13*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2497 = Coupling(name = 'GC_2497',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR21 + ZD45*ZDR22 + ZD46*ZDR23)*complexconjugate(ZN11) + 3*(ZD41*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD42*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD43*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2498 = Coupling(name = 'GC_2498',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) + 6*ZN13*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2499 = Coupling(name = 'GC_2499',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR21 + ZD55*ZDR22 + ZD56*ZDR23)*complexconjugate(ZN11) + 3*(ZD51*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD52*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD53*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2500 = Coupling(name = 'GC_2500',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) + 6*ZN13*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2501 = Coupling(name = 'GC_2501',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR21 + ZD65*ZDR22 + ZD66*ZDR23)*complexconjugate(ZN11) + 3*(ZD61*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD62*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD63*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2502 = Coupling(name = 'GC_2502',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) + 6*ZN13*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2503 = Coupling(name = 'GC_2503',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR31 + ZD15*ZDR32 + ZD16*ZDR33)*complexconjugate(ZN11) + 3*(ZD11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2504 = Coupling(name = 'GC_2504',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) + 6*ZN13*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2505 = Coupling(name = 'GC_2505',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR31 + ZD25*ZDR32 + ZD26*ZDR33)*complexconjugate(ZN11) + 3*(ZD21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2506 = Coupling(name = 'GC_2506',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) + 6*ZN13*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2507 = Coupling(name = 'GC_2507',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR31 + ZD35*ZDR32 + ZD36*ZDR33)*complexconjugate(ZN11) + 3*(ZD31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2508 = Coupling(name = 'GC_2508',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) + 6*ZN13*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2509 = Coupling(name = 'GC_2509',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR31 + ZD45*ZDR32 + ZD46*ZDR33)*complexconjugate(ZN11) + 3*(ZD41*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD42*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD43*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2510 = Coupling(name = 'GC_2510',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) + 6*ZN13*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2511 = Coupling(name = 'GC_2511',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR31 + ZD55*ZDR32 + ZD56*ZDR33)*complexconjugate(ZN11) + 3*(ZD51*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD52*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD53*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2512 = Coupling(name = 'GC_2512',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN12*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) + 6*ZN13*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2513 = Coupling(name = 'GC_2513',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR31 + ZD65*ZDR32 + ZD66*ZDR33)*complexconjugate(ZN11) + 3*(ZD61*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD62*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD63*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2514 = Coupling(name = 'GC_2514',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) + 6*ZN23*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2515 = Coupling(name = 'GC_2515',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR11 + ZD15*ZDR12 + ZD16*ZDR13)*complexconjugate(ZN21) + 3*(ZD11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2516 = Coupling(name = 'GC_2516',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) + 6*ZN23*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2517 = Coupling(name = 'GC_2517',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR11 + ZD25*ZDR12 + ZD26*ZDR13)*complexconjugate(ZN21) + 3*(ZD21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2518 = Coupling(name = 'GC_2518',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) + 6*ZN23*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2519 = Coupling(name = 'GC_2519',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR11 + ZD35*ZDR12 + ZD36*ZDR13)*complexconjugate(ZN21) + 3*(ZD31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2520 = Coupling(name = 'GC_2520',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) + 6*ZN23*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2521 = Coupling(name = 'GC_2521',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR11 + ZD45*ZDR12 + ZD46*ZDR13)*complexconjugate(ZN21) + 3*(ZD41*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD42*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD43*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2522 = Coupling(name = 'GC_2522',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) + 6*ZN23*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2523 = Coupling(name = 'GC_2523',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR11 + ZD55*ZDR12 + ZD56*ZDR13)*complexconjugate(ZN21) + 3*(ZD51*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD52*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD53*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2524 = Coupling(name = 'GC_2524',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) + 6*ZN23*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2525 = Coupling(name = 'GC_2525',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR11 + ZD65*ZDR12 + ZD66*ZDR13)*complexconjugate(ZN21) + 3*(ZD61*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD62*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD63*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2526 = Coupling(name = 'GC_2526',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) + 6*ZN23*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2527 = Coupling(name = 'GC_2527',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR21 + ZD15*ZDR22 + ZD16*ZDR23)*complexconjugate(ZN21) + 3*(ZD11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2528 = Coupling(name = 'GC_2528',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) + 6*ZN23*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2529 = Coupling(name = 'GC_2529',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR21 + ZD25*ZDR22 + ZD26*ZDR23)*complexconjugate(ZN21) + 3*(ZD21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2530 = Coupling(name = 'GC_2530',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) + 6*ZN23*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2531 = Coupling(name = 'GC_2531',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR21 + ZD35*ZDR22 + ZD36*ZDR23)*complexconjugate(ZN21) + 3*(ZD31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2532 = Coupling(name = 'GC_2532',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) + 6*ZN23*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2533 = Coupling(name = 'GC_2533',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR21 + ZD45*ZDR22 + ZD46*ZDR23)*complexconjugate(ZN21) + 3*(ZD41*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD42*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD43*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2534 = Coupling(name = 'GC_2534',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) + 6*ZN23*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2535 = Coupling(name = 'GC_2535',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR21 + ZD55*ZDR22 + ZD56*ZDR23)*complexconjugate(ZN21) + 3*(ZD51*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD52*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD53*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2536 = Coupling(name = 'GC_2536',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) + 6*ZN23*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2537 = Coupling(name = 'GC_2537',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR21 + ZD65*ZDR22 + ZD66*ZDR23)*complexconjugate(ZN21) + 3*(ZD61*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD62*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD63*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2538 = Coupling(name = 'GC_2538',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) + 6*ZN23*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2539 = Coupling(name = 'GC_2539',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR31 + ZD15*ZDR32 + ZD16*ZDR33)*complexconjugate(ZN21) + 3*(ZD11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2540 = Coupling(name = 'GC_2540',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) + 6*ZN23*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2541 = Coupling(name = 'GC_2541',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR31 + ZD25*ZDR32 + ZD26*ZDR33)*complexconjugate(ZN21) + 3*(ZD21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2542 = Coupling(name = 'GC_2542',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) + 6*ZN23*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2543 = Coupling(name = 'GC_2543',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR31 + ZD35*ZDR32 + ZD36*ZDR33)*complexconjugate(ZN21) + 3*(ZD31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2544 = Coupling(name = 'GC_2544',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) + 6*ZN23*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2545 = Coupling(name = 'GC_2545',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR31 + ZD45*ZDR32 + ZD46*ZDR33)*complexconjugate(ZN21) + 3*(ZD41*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD42*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD43*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2546 = Coupling(name = 'GC_2546',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) + 6*ZN23*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2547 = Coupling(name = 'GC_2547',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR31 + ZD55*ZDR32 + ZD56*ZDR33)*complexconjugate(ZN21) + 3*(ZD51*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD52*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD53*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2548 = Coupling(name = 'GC_2548',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN22*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) + 6*ZN23*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2549 = Coupling(name = 'GC_2549',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR31 + ZD65*ZDR32 + ZD66*ZDR33)*complexconjugate(ZN21) + 3*(ZD61*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD62*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD63*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2550 = Coupling(name = 'GC_2550',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) + 6*ZN33*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2551 = Coupling(name = 'GC_2551',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR11 + ZD15*ZDR12 + ZD16*ZDR13)*complexconjugate(ZN31) + 3*(ZD11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2552 = Coupling(name = 'GC_2552',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) + 6*ZN33*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2553 = Coupling(name = 'GC_2553',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR11 + ZD25*ZDR12 + ZD26*ZDR13)*complexconjugate(ZN31) + 3*(ZD21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2554 = Coupling(name = 'GC_2554',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) + 6*ZN33*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2555 = Coupling(name = 'GC_2555',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR11 + ZD35*ZDR12 + ZD36*ZDR13)*complexconjugate(ZN31) + 3*(ZD31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2556 = Coupling(name = 'GC_2556',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) + 6*ZN33*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2557 = Coupling(name = 'GC_2557',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR11 + ZD45*ZDR12 + ZD46*ZDR13)*complexconjugate(ZN31) + 3*(ZD41*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD42*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD43*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2558 = Coupling(name = 'GC_2558',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) + 6*ZN33*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2559 = Coupling(name = 'GC_2559',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR11 + ZD55*ZDR12 + ZD56*ZDR13)*complexconjugate(ZN31) + 3*(ZD51*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD52*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD53*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2560 = Coupling(name = 'GC_2560',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) + 6*ZN33*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2561 = Coupling(name = 'GC_2561',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR11 + ZD65*ZDR12 + ZD66*ZDR13)*complexconjugate(ZN31) + 3*(ZD61*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD62*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD63*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2562 = Coupling(name = 'GC_2562',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) + 6*ZN33*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2563 = Coupling(name = 'GC_2563',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR21 + ZD15*ZDR22 + ZD16*ZDR23)*complexconjugate(ZN31) + 3*(ZD11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2564 = Coupling(name = 'GC_2564',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) + 6*ZN33*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2565 = Coupling(name = 'GC_2565',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR21 + ZD25*ZDR22 + ZD26*ZDR23)*complexconjugate(ZN31) + 3*(ZD21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2566 = Coupling(name = 'GC_2566',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) + 6*ZN33*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2567 = Coupling(name = 'GC_2567',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR21 + ZD35*ZDR22 + ZD36*ZDR23)*complexconjugate(ZN31) + 3*(ZD31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2568 = Coupling(name = 'GC_2568',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) + 6*ZN33*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2569 = Coupling(name = 'GC_2569',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR21 + ZD45*ZDR22 + ZD46*ZDR23)*complexconjugate(ZN31) + 3*(ZD41*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD42*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD43*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2570 = Coupling(name = 'GC_2570',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) + 6*ZN33*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2571 = Coupling(name = 'GC_2571',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR21 + ZD55*ZDR22 + ZD56*ZDR23)*complexconjugate(ZN31) + 3*(ZD51*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD52*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD53*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2572 = Coupling(name = 'GC_2572',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) + 6*ZN33*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2573 = Coupling(name = 'GC_2573',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR21 + ZD65*ZDR22 + ZD66*ZDR23)*complexconjugate(ZN31) + 3*(ZD61*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD62*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD63*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2574 = Coupling(name = 'GC_2574',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) + 6*ZN33*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2575 = Coupling(name = 'GC_2575',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR31 + ZD15*ZDR32 + ZD16*ZDR33)*complexconjugate(ZN31) + 3*(ZD11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2576 = Coupling(name = 'GC_2576',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) + 6*ZN33*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2577 = Coupling(name = 'GC_2577',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR31 + ZD25*ZDR32 + ZD26*ZDR33)*complexconjugate(ZN31) + 3*(ZD21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2578 = Coupling(name = 'GC_2578',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) + 6*ZN33*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2579 = Coupling(name = 'GC_2579',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR31 + ZD35*ZDR32 + ZD36*ZDR33)*complexconjugate(ZN31) + 3*(ZD31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2580 = Coupling(name = 'GC_2580',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) + 6*ZN33*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2581 = Coupling(name = 'GC_2581',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR31 + ZD45*ZDR32 + ZD46*ZDR33)*complexconjugate(ZN31) + 3*(ZD41*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD42*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD43*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2582 = Coupling(name = 'GC_2582',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) + 6*ZN33*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2583 = Coupling(name = 'GC_2583',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR31 + ZD55*ZDR32 + ZD56*ZDR33)*complexconjugate(ZN31) + 3*(ZD51*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD52*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD53*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2584 = Coupling(name = 'GC_2584',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN32*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) + 6*ZN33*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2585 = Coupling(name = 'GC_2585',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR31 + ZD65*ZDR32 + ZD66*ZDR33)*complexconjugate(ZN31) + 3*(ZD61*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD62*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD63*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2586 = Coupling(name = 'GC_2586',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13)) + 6*ZN43*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL11) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL12) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2587 = Coupling(name = 'GC_2587',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR11 + ZD15*ZDR12 + ZD16*ZDR13)*complexconjugate(ZN41) + 3*(ZD11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2588 = Coupling(name = 'GC_2588',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13)) + 6*ZN43*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL11) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL12) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2589 = Coupling(name = 'GC_2589',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR11 + ZD25*ZDR12 + ZD26*ZDR13)*complexconjugate(ZN41) + 3*(ZD21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2590 = Coupling(name = 'GC_2590',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13)) + 6*ZN43*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL11) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL12) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2591 = Coupling(name = 'GC_2591',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR11 + ZD35*ZDR12 + ZD36*ZDR13)*complexconjugate(ZN41) + 3*(ZD31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2592 = Coupling(name = 'GC_2592',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13)) + 6*ZN43*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL11) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL12) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2593 = Coupling(name = 'GC_2593',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR11 + ZD45*ZDR12 + ZD46*ZDR13)*complexconjugate(ZN41) + 3*(ZD41*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD42*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD43*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2594 = Coupling(name = 'GC_2594',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13)) + 6*ZN43*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL11) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL12) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2595 = Coupling(name = 'GC_2595',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR11 + ZD55*ZDR12 + ZD56*ZDR13)*complexconjugate(ZN41) + 3*(ZD51*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD52*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD53*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2596 = Coupling(name = 'GC_2596',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13)) + 6*ZN43*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL11) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL12) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_2597 = Coupling(name = 'GC_2597',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR11 + ZD65*ZDR12 + ZD66*ZDR13)*complexconjugate(ZN41) + 3*(ZD61*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZD62*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZD63*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2598 = Coupling(name = 'GC_2598',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23)) + 6*ZN43*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL21) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL22) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2599 = Coupling(name = 'GC_2599',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR21 + ZD15*ZDR22 + ZD16*ZDR23)*complexconjugate(ZN41) + 3*(ZD11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2600 = Coupling(name = 'GC_2600',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23)) + 6*ZN43*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL21) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL22) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2601 = Coupling(name = 'GC_2601',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR21 + ZD25*ZDR22 + ZD26*ZDR23)*complexconjugate(ZN41) + 3*(ZD21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2602 = Coupling(name = 'GC_2602',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23)) + 6*ZN43*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL21) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL22) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2603 = Coupling(name = 'GC_2603',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR21 + ZD35*ZDR22 + ZD36*ZDR23)*complexconjugate(ZN41) + 3*(ZD31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2604 = Coupling(name = 'GC_2604',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23)) + 6*ZN43*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL21) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL22) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2605 = Coupling(name = 'GC_2605',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR21 + ZD45*ZDR22 + ZD46*ZDR23)*complexconjugate(ZN41) + 3*(ZD41*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD42*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD43*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2606 = Coupling(name = 'GC_2606',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23)) + 6*ZN43*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL21) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL22) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2607 = Coupling(name = 'GC_2607',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR21 + ZD55*ZDR22 + ZD56*ZDR23)*complexconjugate(ZN41) + 3*(ZD51*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD52*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD53*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2608 = Coupling(name = 'GC_2608',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23)) + 6*ZN43*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL21) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL22) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_2609 = Coupling(name = 'GC_2609',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR21 + ZD65*ZDR22 + ZD66*ZDR23)*complexconjugate(ZN41) + 3*(ZD61*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZD62*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZD63*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2610 = Coupling(name = 'GC_2610',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33)) + 6*ZN43*((Yd11*ZD14 + Yd21*ZD15 + Yd31*ZD16)*complexconjugate(ZDL31) + (Yd12*ZD14 + Yd22*ZD15 + Yd32*ZD16)*complexconjugate(ZDL32) + (Yd13*ZD14 + Yd23*ZD15 + Yd33*ZD16)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2611 = Coupling(name = 'GC_2611',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD14*ZDR31 + ZD15*ZDR32 + ZD16*ZDR33)*complexconjugate(ZN41) + 3*(ZD11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2612 = Coupling(name = 'GC_2612',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33)) + 6*ZN43*((Yd11*ZD24 + Yd21*ZD25 + Yd31*ZD26)*complexconjugate(ZDL31) + (Yd12*ZD24 + Yd22*ZD25 + Yd32*ZD26)*complexconjugate(ZDL32) + (Yd13*ZD24 + Yd23*ZD25 + Yd33*ZD26)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2613 = Coupling(name = 'GC_2613',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD24*ZDR31 + ZD25*ZDR32 + ZD26*ZDR33)*complexconjugate(ZN41) + 3*(ZD21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2614 = Coupling(name = 'GC_2614',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33)) + 6*ZN43*((Yd11*ZD34 + Yd21*ZD35 + Yd31*ZD36)*complexconjugate(ZDL31) + (Yd12*ZD34 + Yd22*ZD35 + Yd32*ZD36)*complexconjugate(ZDL32) + (Yd13*ZD34 + Yd23*ZD35 + Yd33*ZD36)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2615 = Coupling(name = 'GC_2615',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD34*ZDR31 + ZD35*ZDR32 + ZD36*ZDR33)*complexconjugate(ZN41) + 3*(ZD31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2616 = Coupling(name = 'GC_2616',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33)) + 6*ZN43*((Yd11*ZD44 + Yd21*ZD45 + Yd31*ZD46)*complexconjugate(ZDL31) + (Yd12*ZD44 + Yd22*ZD45 + Yd32*ZD46)*complexconjugate(ZDL32) + (Yd13*ZD44 + Yd23*ZD45 + Yd33*ZD46)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2617 = Coupling(name = 'GC_2617',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD44*ZDR31 + ZD45*ZDR32 + ZD46*ZDR33)*complexconjugate(ZN41) + 3*(ZD41*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD42*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD43*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2618 = Coupling(name = 'GC_2618',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33)) + 6*ZN43*((Yd11*ZD54 + Yd21*ZD55 + Yd31*ZD56)*complexconjugate(ZDL31) + (Yd12*ZD54 + Yd22*ZD55 + Yd32*ZD56)*complexconjugate(ZDL32) + (Yd13*ZD54 + Yd23*ZD55 + Yd33*ZD56)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2619 = Coupling(name = 'GC_2619',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD54*ZDR31 + ZD55*ZDR32 + ZD56*ZDR33)*complexconjugate(ZN41) + 3*(ZD51*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD52*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD53*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2620 = Coupling(name = 'GC_2620',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) - 3*cmath.sqrt(2)*g2*ZN42*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33)) + 6*ZN43*((Yd11*ZD64 + Yd21*ZD65 + Yd31*ZD66)*complexconjugate(ZDL31) + (Yd12*ZD64 + Yd22*ZD65 + Yd32*ZD66)*complexconjugate(ZDL32) + (Yd13*ZD64 + Yd23*ZD65 + Yd33*ZD66)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_2621 = Coupling(name = 'GC_2621',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*(ZD64*ZDR31 + ZD65*ZDR32 + ZD66*ZDR33)*complexconjugate(ZN41) + 3*(ZD61*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZD62*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZD63*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2622 = Coupling(name = 'GC_2622',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN12*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) - 2*ZN13*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2623 = Coupling(name = 'GC_2623',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER11 + ZE15*ZER12 + ZE16*ZER13)*complexconjugate(ZN11) + (ZE11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2624 = Coupling(name = 'GC_2624',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN12*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) - 2*ZN13*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2625 = Coupling(name = 'GC_2625',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER11 + ZE25*ZER12 + ZE26*ZER13)*complexconjugate(ZN11) + (ZE21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2626 = Coupling(name = 'GC_2626',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN12*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) - 2*ZN13*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2627 = Coupling(name = 'GC_2627',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER11 + ZE35*ZER12 + ZE36*ZER13)*complexconjugate(ZN11) + (ZE31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2628 = Coupling(name = 'GC_2628',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN12*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) - 2*ZN13*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2629 = Coupling(name = 'GC_2629',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER11 + ZE45*ZER12 + ZE46*ZER13)*complexconjugate(ZN11) + (ZE41*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE42*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE43*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2630 = Coupling(name = 'GC_2630',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN12*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) - 2*ZN13*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2631 = Coupling(name = 'GC_2631',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER11 + ZE55*ZER12 + ZE56*ZER13)*complexconjugate(ZN11) + (ZE51*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE52*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE53*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2632 = Coupling(name = 'GC_2632',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN12*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) - 2*ZN13*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2633 = Coupling(name = 'GC_2633',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER11 + ZE65*ZER12 + ZE66*ZER13)*complexconjugate(ZN11) + (ZE61*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE62*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE63*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2634 = Coupling(name = 'GC_2634',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN12*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) - 2*ZN13*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2635 = Coupling(name = 'GC_2635',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER21 + ZE15*ZER22 + ZE16*ZER23)*complexconjugate(ZN11) + (ZE11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2636 = Coupling(name = 'GC_2636',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN12*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) - 2*ZN13*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2637 = Coupling(name = 'GC_2637',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER21 + ZE25*ZER22 + ZE26*ZER23)*complexconjugate(ZN11) + (ZE21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2638 = Coupling(name = 'GC_2638',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN12*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) - 2*ZN13*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2639 = Coupling(name = 'GC_2639',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER21 + ZE35*ZER22 + ZE36*ZER23)*complexconjugate(ZN11) + (ZE31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2640 = Coupling(name = 'GC_2640',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN12*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) - 2*ZN13*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2641 = Coupling(name = 'GC_2641',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER21 + ZE45*ZER22 + ZE46*ZER23)*complexconjugate(ZN11) + (ZE41*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE42*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE43*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2642 = Coupling(name = 'GC_2642',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN12*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) - 2*ZN13*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2643 = Coupling(name = 'GC_2643',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER21 + ZE55*ZER22 + ZE56*ZER23)*complexconjugate(ZN11) + (ZE51*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE52*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE53*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2644 = Coupling(name = 'GC_2644',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN12*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) - 2*ZN13*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2645 = Coupling(name = 'GC_2645',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER21 + ZE65*ZER22 + ZE66*ZER23)*complexconjugate(ZN11) + (ZE61*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE62*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE63*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2646 = Coupling(name = 'GC_2646',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN12*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) - 2*ZN13*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2647 = Coupling(name = 'GC_2647',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER31 + ZE15*ZER32 + ZE16*ZER33)*complexconjugate(ZN11) + (ZE11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2648 = Coupling(name = 'GC_2648',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN12*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) - 2*ZN13*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2649 = Coupling(name = 'GC_2649',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER31 + ZE25*ZER32 + ZE26*ZER33)*complexconjugate(ZN11) + (ZE21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2650 = Coupling(name = 'GC_2650',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN12*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) - 2*ZN13*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2651 = Coupling(name = 'GC_2651',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER31 + ZE35*ZER32 + ZE36*ZER33)*complexconjugate(ZN11) + (ZE31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2652 = Coupling(name = 'GC_2652',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN12*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) - 2*ZN13*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2653 = Coupling(name = 'GC_2653',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER31 + ZE45*ZER32 + ZE46*ZER33)*complexconjugate(ZN11) + (ZE41*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE42*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE43*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2654 = Coupling(name = 'GC_2654',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN12*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) - 2*ZN13*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2655 = Coupling(name = 'GC_2655',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER31 + ZE55*ZER32 + ZE56*ZER33)*complexconjugate(ZN11) + (ZE51*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE52*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE53*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2656 = Coupling(name = 'GC_2656',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN12*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) - 2*ZN13*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2657 = Coupling(name = 'GC_2657',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER31 + ZE65*ZER32 + ZE66*ZER33)*complexconjugate(ZN11) + (ZE61*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE62*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE63*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2658 = Coupling(name = 'GC_2658',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN22*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) - 2*ZN23*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2659 = Coupling(name = 'GC_2659',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER11 + ZE15*ZER12 + ZE16*ZER13)*complexconjugate(ZN21) + (ZE11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2660 = Coupling(name = 'GC_2660',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN22*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) - 2*ZN23*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2661 = Coupling(name = 'GC_2661',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER11 + ZE25*ZER12 + ZE26*ZER13)*complexconjugate(ZN21) + (ZE21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2662 = Coupling(name = 'GC_2662',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN22*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) - 2*ZN23*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2663 = Coupling(name = 'GC_2663',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER11 + ZE35*ZER12 + ZE36*ZER13)*complexconjugate(ZN21) + (ZE31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2664 = Coupling(name = 'GC_2664',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN22*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) - 2*ZN23*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2665 = Coupling(name = 'GC_2665',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER11 + ZE45*ZER12 + ZE46*ZER13)*complexconjugate(ZN21) + (ZE41*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE42*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE43*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2666 = Coupling(name = 'GC_2666',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN22*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) - 2*ZN23*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2667 = Coupling(name = 'GC_2667',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER11 + ZE55*ZER12 + ZE56*ZER13)*complexconjugate(ZN21) + (ZE51*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE52*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE53*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2668 = Coupling(name = 'GC_2668',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN22*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) - 2*ZN23*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2669 = Coupling(name = 'GC_2669',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER11 + ZE65*ZER12 + ZE66*ZER13)*complexconjugate(ZN21) + (ZE61*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE62*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE63*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2670 = Coupling(name = 'GC_2670',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN22*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) - 2*ZN23*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2671 = Coupling(name = 'GC_2671',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER21 + ZE15*ZER22 + ZE16*ZER23)*complexconjugate(ZN21) + (ZE11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2672 = Coupling(name = 'GC_2672',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN22*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) - 2*ZN23*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2673 = Coupling(name = 'GC_2673',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER21 + ZE25*ZER22 + ZE26*ZER23)*complexconjugate(ZN21) + (ZE21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2674 = Coupling(name = 'GC_2674',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN22*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) - 2*ZN23*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2675 = Coupling(name = 'GC_2675',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER21 + ZE35*ZER22 + ZE36*ZER23)*complexconjugate(ZN21) + (ZE31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2676 = Coupling(name = 'GC_2676',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN22*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) - 2*ZN23*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2677 = Coupling(name = 'GC_2677',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER21 + ZE45*ZER22 + ZE46*ZER23)*complexconjugate(ZN21) + (ZE41*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE42*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE43*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2678 = Coupling(name = 'GC_2678',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN22*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) - 2*ZN23*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2679 = Coupling(name = 'GC_2679',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER21 + ZE55*ZER22 + ZE56*ZER23)*complexconjugate(ZN21) + (ZE51*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE52*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE53*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2680 = Coupling(name = 'GC_2680',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN22*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) - 2*ZN23*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2681 = Coupling(name = 'GC_2681',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER21 + ZE65*ZER22 + ZE66*ZER23)*complexconjugate(ZN21) + (ZE61*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE62*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE63*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2682 = Coupling(name = 'GC_2682',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN22*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) - 2*ZN23*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2683 = Coupling(name = 'GC_2683',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER31 + ZE15*ZER32 + ZE16*ZER33)*complexconjugate(ZN21) + (ZE11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2684 = Coupling(name = 'GC_2684',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN22*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) - 2*ZN23*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2685 = Coupling(name = 'GC_2685',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER31 + ZE25*ZER32 + ZE26*ZER33)*complexconjugate(ZN21) + (ZE21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2686 = Coupling(name = 'GC_2686',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN22*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) - 2*ZN23*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2687 = Coupling(name = 'GC_2687',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER31 + ZE35*ZER32 + ZE36*ZER33)*complexconjugate(ZN21) + (ZE31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2688 = Coupling(name = 'GC_2688',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN22*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) - 2*ZN23*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2689 = Coupling(name = 'GC_2689',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER31 + ZE45*ZER32 + ZE46*ZER33)*complexconjugate(ZN21) + (ZE41*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE42*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE43*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2690 = Coupling(name = 'GC_2690',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN22*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) - 2*ZN23*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2691 = Coupling(name = 'GC_2691',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER31 + ZE55*ZER32 + ZE56*ZER33)*complexconjugate(ZN21) + (ZE51*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE52*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE53*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2692 = Coupling(name = 'GC_2692',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN22*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) - 2*ZN23*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2693 = Coupling(name = 'GC_2693',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER31 + ZE65*ZER32 + ZE66*ZER33)*complexconjugate(ZN21) + (ZE61*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE62*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE63*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2694 = Coupling(name = 'GC_2694',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN32*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) - 2*ZN33*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2695 = Coupling(name = 'GC_2695',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER11 + ZE15*ZER12 + ZE16*ZER13)*complexconjugate(ZN31) + (ZE11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2696 = Coupling(name = 'GC_2696',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN32*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) - 2*ZN33*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2697 = Coupling(name = 'GC_2697',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER11 + ZE25*ZER12 + ZE26*ZER13)*complexconjugate(ZN31) + (ZE21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2698 = Coupling(name = 'GC_2698',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN32*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) - 2*ZN33*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2699 = Coupling(name = 'GC_2699',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER11 + ZE35*ZER12 + ZE36*ZER13)*complexconjugate(ZN31) + (ZE31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2700 = Coupling(name = 'GC_2700',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN32*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) - 2*ZN33*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2701 = Coupling(name = 'GC_2701',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER11 + ZE45*ZER12 + ZE46*ZER13)*complexconjugate(ZN31) + (ZE41*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE42*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE43*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2702 = Coupling(name = 'GC_2702',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN32*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) - 2*ZN33*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2703 = Coupling(name = 'GC_2703',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER11 + ZE55*ZER12 + ZE56*ZER13)*complexconjugate(ZN31) + (ZE51*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE52*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE53*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2704 = Coupling(name = 'GC_2704',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN32*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) - 2*ZN33*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2705 = Coupling(name = 'GC_2705',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER11 + ZE65*ZER12 + ZE66*ZER13)*complexconjugate(ZN31) + (ZE61*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE62*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE63*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2706 = Coupling(name = 'GC_2706',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN32*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) - 2*ZN33*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2707 = Coupling(name = 'GC_2707',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER21 + ZE15*ZER22 + ZE16*ZER23)*complexconjugate(ZN31) + (ZE11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2708 = Coupling(name = 'GC_2708',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN32*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) - 2*ZN33*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2709 = Coupling(name = 'GC_2709',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER21 + ZE25*ZER22 + ZE26*ZER23)*complexconjugate(ZN31) + (ZE21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2710 = Coupling(name = 'GC_2710',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN32*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) - 2*ZN33*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2711 = Coupling(name = 'GC_2711',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER21 + ZE35*ZER22 + ZE36*ZER23)*complexconjugate(ZN31) + (ZE31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2712 = Coupling(name = 'GC_2712',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN32*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) - 2*ZN33*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2713 = Coupling(name = 'GC_2713',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER21 + ZE45*ZER22 + ZE46*ZER23)*complexconjugate(ZN31) + (ZE41*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE42*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE43*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2714 = Coupling(name = 'GC_2714',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN32*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) - 2*ZN33*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2715 = Coupling(name = 'GC_2715',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER21 + ZE55*ZER22 + ZE56*ZER23)*complexconjugate(ZN31) + (ZE51*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE52*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE53*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2716 = Coupling(name = 'GC_2716',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN32*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) - 2*ZN33*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2717 = Coupling(name = 'GC_2717',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER21 + ZE65*ZER22 + ZE66*ZER23)*complexconjugate(ZN31) + (ZE61*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE62*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE63*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2718 = Coupling(name = 'GC_2718',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN32*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) - 2*ZN33*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2719 = Coupling(name = 'GC_2719',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER31 + ZE15*ZER32 + ZE16*ZER33)*complexconjugate(ZN31) + (ZE11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2720 = Coupling(name = 'GC_2720',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN32*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) - 2*ZN33*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2721 = Coupling(name = 'GC_2721',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER31 + ZE25*ZER32 + ZE26*ZER33)*complexconjugate(ZN31) + (ZE21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2722 = Coupling(name = 'GC_2722',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN32*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) - 2*ZN33*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2723 = Coupling(name = 'GC_2723',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER31 + ZE35*ZER32 + ZE36*ZER33)*complexconjugate(ZN31) + (ZE31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2724 = Coupling(name = 'GC_2724',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN32*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) - 2*ZN33*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2725 = Coupling(name = 'GC_2725',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER31 + ZE45*ZER32 + ZE46*ZER33)*complexconjugate(ZN31) + (ZE41*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE42*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE43*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2726 = Coupling(name = 'GC_2726',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN32*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) - 2*ZN33*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2727 = Coupling(name = 'GC_2727',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER31 + ZE55*ZER32 + ZE56*ZER33)*complexconjugate(ZN31) + (ZE51*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE52*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE53*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2728 = Coupling(name = 'GC_2728',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN32*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) - 2*ZN33*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2729 = Coupling(name = 'GC_2729',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER31 + ZE65*ZER32 + ZE66*ZER33)*complexconjugate(ZN31) + (ZE61*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE62*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE63*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2730 = Coupling(name = 'GC_2730',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN42*(ZE11*complexconjugate(ZEL11) + ZE12*complexconjugate(ZEL12) + ZE13*complexconjugate(ZEL13)) - 2*ZN43*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL11) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL12) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2731 = Coupling(name = 'GC_2731',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER11 + ZE15*ZER12 + ZE16*ZER13)*complexconjugate(ZN41) + (ZE11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2732 = Coupling(name = 'GC_2732',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN42*(ZE21*complexconjugate(ZEL11) + ZE22*complexconjugate(ZEL12) + ZE23*complexconjugate(ZEL13)) - 2*ZN43*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL11) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL12) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2733 = Coupling(name = 'GC_2733',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER11 + ZE25*ZER12 + ZE26*ZER13)*complexconjugate(ZN41) + (ZE21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2734 = Coupling(name = 'GC_2734',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN42*(ZE31*complexconjugate(ZEL11) + ZE32*complexconjugate(ZEL12) + ZE33*complexconjugate(ZEL13)) - 2*ZN43*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL11) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL12) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2735 = Coupling(name = 'GC_2735',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER11 + ZE35*ZER12 + ZE36*ZER13)*complexconjugate(ZN41) + (ZE31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2736 = Coupling(name = 'GC_2736',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN42*(ZE41*complexconjugate(ZEL11) + ZE42*complexconjugate(ZEL12) + ZE43*complexconjugate(ZEL13)) - 2*ZN43*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL11) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL12) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2737 = Coupling(name = 'GC_2737',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER11 + ZE45*ZER12 + ZE46*ZER13)*complexconjugate(ZN41) + (ZE41*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE42*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE43*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2738 = Coupling(name = 'GC_2738',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN42*(ZE51*complexconjugate(ZEL11) + ZE52*complexconjugate(ZEL12) + ZE53*complexconjugate(ZEL13)) - 2*ZN43*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL11) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL12) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2739 = Coupling(name = 'GC_2739',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER11 + ZE55*ZER12 + ZE56*ZER13)*complexconjugate(ZN41) + (ZE51*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE52*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE53*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2740 = Coupling(name = 'GC_2740',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) + cmath.sqrt(2)*g2*ZN42*(ZE61*complexconjugate(ZEL11) + ZE62*complexconjugate(ZEL12) + ZE63*complexconjugate(ZEL13)) - 2*ZN43*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL11) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL12) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL13)))', 
	 order = {'QED':1} ) 
 
GC_2741 = Coupling(name = 'GC_2741',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER11 + ZE65*ZER12 + ZE66*ZER13)*complexconjugate(ZN41) + (ZE61*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZE62*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZE63*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2742 = Coupling(name = 'GC_2742',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN42*(ZE11*complexconjugate(ZEL21) + ZE12*complexconjugate(ZEL22) + ZE13*complexconjugate(ZEL23)) - 2*ZN43*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL21) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL22) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2743 = Coupling(name = 'GC_2743',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER21 + ZE15*ZER22 + ZE16*ZER23)*complexconjugate(ZN41) + (ZE11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2744 = Coupling(name = 'GC_2744',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN42*(ZE21*complexconjugate(ZEL21) + ZE22*complexconjugate(ZEL22) + ZE23*complexconjugate(ZEL23)) - 2*ZN43*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL21) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL22) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2745 = Coupling(name = 'GC_2745',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER21 + ZE25*ZER22 + ZE26*ZER23)*complexconjugate(ZN41) + (ZE21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2746 = Coupling(name = 'GC_2746',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN42*(ZE31*complexconjugate(ZEL21) + ZE32*complexconjugate(ZEL22) + ZE33*complexconjugate(ZEL23)) - 2*ZN43*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL21) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL22) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2747 = Coupling(name = 'GC_2747',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER21 + ZE35*ZER22 + ZE36*ZER23)*complexconjugate(ZN41) + (ZE31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2748 = Coupling(name = 'GC_2748',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN42*(ZE41*complexconjugate(ZEL21) + ZE42*complexconjugate(ZEL22) + ZE43*complexconjugate(ZEL23)) - 2*ZN43*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL21) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL22) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2749 = Coupling(name = 'GC_2749',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER21 + ZE45*ZER22 + ZE46*ZER23)*complexconjugate(ZN41) + (ZE41*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE42*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE43*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2750 = Coupling(name = 'GC_2750',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN42*(ZE51*complexconjugate(ZEL21) + ZE52*complexconjugate(ZEL22) + ZE53*complexconjugate(ZEL23)) - 2*ZN43*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL21) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL22) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2751 = Coupling(name = 'GC_2751',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER21 + ZE55*ZER22 + ZE56*ZER23)*complexconjugate(ZN41) + (ZE51*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE52*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE53*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2752 = Coupling(name = 'GC_2752',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) + cmath.sqrt(2)*g2*ZN42*(ZE61*complexconjugate(ZEL21) + ZE62*complexconjugate(ZEL22) + ZE63*complexconjugate(ZEL23)) - 2*ZN43*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL21) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL22) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL23)))', 
	 order = {'QED':1} ) 
 
GC_2753 = Coupling(name = 'GC_2753',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER21 + ZE65*ZER22 + ZE66*ZER23)*complexconjugate(ZN41) + (ZE61*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZE62*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZE63*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2754 = Coupling(name = 'GC_2754',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN42*(ZE11*complexconjugate(ZEL31) + ZE12*complexconjugate(ZEL32) + ZE13*complexconjugate(ZEL33)) - 2*ZN43*((Ye11*ZE14 + Ye21*ZE15 + Ye31*ZE16)*complexconjugate(ZEL31) + (Ye12*ZE14 + Ye22*ZE15 + Ye32*ZE16)*complexconjugate(ZEL32) + (Ye13*ZE14 + Ye23*ZE15 + Ye33*ZE16)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2755 = Coupling(name = 'GC_2755',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE14*ZER31 + ZE15*ZER32 + ZE16*ZER33)*complexconjugate(ZN41) + (ZE11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2756 = Coupling(name = 'GC_2756',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN42*(ZE21*complexconjugate(ZEL31) + ZE22*complexconjugate(ZEL32) + ZE23*complexconjugate(ZEL33)) - 2*ZN43*((Ye11*ZE24 + Ye21*ZE25 + Ye31*ZE26)*complexconjugate(ZEL31) + (Ye12*ZE24 + Ye22*ZE25 + Ye32*ZE26)*complexconjugate(ZEL32) + (Ye13*ZE24 + Ye23*ZE25 + Ye33*ZE26)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2757 = Coupling(name = 'GC_2757',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE24*ZER31 + ZE25*ZER32 + ZE26*ZER33)*complexconjugate(ZN41) + (ZE21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2758 = Coupling(name = 'GC_2758',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN42*(ZE31*complexconjugate(ZEL31) + ZE32*complexconjugate(ZEL32) + ZE33*complexconjugate(ZEL33)) - 2*ZN43*((Ye11*ZE34 + Ye21*ZE35 + Ye31*ZE36)*complexconjugate(ZEL31) + (Ye12*ZE34 + Ye22*ZE35 + Ye32*ZE36)*complexconjugate(ZEL32) + (Ye13*ZE34 + Ye23*ZE35 + Ye33*ZE36)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2759 = Coupling(name = 'GC_2759',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE34*ZER31 + ZE35*ZER32 + ZE36*ZER33)*complexconjugate(ZN41) + (ZE31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2760 = Coupling(name = 'GC_2760',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN42*(ZE41*complexconjugate(ZEL31) + ZE42*complexconjugate(ZEL32) + ZE43*complexconjugate(ZEL33)) - 2*ZN43*((Ye11*ZE44 + Ye21*ZE45 + Ye31*ZE46)*complexconjugate(ZEL31) + (Ye12*ZE44 + Ye22*ZE45 + Ye32*ZE46)*complexconjugate(ZEL32) + (Ye13*ZE44 + Ye23*ZE45 + Ye33*ZE46)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2761 = Coupling(name = 'GC_2761',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE44*ZER31 + ZE45*ZER32 + ZE46*ZER33)*complexconjugate(ZN41) + (ZE41*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE42*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE43*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2762 = Coupling(name = 'GC_2762',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN42*(ZE51*complexconjugate(ZEL31) + ZE52*complexconjugate(ZEL32) + ZE53*complexconjugate(ZEL33)) - 2*ZN43*((Ye11*ZE54 + Ye21*ZE55 + Ye31*ZE56)*complexconjugate(ZEL31) + (Ye12*ZE54 + Ye22*ZE55 + Ye32*ZE56)*complexconjugate(ZEL32) + (Ye13*ZE54 + Ye23*ZE55 + Ye33*ZE56)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2763 = Coupling(name = 'GC_2763',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE54*ZER31 + ZE55*ZER32 + ZE56*ZER33)*complexconjugate(ZN41) + (ZE51*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE52*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE53*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2764 = Coupling(name = 'GC_2764',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) + cmath.sqrt(2)*g2*ZN42*(ZE61*complexconjugate(ZEL31) + ZE62*complexconjugate(ZEL32) + ZE63*complexconjugate(ZEL33)) - 2*ZN43*((Ye11*ZE64 + Ye21*ZE65 + Ye31*ZE66)*complexconjugate(ZEL31) + (Ye12*ZE64 + Ye22*ZE65 + Ye32*ZE66)*complexconjugate(ZEL32) + (Ye13*ZE64 + Ye23*ZE65 + Ye33*ZE66)*complexconjugate(ZEL33)))', 
	 order = {'QED':1} ) 
 
GC_2765 = Coupling(name = 'GC_2765',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*(ZE64*ZER31 + ZE65*ZER32 + ZE66*ZER33)*complexconjugate(ZN41) + (ZE61*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZE62*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZE63*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2766 = Coupling(name = 'GC_2766',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 6*ZN14*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2767 = Coupling(name = 'GC_2767',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR11 + ZU15*ZUR12 + ZU16*ZUR13)*complexconjugate(ZN11) - 3*(ZU11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2768 = Coupling(name = 'GC_2768',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 6*ZN14*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2769 = Coupling(name = 'GC_2769',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR11 + ZU25*ZUR12 + ZU26*ZUR13)*complexconjugate(ZN11) - 3*(ZU21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2770 = Coupling(name = 'GC_2770',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 6*ZN14*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2771 = Coupling(name = 'GC_2771',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR11 + ZU35*ZUR12 + ZU36*ZUR13)*complexconjugate(ZN11) - 3*(ZU31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2772 = Coupling(name = 'GC_2772',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 6*ZN14*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2773 = Coupling(name = 'GC_2773',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR11 + ZU45*ZUR12 + ZU46*ZUR13)*complexconjugate(ZN11) - 3*(ZU41*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU42*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU43*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2774 = Coupling(name = 'GC_2774',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 6*ZN14*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2775 = Coupling(name = 'GC_2775',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR11 + ZU55*ZUR12 + ZU56*ZUR13)*complexconjugate(ZN11) - 3*(ZU51*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU52*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU53*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2776 = Coupling(name = 'GC_2776',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 6*ZN14*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2777 = Coupling(name = 'GC_2777',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR11 + ZU65*ZUR12 + ZU66*ZUR13)*complexconjugate(ZN11) - 3*(ZU61*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU62*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU63*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2778 = Coupling(name = 'GC_2778',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 6*ZN14*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2779 = Coupling(name = 'GC_2779',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR21 + ZU15*ZUR22 + ZU16*ZUR23)*complexconjugate(ZN11) - 3*(ZU11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2780 = Coupling(name = 'GC_2780',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 6*ZN14*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2781 = Coupling(name = 'GC_2781',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR21 + ZU25*ZUR22 + ZU26*ZUR23)*complexconjugate(ZN11) - 3*(ZU21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2782 = Coupling(name = 'GC_2782',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 6*ZN14*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2783 = Coupling(name = 'GC_2783',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR21 + ZU35*ZUR22 + ZU36*ZUR23)*complexconjugate(ZN11) - 3*(ZU31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2784 = Coupling(name = 'GC_2784',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 6*ZN14*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2785 = Coupling(name = 'GC_2785',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR21 + ZU45*ZUR22 + ZU46*ZUR23)*complexconjugate(ZN11) - 3*(ZU41*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU42*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU43*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2786 = Coupling(name = 'GC_2786',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 6*ZN14*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2787 = Coupling(name = 'GC_2787',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR21 + ZU55*ZUR22 + ZU56*ZUR23)*complexconjugate(ZN11) - 3*(ZU51*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU52*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU53*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2788 = Coupling(name = 'GC_2788',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 6*ZN14*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2789 = Coupling(name = 'GC_2789',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR21 + ZU65*ZUR22 + ZU66*ZUR23)*complexconjugate(ZN11) - 3*(ZU61*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU62*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU63*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2790 = Coupling(name = 'GC_2790',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 6*ZN14*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2791 = Coupling(name = 'GC_2791',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR31 + ZU15*ZUR32 + ZU16*ZUR33)*complexconjugate(ZN11) - 3*(ZU11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2792 = Coupling(name = 'GC_2792',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 6*ZN14*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2793 = Coupling(name = 'GC_2793',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR31 + ZU25*ZUR32 + ZU26*ZUR33)*complexconjugate(ZN11) - 3*(ZU21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2794 = Coupling(name = 'GC_2794',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 6*ZN14*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2795 = Coupling(name = 'GC_2795',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR31 + ZU35*ZUR32 + ZU36*ZUR33)*complexconjugate(ZN11) - 3*(ZU31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2796 = Coupling(name = 'GC_2796',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 6*ZN14*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2797 = Coupling(name = 'GC_2797',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR31 + ZU45*ZUR32 + ZU46*ZUR33)*complexconjugate(ZN11) - 3*(ZU41*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU42*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU43*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2798 = Coupling(name = 'GC_2798',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 6*ZN14*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2799 = Coupling(name = 'GC_2799',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR31 + ZU55*ZUR32 + ZU56*ZUR33)*complexconjugate(ZN11) - 3*(ZU51*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU52*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU53*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2800 = Coupling(name = 'GC_2800',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN12*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 6*ZN14*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2801 = Coupling(name = 'GC_2801',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR31 + ZU65*ZUR32 + ZU66*ZUR33)*complexconjugate(ZN11) - 3*(ZU61*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU62*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU63*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN14))', 
	 order = {'QED':1} ) 
 
GC_2802 = Coupling(name = 'GC_2802',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 6*ZN24*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2803 = Coupling(name = 'GC_2803',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR11 + ZU15*ZUR12 + ZU16*ZUR13)*complexconjugate(ZN21) - 3*(ZU11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2804 = Coupling(name = 'GC_2804',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 6*ZN24*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2805 = Coupling(name = 'GC_2805',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR11 + ZU25*ZUR12 + ZU26*ZUR13)*complexconjugate(ZN21) - 3*(ZU21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2806 = Coupling(name = 'GC_2806',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 6*ZN24*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2807 = Coupling(name = 'GC_2807',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR11 + ZU35*ZUR12 + ZU36*ZUR13)*complexconjugate(ZN21) - 3*(ZU31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2808 = Coupling(name = 'GC_2808',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 6*ZN24*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2809 = Coupling(name = 'GC_2809',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR11 + ZU45*ZUR12 + ZU46*ZUR13)*complexconjugate(ZN21) - 3*(ZU41*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU42*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU43*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2810 = Coupling(name = 'GC_2810',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 6*ZN24*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2811 = Coupling(name = 'GC_2811',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR11 + ZU55*ZUR12 + ZU56*ZUR13)*complexconjugate(ZN21) - 3*(ZU51*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU52*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU53*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2812 = Coupling(name = 'GC_2812',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 6*ZN24*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2813 = Coupling(name = 'GC_2813',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR11 + ZU65*ZUR12 + ZU66*ZUR13)*complexconjugate(ZN21) - 3*(ZU61*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU62*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU63*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2814 = Coupling(name = 'GC_2814',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 6*ZN24*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2815 = Coupling(name = 'GC_2815',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR21 + ZU15*ZUR22 + ZU16*ZUR23)*complexconjugate(ZN21) - 3*(ZU11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2816 = Coupling(name = 'GC_2816',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 6*ZN24*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2817 = Coupling(name = 'GC_2817',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR21 + ZU25*ZUR22 + ZU26*ZUR23)*complexconjugate(ZN21) - 3*(ZU21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2818 = Coupling(name = 'GC_2818',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 6*ZN24*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2819 = Coupling(name = 'GC_2819',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR21 + ZU35*ZUR22 + ZU36*ZUR23)*complexconjugate(ZN21) - 3*(ZU31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2820 = Coupling(name = 'GC_2820',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 6*ZN24*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2821 = Coupling(name = 'GC_2821',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR21 + ZU45*ZUR22 + ZU46*ZUR23)*complexconjugate(ZN21) - 3*(ZU41*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU42*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU43*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2822 = Coupling(name = 'GC_2822',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 6*ZN24*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2823 = Coupling(name = 'GC_2823',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR21 + ZU55*ZUR22 + ZU56*ZUR23)*complexconjugate(ZN21) - 3*(ZU51*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU52*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU53*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2824 = Coupling(name = 'GC_2824',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 6*ZN24*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2825 = Coupling(name = 'GC_2825',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR21 + ZU65*ZUR22 + ZU66*ZUR23)*complexconjugate(ZN21) - 3*(ZU61*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU62*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU63*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2826 = Coupling(name = 'GC_2826',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 6*ZN24*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2827 = Coupling(name = 'GC_2827',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR31 + ZU15*ZUR32 + ZU16*ZUR33)*complexconjugate(ZN21) - 3*(ZU11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2828 = Coupling(name = 'GC_2828',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 6*ZN24*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2829 = Coupling(name = 'GC_2829',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR31 + ZU25*ZUR32 + ZU26*ZUR33)*complexconjugate(ZN21) - 3*(ZU21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2830 = Coupling(name = 'GC_2830',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 6*ZN24*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2831 = Coupling(name = 'GC_2831',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR31 + ZU35*ZUR32 + ZU36*ZUR33)*complexconjugate(ZN21) - 3*(ZU31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2832 = Coupling(name = 'GC_2832',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 6*ZN24*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2833 = Coupling(name = 'GC_2833',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR31 + ZU45*ZUR32 + ZU46*ZUR33)*complexconjugate(ZN21) - 3*(ZU41*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU42*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU43*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2834 = Coupling(name = 'GC_2834',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 6*ZN24*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2835 = Coupling(name = 'GC_2835',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR31 + ZU55*ZUR32 + ZU56*ZUR33)*complexconjugate(ZN21) - 3*(ZU51*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU52*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU53*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2836 = Coupling(name = 'GC_2836',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN22*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 6*ZN24*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2837 = Coupling(name = 'GC_2837',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR31 + ZU65*ZUR32 + ZU66*ZUR33)*complexconjugate(ZN21) - 3*(ZU61*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU62*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU63*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN24))', 
	 order = {'QED':1} ) 
 
GC_2838 = Coupling(name = 'GC_2838',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 6*ZN34*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2839 = Coupling(name = 'GC_2839',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR11 + ZU15*ZUR12 + ZU16*ZUR13)*complexconjugate(ZN31) - 3*(ZU11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2840 = Coupling(name = 'GC_2840',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 6*ZN34*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2841 = Coupling(name = 'GC_2841',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR11 + ZU25*ZUR12 + ZU26*ZUR13)*complexconjugate(ZN31) - 3*(ZU21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2842 = Coupling(name = 'GC_2842',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 6*ZN34*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2843 = Coupling(name = 'GC_2843',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR11 + ZU35*ZUR12 + ZU36*ZUR13)*complexconjugate(ZN31) - 3*(ZU31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2844 = Coupling(name = 'GC_2844',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 6*ZN34*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2845 = Coupling(name = 'GC_2845',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR11 + ZU45*ZUR12 + ZU46*ZUR13)*complexconjugate(ZN31) - 3*(ZU41*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU42*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU43*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2846 = Coupling(name = 'GC_2846',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 6*ZN34*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2847 = Coupling(name = 'GC_2847',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR11 + ZU55*ZUR12 + ZU56*ZUR13)*complexconjugate(ZN31) - 3*(ZU51*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU52*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU53*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2848 = Coupling(name = 'GC_2848',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 6*ZN34*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2849 = Coupling(name = 'GC_2849',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR11 + ZU65*ZUR12 + ZU66*ZUR13)*complexconjugate(ZN31) - 3*(ZU61*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU62*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU63*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2850 = Coupling(name = 'GC_2850',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 6*ZN34*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2851 = Coupling(name = 'GC_2851',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR21 + ZU15*ZUR22 + ZU16*ZUR23)*complexconjugate(ZN31) - 3*(ZU11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2852 = Coupling(name = 'GC_2852',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 6*ZN34*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2853 = Coupling(name = 'GC_2853',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR21 + ZU25*ZUR22 + ZU26*ZUR23)*complexconjugate(ZN31) - 3*(ZU21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2854 = Coupling(name = 'GC_2854',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 6*ZN34*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2855 = Coupling(name = 'GC_2855',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR21 + ZU35*ZUR22 + ZU36*ZUR23)*complexconjugate(ZN31) - 3*(ZU31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2856 = Coupling(name = 'GC_2856',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 6*ZN34*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2857 = Coupling(name = 'GC_2857',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR21 + ZU45*ZUR22 + ZU46*ZUR23)*complexconjugate(ZN31) - 3*(ZU41*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU42*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU43*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2858 = Coupling(name = 'GC_2858',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 6*ZN34*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2859 = Coupling(name = 'GC_2859',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR21 + ZU55*ZUR22 + ZU56*ZUR23)*complexconjugate(ZN31) - 3*(ZU51*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU52*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU53*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2860 = Coupling(name = 'GC_2860',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 6*ZN34*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2861 = Coupling(name = 'GC_2861',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR21 + ZU65*ZUR22 + ZU66*ZUR23)*complexconjugate(ZN31) - 3*(ZU61*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU62*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU63*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2862 = Coupling(name = 'GC_2862',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 6*ZN34*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2863 = Coupling(name = 'GC_2863',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR31 + ZU15*ZUR32 + ZU16*ZUR33)*complexconjugate(ZN31) - 3*(ZU11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2864 = Coupling(name = 'GC_2864',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 6*ZN34*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2865 = Coupling(name = 'GC_2865',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR31 + ZU25*ZUR32 + ZU26*ZUR33)*complexconjugate(ZN31) - 3*(ZU21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2866 = Coupling(name = 'GC_2866',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 6*ZN34*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2867 = Coupling(name = 'GC_2867',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR31 + ZU35*ZUR32 + ZU36*ZUR33)*complexconjugate(ZN31) - 3*(ZU31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2868 = Coupling(name = 'GC_2868',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 6*ZN34*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2869 = Coupling(name = 'GC_2869',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR31 + ZU45*ZUR32 + ZU46*ZUR33)*complexconjugate(ZN31) - 3*(ZU41*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU42*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU43*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2870 = Coupling(name = 'GC_2870',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 6*ZN34*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2871 = Coupling(name = 'GC_2871',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR31 + ZU55*ZUR32 + ZU56*ZUR33)*complexconjugate(ZN31) - 3*(ZU51*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU52*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU53*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2872 = Coupling(name = 'GC_2872',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN32*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 6*ZN34*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2873 = Coupling(name = 'GC_2873',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR31 + ZU65*ZUR32 + ZU66*ZUR33)*complexconjugate(ZN31) - 3*(ZU61*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU62*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU63*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN34))', 
	 order = {'QED':1} ) 
 
GC_2874 = Coupling(name = 'GC_2874',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13)) + 6*ZN44*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2875 = Coupling(name = 'GC_2875',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR11 + ZU15*ZUR12 + ZU16*ZUR13)*complexconjugate(ZN41) - 3*(ZU11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2876 = Coupling(name = 'GC_2876',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13)) + 6*ZN44*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2877 = Coupling(name = 'GC_2877',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR11 + ZU25*ZUR12 + ZU26*ZUR13)*complexconjugate(ZN41) - 3*(ZU21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2878 = Coupling(name = 'GC_2878',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13)) + 6*ZN44*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2879 = Coupling(name = 'GC_2879',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR11 + ZU35*ZUR12 + ZU36*ZUR13)*complexconjugate(ZN41) - 3*(ZU31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2880 = Coupling(name = 'GC_2880',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13)) + 6*ZN44*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2881 = Coupling(name = 'GC_2881',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR11 + ZU45*ZUR12 + ZU46*ZUR13)*complexconjugate(ZN41) - 3*(ZU41*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU42*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU43*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2882 = Coupling(name = 'GC_2882',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13)) + 6*ZN44*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2883 = Coupling(name = 'GC_2883',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR11 + ZU55*ZUR12 + ZU56*ZUR13)*complexconjugate(ZN41) - 3*(ZU51*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU52*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU53*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2884 = Coupling(name = 'GC_2884',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13)) + 6*ZN44*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL13)))', 
	 order = {'QED':1} ) 
 
GC_2885 = Coupling(name = 'GC_2885',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR11 + ZU65*ZUR12 + ZU66*ZUR13)*complexconjugate(ZN41) - 3*(ZU61*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZU62*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZU63*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2886 = Coupling(name = 'GC_2886',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23)) + 6*ZN44*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2887 = Coupling(name = 'GC_2887',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR21 + ZU15*ZUR22 + ZU16*ZUR23)*complexconjugate(ZN41) - 3*(ZU11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2888 = Coupling(name = 'GC_2888',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23)) + 6*ZN44*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2889 = Coupling(name = 'GC_2889',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR21 + ZU25*ZUR22 + ZU26*ZUR23)*complexconjugate(ZN41) - 3*(ZU21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2890 = Coupling(name = 'GC_2890',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23)) + 6*ZN44*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2891 = Coupling(name = 'GC_2891',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR21 + ZU35*ZUR22 + ZU36*ZUR23)*complexconjugate(ZN41) - 3*(ZU31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2892 = Coupling(name = 'GC_2892',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23)) + 6*ZN44*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2893 = Coupling(name = 'GC_2893',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR21 + ZU45*ZUR22 + ZU46*ZUR23)*complexconjugate(ZN41) - 3*(ZU41*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU42*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU43*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2894 = Coupling(name = 'GC_2894',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23)) + 6*ZN44*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2895 = Coupling(name = 'GC_2895',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR21 + ZU55*ZUR22 + ZU56*ZUR23)*complexconjugate(ZN41) - 3*(ZU51*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU52*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU53*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2896 = Coupling(name = 'GC_2896',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23)) + 6*ZN44*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL23)))', 
	 order = {'QED':1} ) 
 
GC_2897 = Coupling(name = 'GC_2897',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR21 + ZU65*ZUR22 + ZU66*ZUR23)*complexconjugate(ZN41) - 3*(ZU61*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZU62*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZU63*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2898 = Coupling(name = 'GC_2898',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33)) + 6*ZN44*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZUL31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZUL32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2899 = Coupling(name = 'GC_2899',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU14*ZUR31 + ZU15*ZUR32 + ZU16*ZUR33)*complexconjugate(ZN41) - 3*(ZU11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2900 = Coupling(name = 'GC_2900',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33)) + 6*ZN44*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZUL31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZUL32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2901 = Coupling(name = 'GC_2901',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU24*ZUR31 + ZU25*ZUR32 + ZU26*ZUR33)*complexconjugate(ZN41) - 3*(ZU21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2902 = Coupling(name = 'GC_2902',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33)) + 6*ZN44*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZUL31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZUL32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2903 = Coupling(name = 'GC_2903',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU34*ZUR31 + ZU35*ZUR32 + ZU36*ZUR33)*complexconjugate(ZN41) - 3*(ZU31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2904 = Coupling(name = 'GC_2904',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33)) + 6*ZN44*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZUL31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZUL32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2905 = Coupling(name = 'GC_2905',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU44*ZUR31 + ZU45*ZUR32 + ZU46*ZUR33)*complexconjugate(ZN41) - 3*(ZU41*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU42*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU43*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2906 = Coupling(name = 'GC_2906',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33)) + 6*ZN44*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZUL31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZUL32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2907 = Coupling(name = 'GC_2907',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU54*ZUR31 + ZU55*ZUR32 + ZU56*ZUR33)*complexconjugate(ZN41) - 3*(ZU51*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU52*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU53*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2908 = Coupling(name = 'GC_2908',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 3*cmath.sqrt(2)*g2*ZN42*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33)) + 6*ZN44*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZUL31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZUL32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZUL33)))', 
	 order = {'QED':1} ) 
 
GC_2909 = Coupling(name = 'GC_2909',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*(ZU64*ZUR31 + ZU65*ZUR32 + ZU66*ZUR33)*complexconjugate(ZN41) - 3*(ZU61*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZU62*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZU63*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))*complexconjugate(ZN44))', 
	 order = {'QED':1} ) 
 
GC_2910 = Coupling(name = 'GC_2910',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV11))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2911 = Coupling(name = 'GC_2911',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV21))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2912 = Coupling(name = 'GC_2912',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV31))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2913 = Coupling(name = 'GC_2913',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2914 = Coupling(name = 'GC_2914',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2915 = Coupling(name = 'GC_2915',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV32))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2916 = Coupling(name = 'GC_2916',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV13))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2917 = Coupling(name = 'GC_2917',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV23))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2918 = Coupling(name = 'GC_2918',
	 value = '(1*complex(0,1)*(g1*ZN11 - g2*ZN12)*complexconjugate(ZV33))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2919 = Coupling(name = 'GC_2919',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV11))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2920 = Coupling(name = 'GC_2920',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV21))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2921 = Coupling(name = 'GC_2921',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV31))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2922 = Coupling(name = 'GC_2922',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2923 = Coupling(name = 'GC_2923',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2924 = Coupling(name = 'GC_2924',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV32))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2925 = Coupling(name = 'GC_2925',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV13))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2926 = Coupling(name = 'GC_2926',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV23))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2927 = Coupling(name = 'GC_2927',
	 value = '(1*complex(0,1)*(g1*ZN21 - g2*ZN22)*complexconjugate(ZV33))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2928 = Coupling(name = 'GC_2928',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV11))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2929 = Coupling(name = 'GC_2929',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV21))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2930 = Coupling(name = 'GC_2930',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV31))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2931 = Coupling(name = 'GC_2931',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2932 = Coupling(name = 'GC_2932',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2933 = Coupling(name = 'GC_2933',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV32))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2934 = Coupling(name = 'GC_2934',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV13))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2935 = Coupling(name = 'GC_2935',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV23))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2936 = Coupling(name = 'GC_2936',
	 value = '(1*complex(0,1)*(g1*ZN31 - g2*ZN32)*complexconjugate(ZV33))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2937 = Coupling(name = 'GC_2937',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV11))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2938 = Coupling(name = 'GC_2938',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV21))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2939 = Coupling(name = 'GC_2939',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV31))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2940 = Coupling(name = 'GC_2940',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2941 = Coupling(name = 'GC_2941',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2942 = Coupling(name = 'GC_2942',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV32))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2943 = Coupling(name = 'GC_2943',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV13))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2944 = Coupling(name = 'GC_2944',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV23))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2945 = Coupling(name = 'GC_2945',
	 value = '(1*complex(0,1)*(g1*ZN41 - g2*ZN42)*complexconjugate(ZV33))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_2946 = Coupling(name = 'GC_2946',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN11 + g2*ZN12) + 2*g2*UP11*ZN14)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2947 = Coupling(name = 'GC_2947',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2948 = Coupling(name = 'GC_2948',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN11 + g2*ZN12) + 2*g2*UP11*ZN14)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2949 = Coupling(name = 'GC_2949',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2950 = Coupling(name = 'GC_2950',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN21 + g2*ZN22) + 2*g2*UP11*ZN24)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2951 = Coupling(name = 'GC_2951',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2952 = Coupling(name = 'GC_2952',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN21 + g2*ZN22) + 2*g2*UP11*ZN24)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2953 = Coupling(name = 'GC_2953',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2954 = Coupling(name = 'GC_2954',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN31 + g2*ZN32) + 2*g2*UP11*ZN34)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2955 = Coupling(name = 'GC_2955',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2956 = Coupling(name = 'GC_2956',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN31 + g2*ZN32) + 2*g2*UP11*ZN34)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2957 = Coupling(name = 'GC_2957',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2958 = Coupling(name = 'GC_2958',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN41 + g2*ZN42) + 2*g2*UP11*ZN44)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2959 = Coupling(name = 'GC_2959',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2960 = Coupling(name = 'GC_2960',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP12*(g1*ZN41 + g2*ZN42) + 2*g2*UP11*ZN44)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2961 = Coupling(name = 'GC_2961',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM12)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*g2*complexconjugate(UM11)*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2962 = Coupling(name = 'GC_2962',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN11 + g2*ZN12) + 2*g2*UP21*ZN14)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2963 = Coupling(name = 'GC_2963',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2964 = Coupling(name = 'GC_2964',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN11 + g2*ZN12) + 2*g2*UP21*ZN14)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2965 = Coupling(name = 'GC_2965',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2966 = Coupling(name = 'GC_2966',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN21 + g2*ZN22) + 2*g2*UP21*ZN24)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2967 = Coupling(name = 'GC_2967',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2968 = Coupling(name = 'GC_2968',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN21 + g2*ZN22) + 2*g2*UP21*ZN24)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2969 = Coupling(name = 'GC_2969',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2970 = Coupling(name = 'GC_2970',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN31 + g2*ZN32) + 2*g2*UP21*ZN34)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2971 = Coupling(name = 'GC_2971',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2972 = Coupling(name = 'GC_2972',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN31 + g2*ZN32) + 2*g2*UP21*ZN34)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2973 = Coupling(name = 'GC_2973',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_2974 = Coupling(name = 'GC_2974',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN41 + g2*ZN42) + 2*g2*UP21*ZN44)*ZP12', 
	 order = {'QED':1} ) 
 
GC_2975 = Coupling(name = 'GC_2975',
	 value = '1./2.*complex(0,1)*ZP11*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2976 = Coupling(name = 'GC_2976',
	 value = '-1./2.*complex(0,1)*(cmath.sqrt(2)*UP22*(g1*ZN41 + g2*ZN42) + 2*g2*UP21*ZN44)*ZP22', 
	 order = {'QED':1} ) 
 
GC_2977 = Coupling(name = 'GC_2977',
	 value = '1./2.*complex(0,1)*ZP21*(cmath.sqrt(2)*complexconjugate(UM22)*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*g2*complexconjugate(UM21)*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_2978 = Coupling(name = 'GC_2978',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD14)*complexconjugate(ZDR11) + complexconjugate(ZD15)*complexconjugate(ZDR12) + complexconjugate(ZD16)*complexconjugate(ZDR13)) + 3*ZN13*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2979 = Coupling(name = 'GC_2979',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD11) + ZDL12*complexconjugate(ZD12) + ZDL13*complexconjugate(ZD13))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2980 = Coupling(name = 'GC_2980',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD24)*complexconjugate(ZDR11) + complexconjugate(ZD25)*complexconjugate(ZDR12) + complexconjugate(ZD26)*complexconjugate(ZDR13)) + 3*ZN13*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2981 = Coupling(name = 'GC_2981',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD21) + ZDL12*complexconjugate(ZD22) + ZDL13*complexconjugate(ZD23))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2982 = Coupling(name = 'GC_2982',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD34)*complexconjugate(ZDR11) + complexconjugate(ZD35)*complexconjugate(ZDR12) + complexconjugate(ZD36)*complexconjugate(ZDR13)) + 3*ZN13*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2983 = Coupling(name = 'GC_2983',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD31) + ZDL12*complexconjugate(ZD32) + ZDL13*complexconjugate(ZD33))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2984 = Coupling(name = 'GC_2984',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD44)*complexconjugate(ZDR11) + complexconjugate(ZD45)*complexconjugate(ZDR12) + complexconjugate(ZD46)*complexconjugate(ZDR13)) + 3*ZN13*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2985 = Coupling(name = 'GC_2985',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD41) + ZDL12*complexconjugate(ZD42) + ZDL13*complexconjugate(ZD43))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2986 = Coupling(name = 'GC_2986',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD54)*complexconjugate(ZDR11) + complexconjugate(ZD55)*complexconjugate(ZDR12) + complexconjugate(ZD56)*complexconjugate(ZDR13)) + 3*ZN13*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2987 = Coupling(name = 'GC_2987',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD51) + ZDL12*complexconjugate(ZD52) + ZDL13*complexconjugate(ZD53))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2988 = Coupling(name = 'GC_2988',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD64)*complexconjugate(ZDR11) + complexconjugate(ZD65)*complexconjugate(ZDR12) + complexconjugate(ZD66)*complexconjugate(ZDR13)) + 3*ZN13*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2989 = Coupling(name = 'GC_2989',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD61) + ZDL12*complexconjugate(ZD62) + ZDL13*complexconjugate(ZD63))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_2990 = Coupling(name = 'GC_2990',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD14)*complexconjugate(ZDR11) + complexconjugate(ZD15)*complexconjugate(ZDR12) + complexconjugate(ZD16)*complexconjugate(ZDR13)) + 3*ZN23*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2991 = Coupling(name = 'GC_2991',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD11) + ZDL12*complexconjugate(ZD12) + ZDL13*complexconjugate(ZD13))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2992 = Coupling(name = 'GC_2992',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD24)*complexconjugate(ZDR11) + complexconjugate(ZD25)*complexconjugate(ZDR12) + complexconjugate(ZD26)*complexconjugate(ZDR13)) + 3*ZN23*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2993 = Coupling(name = 'GC_2993',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD21) + ZDL12*complexconjugate(ZD22) + ZDL13*complexconjugate(ZD23))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2994 = Coupling(name = 'GC_2994',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD34)*complexconjugate(ZDR11) + complexconjugate(ZD35)*complexconjugate(ZDR12) + complexconjugate(ZD36)*complexconjugate(ZDR13)) + 3*ZN23*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2995 = Coupling(name = 'GC_2995',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD31) + ZDL12*complexconjugate(ZD32) + ZDL13*complexconjugate(ZD33))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2996 = Coupling(name = 'GC_2996',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD44)*complexconjugate(ZDR11) + complexconjugate(ZD45)*complexconjugate(ZDR12) + complexconjugate(ZD46)*complexconjugate(ZDR13)) + 3*ZN23*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2997 = Coupling(name = 'GC_2997',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD41) + ZDL12*complexconjugate(ZD42) + ZDL13*complexconjugate(ZD43))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_2998 = Coupling(name = 'GC_2998',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD54)*complexconjugate(ZDR11) + complexconjugate(ZD55)*complexconjugate(ZDR12) + complexconjugate(ZD56)*complexconjugate(ZDR13)) + 3*ZN23*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_2999 = Coupling(name = 'GC_2999',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD51) + ZDL12*complexconjugate(ZD52) + ZDL13*complexconjugate(ZD53))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3000 = Coupling(name = 'GC_3000',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD64)*complexconjugate(ZDR11) + complexconjugate(ZD65)*complexconjugate(ZDR12) + complexconjugate(ZD66)*complexconjugate(ZDR13)) + 3*ZN23*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3001 = Coupling(name = 'GC_3001',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD61) + ZDL12*complexconjugate(ZD62) + ZDL13*complexconjugate(ZD63))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3002 = Coupling(name = 'GC_3002',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD14)*complexconjugate(ZDR11) + complexconjugate(ZD15)*complexconjugate(ZDR12) + complexconjugate(ZD16)*complexconjugate(ZDR13)) + 3*ZN33*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3003 = Coupling(name = 'GC_3003',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD11) + ZDL12*complexconjugate(ZD12) + ZDL13*complexconjugate(ZD13))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3004 = Coupling(name = 'GC_3004',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD24)*complexconjugate(ZDR11) + complexconjugate(ZD25)*complexconjugate(ZDR12) + complexconjugate(ZD26)*complexconjugate(ZDR13)) + 3*ZN33*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3005 = Coupling(name = 'GC_3005',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD21) + ZDL12*complexconjugate(ZD22) + ZDL13*complexconjugate(ZD23))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3006 = Coupling(name = 'GC_3006',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD34)*complexconjugate(ZDR11) + complexconjugate(ZD35)*complexconjugate(ZDR12) + complexconjugate(ZD36)*complexconjugate(ZDR13)) + 3*ZN33*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3007 = Coupling(name = 'GC_3007',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD31) + ZDL12*complexconjugate(ZD32) + ZDL13*complexconjugate(ZD33))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3008 = Coupling(name = 'GC_3008',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD44)*complexconjugate(ZDR11) + complexconjugate(ZD45)*complexconjugate(ZDR12) + complexconjugate(ZD46)*complexconjugate(ZDR13)) + 3*ZN33*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3009 = Coupling(name = 'GC_3009',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD41) + ZDL12*complexconjugate(ZD42) + ZDL13*complexconjugate(ZD43))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3010 = Coupling(name = 'GC_3010',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD54)*complexconjugate(ZDR11) + complexconjugate(ZD55)*complexconjugate(ZDR12) + complexconjugate(ZD56)*complexconjugate(ZDR13)) + 3*ZN33*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3011 = Coupling(name = 'GC_3011',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD51) + ZDL12*complexconjugate(ZD52) + ZDL13*complexconjugate(ZD53))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3012 = Coupling(name = 'GC_3012',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD64)*complexconjugate(ZDR11) + complexconjugate(ZD65)*complexconjugate(ZDR12) + complexconjugate(ZD66)*complexconjugate(ZDR13)) + 3*ZN33*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3013 = Coupling(name = 'GC_3013',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD61) + ZDL12*complexconjugate(ZD62) + ZDL13*complexconjugate(ZD63))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3014 = Coupling(name = 'GC_3014',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD14)*complexconjugate(ZDR11) + complexconjugate(ZD15)*complexconjugate(ZDR12) + complexconjugate(ZD16)*complexconjugate(ZDR13)) + 3*ZN43*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3015 = Coupling(name = 'GC_3015',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD11) + ZDL12*complexconjugate(ZD12) + ZDL13*complexconjugate(ZD13))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3016 = Coupling(name = 'GC_3016',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD24)*complexconjugate(ZDR11) + complexconjugate(ZD25)*complexconjugate(ZDR12) + complexconjugate(ZD26)*complexconjugate(ZDR13)) + 3*ZN43*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3017 = Coupling(name = 'GC_3017',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD21) + ZDL12*complexconjugate(ZD22) + ZDL13*complexconjugate(ZD23))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3018 = Coupling(name = 'GC_3018',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD34)*complexconjugate(ZDR11) + complexconjugate(ZD35)*complexconjugate(ZDR12) + complexconjugate(ZD36)*complexconjugate(ZDR13)) + 3*ZN43*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3019 = Coupling(name = 'GC_3019',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD31) + ZDL12*complexconjugate(ZD32) + ZDL13*complexconjugate(ZD33))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3020 = Coupling(name = 'GC_3020',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD44)*complexconjugate(ZDR11) + complexconjugate(ZD45)*complexconjugate(ZDR12) + complexconjugate(ZD46)*complexconjugate(ZDR13)) + 3*ZN43*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3021 = Coupling(name = 'GC_3021',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD41) + ZDL12*complexconjugate(ZD42) + ZDL13*complexconjugate(ZD43))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3022 = Coupling(name = 'GC_3022',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD54)*complexconjugate(ZDR11) + complexconjugate(ZD55)*complexconjugate(ZDR12) + complexconjugate(ZD56)*complexconjugate(ZDR13)) + 3*ZN43*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3023 = Coupling(name = 'GC_3023',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD51) + ZDL12*complexconjugate(ZD52) + ZDL13*complexconjugate(ZD53))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3024 = Coupling(name = 'GC_3024',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD64)*complexconjugate(ZDR11) + complexconjugate(ZD65)*complexconjugate(ZDR12) + complexconjugate(ZD66)*complexconjugate(ZDR13)) + 3*ZN43*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))', 
	 order = {'QED':1} ) 
 
GC_3025 = Coupling(name = 'GC_3025',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL11*complexconjugate(ZD61) + ZDL12*complexconjugate(ZD62) + ZDL13*complexconjugate(ZD63))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3026 = Coupling(name = 'GC_3026',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD14)*complexconjugate(ZDR21) + complexconjugate(ZD15)*complexconjugate(ZDR22) + complexconjugate(ZD16)*complexconjugate(ZDR23)) + 3*ZN13*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3027 = Coupling(name = 'GC_3027',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD11) + ZDL22*complexconjugate(ZD12) + ZDL23*complexconjugate(ZD13))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3028 = Coupling(name = 'GC_3028',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD24)*complexconjugate(ZDR21) + complexconjugate(ZD25)*complexconjugate(ZDR22) + complexconjugate(ZD26)*complexconjugate(ZDR23)) + 3*ZN13*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3029 = Coupling(name = 'GC_3029',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD21) + ZDL22*complexconjugate(ZD22) + ZDL23*complexconjugate(ZD23))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3030 = Coupling(name = 'GC_3030',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD34)*complexconjugate(ZDR21) + complexconjugate(ZD35)*complexconjugate(ZDR22) + complexconjugate(ZD36)*complexconjugate(ZDR23)) + 3*ZN13*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3031 = Coupling(name = 'GC_3031',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD31) + ZDL22*complexconjugate(ZD32) + ZDL23*complexconjugate(ZD33))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3032 = Coupling(name = 'GC_3032',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD44)*complexconjugate(ZDR21) + complexconjugate(ZD45)*complexconjugate(ZDR22) + complexconjugate(ZD46)*complexconjugate(ZDR23)) + 3*ZN13*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3033 = Coupling(name = 'GC_3033',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD41) + ZDL22*complexconjugate(ZD42) + ZDL23*complexconjugate(ZD43))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3034 = Coupling(name = 'GC_3034',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD54)*complexconjugate(ZDR21) + complexconjugate(ZD55)*complexconjugate(ZDR22) + complexconjugate(ZD56)*complexconjugate(ZDR23)) + 3*ZN13*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3035 = Coupling(name = 'GC_3035',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD51) + ZDL22*complexconjugate(ZD52) + ZDL23*complexconjugate(ZD53))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3036 = Coupling(name = 'GC_3036',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD64)*complexconjugate(ZDR21) + complexconjugate(ZD65)*complexconjugate(ZDR22) + complexconjugate(ZD66)*complexconjugate(ZDR23)) + 3*ZN13*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3037 = Coupling(name = 'GC_3037',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD61) + ZDL22*complexconjugate(ZD62) + ZDL23*complexconjugate(ZD63))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3038 = Coupling(name = 'GC_3038',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD14)*complexconjugate(ZDR21) + complexconjugate(ZD15)*complexconjugate(ZDR22) + complexconjugate(ZD16)*complexconjugate(ZDR23)) + 3*ZN23*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3039 = Coupling(name = 'GC_3039',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD11) + ZDL22*complexconjugate(ZD12) + ZDL23*complexconjugate(ZD13))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3040 = Coupling(name = 'GC_3040',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD24)*complexconjugate(ZDR21) + complexconjugate(ZD25)*complexconjugate(ZDR22) + complexconjugate(ZD26)*complexconjugate(ZDR23)) + 3*ZN23*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3041 = Coupling(name = 'GC_3041',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD21) + ZDL22*complexconjugate(ZD22) + ZDL23*complexconjugate(ZD23))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3042 = Coupling(name = 'GC_3042',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD34)*complexconjugate(ZDR21) + complexconjugate(ZD35)*complexconjugate(ZDR22) + complexconjugate(ZD36)*complexconjugate(ZDR23)) + 3*ZN23*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3043 = Coupling(name = 'GC_3043',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD31) + ZDL22*complexconjugate(ZD32) + ZDL23*complexconjugate(ZD33))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3044 = Coupling(name = 'GC_3044',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD44)*complexconjugate(ZDR21) + complexconjugate(ZD45)*complexconjugate(ZDR22) + complexconjugate(ZD46)*complexconjugate(ZDR23)) + 3*ZN23*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3045 = Coupling(name = 'GC_3045',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD41) + ZDL22*complexconjugate(ZD42) + ZDL23*complexconjugate(ZD43))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3046 = Coupling(name = 'GC_3046',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD54)*complexconjugate(ZDR21) + complexconjugate(ZD55)*complexconjugate(ZDR22) + complexconjugate(ZD56)*complexconjugate(ZDR23)) + 3*ZN23*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3047 = Coupling(name = 'GC_3047',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD51) + ZDL22*complexconjugate(ZD52) + ZDL23*complexconjugate(ZD53))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3048 = Coupling(name = 'GC_3048',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD64)*complexconjugate(ZDR21) + complexconjugate(ZD65)*complexconjugate(ZDR22) + complexconjugate(ZD66)*complexconjugate(ZDR23)) + 3*ZN23*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3049 = Coupling(name = 'GC_3049',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD61) + ZDL22*complexconjugate(ZD62) + ZDL23*complexconjugate(ZD63))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3050 = Coupling(name = 'GC_3050',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD14)*complexconjugate(ZDR21) + complexconjugate(ZD15)*complexconjugate(ZDR22) + complexconjugate(ZD16)*complexconjugate(ZDR23)) + 3*ZN33*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3051 = Coupling(name = 'GC_3051',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD11) + ZDL22*complexconjugate(ZD12) + ZDL23*complexconjugate(ZD13))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3052 = Coupling(name = 'GC_3052',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD24)*complexconjugate(ZDR21) + complexconjugate(ZD25)*complexconjugate(ZDR22) + complexconjugate(ZD26)*complexconjugate(ZDR23)) + 3*ZN33*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3053 = Coupling(name = 'GC_3053',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD21) + ZDL22*complexconjugate(ZD22) + ZDL23*complexconjugate(ZD23))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3054 = Coupling(name = 'GC_3054',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD34)*complexconjugate(ZDR21) + complexconjugate(ZD35)*complexconjugate(ZDR22) + complexconjugate(ZD36)*complexconjugate(ZDR23)) + 3*ZN33*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3055 = Coupling(name = 'GC_3055',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD31) + ZDL22*complexconjugate(ZD32) + ZDL23*complexconjugate(ZD33))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3056 = Coupling(name = 'GC_3056',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD44)*complexconjugate(ZDR21) + complexconjugate(ZD45)*complexconjugate(ZDR22) + complexconjugate(ZD46)*complexconjugate(ZDR23)) + 3*ZN33*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3057 = Coupling(name = 'GC_3057',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD41) + ZDL22*complexconjugate(ZD42) + ZDL23*complexconjugate(ZD43))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3058 = Coupling(name = 'GC_3058',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD54)*complexconjugate(ZDR21) + complexconjugate(ZD55)*complexconjugate(ZDR22) + complexconjugate(ZD56)*complexconjugate(ZDR23)) + 3*ZN33*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3059 = Coupling(name = 'GC_3059',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD51) + ZDL22*complexconjugate(ZD52) + ZDL23*complexconjugate(ZD53))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3060 = Coupling(name = 'GC_3060',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD64)*complexconjugate(ZDR21) + complexconjugate(ZD65)*complexconjugate(ZDR22) + complexconjugate(ZD66)*complexconjugate(ZDR23)) + 3*ZN33*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3061 = Coupling(name = 'GC_3061',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD61) + ZDL22*complexconjugate(ZD62) + ZDL23*complexconjugate(ZD63))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3062 = Coupling(name = 'GC_3062',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD14)*complexconjugate(ZDR21) + complexconjugate(ZD15)*complexconjugate(ZDR22) + complexconjugate(ZD16)*complexconjugate(ZDR23)) + 3*ZN43*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3063 = Coupling(name = 'GC_3063',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD11) + ZDL22*complexconjugate(ZD12) + ZDL23*complexconjugate(ZD13))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3064 = Coupling(name = 'GC_3064',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD24)*complexconjugate(ZDR21) + complexconjugate(ZD25)*complexconjugate(ZDR22) + complexconjugate(ZD26)*complexconjugate(ZDR23)) + 3*ZN43*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3065 = Coupling(name = 'GC_3065',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD21) + ZDL22*complexconjugate(ZD22) + ZDL23*complexconjugate(ZD23))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3066 = Coupling(name = 'GC_3066',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD34)*complexconjugate(ZDR21) + complexconjugate(ZD35)*complexconjugate(ZDR22) + complexconjugate(ZD36)*complexconjugate(ZDR23)) + 3*ZN43*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3067 = Coupling(name = 'GC_3067',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD31) + ZDL22*complexconjugate(ZD32) + ZDL23*complexconjugate(ZD33))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3068 = Coupling(name = 'GC_3068',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD44)*complexconjugate(ZDR21) + complexconjugate(ZD45)*complexconjugate(ZDR22) + complexconjugate(ZD46)*complexconjugate(ZDR23)) + 3*ZN43*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3069 = Coupling(name = 'GC_3069',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD41) + ZDL22*complexconjugate(ZD42) + ZDL23*complexconjugate(ZD43))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3070 = Coupling(name = 'GC_3070',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD54)*complexconjugate(ZDR21) + complexconjugate(ZD55)*complexconjugate(ZDR22) + complexconjugate(ZD56)*complexconjugate(ZDR23)) + 3*ZN43*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3071 = Coupling(name = 'GC_3071',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD51) + ZDL22*complexconjugate(ZD52) + ZDL23*complexconjugate(ZD53))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3072 = Coupling(name = 'GC_3072',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD64)*complexconjugate(ZDR21) + complexconjugate(ZD65)*complexconjugate(ZDR22) + complexconjugate(ZD66)*complexconjugate(ZDR23)) + 3*ZN43*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))', 
	 order = {'QED':1} ) 
 
GC_3073 = Coupling(name = 'GC_3073',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL21*complexconjugate(ZD61) + ZDL22*complexconjugate(ZD62) + ZDL23*complexconjugate(ZD63))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3074 = Coupling(name = 'GC_3074',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD14)*complexconjugate(ZDR31) + complexconjugate(ZD15)*complexconjugate(ZDR32) + complexconjugate(ZD16)*complexconjugate(ZDR33)) + 3*ZN13*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3075 = Coupling(name = 'GC_3075',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD11) + ZDL32*complexconjugate(ZD12) + ZDL33*complexconjugate(ZD13))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3076 = Coupling(name = 'GC_3076',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD24)*complexconjugate(ZDR31) + complexconjugate(ZD25)*complexconjugate(ZDR32) + complexconjugate(ZD26)*complexconjugate(ZDR33)) + 3*ZN13*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3077 = Coupling(name = 'GC_3077',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD21) + ZDL32*complexconjugate(ZD22) + ZDL33*complexconjugate(ZD23))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3078 = Coupling(name = 'GC_3078',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD34)*complexconjugate(ZDR31) + complexconjugate(ZD35)*complexconjugate(ZDR32) + complexconjugate(ZD36)*complexconjugate(ZDR33)) + 3*ZN13*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3079 = Coupling(name = 'GC_3079',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD31) + ZDL32*complexconjugate(ZD32) + ZDL33*complexconjugate(ZD33))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3080 = Coupling(name = 'GC_3080',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD44)*complexconjugate(ZDR31) + complexconjugate(ZD45)*complexconjugate(ZDR32) + complexconjugate(ZD46)*complexconjugate(ZDR33)) + 3*ZN13*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3081 = Coupling(name = 'GC_3081',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD41) + ZDL32*complexconjugate(ZD42) + ZDL33*complexconjugate(ZD43))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3082 = Coupling(name = 'GC_3082',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD54)*complexconjugate(ZDR31) + complexconjugate(ZD55)*complexconjugate(ZDR32) + complexconjugate(ZD56)*complexconjugate(ZDR33)) + 3*ZN13*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3083 = Coupling(name = 'GC_3083',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD51) + ZDL32*complexconjugate(ZD52) + ZDL33*complexconjugate(ZD53))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3084 = Coupling(name = 'GC_3084',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZD64)*complexconjugate(ZDR31) + complexconjugate(ZD65)*complexconjugate(ZDR32) + complexconjugate(ZD66)*complexconjugate(ZDR33)) + 3*ZN13*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3085 = Coupling(name = 'GC_3085',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD61) + ZDL32*complexconjugate(ZD62) + ZDL33*complexconjugate(ZD63))*(g1*complexconjugate(ZN11) - 3*g2*complexconjugate(ZN12)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3086 = Coupling(name = 'GC_3086',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD14)*complexconjugate(ZDR31) + complexconjugate(ZD15)*complexconjugate(ZDR32) + complexconjugate(ZD16)*complexconjugate(ZDR33)) + 3*ZN23*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3087 = Coupling(name = 'GC_3087',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD11) + ZDL32*complexconjugate(ZD12) + ZDL33*complexconjugate(ZD13))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3088 = Coupling(name = 'GC_3088',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD24)*complexconjugate(ZDR31) + complexconjugate(ZD25)*complexconjugate(ZDR32) + complexconjugate(ZD26)*complexconjugate(ZDR33)) + 3*ZN23*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3089 = Coupling(name = 'GC_3089',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD21) + ZDL32*complexconjugate(ZD22) + ZDL33*complexconjugate(ZD23))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3090 = Coupling(name = 'GC_3090',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD34)*complexconjugate(ZDR31) + complexconjugate(ZD35)*complexconjugate(ZDR32) + complexconjugate(ZD36)*complexconjugate(ZDR33)) + 3*ZN23*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3091 = Coupling(name = 'GC_3091',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD31) + ZDL32*complexconjugate(ZD32) + ZDL33*complexconjugate(ZD33))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3092 = Coupling(name = 'GC_3092',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD44)*complexconjugate(ZDR31) + complexconjugate(ZD45)*complexconjugate(ZDR32) + complexconjugate(ZD46)*complexconjugate(ZDR33)) + 3*ZN23*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3093 = Coupling(name = 'GC_3093',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD41) + ZDL32*complexconjugate(ZD42) + ZDL33*complexconjugate(ZD43))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3094 = Coupling(name = 'GC_3094',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD54)*complexconjugate(ZDR31) + complexconjugate(ZD55)*complexconjugate(ZDR32) + complexconjugate(ZD56)*complexconjugate(ZDR33)) + 3*ZN23*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3095 = Coupling(name = 'GC_3095',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD51) + ZDL32*complexconjugate(ZD52) + ZDL33*complexconjugate(ZD53))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3096 = Coupling(name = 'GC_3096',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZD64)*complexconjugate(ZDR31) + complexconjugate(ZD65)*complexconjugate(ZDR32) + complexconjugate(ZD66)*complexconjugate(ZDR33)) + 3*ZN23*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3097 = Coupling(name = 'GC_3097',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD61) + ZDL32*complexconjugate(ZD62) + ZDL33*complexconjugate(ZD63))*(g1*complexconjugate(ZN21) - 3*g2*complexconjugate(ZN22)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3098 = Coupling(name = 'GC_3098',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD14)*complexconjugate(ZDR31) + complexconjugate(ZD15)*complexconjugate(ZDR32) + complexconjugate(ZD16)*complexconjugate(ZDR33)) + 3*ZN33*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3099 = Coupling(name = 'GC_3099',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD11) + ZDL32*complexconjugate(ZD12) + ZDL33*complexconjugate(ZD13))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3100 = Coupling(name = 'GC_3100',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD24)*complexconjugate(ZDR31) + complexconjugate(ZD25)*complexconjugate(ZDR32) + complexconjugate(ZD26)*complexconjugate(ZDR33)) + 3*ZN33*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3101 = Coupling(name = 'GC_3101',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD21) + ZDL32*complexconjugate(ZD22) + ZDL33*complexconjugate(ZD23))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3102 = Coupling(name = 'GC_3102',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD34)*complexconjugate(ZDR31) + complexconjugate(ZD35)*complexconjugate(ZDR32) + complexconjugate(ZD36)*complexconjugate(ZDR33)) + 3*ZN33*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3103 = Coupling(name = 'GC_3103',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD31) + ZDL32*complexconjugate(ZD32) + ZDL33*complexconjugate(ZD33))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3104 = Coupling(name = 'GC_3104',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD44)*complexconjugate(ZDR31) + complexconjugate(ZD45)*complexconjugate(ZDR32) + complexconjugate(ZD46)*complexconjugate(ZDR33)) + 3*ZN33*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3105 = Coupling(name = 'GC_3105',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD41) + ZDL32*complexconjugate(ZD42) + ZDL33*complexconjugate(ZD43))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3106 = Coupling(name = 'GC_3106',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD54)*complexconjugate(ZDR31) + complexconjugate(ZD55)*complexconjugate(ZDR32) + complexconjugate(ZD56)*complexconjugate(ZDR33)) + 3*ZN33*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3107 = Coupling(name = 'GC_3107',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD51) + ZDL32*complexconjugate(ZD52) + ZDL33*complexconjugate(ZD53))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3108 = Coupling(name = 'GC_3108',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZD64)*complexconjugate(ZDR31) + complexconjugate(ZD65)*complexconjugate(ZDR32) + complexconjugate(ZD66)*complexconjugate(ZDR33)) + 3*ZN33*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3109 = Coupling(name = 'GC_3109',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD61) + ZDL32*complexconjugate(ZD62) + ZDL33*complexconjugate(ZD63))*(g1*complexconjugate(ZN31) - 3*g2*complexconjugate(ZN32)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3110 = Coupling(name = 'GC_3110',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD14)*complexconjugate(ZDR31) + complexconjugate(ZD15)*complexconjugate(ZDR32) + complexconjugate(ZD16)*complexconjugate(ZDR33)) + 3*ZN43*(complexconjugate(ZD11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3111 = Coupling(name = 'GC_3111',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD11) + ZDL32*complexconjugate(ZD12) + ZDL33*complexconjugate(ZD13))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3112 = Coupling(name = 'GC_3112',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD24)*complexconjugate(ZDR31) + complexconjugate(ZD25)*complexconjugate(ZDR32) + complexconjugate(ZD26)*complexconjugate(ZDR33)) + 3*ZN43*(complexconjugate(ZD21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3113 = Coupling(name = 'GC_3113',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD21) + ZDL32*complexconjugate(ZD22) + ZDL33*complexconjugate(ZD23))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3114 = Coupling(name = 'GC_3114',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD34)*complexconjugate(ZDR31) + complexconjugate(ZD35)*complexconjugate(ZDR32) + complexconjugate(ZD36)*complexconjugate(ZDR33)) + 3*ZN43*(complexconjugate(ZD31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3115 = Coupling(name = 'GC_3115',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD31) + ZDL32*complexconjugate(ZD32) + ZDL33*complexconjugate(ZD33))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3116 = Coupling(name = 'GC_3116',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD44)*complexconjugate(ZDR31) + complexconjugate(ZD45)*complexconjugate(ZDR32) + complexconjugate(ZD46)*complexconjugate(ZDR33)) + 3*ZN43*(complexconjugate(ZD41)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD42)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD43)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3117 = Coupling(name = 'GC_3117',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD41) + ZDL32*complexconjugate(ZD42) + ZDL33*complexconjugate(ZD43))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3118 = Coupling(name = 'GC_3118',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD54)*complexconjugate(ZDR31) + complexconjugate(ZD55)*complexconjugate(ZDR32) + complexconjugate(ZD56)*complexconjugate(ZDR33)) + 3*ZN43*(complexconjugate(ZD51)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD52)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD53)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3119 = Coupling(name = 'GC_3119',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD51) + ZDL32*complexconjugate(ZD52) + ZDL33*complexconjugate(ZD53))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3120 = Coupling(name = 'GC_3120',
	 value = '-1./3.*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZD64)*complexconjugate(ZDR31) + complexconjugate(ZD65)*complexconjugate(ZDR32) + complexconjugate(ZD66)*complexconjugate(ZDR33)) + 3*ZN43*(complexconjugate(ZD61)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZD62)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZD63)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))', 
	 order = {'QED':1} ) 
 
GC_3121 = Coupling(name = 'GC_3121',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(ZDL31*complexconjugate(ZD61) + ZDL32*complexconjugate(ZD62) + ZDL33*complexconjugate(ZD63))*(g1*complexconjugate(ZN41) - 3*g2*complexconjugate(ZN42)) + 6*(ZDL31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZDL32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZDL33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3122 = Coupling(name = 'GC_3122',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE14)*complexconjugate(ZER11) + complexconjugate(ZE15)*complexconjugate(ZER12) + complexconjugate(ZE16)*complexconjugate(ZER13)) + ZN13*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3123 = Coupling(name = 'GC_3123',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE11) + ZEL12*complexconjugate(ZE12) + ZEL13*complexconjugate(ZE13))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3124 = Coupling(name = 'GC_3124',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE24)*complexconjugate(ZER11) + complexconjugate(ZE25)*complexconjugate(ZER12) + complexconjugate(ZE26)*complexconjugate(ZER13)) + ZN13*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3125 = Coupling(name = 'GC_3125',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE21) + ZEL12*complexconjugate(ZE22) + ZEL13*complexconjugate(ZE23))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3126 = Coupling(name = 'GC_3126',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE34)*complexconjugate(ZER11) + complexconjugate(ZE35)*complexconjugate(ZER12) + complexconjugate(ZE36)*complexconjugate(ZER13)) + ZN13*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3127 = Coupling(name = 'GC_3127',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE31) + ZEL12*complexconjugate(ZE32) + ZEL13*complexconjugate(ZE33))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3128 = Coupling(name = 'GC_3128',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE44)*complexconjugate(ZER11) + complexconjugate(ZE45)*complexconjugate(ZER12) + complexconjugate(ZE46)*complexconjugate(ZER13)) + ZN13*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3129 = Coupling(name = 'GC_3129',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE41) + ZEL12*complexconjugate(ZE42) + ZEL13*complexconjugate(ZE43))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3130 = Coupling(name = 'GC_3130',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE54)*complexconjugate(ZER11) + complexconjugate(ZE55)*complexconjugate(ZER12) + complexconjugate(ZE56)*complexconjugate(ZER13)) + ZN13*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3131 = Coupling(name = 'GC_3131',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE51) + ZEL12*complexconjugate(ZE52) + ZEL13*complexconjugate(ZE53))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3132 = Coupling(name = 'GC_3132',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE64)*complexconjugate(ZER11) + complexconjugate(ZE65)*complexconjugate(ZER12) + complexconjugate(ZE66)*complexconjugate(ZER13)) + ZN13*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3133 = Coupling(name = 'GC_3133',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE61) + ZEL12*complexconjugate(ZE62) + ZEL13*complexconjugate(ZE63))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3134 = Coupling(name = 'GC_3134',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE14)*complexconjugate(ZER11) + complexconjugate(ZE15)*complexconjugate(ZER12) + complexconjugate(ZE16)*complexconjugate(ZER13)) + ZN23*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3135 = Coupling(name = 'GC_3135',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE11) + ZEL12*complexconjugate(ZE12) + ZEL13*complexconjugate(ZE13))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3136 = Coupling(name = 'GC_3136',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE24)*complexconjugate(ZER11) + complexconjugate(ZE25)*complexconjugate(ZER12) + complexconjugate(ZE26)*complexconjugate(ZER13)) + ZN23*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3137 = Coupling(name = 'GC_3137',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE21) + ZEL12*complexconjugate(ZE22) + ZEL13*complexconjugate(ZE23))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3138 = Coupling(name = 'GC_3138',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE34)*complexconjugate(ZER11) + complexconjugate(ZE35)*complexconjugate(ZER12) + complexconjugate(ZE36)*complexconjugate(ZER13)) + ZN23*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3139 = Coupling(name = 'GC_3139',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE31) + ZEL12*complexconjugate(ZE32) + ZEL13*complexconjugate(ZE33))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3140 = Coupling(name = 'GC_3140',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE44)*complexconjugate(ZER11) + complexconjugate(ZE45)*complexconjugate(ZER12) + complexconjugate(ZE46)*complexconjugate(ZER13)) + ZN23*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3141 = Coupling(name = 'GC_3141',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE41) + ZEL12*complexconjugate(ZE42) + ZEL13*complexconjugate(ZE43))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3142 = Coupling(name = 'GC_3142',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE54)*complexconjugate(ZER11) + complexconjugate(ZE55)*complexconjugate(ZER12) + complexconjugate(ZE56)*complexconjugate(ZER13)) + ZN23*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3143 = Coupling(name = 'GC_3143',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE51) + ZEL12*complexconjugate(ZE52) + ZEL13*complexconjugate(ZE53))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3144 = Coupling(name = 'GC_3144',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE64)*complexconjugate(ZER11) + complexconjugate(ZE65)*complexconjugate(ZER12) + complexconjugate(ZE66)*complexconjugate(ZER13)) + ZN23*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3145 = Coupling(name = 'GC_3145',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE61) + ZEL12*complexconjugate(ZE62) + ZEL13*complexconjugate(ZE63))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3146 = Coupling(name = 'GC_3146',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE14)*complexconjugate(ZER11) + complexconjugate(ZE15)*complexconjugate(ZER12) + complexconjugate(ZE16)*complexconjugate(ZER13)) + ZN33*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3147 = Coupling(name = 'GC_3147',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE11) + ZEL12*complexconjugate(ZE12) + ZEL13*complexconjugate(ZE13))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3148 = Coupling(name = 'GC_3148',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE24)*complexconjugate(ZER11) + complexconjugate(ZE25)*complexconjugate(ZER12) + complexconjugate(ZE26)*complexconjugate(ZER13)) + ZN33*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3149 = Coupling(name = 'GC_3149',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE21) + ZEL12*complexconjugate(ZE22) + ZEL13*complexconjugate(ZE23))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3150 = Coupling(name = 'GC_3150',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE34)*complexconjugate(ZER11) + complexconjugate(ZE35)*complexconjugate(ZER12) + complexconjugate(ZE36)*complexconjugate(ZER13)) + ZN33*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3151 = Coupling(name = 'GC_3151',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE31) + ZEL12*complexconjugate(ZE32) + ZEL13*complexconjugate(ZE33))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3152 = Coupling(name = 'GC_3152',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE44)*complexconjugate(ZER11) + complexconjugate(ZE45)*complexconjugate(ZER12) + complexconjugate(ZE46)*complexconjugate(ZER13)) + ZN33*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3153 = Coupling(name = 'GC_3153',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE41) + ZEL12*complexconjugate(ZE42) + ZEL13*complexconjugate(ZE43))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3154 = Coupling(name = 'GC_3154',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE54)*complexconjugate(ZER11) + complexconjugate(ZE55)*complexconjugate(ZER12) + complexconjugate(ZE56)*complexconjugate(ZER13)) + ZN33*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3155 = Coupling(name = 'GC_3155',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE51) + ZEL12*complexconjugate(ZE52) + ZEL13*complexconjugate(ZE53))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3156 = Coupling(name = 'GC_3156',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE64)*complexconjugate(ZER11) + complexconjugate(ZE65)*complexconjugate(ZER12) + complexconjugate(ZE66)*complexconjugate(ZER13)) + ZN33*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3157 = Coupling(name = 'GC_3157',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE61) + ZEL12*complexconjugate(ZE62) + ZEL13*complexconjugate(ZE63))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3158 = Coupling(name = 'GC_3158',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE14)*complexconjugate(ZER11) + complexconjugate(ZE15)*complexconjugate(ZER12) + complexconjugate(ZE16)*complexconjugate(ZER13)) + ZN43*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3159 = Coupling(name = 'GC_3159',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE11) + ZEL12*complexconjugate(ZE12) + ZEL13*complexconjugate(ZE13))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3160 = Coupling(name = 'GC_3160',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE24)*complexconjugate(ZER11) + complexconjugate(ZE25)*complexconjugate(ZER12) + complexconjugate(ZE26)*complexconjugate(ZER13)) + ZN43*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3161 = Coupling(name = 'GC_3161',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE21) + ZEL12*complexconjugate(ZE22) + ZEL13*complexconjugate(ZE23))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3162 = Coupling(name = 'GC_3162',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE34)*complexconjugate(ZER11) + complexconjugate(ZE35)*complexconjugate(ZER12) + complexconjugate(ZE36)*complexconjugate(ZER13)) + ZN43*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3163 = Coupling(name = 'GC_3163',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE31) + ZEL12*complexconjugate(ZE32) + ZEL13*complexconjugate(ZE33))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3164 = Coupling(name = 'GC_3164',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE44)*complexconjugate(ZER11) + complexconjugate(ZE45)*complexconjugate(ZER12) + complexconjugate(ZE46)*complexconjugate(ZER13)) + ZN43*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3165 = Coupling(name = 'GC_3165',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE41) + ZEL12*complexconjugate(ZE42) + ZEL13*complexconjugate(ZE43))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3166 = Coupling(name = 'GC_3166',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE54)*complexconjugate(ZER11) + complexconjugate(ZE55)*complexconjugate(ZER12) + complexconjugate(ZE56)*complexconjugate(ZER13)) + ZN43*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3167 = Coupling(name = 'GC_3167',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE51) + ZEL12*complexconjugate(ZE52) + ZEL13*complexconjugate(ZE53))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3168 = Coupling(name = 'GC_3168',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE64)*complexconjugate(ZER11) + complexconjugate(ZE65)*complexconjugate(ZER12) + complexconjugate(ZE66)*complexconjugate(ZER13)) + ZN43*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))', 
	 order = {'QED':1} ) 
 
GC_3169 = Coupling(name = 'GC_3169',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL11*complexconjugate(ZE61) + ZEL12*complexconjugate(ZE62) + ZEL13*complexconjugate(ZE63))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL11*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL12*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL13*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3170 = Coupling(name = 'GC_3170',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE14)*complexconjugate(ZER21) + complexconjugate(ZE15)*complexconjugate(ZER22) + complexconjugate(ZE16)*complexconjugate(ZER23)) + ZN13*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3171 = Coupling(name = 'GC_3171',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE11) + ZEL22*complexconjugate(ZE12) + ZEL23*complexconjugate(ZE13))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3172 = Coupling(name = 'GC_3172',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE24)*complexconjugate(ZER21) + complexconjugate(ZE25)*complexconjugate(ZER22) + complexconjugate(ZE26)*complexconjugate(ZER23)) + ZN13*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3173 = Coupling(name = 'GC_3173',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE21) + ZEL22*complexconjugate(ZE22) + ZEL23*complexconjugate(ZE23))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3174 = Coupling(name = 'GC_3174',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE34)*complexconjugate(ZER21) + complexconjugate(ZE35)*complexconjugate(ZER22) + complexconjugate(ZE36)*complexconjugate(ZER23)) + ZN13*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3175 = Coupling(name = 'GC_3175',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE31) + ZEL22*complexconjugate(ZE32) + ZEL23*complexconjugate(ZE33))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3176 = Coupling(name = 'GC_3176',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE44)*complexconjugate(ZER21) + complexconjugate(ZE45)*complexconjugate(ZER22) + complexconjugate(ZE46)*complexconjugate(ZER23)) + ZN13*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3177 = Coupling(name = 'GC_3177',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE41) + ZEL22*complexconjugate(ZE42) + ZEL23*complexconjugate(ZE43))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3178 = Coupling(name = 'GC_3178',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE54)*complexconjugate(ZER21) + complexconjugate(ZE55)*complexconjugate(ZER22) + complexconjugate(ZE56)*complexconjugate(ZER23)) + ZN13*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3179 = Coupling(name = 'GC_3179',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE51) + ZEL22*complexconjugate(ZE52) + ZEL23*complexconjugate(ZE53))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3180 = Coupling(name = 'GC_3180',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE64)*complexconjugate(ZER21) + complexconjugate(ZE65)*complexconjugate(ZER22) + complexconjugate(ZE66)*complexconjugate(ZER23)) + ZN13*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3181 = Coupling(name = 'GC_3181',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE61) + ZEL22*complexconjugate(ZE62) + ZEL23*complexconjugate(ZE63))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3182 = Coupling(name = 'GC_3182',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE14)*complexconjugate(ZER21) + complexconjugate(ZE15)*complexconjugate(ZER22) + complexconjugate(ZE16)*complexconjugate(ZER23)) + ZN23*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3183 = Coupling(name = 'GC_3183',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE11) + ZEL22*complexconjugate(ZE12) + ZEL23*complexconjugate(ZE13))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3184 = Coupling(name = 'GC_3184',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE24)*complexconjugate(ZER21) + complexconjugate(ZE25)*complexconjugate(ZER22) + complexconjugate(ZE26)*complexconjugate(ZER23)) + ZN23*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3185 = Coupling(name = 'GC_3185',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE21) + ZEL22*complexconjugate(ZE22) + ZEL23*complexconjugate(ZE23))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3186 = Coupling(name = 'GC_3186',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE34)*complexconjugate(ZER21) + complexconjugate(ZE35)*complexconjugate(ZER22) + complexconjugate(ZE36)*complexconjugate(ZER23)) + ZN23*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3187 = Coupling(name = 'GC_3187',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE31) + ZEL22*complexconjugate(ZE32) + ZEL23*complexconjugate(ZE33))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3188 = Coupling(name = 'GC_3188',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE44)*complexconjugate(ZER21) + complexconjugate(ZE45)*complexconjugate(ZER22) + complexconjugate(ZE46)*complexconjugate(ZER23)) + ZN23*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3189 = Coupling(name = 'GC_3189',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE41) + ZEL22*complexconjugate(ZE42) + ZEL23*complexconjugate(ZE43))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3190 = Coupling(name = 'GC_3190',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE54)*complexconjugate(ZER21) + complexconjugate(ZE55)*complexconjugate(ZER22) + complexconjugate(ZE56)*complexconjugate(ZER23)) + ZN23*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3191 = Coupling(name = 'GC_3191',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE51) + ZEL22*complexconjugate(ZE52) + ZEL23*complexconjugate(ZE53))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3192 = Coupling(name = 'GC_3192',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE64)*complexconjugate(ZER21) + complexconjugate(ZE65)*complexconjugate(ZER22) + complexconjugate(ZE66)*complexconjugate(ZER23)) + ZN23*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3193 = Coupling(name = 'GC_3193',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE61) + ZEL22*complexconjugate(ZE62) + ZEL23*complexconjugate(ZE63))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3194 = Coupling(name = 'GC_3194',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE14)*complexconjugate(ZER21) + complexconjugate(ZE15)*complexconjugate(ZER22) + complexconjugate(ZE16)*complexconjugate(ZER23)) + ZN33*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3195 = Coupling(name = 'GC_3195',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE11) + ZEL22*complexconjugate(ZE12) + ZEL23*complexconjugate(ZE13))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3196 = Coupling(name = 'GC_3196',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE24)*complexconjugate(ZER21) + complexconjugate(ZE25)*complexconjugate(ZER22) + complexconjugate(ZE26)*complexconjugate(ZER23)) + ZN33*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3197 = Coupling(name = 'GC_3197',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE21) + ZEL22*complexconjugate(ZE22) + ZEL23*complexconjugate(ZE23))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3198 = Coupling(name = 'GC_3198',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE34)*complexconjugate(ZER21) + complexconjugate(ZE35)*complexconjugate(ZER22) + complexconjugate(ZE36)*complexconjugate(ZER23)) + ZN33*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3199 = Coupling(name = 'GC_3199',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE31) + ZEL22*complexconjugate(ZE32) + ZEL23*complexconjugate(ZE33))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3200 = Coupling(name = 'GC_3200',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE44)*complexconjugate(ZER21) + complexconjugate(ZE45)*complexconjugate(ZER22) + complexconjugate(ZE46)*complexconjugate(ZER23)) + ZN33*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3201 = Coupling(name = 'GC_3201',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE41) + ZEL22*complexconjugate(ZE42) + ZEL23*complexconjugate(ZE43))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3202 = Coupling(name = 'GC_3202',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE54)*complexconjugate(ZER21) + complexconjugate(ZE55)*complexconjugate(ZER22) + complexconjugate(ZE56)*complexconjugate(ZER23)) + ZN33*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3203 = Coupling(name = 'GC_3203',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE51) + ZEL22*complexconjugate(ZE52) + ZEL23*complexconjugate(ZE53))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3204 = Coupling(name = 'GC_3204',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE64)*complexconjugate(ZER21) + complexconjugate(ZE65)*complexconjugate(ZER22) + complexconjugate(ZE66)*complexconjugate(ZER23)) + ZN33*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3205 = Coupling(name = 'GC_3205',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE61) + ZEL22*complexconjugate(ZE62) + ZEL23*complexconjugate(ZE63))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3206 = Coupling(name = 'GC_3206',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE14)*complexconjugate(ZER21) + complexconjugate(ZE15)*complexconjugate(ZER22) + complexconjugate(ZE16)*complexconjugate(ZER23)) + ZN43*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3207 = Coupling(name = 'GC_3207',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE11) + ZEL22*complexconjugate(ZE12) + ZEL23*complexconjugate(ZE13))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3208 = Coupling(name = 'GC_3208',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE24)*complexconjugate(ZER21) + complexconjugate(ZE25)*complexconjugate(ZER22) + complexconjugate(ZE26)*complexconjugate(ZER23)) + ZN43*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3209 = Coupling(name = 'GC_3209',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE21) + ZEL22*complexconjugate(ZE22) + ZEL23*complexconjugate(ZE23))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3210 = Coupling(name = 'GC_3210',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE34)*complexconjugate(ZER21) + complexconjugate(ZE35)*complexconjugate(ZER22) + complexconjugate(ZE36)*complexconjugate(ZER23)) + ZN43*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3211 = Coupling(name = 'GC_3211',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE31) + ZEL22*complexconjugate(ZE32) + ZEL23*complexconjugate(ZE33))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3212 = Coupling(name = 'GC_3212',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE44)*complexconjugate(ZER21) + complexconjugate(ZE45)*complexconjugate(ZER22) + complexconjugate(ZE46)*complexconjugate(ZER23)) + ZN43*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3213 = Coupling(name = 'GC_3213',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE41) + ZEL22*complexconjugate(ZE42) + ZEL23*complexconjugate(ZE43))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3214 = Coupling(name = 'GC_3214',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE54)*complexconjugate(ZER21) + complexconjugate(ZE55)*complexconjugate(ZER22) + complexconjugate(ZE56)*complexconjugate(ZER23)) + ZN43*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3215 = Coupling(name = 'GC_3215',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE51) + ZEL22*complexconjugate(ZE52) + ZEL23*complexconjugate(ZE53))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3216 = Coupling(name = 'GC_3216',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE64)*complexconjugate(ZER21) + complexconjugate(ZE65)*complexconjugate(ZER22) + complexconjugate(ZE66)*complexconjugate(ZER23)) + ZN43*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))', 
	 order = {'QED':1} ) 
 
GC_3217 = Coupling(name = 'GC_3217',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL21*complexconjugate(ZE61) + ZEL22*complexconjugate(ZE62) + ZEL23*complexconjugate(ZE63))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL21*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL22*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL23*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3218 = Coupling(name = 'GC_3218',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE14)*complexconjugate(ZER31) + complexconjugate(ZE15)*complexconjugate(ZER32) + complexconjugate(ZE16)*complexconjugate(ZER33)) + ZN13*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3219 = Coupling(name = 'GC_3219',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE11) + ZEL32*complexconjugate(ZE12) + ZEL33*complexconjugate(ZE13))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3220 = Coupling(name = 'GC_3220',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE24)*complexconjugate(ZER31) + complexconjugate(ZE25)*complexconjugate(ZER32) + complexconjugate(ZE26)*complexconjugate(ZER33)) + ZN13*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3221 = Coupling(name = 'GC_3221',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE21) + ZEL32*complexconjugate(ZE22) + ZEL33*complexconjugate(ZE23))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3222 = Coupling(name = 'GC_3222',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE34)*complexconjugate(ZER31) + complexconjugate(ZE35)*complexconjugate(ZER32) + complexconjugate(ZE36)*complexconjugate(ZER33)) + ZN13*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3223 = Coupling(name = 'GC_3223',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE31) + ZEL32*complexconjugate(ZE32) + ZEL33*complexconjugate(ZE33))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3224 = Coupling(name = 'GC_3224',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE44)*complexconjugate(ZER31) + complexconjugate(ZE45)*complexconjugate(ZER32) + complexconjugate(ZE46)*complexconjugate(ZER33)) + ZN13*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3225 = Coupling(name = 'GC_3225',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE41) + ZEL32*complexconjugate(ZE42) + ZEL33*complexconjugate(ZE43))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3226 = Coupling(name = 'GC_3226',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE54)*complexconjugate(ZER31) + complexconjugate(ZE55)*complexconjugate(ZER32) + complexconjugate(ZE56)*complexconjugate(ZER33)) + ZN13*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3227 = Coupling(name = 'GC_3227',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE51) + ZEL32*complexconjugate(ZE52) + ZEL33*complexconjugate(ZE53))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3228 = Coupling(name = 'GC_3228',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZE64)*complexconjugate(ZER31) + complexconjugate(ZE65)*complexconjugate(ZER32) + complexconjugate(ZE66)*complexconjugate(ZER33)) + ZN13*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3229 = Coupling(name = 'GC_3229',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE61) + ZEL32*complexconjugate(ZE62) + ZEL33*complexconjugate(ZE63))*(g1*complexconjugate(ZN11) + g2*complexconjugate(ZN12)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_3230 = Coupling(name = 'GC_3230',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE14)*complexconjugate(ZER31) + complexconjugate(ZE15)*complexconjugate(ZER32) + complexconjugate(ZE16)*complexconjugate(ZER33)) + ZN23*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3231 = Coupling(name = 'GC_3231',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE11) + ZEL32*complexconjugate(ZE12) + ZEL33*complexconjugate(ZE13))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3232 = Coupling(name = 'GC_3232',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE24)*complexconjugate(ZER31) + complexconjugate(ZE25)*complexconjugate(ZER32) + complexconjugate(ZE26)*complexconjugate(ZER33)) + ZN23*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3233 = Coupling(name = 'GC_3233',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE21) + ZEL32*complexconjugate(ZE22) + ZEL33*complexconjugate(ZE23))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3234 = Coupling(name = 'GC_3234',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE34)*complexconjugate(ZER31) + complexconjugate(ZE35)*complexconjugate(ZER32) + complexconjugate(ZE36)*complexconjugate(ZER33)) + ZN23*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3235 = Coupling(name = 'GC_3235',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE31) + ZEL32*complexconjugate(ZE32) + ZEL33*complexconjugate(ZE33))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3236 = Coupling(name = 'GC_3236',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE44)*complexconjugate(ZER31) + complexconjugate(ZE45)*complexconjugate(ZER32) + complexconjugate(ZE46)*complexconjugate(ZER33)) + ZN23*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3237 = Coupling(name = 'GC_3237',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE41) + ZEL32*complexconjugate(ZE42) + ZEL33*complexconjugate(ZE43))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3238 = Coupling(name = 'GC_3238',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE54)*complexconjugate(ZER31) + complexconjugate(ZE55)*complexconjugate(ZER32) + complexconjugate(ZE56)*complexconjugate(ZER33)) + ZN23*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3239 = Coupling(name = 'GC_3239',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE51) + ZEL32*complexconjugate(ZE52) + ZEL33*complexconjugate(ZE53))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3240 = Coupling(name = 'GC_3240',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZE64)*complexconjugate(ZER31) + complexconjugate(ZE65)*complexconjugate(ZER32) + complexconjugate(ZE66)*complexconjugate(ZER33)) + ZN23*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3241 = Coupling(name = 'GC_3241',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE61) + ZEL32*complexconjugate(ZE62) + ZEL33*complexconjugate(ZE63))*(g1*complexconjugate(ZN21) + g2*complexconjugate(ZN22)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_3242 = Coupling(name = 'GC_3242',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE14)*complexconjugate(ZER31) + complexconjugate(ZE15)*complexconjugate(ZER32) + complexconjugate(ZE16)*complexconjugate(ZER33)) + ZN33*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3243 = Coupling(name = 'GC_3243',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE11) + ZEL32*complexconjugate(ZE12) + ZEL33*complexconjugate(ZE13))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3244 = Coupling(name = 'GC_3244',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE24)*complexconjugate(ZER31) + complexconjugate(ZE25)*complexconjugate(ZER32) + complexconjugate(ZE26)*complexconjugate(ZER33)) + ZN33*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3245 = Coupling(name = 'GC_3245',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE21) + ZEL32*complexconjugate(ZE22) + ZEL33*complexconjugate(ZE23))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3246 = Coupling(name = 'GC_3246',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE34)*complexconjugate(ZER31) + complexconjugate(ZE35)*complexconjugate(ZER32) + complexconjugate(ZE36)*complexconjugate(ZER33)) + ZN33*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3247 = Coupling(name = 'GC_3247',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE31) + ZEL32*complexconjugate(ZE32) + ZEL33*complexconjugate(ZE33))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3248 = Coupling(name = 'GC_3248',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE44)*complexconjugate(ZER31) + complexconjugate(ZE45)*complexconjugate(ZER32) + complexconjugate(ZE46)*complexconjugate(ZER33)) + ZN33*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3249 = Coupling(name = 'GC_3249',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE41) + ZEL32*complexconjugate(ZE42) + ZEL33*complexconjugate(ZE43))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3250 = Coupling(name = 'GC_3250',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE54)*complexconjugate(ZER31) + complexconjugate(ZE55)*complexconjugate(ZER32) + complexconjugate(ZE56)*complexconjugate(ZER33)) + ZN33*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3251 = Coupling(name = 'GC_3251',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE51) + ZEL32*complexconjugate(ZE52) + ZEL33*complexconjugate(ZE53))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3252 = Coupling(name = 'GC_3252',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZE64)*complexconjugate(ZER31) + complexconjugate(ZE65)*complexconjugate(ZER32) + complexconjugate(ZE66)*complexconjugate(ZER33)) + ZN33*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3253 = Coupling(name = 'GC_3253',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE61) + ZEL32*complexconjugate(ZE62) + ZEL33*complexconjugate(ZE63))*(g1*complexconjugate(ZN31) + g2*complexconjugate(ZN32)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_3254 = Coupling(name = 'GC_3254',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE14)*complexconjugate(ZER31) + complexconjugate(ZE15)*complexconjugate(ZER32) + complexconjugate(ZE16)*complexconjugate(ZER33)) + ZN43*(complexconjugate(ZE11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3255 = Coupling(name = 'GC_3255',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE11) + ZEL32*complexconjugate(ZE12) + ZEL33*complexconjugate(ZE13))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3256 = Coupling(name = 'GC_3256',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE24)*complexconjugate(ZER31) + complexconjugate(ZE25)*complexconjugate(ZER32) + complexconjugate(ZE26)*complexconjugate(ZER33)) + ZN43*(complexconjugate(ZE21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3257 = Coupling(name = 'GC_3257',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE21) + ZEL32*complexconjugate(ZE22) + ZEL33*complexconjugate(ZE23))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3258 = Coupling(name = 'GC_3258',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE34)*complexconjugate(ZER31) + complexconjugate(ZE35)*complexconjugate(ZER32) + complexconjugate(ZE36)*complexconjugate(ZER33)) + ZN43*(complexconjugate(ZE31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3259 = Coupling(name = 'GC_3259',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE31) + ZEL32*complexconjugate(ZE32) + ZEL33*complexconjugate(ZE33))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3260 = Coupling(name = 'GC_3260',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE44)*complexconjugate(ZER31) + complexconjugate(ZE45)*complexconjugate(ZER32) + complexconjugate(ZE46)*complexconjugate(ZER33)) + ZN43*(complexconjugate(ZE41)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE42)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE43)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3261 = Coupling(name = 'GC_3261',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE41) + ZEL32*complexconjugate(ZE42) + ZEL33*complexconjugate(ZE43))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3262 = Coupling(name = 'GC_3262',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE54)*complexconjugate(ZER31) + complexconjugate(ZE55)*complexconjugate(ZER32) + complexconjugate(ZE56)*complexconjugate(ZER33)) + ZN43*(complexconjugate(ZE51)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE52)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE53)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3263 = Coupling(name = 'GC_3263',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE51) + ZEL32*complexconjugate(ZE52) + ZEL33*complexconjugate(ZE53))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3264 = Coupling(name = 'GC_3264',
	 value = '-1*complex(0,1)*(cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZE64)*complexconjugate(ZER31) + complexconjugate(ZE65)*complexconjugate(ZER32) + complexconjugate(ZE66)*complexconjugate(ZER33)) + ZN43*(complexconjugate(ZE61)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZE62)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZE63)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))', 
	 order = {'QED':1} ) 
 
GC_3265 = Coupling(name = 'GC_3265',
	 value = '1./2.*complex(0,1)*(cmath.sqrt(2)*(ZEL31*complexconjugate(ZE61) + ZEL32*complexconjugate(ZE62) + ZEL33*complexconjugate(ZE63))*(g1*complexconjugate(ZN41) + g2*complexconjugate(ZN42)) - 2*(ZEL31*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)) + ZEL32*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)) + ZEL33*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_3266 = Coupling(name = 'GC_3266',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU14)*complexconjugate(ZUR11) + complexconjugate(ZU15)*complexconjugate(ZUR12) + complexconjugate(ZU16)*complexconjugate(ZUR13)) - 3*ZN14*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3267 = Coupling(name = 'GC_3267',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL11*complexconjugate(ZU11) + ZUL12*complexconjugate(ZU12) + ZUL13*complexconjugate(ZU13)) + 6*complexconjugate(ZN14)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3268 = Coupling(name = 'GC_3268',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU24)*complexconjugate(ZUR11) + complexconjugate(ZU25)*complexconjugate(ZUR12) + complexconjugate(ZU26)*complexconjugate(ZUR13)) - 3*ZN14*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3269 = Coupling(name = 'GC_3269',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL11*complexconjugate(ZU21) + ZUL12*complexconjugate(ZU22) + ZUL13*complexconjugate(ZU23)) + 6*complexconjugate(ZN14)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3270 = Coupling(name = 'GC_3270',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU34)*complexconjugate(ZUR11) + complexconjugate(ZU35)*complexconjugate(ZUR12) + complexconjugate(ZU36)*complexconjugate(ZUR13)) - 3*ZN14*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3271 = Coupling(name = 'GC_3271',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL11*complexconjugate(ZU31) + ZUL12*complexconjugate(ZU32) + ZUL13*complexconjugate(ZU33)) + 6*complexconjugate(ZN14)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3272 = Coupling(name = 'GC_3272',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU44)*complexconjugate(ZUR11) + complexconjugate(ZU45)*complexconjugate(ZUR12) + complexconjugate(ZU46)*complexconjugate(ZUR13)) - 3*ZN14*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3273 = Coupling(name = 'GC_3273',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL11*complexconjugate(ZU41) + ZUL12*complexconjugate(ZU42) + ZUL13*complexconjugate(ZU43)) + 6*complexconjugate(ZN14)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3274 = Coupling(name = 'GC_3274',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU54)*complexconjugate(ZUR11) + complexconjugate(ZU55)*complexconjugate(ZUR12) + complexconjugate(ZU56)*complexconjugate(ZUR13)) - 3*ZN14*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3275 = Coupling(name = 'GC_3275',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL11*complexconjugate(ZU51) + ZUL12*complexconjugate(ZU52) + ZUL13*complexconjugate(ZU53)) + 6*complexconjugate(ZN14)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3276 = Coupling(name = 'GC_3276',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU64)*complexconjugate(ZUR11) + complexconjugate(ZU65)*complexconjugate(ZUR12) + complexconjugate(ZU66)*complexconjugate(ZUR13)) - 3*ZN14*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3277 = Coupling(name = 'GC_3277',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL11*complexconjugate(ZU61) + ZUL12*complexconjugate(ZU62) + ZUL13*complexconjugate(ZU63)) + 6*complexconjugate(ZN14)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3278 = Coupling(name = 'GC_3278',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU14)*complexconjugate(ZUR11) + complexconjugate(ZU15)*complexconjugate(ZUR12) + complexconjugate(ZU16)*complexconjugate(ZUR13)) - 3*ZN24*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3279 = Coupling(name = 'GC_3279',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL11*complexconjugate(ZU11) + ZUL12*complexconjugate(ZU12) + ZUL13*complexconjugate(ZU13)) + 6*complexconjugate(ZN24)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3280 = Coupling(name = 'GC_3280',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU24)*complexconjugate(ZUR11) + complexconjugate(ZU25)*complexconjugate(ZUR12) + complexconjugate(ZU26)*complexconjugate(ZUR13)) - 3*ZN24*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3281 = Coupling(name = 'GC_3281',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL11*complexconjugate(ZU21) + ZUL12*complexconjugate(ZU22) + ZUL13*complexconjugate(ZU23)) + 6*complexconjugate(ZN24)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3282 = Coupling(name = 'GC_3282',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU34)*complexconjugate(ZUR11) + complexconjugate(ZU35)*complexconjugate(ZUR12) + complexconjugate(ZU36)*complexconjugate(ZUR13)) - 3*ZN24*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3283 = Coupling(name = 'GC_3283',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL11*complexconjugate(ZU31) + ZUL12*complexconjugate(ZU32) + ZUL13*complexconjugate(ZU33)) + 6*complexconjugate(ZN24)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3284 = Coupling(name = 'GC_3284',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU44)*complexconjugate(ZUR11) + complexconjugate(ZU45)*complexconjugate(ZUR12) + complexconjugate(ZU46)*complexconjugate(ZUR13)) - 3*ZN24*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3285 = Coupling(name = 'GC_3285',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL11*complexconjugate(ZU41) + ZUL12*complexconjugate(ZU42) + ZUL13*complexconjugate(ZU43)) + 6*complexconjugate(ZN24)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3286 = Coupling(name = 'GC_3286',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU54)*complexconjugate(ZUR11) + complexconjugate(ZU55)*complexconjugate(ZUR12) + complexconjugate(ZU56)*complexconjugate(ZUR13)) - 3*ZN24*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3287 = Coupling(name = 'GC_3287',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL11*complexconjugate(ZU51) + ZUL12*complexconjugate(ZU52) + ZUL13*complexconjugate(ZU53)) + 6*complexconjugate(ZN24)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3288 = Coupling(name = 'GC_3288',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU64)*complexconjugate(ZUR11) + complexconjugate(ZU65)*complexconjugate(ZUR12) + complexconjugate(ZU66)*complexconjugate(ZUR13)) - 3*ZN24*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3289 = Coupling(name = 'GC_3289',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL11*complexconjugate(ZU61) + ZUL12*complexconjugate(ZU62) + ZUL13*complexconjugate(ZU63)) + 6*complexconjugate(ZN24)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3290 = Coupling(name = 'GC_3290',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU14)*complexconjugate(ZUR11) + complexconjugate(ZU15)*complexconjugate(ZUR12) + complexconjugate(ZU16)*complexconjugate(ZUR13)) - 3*ZN34*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3291 = Coupling(name = 'GC_3291',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL11*complexconjugate(ZU11) + ZUL12*complexconjugate(ZU12) + ZUL13*complexconjugate(ZU13)) + 6*complexconjugate(ZN34)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3292 = Coupling(name = 'GC_3292',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU24)*complexconjugate(ZUR11) + complexconjugate(ZU25)*complexconjugate(ZUR12) + complexconjugate(ZU26)*complexconjugate(ZUR13)) - 3*ZN34*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3293 = Coupling(name = 'GC_3293',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL11*complexconjugate(ZU21) + ZUL12*complexconjugate(ZU22) + ZUL13*complexconjugate(ZU23)) + 6*complexconjugate(ZN34)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3294 = Coupling(name = 'GC_3294',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU34)*complexconjugate(ZUR11) + complexconjugate(ZU35)*complexconjugate(ZUR12) + complexconjugate(ZU36)*complexconjugate(ZUR13)) - 3*ZN34*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3295 = Coupling(name = 'GC_3295',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL11*complexconjugate(ZU31) + ZUL12*complexconjugate(ZU32) + ZUL13*complexconjugate(ZU33)) + 6*complexconjugate(ZN34)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3296 = Coupling(name = 'GC_3296',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU44)*complexconjugate(ZUR11) + complexconjugate(ZU45)*complexconjugate(ZUR12) + complexconjugate(ZU46)*complexconjugate(ZUR13)) - 3*ZN34*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3297 = Coupling(name = 'GC_3297',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL11*complexconjugate(ZU41) + ZUL12*complexconjugate(ZU42) + ZUL13*complexconjugate(ZU43)) + 6*complexconjugate(ZN34)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3298 = Coupling(name = 'GC_3298',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU54)*complexconjugate(ZUR11) + complexconjugate(ZU55)*complexconjugate(ZUR12) + complexconjugate(ZU56)*complexconjugate(ZUR13)) - 3*ZN34*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3299 = Coupling(name = 'GC_3299',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL11*complexconjugate(ZU51) + ZUL12*complexconjugate(ZU52) + ZUL13*complexconjugate(ZU53)) + 6*complexconjugate(ZN34)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3300 = Coupling(name = 'GC_3300',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU64)*complexconjugate(ZUR11) + complexconjugate(ZU65)*complexconjugate(ZUR12) + complexconjugate(ZU66)*complexconjugate(ZUR13)) - 3*ZN34*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3301 = Coupling(name = 'GC_3301',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL11*complexconjugate(ZU61) + ZUL12*complexconjugate(ZU62) + ZUL13*complexconjugate(ZU63)) + 6*complexconjugate(ZN34)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3302 = Coupling(name = 'GC_3302',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU14)*complexconjugate(ZUR11) + complexconjugate(ZU15)*complexconjugate(ZUR12) + complexconjugate(ZU16)*complexconjugate(ZUR13)) - 3*ZN44*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3303 = Coupling(name = 'GC_3303',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL11*complexconjugate(ZU11) + ZUL12*complexconjugate(ZU12) + ZUL13*complexconjugate(ZU13)) + 6*complexconjugate(ZN44)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3304 = Coupling(name = 'GC_3304',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU24)*complexconjugate(ZUR11) + complexconjugate(ZU25)*complexconjugate(ZUR12) + complexconjugate(ZU26)*complexconjugate(ZUR13)) - 3*ZN44*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3305 = Coupling(name = 'GC_3305',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL11*complexconjugate(ZU21) + ZUL12*complexconjugate(ZU22) + ZUL13*complexconjugate(ZU23)) + 6*complexconjugate(ZN44)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3306 = Coupling(name = 'GC_3306',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU34)*complexconjugate(ZUR11) + complexconjugate(ZU35)*complexconjugate(ZUR12) + complexconjugate(ZU36)*complexconjugate(ZUR13)) - 3*ZN44*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3307 = Coupling(name = 'GC_3307',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL11*complexconjugate(ZU31) + ZUL12*complexconjugate(ZU32) + ZUL13*complexconjugate(ZU33)) + 6*complexconjugate(ZN44)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3308 = Coupling(name = 'GC_3308',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU44)*complexconjugate(ZUR11) + complexconjugate(ZU45)*complexconjugate(ZUR12) + complexconjugate(ZU46)*complexconjugate(ZUR13)) - 3*ZN44*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3309 = Coupling(name = 'GC_3309',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL11*complexconjugate(ZU41) + ZUL12*complexconjugate(ZU42) + ZUL13*complexconjugate(ZU43)) + 6*complexconjugate(ZN44)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3310 = Coupling(name = 'GC_3310',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU54)*complexconjugate(ZUR11) + complexconjugate(ZU55)*complexconjugate(ZUR12) + complexconjugate(ZU56)*complexconjugate(ZUR13)) - 3*ZN44*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3311 = Coupling(name = 'GC_3311',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL11*complexconjugate(ZU51) + ZUL12*complexconjugate(ZU52) + ZUL13*complexconjugate(ZU53)) + 6*complexconjugate(ZN44)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3312 = Coupling(name = 'GC_3312',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU64)*complexconjugate(ZUR11) + complexconjugate(ZU65)*complexconjugate(ZUR12) + complexconjugate(ZU66)*complexconjugate(ZUR13)) - 3*ZN44*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))', 
	 order = {'QED':1} ) 
 
GC_3313 = Coupling(name = 'GC_3313',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL11*complexconjugate(ZU61) + ZUL12*complexconjugate(ZU62) + ZUL13*complexconjugate(ZU63)) + 6*complexconjugate(ZN44)*(ZUL11*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL12*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL13*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3314 = Coupling(name = 'GC_3314',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU14)*complexconjugate(ZUR21) + complexconjugate(ZU15)*complexconjugate(ZUR22) + complexconjugate(ZU16)*complexconjugate(ZUR23)) - 3*ZN14*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3315 = Coupling(name = 'GC_3315',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL21*complexconjugate(ZU11) + ZUL22*complexconjugate(ZU12) + ZUL23*complexconjugate(ZU13)) + 6*complexconjugate(ZN14)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3316 = Coupling(name = 'GC_3316',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU24)*complexconjugate(ZUR21) + complexconjugate(ZU25)*complexconjugate(ZUR22) + complexconjugate(ZU26)*complexconjugate(ZUR23)) - 3*ZN14*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3317 = Coupling(name = 'GC_3317',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL21*complexconjugate(ZU21) + ZUL22*complexconjugate(ZU22) + ZUL23*complexconjugate(ZU23)) + 6*complexconjugate(ZN14)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3318 = Coupling(name = 'GC_3318',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU34)*complexconjugate(ZUR21) + complexconjugate(ZU35)*complexconjugate(ZUR22) + complexconjugate(ZU36)*complexconjugate(ZUR23)) - 3*ZN14*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3319 = Coupling(name = 'GC_3319',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL21*complexconjugate(ZU31) + ZUL22*complexconjugate(ZU32) + ZUL23*complexconjugate(ZU33)) + 6*complexconjugate(ZN14)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3320 = Coupling(name = 'GC_3320',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU44)*complexconjugate(ZUR21) + complexconjugate(ZU45)*complexconjugate(ZUR22) + complexconjugate(ZU46)*complexconjugate(ZUR23)) - 3*ZN14*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3321 = Coupling(name = 'GC_3321',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL21*complexconjugate(ZU41) + ZUL22*complexconjugate(ZU42) + ZUL23*complexconjugate(ZU43)) + 6*complexconjugate(ZN14)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3322 = Coupling(name = 'GC_3322',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU54)*complexconjugate(ZUR21) + complexconjugate(ZU55)*complexconjugate(ZUR22) + complexconjugate(ZU56)*complexconjugate(ZUR23)) - 3*ZN14*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3323 = Coupling(name = 'GC_3323',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL21*complexconjugate(ZU51) + ZUL22*complexconjugate(ZU52) + ZUL23*complexconjugate(ZU53)) + 6*complexconjugate(ZN14)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3324 = Coupling(name = 'GC_3324',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU64)*complexconjugate(ZUR21) + complexconjugate(ZU65)*complexconjugate(ZUR22) + complexconjugate(ZU66)*complexconjugate(ZUR23)) - 3*ZN14*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3325 = Coupling(name = 'GC_3325',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL21*complexconjugate(ZU61) + ZUL22*complexconjugate(ZU62) + ZUL23*complexconjugate(ZU63)) + 6*complexconjugate(ZN14)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3326 = Coupling(name = 'GC_3326',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU14)*complexconjugate(ZUR21) + complexconjugate(ZU15)*complexconjugate(ZUR22) + complexconjugate(ZU16)*complexconjugate(ZUR23)) - 3*ZN24*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3327 = Coupling(name = 'GC_3327',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL21*complexconjugate(ZU11) + ZUL22*complexconjugate(ZU12) + ZUL23*complexconjugate(ZU13)) + 6*complexconjugate(ZN24)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3328 = Coupling(name = 'GC_3328',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU24)*complexconjugate(ZUR21) + complexconjugate(ZU25)*complexconjugate(ZUR22) + complexconjugate(ZU26)*complexconjugate(ZUR23)) - 3*ZN24*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3329 = Coupling(name = 'GC_3329',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL21*complexconjugate(ZU21) + ZUL22*complexconjugate(ZU22) + ZUL23*complexconjugate(ZU23)) + 6*complexconjugate(ZN24)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3330 = Coupling(name = 'GC_3330',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU34)*complexconjugate(ZUR21) + complexconjugate(ZU35)*complexconjugate(ZUR22) + complexconjugate(ZU36)*complexconjugate(ZUR23)) - 3*ZN24*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3331 = Coupling(name = 'GC_3331',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL21*complexconjugate(ZU31) + ZUL22*complexconjugate(ZU32) + ZUL23*complexconjugate(ZU33)) + 6*complexconjugate(ZN24)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3332 = Coupling(name = 'GC_3332',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU44)*complexconjugate(ZUR21) + complexconjugate(ZU45)*complexconjugate(ZUR22) + complexconjugate(ZU46)*complexconjugate(ZUR23)) - 3*ZN24*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3333 = Coupling(name = 'GC_3333',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL21*complexconjugate(ZU41) + ZUL22*complexconjugate(ZU42) + ZUL23*complexconjugate(ZU43)) + 6*complexconjugate(ZN24)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3334 = Coupling(name = 'GC_3334',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU54)*complexconjugate(ZUR21) + complexconjugate(ZU55)*complexconjugate(ZUR22) + complexconjugate(ZU56)*complexconjugate(ZUR23)) - 3*ZN24*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3335 = Coupling(name = 'GC_3335',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL21*complexconjugate(ZU51) + ZUL22*complexconjugate(ZU52) + ZUL23*complexconjugate(ZU53)) + 6*complexconjugate(ZN24)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3336 = Coupling(name = 'GC_3336',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU64)*complexconjugate(ZUR21) + complexconjugate(ZU65)*complexconjugate(ZUR22) + complexconjugate(ZU66)*complexconjugate(ZUR23)) - 3*ZN24*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3337 = Coupling(name = 'GC_3337',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL21*complexconjugate(ZU61) + ZUL22*complexconjugate(ZU62) + ZUL23*complexconjugate(ZU63)) + 6*complexconjugate(ZN24)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3338 = Coupling(name = 'GC_3338',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU14)*complexconjugate(ZUR21) + complexconjugate(ZU15)*complexconjugate(ZUR22) + complexconjugate(ZU16)*complexconjugate(ZUR23)) - 3*ZN34*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3339 = Coupling(name = 'GC_3339',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL21*complexconjugate(ZU11) + ZUL22*complexconjugate(ZU12) + ZUL23*complexconjugate(ZU13)) + 6*complexconjugate(ZN34)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3340 = Coupling(name = 'GC_3340',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU24)*complexconjugate(ZUR21) + complexconjugate(ZU25)*complexconjugate(ZUR22) + complexconjugate(ZU26)*complexconjugate(ZUR23)) - 3*ZN34*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3341 = Coupling(name = 'GC_3341',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL21*complexconjugate(ZU21) + ZUL22*complexconjugate(ZU22) + ZUL23*complexconjugate(ZU23)) + 6*complexconjugate(ZN34)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3342 = Coupling(name = 'GC_3342',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU34)*complexconjugate(ZUR21) + complexconjugate(ZU35)*complexconjugate(ZUR22) + complexconjugate(ZU36)*complexconjugate(ZUR23)) - 3*ZN34*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3343 = Coupling(name = 'GC_3343',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL21*complexconjugate(ZU31) + ZUL22*complexconjugate(ZU32) + ZUL23*complexconjugate(ZU33)) + 6*complexconjugate(ZN34)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3344 = Coupling(name = 'GC_3344',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU44)*complexconjugate(ZUR21) + complexconjugate(ZU45)*complexconjugate(ZUR22) + complexconjugate(ZU46)*complexconjugate(ZUR23)) - 3*ZN34*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3345 = Coupling(name = 'GC_3345',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL21*complexconjugate(ZU41) + ZUL22*complexconjugate(ZU42) + ZUL23*complexconjugate(ZU43)) + 6*complexconjugate(ZN34)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3346 = Coupling(name = 'GC_3346',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU54)*complexconjugate(ZUR21) + complexconjugate(ZU55)*complexconjugate(ZUR22) + complexconjugate(ZU56)*complexconjugate(ZUR23)) - 3*ZN34*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3347 = Coupling(name = 'GC_3347',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL21*complexconjugate(ZU51) + ZUL22*complexconjugate(ZU52) + ZUL23*complexconjugate(ZU53)) + 6*complexconjugate(ZN34)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3348 = Coupling(name = 'GC_3348',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU64)*complexconjugate(ZUR21) + complexconjugate(ZU65)*complexconjugate(ZUR22) + complexconjugate(ZU66)*complexconjugate(ZUR23)) - 3*ZN34*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3349 = Coupling(name = 'GC_3349',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL21*complexconjugate(ZU61) + ZUL22*complexconjugate(ZU62) + ZUL23*complexconjugate(ZU63)) + 6*complexconjugate(ZN34)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3350 = Coupling(name = 'GC_3350',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU14)*complexconjugate(ZUR21) + complexconjugate(ZU15)*complexconjugate(ZUR22) + complexconjugate(ZU16)*complexconjugate(ZUR23)) - 3*ZN44*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3351 = Coupling(name = 'GC_3351',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL21*complexconjugate(ZU11) + ZUL22*complexconjugate(ZU12) + ZUL23*complexconjugate(ZU13)) + 6*complexconjugate(ZN44)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3352 = Coupling(name = 'GC_3352',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU24)*complexconjugate(ZUR21) + complexconjugate(ZU25)*complexconjugate(ZUR22) + complexconjugate(ZU26)*complexconjugate(ZUR23)) - 3*ZN44*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3353 = Coupling(name = 'GC_3353',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL21*complexconjugate(ZU21) + ZUL22*complexconjugate(ZU22) + ZUL23*complexconjugate(ZU23)) + 6*complexconjugate(ZN44)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3354 = Coupling(name = 'GC_3354',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU34)*complexconjugate(ZUR21) + complexconjugate(ZU35)*complexconjugate(ZUR22) + complexconjugate(ZU36)*complexconjugate(ZUR23)) - 3*ZN44*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3355 = Coupling(name = 'GC_3355',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL21*complexconjugate(ZU31) + ZUL22*complexconjugate(ZU32) + ZUL23*complexconjugate(ZU33)) + 6*complexconjugate(ZN44)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3356 = Coupling(name = 'GC_3356',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU44)*complexconjugate(ZUR21) + complexconjugate(ZU45)*complexconjugate(ZUR22) + complexconjugate(ZU46)*complexconjugate(ZUR23)) - 3*ZN44*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3357 = Coupling(name = 'GC_3357',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL21*complexconjugate(ZU41) + ZUL22*complexconjugate(ZU42) + ZUL23*complexconjugate(ZU43)) + 6*complexconjugate(ZN44)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3358 = Coupling(name = 'GC_3358',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU54)*complexconjugate(ZUR21) + complexconjugate(ZU55)*complexconjugate(ZUR22) + complexconjugate(ZU56)*complexconjugate(ZUR23)) - 3*ZN44*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3359 = Coupling(name = 'GC_3359',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL21*complexconjugate(ZU51) + ZUL22*complexconjugate(ZU52) + ZUL23*complexconjugate(ZU53)) + 6*complexconjugate(ZN44)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3360 = Coupling(name = 'GC_3360',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU64)*complexconjugate(ZUR21) + complexconjugate(ZU65)*complexconjugate(ZUR22) + complexconjugate(ZU66)*complexconjugate(ZUR23)) - 3*ZN44*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))', 
	 order = {'QED':1} ) 
 
GC_3361 = Coupling(name = 'GC_3361',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL21*complexconjugate(ZU61) + ZUL22*complexconjugate(ZU62) + ZUL23*complexconjugate(ZU63)) + 6*complexconjugate(ZN44)*(ZUL21*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL22*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL23*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3362 = Coupling(name = 'GC_3362',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU14)*complexconjugate(ZUR31) + complexconjugate(ZU15)*complexconjugate(ZUR32) + complexconjugate(ZU16)*complexconjugate(ZUR33)) - 3*ZN14*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3363 = Coupling(name = 'GC_3363',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL31*complexconjugate(ZU11) + ZUL32*complexconjugate(ZU12) + ZUL33*complexconjugate(ZU13)) + 6*complexconjugate(ZN14)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3364 = Coupling(name = 'GC_3364',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU24)*complexconjugate(ZUR31) + complexconjugate(ZU25)*complexconjugate(ZUR32) + complexconjugate(ZU26)*complexconjugate(ZUR33)) - 3*ZN14*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3365 = Coupling(name = 'GC_3365',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL31*complexconjugate(ZU21) + ZUL32*complexconjugate(ZU22) + ZUL33*complexconjugate(ZU23)) + 6*complexconjugate(ZN14)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3366 = Coupling(name = 'GC_3366',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU34)*complexconjugate(ZUR31) + complexconjugate(ZU35)*complexconjugate(ZUR32) + complexconjugate(ZU36)*complexconjugate(ZUR33)) - 3*ZN14*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3367 = Coupling(name = 'GC_3367',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL31*complexconjugate(ZU31) + ZUL32*complexconjugate(ZU32) + ZUL33*complexconjugate(ZU33)) + 6*complexconjugate(ZN14)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3368 = Coupling(name = 'GC_3368',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU44)*complexconjugate(ZUR31) + complexconjugate(ZU45)*complexconjugate(ZUR32) + complexconjugate(ZU46)*complexconjugate(ZUR33)) - 3*ZN14*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3369 = Coupling(name = 'GC_3369',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL31*complexconjugate(ZU41) + ZUL32*complexconjugate(ZU42) + ZUL33*complexconjugate(ZU43)) + 6*complexconjugate(ZN14)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3370 = Coupling(name = 'GC_3370',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU54)*complexconjugate(ZUR31) + complexconjugate(ZU55)*complexconjugate(ZUR32) + complexconjugate(ZU56)*complexconjugate(ZUR33)) - 3*ZN14*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3371 = Coupling(name = 'GC_3371',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL31*complexconjugate(ZU51) + ZUL32*complexconjugate(ZU52) + ZUL33*complexconjugate(ZU53)) + 6*complexconjugate(ZN14)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3372 = Coupling(name = 'GC_3372',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN11*(complexconjugate(ZU64)*complexconjugate(ZUR31) + complexconjugate(ZU65)*complexconjugate(ZUR32) + complexconjugate(ZU66)*complexconjugate(ZUR33)) - 3*ZN14*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3373 = Coupling(name = 'GC_3373',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN11) + 3*g2*complexconjugate(ZN12))*(ZUL31*complexconjugate(ZU61) + ZUL32*complexconjugate(ZU62) + ZUL33*complexconjugate(ZU63)) + 6*complexconjugate(ZN14)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3374 = Coupling(name = 'GC_3374',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU14)*complexconjugate(ZUR31) + complexconjugate(ZU15)*complexconjugate(ZUR32) + complexconjugate(ZU16)*complexconjugate(ZUR33)) - 3*ZN24*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3375 = Coupling(name = 'GC_3375',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL31*complexconjugate(ZU11) + ZUL32*complexconjugate(ZU12) + ZUL33*complexconjugate(ZU13)) + 6*complexconjugate(ZN24)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3376 = Coupling(name = 'GC_3376',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU24)*complexconjugate(ZUR31) + complexconjugate(ZU25)*complexconjugate(ZUR32) + complexconjugate(ZU26)*complexconjugate(ZUR33)) - 3*ZN24*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3377 = Coupling(name = 'GC_3377',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL31*complexconjugate(ZU21) + ZUL32*complexconjugate(ZU22) + ZUL33*complexconjugate(ZU23)) + 6*complexconjugate(ZN24)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3378 = Coupling(name = 'GC_3378',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU34)*complexconjugate(ZUR31) + complexconjugate(ZU35)*complexconjugate(ZUR32) + complexconjugate(ZU36)*complexconjugate(ZUR33)) - 3*ZN24*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3379 = Coupling(name = 'GC_3379',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL31*complexconjugate(ZU31) + ZUL32*complexconjugate(ZU32) + ZUL33*complexconjugate(ZU33)) + 6*complexconjugate(ZN24)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3380 = Coupling(name = 'GC_3380',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU44)*complexconjugate(ZUR31) + complexconjugate(ZU45)*complexconjugate(ZUR32) + complexconjugate(ZU46)*complexconjugate(ZUR33)) - 3*ZN24*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3381 = Coupling(name = 'GC_3381',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL31*complexconjugate(ZU41) + ZUL32*complexconjugate(ZU42) + ZUL33*complexconjugate(ZU43)) + 6*complexconjugate(ZN24)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3382 = Coupling(name = 'GC_3382',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU54)*complexconjugate(ZUR31) + complexconjugate(ZU55)*complexconjugate(ZUR32) + complexconjugate(ZU56)*complexconjugate(ZUR33)) - 3*ZN24*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3383 = Coupling(name = 'GC_3383',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL31*complexconjugate(ZU51) + ZUL32*complexconjugate(ZU52) + ZUL33*complexconjugate(ZU53)) + 6*complexconjugate(ZN24)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3384 = Coupling(name = 'GC_3384',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN21*(complexconjugate(ZU64)*complexconjugate(ZUR31) + complexconjugate(ZU65)*complexconjugate(ZUR32) + complexconjugate(ZU66)*complexconjugate(ZUR33)) - 3*ZN24*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3385 = Coupling(name = 'GC_3385',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN21) + 3*g2*complexconjugate(ZN22))*(ZUL31*complexconjugate(ZU61) + ZUL32*complexconjugate(ZU62) + ZUL33*complexconjugate(ZU63)) + 6*complexconjugate(ZN24)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3386 = Coupling(name = 'GC_3386',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU14)*complexconjugate(ZUR31) + complexconjugate(ZU15)*complexconjugate(ZUR32) + complexconjugate(ZU16)*complexconjugate(ZUR33)) - 3*ZN34*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3387 = Coupling(name = 'GC_3387',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL31*complexconjugate(ZU11) + ZUL32*complexconjugate(ZU12) + ZUL33*complexconjugate(ZU13)) + 6*complexconjugate(ZN34)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3388 = Coupling(name = 'GC_3388',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU24)*complexconjugate(ZUR31) + complexconjugate(ZU25)*complexconjugate(ZUR32) + complexconjugate(ZU26)*complexconjugate(ZUR33)) - 3*ZN34*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3389 = Coupling(name = 'GC_3389',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL31*complexconjugate(ZU21) + ZUL32*complexconjugate(ZU22) + ZUL33*complexconjugate(ZU23)) + 6*complexconjugate(ZN34)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3390 = Coupling(name = 'GC_3390',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU34)*complexconjugate(ZUR31) + complexconjugate(ZU35)*complexconjugate(ZUR32) + complexconjugate(ZU36)*complexconjugate(ZUR33)) - 3*ZN34*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3391 = Coupling(name = 'GC_3391',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL31*complexconjugate(ZU31) + ZUL32*complexconjugate(ZU32) + ZUL33*complexconjugate(ZU33)) + 6*complexconjugate(ZN34)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3392 = Coupling(name = 'GC_3392',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU44)*complexconjugate(ZUR31) + complexconjugate(ZU45)*complexconjugate(ZUR32) + complexconjugate(ZU46)*complexconjugate(ZUR33)) - 3*ZN34*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3393 = Coupling(name = 'GC_3393',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL31*complexconjugate(ZU41) + ZUL32*complexconjugate(ZU42) + ZUL33*complexconjugate(ZU43)) + 6*complexconjugate(ZN34)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3394 = Coupling(name = 'GC_3394',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU54)*complexconjugate(ZUR31) + complexconjugate(ZU55)*complexconjugate(ZUR32) + complexconjugate(ZU56)*complexconjugate(ZUR33)) - 3*ZN34*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3395 = Coupling(name = 'GC_3395',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL31*complexconjugate(ZU51) + ZUL32*complexconjugate(ZU52) + ZUL33*complexconjugate(ZU53)) + 6*complexconjugate(ZN34)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3396 = Coupling(name = 'GC_3396',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN31*(complexconjugate(ZU64)*complexconjugate(ZUR31) + complexconjugate(ZU65)*complexconjugate(ZUR32) + complexconjugate(ZU66)*complexconjugate(ZUR33)) - 3*ZN34*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3397 = Coupling(name = 'GC_3397',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN31) + 3*g2*complexconjugate(ZN32))*(ZUL31*complexconjugate(ZU61) + ZUL32*complexconjugate(ZU62) + ZUL33*complexconjugate(ZU63)) + 6*complexconjugate(ZN34)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3398 = Coupling(name = 'GC_3398',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU14)*complexconjugate(ZUR31) + complexconjugate(ZU15)*complexconjugate(ZUR32) + complexconjugate(ZU16)*complexconjugate(ZUR33)) - 3*ZN44*(complexconjugate(ZU11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3399 = Coupling(name = 'GC_3399',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL31*complexconjugate(ZU11) + ZUL32*complexconjugate(ZU12) + ZUL33*complexconjugate(ZU13)) + 6*complexconjugate(ZN44)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU14) + complexconjugate(Yu21)*complexconjugate(ZU15) + complexconjugate(Yu31)*complexconjugate(ZU16)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU14) + complexconjugate(Yu22)*complexconjugate(ZU15) + complexconjugate(Yu32)*complexconjugate(ZU16)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU14) + complexconjugate(Yu23)*complexconjugate(ZU15) + complexconjugate(Yu33)*complexconjugate(ZU16))))', 
	 order = {'QED':1} ) 
 
GC_3400 = Coupling(name = 'GC_3400',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU24)*complexconjugate(ZUR31) + complexconjugate(ZU25)*complexconjugate(ZUR32) + complexconjugate(ZU26)*complexconjugate(ZUR33)) - 3*ZN44*(complexconjugate(ZU21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3401 = Coupling(name = 'GC_3401',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL31*complexconjugate(ZU21) + ZUL32*complexconjugate(ZU22) + ZUL33*complexconjugate(ZU23)) + 6*complexconjugate(ZN44)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU24) + complexconjugate(Yu21)*complexconjugate(ZU25) + complexconjugate(Yu31)*complexconjugate(ZU26)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU24) + complexconjugate(Yu22)*complexconjugate(ZU25) + complexconjugate(Yu32)*complexconjugate(ZU26)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU24) + complexconjugate(Yu23)*complexconjugate(ZU25) + complexconjugate(Yu33)*complexconjugate(ZU26))))', 
	 order = {'QED':1} ) 
 
GC_3402 = Coupling(name = 'GC_3402',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU34)*complexconjugate(ZUR31) + complexconjugate(ZU35)*complexconjugate(ZUR32) + complexconjugate(ZU36)*complexconjugate(ZUR33)) - 3*ZN44*(complexconjugate(ZU31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3403 = Coupling(name = 'GC_3403',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL31*complexconjugate(ZU31) + ZUL32*complexconjugate(ZU32) + ZUL33*complexconjugate(ZU33)) + 6*complexconjugate(ZN44)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU34) + complexconjugate(Yu21)*complexconjugate(ZU35) + complexconjugate(Yu31)*complexconjugate(ZU36)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU34) + complexconjugate(Yu22)*complexconjugate(ZU35) + complexconjugate(Yu32)*complexconjugate(ZU36)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU34) + complexconjugate(Yu23)*complexconjugate(ZU35) + complexconjugate(Yu33)*complexconjugate(ZU36))))', 
	 order = {'QED':1} ) 
 
GC_3404 = Coupling(name = 'GC_3404',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU44)*complexconjugate(ZUR31) + complexconjugate(ZU45)*complexconjugate(ZUR32) + complexconjugate(ZU46)*complexconjugate(ZUR33)) - 3*ZN44*(complexconjugate(ZU41)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU42)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU43)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3405 = Coupling(name = 'GC_3405',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL31*complexconjugate(ZU41) + ZUL32*complexconjugate(ZU42) + ZUL33*complexconjugate(ZU43)) + 6*complexconjugate(ZN44)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU44) + complexconjugate(Yu21)*complexconjugate(ZU45) + complexconjugate(Yu31)*complexconjugate(ZU46)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU44) + complexconjugate(Yu22)*complexconjugate(ZU45) + complexconjugate(Yu32)*complexconjugate(ZU46)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU44) + complexconjugate(Yu23)*complexconjugate(ZU45) + complexconjugate(Yu33)*complexconjugate(ZU46))))', 
	 order = {'QED':1} ) 
 
GC_3406 = Coupling(name = 'GC_3406',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU54)*complexconjugate(ZUR31) + complexconjugate(ZU55)*complexconjugate(ZUR32) + complexconjugate(ZU56)*complexconjugate(ZUR33)) - 3*ZN44*(complexconjugate(ZU51)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU52)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU53)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3407 = Coupling(name = 'GC_3407',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL31*complexconjugate(ZU51) + ZUL32*complexconjugate(ZU52) + ZUL33*complexconjugate(ZU53)) + 6*complexconjugate(ZN44)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU54) + complexconjugate(Yu21)*complexconjugate(ZU55) + complexconjugate(Yu31)*complexconjugate(ZU56)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU54) + complexconjugate(Yu22)*complexconjugate(ZU55) + complexconjugate(Yu32)*complexconjugate(ZU56)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU54) + complexconjugate(Yu23)*complexconjugate(ZU55) + complexconjugate(Yu33)*complexconjugate(ZU56))))', 
	 order = {'QED':1} ) 
 
GC_3408 = Coupling(name = 'GC_3408',
	 value = '1./3.*complex(0,1)*(2*cmath.sqrt(2)*g1*ZN41*(complexconjugate(ZU64)*complexconjugate(ZUR31) + complexconjugate(ZU65)*complexconjugate(ZUR32) + complexconjugate(ZU66)*complexconjugate(ZUR33)) - 3*ZN44*(complexconjugate(ZU61)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZU62)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZU63)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))', 
	 order = {'QED':1} ) 
 
GC_3409 = Coupling(name = 'GC_3409',
	 value = '-1./6.*complex(0,1)*(cmath.sqrt(2)*(g1*complexconjugate(ZN41) + 3*g2*complexconjugate(ZN42))*(ZUL31*complexconjugate(ZU61) + ZUL32*complexconjugate(ZU62) + ZUL33*complexconjugate(ZU63)) + 6*complexconjugate(ZN44)*(ZUL31*(complexconjugate(Yu11)*complexconjugate(ZU64) + complexconjugate(Yu21)*complexconjugate(ZU65) + complexconjugate(Yu31)*complexconjugate(ZU66)) + ZUL32*(complexconjugate(Yu12)*complexconjugate(ZU64) + complexconjugate(Yu22)*complexconjugate(ZU65) + complexconjugate(Yu32)*complexconjugate(ZU66)) + ZUL33*(complexconjugate(Yu13)*complexconjugate(ZU64) + complexconjugate(Yu23)*complexconjugate(ZU65) + complexconjugate(Yu33)*complexconjugate(ZU66))))', 
	 order = {'QED':1} ) 
 
GC_3410 = Coupling(name = 'GC_3410',
	 value = '(1*complex(0,1)*ZV11*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3411 = Coupling(name = 'GC_3411',
	 value = '(1*complex(0,1)*ZV21*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3412 = Coupling(name = 'GC_3412',
	 value = '(1*complex(0,1)*ZV31*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3413 = Coupling(name = 'GC_3413',
	 value = '(1*complex(0,1)*ZV11*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3414 = Coupling(name = 'GC_3414',
	 value = '(1*complex(0,1)*ZV21*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3415 = Coupling(name = 'GC_3415',
	 value = '(1*complex(0,1)*ZV31*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3416 = Coupling(name = 'GC_3416',
	 value = '(1*complex(0,1)*ZV11*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3417 = Coupling(name = 'GC_3417',
	 value = '(1*complex(0,1)*ZV21*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3418 = Coupling(name = 'GC_3418',
	 value = '(1*complex(0,1)*ZV31*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3419 = Coupling(name = 'GC_3419',
	 value = '(1*complex(0,1)*ZV11*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3420 = Coupling(name = 'GC_3420',
	 value = '(1*complex(0,1)*ZV21*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3421 = Coupling(name = 'GC_3421',
	 value = '(1*complex(0,1)*ZV31*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3422 = Coupling(name = 'GC_3422',
	 value = '(1*complex(0,1)*ZV12*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3423 = Coupling(name = 'GC_3423',
	 value = '(1*complex(0,1)*ZV22*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3424 = Coupling(name = 'GC_3424',
	 value = '(1*complex(0,1)*ZV32*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3425 = Coupling(name = 'GC_3425',
	 value = '(1*complex(0,1)*ZV12*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3426 = Coupling(name = 'GC_3426',
	 value = '(1*complex(0,1)*ZV22*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3427 = Coupling(name = 'GC_3427',
	 value = '(1*complex(0,1)*ZV32*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3428 = Coupling(name = 'GC_3428',
	 value = '(1*complex(0,1)*ZV12*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3429 = Coupling(name = 'GC_3429',
	 value = '(1*complex(0,1)*ZV22*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3430 = Coupling(name = 'GC_3430',
	 value = '(1*complex(0,1)*ZV32*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3431 = Coupling(name = 'GC_3431',
	 value = '(1*complex(0,1)*ZV12*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3432 = Coupling(name = 'GC_3432',
	 value = '(1*complex(0,1)*ZV22*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3433 = Coupling(name = 'GC_3433',
	 value = '(1*complex(0,1)*ZV32*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3434 = Coupling(name = 'GC_3434',
	 value = '(1*complex(0,1)*ZV13*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3435 = Coupling(name = 'GC_3435',
	 value = '(1*complex(0,1)*ZV23*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3436 = Coupling(name = 'GC_3436',
	 value = '(1*complex(0,1)*ZV33*(g1*complexconjugate(ZN11) - g2*complexconjugate(ZN12)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3437 = Coupling(name = 'GC_3437',
	 value = '(1*complex(0,1)*ZV13*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3438 = Coupling(name = 'GC_3438',
	 value = '(1*complex(0,1)*ZV23*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3439 = Coupling(name = 'GC_3439',
	 value = '(1*complex(0,1)*ZV33*(g1*complexconjugate(ZN21) - g2*complexconjugate(ZN22)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3440 = Coupling(name = 'GC_3440',
	 value = '(1*complex(0,1)*ZV13*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3441 = Coupling(name = 'GC_3441',
	 value = '(1*complex(0,1)*ZV23*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3442 = Coupling(name = 'GC_3442',
	 value = '(1*complex(0,1)*ZV33*(g1*complexconjugate(ZN31) - g2*complexconjugate(ZN32)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3443 = Coupling(name = 'GC_3443',
	 value = '(1*complex(0,1)*ZV13*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3444 = Coupling(name = 'GC_3444',
	 value = '(1*complex(0,1)*ZV23*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3445 = Coupling(name = 'GC_3445',
	 value = '(1*complex(0,1)*ZV33*(g1*complexconjugate(ZN41) - g2*complexconjugate(ZN42)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3446 = Coupling(name = 'GC_3446',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD11*complexconjugate(ZDL11) + ZD12*complexconjugate(ZDL12) + ZD13*complexconjugate(ZDL13))', 
	 order = {'QCD':1} ) 
 
GC_3447 = Coupling(name = 'GC_3447',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD14*ZDR11 + ZD15*ZDR12 + ZD16*ZDR13)', 
	 order = {'QCD':1} ) 
 
GC_3448 = Coupling(name = 'GC_3448',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD21*complexconjugate(ZDL11) + ZD22*complexconjugate(ZDL12) + ZD23*complexconjugate(ZDL13))', 
	 order = {'QCD':1} ) 
 
GC_3449 = Coupling(name = 'GC_3449',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD24*ZDR11 + ZD25*ZDR12 + ZD26*ZDR13)', 
	 order = {'QCD':1} ) 
 
GC_3450 = Coupling(name = 'GC_3450',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD31*complexconjugate(ZDL11) + ZD32*complexconjugate(ZDL12) + ZD33*complexconjugate(ZDL13))', 
	 order = {'QCD':1} ) 
 
GC_3451 = Coupling(name = 'GC_3451',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD34*ZDR11 + ZD35*ZDR12 + ZD36*ZDR13)', 
	 order = {'QCD':1} ) 
 
GC_3452 = Coupling(name = 'GC_3452',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD41*complexconjugate(ZDL11) + ZD42*complexconjugate(ZDL12) + ZD43*complexconjugate(ZDL13))', 
	 order = {'QCD':1} ) 
 
GC_3453 = Coupling(name = 'GC_3453',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD44*ZDR11 + ZD45*ZDR12 + ZD46*ZDR13)', 
	 order = {'QCD':1} ) 
 
GC_3454 = Coupling(name = 'GC_3454',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD51*complexconjugate(ZDL11) + ZD52*complexconjugate(ZDL12) + ZD53*complexconjugate(ZDL13))', 
	 order = {'QCD':1} ) 
 
GC_3455 = Coupling(name = 'GC_3455',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD54*ZDR11 + ZD55*ZDR12 + ZD56*ZDR13)', 
	 order = {'QCD':1} ) 
 
GC_3456 = Coupling(name = 'GC_3456',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD61*complexconjugate(ZDL11) + ZD62*complexconjugate(ZDL12) + ZD63*complexconjugate(ZDL13))', 
	 order = {'QCD':1} ) 
 
GC_3457 = Coupling(name = 'GC_3457',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD64*ZDR11 + ZD65*ZDR12 + ZD66*ZDR13)', 
	 order = {'QCD':1} ) 
 
GC_3458 = Coupling(name = 'GC_3458',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD11*complexconjugate(ZDL21) + ZD12*complexconjugate(ZDL22) + ZD13*complexconjugate(ZDL23))', 
	 order = {'QCD':1} ) 
 
GC_3459 = Coupling(name = 'GC_3459',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD14*ZDR21 + ZD15*ZDR22 + ZD16*ZDR23)', 
	 order = {'QCD':1} ) 
 
GC_3460 = Coupling(name = 'GC_3460',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD21*complexconjugate(ZDL21) + ZD22*complexconjugate(ZDL22) + ZD23*complexconjugate(ZDL23))', 
	 order = {'QCD':1} ) 
 
GC_3461 = Coupling(name = 'GC_3461',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD24*ZDR21 + ZD25*ZDR22 + ZD26*ZDR23)', 
	 order = {'QCD':1} ) 
 
GC_3462 = Coupling(name = 'GC_3462',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD31*complexconjugate(ZDL21) + ZD32*complexconjugate(ZDL22) + ZD33*complexconjugate(ZDL23))', 
	 order = {'QCD':1} ) 
 
GC_3463 = Coupling(name = 'GC_3463',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD34*ZDR21 + ZD35*ZDR22 + ZD36*ZDR23)', 
	 order = {'QCD':1} ) 
 
GC_3464 = Coupling(name = 'GC_3464',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD41*complexconjugate(ZDL21) + ZD42*complexconjugate(ZDL22) + ZD43*complexconjugate(ZDL23))', 
	 order = {'QCD':1} ) 
 
GC_3465 = Coupling(name = 'GC_3465',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD44*ZDR21 + ZD45*ZDR22 + ZD46*ZDR23)', 
	 order = {'QCD':1} ) 
 
GC_3466 = Coupling(name = 'GC_3466',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD51*complexconjugate(ZDL21) + ZD52*complexconjugate(ZDL22) + ZD53*complexconjugate(ZDL23))', 
	 order = {'QCD':1} ) 
 
GC_3467 = Coupling(name = 'GC_3467',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD54*ZDR21 + ZD55*ZDR22 + ZD56*ZDR23)', 
	 order = {'QCD':1} ) 
 
GC_3468 = Coupling(name = 'GC_3468',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD61*complexconjugate(ZDL21) + ZD62*complexconjugate(ZDL22) + ZD63*complexconjugate(ZDL23))', 
	 order = {'QCD':1} ) 
 
GC_3469 = Coupling(name = 'GC_3469',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD64*ZDR21 + ZD65*ZDR22 + ZD66*ZDR23)', 
	 order = {'QCD':1} ) 
 
GC_3470 = Coupling(name = 'GC_3470',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD11*complexconjugate(ZDL31) + ZD12*complexconjugate(ZDL32) + ZD13*complexconjugate(ZDL33))', 
	 order = {'QCD':1} ) 
 
GC_3471 = Coupling(name = 'GC_3471',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD14*ZDR31 + ZD15*ZDR32 + ZD16*ZDR33)', 
	 order = {'QCD':1} ) 
 
GC_3472 = Coupling(name = 'GC_3472',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD21*complexconjugate(ZDL31) + ZD22*complexconjugate(ZDL32) + ZD23*complexconjugate(ZDL33))', 
	 order = {'QCD':1} ) 
 
GC_3473 = Coupling(name = 'GC_3473',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD24*ZDR31 + ZD25*ZDR32 + ZD26*ZDR33)', 
	 order = {'QCD':1} ) 
 
GC_3474 = Coupling(name = 'GC_3474',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD31*complexconjugate(ZDL31) + ZD32*complexconjugate(ZDL32) + ZD33*complexconjugate(ZDL33))', 
	 order = {'QCD':1} ) 
 
GC_3475 = Coupling(name = 'GC_3475',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD34*ZDR31 + ZD35*ZDR32 + ZD36*ZDR33)', 
	 order = {'QCD':1} ) 
 
GC_3476 = Coupling(name = 'GC_3476',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD41*complexconjugate(ZDL31) + ZD42*complexconjugate(ZDL32) + ZD43*complexconjugate(ZDL33))', 
	 order = {'QCD':1} ) 
 
GC_3477 = Coupling(name = 'GC_3477',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD44*ZDR31 + ZD45*ZDR32 + ZD46*ZDR33)', 
	 order = {'QCD':1} ) 
 
GC_3478 = Coupling(name = 'GC_3478',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD51*complexconjugate(ZDL31) + ZD52*complexconjugate(ZDL32) + ZD53*complexconjugate(ZDL33))', 
	 order = {'QCD':1} ) 
 
GC_3479 = Coupling(name = 'GC_3479',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD54*ZDR31 + ZD55*ZDR32 + ZD56*ZDR33)', 
	 order = {'QCD':1} ) 
 
GC_3480 = Coupling(name = 'GC_3480',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZD61*complexconjugate(ZDL31) + ZD62*complexconjugate(ZDL32) + ZD63*complexconjugate(ZDL33))', 
	 order = {'QCD':1} ) 
 
GC_3481 = Coupling(name = 'GC_3481',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZD64*ZDR31 + ZD65*ZDR32 + ZD66*ZDR33)', 
	 order = {'QCD':1} ) 
 
GC_3482 = Coupling(name = 'GC_3482',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3483 = Coupling(name = 'GC_3483',
	 value = '(-1*complex(0,1)*ZH11*(ZDL11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3484 = Coupling(name = 'GC_3484',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3485 = Coupling(name = 'GC_3485',
	 value = '(-1*complex(0,1)*ZH21*(ZDL11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3486 = Coupling(name = 'GC_3486',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3487 = Coupling(name = 'GC_3487',
	 value = '(-1*complex(0,1)*ZH11*(ZDL11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3488 = Coupling(name = 'GC_3488',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3489 = Coupling(name = 'GC_3489',
	 value = '(-1*complex(0,1)*ZH21*(ZDL11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3490 = Coupling(name = 'GC_3490',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3491 = Coupling(name = 'GC_3491',
	 value = '(-1*complex(0,1)*ZH11*(ZDL11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3492 = Coupling(name = 'GC_3492',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3493 = Coupling(name = 'GC_3493',
	 value = '(-1*complex(0,1)*ZH21*(ZDL11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3494 = Coupling(name = 'GC_3494',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3495 = Coupling(name = 'GC_3495',
	 value = '(-1*complex(0,1)*ZH11*(ZDL21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3496 = Coupling(name = 'GC_3496',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3497 = Coupling(name = 'GC_3497',
	 value = '(-1*complex(0,1)*ZH21*(ZDL21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3498 = Coupling(name = 'GC_3498',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3499 = Coupling(name = 'GC_3499',
	 value = '(-1*complex(0,1)*ZH11*(ZDL21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3500 = Coupling(name = 'GC_3500',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3501 = Coupling(name = 'GC_3501',
	 value = '(-1*complex(0,1)*ZH21*(ZDL21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3502 = Coupling(name = 'GC_3502',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3503 = Coupling(name = 'GC_3503',
	 value = '(-1*complex(0,1)*ZH11*(ZDL21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3504 = Coupling(name = 'GC_3504',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3505 = Coupling(name = 'GC_3505',
	 value = '(-1*complex(0,1)*ZH21*(ZDL21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3506 = Coupling(name = 'GC_3506',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3507 = Coupling(name = 'GC_3507',
	 value = '(-1*complex(0,1)*ZH11*(ZDL31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3508 = Coupling(name = 'GC_3508',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL11)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL12)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL13)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3509 = Coupling(name = 'GC_3509',
	 value = '(-1*complex(0,1)*ZH21*(ZDL31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZDL32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZDL33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3510 = Coupling(name = 'GC_3510',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3511 = Coupling(name = 'GC_3511',
	 value = '(-1*complex(0,1)*ZH11*(ZDL31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3512 = Coupling(name = 'GC_3512',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL21)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL22)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL23)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3513 = Coupling(name = 'GC_3513',
	 value = '(-1*complex(0,1)*ZH21*(ZDL31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZDL32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZDL33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3514 = Coupling(name = 'GC_3514',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3515 = Coupling(name = 'GC_3515',
	 value = '(-1*complex(0,1)*ZH11*(ZDL31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3516 = Coupling(name = 'GC_3516',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZDL31)*(Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33)) + complexconjugate(ZDL32)*(Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33)) + complexconjugate(ZDL33)*(Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3517 = Coupling(name = 'GC_3517',
	 value = '(-1*complex(0,1)*ZH21*(ZDL31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZDL32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZDL33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3518 = Coupling(name = 'GC_3518',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU11*complexconjugate(ZDL11) + ZU12*complexconjugate(ZDL12) + ZU13*complexconjugate(ZDL13)) - UP12*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZDL11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZDL12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3519 = Coupling(name = 'GC_3519',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3520 = Coupling(name = 'GC_3520',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU21*complexconjugate(ZDL11) + ZU22*complexconjugate(ZDL12) + ZU23*complexconjugate(ZDL13)) - UP12*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZDL11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZDL12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3521 = Coupling(name = 'GC_3521',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3522 = Coupling(name = 'GC_3522',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU31*complexconjugate(ZDL11) + ZU32*complexconjugate(ZDL12) + ZU33*complexconjugate(ZDL13)) - UP12*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZDL11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZDL12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3523 = Coupling(name = 'GC_3523',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3524 = Coupling(name = 'GC_3524',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU41*complexconjugate(ZDL11) + ZU42*complexconjugate(ZDL12) + ZU43*complexconjugate(ZDL13)) - UP12*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZDL11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZDL12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3525 = Coupling(name = 'GC_3525',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU41*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU42*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU43*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3526 = Coupling(name = 'GC_3526',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU51*complexconjugate(ZDL11) + ZU52*complexconjugate(ZDL12) + ZU53*complexconjugate(ZDL13)) - UP12*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZDL11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZDL12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3527 = Coupling(name = 'GC_3527',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU51*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU52*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU53*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3528 = Coupling(name = 'GC_3528',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU61*complexconjugate(ZDL11) + ZU62*complexconjugate(ZDL12) + ZU63*complexconjugate(ZDL13)) - UP12*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZDL11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZDL12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3529 = Coupling(name = 'GC_3529',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU61*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU62*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU63*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3530 = Coupling(name = 'GC_3530',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU11*complexconjugate(ZDL21) + ZU12*complexconjugate(ZDL22) + ZU13*complexconjugate(ZDL23)) - UP12*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZDL21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZDL22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3531 = Coupling(name = 'GC_3531',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3532 = Coupling(name = 'GC_3532',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU21*complexconjugate(ZDL21) + ZU22*complexconjugate(ZDL22) + ZU23*complexconjugate(ZDL23)) - UP12*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZDL21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZDL22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3533 = Coupling(name = 'GC_3533',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3534 = Coupling(name = 'GC_3534',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU31*complexconjugate(ZDL21) + ZU32*complexconjugate(ZDL22) + ZU33*complexconjugate(ZDL23)) - UP12*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZDL21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZDL22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3535 = Coupling(name = 'GC_3535',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3536 = Coupling(name = 'GC_3536',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU41*complexconjugate(ZDL21) + ZU42*complexconjugate(ZDL22) + ZU43*complexconjugate(ZDL23)) - UP12*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZDL21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZDL22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3537 = Coupling(name = 'GC_3537',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU41*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU42*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU43*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3538 = Coupling(name = 'GC_3538',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU51*complexconjugate(ZDL21) + ZU52*complexconjugate(ZDL22) + ZU53*complexconjugate(ZDL23)) - UP12*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZDL21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZDL22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3539 = Coupling(name = 'GC_3539',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU51*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU52*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU53*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3540 = Coupling(name = 'GC_3540',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU61*complexconjugate(ZDL21) + ZU62*complexconjugate(ZDL22) + ZU63*complexconjugate(ZDL23)) - UP12*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZDL21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZDL22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3541 = Coupling(name = 'GC_3541',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU61*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU62*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU63*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3542 = Coupling(name = 'GC_3542',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU11*complexconjugate(ZDL31) + ZU12*complexconjugate(ZDL32) + ZU13*complexconjugate(ZDL33)) - UP12*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZDL31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZDL32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3543 = Coupling(name = 'GC_3543',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3544 = Coupling(name = 'GC_3544',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU21*complexconjugate(ZDL31) + ZU22*complexconjugate(ZDL32) + ZU23*complexconjugate(ZDL33)) - UP12*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZDL31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZDL32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3545 = Coupling(name = 'GC_3545',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3546 = Coupling(name = 'GC_3546',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU31*complexconjugate(ZDL31) + ZU32*complexconjugate(ZDL32) + ZU33*complexconjugate(ZDL33)) - UP12*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZDL31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZDL32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3547 = Coupling(name = 'GC_3547',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3548 = Coupling(name = 'GC_3548',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU41*complexconjugate(ZDL31) + ZU42*complexconjugate(ZDL32) + ZU43*complexconjugate(ZDL33)) - UP12*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZDL31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZDL32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3549 = Coupling(name = 'GC_3549',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU41*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU42*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU43*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3550 = Coupling(name = 'GC_3550',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU51*complexconjugate(ZDL31) + ZU52*complexconjugate(ZDL32) + ZU53*complexconjugate(ZDL33)) - UP12*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZDL31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZDL32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3551 = Coupling(name = 'GC_3551',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU51*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU52*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU53*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3552 = Coupling(name = 'GC_3552',
	 value = '-1*complex(0,1)*(g2*UP11*(ZU61*complexconjugate(ZDL31) + ZU62*complexconjugate(ZDL32) + ZU63*complexconjugate(ZDL33)) - UP12*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZDL31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZDL32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3553 = Coupling(name = 'GC_3553',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZU61*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU62*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU63*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3554 = Coupling(name = 'GC_3554',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU11*complexconjugate(ZDL11) + ZU12*complexconjugate(ZDL12) + ZU13*complexconjugate(ZDL13)) - UP22*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZDL11) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZDL12) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3555 = Coupling(name = 'GC_3555',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3556 = Coupling(name = 'GC_3556',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU21*complexconjugate(ZDL11) + ZU22*complexconjugate(ZDL12) + ZU23*complexconjugate(ZDL13)) - UP22*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZDL11) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZDL12) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3557 = Coupling(name = 'GC_3557',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3558 = Coupling(name = 'GC_3558',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU31*complexconjugate(ZDL11) + ZU32*complexconjugate(ZDL12) + ZU33*complexconjugate(ZDL13)) - UP22*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZDL11) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZDL12) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3559 = Coupling(name = 'GC_3559',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3560 = Coupling(name = 'GC_3560',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU41*complexconjugate(ZDL11) + ZU42*complexconjugate(ZDL12) + ZU43*complexconjugate(ZDL13)) - UP22*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZDL11) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZDL12) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3561 = Coupling(name = 'GC_3561',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU41*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU42*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU43*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3562 = Coupling(name = 'GC_3562',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU51*complexconjugate(ZDL11) + ZU52*complexconjugate(ZDL12) + ZU53*complexconjugate(ZDL13)) - UP22*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZDL11) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZDL12) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3563 = Coupling(name = 'GC_3563',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU51*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU52*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU53*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3564 = Coupling(name = 'GC_3564',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU61*complexconjugate(ZDL11) + ZU62*complexconjugate(ZDL12) + ZU63*complexconjugate(ZDL13)) - UP22*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZDL11) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZDL12) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZDL13)))', 
	 order = {'QED':1} ) 
 
GC_3565 = Coupling(name = 'GC_3565',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU61*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZU62*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZU63*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3566 = Coupling(name = 'GC_3566',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU11*complexconjugate(ZDL21) + ZU12*complexconjugate(ZDL22) + ZU13*complexconjugate(ZDL23)) - UP22*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZDL21) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZDL22) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3567 = Coupling(name = 'GC_3567',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3568 = Coupling(name = 'GC_3568',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU21*complexconjugate(ZDL21) + ZU22*complexconjugate(ZDL22) + ZU23*complexconjugate(ZDL23)) - UP22*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZDL21) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZDL22) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3569 = Coupling(name = 'GC_3569',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3570 = Coupling(name = 'GC_3570',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU31*complexconjugate(ZDL21) + ZU32*complexconjugate(ZDL22) + ZU33*complexconjugate(ZDL23)) - UP22*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZDL21) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZDL22) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3571 = Coupling(name = 'GC_3571',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3572 = Coupling(name = 'GC_3572',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU41*complexconjugate(ZDL21) + ZU42*complexconjugate(ZDL22) + ZU43*complexconjugate(ZDL23)) - UP22*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZDL21) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZDL22) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3573 = Coupling(name = 'GC_3573',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU41*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU42*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU43*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3574 = Coupling(name = 'GC_3574',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU51*complexconjugate(ZDL21) + ZU52*complexconjugate(ZDL22) + ZU53*complexconjugate(ZDL23)) - UP22*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZDL21) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZDL22) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3575 = Coupling(name = 'GC_3575',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU51*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU52*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU53*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3576 = Coupling(name = 'GC_3576',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU61*complexconjugate(ZDL21) + ZU62*complexconjugate(ZDL22) + ZU63*complexconjugate(ZDL23)) - UP22*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZDL21) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZDL22) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZDL23)))', 
	 order = {'QED':1} ) 
 
GC_3577 = Coupling(name = 'GC_3577',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU61*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZU62*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZU63*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3578 = Coupling(name = 'GC_3578',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU11*complexconjugate(ZDL31) + ZU12*complexconjugate(ZDL32) + ZU13*complexconjugate(ZDL33)) - UP22*((Yu11*ZU14 + Yu21*ZU15 + Yu31*ZU16)*complexconjugate(ZDL31) + (Yu12*ZU14 + Yu22*ZU15 + Yu32*ZU16)*complexconjugate(ZDL32) + (Yu13*ZU14 + Yu23*ZU15 + Yu33*ZU16)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3579 = Coupling(name = 'GC_3579',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3580 = Coupling(name = 'GC_3580',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU21*complexconjugate(ZDL31) + ZU22*complexconjugate(ZDL32) + ZU23*complexconjugate(ZDL33)) - UP22*((Yu11*ZU24 + Yu21*ZU25 + Yu31*ZU26)*complexconjugate(ZDL31) + (Yu12*ZU24 + Yu22*ZU25 + Yu32*ZU26)*complexconjugate(ZDL32) + (Yu13*ZU24 + Yu23*ZU25 + Yu33*ZU26)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3581 = Coupling(name = 'GC_3581',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3582 = Coupling(name = 'GC_3582',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU31*complexconjugate(ZDL31) + ZU32*complexconjugate(ZDL32) + ZU33*complexconjugate(ZDL33)) - UP22*((Yu11*ZU34 + Yu21*ZU35 + Yu31*ZU36)*complexconjugate(ZDL31) + (Yu12*ZU34 + Yu22*ZU35 + Yu32*ZU36)*complexconjugate(ZDL32) + (Yu13*ZU34 + Yu23*ZU35 + Yu33*ZU36)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3583 = Coupling(name = 'GC_3583',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3584 = Coupling(name = 'GC_3584',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU41*complexconjugate(ZDL31) + ZU42*complexconjugate(ZDL32) + ZU43*complexconjugate(ZDL33)) - UP22*((Yu11*ZU44 + Yu21*ZU45 + Yu31*ZU46)*complexconjugate(ZDL31) + (Yu12*ZU44 + Yu22*ZU45 + Yu32*ZU46)*complexconjugate(ZDL32) + (Yu13*ZU44 + Yu23*ZU45 + Yu33*ZU46)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3585 = Coupling(name = 'GC_3585',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU41*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU42*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU43*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3586 = Coupling(name = 'GC_3586',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU51*complexconjugate(ZDL31) + ZU52*complexconjugate(ZDL32) + ZU53*complexconjugate(ZDL33)) - UP22*((Yu11*ZU54 + Yu21*ZU55 + Yu31*ZU56)*complexconjugate(ZDL31) + (Yu12*ZU54 + Yu22*ZU55 + Yu32*ZU56)*complexconjugate(ZDL32) + (Yu13*ZU54 + Yu23*ZU55 + Yu33*ZU56)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3587 = Coupling(name = 'GC_3587',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU51*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU52*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU53*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3588 = Coupling(name = 'GC_3588',
	 value = '-1*complex(0,1)*(g2*UP21*(ZU61*complexconjugate(ZDL31) + ZU62*complexconjugate(ZDL32) + ZU63*complexconjugate(ZDL33)) - UP22*((Yu11*ZU64 + Yu21*ZU65 + Yu31*ZU66)*complexconjugate(ZDL31) + (Yu12*ZU64 + Yu22*ZU65 + Yu32*ZU66)*complexconjugate(ZDL32) + (Yu13*ZU64 + Yu23*ZU65 + Yu33*ZU66)*complexconjugate(ZDL33)))', 
	 order = {'QED':1} ) 
 
GC_3589 = Coupling(name = 'GC_3589',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZU61*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZU62*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZU63*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3590 = Coupling(name = 'GC_3590',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZDL12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZDL13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3591 = Coupling(name = 'GC_3591',
	 value = '1*complex(0,1)*ZP11*(ZUL11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZUL12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZUL13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3592 = Coupling(name = 'GC_3592',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZDL12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZDL13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3593 = Coupling(name = 'GC_3593',
	 value = '1*complex(0,1)*ZP21*(ZUL11*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZUL12*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZUL13*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3594 = Coupling(name = 'GC_3594',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZDL22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZDL23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3595 = Coupling(name = 'GC_3595',
	 value = '1*complex(0,1)*ZP11*(ZUL11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZUL12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZUL13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3596 = Coupling(name = 'GC_3596',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZDL22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZDL23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3597 = Coupling(name = 'GC_3597',
	 value = '1*complex(0,1)*ZP21*(ZUL11*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZUL12*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZUL13*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3598 = Coupling(name = 'GC_3598',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZDL32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZDL33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3599 = Coupling(name = 'GC_3599',
	 value = '1*complex(0,1)*ZP11*(ZUL11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZUL12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZUL13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3600 = Coupling(name = 'GC_3600',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZDL32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZDL33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3601 = Coupling(name = 'GC_3601',
	 value = '1*complex(0,1)*ZP21*(ZUL11*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZUL12*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZUL13*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3602 = Coupling(name = 'GC_3602',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZDL12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZDL13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3603 = Coupling(name = 'GC_3603',
	 value = '1*complex(0,1)*ZP11*(ZUL21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZUL22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZUL23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3604 = Coupling(name = 'GC_3604',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZDL12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZDL13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3605 = Coupling(name = 'GC_3605',
	 value = '1*complex(0,1)*ZP21*(ZUL21*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZUL22*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZUL23*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3606 = Coupling(name = 'GC_3606',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZDL22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZDL23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3607 = Coupling(name = 'GC_3607',
	 value = '1*complex(0,1)*ZP11*(ZUL21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZUL22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZUL23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3608 = Coupling(name = 'GC_3608',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZDL22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZDL23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3609 = Coupling(name = 'GC_3609',
	 value = '1*complex(0,1)*ZP21*(ZUL21*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZUL22*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZUL23*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3610 = Coupling(name = 'GC_3610',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZDL32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZDL33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3611 = Coupling(name = 'GC_3611',
	 value = '1*complex(0,1)*ZP11*(ZUL21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZUL22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZUL23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3612 = Coupling(name = 'GC_3612',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZDL32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZDL33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3613 = Coupling(name = 'GC_3613',
	 value = '1*complex(0,1)*ZP21*(ZUL21*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZUL22*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZUL23*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3614 = Coupling(name = 'GC_3614',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZDL12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZDL13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3615 = Coupling(name = 'GC_3615',
	 value = '1*complex(0,1)*ZP11*(ZUL31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZUL32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZUL33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3616 = Coupling(name = 'GC_3616',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZDL12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZDL13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3617 = Coupling(name = 'GC_3617',
	 value = '1*complex(0,1)*ZP21*(ZUL31*(ZDR11*complexconjugate(Yd11) + ZDR12*complexconjugate(Yd21) + ZDR13*complexconjugate(Yd31)) + ZUL32*(ZDR11*complexconjugate(Yd12) + ZDR12*complexconjugate(Yd22) + ZDR13*complexconjugate(Yd32)) + ZUL33*(ZDR11*complexconjugate(Yd13) + ZDR12*complexconjugate(Yd23) + ZDR13*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3618 = Coupling(name = 'GC_3618',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZDL22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZDL23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3619 = Coupling(name = 'GC_3619',
	 value = '1*complex(0,1)*ZP11*(ZUL31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZUL32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZUL33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3620 = Coupling(name = 'GC_3620',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZDL22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZDL23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3621 = Coupling(name = 'GC_3621',
	 value = '1*complex(0,1)*ZP21*(ZUL31*(ZDR21*complexconjugate(Yd11) + ZDR22*complexconjugate(Yd21) + ZDR23*complexconjugate(Yd31)) + ZUL32*(ZDR21*complexconjugate(Yd12) + ZDR22*complexconjugate(Yd22) + ZDR23*complexconjugate(Yd32)) + ZUL33*(ZDR21*complexconjugate(Yd13) + ZDR22*complexconjugate(Yd23) + ZDR23*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3622 = Coupling(name = 'GC_3622',
	 value = '1*complex(0,1)*ZP12*(complexconjugate(ZDL31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZDL32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZDL33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3623 = Coupling(name = 'GC_3623',
	 value = '1*complex(0,1)*ZP11*(ZUL31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZUL32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZUL33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3624 = Coupling(name = 'GC_3624',
	 value = '1*complex(0,1)*ZP22*(complexconjugate(ZDL31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZDL32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZDL33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3625 = Coupling(name = 'GC_3625',
	 value = '1*complex(0,1)*ZP21*(ZUL31*(ZDR31*complexconjugate(Yd11) + ZDR32*complexconjugate(Yd21) + ZDR33*complexconjugate(Yd31)) + ZUL32*(ZDR31*complexconjugate(Yd12) + ZDR32*complexconjugate(Yd22) + ZDR33*complexconjugate(Yd32)) + ZUL33*(ZDR31*complexconjugate(Yd13) + ZDR32*complexconjugate(Yd23) + ZDR33*complexconjugate(Yd33)))', 
	 order = {'QED':1} ) 
 
GC_3626 = Coupling(name = 'GC_3626',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3627 = Coupling(name = 'GC_3627',
	 value = '(-1*complex(0,1)*ZH11*(ZEL11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3628 = Coupling(name = 'GC_3628',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3629 = Coupling(name = 'GC_3629',
	 value = '(-1*complex(0,1)*ZH21*(ZEL11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3630 = Coupling(name = 'GC_3630',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3631 = Coupling(name = 'GC_3631',
	 value = '(-1*complex(0,1)*ZH11*(ZEL11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3632 = Coupling(name = 'GC_3632',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3633 = Coupling(name = 'GC_3633',
	 value = '(-1*complex(0,1)*ZH21*(ZEL11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3634 = Coupling(name = 'GC_3634',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3635 = Coupling(name = 'GC_3635',
	 value = '(-1*complex(0,1)*ZH11*(ZEL11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3636 = Coupling(name = 'GC_3636',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3637 = Coupling(name = 'GC_3637',
	 value = '(-1*complex(0,1)*ZH21*(ZEL11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3638 = Coupling(name = 'GC_3638',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3639 = Coupling(name = 'GC_3639',
	 value = '(-1*complex(0,1)*ZH11*(ZEL21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3640 = Coupling(name = 'GC_3640',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3641 = Coupling(name = 'GC_3641',
	 value = '(-1*complex(0,1)*ZH21*(ZEL21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3642 = Coupling(name = 'GC_3642',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3643 = Coupling(name = 'GC_3643',
	 value = '(-1*complex(0,1)*ZH11*(ZEL21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3644 = Coupling(name = 'GC_3644',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3645 = Coupling(name = 'GC_3645',
	 value = '(-1*complex(0,1)*ZH21*(ZEL21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3646 = Coupling(name = 'GC_3646',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3647 = Coupling(name = 'GC_3647',
	 value = '(-1*complex(0,1)*ZH11*(ZEL21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3648 = Coupling(name = 'GC_3648',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3649 = Coupling(name = 'GC_3649',
	 value = '(-1*complex(0,1)*ZH21*(ZEL21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3650 = Coupling(name = 'GC_3650',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3651 = Coupling(name = 'GC_3651',
	 value = '(-1*complex(0,1)*ZH11*(ZEL31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3652 = Coupling(name = 'GC_3652',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL11)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL12)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL13)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3653 = Coupling(name = 'GC_3653',
	 value = '(-1*complex(0,1)*ZH21*(ZEL31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZEL32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZEL33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3654 = Coupling(name = 'GC_3654',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3655 = Coupling(name = 'GC_3655',
	 value = '(-1*complex(0,1)*ZH11*(ZEL31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3656 = Coupling(name = 'GC_3656',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL21)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL22)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL23)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3657 = Coupling(name = 'GC_3657',
	 value = '(-1*complex(0,1)*ZH21*(ZEL31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZEL32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZEL33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3658 = Coupling(name = 'GC_3658',
	 value = '(-1*complex(0,1)*ZH11*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3659 = Coupling(name = 'GC_3659',
	 value = '(-1*complex(0,1)*ZH11*(ZEL31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3660 = Coupling(name = 'GC_3660',
	 value = '(-1*complex(0,1)*ZH21*(complexconjugate(ZEL31)*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33)) + complexconjugate(ZEL32)*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33)) + complexconjugate(ZEL33)*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3661 = Coupling(name = 'GC_3661',
	 value = '(-1*complex(0,1)*ZH21*(ZEL31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZEL32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZEL33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3662 = Coupling(name = 'GC_3662',
	 value = '-1*complex(0,1)*g2*UP11*(ZV11*complexconjugate(ZEL11) + ZV12*complexconjugate(ZEL12) + ZV13*complexconjugate(ZEL13))', 
	 order = {'QED':1} ) 
 
GC_3663 = Coupling(name = 'GC_3663',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZV12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZV13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3664 = Coupling(name = 'GC_3664',
	 value = '-1*complex(0,1)*g2*UP11*(ZV21*complexconjugate(ZEL11) + ZV22*complexconjugate(ZEL12) + ZV23*complexconjugate(ZEL13))', 
	 order = {'QED':1} ) 
 
GC_3665 = Coupling(name = 'GC_3665',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZV22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZV23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3666 = Coupling(name = 'GC_3666',
	 value = '-1*complex(0,1)*g2*UP11*(ZV31*complexconjugate(ZEL11) + ZV32*complexconjugate(ZEL12) + ZV33*complexconjugate(ZEL13))', 
	 order = {'QED':1} ) 
 
GC_3667 = Coupling(name = 'GC_3667',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZV32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZV33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3668 = Coupling(name = 'GC_3668',
	 value = '-1*complex(0,1)*g2*UP11*(ZV11*complexconjugate(ZEL21) + ZV12*complexconjugate(ZEL22) + ZV13*complexconjugate(ZEL23))', 
	 order = {'QED':1} ) 
 
GC_3669 = Coupling(name = 'GC_3669',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZV12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZV13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3670 = Coupling(name = 'GC_3670',
	 value = '-1*complex(0,1)*g2*UP11*(ZV21*complexconjugate(ZEL21) + ZV22*complexconjugate(ZEL22) + ZV23*complexconjugate(ZEL23))', 
	 order = {'QED':1} ) 
 
GC_3671 = Coupling(name = 'GC_3671',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZV22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZV23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3672 = Coupling(name = 'GC_3672',
	 value = '-1*complex(0,1)*g2*UP11*(ZV31*complexconjugate(ZEL21) + ZV32*complexconjugate(ZEL22) + ZV33*complexconjugate(ZEL23))', 
	 order = {'QED':1} ) 
 
GC_3673 = Coupling(name = 'GC_3673',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZV32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZV33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3674 = Coupling(name = 'GC_3674',
	 value = '-1*complex(0,1)*g2*UP11*(ZV11*complexconjugate(ZEL31) + ZV12*complexconjugate(ZEL32) + ZV13*complexconjugate(ZEL33))', 
	 order = {'QED':1} ) 
 
GC_3675 = Coupling(name = 'GC_3675',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZV12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZV13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3676 = Coupling(name = 'GC_3676',
	 value = '-1*complex(0,1)*g2*UP11*(ZV21*complexconjugate(ZEL31) + ZV22*complexconjugate(ZEL32) + ZV23*complexconjugate(ZEL33))', 
	 order = {'QED':1} ) 
 
GC_3677 = Coupling(name = 'GC_3677',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZV22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZV23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3678 = Coupling(name = 'GC_3678',
	 value = '-1*complex(0,1)*g2*UP11*(ZV31*complexconjugate(ZEL31) + ZV32*complexconjugate(ZEL32) + ZV33*complexconjugate(ZEL33))', 
	 order = {'QED':1} ) 
 
GC_3679 = Coupling(name = 'GC_3679',
	 value = '1*complex(0,1)*complexconjugate(UM12)*(ZV31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZV32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZV33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3680 = Coupling(name = 'GC_3680',
	 value = '-1*complex(0,1)*g2*UP21*(ZV11*complexconjugate(ZEL11) + ZV12*complexconjugate(ZEL12) + ZV13*complexconjugate(ZEL13))', 
	 order = {'QED':1} ) 
 
GC_3681 = Coupling(name = 'GC_3681',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZV12*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZV13*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3682 = Coupling(name = 'GC_3682',
	 value = '-1*complex(0,1)*g2*UP21*(ZV21*complexconjugate(ZEL11) + ZV22*complexconjugate(ZEL12) + ZV23*complexconjugate(ZEL13))', 
	 order = {'QED':1} ) 
 
GC_3683 = Coupling(name = 'GC_3683',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZV22*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZV23*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3684 = Coupling(name = 'GC_3684',
	 value = '-1*complex(0,1)*g2*UP21*(ZV31*complexconjugate(ZEL11) + ZV32*complexconjugate(ZEL12) + ZV33*complexconjugate(ZEL13))', 
	 order = {'QED':1} ) 
 
GC_3685 = Coupling(name = 'GC_3685',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV31*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31)) + ZV32*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32)) + ZV33*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3686 = Coupling(name = 'GC_3686',
	 value = '-1*complex(0,1)*g2*UP21*(ZV11*complexconjugate(ZEL21) + ZV12*complexconjugate(ZEL22) + ZV13*complexconjugate(ZEL23))', 
	 order = {'QED':1} ) 
 
GC_3687 = Coupling(name = 'GC_3687',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZV12*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZV13*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3688 = Coupling(name = 'GC_3688',
	 value = '-1*complex(0,1)*g2*UP21*(ZV21*complexconjugate(ZEL21) + ZV22*complexconjugate(ZEL22) + ZV23*complexconjugate(ZEL23))', 
	 order = {'QED':1} ) 
 
GC_3689 = Coupling(name = 'GC_3689',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZV22*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZV23*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3690 = Coupling(name = 'GC_3690',
	 value = '-1*complex(0,1)*g2*UP21*(ZV31*complexconjugate(ZEL21) + ZV32*complexconjugate(ZEL22) + ZV33*complexconjugate(ZEL23))', 
	 order = {'QED':1} ) 
 
GC_3691 = Coupling(name = 'GC_3691',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV31*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31)) + ZV32*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32)) + ZV33*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3692 = Coupling(name = 'GC_3692',
	 value = '-1*complex(0,1)*g2*UP21*(ZV11*complexconjugate(ZEL31) + ZV12*complexconjugate(ZEL32) + ZV13*complexconjugate(ZEL33))', 
	 order = {'QED':1} ) 
 
GC_3693 = Coupling(name = 'GC_3693',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZV12*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZV13*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3694 = Coupling(name = 'GC_3694',
	 value = '-1*complex(0,1)*g2*UP21*(ZV21*complexconjugate(ZEL31) + ZV22*complexconjugate(ZEL32) + ZV23*complexconjugate(ZEL33))', 
	 order = {'QED':1} ) 
 
GC_3695 = Coupling(name = 'GC_3695',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZV22*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZV23*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3696 = Coupling(name = 'GC_3696',
	 value = '-1*complex(0,1)*g2*UP21*(ZV31*complexconjugate(ZEL31) + ZV32*complexconjugate(ZEL32) + ZV33*complexconjugate(ZEL33))', 
	 order = {'QED':1} ) 
 
GC_3697 = Coupling(name = 'GC_3697',
	 value = '1*complex(0,1)*complexconjugate(UM22)*(ZV31*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31)) + ZV32*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32)) + ZV33*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33)))', 
	 order = {'QED':1} ) 
 
GC_3698 = Coupling(name = 'GC_3698',
	 value = '1*complex(0,1)*ZP11*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31))', 
	 order = {'QED':1} ) 
 
GC_3699 = Coupling(name = 'GC_3699',
	 value = '1*complex(0,1)*ZP21*(ZER11*complexconjugate(Ye11) + ZER12*complexconjugate(Ye21) + ZER13*complexconjugate(Ye31))', 
	 order = {'QED':1} ) 
 
GC_3700 = Coupling(name = 'GC_3700',
	 value = '1*complex(0,1)*ZP11*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31))', 
	 order = {'QED':1} ) 
 
GC_3701 = Coupling(name = 'GC_3701',
	 value = '1*complex(0,1)*ZP21*(ZER21*complexconjugate(Ye11) + ZER22*complexconjugate(Ye21) + ZER23*complexconjugate(Ye31))', 
	 order = {'QED':1} ) 
 
GC_3702 = Coupling(name = 'GC_3702',
	 value = '1*complex(0,1)*ZP11*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31))', 
	 order = {'QED':1} ) 
 
GC_3703 = Coupling(name = 'GC_3703',
	 value = '1*complex(0,1)*ZP21*(ZER31*complexconjugate(Ye11) + ZER32*complexconjugate(Ye21) + ZER33*complexconjugate(Ye31))', 
	 order = {'QED':1} ) 
 
GC_3704 = Coupling(name = 'GC_3704',
	 value = '1*complex(0,1)*ZP11*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32))', 
	 order = {'QED':1} ) 
 
GC_3705 = Coupling(name = 'GC_3705',
	 value = '1*complex(0,1)*ZP21*(ZER11*complexconjugate(Ye12) + ZER12*complexconjugate(Ye22) + ZER13*complexconjugate(Ye32))', 
	 order = {'QED':1} ) 
 
GC_3706 = Coupling(name = 'GC_3706',
	 value = '1*complex(0,1)*ZP11*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32))', 
	 order = {'QED':1} ) 
 
GC_3707 = Coupling(name = 'GC_3707',
	 value = '1*complex(0,1)*ZP21*(ZER21*complexconjugate(Ye12) + ZER22*complexconjugate(Ye22) + ZER23*complexconjugate(Ye32))', 
	 order = {'QED':1} ) 
 
GC_3708 = Coupling(name = 'GC_3708',
	 value = '1*complex(0,1)*ZP11*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32))', 
	 order = {'QED':1} ) 
 
GC_3709 = Coupling(name = 'GC_3709',
	 value = '1*complex(0,1)*ZP21*(ZER31*complexconjugate(Ye12) + ZER32*complexconjugate(Ye22) + ZER33*complexconjugate(Ye32))', 
	 order = {'QED':1} ) 
 
GC_3710 = Coupling(name = 'GC_3710',
	 value = '1*complex(0,1)*ZP11*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))', 
	 order = {'QED':1} ) 
 
GC_3711 = Coupling(name = 'GC_3711',
	 value = '1*complex(0,1)*ZP21*(ZER11*complexconjugate(Ye13) + ZER12*complexconjugate(Ye23) + ZER13*complexconjugate(Ye33))', 
	 order = {'QED':1} ) 
 
GC_3712 = Coupling(name = 'GC_3712',
	 value = '1*complex(0,1)*ZP11*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))', 
	 order = {'QED':1} ) 
 
GC_3713 = Coupling(name = 'GC_3713',
	 value = '1*complex(0,1)*ZP21*(ZER21*complexconjugate(Ye13) + ZER22*complexconjugate(Ye23) + ZER23*complexconjugate(Ye33))', 
	 order = {'QED':1} ) 
 
GC_3714 = Coupling(name = 'GC_3714',
	 value = '1*complex(0,1)*ZP11*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))', 
	 order = {'QED':1} ) 
 
GC_3715 = Coupling(name = 'GC_3715',
	 value = '1*complex(0,1)*ZP21*(ZER31*complexconjugate(Ye13) + ZER32*complexconjugate(Ye23) + ZER33*complexconjugate(Ye33))', 
	 order = {'QED':1} ) 
 
GC_3716 = Coupling(name = 'GC_3716',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU11*complexconjugate(ZUL11) + ZU12*complexconjugate(ZUL12) + ZU13*complexconjugate(ZUL13))', 
	 order = {'QCD':1} ) 
 
GC_3717 = Coupling(name = 'GC_3717',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU14*ZUR11 + ZU15*ZUR12 + ZU16*ZUR13)', 
	 order = {'QCD':1} ) 
 
GC_3718 = Coupling(name = 'GC_3718',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU21*complexconjugate(ZUL11) + ZU22*complexconjugate(ZUL12) + ZU23*complexconjugate(ZUL13))', 
	 order = {'QCD':1} ) 
 
GC_3719 = Coupling(name = 'GC_3719',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU24*ZUR11 + ZU25*ZUR12 + ZU26*ZUR13)', 
	 order = {'QCD':1} ) 
 
GC_3720 = Coupling(name = 'GC_3720',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU31*complexconjugate(ZUL11) + ZU32*complexconjugate(ZUL12) + ZU33*complexconjugate(ZUL13))', 
	 order = {'QCD':1} ) 
 
GC_3721 = Coupling(name = 'GC_3721',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU34*ZUR11 + ZU35*ZUR12 + ZU36*ZUR13)', 
	 order = {'QCD':1} ) 
 
GC_3722 = Coupling(name = 'GC_3722',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU41*complexconjugate(ZUL11) + ZU42*complexconjugate(ZUL12) + ZU43*complexconjugate(ZUL13))', 
	 order = {'QCD':1} ) 
 
GC_3723 = Coupling(name = 'GC_3723',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU44*ZUR11 + ZU45*ZUR12 + ZU46*ZUR13)', 
	 order = {'QCD':1} ) 
 
GC_3724 = Coupling(name = 'GC_3724',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU51*complexconjugate(ZUL11) + ZU52*complexconjugate(ZUL12) + ZU53*complexconjugate(ZUL13))', 
	 order = {'QCD':1} ) 
 
GC_3725 = Coupling(name = 'GC_3725',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU54*ZUR11 + ZU55*ZUR12 + ZU56*ZUR13)', 
	 order = {'QCD':1} ) 
 
GC_3726 = Coupling(name = 'GC_3726',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU61*complexconjugate(ZUL11) + ZU62*complexconjugate(ZUL12) + ZU63*complexconjugate(ZUL13))', 
	 order = {'QCD':1} ) 
 
GC_3727 = Coupling(name = 'GC_3727',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU64*ZUR11 + ZU65*ZUR12 + ZU66*ZUR13)', 
	 order = {'QCD':1} ) 
 
GC_3728 = Coupling(name = 'GC_3728',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU11*complexconjugate(ZUL21) + ZU12*complexconjugate(ZUL22) + ZU13*complexconjugate(ZUL23))', 
	 order = {'QCD':1} ) 
 
GC_3729 = Coupling(name = 'GC_3729',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU14*ZUR21 + ZU15*ZUR22 + ZU16*ZUR23)', 
	 order = {'QCD':1} ) 
 
GC_3730 = Coupling(name = 'GC_3730',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU21*complexconjugate(ZUL21) + ZU22*complexconjugate(ZUL22) + ZU23*complexconjugate(ZUL23))', 
	 order = {'QCD':1} ) 
 
GC_3731 = Coupling(name = 'GC_3731',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU24*ZUR21 + ZU25*ZUR22 + ZU26*ZUR23)', 
	 order = {'QCD':1} ) 
 
GC_3732 = Coupling(name = 'GC_3732',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU31*complexconjugate(ZUL21) + ZU32*complexconjugate(ZUL22) + ZU33*complexconjugate(ZUL23))', 
	 order = {'QCD':1} ) 
 
GC_3733 = Coupling(name = 'GC_3733',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU34*ZUR21 + ZU35*ZUR22 + ZU36*ZUR23)', 
	 order = {'QCD':1} ) 
 
GC_3734 = Coupling(name = 'GC_3734',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU41*complexconjugate(ZUL21) + ZU42*complexconjugate(ZUL22) + ZU43*complexconjugate(ZUL23))', 
	 order = {'QCD':1} ) 
 
GC_3735 = Coupling(name = 'GC_3735',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU44*ZUR21 + ZU45*ZUR22 + ZU46*ZUR23)', 
	 order = {'QCD':1} ) 
 
GC_3736 = Coupling(name = 'GC_3736',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU51*complexconjugate(ZUL21) + ZU52*complexconjugate(ZUL22) + ZU53*complexconjugate(ZUL23))', 
	 order = {'QCD':1} ) 
 
GC_3737 = Coupling(name = 'GC_3737',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU54*ZUR21 + ZU55*ZUR22 + ZU56*ZUR23)', 
	 order = {'QCD':1} ) 
 
GC_3738 = Coupling(name = 'GC_3738',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU61*complexconjugate(ZUL21) + ZU62*complexconjugate(ZUL22) + ZU63*complexconjugate(ZUL23))', 
	 order = {'QCD':1} ) 
 
GC_3739 = Coupling(name = 'GC_3739',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU64*ZUR21 + ZU65*ZUR22 + ZU66*ZUR23)', 
	 order = {'QCD':1} ) 
 
GC_3740 = Coupling(name = 'GC_3740',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU11*complexconjugate(ZUL31) + ZU12*complexconjugate(ZUL32) + ZU13*complexconjugate(ZUL33))', 
	 order = {'QCD':1} ) 
 
GC_3741 = Coupling(name = 'GC_3741',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU14*ZUR31 + ZU15*ZUR32 + ZU16*ZUR33)', 
	 order = {'QCD':1} ) 
 
GC_3742 = Coupling(name = 'GC_3742',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU21*complexconjugate(ZUL31) + ZU22*complexconjugate(ZUL32) + ZU23*complexconjugate(ZUL33))', 
	 order = {'QCD':1} ) 
 
GC_3743 = Coupling(name = 'GC_3743',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU24*ZUR31 + ZU25*ZUR32 + ZU26*ZUR33)', 
	 order = {'QCD':1} ) 
 
GC_3744 = Coupling(name = 'GC_3744',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU31*complexconjugate(ZUL31) + ZU32*complexconjugate(ZUL32) + ZU33*complexconjugate(ZUL33))', 
	 order = {'QCD':1} ) 
 
GC_3745 = Coupling(name = 'GC_3745',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU34*ZUR31 + ZU35*ZUR32 + ZU36*ZUR33)', 
	 order = {'QCD':1} ) 
 
GC_3746 = Coupling(name = 'GC_3746',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU41*complexconjugate(ZUL31) + ZU42*complexconjugate(ZUL32) + ZU43*complexconjugate(ZUL33))', 
	 order = {'QCD':1} ) 
 
GC_3747 = Coupling(name = 'GC_3747',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU44*ZUR31 + ZU45*ZUR32 + ZU46*ZUR33)', 
	 order = {'QCD':1} ) 
 
GC_3748 = Coupling(name = 'GC_3748',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU51*complexconjugate(ZUL31) + ZU52*complexconjugate(ZUL32) + ZU53*complexconjugate(ZUL33))', 
	 order = {'QCD':1} ) 
 
GC_3749 = Coupling(name = 'GC_3749',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU54*ZUR31 + ZU55*ZUR32 + ZU56*ZUR33)', 
	 order = {'QCD':1} ) 
 
GC_3750 = Coupling(name = 'GC_3750',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(ZU61*complexconjugate(ZUL31) + ZU62*complexconjugate(ZUL32) + ZU63*complexconjugate(ZUL33))', 
	 order = {'QCD':1} ) 
 
GC_3751 = Coupling(name = 'GC_3751',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZU64*ZUR31 + ZU65*ZUR32 + ZU66*ZUR33)', 
	 order = {'QCD':1} ) 
 
GC_3752 = Coupling(name = 'GC_3752',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3753 = Coupling(name = 'GC_3753',
	 value = '(-1*complex(0,1)*ZH12*(ZUL11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3754 = Coupling(name = 'GC_3754',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3755 = Coupling(name = 'GC_3755',
	 value = '(-1*complex(0,1)*ZH22*(ZUL11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3756 = Coupling(name = 'GC_3756',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3757 = Coupling(name = 'GC_3757',
	 value = '(-1*complex(0,1)*ZH12*(ZUL11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3758 = Coupling(name = 'GC_3758',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3759 = Coupling(name = 'GC_3759',
	 value = '(-1*complex(0,1)*ZH22*(ZUL11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3760 = Coupling(name = 'GC_3760',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3761 = Coupling(name = 'GC_3761',
	 value = '(-1*complex(0,1)*ZH12*(ZUL11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3762 = Coupling(name = 'GC_3762',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3763 = Coupling(name = 'GC_3763',
	 value = '(-1*complex(0,1)*ZH22*(ZUL11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3764 = Coupling(name = 'GC_3764',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3765 = Coupling(name = 'GC_3765',
	 value = '(-1*complex(0,1)*ZH12*(ZUL21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3766 = Coupling(name = 'GC_3766',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3767 = Coupling(name = 'GC_3767',
	 value = '(-1*complex(0,1)*ZH22*(ZUL21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3768 = Coupling(name = 'GC_3768',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3769 = Coupling(name = 'GC_3769',
	 value = '(-1*complex(0,1)*ZH12*(ZUL21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3770 = Coupling(name = 'GC_3770',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3771 = Coupling(name = 'GC_3771',
	 value = '(-1*complex(0,1)*ZH22*(ZUL21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3772 = Coupling(name = 'GC_3772',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3773 = Coupling(name = 'GC_3773',
	 value = '(-1*complex(0,1)*ZH12*(ZUL21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3774 = Coupling(name = 'GC_3774',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3775 = Coupling(name = 'GC_3775',
	 value = '(-1*complex(0,1)*ZH22*(ZUL21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3776 = Coupling(name = 'GC_3776',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3777 = Coupling(name = 'GC_3777',
	 value = '(-1*complex(0,1)*ZH12*(ZUL31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3778 = Coupling(name = 'GC_3778',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3779 = Coupling(name = 'GC_3779',
	 value = '(-1*complex(0,1)*ZH22*(ZUL31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZUL32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZUL33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3780 = Coupling(name = 'GC_3780',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3781 = Coupling(name = 'GC_3781',
	 value = '(-1*complex(0,1)*ZH12*(ZUL31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3782 = Coupling(name = 'GC_3782',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3783 = Coupling(name = 'GC_3783',
	 value = '(-1*complex(0,1)*ZH22*(ZUL31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZUL32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZUL33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3784 = Coupling(name = 'GC_3784',
	 value = '(-1*complex(0,1)*ZH12*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3785 = Coupling(name = 'GC_3785',
	 value = '(-1*complex(0,1)*ZH12*(ZUL31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3786 = Coupling(name = 'GC_3786',
	 value = '(-1*complex(0,1)*ZH22*(complexconjugate(ZUL31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZUL32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZUL33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3787 = Coupling(name = 'GC_3787',
	 value = '(-1*complex(0,1)*ZH22*(ZUL31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZUL32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZUL33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33))))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_3788 = Coupling(name = 'GC_3788',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZUL11) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZUL12) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZUL13))', 
	 order = {'QED':1} ) 
 
GC_3789 = Coupling(name = 'GC_3789',
	 value = '1*complex(0,1)*ZP12*(ZDL11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZDL12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZDL13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3790 = Coupling(name = 'GC_3790',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZUL11) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZUL12) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZUL13))', 
	 order = {'QED':1} ) 
 
GC_3791 = Coupling(name = 'GC_3791',
	 value = '1*complex(0,1)*ZP22*(ZDL11*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZDL12*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZDL13*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3792 = Coupling(name = 'GC_3792',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZUL21) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZUL22) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZUL23))', 
	 order = {'QED':1} ) 
 
GC_3793 = Coupling(name = 'GC_3793',
	 value = '1*complex(0,1)*ZP12*(ZDL11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZDL12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZDL13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3794 = Coupling(name = 'GC_3794',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZUL21) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZUL22) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZUL23))', 
	 order = {'QED':1} ) 
 
GC_3795 = Coupling(name = 'GC_3795',
	 value = '1*complex(0,1)*ZP22*(ZDL11*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZDL12*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZDL13*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3796 = Coupling(name = 'GC_3796',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZUL31) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZUL32) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZUL33))', 
	 order = {'QED':1} ) 
 
GC_3797 = Coupling(name = 'GC_3797',
	 value = '1*complex(0,1)*ZP12*(ZDL11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZDL12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZDL13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3798 = Coupling(name = 'GC_3798',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR11) + Yd21*complexconjugate(ZDR12) + Yd31*complexconjugate(ZDR13))*complexconjugate(ZUL31) + (Yd12*complexconjugate(ZDR11) + Yd22*complexconjugate(ZDR12) + Yd32*complexconjugate(ZDR13))*complexconjugate(ZUL32) + (Yd13*complexconjugate(ZDR11) + Yd23*complexconjugate(ZDR12) + Yd33*complexconjugate(ZDR13))*complexconjugate(ZUL33))', 
	 order = {'QED':1} ) 
 
GC_3799 = Coupling(name = 'GC_3799',
	 value = '1*complex(0,1)*ZP22*(ZDL11*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZDL12*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZDL13*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3800 = Coupling(name = 'GC_3800',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZUL11) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZUL12) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZUL13))', 
	 order = {'QED':1} ) 
 
GC_3801 = Coupling(name = 'GC_3801',
	 value = '1*complex(0,1)*ZP12*(ZDL21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZDL22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZDL23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3802 = Coupling(name = 'GC_3802',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZUL11) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZUL12) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZUL13))', 
	 order = {'QED':1} ) 
 
GC_3803 = Coupling(name = 'GC_3803',
	 value = '1*complex(0,1)*ZP22*(ZDL21*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZDL22*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZDL23*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3804 = Coupling(name = 'GC_3804',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZUL21) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZUL22) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZUL23))', 
	 order = {'QED':1} ) 
 
GC_3805 = Coupling(name = 'GC_3805',
	 value = '1*complex(0,1)*ZP12*(ZDL21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZDL22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZDL23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3806 = Coupling(name = 'GC_3806',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZUL21) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZUL22) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZUL23))', 
	 order = {'QED':1} ) 
 
GC_3807 = Coupling(name = 'GC_3807',
	 value = '1*complex(0,1)*ZP22*(ZDL21*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZDL22*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZDL23*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3808 = Coupling(name = 'GC_3808',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZUL31) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZUL32) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZUL33))', 
	 order = {'QED':1} ) 
 
GC_3809 = Coupling(name = 'GC_3809',
	 value = '1*complex(0,1)*ZP12*(ZDL21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZDL22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZDL23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3810 = Coupling(name = 'GC_3810',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR21) + Yd21*complexconjugate(ZDR22) + Yd31*complexconjugate(ZDR23))*complexconjugate(ZUL31) + (Yd12*complexconjugate(ZDR21) + Yd22*complexconjugate(ZDR22) + Yd32*complexconjugate(ZDR23))*complexconjugate(ZUL32) + (Yd13*complexconjugate(ZDR21) + Yd23*complexconjugate(ZDR22) + Yd33*complexconjugate(ZDR23))*complexconjugate(ZUL33))', 
	 order = {'QED':1} ) 
 
GC_3811 = Coupling(name = 'GC_3811',
	 value = '1*complex(0,1)*ZP22*(ZDL21*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZDL22*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZDL23*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3812 = Coupling(name = 'GC_3812',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZUL11) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZUL12) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZUL13))', 
	 order = {'QED':1} ) 
 
GC_3813 = Coupling(name = 'GC_3813',
	 value = '1*complex(0,1)*ZP12*(ZDL31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZDL32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZDL33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3814 = Coupling(name = 'GC_3814',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZUL11) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZUL12) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZUL13))', 
	 order = {'QED':1} ) 
 
GC_3815 = Coupling(name = 'GC_3815',
	 value = '1*complex(0,1)*ZP22*(ZDL31*(ZUR11*complexconjugate(Yu11) + ZUR12*complexconjugate(Yu21) + ZUR13*complexconjugate(Yu31)) + ZDL32*(ZUR11*complexconjugate(Yu12) + ZUR12*complexconjugate(Yu22) + ZUR13*complexconjugate(Yu32)) + ZDL33*(ZUR11*complexconjugate(Yu13) + ZUR12*complexconjugate(Yu23) + ZUR13*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3816 = Coupling(name = 'GC_3816',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZUL21) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZUL22) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZUL23))', 
	 order = {'QED':1} ) 
 
GC_3817 = Coupling(name = 'GC_3817',
	 value = '1*complex(0,1)*ZP12*(ZDL31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZDL32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZDL33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3818 = Coupling(name = 'GC_3818',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZUL21) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZUL22) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZUL23))', 
	 order = {'QED':1} ) 
 
GC_3819 = Coupling(name = 'GC_3819',
	 value = '1*complex(0,1)*ZP22*(ZDL31*(ZUR21*complexconjugate(Yu11) + ZUR22*complexconjugate(Yu21) + ZUR23*complexconjugate(Yu31)) + ZDL32*(ZUR21*complexconjugate(Yu12) + ZUR22*complexconjugate(Yu22) + ZUR23*complexconjugate(Yu32)) + ZDL33*(ZUR21*complexconjugate(Yu13) + ZUR22*complexconjugate(Yu23) + ZUR23*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3820 = Coupling(name = 'GC_3820',
	 value = '1*complex(0,1)*ZP11*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZUL31) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZUL32) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZUL33))', 
	 order = {'QED':1} ) 
 
GC_3821 = Coupling(name = 'GC_3821',
	 value = '1*complex(0,1)*ZP12*(ZDL31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZDL32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZDL33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3822 = Coupling(name = 'GC_3822',
	 value = '1*complex(0,1)*ZP21*((Yd11*complexconjugate(ZDR31) + Yd21*complexconjugate(ZDR32) + Yd31*complexconjugate(ZDR33))*complexconjugate(ZUL31) + (Yd12*complexconjugate(ZDR31) + Yd22*complexconjugate(ZDR32) + Yd32*complexconjugate(ZDR33))*complexconjugate(ZUL32) + (Yd13*complexconjugate(ZDR31) + Yd23*complexconjugate(ZDR32) + Yd33*complexconjugate(ZDR33))*complexconjugate(ZUL33))', 
	 order = {'QED':1} ) 
 
GC_3823 = Coupling(name = 'GC_3823',
	 value = '1*complex(0,1)*ZP22*(ZDL31*(ZUR31*complexconjugate(Yu11) + ZUR32*complexconjugate(Yu21) + ZUR33*complexconjugate(Yu31)) + ZDL32*(ZUR31*complexconjugate(Yu12) + ZUR32*complexconjugate(Yu22) + ZUR33*complexconjugate(Yu32)) + ZDL33*(ZUR31*complexconjugate(Yu13) + ZUR32*complexconjugate(Yu23) + ZUR33*complexconjugate(Yu33)))', 
	 order = {'QED':1} ) 
 
GC_3824 = Coupling(name = 'GC_3824',
	 value = '1*complex(0,1)*ZP11*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))', 
	 order = {'QED':1} ) 
 
GC_3825 = Coupling(name = 'GC_3825',
	 value = '1*complex(0,1)*ZP21*(Ye11*complexconjugate(ZER11) + Ye21*complexconjugate(ZER12) + Ye31*complexconjugate(ZER13))', 
	 order = {'QED':1} ) 
 
GC_3826 = Coupling(name = 'GC_3826',
	 value = '1*complex(0,1)*ZP11*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))', 
	 order = {'QED':1} ) 
 
GC_3827 = Coupling(name = 'GC_3827',
	 value = '1*complex(0,1)*ZP21*(Ye12*complexconjugate(ZER11) + Ye22*complexconjugate(ZER12) + Ye32*complexconjugate(ZER13))', 
	 order = {'QED':1} ) 
 
GC_3828 = Coupling(name = 'GC_3828',
	 value = '1*complex(0,1)*ZP11*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))', 
	 order = {'QED':1} ) 
 
GC_3829 = Coupling(name = 'GC_3829',
	 value = '1*complex(0,1)*ZP21*(Ye13*complexconjugate(ZER11) + Ye23*complexconjugate(ZER12) + Ye33*complexconjugate(ZER13))', 
	 order = {'QED':1} ) 
 
GC_3830 = Coupling(name = 'GC_3830',
	 value = '1*complex(0,1)*ZP11*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))', 
	 order = {'QED':1} ) 
 
GC_3831 = Coupling(name = 'GC_3831',
	 value = '1*complex(0,1)*ZP21*(Ye11*complexconjugate(ZER21) + Ye21*complexconjugate(ZER22) + Ye31*complexconjugate(ZER23))', 
	 order = {'QED':1} ) 
 
GC_3832 = Coupling(name = 'GC_3832',
	 value = '1*complex(0,1)*ZP11*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))', 
	 order = {'QED':1} ) 
 
GC_3833 = Coupling(name = 'GC_3833',
	 value = '1*complex(0,1)*ZP21*(Ye12*complexconjugate(ZER21) + Ye22*complexconjugate(ZER22) + Ye32*complexconjugate(ZER23))', 
	 order = {'QED':1} ) 
 
GC_3834 = Coupling(name = 'GC_3834',
	 value = '1*complex(0,1)*ZP11*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))', 
	 order = {'QED':1} ) 
 
GC_3835 = Coupling(name = 'GC_3835',
	 value = '1*complex(0,1)*ZP21*(Ye13*complexconjugate(ZER21) + Ye23*complexconjugate(ZER22) + Ye33*complexconjugate(ZER23))', 
	 order = {'QED':1} ) 
 
GC_3836 = Coupling(name = 'GC_3836',
	 value = '1*complex(0,1)*ZP11*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))', 
	 order = {'QED':1} ) 
 
GC_3837 = Coupling(name = 'GC_3837',
	 value = '1*complex(0,1)*ZP21*(Ye11*complexconjugate(ZER31) + Ye21*complexconjugate(ZER32) + Ye31*complexconjugate(ZER33))', 
	 order = {'QED':1} ) 
 
GC_3838 = Coupling(name = 'GC_3838',
	 value = '1*complex(0,1)*ZP11*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))', 
	 order = {'QED':1} ) 
 
GC_3839 = Coupling(name = 'GC_3839',
	 value = '1*complex(0,1)*ZP21*(Ye12*complexconjugate(ZER31) + Ye22*complexconjugate(ZER32) + Ye32*complexconjugate(ZER33))', 
	 order = {'QED':1} ) 
 
GC_3840 = Coupling(name = 'GC_3840',
	 value = '1*complex(0,1)*ZP11*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))', 
	 order = {'QED':1} ) 
 
GC_3841 = Coupling(name = 'GC_3841',
	 value = '1*complex(0,1)*ZP21*(Ye13*complexconjugate(ZER31) + Ye23*complexconjugate(ZER32) + Ye33*complexconjugate(ZER33))', 
	 order = {'QED':1} ) 
 
GC_3842 = Coupling(name = 'GC_3842',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD14)*complexconjugate(ZDR11) + complexconjugate(ZD15)*complexconjugate(ZDR12) + complexconjugate(ZD16)*complexconjugate(ZDR13))', 
	 order = {'QCD':1} ) 
 
GC_3843 = Coupling(name = 'GC_3843',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL11*complexconjugate(ZD11) + ZDL12*complexconjugate(ZD12) + ZDL13*complexconjugate(ZD13))', 
	 order = {'QCD':1} ) 
 
GC_3844 = Coupling(name = 'GC_3844',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD24)*complexconjugate(ZDR11) + complexconjugate(ZD25)*complexconjugate(ZDR12) + complexconjugate(ZD26)*complexconjugate(ZDR13))', 
	 order = {'QCD':1} ) 
 
GC_3845 = Coupling(name = 'GC_3845',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL11*complexconjugate(ZD21) + ZDL12*complexconjugate(ZD22) + ZDL13*complexconjugate(ZD23))', 
	 order = {'QCD':1} ) 
 
GC_3846 = Coupling(name = 'GC_3846',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD34)*complexconjugate(ZDR11) + complexconjugate(ZD35)*complexconjugate(ZDR12) + complexconjugate(ZD36)*complexconjugate(ZDR13))', 
	 order = {'QCD':1} ) 
 
GC_3847 = Coupling(name = 'GC_3847',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL11*complexconjugate(ZD31) + ZDL12*complexconjugate(ZD32) + ZDL13*complexconjugate(ZD33))', 
	 order = {'QCD':1} ) 
 
GC_3848 = Coupling(name = 'GC_3848',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD44)*complexconjugate(ZDR11) + complexconjugate(ZD45)*complexconjugate(ZDR12) + complexconjugate(ZD46)*complexconjugate(ZDR13))', 
	 order = {'QCD':1} ) 
 
GC_3849 = Coupling(name = 'GC_3849',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL11*complexconjugate(ZD41) + ZDL12*complexconjugate(ZD42) + ZDL13*complexconjugate(ZD43))', 
	 order = {'QCD':1} ) 
 
GC_3850 = Coupling(name = 'GC_3850',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD54)*complexconjugate(ZDR11) + complexconjugate(ZD55)*complexconjugate(ZDR12) + complexconjugate(ZD56)*complexconjugate(ZDR13))', 
	 order = {'QCD':1} ) 
 
GC_3851 = Coupling(name = 'GC_3851',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL11*complexconjugate(ZD51) + ZDL12*complexconjugate(ZD52) + ZDL13*complexconjugate(ZD53))', 
	 order = {'QCD':1} ) 
 
GC_3852 = Coupling(name = 'GC_3852',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD64)*complexconjugate(ZDR11) + complexconjugate(ZD65)*complexconjugate(ZDR12) + complexconjugate(ZD66)*complexconjugate(ZDR13))', 
	 order = {'QCD':1} ) 
 
GC_3853 = Coupling(name = 'GC_3853',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL11*complexconjugate(ZD61) + ZDL12*complexconjugate(ZD62) + ZDL13*complexconjugate(ZD63))', 
	 order = {'QCD':1} ) 
 
GC_3854 = Coupling(name = 'GC_3854',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD14)*complexconjugate(ZDR21) + complexconjugate(ZD15)*complexconjugate(ZDR22) + complexconjugate(ZD16)*complexconjugate(ZDR23))', 
	 order = {'QCD':1} ) 
 
GC_3855 = Coupling(name = 'GC_3855',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL21*complexconjugate(ZD11) + ZDL22*complexconjugate(ZD12) + ZDL23*complexconjugate(ZD13))', 
	 order = {'QCD':1} ) 
 
GC_3856 = Coupling(name = 'GC_3856',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD24)*complexconjugate(ZDR21) + complexconjugate(ZD25)*complexconjugate(ZDR22) + complexconjugate(ZD26)*complexconjugate(ZDR23))', 
	 order = {'QCD':1} ) 
 
GC_3857 = Coupling(name = 'GC_3857',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL21*complexconjugate(ZD21) + ZDL22*complexconjugate(ZD22) + ZDL23*complexconjugate(ZD23))', 
	 order = {'QCD':1} ) 
 
GC_3858 = Coupling(name = 'GC_3858',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD34)*complexconjugate(ZDR21) + complexconjugate(ZD35)*complexconjugate(ZDR22) + complexconjugate(ZD36)*complexconjugate(ZDR23))', 
	 order = {'QCD':1} ) 
 
GC_3859 = Coupling(name = 'GC_3859',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL21*complexconjugate(ZD31) + ZDL22*complexconjugate(ZD32) + ZDL23*complexconjugate(ZD33))', 
	 order = {'QCD':1} ) 
 
GC_3860 = Coupling(name = 'GC_3860',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD44)*complexconjugate(ZDR21) + complexconjugate(ZD45)*complexconjugate(ZDR22) + complexconjugate(ZD46)*complexconjugate(ZDR23))', 
	 order = {'QCD':1} ) 
 
GC_3861 = Coupling(name = 'GC_3861',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL21*complexconjugate(ZD41) + ZDL22*complexconjugate(ZD42) + ZDL23*complexconjugate(ZD43))', 
	 order = {'QCD':1} ) 
 
GC_3862 = Coupling(name = 'GC_3862',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD54)*complexconjugate(ZDR21) + complexconjugate(ZD55)*complexconjugate(ZDR22) + complexconjugate(ZD56)*complexconjugate(ZDR23))', 
	 order = {'QCD':1} ) 
 
GC_3863 = Coupling(name = 'GC_3863',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL21*complexconjugate(ZD51) + ZDL22*complexconjugate(ZD52) + ZDL23*complexconjugate(ZD53))', 
	 order = {'QCD':1} ) 
 
GC_3864 = Coupling(name = 'GC_3864',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD64)*complexconjugate(ZDR21) + complexconjugate(ZD65)*complexconjugate(ZDR22) + complexconjugate(ZD66)*complexconjugate(ZDR23))', 
	 order = {'QCD':1} ) 
 
GC_3865 = Coupling(name = 'GC_3865',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL21*complexconjugate(ZD61) + ZDL22*complexconjugate(ZD62) + ZDL23*complexconjugate(ZD63))', 
	 order = {'QCD':1} ) 
 
GC_3866 = Coupling(name = 'GC_3866',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD14)*complexconjugate(ZDR31) + complexconjugate(ZD15)*complexconjugate(ZDR32) + complexconjugate(ZD16)*complexconjugate(ZDR33))', 
	 order = {'QCD':1} ) 
 
GC_3867 = Coupling(name = 'GC_3867',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL31*complexconjugate(ZD11) + ZDL32*complexconjugate(ZD12) + ZDL33*complexconjugate(ZD13))', 
	 order = {'QCD':1} ) 
 
GC_3868 = Coupling(name = 'GC_3868',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD24)*complexconjugate(ZDR31) + complexconjugate(ZD25)*complexconjugate(ZDR32) + complexconjugate(ZD26)*complexconjugate(ZDR33))', 
	 order = {'QCD':1} ) 
 
GC_3869 = Coupling(name = 'GC_3869',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL31*complexconjugate(ZD21) + ZDL32*complexconjugate(ZD22) + ZDL33*complexconjugate(ZD23))', 
	 order = {'QCD':1} ) 
 
GC_3870 = Coupling(name = 'GC_3870',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD34)*complexconjugate(ZDR31) + complexconjugate(ZD35)*complexconjugate(ZDR32) + complexconjugate(ZD36)*complexconjugate(ZDR33))', 
	 order = {'QCD':1} ) 
 
GC_3871 = Coupling(name = 'GC_3871',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL31*complexconjugate(ZD31) + ZDL32*complexconjugate(ZD32) + ZDL33*complexconjugate(ZD33))', 
	 order = {'QCD':1} ) 
 
GC_3872 = Coupling(name = 'GC_3872',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD44)*complexconjugate(ZDR31) + complexconjugate(ZD45)*complexconjugate(ZDR32) + complexconjugate(ZD46)*complexconjugate(ZDR33))', 
	 order = {'QCD':1} ) 
 
GC_3873 = Coupling(name = 'GC_3873',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL31*complexconjugate(ZD41) + ZDL32*complexconjugate(ZD42) + ZDL33*complexconjugate(ZD43))', 
	 order = {'QCD':1} ) 
 
GC_3874 = Coupling(name = 'GC_3874',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD54)*complexconjugate(ZDR31) + complexconjugate(ZD55)*complexconjugate(ZDR32) + complexconjugate(ZD56)*complexconjugate(ZDR33))', 
	 order = {'QCD':1} ) 
 
GC_3875 = Coupling(name = 'GC_3875',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL31*complexconjugate(ZD51) + ZDL32*complexconjugate(ZD52) + ZDL33*complexconjugate(ZD53))', 
	 order = {'QCD':1} ) 
 
GC_3876 = Coupling(name = 'GC_3876',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZD64)*complexconjugate(ZDR31) + complexconjugate(ZD65)*complexconjugate(ZDR32) + complexconjugate(ZD66)*complexconjugate(ZDR33))', 
	 order = {'QCD':1} ) 
 
GC_3877 = Coupling(name = 'GC_3877',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZDL31*complexconjugate(ZD61) + ZDL32*complexconjugate(ZD62) + ZDL33*complexconjugate(ZD63))', 
	 order = {'QCD':1} ) 
 
GC_3878 = Coupling(name = 'GC_3878',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU14)*complexconjugate(ZUR11) + complexconjugate(ZU15)*complexconjugate(ZUR12) + complexconjugate(ZU16)*complexconjugate(ZUR13))', 
	 order = {'QCD':1} ) 
 
GC_3879 = Coupling(name = 'GC_3879',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL11*complexconjugate(ZU11) + ZUL12*complexconjugate(ZU12) + ZUL13*complexconjugate(ZU13))', 
	 order = {'QCD':1} ) 
 
GC_3880 = Coupling(name = 'GC_3880',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU24)*complexconjugate(ZUR11) + complexconjugate(ZU25)*complexconjugate(ZUR12) + complexconjugate(ZU26)*complexconjugate(ZUR13))', 
	 order = {'QCD':1} ) 
 
GC_3881 = Coupling(name = 'GC_3881',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL11*complexconjugate(ZU21) + ZUL12*complexconjugate(ZU22) + ZUL13*complexconjugate(ZU23))', 
	 order = {'QCD':1} ) 
 
GC_3882 = Coupling(name = 'GC_3882',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU34)*complexconjugate(ZUR11) + complexconjugate(ZU35)*complexconjugate(ZUR12) + complexconjugate(ZU36)*complexconjugate(ZUR13))', 
	 order = {'QCD':1} ) 
 
GC_3883 = Coupling(name = 'GC_3883',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL11*complexconjugate(ZU31) + ZUL12*complexconjugate(ZU32) + ZUL13*complexconjugate(ZU33))', 
	 order = {'QCD':1} ) 
 
GC_3884 = Coupling(name = 'GC_3884',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU44)*complexconjugate(ZUR11) + complexconjugate(ZU45)*complexconjugate(ZUR12) + complexconjugate(ZU46)*complexconjugate(ZUR13))', 
	 order = {'QCD':1} ) 
 
GC_3885 = Coupling(name = 'GC_3885',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL11*complexconjugate(ZU41) + ZUL12*complexconjugate(ZU42) + ZUL13*complexconjugate(ZU43))', 
	 order = {'QCD':1} ) 
 
GC_3886 = Coupling(name = 'GC_3886',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU54)*complexconjugate(ZUR11) + complexconjugate(ZU55)*complexconjugate(ZUR12) + complexconjugate(ZU56)*complexconjugate(ZUR13))', 
	 order = {'QCD':1} ) 
 
GC_3887 = Coupling(name = 'GC_3887',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL11*complexconjugate(ZU51) + ZUL12*complexconjugate(ZU52) + ZUL13*complexconjugate(ZU53))', 
	 order = {'QCD':1} ) 
 
GC_3888 = Coupling(name = 'GC_3888',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU64)*complexconjugate(ZUR11) + complexconjugate(ZU65)*complexconjugate(ZUR12) + complexconjugate(ZU66)*complexconjugate(ZUR13))', 
	 order = {'QCD':1} ) 
 
GC_3889 = Coupling(name = 'GC_3889',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL11*complexconjugate(ZU61) + ZUL12*complexconjugate(ZU62) + ZUL13*complexconjugate(ZU63))', 
	 order = {'QCD':1} ) 
 
GC_3890 = Coupling(name = 'GC_3890',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU14)*complexconjugate(ZUR21) + complexconjugate(ZU15)*complexconjugate(ZUR22) + complexconjugate(ZU16)*complexconjugate(ZUR23))', 
	 order = {'QCD':1} ) 
 
GC_3891 = Coupling(name = 'GC_3891',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL21*complexconjugate(ZU11) + ZUL22*complexconjugate(ZU12) + ZUL23*complexconjugate(ZU13))', 
	 order = {'QCD':1} ) 
 
GC_3892 = Coupling(name = 'GC_3892',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU24)*complexconjugate(ZUR21) + complexconjugate(ZU25)*complexconjugate(ZUR22) + complexconjugate(ZU26)*complexconjugate(ZUR23))', 
	 order = {'QCD':1} ) 
 
GC_3893 = Coupling(name = 'GC_3893',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL21*complexconjugate(ZU21) + ZUL22*complexconjugate(ZU22) + ZUL23*complexconjugate(ZU23))', 
	 order = {'QCD':1} ) 
 
GC_3894 = Coupling(name = 'GC_3894',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU34)*complexconjugate(ZUR21) + complexconjugate(ZU35)*complexconjugate(ZUR22) + complexconjugate(ZU36)*complexconjugate(ZUR23))', 
	 order = {'QCD':1} ) 
 
GC_3895 = Coupling(name = 'GC_3895',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL21*complexconjugate(ZU31) + ZUL22*complexconjugate(ZU32) + ZUL23*complexconjugate(ZU33))', 
	 order = {'QCD':1} ) 
 
GC_3896 = Coupling(name = 'GC_3896',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU44)*complexconjugate(ZUR21) + complexconjugate(ZU45)*complexconjugate(ZUR22) + complexconjugate(ZU46)*complexconjugate(ZUR23))', 
	 order = {'QCD':1} ) 
 
GC_3897 = Coupling(name = 'GC_3897',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL21*complexconjugate(ZU41) + ZUL22*complexconjugate(ZU42) + ZUL23*complexconjugate(ZU43))', 
	 order = {'QCD':1} ) 
 
GC_3898 = Coupling(name = 'GC_3898',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU54)*complexconjugate(ZUR21) + complexconjugate(ZU55)*complexconjugate(ZUR22) + complexconjugate(ZU56)*complexconjugate(ZUR23))', 
	 order = {'QCD':1} ) 
 
GC_3899 = Coupling(name = 'GC_3899',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL21*complexconjugate(ZU51) + ZUL22*complexconjugate(ZU52) + ZUL23*complexconjugate(ZU53))', 
	 order = {'QCD':1} ) 
 
GC_3900 = Coupling(name = 'GC_3900',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU64)*complexconjugate(ZUR21) + complexconjugate(ZU65)*complexconjugate(ZUR22) + complexconjugate(ZU66)*complexconjugate(ZUR23))', 
	 order = {'QCD':1} ) 
 
GC_3901 = Coupling(name = 'GC_3901',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL21*complexconjugate(ZU61) + ZUL22*complexconjugate(ZU62) + ZUL23*complexconjugate(ZU63))', 
	 order = {'QCD':1} ) 
 
GC_3902 = Coupling(name = 'GC_3902',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU14)*complexconjugate(ZUR31) + complexconjugate(ZU15)*complexconjugate(ZUR32) + complexconjugate(ZU16)*complexconjugate(ZUR33))', 
	 order = {'QCD':1} ) 
 
GC_3903 = Coupling(name = 'GC_3903',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL31*complexconjugate(ZU11) + ZUL32*complexconjugate(ZU12) + ZUL33*complexconjugate(ZU13))', 
	 order = {'QCD':1} ) 
 
GC_3904 = Coupling(name = 'GC_3904',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU24)*complexconjugate(ZUR31) + complexconjugate(ZU25)*complexconjugate(ZUR32) + complexconjugate(ZU26)*complexconjugate(ZUR33))', 
	 order = {'QCD':1} ) 
 
GC_3905 = Coupling(name = 'GC_3905',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL31*complexconjugate(ZU21) + ZUL32*complexconjugate(ZU22) + ZUL33*complexconjugate(ZU23))', 
	 order = {'QCD':1} ) 
 
GC_3906 = Coupling(name = 'GC_3906',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU34)*complexconjugate(ZUR31) + complexconjugate(ZU35)*complexconjugate(ZUR32) + complexconjugate(ZU36)*complexconjugate(ZUR33))', 
	 order = {'QCD':1} ) 
 
GC_3907 = Coupling(name = 'GC_3907',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL31*complexconjugate(ZU31) + ZUL32*complexconjugate(ZU32) + ZUL33*complexconjugate(ZU33))', 
	 order = {'QCD':1} ) 
 
GC_3908 = Coupling(name = 'GC_3908',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU44)*complexconjugate(ZUR31) + complexconjugate(ZU45)*complexconjugate(ZUR32) + complexconjugate(ZU46)*complexconjugate(ZUR33))', 
	 order = {'QCD':1} ) 
 
GC_3909 = Coupling(name = 'GC_3909',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL31*complexconjugate(ZU41) + ZUL32*complexconjugate(ZU42) + ZUL33*complexconjugate(ZU43))', 
	 order = {'QCD':1} ) 
 
GC_3910 = Coupling(name = 'GC_3910',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU54)*complexconjugate(ZUR31) + complexconjugate(ZU55)*complexconjugate(ZUR32) + complexconjugate(ZU56)*complexconjugate(ZUR33))', 
	 order = {'QCD':1} ) 
 
GC_3911 = Coupling(name = 'GC_3911',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL31*complexconjugate(ZU51) + ZUL32*complexconjugate(ZU52) + ZUL33*complexconjugate(ZU53))', 
	 order = {'QCD':1} ) 
 
GC_3912 = Coupling(name = 'GC_3912',
	 value = '1*complex(0,1)*cmath.sqrt(2)*G*complexconjugate(pG)*(complexconjugate(ZU64)*complexconjugate(ZUR31) + complexconjugate(ZU65)*complexconjugate(ZUR32) + complexconjugate(ZU66)*complexconjugate(ZUR33))', 
	 order = {'QCD':1} ) 
 
GC_3913 = Coupling(name = 'GC_3913',
	 value = '-1*complex(0,1)*cmath.sqrt(2)*G*pG*(ZUL31*complexconjugate(ZU61) + ZUL32*complexconjugate(ZU62) + ZUL33*complexconjugate(ZU63))', 
	 order = {'QCD':1} ) 
 
GC_3914 = Coupling(name = 'GC_3914',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3915 = Coupling(name = 'GC_3915',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL11*complexconjugate(ZD11) + ZUL12*complexconjugate(ZD12) + ZUL13*complexconjugate(ZD13)) - complexconjugate(UM12)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))', 
	 order = {'QED':1} ) 
 
GC_3916 = Coupling(name = 'GC_3916',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3917 = Coupling(name = 'GC_3917',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL11*complexconjugate(ZD21) + ZUL12*complexconjugate(ZD22) + ZUL13*complexconjugate(ZD23)) - complexconjugate(UM12)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))', 
	 order = {'QED':1} ) 
 
GC_3918 = Coupling(name = 'GC_3918',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3919 = Coupling(name = 'GC_3919',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL11*complexconjugate(ZD31) + ZUL12*complexconjugate(ZD32) + ZUL13*complexconjugate(ZD33)) - complexconjugate(UM12)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))', 
	 order = {'QED':1} ) 
 
GC_3920 = Coupling(name = 'GC_3920',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD41)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD42)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD43)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3921 = Coupling(name = 'GC_3921',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL11*complexconjugate(ZD41) + ZUL12*complexconjugate(ZD42) + ZUL13*complexconjugate(ZD43)) - complexconjugate(UM12)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))', 
	 order = {'QED':1} ) 
 
GC_3922 = Coupling(name = 'GC_3922',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD51)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD52)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD53)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3923 = Coupling(name = 'GC_3923',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL11*complexconjugate(ZD51) + ZUL12*complexconjugate(ZD52) + ZUL13*complexconjugate(ZD53)) - complexconjugate(UM12)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))', 
	 order = {'QED':1} ) 
 
GC_3924 = Coupling(name = 'GC_3924',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD61)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD62)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD63)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3925 = Coupling(name = 'GC_3925',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL11*complexconjugate(ZD61) + ZUL12*complexconjugate(ZD62) + ZUL13*complexconjugate(ZD63)) - complexconjugate(UM12)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))', 
	 order = {'QED':1} ) 
 
GC_3926 = Coupling(name = 'GC_3926',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3927 = Coupling(name = 'GC_3927',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL21*complexconjugate(ZD11) + ZUL22*complexconjugate(ZD12) + ZUL23*complexconjugate(ZD13)) - complexconjugate(UM12)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))', 
	 order = {'QED':1} ) 
 
GC_3928 = Coupling(name = 'GC_3928',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3929 = Coupling(name = 'GC_3929',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL21*complexconjugate(ZD21) + ZUL22*complexconjugate(ZD22) + ZUL23*complexconjugate(ZD23)) - complexconjugate(UM12)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))', 
	 order = {'QED':1} ) 
 
GC_3930 = Coupling(name = 'GC_3930',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3931 = Coupling(name = 'GC_3931',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL21*complexconjugate(ZD31) + ZUL22*complexconjugate(ZD32) + ZUL23*complexconjugate(ZD33)) - complexconjugate(UM12)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))', 
	 order = {'QED':1} ) 
 
GC_3932 = Coupling(name = 'GC_3932',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD41)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD42)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD43)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3933 = Coupling(name = 'GC_3933',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL21*complexconjugate(ZD41) + ZUL22*complexconjugate(ZD42) + ZUL23*complexconjugate(ZD43)) - complexconjugate(UM12)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))', 
	 order = {'QED':1} ) 
 
GC_3934 = Coupling(name = 'GC_3934',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD51)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD52)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD53)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3935 = Coupling(name = 'GC_3935',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL21*complexconjugate(ZD51) + ZUL22*complexconjugate(ZD52) + ZUL23*complexconjugate(ZD53)) - complexconjugate(UM12)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))', 
	 order = {'QED':1} ) 
 
GC_3936 = Coupling(name = 'GC_3936',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD61)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD62)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD63)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3937 = Coupling(name = 'GC_3937',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL21*complexconjugate(ZD61) + ZUL22*complexconjugate(ZD62) + ZUL23*complexconjugate(ZD63)) - complexconjugate(UM12)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))', 
	 order = {'QED':1} ) 
 
GC_3938 = Coupling(name = 'GC_3938',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3939 = Coupling(name = 'GC_3939',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL31*complexconjugate(ZD11) + ZUL32*complexconjugate(ZD12) + ZUL33*complexconjugate(ZD13)) - complexconjugate(UM12)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))', 
	 order = {'QED':1} ) 
 
GC_3940 = Coupling(name = 'GC_3940',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3941 = Coupling(name = 'GC_3941',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL31*complexconjugate(ZD21) + ZUL32*complexconjugate(ZD22) + ZUL33*complexconjugate(ZD23)) - complexconjugate(UM12)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))', 
	 order = {'QED':1} ) 
 
GC_3942 = Coupling(name = 'GC_3942',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3943 = Coupling(name = 'GC_3943',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL31*complexconjugate(ZD31) + ZUL32*complexconjugate(ZD32) + ZUL33*complexconjugate(ZD33)) - complexconjugate(UM12)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))', 
	 order = {'QED':1} ) 
 
GC_3944 = Coupling(name = 'GC_3944',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD41)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD42)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD43)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3945 = Coupling(name = 'GC_3945',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL31*complexconjugate(ZD41) + ZUL32*complexconjugate(ZD42) + ZUL33*complexconjugate(ZD43)) - complexconjugate(UM12)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))', 
	 order = {'QED':1} ) 
 
GC_3946 = Coupling(name = 'GC_3946',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD51)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD52)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD53)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3947 = Coupling(name = 'GC_3947',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL31*complexconjugate(ZD51) + ZUL32*complexconjugate(ZD52) + ZUL33*complexconjugate(ZD53)) - complexconjugate(UM12)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))', 
	 order = {'QED':1} ) 
 
GC_3948 = Coupling(name = 'GC_3948',
	 value = '1*complex(0,1)*UP12*(complexconjugate(ZD61)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD62)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD63)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3949 = Coupling(name = 'GC_3949',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM11)*(ZUL31*complexconjugate(ZD61) + ZUL32*complexconjugate(ZD62) + ZUL33*complexconjugate(ZD63)) - complexconjugate(UM12)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))', 
	 order = {'QED':1} ) 
 
GC_3950 = Coupling(name = 'GC_3950',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD11)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD12)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD13)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3951 = Coupling(name = 'GC_3951',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL11*complexconjugate(ZD11) + ZUL12*complexconjugate(ZD12) + ZUL13*complexconjugate(ZD13)) - complexconjugate(UM22)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))', 
	 order = {'QED':1} ) 
 
GC_3952 = Coupling(name = 'GC_3952',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD21)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD22)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD23)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3953 = Coupling(name = 'GC_3953',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL11*complexconjugate(ZD21) + ZUL12*complexconjugate(ZD22) + ZUL13*complexconjugate(ZD23)) - complexconjugate(UM22)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))', 
	 order = {'QED':1} ) 
 
GC_3954 = Coupling(name = 'GC_3954',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD31)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD32)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD33)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3955 = Coupling(name = 'GC_3955',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL11*complexconjugate(ZD31) + ZUL12*complexconjugate(ZD32) + ZUL13*complexconjugate(ZD33)) - complexconjugate(UM22)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))', 
	 order = {'QED':1} ) 
 
GC_3956 = Coupling(name = 'GC_3956',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD41)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD42)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD43)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3957 = Coupling(name = 'GC_3957',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL11*complexconjugate(ZD41) + ZUL12*complexconjugate(ZD42) + ZUL13*complexconjugate(ZD43)) - complexconjugate(UM22)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))', 
	 order = {'QED':1} ) 
 
GC_3958 = Coupling(name = 'GC_3958',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD51)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD52)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD53)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3959 = Coupling(name = 'GC_3959',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL11*complexconjugate(ZD51) + ZUL12*complexconjugate(ZD52) + ZUL13*complexconjugate(ZD53)) - complexconjugate(UM22)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))', 
	 order = {'QED':1} ) 
 
GC_3960 = Coupling(name = 'GC_3960',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD61)*(Yu11*complexconjugate(ZUR11) + Yu21*complexconjugate(ZUR12) + Yu31*complexconjugate(ZUR13)) + complexconjugate(ZD62)*(Yu12*complexconjugate(ZUR11) + Yu22*complexconjugate(ZUR12) + Yu32*complexconjugate(ZUR13)) + complexconjugate(ZD63)*(Yu13*complexconjugate(ZUR11) + Yu23*complexconjugate(ZUR12) + Yu33*complexconjugate(ZUR13)))', 
	 order = {'QED':1} ) 
 
GC_3961 = Coupling(name = 'GC_3961',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL11*complexconjugate(ZD61) + ZUL12*complexconjugate(ZD62) + ZUL13*complexconjugate(ZD63)) - complexconjugate(UM22)*(ZUL11*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZUL12*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZUL13*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))', 
	 order = {'QED':1} ) 
 
GC_3962 = Coupling(name = 'GC_3962',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD11)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD12)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD13)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3963 = Coupling(name = 'GC_3963',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL21*complexconjugate(ZD11) + ZUL22*complexconjugate(ZD12) + ZUL23*complexconjugate(ZD13)) - complexconjugate(UM22)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))', 
	 order = {'QED':1} ) 
 
GC_3964 = Coupling(name = 'GC_3964',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD21)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD22)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD23)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3965 = Coupling(name = 'GC_3965',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL21*complexconjugate(ZD21) + ZUL22*complexconjugate(ZD22) + ZUL23*complexconjugate(ZD23)) - complexconjugate(UM22)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))', 
	 order = {'QED':1} ) 
 
GC_3966 = Coupling(name = 'GC_3966',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD31)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD32)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD33)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3967 = Coupling(name = 'GC_3967',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL21*complexconjugate(ZD31) + ZUL22*complexconjugate(ZD32) + ZUL23*complexconjugate(ZD33)) - complexconjugate(UM22)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))', 
	 order = {'QED':1} ) 
 
GC_3968 = Coupling(name = 'GC_3968',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD41)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD42)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD43)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3969 = Coupling(name = 'GC_3969',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL21*complexconjugate(ZD41) + ZUL22*complexconjugate(ZD42) + ZUL23*complexconjugate(ZD43)) - complexconjugate(UM22)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))', 
	 order = {'QED':1} ) 
 
GC_3970 = Coupling(name = 'GC_3970',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD51)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD52)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD53)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3971 = Coupling(name = 'GC_3971',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL21*complexconjugate(ZD51) + ZUL22*complexconjugate(ZD52) + ZUL23*complexconjugate(ZD53)) - complexconjugate(UM22)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))', 
	 order = {'QED':1} ) 
 
GC_3972 = Coupling(name = 'GC_3972',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD61)*(Yu11*complexconjugate(ZUR21) + Yu21*complexconjugate(ZUR22) + Yu31*complexconjugate(ZUR23)) + complexconjugate(ZD62)*(Yu12*complexconjugate(ZUR21) + Yu22*complexconjugate(ZUR22) + Yu32*complexconjugate(ZUR23)) + complexconjugate(ZD63)*(Yu13*complexconjugate(ZUR21) + Yu23*complexconjugate(ZUR22) + Yu33*complexconjugate(ZUR23)))', 
	 order = {'QED':1} ) 
 
GC_3973 = Coupling(name = 'GC_3973',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL21*complexconjugate(ZD61) + ZUL22*complexconjugate(ZD62) + ZUL23*complexconjugate(ZD63)) - complexconjugate(UM22)*(ZUL21*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZUL22*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZUL23*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))', 
	 order = {'QED':1} ) 
 
GC_3974 = Coupling(name = 'GC_3974',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD11)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD12)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD13)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3975 = Coupling(name = 'GC_3975',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL31*complexconjugate(ZD11) + ZUL32*complexconjugate(ZD12) + ZUL33*complexconjugate(ZD13)) - complexconjugate(UM22)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD14) + complexconjugate(Yd21)*complexconjugate(ZD15) + complexconjugate(Yd31)*complexconjugate(ZD16)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD14) + complexconjugate(Yd22)*complexconjugate(ZD15) + complexconjugate(Yd32)*complexconjugate(ZD16)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD14) + complexconjugate(Yd23)*complexconjugate(ZD15) + complexconjugate(Yd33)*complexconjugate(ZD16))))', 
	 order = {'QED':1} ) 
 
GC_3976 = Coupling(name = 'GC_3976',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD21)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD22)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD23)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3977 = Coupling(name = 'GC_3977',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL31*complexconjugate(ZD21) + ZUL32*complexconjugate(ZD22) + ZUL33*complexconjugate(ZD23)) - complexconjugate(UM22)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD24) + complexconjugate(Yd21)*complexconjugate(ZD25) + complexconjugate(Yd31)*complexconjugate(ZD26)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD24) + complexconjugate(Yd22)*complexconjugate(ZD25) + complexconjugate(Yd32)*complexconjugate(ZD26)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD24) + complexconjugate(Yd23)*complexconjugate(ZD25) + complexconjugate(Yd33)*complexconjugate(ZD26))))', 
	 order = {'QED':1} ) 
 
GC_3978 = Coupling(name = 'GC_3978',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD31)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD32)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD33)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3979 = Coupling(name = 'GC_3979',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL31*complexconjugate(ZD31) + ZUL32*complexconjugate(ZD32) + ZUL33*complexconjugate(ZD33)) - complexconjugate(UM22)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD34) + complexconjugate(Yd21)*complexconjugate(ZD35) + complexconjugate(Yd31)*complexconjugate(ZD36)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD34) + complexconjugate(Yd22)*complexconjugate(ZD35) + complexconjugate(Yd32)*complexconjugate(ZD36)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD34) + complexconjugate(Yd23)*complexconjugate(ZD35) + complexconjugate(Yd33)*complexconjugate(ZD36))))', 
	 order = {'QED':1} ) 
 
GC_3980 = Coupling(name = 'GC_3980',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD41)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD42)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD43)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3981 = Coupling(name = 'GC_3981',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL31*complexconjugate(ZD41) + ZUL32*complexconjugate(ZD42) + ZUL33*complexconjugate(ZD43)) - complexconjugate(UM22)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD44) + complexconjugate(Yd21)*complexconjugate(ZD45) + complexconjugate(Yd31)*complexconjugate(ZD46)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD44) + complexconjugate(Yd22)*complexconjugate(ZD45) + complexconjugate(Yd32)*complexconjugate(ZD46)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD44) + complexconjugate(Yd23)*complexconjugate(ZD45) + complexconjugate(Yd33)*complexconjugate(ZD46))))', 
	 order = {'QED':1} ) 
 
GC_3982 = Coupling(name = 'GC_3982',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD51)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD52)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD53)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3983 = Coupling(name = 'GC_3983',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL31*complexconjugate(ZD51) + ZUL32*complexconjugate(ZD52) + ZUL33*complexconjugate(ZD53)) - complexconjugate(UM22)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD54) + complexconjugate(Yd21)*complexconjugate(ZD55) + complexconjugate(Yd31)*complexconjugate(ZD56)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD54) + complexconjugate(Yd22)*complexconjugate(ZD55) + complexconjugate(Yd32)*complexconjugate(ZD56)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD54) + complexconjugate(Yd23)*complexconjugate(ZD55) + complexconjugate(Yd33)*complexconjugate(ZD56))))', 
	 order = {'QED':1} ) 
 
GC_3984 = Coupling(name = 'GC_3984',
	 value = '1*complex(0,1)*UP22*(complexconjugate(ZD61)*(Yu11*complexconjugate(ZUR31) + Yu21*complexconjugate(ZUR32) + Yu31*complexconjugate(ZUR33)) + complexconjugate(ZD62)*(Yu12*complexconjugate(ZUR31) + Yu22*complexconjugate(ZUR32) + Yu32*complexconjugate(ZUR33)) + complexconjugate(ZD63)*(Yu13*complexconjugate(ZUR31) + Yu23*complexconjugate(ZUR32) + Yu33*complexconjugate(ZUR33)))', 
	 order = {'QED':1} ) 
 
GC_3985 = Coupling(name = 'GC_3985',
	 value = '-1*complex(0,1)*(g2*complexconjugate(UM21)*(ZUL31*complexconjugate(ZD61) + ZUL32*complexconjugate(ZD62) + ZUL33*complexconjugate(ZD63)) - complexconjugate(UM22)*(ZUL31*(complexconjugate(Yd11)*complexconjugate(ZD64) + complexconjugate(Yd21)*complexconjugate(ZD65) + complexconjugate(Yd31)*complexconjugate(ZD66)) + ZUL32*(complexconjugate(Yd12)*complexconjugate(ZD64) + complexconjugate(Yd22)*complexconjugate(ZD65) + complexconjugate(Yd32)*complexconjugate(ZD66)) + ZUL33*(complexconjugate(Yd13)*complexconjugate(ZD64) + complexconjugate(Yd23)*complexconjugate(ZD65) + complexconjugate(Yd33)*complexconjugate(ZD66))))', 
	 order = {'QED':1} ) 
 
GC_3986 = Coupling(name = 'GC_3986',
	 value = '-1*complex(0,1)*(g2*ZE11*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)))', 
	 order = {'QED':1} ) 
 
GC_3987 = Coupling(name = 'GC_3987',
	 value = '-1*complex(0,1)*(g2*ZE21*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)))', 
	 order = {'QED':1} ) 
 
GC_3988 = Coupling(name = 'GC_3988',
	 value = '-1*complex(0,1)*(g2*ZE31*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)))', 
	 order = {'QED':1} ) 
 
GC_3989 = Coupling(name = 'GC_3989',
	 value = '-1*complex(0,1)*(g2*ZE41*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)))', 
	 order = {'QED':1} ) 
 
GC_3990 = Coupling(name = 'GC_3990',
	 value = '-1*complex(0,1)*(g2*ZE51*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)))', 
	 order = {'QED':1} ) 
 
GC_3991 = Coupling(name = 'GC_3991',
	 value = '-1*complex(0,1)*(g2*ZE61*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)))', 
	 order = {'QED':1} ) 
 
GC_3992 = Coupling(name = 'GC_3992',
	 value = '-1*complex(0,1)*(g2*ZE12*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)))', 
	 order = {'QED':1} ) 
 
GC_3993 = Coupling(name = 'GC_3993',
	 value = '-1*complex(0,1)*(g2*ZE22*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)))', 
	 order = {'QED':1} ) 
 
GC_3994 = Coupling(name = 'GC_3994',
	 value = '-1*complex(0,1)*(g2*ZE32*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)))', 
	 order = {'QED':1} ) 
 
GC_3995 = Coupling(name = 'GC_3995',
	 value = '-1*complex(0,1)*(g2*ZE42*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)))', 
	 order = {'QED':1} ) 
 
GC_3996 = Coupling(name = 'GC_3996',
	 value = '-1*complex(0,1)*(g2*ZE52*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)))', 
	 order = {'QED':1} ) 
 
GC_3997 = Coupling(name = 'GC_3997',
	 value = '-1*complex(0,1)*(g2*ZE62*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)))', 
	 order = {'QED':1} ) 
 
GC_3998 = Coupling(name = 'GC_3998',
	 value = '-1*complex(0,1)*(g2*ZE13*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))', 
	 order = {'QED':1} ) 
 
GC_3999 = Coupling(name = 'GC_3999',
	 value = '-1*complex(0,1)*(g2*ZE23*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))', 
	 order = {'QED':1} ) 
 
GC_4000 = Coupling(name = 'GC_4000',
	 value = '-1*complex(0,1)*(g2*ZE33*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))', 
	 order = {'QED':1} ) 
 
GC_4001 = Coupling(name = 'GC_4001',
	 value = '-1*complex(0,1)*(g2*ZE43*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))', 
	 order = {'QED':1} ) 
 
GC_4002 = Coupling(name = 'GC_4002',
	 value = '-1*complex(0,1)*(g2*ZE53*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))', 
	 order = {'QED':1} ) 
 
GC_4003 = Coupling(name = 'GC_4003',
	 value = '-1*complex(0,1)*(g2*ZE63*complexconjugate(UM11) - complexconjugate(UM12)*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))', 
	 order = {'QED':1} ) 
 
GC_4004 = Coupling(name = 'GC_4004',
	 value = '-1*complex(0,1)*(g2*ZE11*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye11)*complexconjugate(ZE14) + complexconjugate(Ye21)*complexconjugate(ZE15) + complexconjugate(Ye31)*complexconjugate(ZE16)))', 
	 order = {'QED':1} ) 
 
GC_4005 = Coupling(name = 'GC_4005',
	 value = '-1*complex(0,1)*(g2*ZE21*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye11)*complexconjugate(ZE24) + complexconjugate(Ye21)*complexconjugate(ZE25) + complexconjugate(Ye31)*complexconjugate(ZE26)))', 
	 order = {'QED':1} ) 
 
GC_4006 = Coupling(name = 'GC_4006',
	 value = '-1*complex(0,1)*(g2*ZE31*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye11)*complexconjugate(ZE34) + complexconjugate(Ye21)*complexconjugate(ZE35) + complexconjugate(Ye31)*complexconjugate(ZE36)))', 
	 order = {'QED':1} ) 
 
GC_4007 = Coupling(name = 'GC_4007',
	 value = '-1*complex(0,1)*(g2*ZE41*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye11)*complexconjugate(ZE44) + complexconjugate(Ye21)*complexconjugate(ZE45) + complexconjugate(Ye31)*complexconjugate(ZE46)))', 
	 order = {'QED':1} ) 
 
GC_4008 = Coupling(name = 'GC_4008',
	 value = '-1*complex(0,1)*(g2*ZE51*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye11)*complexconjugate(ZE54) + complexconjugate(Ye21)*complexconjugate(ZE55) + complexconjugate(Ye31)*complexconjugate(ZE56)))', 
	 order = {'QED':1} ) 
 
GC_4009 = Coupling(name = 'GC_4009',
	 value = '-1*complex(0,1)*(g2*ZE61*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye11)*complexconjugate(ZE64) + complexconjugate(Ye21)*complexconjugate(ZE65) + complexconjugate(Ye31)*complexconjugate(ZE66)))', 
	 order = {'QED':1} ) 
 
GC_4010 = Coupling(name = 'GC_4010',
	 value = '-1*complex(0,1)*(g2*ZE12*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye12)*complexconjugate(ZE14) + complexconjugate(Ye22)*complexconjugate(ZE15) + complexconjugate(Ye32)*complexconjugate(ZE16)))', 
	 order = {'QED':1} ) 
 
GC_4011 = Coupling(name = 'GC_4011',
	 value = '-1*complex(0,1)*(g2*ZE22*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye12)*complexconjugate(ZE24) + complexconjugate(Ye22)*complexconjugate(ZE25) + complexconjugate(Ye32)*complexconjugate(ZE26)))', 
	 order = {'QED':1} ) 
 
GC_4012 = Coupling(name = 'GC_4012',
	 value = '-1*complex(0,1)*(g2*ZE32*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye12)*complexconjugate(ZE34) + complexconjugate(Ye22)*complexconjugate(ZE35) + complexconjugate(Ye32)*complexconjugate(ZE36)))', 
	 order = {'QED':1} ) 
 
GC_4013 = Coupling(name = 'GC_4013',
	 value = '-1*complex(0,1)*(g2*ZE42*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye12)*complexconjugate(ZE44) + complexconjugate(Ye22)*complexconjugate(ZE45) + complexconjugate(Ye32)*complexconjugate(ZE46)))', 
	 order = {'QED':1} ) 
 
GC_4014 = Coupling(name = 'GC_4014',
	 value = '-1*complex(0,1)*(g2*ZE52*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye12)*complexconjugate(ZE54) + complexconjugate(Ye22)*complexconjugate(ZE55) + complexconjugate(Ye32)*complexconjugate(ZE56)))', 
	 order = {'QED':1} ) 
 
GC_4015 = Coupling(name = 'GC_4015',
	 value = '-1*complex(0,1)*(g2*ZE62*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye12)*complexconjugate(ZE64) + complexconjugate(Ye22)*complexconjugate(ZE65) + complexconjugate(Ye32)*complexconjugate(ZE66)))', 
	 order = {'QED':1} ) 
 
GC_4016 = Coupling(name = 'GC_4016',
	 value = '-1*complex(0,1)*(g2*ZE13*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye13)*complexconjugate(ZE14) + complexconjugate(Ye23)*complexconjugate(ZE15) + complexconjugate(Ye33)*complexconjugate(ZE16)))', 
	 order = {'QED':1} ) 
 
GC_4017 = Coupling(name = 'GC_4017',
	 value = '-1*complex(0,1)*(g2*ZE23*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye13)*complexconjugate(ZE24) + complexconjugate(Ye23)*complexconjugate(ZE25) + complexconjugate(Ye33)*complexconjugate(ZE26)))', 
	 order = {'QED':1} ) 
 
GC_4018 = Coupling(name = 'GC_4018',
	 value = '-1*complex(0,1)*(g2*ZE33*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye13)*complexconjugate(ZE34) + complexconjugate(Ye23)*complexconjugate(ZE35) + complexconjugate(Ye33)*complexconjugate(ZE36)))', 
	 order = {'QED':1} ) 
 
GC_4019 = Coupling(name = 'GC_4019',
	 value = '-1*complex(0,1)*(g2*ZE43*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye13)*complexconjugate(ZE44) + complexconjugate(Ye23)*complexconjugate(ZE45) + complexconjugate(Ye33)*complexconjugate(ZE46)))', 
	 order = {'QED':1} ) 
 
GC_4020 = Coupling(name = 'GC_4020',
	 value = '-1*complex(0,1)*(g2*ZE53*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye13)*complexconjugate(ZE54) + complexconjugate(Ye23)*complexconjugate(ZE55) + complexconjugate(Ye33)*complexconjugate(ZE56)))', 
	 order = {'QED':1} ) 
 
GC_4021 = Coupling(name = 'GC_4021',
	 value = '-1*complex(0,1)*(g2*ZE63*complexconjugate(UM21) - complexconjugate(UM22)*(complexconjugate(Ye13)*complexconjugate(ZE64) + complexconjugate(Ye23)*complexconjugate(ZE65) + complexconjugate(Ye33)*complexconjugate(ZE66)))', 
	 order = {'QED':1} ) 
 
GC_4022 = Coupling(name = 'GC_4022',
	 value = '1./2.*complex(0,1)*g2*(2*UM11*complexconjugate(ZN12) + cmath.sqrt(2)*UM12*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_4023 = Coupling(name = 'GC_4023',
	 value = '1*complex(0,1)*g2*ZN12*complexconjugate(UP11) - (1*complex(0,1)*g2*ZN14*complexconjugate(UP12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4024 = Coupling(name = 'GC_4024',
	 value = '1./2.*complex(0,1)*g2*(2*UM21*complexconjugate(ZN12) + cmath.sqrt(2)*UM22*complexconjugate(ZN13))', 
	 order = {'QED':1} ) 
 
GC_4025 = Coupling(name = 'GC_4025',
	 value = '1*complex(0,1)*g2*ZN12*complexconjugate(UP21) - (1*complex(0,1)*g2*ZN14*complexconjugate(UP22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4026 = Coupling(name = 'GC_4026',
	 value = '1./2.*complex(0,1)*g2*(2*UM11*complexconjugate(ZN22) + cmath.sqrt(2)*UM12*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_4027 = Coupling(name = 'GC_4027',
	 value = '1*complex(0,1)*g2*ZN22*complexconjugate(UP11) - (1*complex(0,1)*g2*ZN24*complexconjugate(UP12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4028 = Coupling(name = 'GC_4028',
	 value = '1./2.*complex(0,1)*g2*(2*UM21*complexconjugate(ZN22) + cmath.sqrt(2)*UM22*complexconjugate(ZN23))', 
	 order = {'QED':1} ) 
 
GC_4029 = Coupling(name = 'GC_4029',
	 value = '1*complex(0,1)*g2*ZN22*complexconjugate(UP21) - (1*complex(0,1)*g2*ZN24*complexconjugate(UP22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4030 = Coupling(name = 'GC_4030',
	 value = '1./2.*complex(0,1)*g2*(2*UM11*complexconjugate(ZN32) + cmath.sqrt(2)*UM12*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_4031 = Coupling(name = 'GC_4031',
	 value = '1*complex(0,1)*g2*ZN32*complexconjugate(UP11) - (1*complex(0,1)*g2*ZN34*complexconjugate(UP12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4032 = Coupling(name = 'GC_4032',
	 value = '1./2.*complex(0,1)*g2*(2*UM21*complexconjugate(ZN32) + cmath.sqrt(2)*UM22*complexconjugate(ZN33))', 
	 order = {'QED':1} ) 
 
GC_4033 = Coupling(name = 'GC_4033',
	 value = '1*complex(0,1)*g2*ZN32*complexconjugate(UP21) - (1*complex(0,1)*g2*ZN34*complexconjugate(UP22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4034 = Coupling(name = 'GC_4034',
	 value = '1./2.*complex(0,1)*g2*(2*UM11*complexconjugate(ZN42) + cmath.sqrt(2)*UM12*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_4035 = Coupling(name = 'GC_4035',
	 value = '1*complex(0,1)*g2*ZN42*complexconjugate(UP11) - (1*complex(0,1)*g2*ZN44*complexconjugate(UP12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4036 = Coupling(name = 'GC_4036',
	 value = '1./2.*complex(0,1)*g2*(2*UM21*complexconjugate(ZN42) + cmath.sqrt(2)*UM22*complexconjugate(ZN43))', 
	 order = {'QED':1} ) 
 
GC_4037 = Coupling(name = 'GC_4037',
	 value = '1*complex(0,1)*g2*ZN42*complexconjugate(UP21) - (1*complex(0,1)*g2*ZN44*complexconjugate(UP22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4038 = Coupling(name = 'GC_4038',
	 value = '-1./2.*complex(0,1)*(2*g2*UM11*complexconjugate(UM11)*cmath.sin(TW) + UM12*complexconjugate(UM12)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4039 = Coupling(name = 'GC_4039',
	 value = '-1./2.*complex(0,1)*(2*g2*UP11*complexconjugate(UP11)*cmath.sin(TW) + UP12*complexconjugate(UP12)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4040 = Coupling(name = 'GC_4040',
	 value = '-1./2.*complex(0,1)*(2*g2*UM21*complexconjugate(UM11)*cmath.sin(TW) + UM22*complexconjugate(UM12)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4041 = Coupling(name = 'GC_4041',
	 value = '-1./2.*complex(0,1)*(2*g2*UP11*complexconjugate(UP21)*cmath.sin(TW) + UP12*complexconjugate(UP22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4042 = Coupling(name = 'GC_4042',
	 value = '-1./2.*complex(0,1)*(2*g2*UM11*complexconjugate(UM21)*cmath.sin(TW) + UM12*complexconjugate(UM22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4043 = Coupling(name = 'GC_4043',
	 value = '-1./2.*complex(0,1)*(2*g2*UP21*complexconjugate(UP11)*cmath.sin(TW) + UP22*complexconjugate(UP12)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4044 = Coupling(name = 'GC_4044',
	 value = '-1./2.*complex(0,1)*(2*g2*UM21*complexconjugate(UM21)*cmath.sin(TW) + UM22*complexconjugate(UM22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4045 = Coupling(name = 'GC_4045',
	 value = '-1./2.*complex(0,1)*(2*g2*UP21*complexconjugate(UP21)*cmath.sin(TW) + UP22*complexconjugate(UP22)*(g1*cmath.cos(TW) + g2*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4046 = Coupling(name = 'GC_4046',
	 value = '-1./2.*complex(0,1)*(2*g2*UM11*complexconjugate(UM11)*cmath.cos(TW) + UM12*complexconjugate(UM12)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4047 = Coupling(name = 'GC_4047',
	 value = '-1./2.*complex(0,1)*(2*g2*UP11*complexconjugate(UP11)*cmath.cos(TW) + UP12*complexconjugate(UP12)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4048 = Coupling(name = 'GC_4048',
	 value = '-1./2.*complex(0,1)*(2*g2*UM21*complexconjugate(UM11)*cmath.cos(TW) + UM22*complexconjugate(UM12)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4049 = Coupling(name = 'GC_4049',
	 value = '-1./2.*complex(0,1)*(2*g2*UP11*complexconjugate(UP21)*cmath.cos(TW) + UP12*complexconjugate(UP22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4050 = Coupling(name = 'GC_4050',
	 value = '-1./2.*complex(0,1)*(2*g2*UM11*complexconjugate(UM21)*cmath.cos(TW) + UM12*complexconjugate(UM22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4051 = Coupling(name = 'GC_4051',
	 value = '-1./2.*complex(0,1)*(2*g2*UP21*complexconjugate(UP11)*cmath.cos(TW) + UP22*complexconjugate(UP12)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4052 = Coupling(name = 'GC_4052',
	 value = '-1./2.*complex(0,1)*(2*g2*UM21*complexconjugate(UM21)*cmath.cos(TW) + UM22*complexconjugate(UM22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4053 = Coupling(name = 'GC_4053',
	 value = '-1./2.*complex(0,1)*(2*g2*UP21*complexconjugate(UP21)*cmath.cos(TW) + UP22*complexconjugate(UP22)*(g2*cmath.cos(TW) - g1*cmath.sin(TW)))', 
	 order = {'QED':1} ) 
 
GC_4054 = Coupling(name = 'GC_4054',
	 value = '1./2.*complex(0,1)*(ZN13*complexconjugate(ZN13) - ZN14*complexconjugate(ZN14))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4055 = Coupling(name = 'GC_4055',
	 value = '-1./2.*complex(0,1)*(ZN13*complexconjugate(ZN13) - ZN14*complexconjugate(ZN14))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4056 = Coupling(name = 'GC_4056',
	 value = '1./2.*complex(0,1)*(ZN23*complexconjugate(ZN13) - ZN24*complexconjugate(ZN14))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4057 = Coupling(name = 'GC_4057',
	 value = '-1./2.*complex(0,1)*(ZN13*complexconjugate(ZN23) - ZN14*complexconjugate(ZN24))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4058 = Coupling(name = 'GC_4058',
	 value = '1./2.*complex(0,1)*(ZN33*complexconjugate(ZN13) - ZN34*complexconjugate(ZN14))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4059 = Coupling(name = 'GC_4059',
	 value = '-1./2.*complex(0,1)*(ZN13*complexconjugate(ZN33) - ZN14*complexconjugate(ZN34))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4060 = Coupling(name = 'GC_4060',
	 value = '1./2.*complex(0,1)*(ZN43*complexconjugate(ZN13) - ZN44*complexconjugate(ZN14))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4061 = Coupling(name = 'GC_4061',
	 value = '-1./2.*complex(0,1)*(ZN13*complexconjugate(ZN43) - ZN14*complexconjugate(ZN44))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4062 = Coupling(name = 'GC_4062',
	 value = '1./2.*complex(0,1)*(ZN23*complexconjugate(ZN23) - ZN24*complexconjugate(ZN24))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4063 = Coupling(name = 'GC_4063',
	 value = '-1./2.*complex(0,1)*(ZN23*complexconjugate(ZN23) - ZN24*complexconjugate(ZN24))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4064 = Coupling(name = 'GC_4064',
	 value = '1./2.*complex(0,1)*(ZN33*complexconjugate(ZN23) - ZN34*complexconjugate(ZN24))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4065 = Coupling(name = 'GC_4065',
	 value = '-1./2.*complex(0,1)*(ZN23*complexconjugate(ZN33) - ZN24*complexconjugate(ZN34))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4066 = Coupling(name = 'GC_4066',
	 value = '1./2.*complex(0,1)*(ZN43*complexconjugate(ZN23) - ZN44*complexconjugate(ZN24))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4067 = Coupling(name = 'GC_4067',
	 value = '-1./2.*complex(0,1)*(ZN23*complexconjugate(ZN43) - ZN24*complexconjugate(ZN44))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4068 = Coupling(name = 'GC_4068',
	 value = '1./2.*complex(0,1)*(ZN33*complexconjugate(ZN33) - ZN34*complexconjugate(ZN34))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4069 = Coupling(name = 'GC_4069',
	 value = '-1./2.*complex(0,1)*(ZN33*complexconjugate(ZN33) - ZN34*complexconjugate(ZN34))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4070 = Coupling(name = 'GC_4070',
	 value = '1./2.*complex(0,1)*(ZN43*complexconjugate(ZN33) - ZN44*complexconjugate(ZN34))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4071 = Coupling(name = 'GC_4071',
	 value = '-1./2.*complex(0,1)*(ZN33*complexconjugate(ZN43) - ZN34*complexconjugate(ZN44))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4072 = Coupling(name = 'GC_4072',
	 value = '1./2.*complex(0,1)*(ZN43*complexconjugate(ZN43) - ZN44*complexconjugate(ZN44))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4073 = Coupling(name = 'GC_4073',
	 value = '-1./2.*complex(0,1)*(ZN43*complexconjugate(ZN43) - ZN44*complexconjugate(ZN44))*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4074 = Coupling(name = 'GC_4074',
	 value = '1./2.*complex(0,1)*g2*(2*ZN12*complexconjugate(UM11) + cmath.sqrt(2)*ZN13*complexconjugate(UM12))', 
	 order = {'QED':1} ) 
 
GC_4075 = Coupling(name = 'GC_4075',
	 value = '1*complex(0,1)*g2*UP11*complexconjugate(ZN12) - (1*complex(0,1)*g2*UP12*complexconjugate(ZN14))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4076 = Coupling(name = 'GC_4076',
	 value = '1./2.*complex(0,1)*g2*(2*ZN22*complexconjugate(UM11) + cmath.sqrt(2)*ZN23*complexconjugate(UM12))', 
	 order = {'QED':1} ) 
 
GC_4077 = Coupling(name = 'GC_4077',
	 value = '1*complex(0,1)*g2*UP11*complexconjugate(ZN22) - (1*complex(0,1)*g2*UP12*complexconjugate(ZN24))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4078 = Coupling(name = 'GC_4078',
	 value = '1./2.*complex(0,1)*g2*(2*ZN32*complexconjugate(UM11) + cmath.sqrt(2)*ZN33*complexconjugate(UM12))', 
	 order = {'QED':1} ) 
 
GC_4079 = Coupling(name = 'GC_4079',
	 value = '1*complex(0,1)*g2*UP11*complexconjugate(ZN32) - (1*complex(0,1)*g2*UP12*complexconjugate(ZN34))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4080 = Coupling(name = 'GC_4080',
	 value = '1./2.*complex(0,1)*g2*(2*ZN42*complexconjugate(UM11) + cmath.sqrt(2)*ZN43*complexconjugate(UM12))', 
	 order = {'QED':1} ) 
 
GC_4081 = Coupling(name = 'GC_4081',
	 value = '1*complex(0,1)*g2*UP11*complexconjugate(ZN42) - (1*complex(0,1)*g2*UP12*complexconjugate(ZN44))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4082 = Coupling(name = 'GC_4082',
	 value = '1./2.*complex(0,1)*g2*(2*ZN12*complexconjugate(UM21) + cmath.sqrt(2)*ZN13*complexconjugate(UM22))', 
	 order = {'QED':1} ) 
 
GC_4083 = Coupling(name = 'GC_4083',
	 value = '1*complex(0,1)*g2*UP21*complexconjugate(ZN12) - (1*complex(0,1)*g2*UP22*complexconjugate(ZN14))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4084 = Coupling(name = 'GC_4084',
	 value = '1./2.*complex(0,1)*g2*(2*ZN22*complexconjugate(UM21) + cmath.sqrt(2)*ZN23*complexconjugate(UM22))', 
	 order = {'QED':1} ) 
 
GC_4085 = Coupling(name = 'GC_4085',
	 value = '1*complex(0,1)*g2*UP21*complexconjugate(ZN22) - (1*complex(0,1)*g2*UP22*complexconjugate(ZN24))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4086 = Coupling(name = 'GC_4086',
	 value = '1./2.*complex(0,1)*g2*(2*ZN32*complexconjugate(UM21) + cmath.sqrt(2)*ZN33*complexconjugate(UM22))', 
	 order = {'QED':1} ) 
 
GC_4087 = Coupling(name = 'GC_4087',
	 value = '1*complex(0,1)*g2*UP21*complexconjugate(ZN32) - (1*complex(0,1)*g2*UP22*complexconjugate(ZN34))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4088 = Coupling(name = 'GC_4088',
	 value = '1./2.*complex(0,1)*g2*(2*ZN42*complexconjugate(UM21) + cmath.sqrt(2)*ZN43*complexconjugate(UM22))', 
	 order = {'QED':1} ) 
 
GC_4089 = Coupling(name = 'GC_4089',
	 value = '1*complex(0,1)*g2*UP21*complexconjugate(ZN42) - (1*complex(0,1)*g2*UP22*complexconjugate(ZN44))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4090 = Coupling(name = 'GC_4090',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4091 = Coupling(name = 'GC_4091',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4092 = Coupling(name = 'GC_4092',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4093 = Coupling(name = 'GC_4093',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4094 = Coupling(name = 'GC_4094',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4095 = Coupling(name = 'GC_4095',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4096 = Coupling(name = 'GC_4096',
	 value = '1./6.*complex(0,1)*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4097 = Coupling(name = 'GC_4097',
	 value = '-1./3.*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4098 = Coupling(name = 'GC_4098',
	 value = '1./6.*complex(0,1)*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4099 = Coupling(name = 'GC_4099',
	 value = '-1./3.*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4100 = Coupling(name = 'GC_4100',
	 value = '1./6.*complex(0,1)*(g1*cmath.cos(TW) - 3*g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4101 = Coupling(name = 'GC_4101',
	 value = '-1./3.*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4102 = Coupling(name = 'GC_4102',
	 value = '-1./6.*complex(0,1)*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4103 = Coupling(name = 'GC_4103',
	 value = '1./3.*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4104 = Coupling(name = 'GC_4104',
	 value = '-1./6.*complex(0,1)*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4105 = Coupling(name = 'GC_4105',
	 value = '1./3.*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4106 = Coupling(name = 'GC_4106',
	 value = '-1./6.*complex(0,1)*(3*g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4107 = Coupling(name = 'GC_4107',
	 value = '1./3.*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4108 = Coupling(name = 'GC_4108',
	 value = '(1*complex(0,1)*g2*(ZUL11*complexconjugate(ZDL11) + ZUL12*complexconjugate(ZDL12) + ZUL13*complexconjugate(ZDL13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4109 = Coupling(name = 'GC_4109',
	 value = '(1*complex(0,1)*g2*(ZUL11*complexconjugate(ZDL21) + ZUL12*complexconjugate(ZDL22) + ZUL13*complexconjugate(ZDL23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4110 = Coupling(name = 'GC_4110',
	 value = '(1*complex(0,1)*g2*(ZUL11*complexconjugate(ZDL31) + ZUL12*complexconjugate(ZDL32) + ZUL13*complexconjugate(ZDL33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4111 = Coupling(name = 'GC_4111',
	 value = '(1*complex(0,1)*g2*(ZUL21*complexconjugate(ZDL11) + ZUL22*complexconjugate(ZDL12) + ZUL23*complexconjugate(ZDL13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4112 = Coupling(name = 'GC_4112',
	 value = '(1*complex(0,1)*g2*(ZUL21*complexconjugate(ZDL21) + ZUL22*complexconjugate(ZDL22) + ZUL23*complexconjugate(ZDL23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4113 = Coupling(name = 'GC_4113',
	 value = '(1*complex(0,1)*g2*(ZUL21*complexconjugate(ZDL31) + ZUL22*complexconjugate(ZDL32) + ZUL23*complexconjugate(ZDL33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4114 = Coupling(name = 'GC_4114',
	 value = '(1*complex(0,1)*g2*(ZUL31*complexconjugate(ZDL11) + ZUL32*complexconjugate(ZDL12) + ZUL33*complexconjugate(ZDL13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4115 = Coupling(name = 'GC_4115',
	 value = '(1*complex(0,1)*g2*(ZUL31*complexconjugate(ZDL21) + ZUL32*complexconjugate(ZDL22) + ZUL33*complexconjugate(ZDL23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4116 = Coupling(name = 'GC_4116',
	 value = '(1*complex(0,1)*g2*(ZUL31*complexconjugate(ZDL31) + ZUL32*complexconjugate(ZDL32) + ZUL33*complexconjugate(ZDL33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4117 = Coupling(name = 'GC_4117',
	 value = '-1./2.*complex(0,1)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4118 = Coupling(name = 'GC_4118',
	 value = '-1*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4119 = Coupling(name = 'GC_4119',
	 value = '-1./2.*complex(0,1)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4120 = Coupling(name = 'GC_4120',
	 value = '-1*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4121 = Coupling(name = 'GC_4121',
	 value = '-1./2.*complex(0,1)*(g1*cmath.cos(TW) + g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4122 = Coupling(name = 'GC_4122',
	 value = '-1*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4123 = Coupling(name = 'GC_4123',
	 value = '-1./2.*complex(0,1)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4124 = Coupling(name = 'GC_4124',
	 value = '1*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4125 = Coupling(name = 'GC_4125',
	 value = '-1./2.*complex(0,1)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4126 = Coupling(name = 'GC_4126',
	 value = '1*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4127 = Coupling(name = 'GC_4127',
	 value = '-1./2.*complex(0,1)*(g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4128 = Coupling(name = 'GC_4128',
	 value = '1*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4129 = Coupling(name = 'GC_4129',
	 value = '(1*complex(0,1)*g2*ZEL11)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4130 = Coupling(name = 'GC_4130',
	 value = '(1*complex(0,1)*g2*ZEL21)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4131 = Coupling(name = 'GC_4131',
	 value = '(1*complex(0,1)*g2*ZEL31)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4132 = Coupling(name = 'GC_4132',
	 value = '(1*complex(0,1)*g2*ZEL12)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4133 = Coupling(name = 'GC_4133',
	 value = '(1*complex(0,1)*g2*ZEL22)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4134 = Coupling(name = 'GC_4134',
	 value = '(1*complex(0,1)*g2*ZEL32)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4135 = Coupling(name = 'GC_4135',
	 value = '(1*complex(0,1)*g2*ZEL13)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4136 = Coupling(name = 'GC_4136',
	 value = '(1*complex(0,1)*g2*ZEL23)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4137 = Coupling(name = 'GC_4137',
	 value = '(1*complex(0,1)*g2*ZEL33)/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4138 = Coupling(name = 'GC_4138',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4139 = Coupling(name = 'GC_4139',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4140 = Coupling(name = 'GC_4140',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4141 = Coupling(name = 'GC_4141',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4142 = Coupling(name = 'GC_4142',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4143 = Coupling(name = 'GC_4143',
	 value = '1*complex(0,1)*G', 
	 order = {'QCD':1} ) 
 
GC_4144 = Coupling(name = 'GC_4144',
	 value = '1./6.*complex(0,1)*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4145 = Coupling(name = 'GC_4145',
	 value = '2./3.*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4146 = Coupling(name = 'GC_4146',
	 value = '1./6.*complex(0,1)*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4147 = Coupling(name = 'GC_4147',
	 value = '2./3.*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4148 = Coupling(name = 'GC_4148',
	 value = '1./6.*complex(0,1)*(g1*cmath.cos(TW) + 3*g2*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4149 = Coupling(name = 'GC_4149',
	 value = '2./3.*complex(0,1)*g1*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4150 = Coupling(name = 'GC_4150',
	 value = '(1*complex(0,1)*g2*(ZDL11*complexconjugate(ZUL11) + ZDL12*complexconjugate(ZUL12) + ZDL13*complexconjugate(ZUL13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4151 = Coupling(name = 'GC_4151',
	 value = '(1*complex(0,1)*g2*(ZDL11*complexconjugate(ZUL21) + ZDL12*complexconjugate(ZUL22) + ZDL13*complexconjugate(ZUL23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4152 = Coupling(name = 'GC_4152',
	 value = '(1*complex(0,1)*g2*(ZDL11*complexconjugate(ZUL31) + ZDL12*complexconjugate(ZUL32) + ZDL13*complexconjugate(ZUL33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4153 = Coupling(name = 'GC_4153',
	 value = '(1*complex(0,1)*g2*(ZDL21*complexconjugate(ZUL11) + ZDL22*complexconjugate(ZUL12) + ZDL23*complexconjugate(ZUL13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4154 = Coupling(name = 'GC_4154',
	 value = '(1*complex(0,1)*g2*(ZDL21*complexconjugate(ZUL21) + ZDL22*complexconjugate(ZUL22) + ZDL23*complexconjugate(ZUL23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4155 = Coupling(name = 'GC_4155',
	 value = '(1*complex(0,1)*g2*(ZDL21*complexconjugate(ZUL31) + ZDL22*complexconjugate(ZUL32) + ZDL23*complexconjugate(ZUL33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4156 = Coupling(name = 'GC_4156',
	 value = '(1*complex(0,1)*g2*(ZDL31*complexconjugate(ZUL11) + ZDL32*complexconjugate(ZUL12) + ZDL33*complexconjugate(ZUL13)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4157 = Coupling(name = 'GC_4157',
	 value = '(1*complex(0,1)*g2*(ZDL31*complexconjugate(ZUL21) + ZDL32*complexconjugate(ZUL22) + ZDL33*complexconjugate(ZUL23)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4158 = Coupling(name = 'GC_4158',
	 value = '(1*complex(0,1)*g2*(ZDL31*complexconjugate(ZUL31) + ZDL32*complexconjugate(ZUL32) + ZDL33*complexconjugate(ZUL33)))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4159 = Coupling(name = 'GC_4159',
	 value = '1./6.*complex(0,1)*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4160 = Coupling(name = 'GC_4160',
	 value = '-2./3.*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4161 = Coupling(name = 'GC_4161',
	 value = '1./6.*complex(0,1)*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4162 = Coupling(name = 'GC_4162',
	 value = '-2./3.*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4163 = Coupling(name = 'GC_4163',
	 value = '1./6.*complex(0,1)*(3*g2*cmath.cos(TW) - g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4164 = Coupling(name = 'GC_4164',
	 value = '-2./3.*complex(0,1)*g1*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4165 = Coupling(name = 'GC_4165',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL11))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4166 = Coupling(name = 'GC_4166',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL12))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4167 = Coupling(name = 'GC_4167',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL13))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4168 = Coupling(name = 'GC_4168',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL21))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4169 = Coupling(name = 'GC_4169',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL22))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4170 = Coupling(name = 'GC_4170',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL23))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4171 = Coupling(name = 'GC_4171',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL31))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4172 = Coupling(name = 'GC_4172',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL32))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4173 = Coupling(name = 'GC_4173',
	 value = '(1*complex(0,1)*g2*complexconjugate(ZEL33))/cmath.sqrt(2)', 
	 order = {'QED':1} ) 
 
GC_4174 = Coupling(name = 'GC_4174',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4175 = Coupling(name = 'GC_4175',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4176 = Coupling(name = 'GC_4176',
	 value = '1./2.*complex(0,1)*(g2*cmath.cos(TW) + g1*cmath.sin(TW))', 
	 order = {'QED':1} ) 
 
GC_4177 = Coupling(name = 'GC_4177',
	 value = '-(G*pG*complexconjugate(pG))', 
	 order = {'QCD':1} ) 
 
GC_4178 = Coupling(name = 'GC_4178',
	 value = '-(G*pG*complexconjugate(pG))', 
	 order = {'QCD':1} ) 
 
GC_4179 = Coupling(name = 'GC_4179',
	 value = 'G', 
	 order = {'QCD':1} ) 
 
GC_4180 = Coupling(name = 'GC_4180',
	 value = '-1*complex(0,1)*g2*cmath.sin(TW)', 
	 order = {'QED':1} ) 
 
GC_4181 = Coupling(name = 'GC_4181',
	 value = '1*complex(0,1)*g2*cmath.cos(TW)', 
	 order = {'QED':1} ) 
 
GC_4182 = Coupling(name = 'GC_4182',
	 value = '-1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_4183 = Coupling(name = 'GC_4183',
	 value = '-1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_4184 = Coupling(name = 'GC_4184',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_4185 = Coupling(name = 'GC_4185',
	 value = '-1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_4186 = Coupling(name = 'GC_4186',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_4187 = Coupling(name = 'GC_4187',
	 value = '1*complex(0,1)*G**2', 
	 order = {'QCD':2} ) 
 
GC_4188 = Coupling(name = 'GC_4188',
	 value = '1*complex(0,1)*g2**2*cmath.sin(TW)**2', 
	 order = {'QED':2} ) 
 
GC_4189 = Coupling(name = 'GC_4189',
	 value = '1*complex(0,1)*g2**2*cmath.sin(TW)**2', 
	 order = {'QED':2} ) 
 
GC_4190 = Coupling(name = 'GC_4190',
	 value = '-2*complex(0,1)*g2**2*cmath.sin(TW)**2', 
	 order = {'QED':2} ) 
 
GC_4191 = Coupling(name = 'GC_4191',
	 value = '1*complex(0,1)*g2**2*cmath.cos(TW)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_4192 = Coupling(name = 'GC_4192',
	 value = '-1*complex(0,1)*g2**2*cmath.sin(2*TW)', 
	 order = {'QED':2} ) 
 
GC_4193 = Coupling(name = 'GC_4193',
	 value = '1*complex(0,1)*g2**2*cmath.cos(TW)*cmath.sin(TW)', 
	 order = {'QED':2} ) 
 
GC_4194 = Coupling(name = 'GC_4194',
	 value = '2*complex(0,1)*g2**2', 
	 order = {'QED':2} ) 
 
GC_4195 = Coupling(name = 'GC_4195',
	 value = '-1*complex(0,1)*g2**2', 
	 order = {'QED':2} ) 
 
GC_4196 = Coupling(name = 'GC_4196',
	 value = '-1*complex(0,1)*g2**2', 
	 order = {'QED':2} ) 
 
GC_4197 = Coupling(name = 'GC_4197',
	 value = '-2*complex(0,1)*g2**2*cmath.cos(TW)**2', 
	 order = {'QED':2} ) 
 
GC_4198 = Coupling(name = 'GC_4198',
	 value = '1*complex(0,1)*g2**2*cmath.cos(TW)**2', 
	 order = {'QED':2} ) 
 
GC_4199 = Coupling(name = 'GC_4199',
	 value = '1*complex(0,1)*g2**2*cmath.cos(TW)**2', 
	 order = {'QED':2} ) 
 
