(* --------------------------------------------------------------------------------
   Autogenerated by the happy scrappy WHIZARD model file generator on 9/4/2014 , 19:48:20
   WHIZARD interface svn revision info: $Id: WOMathematicaInterface.m 3666 2012-01-14 17:03:09Z cnspeckn $
   Code generated for WHIZARD / O'Mega version 2.2.0
   Model name: mssm_sarah
   Gauge: Unitarity
   Maximum number of couplings per FORTRAN module: 150
   --------------------------------------------------------------------------------
   
   -------------------------------------------------------------------------------- *)

type gauge = Unitarity | Feynman | Rxi

module type Frules_options =
sig
   val gauge: gauge
   val color: bool
end

module Implementation (Opts: Frules_options) =
struct

   open Coupling

   (* Classes with their members *)

   type f15_Go =
      | Go_1
   type f1_Nu =
      | Nu1 | Nu1bar | Nu2 | Nu2bar | Nu3 | Nu3bar
   type f11_N =
      | N1 | N2 | N3 | N4
   type f12_C =
      | C1 | C1bar | C2 | C2bar
   type f2_E =
      | E1 | E1bar | E2 | E2bar | E3 | E3bar
   type f4_D =
      | D1 | D1bar | D2 | D2bar | D3 | D3bar
   type f3_U =
      | U1 | U1bar | U2 | U2bar | U3 | U3bar
   type s14_Sd =
      | Sd1 | Sd1c | Sd2 | Sd2c | Sd3 | Sd3c | Sd4 | Sd4c | Sd5 | Sd5c | Sd6 | Sd6c
   type s11_Sv =
      | Sv1 | Sv1c | Sv2 | Sv2c | Sv3 | Sv3c
   type s13_Su =
      | Su1 | Su1c | Su2 | Su2c | Su3 | Su3c | Su4 | Su4c | Su5 | Su5c | Su6 | Su6c
   type s12_Se =
      | Se1 | Se1c | Se2 | Se2c | Se3 | Se3c | Se4 | Se4c | Se5 | Se5c | Se6 | Se6c
   type s1_H =
      | H1 | H2
   type s2_Ah =
      | Ah1 | Ah2
   type s3_Hm =
      | Hm1 | Hm1c | Hm2 | Hm2c
   type v5_G =
      | G_1
   type v1_A =
      | A_1
   type v2_Z =
      | Z_1
   type v3_Wm =
      | Wm_1 | Wmc

   (* Lorentz types with the corresponding classes *)

   type scalar =
      | S14_Sd of s14_Sd | S11_Sv of s11_Sv | S13_Su of s13_Su | S12_Se of s12_Se
      | S1_H of s1_H | S2_Ah of s2_Ah | S3_Hm of s3_Hm
   type fermion =
      | F15_Go of f15_Go | F1_Nu of f1_Nu | F11_N of f11_N | F12_C of f12_C
      | F2_E of f2_E | F4_D of f4_D | F3_U of f3_U
   type vector =
      | V5_G of v5_G | V1_A of v1_A | V2_Z of v2_Z | V3_Wm of v3_Wm

   (* The actual flavor type *)

   type flavor =
      | FRS of scalar | FRF of fermion | FRV of vector

   (* Trampoline functions *)

   let fermion_of_f15_Go c = F15_Go c
   let fermion_of_f1_Nu c = F1_Nu c
   let fermion_of_f11_N c = F11_N c
   let fermion_of_f12_C c = F12_C c
   let fermion_of_f2_E c = F2_E c
   let fermion_of_f4_D c = F4_D c
   let fermion_of_f3_U c = F3_U c
   let scalar_of_s14_Sd c = S14_Sd c
   let scalar_of_s11_Sv c = S11_Sv c
   let scalar_of_s13_Su c = S13_Su c
   let scalar_of_s12_Se c = S12_Se c
   let scalar_of_s1_H c = S1_H c
   let scalar_of_s2_Ah c = S2_Ah c
   let scalar_of_s3_Hm c = S3_Hm c
   let vector_of_v5_G c = V5_G c
   let vector_of_v1_A c = V1_A c
   let vector_of_v2_Z c = V2_Z c
   let vector_of_v3_Wm c = V3_Wm c
   let flavor_of_scalar lt = FRS lt
   let flavor_of_fermion lt = FRF lt
   let flavor_of_vector lt = FRV lt

   (* Particle lists *)

   let f15_Go_members =
      [Go_1;]
   let f1_Nu_members =
      [Nu1; Nu1bar; Nu2; Nu2bar; Nu3; Nu3bar;]
   let f11_N_members =
      [N1; N2; N3; N4;]
   let f12_C_members =
      [C1; C1bar; C2; C2bar;]
   let f2_E_members =
      [E1; E1bar; E2; E2bar; E3; E3bar;]
   let f4_D_members =
      [D1; D1bar; D2; D2bar; D3; D3bar;]
   let f3_U_members =
      [U1; U1bar; U2; U2bar; U3; U3bar;]
   let s14_Sd_members =
      [Sd1; Sd1c; Sd2; Sd2c; Sd3; Sd3c; Sd4; Sd4c; Sd5; Sd5c; Sd6; Sd6c;]
   let s11_Sv_members =
      [Sv1; Sv1c; Sv2; Sv2c; Sv3; Sv3c;]
   let s13_Su_members =
      [Su1; Su1c; Su2; Su2c; Su3; Su3c; Su4; Su4c; Su5; Su5c; Su6; Su6c;]
   let s12_Se_members =
      [Se1; Se1c; Se2; Se2c; Se3; Se3c; Se4; Se4c; Se5; Se5c; Se6; Se6c;]
   let s1_H_members =
      [H1; H2;]
   let s2_Ah_members =
      [Ah1; Ah2;]
   let s3_Hm_members =
      [Hm1; Hm1c; Hm2; Hm2c;]
   let v5_G_members =
      [G_1;]
   let v1_A_members =
      [A_1;]
   let v2_Z_members =
      [Z_1;]
   let v3_Wm_members =
      [Wm_1; Wmc;]
   let all_scalars = []
      @ (List.map scalar_of_s14_Sd s14_Sd_members)
      @ (List.map scalar_of_s11_Sv s11_Sv_members)
      @ (List.map scalar_of_s13_Su s13_Su_members)
      @ (List.map scalar_of_s12_Se s12_Se_members)
      @ (List.map scalar_of_s1_H s1_H_members)
      @ (List.map scalar_of_s2_Ah s2_Ah_members)
      @ (List.map scalar_of_s3_Hm s3_Hm_members)
   let all_fermions = []
      @ (List.map fermion_of_f15_Go f15_Go_members)
      @ (List.map fermion_of_f1_Nu f1_Nu_members)
      @ (List.map fermion_of_f11_N f11_N_members)
      @ (List.map fermion_of_f12_C f12_C_members)
      @ (List.map fermion_of_f2_E f2_E_members)
      @ (List.map fermion_of_f4_D f4_D_members)
      @ (List.map fermion_of_f3_U f3_U_members)
   let all_vectors = []
      @ (List.map vector_of_v5_G v5_G_members)
      @ (List.map vector_of_v1_A v1_A_members)
      @ (List.map vector_of_v2_Z v2_Z_members)
      @ (List.map vector_of_v3_Wm v3_Wm_members)

   (* Orders *) 

   type orders = int * int 

   let orders = function  
       | _ -> (0,0) 


   (* The conjugation operation on a single class *)

   let conjugate_f15_Go = function 
      | x -> x
   let conjugate_f1_Nu = function 
      | Nu1 -> Nu1bar | Nu1bar -> Nu1 | Nu2 -> Nu2bar | Nu2bar -> Nu2 | Nu3 -> Nu3bar
      | Nu3bar -> Nu3
   let conjugate_f11_N = function 
      | x -> x
   let conjugate_f12_C = function 
      | C1 -> C1bar | C1bar -> C1 | C2 -> C2bar | C2bar -> C2
   let conjugate_f2_E = function 
      | E1 -> E1bar | E1bar -> E1 | E2 -> E2bar | E2bar -> E2 | E3 -> E3bar
      | E3bar -> E3
   let conjugate_f4_D = function 
      | D1 -> D1bar | D1bar -> D1 | D2 -> D2bar | D2bar -> D2 | D3 -> D3bar
      | D3bar -> D3
   let conjugate_f3_U = function 
      | U1 -> U1bar | U1bar -> U1 | U2 -> U2bar | U2bar -> U2 | U3 -> U3bar
      | U3bar -> U3
   let conjugate_s14_Sd = function 
      | Sd1 -> Sd1c | Sd1c -> Sd1 | Sd2 -> Sd2c | Sd2c -> Sd2 | Sd3 -> Sd3c
      | Sd3c -> Sd3 | Sd4 -> Sd4c | Sd4c -> Sd4 | Sd5 -> Sd5c | Sd5c -> Sd5
      | Sd6 -> Sd6c | Sd6c -> Sd6
   let conjugate_s11_Sv = function 
      | Sv1 -> Sv1c | Sv1c -> Sv1 | Sv2 -> Sv2c | Sv2c -> Sv2 | Sv3 -> Sv3c
      | Sv3c -> Sv3
   let conjugate_s13_Su = function 
      | Su1 -> Su1c | Su1c -> Su1 | Su2 -> Su2c | Su2c -> Su2 | Su3 -> Su3c
      | Su3c -> Su3 | Su4 -> Su4c | Su4c -> Su4 | Su5 -> Su5c | Su5c -> Su5
      | Su6 -> Su6c | Su6c -> Su6
   let conjugate_s12_Se = function 
      | Se1 -> Se1c | Se1c -> Se1 | Se2 -> Se2c | Se2c -> Se2 | Se3 -> Se3c
      | Se3c -> Se3 | Se4 -> Se4c | Se4c -> Se4 | Se5 -> Se5c | Se5c -> Se5
      | Se6 -> Se6c | Se6c -> Se6
   let conjugate_s1_H = function 
      | x -> x
   let conjugate_s2_Ah = function 
      | x -> x
   let conjugate_s3_Hm = function 
      | Hm1 -> Hm1c | Hm1c -> Hm1 | Hm2 -> Hm2c | Hm2c -> Hm2
   let conjugate_v5_G = function 
      | x -> x
   let conjugate_v1_A = function 
      | x -> x
   let conjugate_v2_Z = function 
      | x -> x
   let conjugate_v3_Wm = function 
      | Wm_1 -> Wmc | Wmc -> Wm_1

   (* The conjugation operation on a lorentz type *)

   let conjugate_scalar = function 
      | S14_Sd x -> S14_Sd (conjugate_s14_Sd x)
      | S11_Sv x -> S11_Sv (conjugate_s11_Sv x)
      | S13_Su x -> S13_Su (conjugate_s13_Su x)
      | S12_Se x -> S12_Se (conjugate_s12_Se x)
      | S1_H x -> S1_H (conjugate_s1_H x)
      | S2_Ah x -> S2_Ah (conjugate_s2_Ah x)
      | S3_Hm x -> S3_Hm (conjugate_s3_Hm x)
   let conjugate_fermion = function 
      | F15_Go x -> F15_Go (conjugate_f15_Go x)
      | F1_Nu x -> F1_Nu (conjugate_f1_Nu x)
      | F11_N x -> F11_N (conjugate_f11_N x)
      | F12_C x -> F12_C (conjugate_f12_C x)
      | F2_E x -> F2_E (conjugate_f2_E x)
      | F4_D x -> F4_D (conjugate_f4_D x)
      | F3_U x -> F3_U (conjugate_f3_U x)
   let conjugate_vector = function 
      | V5_G x -> V5_G (conjugate_v5_G x)
      | V1_A x -> V1_A (conjugate_v1_A x)
      | V2_Z x -> V2_Z (conjugate_v2_Z x)
      | V3_Wm x -> V3_Wm (conjugate_v3_Wm x)

   (* Conjugation for the masses *)

   let conjugate = function
      | FRS x -> FRS (conjugate_scalar x)
      | FRF x -> FRF (conjugate_fermion x)
      | FRV x -> FRV (conjugate_vector x)

   let color = function
      | FRS x -> (match x with 
         | S14_Sd x -> (match x with 
            | Sd1 | Sd2 | Sd3 | Sd4 | Sd5 | Sd6 -> Color.SUN 3
            | Sd1c | Sd2c | Sd3c | Sd4c | Sd5c | Sd6c -> Color.SUN (-3))

         | S11_Sv _ -> Color.Singlet
         | S13_Su x -> (match x with 
            | Su1 | Su2 | Su3 | Su4 | Su5 | Su6 -> Color.SUN 3
            | Su1c | Su2c | Su3c | Su4c | Su5c | Su6c -> Color.SUN (-3))

         | S12_Se _ -> Color.Singlet
         | S1_H _ -> Color.Singlet
         | S2_Ah _ -> Color.Singlet
         | S3_Hm _ -> Color.Singlet)
      | FRF x -> (match x with 
         | F15_Go Go_1 -> Color.AdjSUN 3
         | F1_Nu _ -> Color.Singlet
         | F11_N _ -> Color.Singlet
         | F12_C _ -> Color.Singlet
         | F2_E _ -> Color.Singlet
         | F4_D x -> (match x with 
            | D1 | D2 | D3 -> Color.SUN 3 | D1bar | D2bar | D3bar -> Color.SUN (-3))

         | F3_U x -> (match x with 
            | U1 | U2 | U3 -> Color.SUN 3 | U1bar | U2bar | U3bar -> Color.SUN (-3)))
      | FRV x -> (match x with 
         | V5_G G_1 -> Color.AdjSUN 3
         | V1_A _ -> Color.Singlet
         | V2_Z _ -> Color.Singlet
         | V3_Wm _ -> Color.Singlet)

   let pdg = function
      | FRS x -> (match x with 
         | S14_Sd x -> (match x with 
            | Sd1 -> 1000001 | Sd1c -> -1000001 | Sd2 -> 1000003 | Sd2c -> -1000003
            | Sd3 -> 1000005 | Sd3c -> -1000005 | Sd4 -> 2000001 | Sd4c -> -2000001
            | Sd5 -> 2000003 | Sd5c -> -2000003 | Sd6 -> 2000005 | Sd6c -> -2000005)

         | S11_Sv x -> (match x with 
            | Sv1 -> 1000012 | Sv1c -> -1000012 | Sv2 -> 1000014 | Sv2c -> -1000014
            | Sv3 -> 1000016 | Sv3c -> -1000016)
         | S13_Su x -> (match x with 
            | Su1 -> 1000002 | Su1c -> -1000002 | Su2 -> 1000004 | Su2c -> -1000004
            | Su3 -> 1000006 | Su3c -> -1000006 | Su4 -> 2000002 | Su4c -> -2000002
            | Su5 -> 2000004 | Su5c -> -2000004 | Su6 -> 2000006 | Su6c -> -2000006)

         | S12_Se x -> (match x with 
            | Se1 -> 1000011 | Se1c -> -1000011 | Se2 -> 1000013 | Se2c -> -1000013
            | Se3 -> 1000015 | Se3c -> -1000015 | Se4 -> 2000011 | Se4c -> -2000011
            | Se5 -> 2000013 | Se5c -> -2000013 | Se6 -> 2000015 | Se6c -> -2000015)

         | S1_H x -> (match x with 
            | H1 -> 25 | H2 -> 35)
         | S2_Ah x -> (match x with 
            | Ah1 -> 999900 | Ah2 -> 36)
         | S3_Hm x -> (match x with 
            | Hm1 -> 999901 | Hm1c -> -999901 | Hm2 -> -37 | Hm2c -> 37))
      | FRF x -> (match x with 
         | F15_Go Go_1 -> 1000021
         | F1_Nu x -> (match x with 
            | Nu1 -> 12 | Nu1bar -> -12 | Nu2 -> 14 | Nu2bar -> -14 | Nu3 -> 16
            | Nu3bar -> -16)
         | F11_N x -> (match x with 
            | N1 -> 1000022 | N2 -> 1000023 | N3 -> 1000025 | N4 -> 1000035)

         | F12_C x -> (match x with 
            | C1 -> -1000024 | C1bar -> 1000024 | C2 -> -1000037 | C2bar -> 1000037)

         | F2_E x -> (match x with 
            | E1 -> 11 | E1bar -> -11 | E2 -> 13 | E2bar -> -13 | E3 -> 15 | E3bar -> -15)

         | F4_D x -> (match x with 
            | D1 -> 1 | D1bar -> -1 | D2 -> 3 | D2bar -> -3 | D3 -> 5 | D3bar -> -5)

         | F3_U x -> (match x with 
            | U1 -> 2 | U1bar -> -2 | U2 -> 4 | U2bar -> -4 | U3 -> 6 | U3bar -> -6))
      | FRV x -> (match x with 
         | V5_G G_1 -> 21
         | V1_A A_1 -> 22
         | V2_Z Z_1 -> 23
         | V3_Wm x -> (match x with 
            | Wm_1 -> -24 | Wmc -> 24))

   let lorentz = function
      | FRF x -> (match x with 
         | F15_Go Go_1 -> Majorana
         | F1_Nu x -> (match x with 
            | Nu1 | Nu2 | Nu3 -> Spinor | Nu1bar | Nu2bar | Nu3bar -> ConjSpinor)

         | F11_N x -> (match x with 
            | N1 | N2 | N3 | N4 -> Majorana)
         | F12_C x -> (match x with 
            | C1 | C2 -> Spinor | C1bar | C2bar -> ConjSpinor)
         | F2_E x -> (match x with 
            | E1 | E2 | E3 -> Spinor | E1bar | E2bar | E3bar -> ConjSpinor)

         | F4_D x -> (match x with 
            | D1 | D2 | D3 -> Spinor | D1bar | D2bar | D3bar -> ConjSpinor)

         | F3_U x -> (match x with 
            | U1 | U2 | U3 -> Spinor | U1bar | U2bar | U3bar -> ConjSpinor))
      | FRV x -> (match x with 
         | V5_G G_1 -> Vector
         | V1_A A_1 -> Vector
         | V2_Z Z_1 -> Massive_Vector
         | V3_Wm x -> (match x with 
            | Wm_1 | Wmc -> Massive_Vector))
      | FRS _ -> Scalar

   type gauge = Xi

   let propagator = 
      let msg = "mssm_sarah.Implementation: invalid lorentz rep in propagator" in function
      | FRS _ -> Prop_Scalar
      | FRF x -> (match lorentz (FRF x) with
         | Spinor -> Prop_Spinor
         | ConjSpinor -> Prop_ConjSpinor
         | Majorana -> Prop_Majorana
         | _ -> invalid_arg msg)
      | FRV x -> (match Opts.gauge with
         | Unitarity -> (match lorentz (FRV x) with
            | Vector -> Prop_Feynman
            | Massive_Vector -> Prop_Unitarity
            | _ -> invalid_arg msg)
         | Feynman -> (match lorentz (FRV x) with
            | Vector -> Prop_Feynman
            | Massive_Vector -> Prop_Rxi Xi
            | _ -> invalid_arg msg)
         | Rxi -> (match lorentz (FRV x) with
            | Vector -> Prop_Gauge Xi
            | Massive_Vector -> Prop_Rxi Xi
            | _ -> invalid_arg msg))

   let width_symbol = function
      | FRS x -> (match x with 
         | S14_Sd x -> (match x with 
            | Sd1 -> "wsd1" | Sd1c -> "wsd1" | Sd2 -> "wsd2" | Sd2c -> "wsd2" | Sd3 -> "wsd3"
            | Sd3c -> "wsd3" | Sd4 -> "wsd4" | Sd4c -> "wsd4" | Sd5 -> "wsd5"
            | Sd5c -> "wsd5" | Sd6 -> "wsd6" | Sd6c -> "wsd6")

         | S11_Sv x -> (match x with 
            | Sv1 -> "wsv1" | Sv1c -> "wsv1" | Sv2 -> "wsv2" | Sv2c -> "wsv2" | Sv3 -> "wsv3"
            | Sv3c -> "wsv3")
         | S13_Su x -> (match x with 
            | Su1 -> "wsu1" | Su1c -> "wsu1" | Su2 -> "wsu2" | Su2c -> "wsu2" | Su3 -> "wsu3"
            | Su3c -> "wsu3" | Su4 -> "wsu4" | Su4c -> "wsu4" | Su5 -> "wsu5"
            | Su5c -> "wsu5" | Su6 -> "wsu6" | Su6c -> "wsu6")

         | S12_Se x -> (match x with 
            | Se1 -> "wse1" | Se1c -> "wse1" | Se2 -> "wse2" | Se2c -> "wse2" | Se3 -> "wse3"
            | Se3c -> "wse3" | Se4 -> "wse4" | Se4c -> "wse4" | Se5 -> "wse5"
            | Se5c -> "wse5" | Se6 -> "wse6" | Se6c -> "wse6")
         | S1_H x -> (match x with 
            | H1 -> "wh1" | H2 -> "wh2")
         | S2_Ah x -> (match x with 
            | Ah2 -> "wah2" | _ -> "fr_zero")
         | S3_Hm x -> (match x with 
            | Hm2 -> "whm2" | Hm2c -> "whm2" | _ -> "fr_zero"))
      | FRF x -> (match x with 
         | F15_Go Go_1 -> "wgo"
         | F1_Nu _ -> "fr_zero"
         | F11_N x -> (match x with 
            | N1 -> "wn1" | N2 -> "wn2" | N3 -> "wn3" | N4 -> "wn4")

         | F12_C x -> (match x with 
            | C1 -> "wc1" | C1bar -> "wc1" | C2 -> "wc2" | C2bar -> "wc2")

         | F2_E _ -> "fr_zero"
         | F4_D _ -> "fr_zero"
         | F3_U x -> (match x with 
            | U3 -> "wu3" | U3bar -> "wu3" | _ -> "fr_zero"))
      | FRV x -> (match x with 
         | V5_G _ -> "fr_zero"
         | V1_A _ -> "fr_zero"
         | V2_Z Z_1 -> "wz"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "wwm" | Wmc -> "wwm"))

   let width x = match width_symbol x with 
      | "fr_zero" -> Vanishing
      | _ -> Timelike

   let fermion x = (match lorentz x with
      | Spinor -> 1 | ConjSpinor -> -1 | Majorana -> 2 | _ -> 0)

   let colsymm _ = (0, false), (0, false)

   let flavors () = []
      @ (List.map flavor_of_scalar all_scalars)
      @ (List.map flavor_of_fermion all_fermions)
      @ (List.map flavor_of_vector all_vectors)

   let external_flavors () = ["Autogenerated flavors", flavors ()]

   let goldstone _ = None

   let flavor_to_string = function
      | FRS x -> (match x with 
         | S14_Sd x -> (match x with 
            | Sd1 -> "sd1" | Sd1c -> "sd1c" | Sd2 -> "sd2" | Sd2c -> "sd2c" | Sd3 -> "sd3"
            | Sd3c -> "sd3c" | Sd4 -> "sd4" | Sd4c -> "sd4c" | Sd5 -> "sd5"
            | Sd5c -> "sd5c" | Sd6 -> "sd6" | Sd6c -> "sd6c")
         | S11_Sv x -> (match x with 
            | Sv1 -> "sv1" | Sv1c -> "sv1c" | Sv2 -> "sv2" | Sv2c -> "sv2c" | Sv3 -> "sv3"
            | Sv3c -> "sv3c")
         | S13_Su x -> (match x with 
            | Su1 -> "su1" | Su1c -> "su1c" | Su2 -> "su2" | Su2c -> "su2c" | Su3 -> "su3"
            | Su3c -> "su3c" | Su4 -> "su4" | Su4c -> "su4c" | Su5 -> "su5"
            | Su5c -> "su5c" | Su6 -> "su6" | Su6c -> "su6c")
         | S12_Se x -> (match x with 
            | Se1 -> "se1" | Se1c -> "se1c" | Se2 -> "se2" | Se2c -> "se2c" | Se3 -> "se3"
            | Se3c -> "se3c" | Se4 -> "se4" | Se4c -> "se4c" | Se5 -> "se5"
            | Se5c -> "se5c" | Se6 -> "se6" | Se6c -> "se6c")
         | S1_H x -> (match x with 
            | H1 -> "h1" | H2 -> "h2")
         | S2_Ah x -> (match x with 
            | Ah1 -> "Ah1" | Ah2 -> "Ah2")
         | S3_Hm x -> (match x with 
            | Hm1 -> "Hm1" | Hm1c -> "Hm1c" | Hm2 -> "Hm2" | Hm2c -> "Hm2c"))
      | FRF x -> (match x with 
         | F15_Go Go_1 -> "go"
         | F1_Nu x -> (match x with 
            | Nu1 -> "nu1" | Nu1bar -> "nu1bar" | Nu2 -> "nu2" | Nu2bar -> "nu2bar"
            | Nu3 -> "nu3" | Nu3bar -> "nu3bar")
         | F11_N x -> (match x with 
            | N1 -> "N1" | N2 -> "N2" | N3 -> "N3" | N4 -> "N4")

         | F12_C x -> (match x with 
            | C1 -> "C1" | C1bar -> "C1bar" | C2 -> "C2" | C2bar -> "C2bar")

         | F2_E x -> (match x with 
            | E1 -> "e1" | E1bar -> "e1bar" | E2 -> "e2" | E2bar -> "e2bar" | E3 -> "e3"
            | E3bar -> "e3bar")
         | F4_D x -> (match x with 
            | D1 -> "d1" | D1bar -> "d1bar" | D2 -> "d2" | D2bar -> "d2bar" | D3 -> "d3"
            | D3bar -> "d3bar")
         | F3_U x -> (match x with 
            | U1 -> "u1" | U1bar -> "u1bar" | U2 -> "u2" | U2bar -> "u2bar" | U3 -> "u3"
            | U3bar -> "u3bar"))
      | FRV x -> (match x with 
         | V5_G G_1 -> "g"
         | V1_A A_1 -> "A"
         | V2_Z Z_1 -> "Z"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "Wm" | Wmc -> "Wmc"))

   let flavor_to_TeX = function
      | FRS x -> (match x with 
         | S14_Sd x -> (match x with 
            | Sd1 -> "{\\tilde{d}}_1" | Sd1c -> "{\\tilde{d}^*}_1" | Sd2 -> "{\\tilde{d}}_2"
            | Sd2c -> "{\\tilde{d}^*}_2" | Sd3 -> "{\\tilde{d}}_3"
            | Sd3c -> "{\\tilde{d}^*}_3" | Sd4 -> "{\\tilde{d}}_4"
            | Sd4c -> "{\\tilde{d}^*}_4" | Sd5 -> "{\\tilde{d}}_5"
            | Sd5c -> "{\\tilde{d}^*}_5" | Sd6 -> "{\\tilde{d}}_6"
            | Sd6c -> "{\\tilde{d}^*}_6")
         | S11_Sv x -> (match x with 
            | Sv1 -> "{\\tilde{\\nu}}_1" | Sv1c -> "{\\tilde{\\nu}^*}_1"
            | Sv2 -> "{\\tilde{\\nu}}_2" | Sv2c -> "{\\tilde{\\nu}^*}_2"
            | Sv3 -> "{\\tilde{\\nu}}_3" | Sv3c -> "{\\tilde{\\nu}^*}_3")

         | S13_Su x -> (match x with 
            | Su1 -> "{\\tilde{u}}_1" | Su1c -> "{\\tilde{u}^*}_1" | Su2 -> "{\\tilde{u}}_2"
            | Su2c -> "{\\tilde{u}^*}_2" | Su3 -> "{\\tilde{u}}_3"
            | Su3c -> "{\\tilde{u}^*}_3" | Su4 -> "{\\tilde{u}}_4"
            | Su4c -> "{\\tilde{u}^*}_4" | Su5 -> "{\\tilde{u}}_5"
            | Su5c -> "{\\tilde{u}^*}_5" | Su6 -> "{\\tilde{u}}_6"
            | Su6c -> "{\\tilde{u}^*}_6")
         | S12_Se x -> (match x with 
            | Se1 -> "{\\tilde{e}}_1" | Se1c -> "{\\tilde{e}^*}_1" | Se2 -> "{\\tilde{e}}_2"
            | Se2c -> "{\\tilde{e}^*}_2" | Se3 -> "{\\tilde{e}}_3"
            | Se3c -> "{\\tilde{e}^*}_3" | Se4 -> "{\\tilde{e}}_4"
            | Se4c -> "{\\tilde{e}^*}_4" | Se5 -> "{\\tilde{e}}_5"
            | Se5c -> "{\\tilde{e}^*}_5" | Se6 -> "{\\tilde{e}}_6"
            | Se6c -> "{\\tilde{e}^*}_6")
         | S1_H x -> (match x with 
            | H1 -> "{h}_1" | H2 -> "{h}_2")
         | S2_Ah x -> (match x with 
            | Ah1 -> "{A^0}_1" | Ah2 -> "{A^0}_2")
         | S3_Hm x -> (match x with 
            | Hm1 -> "{H^-}_1" | Hm1c -> "{H^+}_1" | Hm2 -> "{H^-}_2" | Hm2c -> "{H^+}_2"))
      | FRF x -> (match x with 
         | F15_Go Go_1 -> "\\tilde{g}"
         | F1_Nu x -> (match x with 
            | Nu1 -> "{\\nu}_1" | Nu1bar -> "{\\bar{\\nu}}_1" | Nu2 -> "{\\nu}_2"
            | Nu2bar -> "{\\bar{\\nu}}_2" | Nu3 -> "{\\nu}_3" | Nu3bar -> "{\\bar{\\nu}}_3")

         | F11_N x -> (match x with 
            | N1 -> "{\\tilde{\\chi}^0}_1" | N2 -> "{\\tilde{\\chi}^0}_2"
            | N3 -> "{\\tilde{\\chi}^0}_3" | N4 -> "{\\tilde{\\chi}^0}_4")

         | F12_C x -> (match x with 
            | C1 -> "{\\tilde{\\chi}^-}_1" | C1bar -> "{\\tilde{\\chi}^+}_1"
            | C2 -> "{\\tilde{\\chi}^-}_2" | C2bar -> "{\\tilde{\\chi}^+}_2")

         | F2_E x -> (match x with 
            | E1 -> "{e}_1" | E1bar -> "{\\bar{e}}_1" | E2 -> "{e}_2"
            | E2bar -> "{\\bar{e}}_2" | E3 -> "{e}_3" | E3bar -> "{\\bar{e}}_3")

         | F4_D x -> (match x with 
            | D1 -> "{d}_1" | D1bar -> "{\\bar{d}}_1" | D2 -> "{d}_2"
            | D2bar -> "{\\bar{d}}_2" | D3 -> "{d}_3" | D3bar -> "{\\bar{d}}_3")

         | F3_U x -> (match x with 
            | U1 -> "{u}_1" | U1bar -> "{\\bar{u}}_1" | U2 -> "{u}_2"
            | U2bar -> "{\\bar{u}}_2" | U3 -> "{u}_3" | U3bar -> "{\\bar{u}}_3"))
      | FRV x -> (match x with 
         | V5_G G_1 -> "g"
         | V1_A A_1 -> "\\gamma"
         | V2_Z Z_1 -> "Z"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "W^-" | Wmc -> "W^+"))

   let flavor_of_string x =
      let dict = List.map (fun x -> (x, flavor_to_string x)) (flavors ())
      in try
         fst (List.find (fun (_, y) -> (x = y)) dict)
      with
         Not_found -> invalid_arg "mssm_sarah.Implementation: flavor_of_string: invalid particle?"

   let flavor_symbol = function
      | FRS x -> (match x with 
         | S14_Sd x -> (match x with 
            | Sd1 -> "sd1" | Sd1c -> "sd1c" | Sd2 -> "sd2" | Sd2c -> "sd2c" | Sd3 -> "sd3"
            | Sd3c -> "sd3c" | Sd4 -> "sd4" | Sd4c -> "sd4c" | Sd5 -> "sd5"
            | Sd5c -> "sd5c" | Sd6 -> "sd6" | Sd6c -> "sd6c")
         | S11_Sv x -> (match x with 
            | Sv1 -> "sv1" | Sv1c -> "sv1c" | Sv2 -> "sv2" | Sv2c -> "sv2c" | Sv3 -> "sv3"
            | Sv3c -> "sv3c")
         | S13_Su x -> (match x with 
            | Su1 -> "su1" | Su1c -> "su1c" | Su2 -> "su2" | Su2c -> "su2c" | Su3 -> "su3"
            | Su3c -> "su3c" | Su4 -> "su4" | Su4c -> "su4c" | Su5 -> "su5"
            | Su5c -> "su5c" | Su6 -> "su6" | Su6c -> "su6c")
         | S12_Se x -> (match x with 
            | Se1 -> "se1" | Se1c -> "se1c" | Se2 -> "se2" | Se2c -> "se2c" | Se3 -> "se3"
            | Se3c -> "se3c" | Se4 -> "se4" | Se4c -> "se4c" | Se5 -> "se5"
            | Se5c -> "se5c" | Se6 -> "se6" | Se6c -> "se6c")
         | S1_H x -> (match x with 
            | H1 -> "h1" | H2 -> "h2")
         | S2_Ah x -> (match x with 
            | Ah1 -> "ah1" | Ah2 -> "ah2")
         | S3_Hm x -> (match x with 
            | Hm1 -> "hm1" | Hm1c -> "hm1c" | Hm2 -> "hm2" | Hm2c -> "hm2c"))
      | FRF x -> (match x with 
         | F15_Go Go_1 -> "go_1"
         | F1_Nu x -> (match x with 
            | Nu1 -> "nu1" | Nu1bar -> "nu1bar" | Nu2 -> "nu2" | Nu2bar -> "nu2bar"
            | Nu3 -> "nu3" | Nu3bar -> "nu3bar")
         | F11_N x -> (match x with 
            | N1 -> "n1" | N2 -> "n2" | N3 -> "n3" | N4 -> "n4")

         | F12_C x -> (match x with 
            | C1 -> "c1" | C1bar -> "c1bar" | C2 -> "c2" | C2bar -> "c2bar")

         | F2_E x -> (match x with 
            | E1 -> "e1" | E1bar -> "e1bar" | E2 -> "e2" | E2bar -> "e2bar" | E3 -> "e3"
            | E3bar -> "e3bar")
         | F4_D x -> (match x with 
            | D1 -> "d1" | D1bar -> "d1bar" | D2 -> "d2" | D2bar -> "d2bar" | D3 -> "d3"
            | D3bar -> "d3bar")
         | F3_U x -> (match x with 
            | U1 -> "u1" | U1bar -> "u1bar" | U2 -> "u2" | U2bar -> "u2bar" | U3 -> "u3"
            | U3bar -> "u3bar"))
      | FRV x -> (match x with 
         | V5_G G_1 -> "g_1"
         | V1_A A_1 -> "a_1"
         | V2_Z Z_1 -> "z_1"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "wm_1" | Wmc -> "wmc"))

   let gauge_symbol = function
      Xi -> (match Opts.gauge with
         | Unitarity -> invalid_arg
            "mssm_sarah.Implementation: requesting gauge symbol in unitarity gauge!"
         | Feynman -> "one"
         | Rxi -> "Rxi")

   let mass_symbol = function
      | FRS x -> (match x with 
         | S14_Sd x -> (match x with 
            | Sd1 -> "msd1" | Sd1c -> "msd1" | Sd2 -> "msd2" | Sd2c -> "msd2" | Sd3 -> "msd3"
            | Sd3c -> "msd3" | Sd4 -> "msd4" | Sd4c -> "msd4" | Sd5 -> "msd5"
            | Sd5c -> "msd5" | Sd6 -> "msd6" | Sd6c -> "msd6")

         | S11_Sv x -> (match x with 
            | Sv1 -> "msv1" | Sv1c -> "msv1" | Sv2 -> "msv2" | Sv2c -> "msv2" | Sv3 -> "msv3"
            | Sv3c -> "msv3")
         | S13_Su x -> (match x with 
            | Su1 -> "msu1" | Su1c -> "msu1" | Su2 -> "msu2" | Su2c -> "msu2" | Su3 -> "msu3"
            | Su3c -> "msu3" | Su4 -> "msu4" | Su4c -> "msu4" | Su5 -> "msu5"
            | Su5c -> "msu5" | Su6 -> "msu6" | Su6c -> "msu6")

         | S12_Se x -> (match x with 
            | Se1 -> "mse1" | Se1c -> "mse1" | Se2 -> "mse2" | Se2c -> "mse2" | Se3 -> "mse3"
            | Se3c -> "mse3" | Se4 -> "mse4" | Se4c -> "mse4" | Se5 -> "mse5"
            | Se5c -> "mse5" | Se6 -> "mse6" | Se6c -> "mse6")
         | S1_H x -> (match x with 
            | H1 -> "mh1" | H2 -> "mh2")
         | S2_Ah x -> (match x with 
            | Ah2 -> "mah2" | _ -> "fr_zero")
         | S3_Hm x -> (match x with 
            | Hm2 -> "mhm2" | Hm2c -> "mhm2" | _ -> "fr_zero"))
      | FRF x -> (match x with 
         | F15_Go Go_1 -> "mgo"
         | F1_Nu _ -> "fr_zero"
         | F11_N x -> (match x with 
            | N1 -> "mn1" | N2 -> "mn2" | N3 -> "mn3" | N4 -> "mn4")

         | F12_C x -> (match x with 
            | C1 -> "mc1" | C1bar -> "mc1" | C2 -> "mc2" | C2bar -> "mc2")

         | F2_E x -> (match x with 
            | E1 -> "me1" | E1bar -> "me1" | E2 -> "me2" | E2bar -> "me2" | E3 -> "me3"
            | E3bar -> "me3")
         | F4_D x -> (match x with 
            | D1 -> "md1" | D1bar -> "md1" | D2 -> "md2" | D2bar -> "md2" | D3 -> "md3"
            | D3bar -> "md3")
         | F3_U x -> (match x with 
            | U1 -> "mu1" | U1bar -> "mu1" | U2 -> "mu2" | U2bar -> "mu2" | U3 -> "mu3"
            | U3bar -> "mu3"))
      | FRV x -> (match x with 
         | V5_G _ -> "fr_zero"
         | V1_A _ -> "fr_zero"
         | V2_Z Z_1 -> "mz"
         | V3_Wm x -> (match x with 
            | Wm_1 -> "mwm" | Wmc -> "mwm"))

   (* Coupling constants and parameters *)

   type constant =
      | G_ah2_ah2_h1 | G_ah2_ah2_h2 | G_ah2_sd1_sd1c | G_ah2_sd1_sd2c | G_ah2_sd1_sd3c
      | G_ah2_sd1_sd4c | G_ah2_sd1_sd5c | G_ah2_sd1_sd6c | G_ah2_sd2_sd1c
      | G_ah2_sd2_sd2c | G_ah2_sd2_sd3c | G_ah2_sd2_sd4c | G_ah2_sd2_sd5c
      | G_ah2_sd2_sd6c | G_ah2_sd3_sd1c | G_ah2_sd3_sd2c | G_ah2_sd3_sd3c
      | G_ah2_sd3_sd4c | G_ah2_sd3_sd5c | G_ah2_sd3_sd6c | G_ah2_sd4_sd1c
      | G_ah2_sd4_sd2c | G_ah2_sd4_sd3c | G_ah2_sd4_sd4c | G_ah2_sd4_sd5c
      | G_ah2_sd4_sd6c | G_ah2_sd5_sd1c | G_ah2_sd5_sd2c | G_ah2_sd5_sd3c
      | G_ah2_sd5_sd4c | G_ah2_sd5_sd5c | G_ah2_sd5_sd6c | G_ah2_sd6_sd1c
      | G_ah2_sd6_sd2c | G_ah2_sd6_sd3c | G_ah2_sd6_sd4c | G_ah2_sd6_sd5c
      | G_ah2_sd6_sd6c | G_ah2_se1_se1c | G_ah2_se1_se2c | G_ah2_se1_se3c
      | G_ah2_se1_se4c | G_ah2_se1_se5c | G_ah2_se1_se6c | G_ah2_se2_se1c
      | G_ah2_se2_se2c | G_ah2_se2_se3c | G_ah2_se2_se4c | G_ah2_se2_se5c
      | G_ah2_se2_se6c | G_ah2_se3_se1c | G_ah2_se3_se2c | G_ah2_se3_se3c
      | G_ah2_se3_se4c | G_ah2_se3_se5c | G_ah2_se3_se6c | G_ah2_se4_se1c
      | G_ah2_se4_se2c | G_ah2_se4_se3c | G_ah2_se4_se4c | G_ah2_se4_se5c
      | G_ah2_se4_se6c | G_ah2_se5_se1c | G_ah2_se5_se2c | G_ah2_se5_se3c
      | G_ah2_se5_se4c | G_ah2_se5_se5c | G_ah2_se5_se6c | G_ah2_se6_se1c
      | G_ah2_se6_se2c | G_ah2_se6_se3c | G_ah2_se6_se4c | G_ah2_se6_se5c
      | G_ah2_se6_se6c | G_ah2_su1_su1c | G_ah2_su1_su2c | G_ah2_su1_su3c
      | G_ah2_su1_su4c | G_ah2_su1_su5c | G_ah2_su1_su6c | G_ah2_su2_su1c
      | G_ah2_su2_su2c | G_ah2_su2_su3c | G_ah2_su2_su4c | G_ah2_su2_su5c
      | G_ah2_su2_su6c | G_ah2_su3_su1c | G_ah2_su3_su2c | G_ah2_su3_su3c
      | G_ah2_su3_su4c | G_ah2_su3_su5c | G_ah2_su3_su6c | G_ah2_su4_su1c
      | G_ah2_su4_su2c | G_ah2_su4_su3c | G_ah2_su4_su4c | G_ah2_su4_su5c
      | G_ah2_su4_su6c | G_ah2_su5_su1c | G_ah2_su5_su2c | G_ah2_su5_su3c
      | G_ah2_su5_su4c | G_ah2_su5_su5c | G_ah2_su5_su6c | G_ah2_su6_su1c
      | G_ah2_su6_su2c | G_ah2_su6_su3c | G_ah2_su6_su4c | G_ah2_su6_su5c
      | G_ah2_su6_su6c | G_h1_h1_h1 | G_h1_h1_h2 | G_h1_h2_h2 | G_h2_h2_h2
      | G_h1_hm2_hm2c | G_h2_hm2_hm2c | G_h1_sd1_sd1c | G_h1_sd1_sd2c | G_h1_sd1_sd3c
      | G_h1_sd1_sd4c | G_h1_sd1_sd5c | G_h1_sd1_sd6c | G_h1_sd2_sd1c | G_h1_sd2_sd2c
      | G_h1_sd2_sd3c | G_h1_sd2_sd4c | G_h1_sd2_sd5c | G_h1_sd2_sd6c | G_h1_sd3_sd1c
      | G_h1_sd3_sd2c | G_h1_sd3_sd3c | G_h1_sd3_sd4c | G_h1_sd3_sd5c | G_h1_sd3_sd6c
      | G_h1_sd4_sd1c | G_h1_sd4_sd2c | G_h1_sd4_sd3c | G_h1_sd4_sd4c | G_h1_sd4_sd5c
      | G_h1_sd4_sd6c | G_h1_sd5_sd1c | G_h1_sd5_sd2c | G_h1_sd5_sd3c | G_h1_sd5_sd4c
      | G_h1_sd5_sd5c | G_h1_sd5_sd6c | G_h1_sd6_sd1c | G_h1_sd6_sd2c | G_h1_sd6_sd3c
      | G_h1_sd6_sd4c | G_h1_sd6_sd5c | G_h1_sd6_sd6c | G_h2_sd1_sd1c | G_h2_sd1_sd2c
      | G_h2_sd1_sd3c | G_h2_sd1_sd4c | G_h2_sd1_sd5c | G_h2_sd1_sd6c | G_h2_sd2_sd1c
      | G_h2_sd2_sd2c | G_h2_sd2_sd3c | G_h2_sd2_sd4c | G_h2_sd2_sd5c | G_h2_sd2_sd6c
      | G_h2_sd3_sd1c | G_h2_sd3_sd2c | G_h2_sd3_sd3c | G_h2_sd3_sd4c | G_h2_sd3_sd5c
      | G_h2_sd3_sd6c | G_h2_sd4_sd1c | G_h2_sd4_sd2c | G_h2_sd4_sd3c | G_h2_sd4_sd4c
      | G_h2_sd4_sd5c | G_h2_sd4_sd6c | G_h2_sd5_sd1c | G_h2_sd5_sd2c | G_h2_sd5_sd3c
      | G_h2_sd5_sd4c | G_h2_sd5_sd5c | G_h2_sd5_sd6c | G_h2_sd6_sd1c | G_h2_sd6_sd2c
      | G_h2_sd6_sd3c | G_h2_sd6_sd4c | G_h2_sd6_sd5c | G_h2_sd6_sd6c | G_h1_se1_se1c
      | G_h1_se1_se2c | G_h1_se1_se3c | G_h1_se1_se4c | G_h1_se1_se5c | G_h1_se1_se6c
      | G_h1_se2_se1c | G_h1_se2_se2c | G_h1_se2_se3c | G_h1_se2_se4c | G_h1_se2_se5c
      | G_h1_se2_se6c | G_h1_se3_se1c | G_h1_se3_se2c | G_h1_se3_se3c | G_h1_se3_se4c
      | G_h1_se3_se5c | G_h1_se3_se6c | G_h1_se4_se1c | G_h1_se4_se2c | G_h1_se4_se3c
      | G_h1_se4_se4c | G_h1_se4_se5c | G_h1_se4_se6c | G_h1_se5_se1c | G_h1_se5_se2c
      | G_h1_se5_se3c | G_h1_se5_se4c | G_h1_se5_se5c | G_h1_se5_se6c | G_h1_se6_se1c
      | G_h1_se6_se2c | G_h1_se6_se3c | G_h1_se6_se4c | G_h1_se6_se5c | G_h1_se6_se6c
      | G_h2_se1_se1c | G_h2_se1_se2c | G_h2_se1_se3c | G_h2_se1_se4c | G_h2_se1_se5c
      | G_h2_se1_se6c | G_h2_se2_se1c | G_h2_se2_se2c | G_h2_se2_se3c | G_h2_se2_se4c
      | G_h2_se2_se5c | G_h2_se2_se6c | G_h2_se3_se1c | G_h2_se3_se2c | G_h2_se3_se3c
      | G_h2_se3_se4c | G_h2_se3_se5c | G_h2_se3_se6c | G_h2_se4_se1c | G_h2_se4_se2c
      | G_h2_se4_se3c | G_h2_se4_se4c | G_h2_se4_se5c | G_h2_se4_se6c | G_h2_se5_se1c
      | G_h2_se5_se2c | G_h2_se5_se3c | G_h2_se5_se4c | G_h2_se5_se5c | G_h2_se5_se6c
      | G_h2_se6_se1c | G_h2_se6_se2c | G_h2_se6_se3c | G_h2_se6_se4c | G_h2_se6_se5c
      | G_h2_se6_se6c | G_h1_su1_su1c | G_h1_su1_su2c | G_h1_su1_su3c | G_h1_su1_su4c
      | G_h1_su1_su5c | G_h1_su1_su6c | G_h1_su2_su1c | G_h1_su2_su2c | G_h1_su2_su3c
      | G_h1_su2_su4c | G_h1_su2_su5c | G_h1_su2_su6c | G_h1_su3_su1c | G_h1_su3_su2c
      | G_h1_su3_su3c | G_h1_su3_su4c | G_h1_su3_su5c | G_h1_su3_su6c | G_h1_su4_su1c
      | G_h1_su4_su2c | G_h1_su4_su3c | G_h1_su4_su4c | G_h1_su4_su5c | G_h1_su4_su6c
      | G_h1_su5_su1c | G_h1_su5_su2c | G_h1_su5_su3c | G_h1_su5_su4c | G_h1_su5_su5c
      | G_h1_su5_su6c | G_h1_su6_su1c | G_h1_su6_su2c | G_h1_su6_su3c | G_h1_su6_su4c
      | G_h1_su6_su5c | G_h1_su6_su6c | G_h2_su1_su1c | G_h2_su1_su2c | G_h2_su1_su3c
      | G_h2_su1_su4c | G_h2_su1_su5c | G_h2_su1_su6c | G_h2_su2_su1c | G_h2_su2_su2c
      | G_h2_su2_su3c | G_h2_su2_su4c | G_h2_su2_su5c | G_h2_su2_su6c | G_h2_su3_su1c
      | G_h2_su3_su2c | G_h2_su3_su3c | G_h2_su3_su4c | G_h2_su3_su5c | G_h2_su3_su6c
      | G_h2_su4_su1c | G_h2_su4_su2c | G_h2_su4_su3c | G_h2_su4_su4c | G_h2_su4_su5c
      | G_h2_su4_su6c | G_h2_su5_su1c | G_h2_su5_su2c | G_h2_su5_su3c | G_h2_su5_su4c
      | G_h2_su5_su5c | G_h2_su5_su6c | G_h2_su6_su1c | G_h2_su6_su2c | G_h2_su6_su3c
      | G_h2_su6_su4c | G_h2_su6_su5c | G_h2_su6_su6c | G_h1_sv1_sv1c | G_h2_sv1_sv1c
      | G_hm2_su1_sd1c | G_hm2_su1_sd2c | G_hm2_su1_sd3c | G_hm2_su1_sd4c
      | G_hm2_su1_sd5c | G_hm2_su1_sd6c | G_hm2_su2_sd1c | G_hm2_su2_sd2c
      | G_hm2_su2_sd3c | G_hm2_su2_sd4c | G_hm2_su2_sd5c | G_hm2_su2_sd6c
      | G_hm2_su3_sd1c | G_hm2_su3_sd2c | G_hm2_su3_sd3c | G_hm2_su3_sd4c
      | G_hm2_su3_sd5c | G_hm2_su3_sd6c | G_hm2_su4_sd1c | G_hm2_su4_sd2c
      | G_hm2_su4_sd3c | G_hm2_su4_sd4c | G_hm2_su4_sd5c | G_hm2_su4_sd6c
      | G_hm2_su5_sd1c | G_hm2_su5_sd2c | G_hm2_su5_sd3c | G_hm2_su5_sd4c
      | G_hm2_su5_sd5c | G_hm2_su5_sd6c | G_hm2_su6_sd1c | G_hm2_su6_sd2c
      | G_hm2_su6_sd3c | G_hm2_su6_sd4c | G_hm2_su6_sd5c | G_hm2_su6_sd6c
      | G_hm2_sv1_se1c | G_hm2_sv1_se2c | G_hm2_sv1_se3c | G_hm2_sv1_se4c
      | G_hm2_sv1_se5c | G_hm2_sv1_se6c | G_hm2_sv2_se1c | G_hm2_sv2_se2c
      | G_hm2_sv2_se3c | G_hm2_sv2_se4c | G_hm2_sv2_se5c | G_hm2_sv2_se6c
      | G_hm2_sv3_se1c | G_hm2_sv3_se2c | G_hm2_sv3_se3c | G_hm2_sv3_se4c
      | G_hm2_sv3_se5c | G_hm2_sv3_se6c | G_sd1_hm2c_su1c | G_sd1_hm2c_su2c
      | G_sd1_hm2c_su3c | G_sd1_hm2c_su4c | G_sd1_hm2c_su5c | G_sd1_hm2c_su6c
      | G_sd2_hm2c_su1c | G_sd2_hm2c_su2c | G_sd2_hm2c_su3c | G_sd2_hm2c_su4c
      | G_sd2_hm2c_su5c | G_sd2_hm2c_su6c | G_sd3_hm2c_su1c | G_sd3_hm2c_su2c
      | G_sd3_hm2c_su3c | G_sd3_hm2c_su4c | G_sd3_hm2c_su5c | G_sd3_hm2c_su6c
      | G_sd4_hm2c_su1c | G_sd4_hm2c_su2c | G_sd4_hm2c_su3c | G_sd4_hm2c_su4c
      | G_sd4_hm2c_su5c | G_sd4_hm2c_su6c | G_sd5_hm2c_su1c | G_sd5_hm2c_su2c
      | G_sd5_hm2c_su3c | G_sd5_hm2c_su4c | G_sd5_hm2c_su5c | G_sd5_hm2c_su6c
      | G_sd6_hm2c_su1c | G_sd6_hm2c_su2c | G_sd6_hm2c_su3c | G_sd6_hm2c_su4c
      | G_sd6_hm2c_su5c | G_sd6_hm2c_su6c | G_se1_hm2c_sv1c | G_se1_hm2c_sv2c
      | G_se1_hm2c_sv3c | G_se2_hm2c_sv1c | G_se2_hm2c_sv2c | G_se2_hm2c_sv3c
      | G_se3_hm2c_sv1c | G_se3_hm2c_sv2c | G_se3_hm2c_sv3c | G_se4_hm2c_sv1c
      | G_se4_hm2c_sv2c | G_se4_hm2c_sv3c | G_se5_hm2c_sv1c | G_se5_hm2c_sv2c
      | G_se5_hm2c_sv3c | G_se6_hm2c_sv1c | G_se6_hm2c_sv2c | G_se6_hm2c_sv3c
      | G_ah2_ah2_wmc_wm_1 | G_ah2_ah2_z_1_z_1 | G_ah2_hm2_wmc_a_1
      | G_ah2_hm2_wmc_z_1 | G_ah2_hm2c_a_1_wm_1 | G_ah2_hm2c_wm_1_z_1
      | G_h1_h1_wmc_wm_1 | G_h1_h2_wmc_wm_1 | G_h2_h2_wmc_wm_1 | G_h1_h1_z_1_z_1
      | G_h1_h2_z_1_z_1 | G_h2_h2_z_1_z_1 | G_h1_hm2_wmc_a_1 | G_h2_hm2_wmc_a_1
      | G_h1_hm2_wmc_z_1 | G_h2_hm2_wmc_z_1 | G_hm2_hm2c_a_1_a_1 | G_hm2_hm2c_a_1_z_1
      | G_hm2_hm2c_wmc_wm_1 | G_hm2_hm2c_z_1_z_1 | G_sd1_sd1c_g_1_g_1
      | G_sd1_sd1c_g_1_a_1 | G_sd1_sd2c_g_1_a_1 | G_sd1_sd3c_g_1_a_1
      | G_sd1_sd4c_g_1_a_1 | G_sd1_sd5c_g_1_a_1 | G_sd1_sd6c_g_1_a_1
      | G_sd2_sd1c_g_1_a_1 | G_sd2_sd2c_g_1_a_1 | G_sd2_sd3c_g_1_a_1
      | G_sd2_sd4c_g_1_a_1 | G_sd2_sd5c_g_1_a_1 | G_sd2_sd6c_g_1_a_1
      | G_sd3_sd1c_g_1_a_1 | G_sd3_sd2c_g_1_a_1 | G_sd3_sd3c_g_1_a_1
      | G_sd3_sd4c_g_1_a_1 | G_sd3_sd5c_g_1_a_1 | G_sd3_sd6c_g_1_a_1
      | G_sd4_sd1c_g_1_a_1 | G_sd4_sd2c_g_1_a_1 | G_sd4_sd3c_g_1_a_1
      | G_sd4_sd4c_g_1_a_1 | G_sd4_sd5c_g_1_a_1 | G_sd4_sd6c_g_1_a_1
      | G_sd5_sd1c_g_1_a_1 | G_sd5_sd2c_g_1_a_1 | G_sd5_sd3c_g_1_a_1
      | G_sd5_sd4c_g_1_a_1 | G_sd5_sd5c_g_1_a_1 | G_sd5_sd6c_g_1_a_1
      | G_sd6_sd1c_g_1_a_1 | G_sd6_sd2c_g_1_a_1 | G_sd6_sd3c_g_1_a_1
      | G_sd6_sd4c_g_1_a_1 | G_sd6_sd5c_g_1_a_1 | G_sd6_sd6c_g_1_a_1
      | G_sd1_sd1c_g_1_z_1 | G_sd1_sd2c_g_1_z_1 | G_sd1_sd3c_g_1_z_1
      | G_sd1_sd4c_g_1_z_1 | G_sd1_sd5c_g_1_z_1 | G_sd1_sd6c_g_1_z_1
      | G_sd2_sd1c_g_1_z_1 | G_sd2_sd2c_g_1_z_1 | G_sd2_sd3c_g_1_z_1
      | G_sd2_sd4c_g_1_z_1 | G_sd2_sd5c_g_1_z_1 | G_sd2_sd6c_g_1_z_1
      | G_sd3_sd1c_g_1_z_1 | G_sd3_sd2c_g_1_z_1 | G_sd3_sd3c_g_1_z_1
      | G_sd3_sd4c_g_1_z_1 | G_sd3_sd5c_g_1_z_1 | G_sd3_sd6c_g_1_z_1
      | G_sd4_sd1c_g_1_z_1 | G_sd4_sd2c_g_1_z_1 | G_sd4_sd3c_g_1_z_1
      | G_sd4_sd4c_g_1_z_1 | G_sd4_sd5c_g_1_z_1 | G_sd4_sd6c_g_1_z_1
      | G_sd5_sd1c_g_1_z_1 | G_sd5_sd2c_g_1_z_1 | G_sd5_sd3c_g_1_z_1
      | G_sd5_sd4c_g_1_z_1 | G_sd5_sd5c_g_1_z_1 | G_sd5_sd6c_g_1_z_1
      | G_sd6_sd1c_g_1_z_1 | G_sd6_sd2c_g_1_z_1 | G_sd6_sd3c_g_1_z_1
      | G_sd6_sd4c_g_1_z_1 | G_sd6_sd5c_g_1_z_1 | G_sd6_sd6c_g_1_z_1
      | G_sd1_su1c_wmc_g_1 | G_sd1_su2c_wmc_g_1 | G_sd1_su3c_wmc_g_1
      | G_sd1_su4c_wmc_g_1 | G_sd1_su5c_wmc_g_1 | G_sd1_su6c_wmc_g_1
      | G_sd2_su1c_wmc_g_1 | G_sd2_su2c_wmc_g_1 | G_sd2_su3c_wmc_g_1
      | G_sd2_su4c_wmc_g_1 | G_sd2_su5c_wmc_g_1 | G_sd2_su6c_wmc_g_1
      | G_sd3_su1c_wmc_g_1 | G_sd3_su2c_wmc_g_1 | G_sd3_su3c_wmc_g_1
      | G_sd3_su4c_wmc_g_1 | G_sd3_su5c_wmc_g_1 | G_sd3_su6c_wmc_g_1
      | G_sd4_su1c_wmc_g_1 | G_sd4_su2c_wmc_g_1 | G_sd4_su3c_wmc_g_1
      | G_sd4_su4c_wmc_g_1 | G_sd4_su5c_wmc_g_1 | G_sd4_su6c_wmc_g_1
      | G_sd5_su1c_wmc_g_1 | G_sd5_su2c_wmc_g_1 | G_sd5_su3c_wmc_g_1
      | G_sd5_su4c_wmc_g_1 | G_sd5_su5c_wmc_g_1 | G_sd5_su6c_wmc_g_1
      | G_sd6_su1c_wmc_g_1 | G_sd6_su2c_wmc_g_1 | G_sd6_su3c_wmc_g_1
      | G_sd6_su4c_wmc_g_1 | G_sd6_su5c_wmc_g_1 | G_sd6_su6c_wmc_g_1
      | G_sd1_sd1c_a_1_a_1 | G_sd1_sd2c_a_1_a_1 | G_sd1_sd3c_a_1_a_1
      | G_sd1_sd4c_a_1_a_1 | G_sd1_sd5c_a_1_a_1 | G_sd1_sd6c_a_1_a_1
      | G_sd2_sd1c_a_1_a_1 | G_sd2_sd2c_a_1_a_1 | G_sd2_sd3c_a_1_a_1
      | G_sd2_sd4c_a_1_a_1 | G_sd2_sd5c_a_1_a_1 | G_sd2_sd6c_a_1_a_1
      | G_sd3_sd1c_a_1_a_1 | G_sd3_sd2c_a_1_a_1 | G_sd3_sd3c_a_1_a_1
      | G_sd3_sd4c_a_1_a_1 | G_sd3_sd5c_a_1_a_1 | G_sd3_sd6c_a_1_a_1
      | G_sd4_sd1c_a_1_a_1 | G_sd4_sd2c_a_1_a_1 | G_sd4_sd3c_a_1_a_1
      | G_sd4_sd4c_a_1_a_1 | G_sd4_sd5c_a_1_a_1 | G_sd4_sd6c_a_1_a_1
      | G_sd5_sd1c_a_1_a_1 | G_sd5_sd2c_a_1_a_1 | G_sd5_sd3c_a_1_a_1
      | G_sd5_sd4c_a_1_a_1 | G_sd5_sd5c_a_1_a_1 | G_sd5_sd6c_a_1_a_1
      | G_sd6_sd1c_a_1_a_1 | G_sd6_sd2c_a_1_a_1 | G_sd6_sd3c_a_1_a_1
      | G_sd6_sd4c_a_1_a_1 | G_sd6_sd5c_a_1_a_1 | G_sd6_sd6c_a_1_a_1
      | G_sd1_sd1c_a_1_z_1 | G_sd1_sd2c_a_1_z_1 | G_sd1_sd3c_a_1_z_1
      | G_sd1_sd4c_a_1_z_1 | G_sd1_sd5c_a_1_z_1 | G_sd1_sd6c_a_1_z_1
      | G_sd2_sd1c_a_1_z_1 | G_sd2_sd2c_a_1_z_1 | G_sd2_sd3c_a_1_z_1
      | G_sd2_sd4c_a_1_z_1 | G_sd2_sd5c_a_1_z_1 | G_sd2_sd6c_a_1_z_1
      | G_sd3_sd1c_a_1_z_1 | G_sd3_sd2c_a_1_z_1 | G_sd3_sd3c_a_1_z_1
      | G_sd3_sd4c_a_1_z_1 | G_sd3_sd5c_a_1_z_1 | G_sd3_sd6c_a_1_z_1
      | G_sd4_sd1c_a_1_z_1 | G_sd4_sd2c_a_1_z_1 | G_sd4_sd3c_a_1_z_1
      | G_sd4_sd4c_a_1_z_1 | G_sd4_sd5c_a_1_z_1 | G_sd4_sd6c_a_1_z_1
      | G_sd5_sd1c_a_1_z_1 | G_sd5_sd2c_a_1_z_1 | G_sd5_sd3c_a_1_z_1
      | G_sd5_sd4c_a_1_z_1 | G_sd5_sd5c_a_1_z_1 | G_sd5_sd6c_a_1_z_1
      | G_sd6_sd1c_a_1_z_1 | G_sd6_sd2c_a_1_z_1 | G_sd6_sd3c_a_1_z_1
      | G_sd6_sd4c_a_1_z_1 | G_sd6_sd5c_a_1_z_1 | G_sd6_sd6c_a_1_z_1
      | G_sd1_su1c_wmc_a_1 | G_sd1_su2c_wmc_a_1 | G_sd1_su3c_wmc_a_1
      | G_sd1_su4c_wmc_a_1 | G_sd1_su5c_wmc_a_1 | G_sd1_su6c_wmc_a_1
      | G_sd2_su1c_wmc_a_1 | G_sd2_su2c_wmc_a_1 | G_sd2_su3c_wmc_a_1
      | G_sd2_su4c_wmc_a_1 | G_sd2_su5c_wmc_a_1 | G_sd2_su6c_wmc_a_1
      | G_sd3_su1c_wmc_a_1 | G_sd3_su2c_wmc_a_1 | G_sd3_su3c_wmc_a_1
      | G_sd3_su4c_wmc_a_1 | G_sd3_su5c_wmc_a_1 | G_sd3_su6c_wmc_a_1
      | G_sd4_su1c_wmc_a_1 | G_sd4_su2c_wmc_a_1 | G_sd4_su3c_wmc_a_1
      | G_sd4_su4c_wmc_a_1 | G_sd4_su5c_wmc_a_1 | G_sd4_su6c_wmc_a_1
      | G_sd5_su1c_wmc_a_1 | G_sd5_su2c_wmc_a_1 | G_sd5_su3c_wmc_a_1
      | G_sd5_su4c_wmc_a_1 | G_sd5_su5c_wmc_a_1 | G_sd5_su6c_wmc_a_1
      | G_sd6_su1c_wmc_a_1 | G_sd6_su2c_wmc_a_1 | G_sd6_su3c_wmc_a_1
      | G_sd6_su4c_wmc_a_1 | G_sd6_su5c_wmc_a_1 | G_sd6_su6c_wmc_a_1
      | G_sd1_sd1c_wmc_wm_1 | G_sd1_sd2c_wmc_wm_1 | G_sd1_sd3c_wmc_wm_1
      | G_sd1_sd4c_wmc_wm_1 | G_sd1_sd5c_wmc_wm_1 | G_sd1_sd6c_wmc_wm_1
      | G_sd2_sd1c_wmc_wm_1 | G_sd2_sd2c_wmc_wm_1 | G_sd2_sd3c_wmc_wm_1
      | G_sd2_sd4c_wmc_wm_1 | G_sd2_sd5c_wmc_wm_1 | G_sd2_sd6c_wmc_wm_1
      | G_sd3_sd1c_wmc_wm_1 | G_sd3_sd2c_wmc_wm_1 | G_sd3_sd3c_wmc_wm_1
      | G_sd3_sd4c_wmc_wm_1 | G_sd3_sd5c_wmc_wm_1 | G_sd3_sd6c_wmc_wm_1
      | G_sd4_sd1c_wmc_wm_1 | G_sd4_sd2c_wmc_wm_1 | G_sd4_sd3c_wmc_wm_1
      | G_sd4_sd4c_wmc_wm_1 | G_sd4_sd5c_wmc_wm_1 | G_sd4_sd6c_wmc_wm_1
      | G_sd5_sd1c_wmc_wm_1 | G_sd5_sd2c_wmc_wm_1 | G_sd5_sd3c_wmc_wm_1
      | G_sd5_sd4c_wmc_wm_1 | G_sd5_sd5c_wmc_wm_1 | G_sd5_sd6c_wmc_wm_1
      | G_sd6_sd1c_wmc_wm_1 | G_sd6_sd2c_wmc_wm_1 | G_sd6_sd3c_wmc_wm_1
      | G_sd6_sd4c_wmc_wm_1 | G_sd6_sd5c_wmc_wm_1 | G_sd6_sd6c_wmc_wm_1
      | G_sd1_sd1c_z_1_z_1 | G_sd1_sd2c_z_1_z_1 | G_sd1_sd3c_z_1_z_1
      | G_sd1_sd4c_z_1_z_1 | G_sd1_sd5c_z_1_z_1 | G_sd1_sd6c_z_1_z_1
      | G_sd2_sd1c_z_1_z_1 | G_sd2_sd2c_z_1_z_1 | G_sd2_sd3c_z_1_z_1
      | G_sd2_sd4c_z_1_z_1 | G_sd2_sd5c_z_1_z_1 | G_sd2_sd6c_z_1_z_1
      | G_sd3_sd1c_z_1_z_1 | G_sd3_sd2c_z_1_z_1 | G_sd3_sd3c_z_1_z_1
      | G_sd3_sd4c_z_1_z_1 | G_sd3_sd5c_z_1_z_1 | G_sd3_sd6c_z_1_z_1
      | G_sd4_sd1c_z_1_z_1 | G_sd4_sd2c_z_1_z_1 | G_sd4_sd3c_z_1_z_1
      | G_sd4_sd4c_z_1_z_1 | G_sd4_sd5c_z_1_z_1 | G_sd4_sd6c_z_1_z_1
      | G_sd5_sd1c_z_1_z_1 | G_sd5_sd2c_z_1_z_1 | G_sd5_sd3c_z_1_z_1
      | G_sd5_sd4c_z_1_z_1 | G_sd5_sd5c_z_1_z_1 | G_sd5_sd6c_z_1_z_1
      | G_sd6_sd1c_z_1_z_1 | G_sd6_sd2c_z_1_z_1 | G_sd6_sd3c_z_1_z_1
      | G_sd6_sd4c_z_1_z_1 | G_sd6_sd5c_z_1_z_1 | G_sd6_sd6c_z_1_z_1
      | G_sd1_su1c_wmc_z_1 | G_sd1_su2c_wmc_z_1 | G_sd1_su3c_wmc_z_1
      | G_sd1_su4c_wmc_z_1 | G_sd1_su5c_wmc_z_1 | G_sd1_su6c_wmc_z_1
      | G_sd2_su1c_wmc_z_1 | G_sd2_su2c_wmc_z_1 | G_sd2_su3c_wmc_z_1
      | G_sd2_su4c_wmc_z_1 | G_sd2_su5c_wmc_z_1 | G_sd2_su6c_wmc_z_1
      | G_sd3_su1c_wmc_z_1 | G_sd3_su2c_wmc_z_1 | G_sd3_su3c_wmc_z_1
      | G_sd3_su4c_wmc_z_1 | G_sd3_su5c_wmc_z_1 | G_sd3_su6c_wmc_z_1
      | G_sd4_su1c_wmc_z_1 | G_sd4_su2c_wmc_z_1 | G_sd4_su3c_wmc_z_1
      | G_sd4_su4c_wmc_z_1 | G_sd4_su5c_wmc_z_1 | G_sd4_su6c_wmc_z_1
      | G_sd5_su1c_wmc_z_1 | G_sd5_su2c_wmc_z_1 | G_sd5_su3c_wmc_z_1
      | G_sd5_su4c_wmc_z_1 | G_sd5_su5c_wmc_z_1 | G_sd5_su6c_wmc_z_1
      | G_sd6_su1c_wmc_z_1 | G_sd6_su2c_wmc_z_1 | G_sd6_su3c_wmc_z_1
      | G_sd6_su4c_wmc_z_1 | G_sd6_su5c_wmc_z_1 | G_sd6_su6c_wmc_z_1
      | G_se1_se1c_a_1_a_1 | G_se1_se2c_a_1_a_1 | G_se1_se3c_a_1_a_1
      | G_se1_se4c_a_1_a_1 | G_se1_se5c_a_1_a_1 | G_se1_se6c_a_1_a_1
      | G_se2_se1c_a_1_a_1 | G_se2_se2c_a_1_a_1 | G_se2_se3c_a_1_a_1
      | G_se2_se4c_a_1_a_1 | G_se2_se5c_a_1_a_1 | G_se2_se6c_a_1_a_1
      | G_se3_se1c_a_1_a_1 | G_se3_se2c_a_1_a_1 | G_se3_se3c_a_1_a_1
      | G_se3_se4c_a_1_a_1 | G_se3_se5c_a_1_a_1 | G_se3_se6c_a_1_a_1
      | G_se4_se1c_a_1_a_1 | G_se4_se2c_a_1_a_1 | G_se4_se3c_a_1_a_1
      | G_se4_se4c_a_1_a_1 | G_se4_se5c_a_1_a_1 | G_se4_se6c_a_1_a_1
      | G_se5_se1c_a_1_a_1 | G_se5_se2c_a_1_a_1 | G_se5_se3c_a_1_a_1
      | G_se5_se4c_a_1_a_1 | G_se5_se5c_a_1_a_1 | G_se5_se6c_a_1_a_1
      | G_se6_se1c_a_1_a_1 | G_se6_se2c_a_1_a_1 | G_se6_se3c_a_1_a_1
      | G_se6_se4c_a_1_a_1 | G_se6_se5c_a_1_a_1 | G_se6_se6c_a_1_a_1
      | G_se1_se1c_a_1_z_1 | G_se1_se2c_a_1_z_1 | G_se1_se3c_a_1_z_1
      | G_se1_se4c_a_1_z_1 | G_se1_se5c_a_1_z_1 | G_se1_se6c_a_1_z_1
      | G_se2_se1c_a_1_z_1 | G_se2_se2c_a_1_z_1 | G_se2_se3c_a_1_z_1
      | G_se2_se4c_a_1_z_1 | G_se2_se5c_a_1_z_1 | G_se2_se6c_a_1_z_1
      | G_se3_se1c_a_1_z_1 | G_se3_se2c_a_1_z_1 | G_se3_se3c_a_1_z_1
      | G_se3_se4c_a_1_z_1 | G_se3_se5c_a_1_z_1 | G_se3_se6c_a_1_z_1
      | G_se4_se1c_a_1_z_1 | G_se4_se2c_a_1_z_1 | G_se4_se3c_a_1_z_1
      | G_se4_se4c_a_1_z_1 | G_se4_se5c_a_1_z_1 | G_se4_se6c_a_1_z_1
      | G_se5_se1c_a_1_z_1 | G_se5_se2c_a_1_z_1 | G_se5_se3c_a_1_z_1
      | G_se5_se4c_a_1_z_1 | G_se5_se5c_a_1_z_1 | G_se5_se6c_a_1_z_1
      | G_se6_se1c_a_1_z_1 | G_se6_se2c_a_1_z_1 | G_se6_se3c_a_1_z_1
      | G_se6_se4c_a_1_z_1 | G_se6_se5c_a_1_z_1 | G_se6_se6c_a_1_z_1
      | G_se1_sv1c_wmc_a_1 | G_se1_sv2c_wmc_a_1 | G_se1_sv3c_wmc_a_1
      | G_se2_sv1c_wmc_a_1 | G_se2_sv2c_wmc_a_1 | G_se2_sv3c_wmc_a_1
      | G_se3_sv1c_wmc_a_1 | G_se3_sv2c_wmc_a_1 | G_se3_sv3c_wmc_a_1
      | G_se4_sv1c_wmc_a_1 | G_se4_sv2c_wmc_a_1 | G_se4_sv3c_wmc_a_1
      | G_se5_sv1c_wmc_a_1 | G_se5_sv2c_wmc_a_1 | G_se5_sv3c_wmc_a_1
      | G_se6_sv1c_wmc_a_1 | G_se6_sv2c_wmc_a_1 | G_se6_sv3c_wmc_a_1
      | G_se1_se1c_wmc_wm_1 | G_se1_se2c_wmc_wm_1 | G_se1_se3c_wmc_wm_1
      | G_se1_se4c_wmc_wm_1 | G_se1_se5c_wmc_wm_1 | G_se1_se6c_wmc_wm_1
      | G_se2_se1c_wmc_wm_1 | G_se2_se2c_wmc_wm_1 | G_se2_se3c_wmc_wm_1
      | G_se2_se4c_wmc_wm_1 | G_se2_se5c_wmc_wm_1 | G_se2_se6c_wmc_wm_1
      | G_se3_se1c_wmc_wm_1 | G_se3_se2c_wmc_wm_1 | G_se3_se3c_wmc_wm_1
      | G_se3_se4c_wmc_wm_1 | G_se3_se5c_wmc_wm_1 | G_se3_se6c_wmc_wm_1
      | G_se4_se1c_wmc_wm_1 | G_se4_se2c_wmc_wm_1 | G_se4_se3c_wmc_wm_1
      | G_se4_se4c_wmc_wm_1 | G_se4_se5c_wmc_wm_1 | G_se4_se6c_wmc_wm_1
      | G_se5_se1c_wmc_wm_1 | G_se5_se2c_wmc_wm_1 | G_se5_se3c_wmc_wm_1
      | G_se5_se4c_wmc_wm_1 | G_se5_se5c_wmc_wm_1 | G_se5_se6c_wmc_wm_1
      | G_se6_se1c_wmc_wm_1 | G_se6_se2c_wmc_wm_1 | G_se6_se3c_wmc_wm_1
      | G_se6_se4c_wmc_wm_1 | G_se6_se5c_wmc_wm_1 | G_se6_se6c_wmc_wm_1
      | G_se1_se1c_z_1_z_1 | G_se1_se2c_z_1_z_1 | G_se1_se3c_z_1_z_1
      | G_se1_se4c_z_1_z_1 | G_se1_se5c_z_1_z_1 | G_se1_se6c_z_1_z_1
      | G_se2_se1c_z_1_z_1 | G_se2_se2c_z_1_z_1 | G_se2_se3c_z_1_z_1
      | G_se2_se4c_z_1_z_1 | G_se2_se5c_z_1_z_1 | G_se2_se6c_z_1_z_1
      | G_se3_se1c_z_1_z_1 | G_se3_se2c_z_1_z_1 | G_se3_se3c_z_1_z_1
      | G_se3_se4c_z_1_z_1 | G_se3_se5c_z_1_z_1 | G_se3_se6c_z_1_z_1
      | G_se4_se1c_z_1_z_1 | G_se4_se2c_z_1_z_1 | G_se4_se3c_z_1_z_1
      | G_se4_se4c_z_1_z_1 | G_se4_se5c_z_1_z_1 | G_se4_se6c_z_1_z_1
      | G_se5_se1c_z_1_z_1 | G_se5_se2c_z_1_z_1 | G_se5_se3c_z_1_z_1
      | G_se5_se4c_z_1_z_1 | G_se5_se5c_z_1_z_1 | G_se5_se6c_z_1_z_1
      | G_se6_se1c_z_1_z_1 | G_se6_se2c_z_1_z_1 | G_se6_se3c_z_1_z_1
      | G_se6_se4c_z_1_z_1 | G_se6_se5c_z_1_z_1 | G_se6_se6c_z_1_z_1
      | G_se1_sv1c_wmc_z_1 | G_se1_sv2c_wmc_z_1 | G_se1_sv3c_wmc_z_1
      | G_se2_sv1c_wmc_z_1 | G_se2_sv2c_wmc_z_1 | G_se2_sv3c_wmc_z_1
      | G_se3_sv1c_wmc_z_1 | G_se3_sv2c_wmc_z_1 | G_se3_sv3c_wmc_z_1
      | G_se4_sv1c_wmc_z_1 | G_se4_sv2c_wmc_z_1 | G_se4_sv3c_wmc_z_1
      | G_se5_sv1c_wmc_z_1 | G_se5_sv2c_wmc_z_1 | G_se5_sv3c_wmc_z_1
      | G_se6_sv1c_wmc_z_1 | G_se6_sv2c_wmc_z_1 | G_se6_sv3c_wmc_z_1
      | G_su1_su1c_g_1_a_1 | G_su1_su2c_g_1_a_1 | G_su1_su3c_g_1_a_1
      | G_su1_su4c_g_1_a_1 | G_su1_su5c_g_1_a_1 | G_su1_su6c_g_1_a_1
      | G_su2_su1c_g_1_a_1 | G_su2_su2c_g_1_a_1 | G_su2_su3c_g_1_a_1
      | G_su2_su4c_g_1_a_1 | G_su2_su5c_g_1_a_1 | G_su2_su6c_g_1_a_1
      | G_su3_su1c_g_1_a_1 | G_su3_su2c_g_1_a_1 | G_su3_su3c_g_1_a_1
      | G_su3_su4c_g_1_a_1 | G_su3_su5c_g_1_a_1 | G_su3_su6c_g_1_a_1
      | G_su4_su1c_g_1_a_1 | G_su4_su2c_g_1_a_1 | G_su4_su3c_g_1_a_1
      | G_su4_su4c_g_1_a_1 | G_su4_su5c_g_1_a_1 | G_su4_su6c_g_1_a_1
      | G_su5_su1c_g_1_a_1 | G_su5_su2c_g_1_a_1 | G_su5_su3c_g_1_a_1
      | G_su5_su4c_g_1_a_1 | G_su5_su5c_g_1_a_1 | G_su5_su6c_g_1_a_1
      | G_su6_su1c_g_1_a_1 | G_su6_su2c_g_1_a_1 | G_su6_su3c_g_1_a_1
      | G_su6_su4c_g_1_a_1 | G_su6_su5c_g_1_a_1 | G_su6_su6c_g_1_a_1
      | G_su1_sd1c_g_1_wm_1 | G_su1_sd2c_g_1_wm_1 | G_su1_sd3c_g_1_wm_1
      | G_su1_sd4c_g_1_wm_1 | G_su1_sd5c_g_1_wm_1 | G_su1_sd6c_g_1_wm_1
      | G_su2_sd1c_g_1_wm_1 | G_su2_sd2c_g_1_wm_1 | G_su2_sd3c_g_1_wm_1
      | G_su2_sd4c_g_1_wm_1 | G_su2_sd5c_g_1_wm_1 | G_su2_sd6c_g_1_wm_1
      | G_su3_sd1c_g_1_wm_1 | G_su3_sd2c_g_1_wm_1 | G_su3_sd3c_g_1_wm_1
      | G_su3_sd4c_g_1_wm_1 | G_su3_sd5c_g_1_wm_1 | G_su3_sd6c_g_1_wm_1
      | G_su4_sd1c_g_1_wm_1 | G_su4_sd2c_g_1_wm_1 | G_su4_sd3c_g_1_wm_1
      | G_su4_sd4c_g_1_wm_1 | G_su4_sd5c_g_1_wm_1 | G_su4_sd6c_g_1_wm_1
      | G_su5_sd1c_g_1_wm_1 | G_su5_sd2c_g_1_wm_1 | G_su5_sd3c_g_1_wm_1
      | G_su5_sd4c_g_1_wm_1 | G_su5_sd5c_g_1_wm_1 | G_su5_sd6c_g_1_wm_1
      | G_su6_sd1c_g_1_wm_1 | G_su6_sd2c_g_1_wm_1 | G_su6_sd3c_g_1_wm_1
      | G_su6_sd4c_g_1_wm_1 | G_su6_sd5c_g_1_wm_1 | G_su6_sd6c_g_1_wm_1
      | G_su1_su1c_g_1_z_1 | G_su1_su2c_g_1_z_1 | G_su1_su3c_g_1_z_1
      | G_su1_su4c_g_1_z_1 | G_su1_su5c_g_1_z_1 | G_su1_su6c_g_1_z_1
      | G_su2_su1c_g_1_z_1 | G_su2_su2c_g_1_z_1 | G_su2_su3c_g_1_z_1
      | G_su2_su4c_g_1_z_1 | G_su2_su5c_g_1_z_1 | G_su2_su6c_g_1_z_1
      | G_su3_su1c_g_1_z_1 | G_su3_su2c_g_1_z_1 | G_su3_su3c_g_1_z_1
      | G_su3_su4c_g_1_z_1 | G_su3_su5c_g_1_z_1 | G_su3_su6c_g_1_z_1
      | G_su4_su1c_g_1_z_1 | G_su4_su2c_g_1_z_1 | G_su4_su3c_g_1_z_1
      | G_su4_su4c_g_1_z_1 | G_su4_su5c_g_1_z_1 | G_su4_su6c_g_1_z_1
      | G_su5_su1c_g_1_z_1 | G_su5_su2c_g_1_z_1 | G_su5_su3c_g_1_z_1
      | G_su5_su4c_g_1_z_1 | G_su5_su5c_g_1_z_1 | G_su5_su6c_g_1_z_1
      | G_su6_su1c_g_1_z_1 | G_su6_su2c_g_1_z_1 | G_su6_su3c_g_1_z_1
      | G_su6_su4c_g_1_z_1 | G_su6_su5c_g_1_z_1 | G_su6_su6c_g_1_z_1
      | G_su1_su1c_a_1_a_1 | G_su1_su2c_a_1_a_1 | G_su1_su3c_a_1_a_1
      | G_su1_su4c_a_1_a_1 | G_su1_su5c_a_1_a_1 | G_su1_su6c_a_1_a_1
      | G_su2_su1c_a_1_a_1 | G_su2_su2c_a_1_a_1 | G_su2_su3c_a_1_a_1
      | G_su2_su4c_a_1_a_1 | G_su2_su5c_a_1_a_1 | G_su2_su6c_a_1_a_1
      | G_su3_su1c_a_1_a_1 | G_su3_su2c_a_1_a_1 | G_su3_su3c_a_1_a_1
      | G_su3_su4c_a_1_a_1 | G_su3_su5c_a_1_a_1 | G_su3_su6c_a_1_a_1
      | G_su4_su1c_a_1_a_1 | G_su4_su2c_a_1_a_1 | G_su4_su3c_a_1_a_1
      | G_su4_su4c_a_1_a_1 | G_su4_su5c_a_1_a_1 | G_su4_su6c_a_1_a_1
      | G_su5_su1c_a_1_a_1 | G_su5_su2c_a_1_a_1 | G_su5_su3c_a_1_a_1
      | G_su5_su4c_a_1_a_1 | G_su5_su5c_a_1_a_1 | G_su5_su6c_a_1_a_1
      | G_su6_su1c_a_1_a_1 | G_su6_su2c_a_1_a_1 | G_su6_su3c_a_1_a_1
      | G_su6_su4c_a_1_a_1 | G_su6_su5c_a_1_a_1 | G_su6_su6c_a_1_a_1
      | G_su1_sd1c_a_1_wm_1 | G_su1_sd2c_a_1_wm_1 | G_su1_sd3c_a_1_wm_1
      | G_su1_sd4c_a_1_wm_1 | G_su1_sd5c_a_1_wm_1 | G_su1_sd6c_a_1_wm_1
      | G_su2_sd1c_a_1_wm_1 | G_su2_sd2c_a_1_wm_1 | G_su2_sd3c_a_1_wm_1
      | G_su2_sd4c_a_1_wm_1 | G_su2_sd5c_a_1_wm_1 | G_su2_sd6c_a_1_wm_1
      | G_su3_sd1c_a_1_wm_1 | G_su3_sd2c_a_1_wm_1 | G_su3_sd3c_a_1_wm_1
      | G_su3_sd4c_a_1_wm_1 | G_su3_sd5c_a_1_wm_1 | G_su3_sd6c_a_1_wm_1
      | G_su4_sd1c_a_1_wm_1 | G_su4_sd2c_a_1_wm_1 | G_su4_sd3c_a_1_wm_1
      | G_su4_sd4c_a_1_wm_1 | G_su4_sd5c_a_1_wm_1 | G_su4_sd6c_a_1_wm_1
      | G_su5_sd1c_a_1_wm_1 | G_su5_sd2c_a_1_wm_1 | G_su5_sd3c_a_1_wm_1
      | G_su5_sd4c_a_1_wm_1 | G_su5_sd5c_a_1_wm_1 | G_su5_sd6c_a_1_wm_1
      | G_su6_sd1c_a_1_wm_1 | G_su6_sd2c_a_1_wm_1 | G_su6_sd3c_a_1_wm_1
      | G_su6_sd4c_a_1_wm_1 | G_su6_sd5c_a_1_wm_1 | G_su6_sd6c_a_1_wm_1
      | G_su1_su1c_a_1_z_1 | G_su1_su2c_a_1_z_1 | G_su1_su3c_a_1_z_1
      | G_su1_su4c_a_1_z_1 | G_su1_su5c_a_1_z_1 | G_su1_su6c_a_1_z_1
      | G_su2_su1c_a_1_z_1 | G_su2_su2c_a_1_z_1 | G_su2_su3c_a_1_z_1
      | G_su2_su4c_a_1_z_1 | G_su2_su5c_a_1_z_1 | G_su2_su6c_a_1_z_1
      | G_su3_su1c_a_1_z_1 | G_su3_su2c_a_1_z_1 | G_su3_su3c_a_1_z_1
      | G_su3_su4c_a_1_z_1 | G_su3_su5c_a_1_z_1 | G_su3_su6c_a_1_z_1
      | G_su4_su1c_a_1_z_1 | G_su4_su2c_a_1_z_1 | G_su4_su3c_a_1_z_1
      | G_su4_su4c_a_1_z_1 | G_su4_su5c_a_1_z_1 | G_su4_su6c_a_1_z_1
      | G_su5_su1c_a_1_z_1 | G_su5_su2c_a_1_z_1 | G_su5_su3c_a_1_z_1
      | G_su5_su4c_a_1_z_1 | G_su5_su5c_a_1_z_1 | G_su5_su6c_a_1_z_1
      | G_su6_su1c_a_1_z_1 | G_su6_su2c_a_1_z_1 | G_su6_su3c_a_1_z_1
      | G_su6_su4c_a_1_z_1 | G_su6_su5c_a_1_z_1 | G_su6_su6c_a_1_z_1
      | G_su1_sd1c_wm_1_z_1 | G_su1_sd2c_wm_1_z_1 | G_su1_sd3c_wm_1_z_1
      | G_su1_sd4c_wm_1_z_1 | G_su1_sd5c_wm_1_z_1 | G_su1_sd6c_wm_1_z_1
      | G_su2_sd1c_wm_1_z_1 | G_su2_sd2c_wm_1_z_1 | G_su2_sd3c_wm_1_z_1
      | G_su2_sd4c_wm_1_z_1 | G_su2_sd5c_wm_1_z_1 | G_su2_sd6c_wm_1_z_1
      | G_su3_sd1c_wm_1_z_1 | G_su3_sd2c_wm_1_z_1 | G_su3_sd3c_wm_1_z_1
      | G_su3_sd4c_wm_1_z_1 | G_su3_sd5c_wm_1_z_1 | G_su3_sd6c_wm_1_z_1
      | G_su4_sd1c_wm_1_z_1 | G_su4_sd2c_wm_1_z_1 | G_su4_sd3c_wm_1_z_1
      | G_su4_sd4c_wm_1_z_1 | G_su4_sd5c_wm_1_z_1 | G_su4_sd6c_wm_1_z_1
      | G_su5_sd1c_wm_1_z_1 | G_su5_sd2c_wm_1_z_1 | G_su5_sd3c_wm_1_z_1
      | G_su5_sd4c_wm_1_z_1 | G_su5_sd5c_wm_1_z_1 | G_su5_sd6c_wm_1_z_1
      | G_su6_sd1c_wm_1_z_1 | G_su6_sd2c_wm_1_z_1 | G_su6_sd3c_wm_1_z_1
      | G_su6_sd4c_wm_1_z_1 | G_su6_sd5c_wm_1_z_1 | G_su6_sd6c_wm_1_z_1
      | G_su1_su1c_wmc_wm_1 | G_su1_su2c_wmc_wm_1 | G_su1_su3c_wmc_wm_1
      | G_su1_su4c_wmc_wm_1 | G_su1_su5c_wmc_wm_1 | G_su1_su6c_wmc_wm_1
      | G_su2_su1c_wmc_wm_1 | G_su2_su2c_wmc_wm_1 | G_su2_su3c_wmc_wm_1
      | G_su2_su4c_wmc_wm_1 | G_su2_su5c_wmc_wm_1 | G_su2_su6c_wmc_wm_1
      | G_su3_su1c_wmc_wm_1 | G_su3_su2c_wmc_wm_1 | G_su3_su3c_wmc_wm_1
      | G_su3_su4c_wmc_wm_1 | G_su3_su5c_wmc_wm_1 | G_su3_su6c_wmc_wm_1
      | G_su4_su1c_wmc_wm_1 | G_su4_su2c_wmc_wm_1 | G_su4_su3c_wmc_wm_1
      | G_su4_su4c_wmc_wm_1 | G_su4_su5c_wmc_wm_1 | G_su4_su6c_wmc_wm_1
      | G_su5_su1c_wmc_wm_1 | G_su5_su2c_wmc_wm_1 | G_su5_su3c_wmc_wm_1
      | G_su5_su4c_wmc_wm_1 | G_su5_su5c_wmc_wm_1 | G_su5_su6c_wmc_wm_1
      | G_su6_su1c_wmc_wm_1 | G_su6_su2c_wmc_wm_1 | G_su6_su3c_wmc_wm_1
      | G_su6_su4c_wmc_wm_1 | G_su6_su5c_wmc_wm_1 | G_su6_su6c_wmc_wm_1
      | G_su1_su1c_z_1_z_1 | G_su1_su2c_z_1_z_1 | G_su1_su3c_z_1_z_1
      | G_su1_su4c_z_1_z_1 | G_su1_su5c_z_1_z_1 | G_su1_su6c_z_1_z_1
      | G_su2_su1c_z_1_z_1 | G_su2_su2c_z_1_z_1 | G_su2_su3c_z_1_z_1
      | G_su2_su4c_z_1_z_1 | G_su2_su5c_z_1_z_1 | G_su2_su6c_z_1_z_1
      | G_su3_su1c_z_1_z_1 | G_su3_su2c_z_1_z_1 | G_su3_su3c_z_1_z_1
      | G_su3_su4c_z_1_z_1 | G_su3_su5c_z_1_z_1 | G_su3_su6c_z_1_z_1
      | G_su4_su1c_z_1_z_1 | G_su4_su2c_z_1_z_1 | G_su4_su3c_z_1_z_1
      | G_su4_su4c_z_1_z_1 | G_su4_su5c_z_1_z_1 | G_su4_su6c_z_1_z_1
      | G_su5_su1c_z_1_z_1 | G_su5_su2c_z_1_z_1 | G_su5_su3c_z_1_z_1
      | G_su5_su4c_z_1_z_1 | G_su5_su5c_z_1_z_1 | G_su5_su6c_z_1_z_1
      | G_su6_su1c_z_1_z_1 | G_su6_su2c_z_1_z_1 | G_su6_su3c_z_1_z_1
      | G_su6_su4c_z_1_z_1 | G_su6_su5c_z_1_z_1 | G_su6_su6c_z_1_z_1
      | G_sv1_se1c_a_1_wm_1 | G_sv1_se2c_a_1_wm_1 | G_sv1_se3c_a_1_wm_1
      | G_sv1_se4c_a_1_wm_1 | G_sv1_se5c_a_1_wm_1 | G_sv1_se6c_a_1_wm_1
      | G_sv2_se1c_a_1_wm_1 | G_sv2_se2c_a_1_wm_1 | G_sv2_se3c_a_1_wm_1
      | G_sv2_se4c_a_1_wm_1 | G_sv2_se5c_a_1_wm_1 | G_sv2_se6c_a_1_wm_1
      | G_sv3_se1c_a_1_wm_1 | G_sv3_se2c_a_1_wm_1 | G_sv3_se3c_a_1_wm_1
      | G_sv3_se4c_a_1_wm_1 | G_sv3_se5c_a_1_wm_1 | G_sv3_se6c_a_1_wm_1
      | G_sv1_se1c_wm_1_z_1 | G_sv1_se2c_wm_1_z_1 | G_sv1_se3c_wm_1_z_1
      | G_sv1_se4c_wm_1_z_1 | G_sv1_se5c_wm_1_z_1 | G_sv1_se6c_wm_1_z_1
      | G_sv2_se1c_wm_1_z_1 | G_sv2_se2c_wm_1_z_1 | G_sv2_se3c_wm_1_z_1
      | G_sv2_se4c_wm_1_z_1 | G_sv2_se5c_wm_1_z_1 | G_sv2_se6c_wm_1_z_1
      | G_sv3_se1c_wm_1_z_1 | G_sv3_se2c_wm_1_z_1 | G_sv3_se3c_wm_1_z_1
      | G_sv3_se4c_wm_1_z_1 | G_sv3_se5c_wm_1_z_1 | G_sv3_se6c_wm_1_z_1
      | G_sv1_sv1c_wmc_wm_1 | G_sv1_sv1c_z_1_z_1 | G_z_1_ah2_h1 | G_z_1_ah2_h2
      | G_wmc_ah2_hm2 | G_wmc_h1_hm2 | G_wmc_h2_hm2 | G_wm_1_h1_hm2c | G_wm_1_h2_hm2c
      | G_a_1_hm2_hm2c | G_z_1_hm2_hm2c | G_g_1_sd1_sd1c | G_a_1_sd1_sd1c
      | G_a_1_sd1_sd2c | G_a_1_sd1_sd3c | G_a_1_sd1_sd4c | G_a_1_sd1_sd5c
      | G_a_1_sd1_sd6c | G_a_1_sd2_sd1c | G_a_1_sd2_sd2c | G_a_1_sd2_sd3c
      | G_a_1_sd2_sd4c | G_a_1_sd2_sd5c | G_a_1_sd2_sd6c | G_a_1_sd3_sd1c
      | G_a_1_sd3_sd2c | G_a_1_sd3_sd3c | G_a_1_sd3_sd4c | G_a_1_sd3_sd5c
      | G_a_1_sd3_sd6c | G_a_1_sd4_sd1c | G_a_1_sd4_sd2c | G_a_1_sd4_sd3c
      | G_a_1_sd4_sd4c | G_a_1_sd4_sd5c | G_a_1_sd4_sd6c | G_a_1_sd5_sd1c
      | G_a_1_sd5_sd2c | G_a_1_sd5_sd3c | G_a_1_sd5_sd4c | G_a_1_sd5_sd5c
      | G_a_1_sd5_sd6c | G_a_1_sd6_sd1c | G_a_1_sd6_sd2c | G_a_1_sd6_sd3c
      | G_a_1_sd6_sd4c | G_a_1_sd6_sd5c | G_a_1_sd6_sd6c | G_z_1_sd1_sd1c
      | G_z_1_sd1_sd2c | G_z_1_sd1_sd3c | G_z_1_sd1_sd4c | G_z_1_sd1_sd5c
      | G_z_1_sd1_sd6c | G_z_1_sd2_sd1c | G_z_1_sd2_sd2c | G_z_1_sd2_sd3c
      | G_z_1_sd2_sd4c | G_z_1_sd2_sd5c | G_z_1_sd2_sd6c | G_z_1_sd3_sd1c
      | G_z_1_sd3_sd2c | G_z_1_sd3_sd3c | G_z_1_sd3_sd4c | G_z_1_sd3_sd5c
      | G_z_1_sd3_sd6c | G_z_1_sd4_sd1c | G_z_1_sd4_sd2c | G_z_1_sd4_sd3c
      | G_z_1_sd4_sd4c | G_z_1_sd4_sd5c | G_z_1_sd4_sd6c | G_z_1_sd5_sd1c
      | G_z_1_sd5_sd2c | G_z_1_sd5_sd3c | G_z_1_sd5_sd4c | G_z_1_sd5_sd5c
      | G_z_1_sd5_sd6c | G_z_1_sd6_sd1c | G_z_1_sd6_sd2c | G_z_1_sd6_sd3c
      | G_z_1_sd6_sd4c | G_z_1_sd6_sd5c | G_z_1_sd6_sd6c | G_wmc_sd1_su1c
      | G_wmc_sd1_su2c | G_wmc_sd1_su3c | G_wmc_sd1_su4c | G_wmc_sd1_su5c
      | G_wmc_sd1_su6c | G_wmc_sd2_su1c | G_wmc_sd2_su2c | G_wmc_sd2_su3c
      | G_wmc_sd2_su4c | G_wmc_sd2_su5c | G_wmc_sd2_su6c | G_wmc_sd3_su1c
      | G_wmc_sd3_su2c | G_wmc_sd3_su3c | G_wmc_sd3_su4c | G_wmc_sd3_su5c
      | G_wmc_sd3_su6c | G_wmc_sd4_su1c | G_wmc_sd4_su2c | G_wmc_sd4_su3c
      | G_wmc_sd4_su4c | G_wmc_sd4_su5c | G_wmc_sd4_su6c | G_wmc_sd5_su1c
      | G_wmc_sd5_su2c | G_wmc_sd5_su3c | G_wmc_sd5_su4c | G_wmc_sd5_su5c
      | G_wmc_sd5_su6c | G_wmc_sd6_su1c | G_wmc_sd6_su2c | G_wmc_sd6_su3c
      | G_wmc_sd6_su4c | G_wmc_sd6_su5c | G_wmc_sd6_su6c | G_a_1_se1_se1c
      | G_a_1_se1_se2c | G_a_1_se1_se3c | G_a_1_se1_se4c | G_a_1_se1_se5c
      | G_a_1_se1_se6c | G_a_1_se2_se1c | G_a_1_se2_se2c | G_a_1_se2_se3c
      | G_a_1_se2_se4c | G_a_1_se2_se5c | G_a_1_se2_se6c | G_a_1_se3_se1c
      | G_a_1_se3_se2c | G_a_1_se3_se3c | G_a_1_se3_se4c | G_a_1_se3_se5c
      | G_a_1_se3_se6c | G_a_1_se4_se1c | G_a_1_se4_se2c | G_a_1_se4_se3c
      | G_a_1_se4_se4c | G_a_1_se4_se5c | G_a_1_se4_se6c | G_a_1_se5_se1c
      | G_a_1_se5_se2c | G_a_1_se5_se3c | G_a_1_se5_se4c | G_a_1_se5_se5c
      | G_a_1_se5_se6c | G_a_1_se6_se1c | G_a_1_se6_se2c | G_a_1_se6_se3c
      | G_a_1_se6_se4c | G_a_1_se6_se5c | G_a_1_se6_se6c | G_z_1_se1_se1c
      | G_z_1_se1_se2c | G_z_1_se1_se3c | G_z_1_se1_se4c | G_z_1_se1_se5c
      | G_z_1_se1_se6c | G_z_1_se2_se1c | G_z_1_se2_se2c | G_z_1_se2_se3c
      | G_z_1_se2_se4c | G_z_1_se2_se5c | G_z_1_se2_se6c | G_z_1_se3_se1c
      | G_z_1_se3_se2c | G_z_1_se3_se3c | G_z_1_se3_se4c | G_z_1_se3_se5c
      | G_z_1_se3_se6c | G_z_1_se4_se1c | G_z_1_se4_se2c | G_z_1_se4_se3c
      | G_z_1_se4_se4c | G_z_1_se4_se5c | G_z_1_se4_se6c | G_z_1_se5_se1c
      | G_z_1_se5_se2c | G_z_1_se5_se3c | G_z_1_se5_se4c | G_z_1_se5_se5c
      | G_z_1_se5_se6c | G_z_1_se6_se1c | G_z_1_se6_se2c | G_z_1_se6_se3c
      | G_z_1_se6_se4c | G_z_1_se6_se5c | G_z_1_se6_se6c | G_wmc_se1_sv1c
      | G_wmc_se1_sv2c | G_wmc_se1_sv3c | G_wmc_se2_sv1c | G_wmc_se2_sv2c
      | G_wmc_se2_sv3c | G_wmc_se3_sv1c | G_wmc_se3_sv2c | G_wmc_se3_sv3c
      | G_wmc_se4_sv1c | G_wmc_se4_sv2c | G_wmc_se4_sv3c | G_wmc_se5_sv1c
      | G_wmc_se5_sv2c | G_wmc_se5_sv3c | G_wmc_se6_sv1c | G_wmc_se6_sv2c
      | G_wmc_se6_sv3c | G_a_1_su1_su1c | G_a_1_su1_su2c | G_a_1_su1_su3c
      | G_a_1_su1_su4c | G_a_1_su1_su5c | G_a_1_su1_su6c | G_a_1_su2_su1c
      | G_a_1_su2_su2c | G_a_1_su2_su3c | G_a_1_su2_su4c | G_a_1_su2_su5c
      | G_a_1_su2_su6c | G_a_1_su3_su1c | G_a_1_su3_su2c | G_a_1_su3_su3c
      | G_a_1_su3_su4c | G_a_1_su3_su5c | G_a_1_su3_su6c | G_a_1_su4_su1c
      | G_a_1_su4_su2c | G_a_1_su4_su3c | G_a_1_su4_su4c | G_a_1_su4_su5c
      | G_a_1_su4_su6c | G_a_1_su5_su1c | G_a_1_su5_su2c | G_a_1_su5_su3c
      | G_a_1_su5_su4c | G_a_1_su5_su5c | G_a_1_su5_su6c | G_a_1_su6_su1c
      | G_a_1_su6_su2c | G_a_1_su6_su3c | G_a_1_su6_su4c | G_a_1_su6_su5c
      | G_a_1_su6_su6c | G_wm_1_su1_sd1c | G_wm_1_su1_sd2c | G_wm_1_su1_sd3c
      | G_wm_1_su1_sd4c | G_wm_1_su1_sd5c | G_wm_1_su1_sd6c | G_wm_1_su2_sd1c
      | G_wm_1_su2_sd2c | G_wm_1_su2_sd3c | G_wm_1_su2_sd4c | G_wm_1_su2_sd5c
      | G_wm_1_su2_sd6c | G_wm_1_su3_sd1c | G_wm_1_su3_sd2c | G_wm_1_su3_sd3c
      | G_wm_1_su3_sd4c | G_wm_1_su3_sd5c | G_wm_1_su3_sd6c | G_wm_1_su4_sd1c
      | G_wm_1_su4_sd2c | G_wm_1_su4_sd3c | G_wm_1_su4_sd4c | G_wm_1_su4_sd5c
      | G_wm_1_su4_sd6c | G_wm_1_su5_sd1c | G_wm_1_su5_sd2c | G_wm_1_su5_sd3c
      | G_wm_1_su5_sd4c | G_wm_1_su5_sd5c | G_wm_1_su5_sd6c | G_wm_1_su6_sd1c
      | G_wm_1_su6_sd2c | G_wm_1_su6_sd3c | G_wm_1_su6_sd4c | G_wm_1_su6_sd5c
      | G_wm_1_su6_sd6c | G_z_1_su1_su1c | G_z_1_su1_su2c | G_z_1_su1_su3c
      | G_z_1_su1_su4c | G_z_1_su1_su5c | G_z_1_su1_su6c | G_z_1_su2_su1c
      | G_z_1_su2_su2c | G_z_1_su2_su3c | G_z_1_su2_su4c | G_z_1_su2_su5c
      | G_z_1_su2_su6c | G_z_1_su3_su1c | G_z_1_su3_su2c | G_z_1_su3_su3c
      | G_z_1_su3_su4c | G_z_1_su3_su5c | G_z_1_su3_su6c | G_z_1_su4_su1c
      | G_z_1_su4_su2c | G_z_1_su4_su3c | G_z_1_su4_su4c | G_z_1_su4_su5c
      | G_z_1_su4_su6c | G_z_1_su5_su1c | G_z_1_su5_su2c | G_z_1_su5_su3c
      | G_z_1_su5_su4c | G_z_1_su5_su5c | G_z_1_su5_su6c | G_z_1_su6_su1c
      | G_z_1_su6_su2c | G_z_1_su6_su3c | G_z_1_su6_su4c | G_z_1_su6_su5c
      | G_z_1_su6_su6c | G_wm_1_sv1_se1c | G_wm_1_sv1_se2c | G_wm_1_sv1_se3c
      | G_wm_1_sv1_se4c | G_wm_1_sv1_se5c | G_wm_1_sv1_se6c | G_wm_1_sv2_se1c
      | G_wm_1_sv2_se2c | G_wm_1_sv2_se3c | G_wm_1_sv2_se4c | G_wm_1_sv2_se5c
      | G_wm_1_sv2_se6c | G_wm_1_sv3_se1c | G_wm_1_sv3_se2c | G_wm_1_sv3_se3c
      | G_wm_1_sv3_se4c | G_wm_1_sv3_se5c | G_wm_1_sv3_se6c | G_z_1_sv1_sv1c
      | G_h1_wmc_wm_1 | G_h2_wmc_wm_1 | G_h1_z_1_z_1 | G_h2_z_1_z_1 | G_hm2_wmc_a_1
      | G_hm2_wmc_z_1 | G_c1bar_ah2_c1 | G_c1bar_ah2_c2 | G_c2bar_ah2_c1
      | G_c2bar_ah2_c2 | G_n1_ah2_n1 | G_n1_ah2_n2 | G_n1_ah2_n3 | G_n1_ah2_n4
      | G_n2_ah2_n2 | G_n2_ah2_n3 | G_n2_ah2_n4 | G_n3_ah2_n3 | G_n3_ah2_n4
      | G_n4_ah2_n4 | G_d1bar_ah2_d1 | G_d1bar_ah2_d2 | G_d1bar_ah2_d3
      | G_d2bar_ah2_d1 | G_d2bar_ah2_d2 | G_d2bar_ah2_d3 | G_d3bar_ah2_d1
      | G_d3bar_ah2_d2 | G_d3bar_ah2_d3 | G_e1bar_ah2_e1 | G_e1bar_ah2_e2
      | G_e1bar_ah2_e3 | G_e2bar_ah2_e1 | G_e2bar_ah2_e2 | G_e2bar_ah2_e3
      | G_e3bar_ah2_e1 | G_e3bar_ah2_e2 | G_e3bar_ah2_e3 | G_u1bar_ah2_u1
      | G_u1bar_ah2_u2 | G_u1bar_ah2_u3 | G_u2bar_ah2_u1 | G_u2bar_ah2_u2
      | G_u2bar_ah2_u3 | G_u3bar_ah2_u1 | G_u3bar_ah2_u2 | G_u3bar_ah2_u3
      | G_n1_hm2c_c1 | G_n1_hm2c_c2 | G_n2_hm2c_c1 | G_n2_hm2c_c2 | G_n3_hm2c_c1
      | G_n3_hm2c_c2 | G_n4_hm2c_c1 | G_n4_hm2c_c2 | G_c1_sd1c_u1 | G_c1_sd2c_u1
      | G_c1_sd3c_u1 | G_c1_sd4c_u1 | G_c1_sd5c_u1 | G_c1_sd6c_u1 | G_c1_sd1c_u2
      | G_c1_sd2c_u2 | G_c1_sd3c_u2 | G_c1_sd4c_u2 | G_c1_sd5c_u2 | G_c1_sd6c_u2
      | G_c1_sd1c_u3 | G_c1_sd2c_u3 | G_c1_sd3c_u3 | G_c1_sd4c_u3 | G_c1_sd5c_u3
      | G_c1_sd6c_u3 | G_c2_sd1c_u1 | G_c2_sd2c_u1 | G_c2_sd3c_u1 | G_c2_sd4c_u1
      | G_c2_sd5c_u1 | G_c2_sd6c_u1 | G_c2_sd1c_u2 | G_c2_sd2c_u2 | G_c2_sd3c_u2
      | G_c2_sd4c_u2 | G_c2_sd5c_u2 | G_c2_sd6c_u2 | G_c2_sd1c_u3 | G_c2_sd2c_u3
      | G_c2_sd3c_u3 | G_c2_sd4c_u3 | G_c2_sd5c_u3 | G_c2_sd6c_u3 | G_c1_se1c_nu1
      | G_c1_se2c_nu1 | G_c1_se3c_nu1 | G_c1_se4c_nu1 | G_c1_se5c_nu1 | G_c1_se6c_nu1
      | G_c1_se1c_nu2 | G_c1_se2c_nu2 | G_c1_se3c_nu2 | G_c1_se4c_nu2 | G_c1_se5c_nu2
      | G_c1_se6c_nu2 | G_c1_se1c_nu3 | G_c1_se2c_nu3 | G_c1_se3c_nu3 | G_c1_se4c_nu3
      | G_c1_se5c_nu3 | G_c1_se6c_nu3 | G_c2_se1c_nu1 | G_c2_se2c_nu1 | G_c2_se3c_nu1
      | G_c2_se4c_nu1 | G_c2_se5c_nu1 | G_c2_se6c_nu1 | G_c2_se1c_nu2 | G_c2_se2c_nu2
      | G_c2_se3c_nu2 | G_c2_se4c_nu2 | G_c2_se5c_nu2 | G_c2_se6c_nu2 | G_c2_se1c_nu3
      | G_c2_se2c_nu3 | G_c2_se3c_nu3 | G_c2_se4c_nu3 | G_c2_se5c_nu3 | G_c2_se6c_nu3
      | G_c1bar_h1_c1 | G_c1bar_h2_c1 | G_c1bar_h1_c2 | G_c1bar_h2_c2 | G_c2bar_h1_c1
      | G_c2bar_h2_c1 | G_c2bar_h1_c2 | G_c2bar_h2_c2 | G_d1bar_su1_c1
      | G_d1bar_su2_c1 | G_d1bar_su3_c1 | G_d1bar_su4_c1 | G_d1bar_su5_c1
      | G_d1bar_su6_c1 | G_d1bar_su1_c2 | G_d1bar_su2_c2 | G_d1bar_su3_c2
      | G_d1bar_su4_c2 | G_d1bar_su5_c2 | G_d1bar_su6_c2 | G_d2bar_su1_c1
      | G_d2bar_su2_c1 | G_d2bar_su3_c1 | G_d2bar_su4_c1 | G_d2bar_su5_c1
      | G_d2bar_su6_c1 | G_d2bar_su1_c2 | G_d2bar_su2_c2 | G_d2bar_su3_c2
      | G_d2bar_su4_c2 | G_d2bar_su5_c2 | G_d2bar_su6_c2 | G_d3bar_su1_c1
      | G_d3bar_su2_c1 | G_d3bar_su3_c1 | G_d3bar_su4_c1 | G_d3bar_su5_c1
      | G_d3bar_su6_c1 | G_d3bar_su1_c2 | G_d3bar_su2_c2 | G_d3bar_su3_c2
      | G_d3bar_su4_c2 | G_d3bar_su5_c2 | G_d3bar_su6_c2 | G_e1bar_sv1_c1
      | G_e1bar_sv2_c1 | G_e1bar_sv3_c1 | G_e1bar_sv1_c2 | G_e1bar_sv2_c2
      | G_e1bar_sv3_c2 | G_e2bar_sv1_c1 | G_e2bar_sv2_c1 | G_e2bar_sv3_c1
      | G_e2bar_sv1_c2 | G_e2bar_sv2_c2 | G_e2bar_sv3_c2 | G_e3bar_sv1_c1
      | G_e3bar_sv2_c1 | G_e3bar_sv3_c1 | G_e3bar_sv1_c2 | G_e3bar_sv2_c2
      | G_e3bar_sv3_c2 | G_n1_h1_n1 | G_n1_h2_n1 | G_n1_h1_n2 | G_n1_h2_n2
      | G_n1_h1_n3 | G_n1_h2_n3 | G_n1_h1_n4 | G_n1_h2_n4 | G_n2_h1_n2 | G_n2_h2_n2
      | G_n2_h1_n3 | G_n2_h2_n3 | G_n2_h1_n4 | G_n2_h2_n4 | G_n3_h1_n3 | G_n3_h2_n3
      | G_n3_h1_n4 | G_n3_h2_n4 | G_n4_h1_n4 | G_n4_h2_n4 | G_n1_sd1c_d1
      | G_n1_sd2c_d1 | G_n1_sd3c_d1 | G_n1_sd4c_d1 | G_n1_sd5c_d1 | G_n1_sd6c_d1
      | G_n1_sd1c_d2 | G_n1_sd2c_d2 | G_n1_sd3c_d2 | G_n1_sd4c_d2 | G_n1_sd5c_d2
      | G_n1_sd6c_d2 | G_n1_sd1c_d3 | G_n1_sd2c_d3 | G_n1_sd3c_d3 | G_n1_sd4c_d3
      | G_n1_sd5c_d3 | G_n1_sd6c_d3 | G_n2_sd1c_d1 | G_n2_sd2c_d1 | G_n2_sd3c_d1
      | G_n2_sd4c_d1 | G_n2_sd5c_d1 | G_n2_sd6c_d1 | G_n2_sd1c_d2 | G_n2_sd2c_d2
      | G_n2_sd3c_d2 | G_n2_sd4c_d2 | G_n2_sd5c_d2 | G_n2_sd6c_d2 | G_n2_sd1c_d3
      | G_n2_sd2c_d3 | G_n2_sd3c_d3 | G_n2_sd4c_d3 | G_n2_sd5c_d3 | G_n2_sd6c_d3
      | G_n3_sd1c_d1 | G_n3_sd2c_d1 | G_n3_sd3c_d1 | G_n3_sd4c_d1 | G_n3_sd5c_d1
      | G_n3_sd6c_d1 | G_n3_sd1c_d2 | G_n3_sd2c_d2 | G_n3_sd3c_d2 | G_n3_sd4c_d2
      | G_n3_sd5c_d2 | G_n3_sd6c_d2 | G_n3_sd1c_d3 | G_n3_sd2c_d3 | G_n3_sd3c_d3
      | G_n3_sd4c_d3 | G_n3_sd5c_d3 | G_n3_sd6c_d3 | G_n4_sd1c_d1 | G_n4_sd2c_d1
      | G_n4_sd3c_d1 | G_n4_sd4c_d1 | G_n4_sd5c_d1 | G_n4_sd6c_d1 | G_n4_sd1c_d2
      | G_n4_sd2c_d2 | G_n4_sd3c_d2 | G_n4_sd4c_d2 | G_n4_sd5c_d2 | G_n4_sd6c_d2
      | G_n4_sd1c_d3 | G_n4_sd2c_d3 | G_n4_sd3c_d3 | G_n4_sd4c_d3 | G_n4_sd5c_d3
      | G_n4_sd6c_d3 | G_n1_se1c_e1 | G_n1_se2c_e1 | G_n1_se3c_e1 | G_n1_se4c_e1
      | G_n1_se5c_e1 | G_n1_se6c_e1 | G_n1_se1c_e2 | G_n1_se2c_e2 | G_n1_se3c_e2
      | G_n1_se4c_e2 | G_n1_se5c_e2 | G_n1_se6c_e2 | G_n1_se1c_e3 | G_n1_se2c_e3
      | G_n1_se3c_e3 | G_n1_se4c_e3 | G_n1_se5c_e3 | G_n1_se6c_e3 | G_n2_se1c_e1
      | G_n2_se2c_e1 | G_n2_se3c_e1 | G_n2_se4c_e1 | G_n2_se5c_e1 | G_n2_se6c_e1
      | G_n2_se1c_e2 | G_n2_se2c_e2 | G_n2_se3c_e2 | G_n2_se4c_e2 | G_n2_se5c_e2
      | G_n2_se6c_e2 | G_n2_se1c_e3 | G_n2_se2c_e3 | G_n2_se3c_e3 | G_n2_se4c_e3
      | G_n2_se5c_e3 | G_n2_se6c_e3 | G_n3_se1c_e1 | G_n3_se2c_e1 | G_n3_se3c_e1
      | G_n3_se4c_e1 | G_n3_se5c_e1 | G_n3_se6c_e1 | G_n3_se1c_e2 | G_n3_se2c_e2
      | G_n3_se3c_e2 | G_n3_se4c_e2 | G_n3_se5c_e2 | G_n3_se6c_e2 | G_n3_se1c_e3
      | G_n3_se2c_e3 | G_n3_se3c_e3 | G_n3_se4c_e3 | G_n3_se5c_e3 | G_n3_se6c_e3
      | G_n4_se1c_e1 | G_n4_se2c_e1 | G_n4_se3c_e1 | G_n4_se4c_e1 | G_n4_se5c_e1
      | G_n4_se6c_e1 | G_n4_se1c_e2 | G_n4_se2c_e2 | G_n4_se3c_e2 | G_n4_se4c_e2
      | G_n4_se5c_e2 | G_n4_se6c_e2 | G_n4_se1c_e3 | G_n4_se2c_e3 | G_n4_se3c_e3
      | G_n4_se4c_e3 | G_n4_se5c_e3 | G_n4_se6c_e3 | G_n1_su1c_u1 | G_n1_su2c_u1
      | G_n1_su3c_u1 | G_n1_su4c_u1 | G_n1_su5c_u1 | G_n1_su6c_u1 | G_n1_su1c_u2
      | G_n1_su2c_u2 | G_n1_su3c_u2 | G_n1_su4c_u2 | G_n1_su5c_u2 | G_n1_su6c_u2
      | G_n1_su1c_u3 | G_n1_su2c_u3 | G_n1_su3c_u3 | G_n1_su4c_u3 | G_n1_su5c_u3
      | G_n1_su6c_u3 | G_n2_su1c_u1 | G_n2_su2c_u1 | G_n2_su3c_u1 | G_n2_su4c_u1
      | G_n2_su5c_u1 | G_n2_su6c_u1 | G_n2_su1c_u2 | G_n2_su2c_u2 | G_n2_su3c_u2
      | G_n2_su4c_u2 | G_n2_su5c_u2 | G_n2_su6c_u2 | G_n2_su1c_u3 | G_n2_su2c_u3
      | G_n2_su3c_u3 | G_n2_su4c_u3 | G_n2_su5c_u3 | G_n2_su6c_u3 | G_n3_su1c_u1
      | G_n3_su2c_u1 | G_n3_su3c_u1 | G_n3_su4c_u1 | G_n3_su5c_u1 | G_n3_su6c_u1
      | G_n3_su1c_u2 | G_n3_su2c_u2 | G_n3_su3c_u2 | G_n3_su4c_u2 | G_n3_su5c_u2
      | G_n3_su6c_u2 | G_n3_su1c_u3 | G_n3_su2c_u3 | G_n3_su3c_u3 | G_n3_su4c_u3
      | G_n3_su5c_u3 | G_n3_su6c_u3 | G_n4_su1c_u1 | G_n4_su2c_u1 | G_n4_su3c_u1
      | G_n4_su4c_u1 | G_n4_su5c_u1 | G_n4_su6c_u1 | G_n4_su1c_u2 | G_n4_su2c_u2
      | G_n4_su3c_u2 | G_n4_su4c_u2 | G_n4_su5c_u2 | G_n4_su6c_u2 | G_n4_su1c_u3
      | G_n4_su2c_u3 | G_n4_su3c_u3 | G_n4_su4c_u3 | G_n4_su5c_u3 | G_n4_su6c_u3
      | G_n1_sv1c_nu1 | G_n1_sv2c_nu1 | G_n1_sv3c_nu1 | G_n1_sv1c_nu2 | G_n1_sv2c_nu2
      | G_n1_sv3c_nu2 | G_n1_sv1c_nu3 | G_n1_sv2c_nu3 | G_n1_sv3c_nu3 | G_n2_sv1c_nu1
      | G_n2_sv2c_nu1 | G_n2_sv3c_nu1 | G_n2_sv1c_nu2 | G_n2_sv2c_nu2 | G_n2_sv3c_nu2
      | G_n2_sv1c_nu3 | G_n2_sv2c_nu3 | G_n2_sv3c_nu3 | G_n3_sv1c_nu1 | G_n3_sv2c_nu1
      | G_n3_sv3c_nu1 | G_n3_sv1c_nu2 | G_n3_sv2c_nu2 | G_n3_sv3c_nu2 | G_n3_sv1c_nu3
      | G_n3_sv2c_nu3 | G_n3_sv3c_nu3 | G_n4_sv1c_nu1 | G_n4_sv2c_nu1 | G_n4_sv3c_nu1
      | G_n4_sv1c_nu2 | G_n4_sv2c_nu2 | G_n4_sv3c_nu2 | G_n4_sv1c_nu3 | G_n4_sv2c_nu3
      | G_n4_sv3c_nu3 | G_c1bar_hm2_n1 | G_c1bar_hm2_n2 | G_c1bar_hm2_n3
      | G_c1bar_hm2_n4 | G_c2bar_hm2_n1 | G_c2bar_hm2_n2 | G_c2bar_hm2_n3
      | G_c2bar_hm2_n4 | G_d1bar_sd1_n1 | G_d1bar_sd2_n1 | G_d1bar_sd3_n1
      | G_d1bar_sd4_n1 | G_d1bar_sd5_n1 | G_d1bar_sd6_n1 | G_d1bar_sd1_n2
      | G_d1bar_sd2_n2 | G_d1bar_sd3_n2 | G_d1bar_sd4_n2 | G_d1bar_sd5_n2
      | G_d1bar_sd6_n2 | G_d1bar_sd1_n3 | G_d1bar_sd2_n3 | G_d1bar_sd3_n3
      | G_d1bar_sd4_n3 | G_d1bar_sd5_n3 | G_d1bar_sd6_n3 | G_d1bar_sd1_n4
      | G_d1bar_sd2_n4 | G_d1bar_sd3_n4 | G_d1bar_sd4_n4 | G_d1bar_sd5_n4
      | G_d1bar_sd6_n4 | G_d2bar_sd1_n1 | G_d2bar_sd2_n1 | G_d2bar_sd3_n1
      | G_d2bar_sd4_n1 | G_d2bar_sd5_n1 | G_d2bar_sd6_n1 | G_d2bar_sd1_n2
      | G_d2bar_sd2_n2 | G_d2bar_sd3_n2 | G_d2bar_sd4_n2 | G_d2bar_sd5_n2
      | G_d2bar_sd6_n2 | G_d2bar_sd1_n3 | G_d2bar_sd2_n3 | G_d2bar_sd3_n3
      | G_d2bar_sd4_n3 | G_d2bar_sd5_n3 | G_d2bar_sd6_n3 | G_d2bar_sd1_n4
      | G_d2bar_sd2_n4 | G_d2bar_sd3_n4 | G_d2bar_sd4_n4 | G_d2bar_sd5_n4
      | G_d2bar_sd6_n4 | G_d3bar_sd1_n1 | G_d3bar_sd2_n1 | G_d3bar_sd3_n1
      | G_d3bar_sd4_n1 | G_d3bar_sd5_n1 | G_d3bar_sd6_n1 | G_d3bar_sd1_n2
      | G_d3bar_sd2_n2 | G_d3bar_sd3_n2 | G_d3bar_sd4_n2 | G_d3bar_sd5_n2
      | G_d3bar_sd6_n2 | G_d3bar_sd1_n3 | G_d3bar_sd2_n3 | G_d3bar_sd3_n3
      | G_d3bar_sd4_n3 | G_d3bar_sd5_n3 | G_d3bar_sd6_n3 | G_d3bar_sd1_n4
      | G_d3bar_sd2_n4 | G_d3bar_sd3_n4 | G_d3bar_sd4_n4 | G_d3bar_sd5_n4
      | G_d3bar_sd6_n4 | G_e1bar_se1_n1 | G_e1bar_se2_n1 | G_e1bar_se3_n1
      | G_e1bar_se4_n1 | G_e1bar_se5_n1 | G_e1bar_se6_n1 | G_e1bar_se1_n2
      | G_e1bar_se2_n2 | G_e1bar_se3_n2 | G_e1bar_se4_n2 | G_e1bar_se5_n2
      | G_e1bar_se6_n2 | G_e1bar_se1_n3 | G_e1bar_se2_n3 | G_e1bar_se3_n3
      | G_e1bar_se4_n3 | G_e1bar_se5_n3 | G_e1bar_se6_n3 | G_e1bar_se1_n4
      | G_e1bar_se2_n4 | G_e1bar_se3_n4 | G_e1bar_se4_n4 | G_e1bar_se5_n4
      | G_e1bar_se6_n4 | G_e2bar_se1_n1 | G_e2bar_se2_n1 | G_e2bar_se3_n1
      | G_e2bar_se4_n1 | G_e2bar_se5_n1 | G_e2bar_se6_n1 | G_e2bar_se1_n2
      | G_e2bar_se2_n2 | G_e2bar_se3_n2 | G_e2bar_se4_n2 | G_e2bar_se5_n2
      | G_e2bar_se6_n2 | G_e2bar_se1_n3 | G_e2bar_se2_n3 | G_e2bar_se3_n3
      | G_e2bar_se4_n3 | G_e2bar_se5_n3 | G_e2bar_se6_n3 | G_e2bar_se1_n4
      | G_e2bar_se2_n4 | G_e2bar_se3_n4 | G_e2bar_se4_n4 | G_e2bar_se5_n4
      | G_e2bar_se6_n4 | G_e3bar_se1_n1 | G_e3bar_se2_n1 | G_e3bar_se3_n1
      | G_e3bar_se4_n1 | G_e3bar_se5_n1 | G_e3bar_se6_n1 | G_e3bar_se1_n2
      | G_e3bar_se2_n2 | G_e3bar_se3_n2 | G_e3bar_se4_n2 | G_e3bar_se5_n2
      | G_e3bar_se6_n2 | G_e3bar_se1_n3 | G_e3bar_se2_n3 | G_e3bar_se3_n3
      | G_e3bar_se4_n3 | G_e3bar_se5_n3 | G_e3bar_se6_n3 | G_e3bar_se1_n4
      | G_e3bar_se2_n4 | G_e3bar_se3_n4 | G_e3bar_se4_n4 | G_e3bar_se5_n4
      | G_e3bar_se6_n4 | G_u1bar_su1_n1 | G_u1bar_su2_n1 | G_u1bar_su3_n1
      | G_u1bar_su4_n1 | G_u1bar_su5_n1 | G_u1bar_su6_n1 | G_u1bar_su1_n2
      | G_u1bar_su2_n2 | G_u1bar_su3_n2 | G_u1bar_su4_n2 | G_u1bar_su5_n2
      | G_u1bar_su6_n2 | G_u1bar_su1_n3 | G_u1bar_su2_n3 | G_u1bar_su3_n3
      | G_u1bar_su4_n3 | G_u1bar_su5_n3 | G_u1bar_su6_n3 | G_u1bar_su1_n4
      | G_u1bar_su2_n4 | G_u1bar_su3_n4 | G_u1bar_su4_n4 | G_u1bar_su5_n4
      | G_u1bar_su6_n4 | G_u2bar_su1_n1 | G_u2bar_su2_n1 | G_u2bar_su3_n1
      | G_u2bar_su4_n1 | G_u2bar_su5_n1 | G_u2bar_su6_n1 | G_u2bar_su1_n2
      | G_u2bar_su2_n2 | G_u2bar_su3_n2 | G_u2bar_su4_n2 | G_u2bar_su5_n2
      | G_u2bar_su6_n2 | G_u2bar_su1_n3 | G_u2bar_su2_n3 | G_u2bar_su3_n3
      | G_u2bar_su4_n3 | G_u2bar_su5_n3 | G_u2bar_su6_n3 | G_u2bar_su1_n4
      | G_u2bar_su2_n4 | G_u2bar_su3_n4 | G_u2bar_su4_n4 | G_u2bar_su5_n4
      | G_u2bar_su6_n4 | G_u3bar_su1_n1 | G_u3bar_su2_n1 | G_u3bar_su3_n1
      | G_u3bar_su4_n1 | G_u3bar_su5_n1 | G_u3bar_su6_n1 | G_u3bar_su1_n2
      | G_u3bar_su2_n2 | G_u3bar_su3_n2 | G_u3bar_su4_n2 | G_u3bar_su5_n2
      | G_u3bar_su6_n2 | G_u3bar_su1_n3 | G_u3bar_su2_n3 | G_u3bar_su3_n3
      | G_u3bar_su4_n3 | G_u3bar_su5_n3 | G_u3bar_su6_n3 | G_u3bar_su1_n4
      | G_u3bar_su2_n4 | G_u3bar_su3_n4 | G_u3bar_su4_n4 | G_u3bar_su5_n4
      | G_u3bar_su6_n4 | G_nu1bar_sv1_n1 | G_nu1bar_sv2_n1 | G_nu1bar_sv3_n1
      | G_nu1bar_sv1_n2 | G_nu1bar_sv2_n2 | G_nu1bar_sv3_n2 | G_nu1bar_sv1_n3
      | G_nu1bar_sv2_n3 | G_nu1bar_sv3_n3 | G_nu1bar_sv1_n4 | G_nu1bar_sv2_n4
      | G_nu1bar_sv3_n4 | G_nu2bar_sv1_n1 | G_nu2bar_sv2_n1 | G_nu2bar_sv3_n1
      | G_nu2bar_sv1_n2 | G_nu2bar_sv2_n2 | G_nu2bar_sv3_n2 | G_nu2bar_sv1_n3
      | G_nu2bar_sv2_n3 | G_nu2bar_sv3_n3 | G_nu2bar_sv1_n4 | G_nu2bar_sv2_n4
      | G_nu2bar_sv3_n4 | G_nu3bar_sv1_n1 | G_nu3bar_sv2_n1 | G_nu3bar_sv3_n1
      | G_nu3bar_sv1_n2 | G_nu3bar_sv2_n2 | G_nu3bar_sv3_n2 | G_nu3bar_sv1_n3
      | G_nu3bar_sv2_n3 | G_nu3bar_sv3_n3 | G_nu3bar_sv1_n4 | G_nu3bar_sv2_n4
      | G_nu3bar_sv3_n4 | G_go_1_sd1c_d1 | G_go_1_sd2c_d1 | G_go_1_sd3c_d1
      | G_go_1_sd4c_d1 | G_go_1_sd5c_d1 | G_go_1_sd6c_d1 | G_go_1_sd1c_d2
      | G_go_1_sd2c_d2 | G_go_1_sd3c_d2 | G_go_1_sd4c_d2 | G_go_1_sd5c_d2
      | G_go_1_sd6c_d2 | G_go_1_sd1c_d3 | G_go_1_sd2c_d3 | G_go_1_sd3c_d3
      | G_go_1_sd4c_d3 | G_go_1_sd5c_d3 | G_go_1_sd6c_d3 | G_d1bar_h1_d1
      | G_d1bar_h2_d1 | G_d1bar_h1_d2 | G_d1bar_h2_d2 | G_d1bar_h1_d3 | G_d1bar_h2_d3
      | G_d2bar_h1_d1 | G_d2bar_h2_d1 | G_d2bar_h1_d2 | G_d2bar_h2_d2 | G_d2bar_h1_d3
      | G_d2bar_h2_d3 | G_d3bar_h1_d1 | G_d3bar_h2_d1 | G_d3bar_h1_d2 | G_d3bar_h2_d2
      | G_d3bar_h1_d3 | G_d3bar_h2_d3 | G_c1bar_su1c_d1 | G_c1bar_su2c_d1
      | G_c1bar_su3c_d1 | G_c1bar_su4c_d1 | G_c1bar_su5c_d1 | G_c1bar_su6c_d1
      | G_c1bar_su1c_d2 | G_c1bar_su2c_d2 | G_c1bar_su3c_d2 | G_c1bar_su4c_d2
      | G_c1bar_su5c_d2 | G_c1bar_su6c_d2 | G_c1bar_su1c_d3 | G_c1bar_su2c_d3
      | G_c1bar_su3c_d3 | G_c1bar_su4c_d3 | G_c1bar_su5c_d3 | G_c1bar_su6c_d3
      | G_c2bar_su1c_d1 | G_c2bar_su2c_d1 | G_c2bar_su3c_d1 | G_c2bar_su4c_d1
      | G_c2bar_su5c_d1 | G_c2bar_su6c_d1 | G_c2bar_su1c_d2 | G_c2bar_su2c_d2
      | G_c2bar_su3c_d2 | G_c2bar_su4c_d2 | G_c2bar_su5c_d2 | G_c2bar_su6c_d2
      | G_c2bar_su1c_d3 | G_c2bar_su2c_d3 | G_c2bar_su3c_d3 | G_c2bar_su4c_d3
      | G_c2bar_su5c_d3 | G_c2bar_su6c_d3 | G_u1bar_hm2c_d1 | G_u1bar_hm2c_d2
      | G_u1bar_hm2c_d3 | G_u2bar_hm2c_d1 | G_u2bar_hm2c_d2 | G_u2bar_hm2c_d3
      | G_u3bar_hm2c_d1 | G_u3bar_hm2c_d2 | G_u3bar_hm2c_d3 | G_e1bar_h1_e1
      | G_e1bar_h2_e1 | G_e1bar_h1_e2 | G_e1bar_h2_e2 | G_e1bar_h1_e3 | G_e1bar_h2_e3
      | G_e2bar_h1_e1 | G_e2bar_h2_e1 | G_e2bar_h1_e2 | G_e2bar_h2_e2 | G_e2bar_h1_e3
      | G_e2bar_h2_e3 | G_e3bar_h1_e1 | G_e3bar_h2_e1 | G_e3bar_h1_e2 | G_e3bar_h2_e2
      | G_e3bar_h1_e3 | G_e3bar_h2_e3 | G_c1bar_sv1c_e1 | G_c1bar_sv2c_e1
      | G_c1bar_sv3c_e1 | G_c1bar_sv1c_e2 | G_c1bar_sv2c_e2 | G_c1bar_sv3c_e2
      | G_c1bar_sv1c_e3 | G_c1bar_sv2c_e3 | G_c1bar_sv3c_e3 | G_c2bar_sv1c_e1
      | G_c2bar_sv2c_e1 | G_c2bar_sv3c_e1 | G_c2bar_sv1c_e2 | G_c2bar_sv2c_e2
      | G_c2bar_sv3c_e2 | G_c2bar_sv1c_e3 | G_c2bar_sv2c_e3 | G_c2bar_sv3c_e3
      | G_nu1bar_hm2c_e1 | G_nu1bar_hm2c_e2 | G_nu1bar_hm2c_e3 | G_nu2bar_hm2c_e1
      | G_nu2bar_hm2c_e2 | G_nu2bar_hm2c_e3 | G_nu3bar_hm2c_e1 | G_nu3bar_hm2c_e2
      | G_nu3bar_hm2c_e3 | G_go_1_su1c_u1 | G_go_1_su2c_u1 | G_go_1_su3c_u1
      | G_go_1_su4c_u1 | G_go_1_su5c_u1 | G_go_1_su6c_u1 | G_go_1_su1c_u2
      | G_go_1_su2c_u2 | G_go_1_su3c_u2 | G_go_1_su4c_u2 | G_go_1_su5c_u2
      | G_go_1_su6c_u2 | G_go_1_su1c_u3 | G_go_1_su2c_u3 | G_go_1_su3c_u3
      | G_go_1_su4c_u3 | G_go_1_su5c_u3 | G_go_1_su6c_u3 | G_u1bar_h1_u1
      | G_u1bar_h2_u1 | G_u1bar_h1_u2 | G_u1bar_h2_u2 | G_u1bar_h1_u3 | G_u1bar_h2_u3
      | G_u2bar_h1_u1 | G_u2bar_h2_u1 | G_u2bar_h1_u2 | G_u2bar_h2_u2 | G_u2bar_h1_u3
      | G_u2bar_h2_u3 | G_u3bar_h1_u1 | G_u3bar_h2_u1 | G_u3bar_h1_u2 | G_u3bar_h2_u2
      | G_u3bar_h1_u3 | G_u3bar_h2_u3 | G_d1bar_hm2_u1 | G_d1bar_hm2_u2
      | G_d1bar_hm2_u3 | G_d2bar_hm2_u1 | G_d2bar_hm2_u2 | G_d2bar_hm2_u3
      | G_d3bar_hm2_u1 | G_d3bar_hm2_u2 | G_d3bar_hm2_u3 | G_e1bar_hm2_nu1
      | G_e1bar_hm2_nu2 | G_e1bar_hm2_nu3 | G_e2bar_hm2_nu1 | G_e2bar_hm2_nu2
      | G_e2bar_hm2_nu3 | G_e3bar_hm2_nu1 | G_e3bar_hm2_nu2 | G_e3bar_hm2_nu3
      | G_d1bar_sd1_go_1 | G_d1bar_sd2_go_1 | G_d1bar_sd3_go_1 | G_d1bar_sd4_go_1
      | G_d1bar_sd5_go_1 | G_d1bar_sd6_go_1 | G_d2bar_sd1_go_1 | G_d2bar_sd2_go_1
      | G_d2bar_sd3_go_1 | G_d2bar_sd4_go_1 | G_d2bar_sd5_go_1 | G_d2bar_sd6_go_1
      | G_d3bar_sd1_go_1 | G_d3bar_sd2_go_1 | G_d3bar_sd3_go_1 | G_d3bar_sd4_go_1
      | G_d3bar_sd5_go_1 | G_d3bar_sd6_go_1 | G_u1bar_su1_go_1 | G_u1bar_su2_go_1
      | G_u1bar_su3_go_1 | G_u1bar_su4_go_1 | G_u1bar_su5_go_1 | G_u1bar_su6_go_1
      | G_u2bar_su1_go_1 | G_u2bar_su2_go_1 | G_u2bar_su3_go_1 | G_u2bar_su4_go_1
      | G_u2bar_su5_go_1 | G_u2bar_su6_go_1 | G_u3bar_su1_go_1 | G_u3bar_su2_go_1
      | G_u3bar_su3_go_1 | G_u3bar_su4_go_1 | G_u3bar_su5_go_1 | G_u3bar_su6_go_1
      | G_c1bar_sd1_u1bar | G_c1bar_sd2_u1bar | G_c1bar_sd3_u1bar | G_c1bar_sd4_u1bar
      | G_c1bar_sd5_u1bar | G_c1bar_sd6_u1bar | G_c1bar_sd1_u2bar | G_c1bar_sd2_u2bar
      | G_c1bar_sd3_u2bar | G_c1bar_sd4_u2bar | G_c1bar_sd5_u2bar | G_c1bar_sd6_u2bar
      | G_c1bar_sd1_u3bar | G_c1bar_sd2_u3bar | G_c1bar_sd3_u3bar | G_c1bar_sd4_u3bar
      | G_c1bar_sd5_u3bar | G_c1bar_sd6_u3bar | G_c2bar_sd1_u1bar | G_c2bar_sd2_u1bar
      | G_c2bar_sd3_u1bar | G_c2bar_sd4_u1bar | G_c2bar_sd5_u1bar | G_c2bar_sd6_u1bar
      | G_c2bar_sd1_u2bar | G_c2bar_sd2_u2bar | G_c2bar_sd3_u2bar | G_c2bar_sd4_u2bar
      | G_c2bar_sd5_u2bar | G_c2bar_sd6_u2bar | G_c2bar_sd1_u3bar | G_c2bar_sd2_u3bar
      | G_c2bar_sd3_u3bar | G_c2bar_sd4_u3bar | G_c2bar_sd5_u3bar | G_c2bar_sd6_u3bar
      | G_c1bar_se1_nu1bar | G_c1bar_se2_nu1bar | G_c1bar_se3_nu1bar
      | G_c1bar_se4_nu1bar | G_c1bar_se5_nu1bar | G_c1bar_se6_nu1bar
      | G_c1bar_se1_nu2bar | G_c1bar_se2_nu2bar | G_c1bar_se3_nu2bar
      | G_c1bar_se4_nu2bar | G_c1bar_se5_nu2bar | G_c1bar_se6_nu2bar
      | G_c1bar_se1_nu3bar | G_c1bar_se2_nu3bar | G_c1bar_se3_nu3bar
      | G_c1bar_se4_nu3bar | G_c1bar_se5_nu3bar | G_c1bar_se6_nu3bar
      | G_c2bar_se1_nu1bar | G_c2bar_se2_nu1bar | G_c2bar_se3_nu1bar
      | G_c2bar_se4_nu1bar | G_c2bar_se5_nu1bar | G_c2bar_se6_nu1bar
      | G_c2bar_se1_nu2bar | G_c2bar_se2_nu2bar | G_c2bar_se3_nu2bar
      | G_c2bar_se4_nu2bar | G_c2bar_se5_nu2bar | G_c2bar_se6_nu2bar
      | G_c2bar_se1_nu3bar | G_c2bar_se2_nu3bar | G_c2bar_se3_nu3bar
      | G_c2bar_se4_nu3bar | G_c2bar_se5_nu3bar | G_c2bar_se6_nu3bar | G_n1_wmc_c1
      | G_n1_wmc_c2 | G_n2_wmc_c1 | G_n2_wmc_c2 | G_n3_wmc_c1 | G_n3_wmc_c2
      | G_n4_wmc_c1 | G_n4_wmc_c2 | G_c1bar_a_1_c1 | G_c1bar_a_1_c2 | G_c2bar_a_1_c1
      | G_c2bar_a_1_c2 | G_c1bar_z_1_c1 | G_c1bar_z_1_c2 | G_c2bar_z_1_c1
      | G_c2bar_z_1_c2 | G_n1_z_1_n1 | G_n1_z_1_n2 | G_n1_z_1_n3 | G_n1_z_1_n4
      | G_n2_z_1_n2 | G_n2_z_1_n3 | G_n2_z_1_n4 | G_n3_z_1_n3 | G_n3_z_1_n4
      | G_n4_z_1_n4 | G_c1bar_wm_1_n1 | G_c1bar_wm_1_n2 | G_c1bar_wm_1_n3
      | G_c1bar_wm_1_n4 | G_c2bar_wm_1_n1 | G_c2bar_wm_1_n2 | G_c2bar_wm_1_n3
      | G_c2bar_wm_1_n4 | G_d1bar_g_1_d1 | G_d1bar_a_1_d1 | G_d1bar_z_1_d1
      | G_u1bar_wmc_d1 | G_u1bar_wmc_d2 | G_u1bar_wmc_d3 | G_u2bar_wmc_d1
      | G_u2bar_wmc_d2 | G_u2bar_wmc_d3 | G_u3bar_wmc_d1 | G_u3bar_wmc_d2
      | G_u3bar_wmc_d3 | G_e1bar_a_1_e1 | G_e1bar_z_1_e1 | G_nu1bar_wmc_e1
      | G_nu1bar_wmc_e2 | G_nu1bar_wmc_e3 | G_nu2bar_wmc_e1 | G_nu2bar_wmc_e2
      | G_nu2bar_wmc_e3 | G_nu3bar_wmc_e1 | G_nu3bar_wmc_e2 | G_nu3bar_wmc_e3
      | G_u1bar_a_1_u1 | G_d1bar_wm_1_u1 | G_d1bar_wm_1_u2 | G_d1bar_wm_1_u3
      | G_d2bar_wm_1_u1 | G_d2bar_wm_1_u2 | G_d2bar_wm_1_u3 | G_d3bar_wm_1_u1
      | G_d3bar_wm_1_u2 | G_d3bar_wm_1_u3 | G_u1bar_z_1_u1 | G_e1bar_wm_1_nu1
      | G_e1bar_wm_1_nu2 | G_e1bar_wm_1_nu3 | G_e2bar_wm_1_nu1 | G_e2bar_wm_1_nu2
      | G_e2bar_wm_1_nu3 | G_e3bar_wm_1_nu1 | G_e3bar_wm_1_nu2 | G_e3bar_wm_1_nu3
      | G_nu1bar_z_1_nu1 | G_go_1_g_1_go_1 | G_g_1_g_1_g_1 | G_wmc_a_1_wm_1
      | G_wmc_wm_1_z_1 | G_g_1_g_1_g_1_g_1 | G_wmc_a_1_a_1_wm_1 | G_wmc_a_1_wm_1_z_1
      | G_wmc_a_1_wm_1_z_1_1 | G_wmc_wmc_wm_1_wm_1 | G_wmc_wm_1_z_1_z_1

   let parameters () = {input = []; derived = []; derived_arrays = []}

   let constant_symbol = function
      | G_ah2_ah2_h1 -> "G_ah2_ah2_h1" | G_ah2_ah2_h2 -> "G_ah2_ah2_h2"
      | G_ah2_sd1_sd1c -> "G_ah2_sd1_sd1c" | G_ah2_sd1_sd2c -> "G_ah2_sd1_sd2c"
      | G_ah2_sd1_sd3c -> "G_ah2_sd1_sd3c" | G_ah2_sd1_sd4c -> "G_ah2_sd1_sd4c"
      | G_ah2_sd1_sd5c -> "G_ah2_sd1_sd5c" | G_ah2_sd1_sd6c -> "G_ah2_sd1_sd6c"
      | G_ah2_sd2_sd1c -> "G_ah2_sd2_sd1c" | G_ah2_sd2_sd2c -> "G_ah2_sd2_sd2c"
      | G_ah2_sd2_sd3c -> "G_ah2_sd2_sd3c" | G_ah2_sd2_sd4c -> "G_ah2_sd2_sd4c"
      | G_ah2_sd2_sd5c -> "G_ah2_sd2_sd5c" | G_ah2_sd2_sd6c -> "G_ah2_sd2_sd6c"
      | G_ah2_sd3_sd1c -> "G_ah2_sd3_sd1c" | G_ah2_sd3_sd2c -> "G_ah2_sd3_sd2c"
      | G_ah2_sd3_sd3c -> "G_ah2_sd3_sd3c" | G_ah2_sd3_sd4c -> "G_ah2_sd3_sd4c"
      | G_ah2_sd3_sd5c -> "G_ah2_sd3_sd5c" | G_ah2_sd3_sd6c -> "G_ah2_sd3_sd6c"
      | G_ah2_sd4_sd1c -> "G_ah2_sd4_sd1c" | G_ah2_sd4_sd2c -> "G_ah2_sd4_sd2c"
      | G_ah2_sd4_sd3c -> "G_ah2_sd4_sd3c" | G_ah2_sd4_sd4c -> "G_ah2_sd4_sd4c"
      | G_ah2_sd4_sd5c -> "G_ah2_sd4_sd5c" | G_ah2_sd4_sd6c -> "G_ah2_sd4_sd6c"
      | G_ah2_sd5_sd1c -> "G_ah2_sd5_sd1c" | G_ah2_sd5_sd2c -> "G_ah2_sd5_sd2c"
      | G_ah2_sd5_sd3c -> "G_ah2_sd5_sd3c" | G_ah2_sd5_sd4c -> "G_ah2_sd5_sd4c"
      | G_ah2_sd5_sd5c -> "G_ah2_sd5_sd5c" | G_ah2_sd5_sd6c -> "G_ah2_sd5_sd6c"
      | G_ah2_sd6_sd1c -> "G_ah2_sd6_sd1c" | G_ah2_sd6_sd2c -> "G_ah2_sd6_sd2c"
      | G_ah2_sd6_sd3c -> "G_ah2_sd6_sd3c" | G_ah2_sd6_sd4c -> "G_ah2_sd6_sd4c"
      | G_ah2_sd6_sd5c -> "G_ah2_sd6_sd5c" | G_ah2_sd6_sd6c -> "G_ah2_sd6_sd6c"
      | G_ah2_se1_se1c -> "G_ah2_se1_se1c" | G_ah2_se1_se2c -> "G_ah2_se1_se2c"
      | G_ah2_se1_se3c -> "G_ah2_se1_se3c" | G_ah2_se1_se4c -> "G_ah2_se1_se4c"
      | G_ah2_se1_se5c -> "G_ah2_se1_se5c" | G_ah2_se1_se6c -> "G_ah2_se1_se6c"
      | G_ah2_se2_se1c -> "G_ah2_se2_se1c" | G_ah2_se2_se2c -> "G_ah2_se2_se2c"
      | G_ah2_se2_se3c -> "G_ah2_se2_se3c" | G_ah2_se2_se4c -> "G_ah2_se2_se4c"
      | G_ah2_se2_se5c -> "G_ah2_se2_se5c" | G_ah2_se2_se6c -> "G_ah2_se2_se6c"
      | G_ah2_se3_se1c -> "G_ah2_se3_se1c" | G_ah2_se3_se2c -> "G_ah2_se3_se2c"
      | G_ah2_se3_se3c -> "G_ah2_se3_se3c" | G_ah2_se3_se4c -> "G_ah2_se3_se4c"
      | G_ah2_se3_se5c -> "G_ah2_se3_se5c" | G_ah2_se3_se6c -> "G_ah2_se3_se6c"
      | G_ah2_se4_se1c -> "G_ah2_se4_se1c" | G_ah2_se4_se2c -> "G_ah2_se4_se2c"
      | G_ah2_se4_se3c -> "G_ah2_se4_se3c" | G_ah2_se4_se4c -> "G_ah2_se4_se4c"
      | G_ah2_se4_se5c -> "G_ah2_se4_se5c" | G_ah2_se4_se6c -> "G_ah2_se4_se6c"
      | G_ah2_se5_se1c -> "G_ah2_se5_se1c" | G_ah2_se5_se2c -> "G_ah2_se5_se2c"
      | G_ah2_se5_se3c -> "G_ah2_se5_se3c" | G_ah2_se5_se4c -> "G_ah2_se5_se4c"
      | G_ah2_se5_se5c -> "G_ah2_se5_se5c" | G_ah2_se5_se6c -> "G_ah2_se5_se6c"
      | G_ah2_se6_se1c -> "G_ah2_se6_se1c" | G_ah2_se6_se2c -> "G_ah2_se6_se2c"
      | G_ah2_se6_se3c -> "G_ah2_se6_se3c" | G_ah2_se6_se4c -> "G_ah2_se6_se4c"
      | G_ah2_se6_se5c -> "G_ah2_se6_se5c" | G_ah2_se6_se6c -> "G_ah2_se6_se6c"
      | G_ah2_su1_su1c -> "G_ah2_su1_su1c" | G_ah2_su1_su2c -> "G_ah2_su1_su2c"
      | G_ah2_su1_su3c -> "G_ah2_su1_su3c" | G_ah2_su1_su4c -> "G_ah2_su1_su4c"
      | G_ah2_su1_su5c -> "G_ah2_su1_su5c" | G_ah2_su1_su6c -> "G_ah2_su1_su6c"
      | G_ah2_su2_su1c -> "G_ah2_su2_su1c" | G_ah2_su2_su2c -> "G_ah2_su2_su2c"
      | G_ah2_su2_su3c -> "G_ah2_su2_su3c" | G_ah2_su2_su4c -> "G_ah2_su2_su4c"
      | G_ah2_su2_su5c -> "G_ah2_su2_su5c" | G_ah2_su2_su6c -> "G_ah2_su2_su6c"
      | G_ah2_su3_su1c -> "G_ah2_su3_su1c" | G_ah2_su3_su2c -> "G_ah2_su3_su2c"
      | G_ah2_su3_su3c -> "G_ah2_su3_su3c" | G_ah2_su3_su4c -> "G_ah2_su3_su4c"
      | G_ah2_su3_su5c -> "G_ah2_su3_su5c" | G_ah2_su3_su6c -> "G_ah2_su3_su6c"
      | G_ah2_su4_su1c -> "G_ah2_su4_su1c" | G_ah2_su4_su2c -> "G_ah2_su4_su2c"
      | G_ah2_su4_su3c -> "G_ah2_su4_su3c" | G_ah2_su4_su4c -> "G_ah2_su4_su4c"
      | G_ah2_su4_su5c -> "G_ah2_su4_su5c" | G_ah2_su4_su6c -> "G_ah2_su4_su6c"
      | G_ah2_su5_su1c -> "G_ah2_su5_su1c" | G_ah2_su5_su2c -> "G_ah2_su5_su2c"
      | G_ah2_su5_su3c -> "G_ah2_su5_su3c" | G_ah2_su5_su4c -> "G_ah2_su5_su4c"
      | G_ah2_su5_su5c -> "G_ah2_su5_su5c" | G_ah2_su5_su6c -> "G_ah2_su5_su6c"
      | G_ah2_su6_su1c -> "G_ah2_su6_su1c" | G_ah2_su6_su2c -> "G_ah2_su6_su2c"
      | G_ah2_su6_su3c -> "G_ah2_su6_su3c" | G_ah2_su6_su4c -> "G_ah2_su6_su4c"
      | G_ah2_su6_su5c -> "G_ah2_su6_su5c" | G_ah2_su6_su6c -> "G_ah2_su6_su6c"
      | G_h1_h1_h1 -> "G_h1_h1_h1" | G_h1_h1_h2 -> "G_h1_h1_h2"
      | G_h1_h2_h2 -> "G_h1_h2_h2" | G_h2_h2_h2 -> "G_h2_h2_h2"
      | G_h1_hm2_hm2c -> "G_h1_hm2_hm2c" | G_h2_hm2_hm2c -> "G_h2_hm2_hm2c"
      | G_h1_sd1_sd1c -> "G_h1_sd1_sd1c" | G_h1_sd1_sd2c -> "G_h1_sd1_sd2c"
      | G_h1_sd1_sd3c -> "G_h1_sd1_sd3c" | G_h1_sd1_sd4c -> "G_h1_sd1_sd4c"
      | G_h1_sd1_sd5c -> "G_h1_sd1_sd5c" | G_h1_sd1_sd6c -> "G_h1_sd1_sd6c"
      | G_h1_sd2_sd1c -> "G_h1_sd2_sd1c" | G_h1_sd2_sd2c -> "G_h1_sd2_sd2c"
      | G_h1_sd2_sd3c -> "G_h1_sd2_sd3c" | G_h1_sd2_sd4c -> "G_h1_sd2_sd4c"
      | G_h1_sd2_sd5c -> "G_h1_sd2_sd5c" | G_h1_sd2_sd6c -> "G_h1_sd2_sd6c"
      | G_h1_sd3_sd1c -> "G_h1_sd3_sd1c" | G_h1_sd3_sd2c -> "G_h1_sd3_sd2c"
      | G_h1_sd3_sd3c -> "G_h1_sd3_sd3c" | G_h1_sd3_sd4c -> "G_h1_sd3_sd4c"
      | G_h1_sd3_sd5c -> "G_h1_sd3_sd5c" | G_h1_sd3_sd6c -> "G_h1_sd3_sd6c"
      | G_h1_sd4_sd1c -> "G_h1_sd4_sd1c" | G_h1_sd4_sd2c -> "G_h1_sd4_sd2c"
      | G_h1_sd4_sd3c -> "G_h1_sd4_sd3c" | G_h1_sd4_sd4c -> "G_h1_sd4_sd4c"
      | G_h1_sd4_sd5c -> "G_h1_sd4_sd5c" | G_h1_sd4_sd6c -> "G_h1_sd4_sd6c"
      | G_h1_sd5_sd1c -> "G_h1_sd5_sd1c" | G_h1_sd5_sd2c -> "G_h1_sd5_sd2c"
      | G_h1_sd5_sd3c -> "G_h1_sd5_sd3c" | G_h1_sd5_sd4c -> "G_h1_sd5_sd4c"
      | G_h1_sd5_sd5c -> "G_h1_sd5_sd5c" | G_h1_sd5_sd6c -> "G_h1_sd5_sd6c"
      | G_h1_sd6_sd1c -> "G_h1_sd6_sd1c" | G_h1_sd6_sd2c -> "G_h1_sd6_sd2c"
      | G_h1_sd6_sd3c -> "G_h1_sd6_sd3c" | G_h1_sd6_sd4c -> "G_h1_sd6_sd4c"
      | G_h1_sd6_sd5c -> "G_h1_sd6_sd5c" | G_h1_sd6_sd6c -> "G_h1_sd6_sd6c"
      | G_h2_sd1_sd1c -> "G_h2_sd1_sd1c" | G_h2_sd1_sd2c -> "G_h2_sd1_sd2c"
      | G_h2_sd1_sd3c -> "G_h2_sd1_sd3c" | G_h2_sd1_sd4c -> "G_h2_sd1_sd4c"
      | G_h2_sd1_sd5c -> "G_h2_sd1_sd5c" | G_h2_sd1_sd6c -> "G_h2_sd1_sd6c"
      | G_h2_sd2_sd1c -> "G_h2_sd2_sd1c" | G_h2_sd2_sd2c -> "G_h2_sd2_sd2c"
      | G_h2_sd2_sd3c -> "G_h2_sd2_sd3c" | G_h2_sd2_sd4c -> "G_h2_sd2_sd4c"
      | G_h2_sd2_sd5c -> "G_h2_sd2_sd5c" | G_h2_sd2_sd6c -> "G_h2_sd2_sd6c"
      | G_h2_sd3_sd1c -> "G_h2_sd3_sd1c" | G_h2_sd3_sd2c -> "G_h2_sd3_sd2c"
      | G_h2_sd3_sd3c -> "G_h2_sd3_sd3c" | G_h2_sd3_sd4c -> "G_h2_sd3_sd4c"
      | G_h2_sd3_sd5c -> "G_h2_sd3_sd5c" | G_h2_sd3_sd6c -> "G_h2_sd3_sd6c"
      | G_h2_sd4_sd1c -> "G_h2_sd4_sd1c" | G_h2_sd4_sd2c -> "G_h2_sd4_sd2c"
      | G_h2_sd4_sd3c -> "G_h2_sd4_sd3c" | G_h2_sd4_sd4c -> "G_h2_sd4_sd4c"
      | G_h2_sd4_sd5c -> "G_h2_sd4_sd5c" | G_h2_sd4_sd6c -> "G_h2_sd4_sd6c"
      | G_h2_sd5_sd1c -> "G_h2_sd5_sd1c" | G_h2_sd5_sd2c -> "G_h2_sd5_sd2c"
      | G_h2_sd5_sd3c -> "G_h2_sd5_sd3c" | G_h2_sd5_sd4c -> "G_h2_sd5_sd4c"
      | G_h2_sd5_sd5c -> "G_h2_sd5_sd5c" | G_h2_sd5_sd6c -> "G_h2_sd5_sd6c"
      | G_h2_sd6_sd1c -> "G_h2_sd6_sd1c" | G_h2_sd6_sd2c -> "G_h2_sd6_sd2c"
      | G_h2_sd6_sd3c -> "G_h2_sd6_sd3c" | G_h2_sd6_sd4c -> "G_h2_sd6_sd4c"
      | G_h2_sd6_sd5c -> "G_h2_sd6_sd5c" | G_h2_sd6_sd6c -> "G_h2_sd6_sd6c"
      | G_h1_se1_se1c -> "G_h1_se1_se1c" | G_h1_se1_se2c -> "G_h1_se1_se2c"
      | G_h1_se1_se3c -> "G_h1_se1_se3c" | G_h1_se1_se4c -> "G_h1_se1_se4c"
      | G_h1_se1_se5c -> "G_h1_se1_se5c" | G_h1_se1_se6c -> "G_h1_se1_se6c"
      | G_h1_se2_se1c -> "G_h1_se2_se1c" | G_h1_se2_se2c -> "G_h1_se2_se2c"
      | G_h1_se2_se3c -> "G_h1_se2_se3c" | G_h1_se2_se4c -> "G_h1_se2_se4c"
      | G_h1_se2_se5c -> "G_h1_se2_se5c" | G_h1_se2_se6c -> "G_h1_se2_se6c"
      | G_h1_se3_se1c -> "G_h1_se3_se1c" | G_h1_se3_se2c -> "G_h1_se3_se2c"
      | G_h1_se3_se3c -> "G_h1_se3_se3c" | G_h1_se3_se4c -> "G_h1_se3_se4c"
      | G_h1_se3_se5c -> "G_h1_se3_se5c" | G_h1_se3_se6c -> "G_h1_se3_se6c"
      | G_h1_se4_se1c -> "G_h1_se4_se1c" | G_h1_se4_se2c -> "G_h1_se4_se2c"
      | G_h1_se4_se3c -> "G_h1_se4_se3c" | G_h1_se4_se4c -> "G_h1_se4_se4c"
      | G_h1_se4_se5c -> "G_h1_se4_se5c" | G_h1_se4_se6c -> "G_h1_se4_se6c"
      | G_h1_se5_se1c -> "G_h1_se5_se1c" | G_h1_se5_se2c -> "G_h1_se5_se2c"
      | G_h1_se5_se3c -> "G_h1_se5_se3c" | G_h1_se5_se4c -> "G_h1_se5_se4c"
      | G_h1_se5_se5c -> "G_h1_se5_se5c" | G_h1_se5_se6c -> "G_h1_se5_se6c"
      | G_h1_se6_se1c -> "G_h1_se6_se1c" | G_h1_se6_se2c -> "G_h1_se6_se2c"
      | G_h1_se6_se3c -> "G_h1_se6_se3c" | G_h1_se6_se4c -> "G_h1_se6_se4c"
      | G_h1_se6_se5c -> "G_h1_se6_se5c" | G_h1_se6_se6c -> "G_h1_se6_se6c"
      | G_h2_se1_se1c -> "G_h2_se1_se1c" | G_h2_se1_se2c -> "G_h2_se1_se2c"
      | G_h2_se1_se3c -> "G_h2_se1_se3c" | G_h2_se1_se4c -> "G_h2_se1_se4c"
      | G_h2_se1_se5c -> "G_h2_se1_se5c" | G_h2_se1_se6c -> "G_h2_se1_se6c"
      | G_h2_se2_se1c -> "G_h2_se2_se1c" | G_h2_se2_se2c -> "G_h2_se2_se2c"
      | G_h2_se2_se3c -> "G_h2_se2_se3c" | G_h2_se2_se4c -> "G_h2_se2_se4c"
      | G_h2_se2_se5c -> "G_h2_se2_se5c" | G_h2_se2_se6c -> "G_h2_se2_se6c"
      | G_h2_se3_se1c -> "G_h2_se3_se1c" | G_h2_se3_se2c -> "G_h2_se3_se2c"
      | G_h2_se3_se3c -> "G_h2_se3_se3c" | G_h2_se3_se4c -> "G_h2_se3_se4c"
      | G_h2_se3_se5c -> "G_h2_se3_se5c" | G_h2_se3_se6c -> "G_h2_se3_se6c"
      | G_h2_se4_se1c -> "G_h2_se4_se1c" | G_h2_se4_se2c -> "G_h2_se4_se2c"
      | G_h2_se4_se3c -> "G_h2_se4_se3c" | G_h2_se4_se4c -> "G_h2_se4_se4c"
      | G_h2_se4_se5c -> "G_h2_se4_se5c" | G_h2_se4_se6c -> "G_h2_se4_se6c"
      | G_h2_se5_se1c -> "G_h2_se5_se1c" | G_h2_se5_se2c -> "G_h2_se5_se2c"
      | G_h2_se5_se3c -> "G_h2_se5_se3c" | G_h2_se5_se4c -> "G_h2_se5_se4c"
      | G_h2_se5_se5c -> "G_h2_se5_se5c" | G_h2_se5_se6c -> "G_h2_se5_se6c"
      | G_h2_se6_se1c -> "G_h2_se6_se1c" | G_h2_se6_se2c -> "G_h2_se6_se2c"
      | G_h2_se6_se3c -> "G_h2_se6_se3c" | G_h2_se6_se4c -> "G_h2_se6_se4c"
      | G_h2_se6_se5c -> "G_h2_se6_se5c" | G_h2_se6_se6c -> "G_h2_se6_se6c"
      | G_h1_su1_su1c -> "G_h1_su1_su1c" | G_h1_su1_su2c -> "G_h1_su1_su2c"
      | G_h1_su1_su3c -> "G_h1_su1_su3c" | G_h1_su1_su4c -> "G_h1_su1_su4c"
      | G_h1_su1_su5c -> "G_h1_su1_su5c" | G_h1_su1_su6c -> "G_h1_su1_su6c"
      | G_h1_su2_su1c -> "G_h1_su2_su1c" | G_h1_su2_su2c -> "G_h1_su2_su2c"
      | G_h1_su2_su3c -> "G_h1_su2_su3c" | G_h1_su2_su4c -> "G_h1_su2_su4c"
      | G_h1_su2_su5c -> "G_h1_su2_su5c" | G_h1_su2_su6c -> "G_h1_su2_su6c"
      | G_h1_su3_su1c -> "G_h1_su3_su1c" | G_h1_su3_su2c -> "G_h1_su3_su2c"
      | G_h1_su3_su3c -> "G_h1_su3_su3c" | G_h1_su3_su4c -> "G_h1_su3_su4c"
      | G_h1_su3_su5c -> "G_h1_su3_su5c" | G_h1_su3_su6c -> "G_h1_su3_su6c"
      | G_h1_su4_su1c -> "G_h1_su4_su1c" | G_h1_su4_su2c -> "G_h1_su4_su2c"
      | G_h1_su4_su3c -> "G_h1_su4_su3c" | G_h1_su4_su4c -> "G_h1_su4_su4c"
      | G_h1_su4_su5c -> "G_h1_su4_su5c" | G_h1_su4_su6c -> "G_h1_su4_su6c"
      | G_h1_su5_su1c -> "G_h1_su5_su1c" | G_h1_su5_su2c -> "G_h1_su5_su2c"
      | G_h1_su5_su3c -> "G_h1_su5_su3c" | G_h1_su5_su4c -> "G_h1_su5_su4c"
      | G_h1_su5_su5c -> "G_h1_su5_su5c" | G_h1_su5_su6c -> "G_h1_su5_su6c"
      | G_h1_su6_su1c -> "G_h1_su6_su1c" | G_h1_su6_su2c -> "G_h1_su6_su2c"
      | G_h1_su6_su3c -> "G_h1_su6_su3c" | G_h1_su6_su4c -> "G_h1_su6_su4c"
      | G_h1_su6_su5c -> "G_h1_su6_su5c" | G_h1_su6_su6c -> "G_h1_su6_su6c"
      | G_h2_su1_su1c -> "G_h2_su1_su1c" | G_h2_su1_su2c -> "G_h2_su1_su2c"
      | G_h2_su1_su3c -> "G_h2_su1_su3c" | G_h2_su1_su4c -> "G_h2_su1_su4c"
      | G_h2_su1_su5c -> "G_h2_su1_su5c" | G_h2_su1_su6c -> "G_h2_su1_su6c"
      | G_h2_su2_su1c -> "G_h2_su2_su1c" | G_h2_su2_su2c -> "G_h2_su2_su2c"
      | G_h2_su2_su3c -> "G_h2_su2_su3c" | G_h2_su2_su4c -> "G_h2_su2_su4c"
      | G_h2_su2_su5c -> "G_h2_su2_su5c" | G_h2_su2_su6c -> "G_h2_su2_su6c"
      | G_h2_su3_su1c -> "G_h2_su3_su1c" | G_h2_su3_su2c -> "G_h2_su3_su2c"
      | G_h2_su3_su3c -> "G_h2_su3_su3c" | G_h2_su3_su4c -> "G_h2_su3_su4c"
      | G_h2_su3_su5c -> "G_h2_su3_su5c" | G_h2_su3_su6c -> "G_h2_su3_su6c"
      | G_h2_su4_su1c -> "G_h2_su4_su1c" | G_h2_su4_su2c -> "G_h2_su4_su2c"
      | G_h2_su4_su3c -> "G_h2_su4_su3c" | G_h2_su4_su4c -> "G_h2_su4_su4c"
      | G_h2_su4_su5c -> "G_h2_su4_su5c" | G_h2_su4_su6c -> "G_h2_su4_su6c"
      | G_h2_su5_su1c -> "G_h2_su5_su1c" | G_h2_su5_su2c -> "G_h2_su5_su2c"
      | G_h2_su5_su3c -> "G_h2_su5_su3c" | G_h2_su5_su4c -> "G_h2_su5_su4c"
      | G_h2_su5_su5c -> "G_h2_su5_su5c" | G_h2_su5_su6c -> "G_h2_su5_su6c"
      | G_h2_su6_su1c -> "G_h2_su6_su1c" | G_h2_su6_su2c -> "G_h2_su6_su2c"
      | G_h2_su6_su3c -> "G_h2_su6_su3c" | G_h2_su6_su4c -> "G_h2_su6_su4c"
      | G_h2_su6_su5c -> "G_h2_su6_su5c" | G_h2_su6_su6c -> "G_h2_su6_su6c"
      | G_h1_sv1_sv1c -> "G_h1_sv1_sv1c" | G_h2_sv1_sv1c -> "G_h2_sv1_sv1c"
      | G_hm2_su1_sd1c -> "G_hm2_su1_sd1c" | G_hm2_su1_sd2c -> "G_hm2_su1_sd2c"
      | G_hm2_su1_sd3c -> "G_hm2_su1_sd3c" | G_hm2_su1_sd4c -> "G_hm2_su1_sd4c"
      | G_hm2_su1_sd5c -> "G_hm2_su1_sd5c" | G_hm2_su1_sd6c -> "G_hm2_su1_sd6c"
      | G_hm2_su2_sd1c -> "G_hm2_su2_sd1c" | G_hm2_su2_sd2c -> "G_hm2_su2_sd2c"
      | G_hm2_su2_sd3c -> "G_hm2_su2_sd3c" | G_hm2_su2_sd4c -> "G_hm2_su2_sd4c"
      | G_hm2_su2_sd5c -> "G_hm2_su2_sd5c" | G_hm2_su2_sd6c -> "G_hm2_su2_sd6c"
      | G_hm2_su3_sd1c -> "G_hm2_su3_sd1c" | G_hm2_su3_sd2c -> "G_hm2_su3_sd2c"
      | G_hm2_su3_sd3c -> "G_hm2_su3_sd3c" | G_hm2_su3_sd4c -> "G_hm2_su3_sd4c"
      | G_hm2_su3_sd5c -> "G_hm2_su3_sd5c" | G_hm2_su3_sd6c -> "G_hm2_su3_sd6c"
      | G_hm2_su4_sd1c -> "G_hm2_su4_sd1c" | G_hm2_su4_sd2c -> "G_hm2_su4_sd2c"
      | G_hm2_su4_sd3c -> "G_hm2_su4_sd3c" | G_hm2_su4_sd4c -> "G_hm2_su4_sd4c"
      | G_hm2_su4_sd5c -> "G_hm2_su4_sd5c" | G_hm2_su4_sd6c -> "G_hm2_su4_sd6c"
      | G_hm2_su5_sd1c -> "G_hm2_su5_sd1c" | G_hm2_su5_sd2c -> "G_hm2_su5_sd2c"
      | G_hm2_su5_sd3c -> "G_hm2_su5_sd3c" | G_hm2_su5_sd4c -> "G_hm2_su5_sd4c"
      | G_hm2_su5_sd5c -> "G_hm2_su5_sd5c" | G_hm2_su5_sd6c -> "G_hm2_su5_sd6c"
      | G_hm2_su6_sd1c -> "G_hm2_su6_sd1c" | G_hm2_su6_sd2c -> "G_hm2_su6_sd2c"
      | G_hm2_su6_sd3c -> "G_hm2_su6_sd3c" | G_hm2_su6_sd4c -> "G_hm2_su6_sd4c"
      | G_hm2_su6_sd5c -> "G_hm2_su6_sd5c" | G_hm2_su6_sd6c -> "G_hm2_su6_sd6c"
      | G_hm2_sv1_se1c -> "G_hm2_sv1_se1c" | G_hm2_sv1_se2c -> "G_hm2_sv1_se2c"
      | G_hm2_sv1_se3c -> "G_hm2_sv1_se3c" | G_hm2_sv1_se4c -> "G_hm2_sv1_se4c"
      | G_hm2_sv1_se5c -> "G_hm2_sv1_se5c" | G_hm2_sv1_se6c -> "G_hm2_sv1_se6c"
      | G_hm2_sv2_se1c -> "G_hm2_sv2_se1c" | G_hm2_sv2_se2c -> "G_hm2_sv2_se2c"
      | G_hm2_sv2_se3c -> "G_hm2_sv2_se3c" | G_hm2_sv2_se4c -> "G_hm2_sv2_se4c"
      | G_hm2_sv2_se5c -> "G_hm2_sv2_se5c" | G_hm2_sv2_se6c -> "G_hm2_sv2_se6c"
      | G_hm2_sv3_se1c -> "G_hm2_sv3_se1c" | G_hm2_sv3_se2c -> "G_hm2_sv3_se2c"
      | G_hm2_sv3_se3c -> "G_hm2_sv3_se3c" | G_hm2_sv3_se4c -> "G_hm2_sv3_se4c"
      | G_hm2_sv3_se5c -> "G_hm2_sv3_se5c" | G_hm2_sv3_se6c -> "G_hm2_sv3_se6c"
      | G_sd1_hm2c_su1c -> "G_sd1_hm2c_su1c" | G_sd1_hm2c_su2c -> "G_sd1_hm2c_su2c"
      | G_sd1_hm2c_su3c -> "G_sd1_hm2c_su3c" | G_sd1_hm2c_su4c -> "G_sd1_hm2c_su4c"
      | G_sd1_hm2c_su5c -> "G_sd1_hm2c_su5c" | G_sd1_hm2c_su6c -> "G_sd1_hm2c_su6c"
      | G_sd2_hm2c_su1c -> "G_sd2_hm2c_su1c" | G_sd2_hm2c_su2c -> "G_sd2_hm2c_su2c"
      | G_sd2_hm2c_su3c -> "G_sd2_hm2c_su3c" | G_sd2_hm2c_su4c -> "G_sd2_hm2c_su4c"
      | G_sd2_hm2c_su5c -> "G_sd2_hm2c_su5c" | G_sd2_hm2c_su6c -> "G_sd2_hm2c_su6c"
      | G_sd3_hm2c_su1c -> "G_sd3_hm2c_su1c" | G_sd3_hm2c_su2c -> "G_sd3_hm2c_su2c"
      | G_sd3_hm2c_su3c -> "G_sd3_hm2c_su3c" | G_sd3_hm2c_su4c -> "G_sd3_hm2c_su4c"
      | G_sd3_hm2c_su5c -> "G_sd3_hm2c_su5c" | G_sd3_hm2c_su6c -> "G_sd3_hm2c_su6c"
      | G_sd4_hm2c_su1c -> "G_sd4_hm2c_su1c" | G_sd4_hm2c_su2c -> "G_sd4_hm2c_su2c"
      | G_sd4_hm2c_su3c -> "G_sd4_hm2c_su3c" | G_sd4_hm2c_su4c -> "G_sd4_hm2c_su4c"
      | G_sd4_hm2c_su5c -> "G_sd4_hm2c_su5c" | G_sd4_hm2c_su6c -> "G_sd4_hm2c_su6c"
      | G_sd5_hm2c_su1c -> "G_sd5_hm2c_su1c" | G_sd5_hm2c_su2c -> "G_sd5_hm2c_su2c"
      | G_sd5_hm2c_su3c -> "G_sd5_hm2c_su3c" | G_sd5_hm2c_su4c -> "G_sd5_hm2c_su4c"
      | G_sd5_hm2c_su5c -> "G_sd5_hm2c_su5c" | G_sd5_hm2c_su6c -> "G_sd5_hm2c_su6c"
      | G_sd6_hm2c_su1c -> "G_sd6_hm2c_su1c" | G_sd6_hm2c_su2c -> "G_sd6_hm2c_su2c"
      | G_sd6_hm2c_su3c -> "G_sd6_hm2c_su3c" | G_sd6_hm2c_su4c -> "G_sd6_hm2c_su4c"
      | G_sd6_hm2c_su5c -> "G_sd6_hm2c_su5c" | G_sd6_hm2c_su6c -> "G_sd6_hm2c_su6c"
      | G_se1_hm2c_sv1c -> "G_se1_hm2c_sv1c" | G_se1_hm2c_sv2c -> "G_se1_hm2c_sv2c"
      | G_se1_hm2c_sv3c -> "G_se1_hm2c_sv3c" | G_se2_hm2c_sv1c -> "G_se2_hm2c_sv1c"
      | G_se2_hm2c_sv2c -> "G_se2_hm2c_sv2c" | G_se2_hm2c_sv3c -> "G_se2_hm2c_sv3c"
      | G_se3_hm2c_sv1c -> "G_se3_hm2c_sv1c" | G_se3_hm2c_sv2c -> "G_se3_hm2c_sv2c"
      | G_se3_hm2c_sv3c -> "G_se3_hm2c_sv3c" | G_se4_hm2c_sv1c -> "G_se4_hm2c_sv1c"
      | G_se4_hm2c_sv2c -> "G_se4_hm2c_sv2c" | G_se4_hm2c_sv3c -> "G_se4_hm2c_sv3c"
      | G_se5_hm2c_sv1c -> "G_se5_hm2c_sv1c" | G_se5_hm2c_sv2c -> "G_se5_hm2c_sv2c"
      | G_se5_hm2c_sv3c -> "G_se5_hm2c_sv3c" | G_se6_hm2c_sv1c -> "G_se6_hm2c_sv1c"
      | G_se6_hm2c_sv2c -> "G_se6_hm2c_sv2c" | G_se6_hm2c_sv3c -> "G_se6_hm2c_sv3c"
      | G_ah2_ah2_wmc_wm_1 -> "G_ah2_ah2_wmc_wm_1"
      | G_ah2_ah2_z_1_z_1 -> "G_ah2_ah2_z_1_z_1"
      | G_ah2_hm2_wmc_a_1 -> "G_ah2_hm2_wmc_a_1"
      | G_ah2_hm2_wmc_z_1 -> "G_ah2_hm2_wmc_z_1"
      | G_ah2_hm2c_a_1_wm_1 -> "G_ah2_hm2c_a_1_wm_1"
      | G_ah2_hm2c_wm_1_z_1 -> "G_ah2_hm2c_wm_1_z_1"
      | G_h1_h1_wmc_wm_1 -> "G_h1_h1_wmc_wm_1"
      | G_h1_h2_wmc_wm_1 -> "G_h1_h2_wmc_wm_1"
      | G_h2_h2_wmc_wm_1 -> "G_h2_h2_wmc_wm_1" | G_h1_h1_z_1_z_1 -> "G_h1_h1_z_1_z_1"
      | G_h1_h2_z_1_z_1 -> "G_h1_h2_z_1_z_1" | G_h2_h2_z_1_z_1 -> "G_h2_h2_z_1_z_1"
      | G_h1_hm2_wmc_a_1 -> "G_h1_hm2_wmc_a_1"
      | G_h2_hm2_wmc_a_1 -> "G_h2_hm2_wmc_a_1"
      | G_h1_hm2_wmc_z_1 -> "G_h1_hm2_wmc_z_1"
      | G_h2_hm2_wmc_z_1 -> "G_h2_hm2_wmc_z_1"
      | G_hm2_hm2c_a_1_a_1 -> "G_hm2_hm2c_a_1_a_1"
      | G_hm2_hm2c_a_1_z_1 -> "G_hm2_hm2c_a_1_z_1"
      | G_hm2_hm2c_wmc_wm_1 -> "G_hm2_hm2c_wmc_wm_1"
      | G_hm2_hm2c_z_1_z_1 -> "G_hm2_hm2c_z_1_z_1"
      | G_sd1_sd1c_g_1_g_1 -> "G_sd1_sd1c_g_1_g_1"
      | G_sd1_sd1c_g_1_a_1 -> "G_sd1_sd1c_g_1_a_1"
      | G_sd1_sd2c_g_1_a_1 -> "G_sd1_sd2c_g_1_a_1"
      | G_sd1_sd3c_g_1_a_1 -> "G_sd1_sd3c_g_1_a_1"
      | G_sd1_sd4c_g_1_a_1 -> "G_sd1_sd4c_g_1_a_1"
      | G_sd1_sd5c_g_1_a_1 -> "G_sd1_sd5c_g_1_a_1"
      | G_sd1_sd6c_g_1_a_1 -> "G_sd1_sd6c_g_1_a_1"
      | G_sd2_sd1c_g_1_a_1 -> "G_sd2_sd1c_g_1_a_1"
      | G_sd2_sd2c_g_1_a_1 -> "G_sd2_sd2c_g_1_a_1"
      | G_sd2_sd3c_g_1_a_1 -> "G_sd2_sd3c_g_1_a_1"
      | G_sd2_sd4c_g_1_a_1 -> "G_sd2_sd4c_g_1_a_1"
      | G_sd2_sd5c_g_1_a_1 -> "G_sd2_sd5c_g_1_a_1"
      | G_sd2_sd6c_g_1_a_1 -> "G_sd2_sd6c_g_1_a_1"
      | G_sd3_sd1c_g_1_a_1 -> "G_sd3_sd1c_g_1_a_1"
      | G_sd3_sd2c_g_1_a_1 -> "G_sd3_sd2c_g_1_a_1"
      | G_sd3_sd3c_g_1_a_1 -> "G_sd3_sd3c_g_1_a_1"
      | G_sd3_sd4c_g_1_a_1 -> "G_sd3_sd4c_g_1_a_1"
      | G_sd3_sd5c_g_1_a_1 -> "G_sd3_sd5c_g_1_a_1"
      | G_sd3_sd6c_g_1_a_1 -> "G_sd3_sd6c_g_1_a_1"
      | G_sd4_sd1c_g_1_a_1 -> "G_sd4_sd1c_g_1_a_1"
      | G_sd4_sd2c_g_1_a_1 -> "G_sd4_sd2c_g_1_a_1"
      | G_sd4_sd3c_g_1_a_1 -> "G_sd4_sd3c_g_1_a_1"
      | G_sd4_sd4c_g_1_a_1 -> "G_sd4_sd4c_g_1_a_1"
      | G_sd4_sd5c_g_1_a_1 -> "G_sd4_sd5c_g_1_a_1"
      | G_sd4_sd6c_g_1_a_1 -> "G_sd4_sd6c_g_1_a_1"
      | G_sd5_sd1c_g_1_a_1 -> "G_sd5_sd1c_g_1_a_1"
      | G_sd5_sd2c_g_1_a_1 -> "G_sd5_sd2c_g_1_a_1"
      | G_sd5_sd3c_g_1_a_1 -> "G_sd5_sd3c_g_1_a_1"
      | G_sd5_sd4c_g_1_a_1 -> "G_sd5_sd4c_g_1_a_1"
      | G_sd5_sd5c_g_1_a_1 -> "G_sd5_sd5c_g_1_a_1"
      | G_sd5_sd6c_g_1_a_1 -> "G_sd5_sd6c_g_1_a_1"
      | G_sd6_sd1c_g_1_a_1 -> "G_sd6_sd1c_g_1_a_1"
      | G_sd6_sd2c_g_1_a_1 -> "G_sd6_sd2c_g_1_a_1"
      | G_sd6_sd3c_g_1_a_1 -> "G_sd6_sd3c_g_1_a_1"
      | G_sd6_sd4c_g_1_a_1 -> "G_sd6_sd4c_g_1_a_1"
      | G_sd6_sd5c_g_1_a_1 -> "G_sd6_sd5c_g_1_a_1"
      | G_sd6_sd6c_g_1_a_1 -> "G_sd6_sd6c_g_1_a_1"
      | G_sd1_sd1c_g_1_z_1 -> "G_sd1_sd1c_g_1_z_1"
      | G_sd1_sd2c_g_1_z_1 -> "G_sd1_sd2c_g_1_z_1"
      | G_sd1_sd3c_g_1_z_1 -> "G_sd1_sd3c_g_1_z_1"
      | G_sd1_sd4c_g_1_z_1 -> "G_sd1_sd4c_g_1_z_1"
      | G_sd1_sd5c_g_1_z_1 -> "G_sd1_sd5c_g_1_z_1"
      | G_sd1_sd6c_g_1_z_1 -> "G_sd1_sd6c_g_1_z_1"
      | G_sd2_sd1c_g_1_z_1 -> "G_sd2_sd1c_g_1_z_1"
      | G_sd2_sd2c_g_1_z_1 -> "G_sd2_sd2c_g_1_z_1"
      | G_sd2_sd3c_g_1_z_1 -> "G_sd2_sd3c_g_1_z_1"
      | G_sd2_sd4c_g_1_z_1 -> "G_sd2_sd4c_g_1_z_1"
      | G_sd2_sd5c_g_1_z_1 -> "G_sd2_sd5c_g_1_z_1"
      | G_sd2_sd6c_g_1_z_1 -> "G_sd2_sd6c_g_1_z_1"
      | G_sd3_sd1c_g_1_z_1 -> "G_sd3_sd1c_g_1_z_1"
      | G_sd3_sd2c_g_1_z_1 -> "G_sd3_sd2c_g_1_z_1"
      | G_sd3_sd3c_g_1_z_1 -> "G_sd3_sd3c_g_1_z_1"
      | G_sd3_sd4c_g_1_z_1 -> "G_sd3_sd4c_g_1_z_1"
      | G_sd3_sd5c_g_1_z_1 -> "G_sd3_sd5c_g_1_z_1"
      | G_sd3_sd6c_g_1_z_1 -> "G_sd3_sd6c_g_1_z_1"
      | G_sd4_sd1c_g_1_z_1 -> "G_sd4_sd1c_g_1_z_1"
      | G_sd4_sd2c_g_1_z_1 -> "G_sd4_sd2c_g_1_z_1"
      | G_sd4_sd3c_g_1_z_1 -> "G_sd4_sd3c_g_1_z_1"
      | G_sd4_sd4c_g_1_z_1 -> "G_sd4_sd4c_g_1_z_1"
      | G_sd4_sd5c_g_1_z_1 -> "G_sd4_sd5c_g_1_z_1"
      | G_sd4_sd6c_g_1_z_1 -> "G_sd4_sd6c_g_1_z_1"
      | G_sd5_sd1c_g_1_z_1 -> "G_sd5_sd1c_g_1_z_1"
      | G_sd5_sd2c_g_1_z_1 -> "G_sd5_sd2c_g_1_z_1"
      | G_sd5_sd3c_g_1_z_1 -> "G_sd5_sd3c_g_1_z_1"
      | G_sd5_sd4c_g_1_z_1 -> "G_sd5_sd4c_g_1_z_1"
      | G_sd5_sd5c_g_1_z_1 -> "G_sd5_sd5c_g_1_z_1"
      | G_sd5_sd6c_g_1_z_1 -> "G_sd5_sd6c_g_1_z_1"
      | G_sd6_sd1c_g_1_z_1 -> "G_sd6_sd1c_g_1_z_1"
      | G_sd6_sd2c_g_1_z_1 -> "G_sd6_sd2c_g_1_z_1"
      | G_sd6_sd3c_g_1_z_1 -> "G_sd6_sd3c_g_1_z_1"
      | G_sd6_sd4c_g_1_z_1 -> "G_sd6_sd4c_g_1_z_1"
      | G_sd6_sd5c_g_1_z_1 -> "G_sd6_sd5c_g_1_z_1"
      | G_sd6_sd6c_g_1_z_1 -> "G_sd6_sd6c_g_1_z_1"
      | G_sd1_su1c_wmc_g_1 -> "G_sd1_su1c_wmc_g_1"
      | G_sd1_su2c_wmc_g_1 -> "G_sd1_su2c_wmc_g_1"
      | G_sd1_su3c_wmc_g_1 -> "G_sd1_su3c_wmc_g_1"
      | G_sd1_su4c_wmc_g_1 -> "G_sd1_su4c_wmc_g_1"
      | G_sd1_su5c_wmc_g_1 -> "G_sd1_su5c_wmc_g_1"
      | G_sd1_su6c_wmc_g_1 -> "G_sd1_su6c_wmc_g_1"
      | G_sd2_su1c_wmc_g_1 -> "G_sd2_su1c_wmc_g_1"
      | G_sd2_su2c_wmc_g_1 -> "G_sd2_su2c_wmc_g_1"
      | G_sd2_su3c_wmc_g_1 -> "G_sd2_su3c_wmc_g_1"
      | G_sd2_su4c_wmc_g_1 -> "G_sd2_su4c_wmc_g_1"
      | G_sd2_su5c_wmc_g_1 -> "G_sd2_su5c_wmc_g_1"
      | G_sd2_su6c_wmc_g_1 -> "G_sd2_su6c_wmc_g_1"
      | G_sd3_su1c_wmc_g_1 -> "G_sd3_su1c_wmc_g_1"
      | G_sd3_su2c_wmc_g_1 -> "G_sd3_su2c_wmc_g_1"
      | G_sd3_su3c_wmc_g_1 -> "G_sd3_su3c_wmc_g_1"
      | G_sd3_su4c_wmc_g_1 -> "G_sd3_su4c_wmc_g_1"
      | G_sd3_su5c_wmc_g_1 -> "G_sd3_su5c_wmc_g_1"
      | G_sd3_su6c_wmc_g_1 -> "G_sd3_su6c_wmc_g_1"
      | G_sd4_su1c_wmc_g_1 -> "G_sd4_su1c_wmc_g_1"
      | G_sd4_su2c_wmc_g_1 -> "G_sd4_su2c_wmc_g_1"
      | G_sd4_su3c_wmc_g_1 -> "G_sd4_su3c_wmc_g_1"
      | G_sd4_su4c_wmc_g_1 -> "G_sd4_su4c_wmc_g_1"
      | G_sd4_su5c_wmc_g_1 -> "G_sd4_su5c_wmc_g_1"
      | G_sd4_su6c_wmc_g_1 -> "G_sd4_su6c_wmc_g_1"
      | G_sd5_su1c_wmc_g_1 -> "G_sd5_su1c_wmc_g_1"
      | G_sd5_su2c_wmc_g_1 -> "G_sd5_su2c_wmc_g_1"
      | G_sd5_su3c_wmc_g_1 -> "G_sd5_su3c_wmc_g_1"
      | G_sd5_su4c_wmc_g_1 -> "G_sd5_su4c_wmc_g_1"
      | G_sd5_su5c_wmc_g_1 -> "G_sd5_su5c_wmc_g_1"
      | G_sd5_su6c_wmc_g_1 -> "G_sd5_su6c_wmc_g_1"
      | G_sd6_su1c_wmc_g_1 -> "G_sd6_su1c_wmc_g_1"
      | G_sd6_su2c_wmc_g_1 -> "G_sd6_su2c_wmc_g_1"
      | G_sd6_su3c_wmc_g_1 -> "G_sd6_su3c_wmc_g_1"
      | G_sd6_su4c_wmc_g_1 -> "G_sd6_su4c_wmc_g_1"
      | G_sd6_su5c_wmc_g_1 -> "G_sd6_su5c_wmc_g_1"
      | G_sd6_su6c_wmc_g_1 -> "G_sd6_su6c_wmc_g_1"
      | G_sd1_sd1c_a_1_a_1 -> "G_sd1_sd1c_a_1_a_1"
      | G_sd1_sd2c_a_1_a_1 -> "G_sd1_sd2c_a_1_a_1"
      | G_sd1_sd3c_a_1_a_1 -> "G_sd1_sd3c_a_1_a_1"
      | G_sd1_sd4c_a_1_a_1 -> "G_sd1_sd4c_a_1_a_1"
      | G_sd1_sd5c_a_1_a_1 -> "G_sd1_sd5c_a_1_a_1"
      | G_sd1_sd6c_a_1_a_1 -> "G_sd1_sd6c_a_1_a_1"
      | G_sd2_sd1c_a_1_a_1 -> "G_sd2_sd1c_a_1_a_1"
      | G_sd2_sd2c_a_1_a_1 -> "G_sd2_sd2c_a_1_a_1"
      | G_sd2_sd3c_a_1_a_1 -> "G_sd2_sd3c_a_1_a_1"
      | G_sd2_sd4c_a_1_a_1 -> "G_sd2_sd4c_a_1_a_1"
      | G_sd2_sd5c_a_1_a_1 -> "G_sd2_sd5c_a_1_a_1"
      | G_sd2_sd6c_a_1_a_1 -> "G_sd2_sd6c_a_1_a_1"
      | G_sd3_sd1c_a_1_a_1 -> "G_sd3_sd1c_a_1_a_1"
      | G_sd3_sd2c_a_1_a_1 -> "G_sd3_sd2c_a_1_a_1"
      | G_sd3_sd3c_a_1_a_1 -> "G_sd3_sd3c_a_1_a_1"
      | G_sd3_sd4c_a_1_a_1 -> "G_sd3_sd4c_a_1_a_1"
      | G_sd3_sd5c_a_1_a_1 -> "G_sd3_sd5c_a_1_a_1"
      | G_sd3_sd6c_a_1_a_1 -> "G_sd3_sd6c_a_1_a_1"
      | G_sd4_sd1c_a_1_a_1 -> "G_sd4_sd1c_a_1_a_1"
      | G_sd4_sd2c_a_1_a_1 -> "G_sd4_sd2c_a_1_a_1"
      | G_sd4_sd3c_a_1_a_1 -> "G_sd4_sd3c_a_1_a_1"
      | G_sd4_sd4c_a_1_a_1 -> "G_sd4_sd4c_a_1_a_1"
      | G_sd4_sd5c_a_1_a_1 -> "G_sd4_sd5c_a_1_a_1"
      | G_sd4_sd6c_a_1_a_1 -> "G_sd4_sd6c_a_1_a_1"
      | G_sd5_sd1c_a_1_a_1 -> "G_sd5_sd1c_a_1_a_1"
      | G_sd5_sd2c_a_1_a_1 -> "G_sd5_sd2c_a_1_a_1"
      | G_sd5_sd3c_a_1_a_1 -> "G_sd5_sd3c_a_1_a_1"
      | G_sd5_sd4c_a_1_a_1 -> "G_sd5_sd4c_a_1_a_1"
      | G_sd5_sd5c_a_1_a_1 -> "G_sd5_sd5c_a_1_a_1"
      | G_sd5_sd6c_a_1_a_1 -> "G_sd5_sd6c_a_1_a_1"
      | G_sd6_sd1c_a_1_a_1 -> "G_sd6_sd1c_a_1_a_1"
      | G_sd6_sd2c_a_1_a_1 -> "G_sd6_sd2c_a_1_a_1"
      | G_sd6_sd3c_a_1_a_1 -> "G_sd6_sd3c_a_1_a_1"
      | G_sd6_sd4c_a_1_a_1 -> "G_sd6_sd4c_a_1_a_1"
      | G_sd6_sd5c_a_1_a_1 -> "G_sd6_sd5c_a_1_a_1"
      | G_sd6_sd6c_a_1_a_1 -> "G_sd6_sd6c_a_1_a_1"
      | G_sd1_sd1c_a_1_z_1 -> "G_sd1_sd1c_a_1_z_1"
      | G_sd1_sd2c_a_1_z_1 -> "G_sd1_sd2c_a_1_z_1"
      | G_sd1_sd3c_a_1_z_1 -> "G_sd1_sd3c_a_1_z_1"
      | G_sd1_sd4c_a_1_z_1 -> "G_sd1_sd4c_a_1_z_1"
      | G_sd1_sd5c_a_1_z_1 -> "G_sd1_sd5c_a_1_z_1"
      | G_sd1_sd6c_a_1_z_1 -> "G_sd1_sd6c_a_1_z_1"
      | G_sd2_sd1c_a_1_z_1 -> "G_sd2_sd1c_a_1_z_1"
      | G_sd2_sd2c_a_1_z_1 -> "G_sd2_sd2c_a_1_z_1"
      | G_sd2_sd3c_a_1_z_1 -> "G_sd2_sd3c_a_1_z_1"
      | G_sd2_sd4c_a_1_z_1 -> "G_sd2_sd4c_a_1_z_1"
      | G_sd2_sd5c_a_1_z_1 -> "G_sd2_sd5c_a_1_z_1"
      | G_sd2_sd6c_a_1_z_1 -> "G_sd2_sd6c_a_1_z_1"
      | G_sd3_sd1c_a_1_z_1 -> "G_sd3_sd1c_a_1_z_1"
      | G_sd3_sd2c_a_1_z_1 -> "G_sd3_sd2c_a_1_z_1"
      | G_sd3_sd3c_a_1_z_1 -> "G_sd3_sd3c_a_1_z_1"
      | G_sd3_sd4c_a_1_z_1 -> "G_sd3_sd4c_a_1_z_1"
      | G_sd3_sd5c_a_1_z_1 -> "G_sd3_sd5c_a_1_z_1"
      | G_sd3_sd6c_a_1_z_1 -> "G_sd3_sd6c_a_1_z_1"
      | G_sd4_sd1c_a_1_z_1 -> "G_sd4_sd1c_a_1_z_1"
      | G_sd4_sd2c_a_1_z_1 -> "G_sd4_sd2c_a_1_z_1"
      | G_sd4_sd3c_a_1_z_1 -> "G_sd4_sd3c_a_1_z_1"
      | G_sd4_sd4c_a_1_z_1 -> "G_sd4_sd4c_a_1_z_1"
      | G_sd4_sd5c_a_1_z_1 -> "G_sd4_sd5c_a_1_z_1"
      | G_sd4_sd6c_a_1_z_1 -> "G_sd4_sd6c_a_1_z_1"
      | G_sd5_sd1c_a_1_z_1 -> "G_sd5_sd1c_a_1_z_1"
      | G_sd5_sd2c_a_1_z_1 -> "G_sd5_sd2c_a_1_z_1"
      | G_sd5_sd3c_a_1_z_1 -> "G_sd5_sd3c_a_1_z_1"
      | G_sd5_sd4c_a_1_z_1 -> "G_sd5_sd4c_a_1_z_1"
      | G_sd5_sd5c_a_1_z_1 -> "G_sd5_sd5c_a_1_z_1"
      | G_sd5_sd6c_a_1_z_1 -> "G_sd5_sd6c_a_1_z_1"
      | G_sd6_sd1c_a_1_z_1 -> "G_sd6_sd1c_a_1_z_1"
      | G_sd6_sd2c_a_1_z_1 -> "G_sd6_sd2c_a_1_z_1"
      | G_sd6_sd3c_a_1_z_1 -> "G_sd6_sd3c_a_1_z_1"
      | G_sd6_sd4c_a_1_z_1 -> "G_sd6_sd4c_a_1_z_1"
      | G_sd6_sd5c_a_1_z_1 -> "G_sd6_sd5c_a_1_z_1"
      | G_sd6_sd6c_a_1_z_1 -> "G_sd6_sd6c_a_1_z_1"
      | G_sd1_su1c_wmc_a_1 -> "G_sd1_su1c_wmc_a_1"
      | G_sd1_su2c_wmc_a_1 -> "G_sd1_su2c_wmc_a_1"
      | G_sd1_su3c_wmc_a_1 -> "G_sd1_su3c_wmc_a_1"
      | G_sd1_su4c_wmc_a_1 -> "G_sd1_su4c_wmc_a_1"
      | G_sd1_su5c_wmc_a_1 -> "G_sd1_su5c_wmc_a_1"
      | G_sd1_su6c_wmc_a_1 -> "G_sd1_su6c_wmc_a_1"
      | G_sd2_su1c_wmc_a_1 -> "G_sd2_su1c_wmc_a_1"
      | G_sd2_su2c_wmc_a_1 -> "G_sd2_su2c_wmc_a_1"
      | G_sd2_su3c_wmc_a_1 -> "G_sd2_su3c_wmc_a_1"
      | G_sd2_su4c_wmc_a_1 -> "G_sd2_su4c_wmc_a_1"
      | G_sd2_su5c_wmc_a_1 -> "G_sd2_su5c_wmc_a_1"
      | G_sd2_su6c_wmc_a_1 -> "G_sd2_su6c_wmc_a_1"
      | G_sd3_su1c_wmc_a_1 -> "G_sd3_su1c_wmc_a_1"
      | G_sd3_su2c_wmc_a_1 -> "G_sd3_su2c_wmc_a_1"
      | G_sd3_su3c_wmc_a_1 -> "G_sd3_su3c_wmc_a_1"
      | G_sd3_su4c_wmc_a_1 -> "G_sd3_su4c_wmc_a_1"
      | G_sd3_su5c_wmc_a_1 -> "G_sd3_su5c_wmc_a_1"
      | G_sd3_su6c_wmc_a_1 -> "G_sd3_su6c_wmc_a_1"
      | G_sd4_su1c_wmc_a_1 -> "G_sd4_su1c_wmc_a_1"
      | G_sd4_su2c_wmc_a_1 -> "G_sd4_su2c_wmc_a_1"
      | G_sd4_su3c_wmc_a_1 -> "G_sd4_su3c_wmc_a_1"
      | G_sd4_su4c_wmc_a_1 -> "G_sd4_su4c_wmc_a_1"
      | G_sd4_su5c_wmc_a_1 -> "G_sd4_su5c_wmc_a_1"
      | G_sd4_su6c_wmc_a_1 -> "G_sd4_su6c_wmc_a_1"
      | G_sd5_su1c_wmc_a_1 -> "G_sd5_su1c_wmc_a_1"
      | G_sd5_su2c_wmc_a_1 -> "G_sd5_su2c_wmc_a_1"
      | G_sd5_su3c_wmc_a_1 -> "G_sd5_su3c_wmc_a_1"
      | G_sd5_su4c_wmc_a_1 -> "G_sd5_su4c_wmc_a_1"
      | G_sd5_su5c_wmc_a_1 -> "G_sd5_su5c_wmc_a_1"
      | G_sd5_su6c_wmc_a_1 -> "G_sd5_su6c_wmc_a_1"
      | G_sd6_su1c_wmc_a_1 -> "G_sd6_su1c_wmc_a_1"
      | G_sd6_su2c_wmc_a_1 -> "G_sd6_su2c_wmc_a_1"
      | G_sd6_su3c_wmc_a_1 -> "G_sd6_su3c_wmc_a_1"
      | G_sd6_su4c_wmc_a_1 -> "G_sd6_su4c_wmc_a_1"
      | G_sd6_su5c_wmc_a_1 -> "G_sd6_su5c_wmc_a_1"
      | G_sd6_su6c_wmc_a_1 -> "G_sd6_su6c_wmc_a_1"
      | G_sd1_sd1c_wmc_wm_1 -> "G_sd1_sd1c_wmc_wm_1"
      | G_sd1_sd2c_wmc_wm_1 -> "G_sd1_sd2c_wmc_wm_1"
      | G_sd1_sd3c_wmc_wm_1 -> "G_sd1_sd3c_wmc_wm_1"
      | G_sd1_sd4c_wmc_wm_1 -> "G_sd1_sd4c_wmc_wm_1"
      | G_sd1_sd5c_wmc_wm_1 -> "G_sd1_sd5c_wmc_wm_1"
      | G_sd1_sd6c_wmc_wm_1 -> "G_sd1_sd6c_wmc_wm_1"
      | G_sd2_sd1c_wmc_wm_1 -> "G_sd2_sd1c_wmc_wm_1"
      | G_sd2_sd2c_wmc_wm_1 -> "G_sd2_sd2c_wmc_wm_1"
      | G_sd2_sd3c_wmc_wm_1 -> "G_sd2_sd3c_wmc_wm_1"
      | G_sd2_sd4c_wmc_wm_1 -> "G_sd2_sd4c_wmc_wm_1"
      | G_sd2_sd5c_wmc_wm_1 -> "G_sd2_sd5c_wmc_wm_1"
      | G_sd2_sd6c_wmc_wm_1 -> "G_sd2_sd6c_wmc_wm_1"
      | G_sd3_sd1c_wmc_wm_1 -> "G_sd3_sd1c_wmc_wm_1"
      | G_sd3_sd2c_wmc_wm_1 -> "G_sd3_sd2c_wmc_wm_1"
      | G_sd3_sd3c_wmc_wm_1 -> "G_sd3_sd3c_wmc_wm_1"
      | G_sd3_sd4c_wmc_wm_1 -> "G_sd3_sd4c_wmc_wm_1"
      | G_sd3_sd5c_wmc_wm_1 -> "G_sd3_sd5c_wmc_wm_1"
      | G_sd3_sd6c_wmc_wm_1 -> "G_sd3_sd6c_wmc_wm_1"
      | G_sd4_sd1c_wmc_wm_1 -> "G_sd4_sd1c_wmc_wm_1"
      | G_sd4_sd2c_wmc_wm_1 -> "G_sd4_sd2c_wmc_wm_1"
      | G_sd4_sd3c_wmc_wm_1 -> "G_sd4_sd3c_wmc_wm_1"
      | G_sd4_sd4c_wmc_wm_1 -> "G_sd4_sd4c_wmc_wm_1"
      | G_sd4_sd5c_wmc_wm_1 -> "G_sd4_sd5c_wmc_wm_1"
      | G_sd4_sd6c_wmc_wm_1 -> "G_sd4_sd6c_wmc_wm_1"
      | G_sd5_sd1c_wmc_wm_1 -> "G_sd5_sd1c_wmc_wm_1"
      | G_sd5_sd2c_wmc_wm_1 -> "G_sd5_sd2c_wmc_wm_1"
      | G_sd5_sd3c_wmc_wm_1 -> "G_sd5_sd3c_wmc_wm_1"
      | G_sd5_sd4c_wmc_wm_1 -> "G_sd5_sd4c_wmc_wm_1"
      | G_sd5_sd5c_wmc_wm_1 -> "G_sd5_sd5c_wmc_wm_1"
      | G_sd5_sd6c_wmc_wm_1 -> "G_sd5_sd6c_wmc_wm_1"
      | G_sd6_sd1c_wmc_wm_1 -> "G_sd6_sd1c_wmc_wm_1"
      | G_sd6_sd2c_wmc_wm_1 -> "G_sd6_sd2c_wmc_wm_1"
      | G_sd6_sd3c_wmc_wm_1 -> "G_sd6_sd3c_wmc_wm_1"
      | G_sd6_sd4c_wmc_wm_1 -> "G_sd6_sd4c_wmc_wm_1"
      | G_sd6_sd5c_wmc_wm_1 -> "G_sd6_sd5c_wmc_wm_1"
      | G_sd6_sd6c_wmc_wm_1 -> "G_sd6_sd6c_wmc_wm_1"
      | G_sd1_sd1c_z_1_z_1 -> "G_sd1_sd1c_z_1_z_1"
      | G_sd1_sd2c_z_1_z_1 -> "G_sd1_sd2c_z_1_z_1"
      | G_sd1_sd3c_z_1_z_1 -> "G_sd1_sd3c_z_1_z_1"
      | G_sd1_sd4c_z_1_z_1 -> "G_sd1_sd4c_z_1_z_1"
      | G_sd1_sd5c_z_1_z_1 -> "G_sd1_sd5c_z_1_z_1"
      | G_sd1_sd6c_z_1_z_1 -> "G_sd1_sd6c_z_1_z_1"
      | G_sd2_sd1c_z_1_z_1 -> "G_sd2_sd1c_z_1_z_1"
      | G_sd2_sd2c_z_1_z_1 -> "G_sd2_sd2c_z_1_z_1"
      | G_sd2_sd3c_z_1_z_1 -> "G_sd2_sd3c_z_1_z_1"
      | G_sd2_sd4c_z_1_z_1 -> "G_sd2_sd4c_z_1_z_1"
      | G_sd2_sd5c_z_1_z_1 -> "G_sd2_sd5c_z_1_z_1"
      | G_sd2_sd6c_z_1_z_1 -> "G_sd2_sd6c_z_1_z_1"
      | G_sd3_sd1c_z_1_z_1 -> "G_sd3_sd1c_z_1_z_1"
      | G_sd3_sd2c_z_1_z_1 -> "G_sd3_sd2c_z_1_z_1"
      | G_sd3_sd3c_z_1_z_1 -> "G_sd3_sd3c_z_1_z_1"
      | G_sd3_sd4c_z_1_z_1 -> "G_sd3_sd4c_z_1_z_1"
      | G_sd3_sd5c_z_1_z_1 -> "G_sd3_sd5c_z_1_z_1"
      | G_sd3_sd6c_z_1_z_1 -> "G_sd3_sd6c_z_1_z_1"
      | G_sd4_sd1c_z_1_z_1 -> "G_sd4_sd1c_z_1_z_1"
      | G_sd4_sd2c_z_1_z_1 -> "G_sd4_sd2c_z_1_z_1"
      | G_sd4_sd3c_z_1_z_1 -> "G_sd4_sd3c_z_1_z_1"
      | G_sd4_sd4c_z_1_z_1 -> "G_sd4_sd4c_z_1_z_1"
      | G_sd4_sd5c_z_1_z_1 -> "G_sd4_sd5c_z_1_z_1"
      | G_sd4_sd6c_z_1_z_1 -> "G_sd4_sd6c_z_1_z_1"
      | G_sd5_sd1c_z_1_z_1 -> "G_sd5_sd1c_z_1_z_1"
      | G_sd5_sd2c_z_1_z_1 -> "G_sd5_sd2c_z_1_z_1"
      | G_sd5_sd3c_z_1_z_1 -> "G_sd5_sd3c_z_1_z_1"
      | G_sd5_sd4c_z_1_z_1 -> "G_sd5_sd4c_z_1_z_1"
      | G_sd5_sd5c_z_1_z_1 -> "G_sd5_sd5c_z_1_z_1"
      | G_sd5_sd6c_z_1_z_1 -> "G_sd5_sd6c_z_1_z_1"
      | G_sd6_sd1c_z_1_z_1 -> "G_sd6_sd1c_z_1_z_1"
      | G_sd6_sd2c_z_1_z_1 -> "G_sd6_sd2c_z_1_z_1"
      | G_sd6_sd3c_z_1_z_1 -> "G_sd6_sd3c_z_1_z_1"
      | G_sd6_sd4c_z_1_z_1 -> "G_sd6_sd4c_z_1_z_1"
      | G_sd6_sd5c_z_1_z_1 -> "G_sd6_sd5c_z_1_z_1"
      | G_sd6_sd6c_z_1_z_1 -> "G_sd6_sd6c_z_1_z_1"
      | G_sd1_su1c_wmc_z_1 -> "G_sd1_su1c_wmc_z_1"
      | G_sd1_su2c_wmc_z_1 -> "G_sd1_su2c_wmc_z_1"
      | G_sd1_su3c_wmc_z_1 -> "G_sd1_su3c_wmc_z_1"
      | G_sd1_su4c_wmc_z_1 -> "G_sd1_su4c_wmc_z_1"
      | G_sd1_su5c_wmc_z_1 -> "G_sd1_su5c_wmc_z_1"
      | G_sd1_su6c_wmc_z_1 -> "G_sd1_su6c_wmc_z_1"
      | G_sd2_su1c_wmc_z_1 -> "G_sd2_su1c_wmc_z_1"
      | G_sd2_su2c_wmc_z_1 -> "G_sd2_su2c_wmc_z_1"
      | G_sd2_su3c_wmc_z_1 -> "G_sd2_su3c_wmc_z_1"
      | G_sd2_su4c_wmc_z_1 -> "G_sd2_su4c_wmc_z_1"
      | G_sd2_su5c_wmc_z_1 -> "G_sd2_su5c_wmc_z_1"
      | G_sd2_su6c_wmc_z_1 -> "G_sd2_su6c_wmc_z_1"
      | G_sd3_su1c_wmc_z_1 -> "G_sd3_su1c_wmc_z_1"
      | G_sd3_su2c_wmc_z_1 -> "G_sd3_su2c_wmc_z_1"
      | G_sd3_su3c_wmc_z_1 -> "G_sd3_su3c_wmc_z_1"
      | G_sd3_su4c_wmc_z_1 -> "G_sd3_su4c_wmc_z_1"
      | G_sd3_su5c_wmc_z_1 -> "G_sd3_su5c_wmc_z_1"
      | G_sd3_su6c_wmc_z_1 -> "G_sd3_su6c_wmc_z_1"
      | G_sd4_su1c_wmc_z_1 -> "G_sd4_su1c_wmc_z_1"
      | G_sd4_su2c_wmc_z_1 -> "G_sd4_su2c_wmc_z_1"
      | G_sd4_su3c_wmc_z_1 -> "G_sd4_su3c_wmc_z_1"
      | G_sd4_su4c_wmc_z_1 -> "G_sd4_su4c_wmc_z_1"
      | G_sd4_su5c_wmc_z_1 -> "G_sd4_su5c_wmc_z_1"
      | G_sd4_su6c_wmc_z_1 -> "G_sd4_su6c_wmc_z_1"
      | G_sd5_su1c_wmc_z_1 -> "G_sd5_su1c_wmc_z_1"
      | G_sd5_su2c_wmc_z_1 -> "G_sd5_su2c_wmc_z_1"
      | G_sd5_su3c_wmc_z_1 -> "G_sd5_su3c_wmc_z_1"
      | G_sd5_su4c_wmc_z_1 -> "G_sd5_su4c_wmc_z_1"
      | G_sd5_su5c_wmc_z_1 -> "G_sd5_su5c_wmc_z_1"
      | G_sd5_su6c_wmc_z_1 -> "G_sd5_su6c_wmc_z_1"
      | G_sd6_su1c_wmc_z_1 -> "G_sd6_su1c_wmc_z_1"
      | G_sd6_su2c_wmc_z_1 -> "G_sd6_su2c_wmc_z_1"
      | G_sd6_su3c_wmc_z_1 -> "G_sd6_su3c_wmc_z_1"
      | G_sd6_su4c_wmc_z_1 -> "G_sd6_su4c_wmc_z_1"
      | G_sd6_su5c_wmc_z_1 -> "G_sd6_su5c_wmc_z_1"
      | G_sd6_su6c_wmc_z_1 -> "G_sd6_su6c_wmc_z_1"
      | G_se1_se1c_a_1_a_1 -> "G_se1_se1c_a_1_a_1"
      | G_se1_se2c_a_1_a_1 -> "G_se1_se2c_a_1_a_1"
      | G_se1_se3c_a_1_a_1 -> "G_se1_se3c_a_1_a_1"
      | G_se1_se4c_a_1_a_1 -> "G_se1_se4c_a_1_a_1"
      | G_se1_se5c_a_1_a_1 -> "G_se1_se5c_a_1_a_1"
      | G_se1_se6c_a_1_a_1 -> "G_se1_se6c_a_1_a_1"
      | G_se2_se1c_a_1_a_1 -> "G_se2_se1c_a_1_a_1"
      | G_se2_se2c_a_1_a_1 -> "G_se2_se2c_a_1_a_1"
      | G_se2_se3c_a_1_a_1 -> "G_se2_se3c_a_1_a_1"
      | G_se2_se4c_a_1_a_1 -> "G_se2_se4c_a_1_a_1"
      | G_se2_se5c_a_1_a_1 -> "G_se2_se5c_a_1_a_1"
      | G_se2_se6c_a_1_a_1 -> "G_se2_se6c_a_1_a_1"
      | G_se3_se1c_a_1_a_1 -> "G_se3_se1c_a_1_a_1"
      | G_se3_se2c_a_1_a_1 -> "G_se3_se2c_a_1_a_1"
      | G_se3_se3c_a_1_a_1 -> "G_se3_se3c_a_1_a_1"
      | G_se3_se4c_a_1_a_1 -> "G_se3_se4c_a_1_a_1"
      | G_se3_se5c_a_1_a_1 -> "G_se3_se5c_a_1_a_1"
      | G_se3_se6c_a_1_a_1 -> "G_se3_se6c_a_1_a_1"
      | G_se4_se1c_a_1_a_1 -> "G_se4_se1c_a_1_a_1"
      | G_se4_se2c_a_1_a_1 -> "G_se4_se2c_a_1_a_1"
      | G_se4_se3c_a_1_a_1 -> "G_se4_se3c_a_1_a_1"
      | G_se4_se4c_a_1_a_1 -> "G_se4_se4c_a_1_a_1"
      | G_se4_se5c_a_1_a_1 -> "G_se4_se5c_a_1_a_1"
      | G_se4_se6c_a_1_a_1 -> "G_se4_se6c_a_1_a_1"
      | G_se5_se1c_a_1_a_1 -> "G_se5_se1c_a_1_a_1"
      | G_se5_se2c_a_1_a_1 -> "G_se5_se2c_a_1_a_1"
      | G_se5_se3c_a_1_a_1 -> "G_se5_se3c_a_1_a_1"
      | G_se5_se4c_a_1_a_1 -> "G_se5_se4c_a_1_a_1"
      | G_se5_se5c_a_1_a_1 -> "G_se5_se5c_a_1_a_1"
      | G_se5_se6c_a_1_a_1 -> "G_se5_se6c_a_1_a_1"
      | G_se6_se1c_a_1_a_1 -> "G_se6_se1c_a_1_a_1"
      | G_se6_se2c_a_1_a_1 -> "G_se6_se2c_a_1_a_1"
      | G_se6_se3c_a_1_a_1 -> "G_se6_se3c_a_1_a_1"
      | G_se6_se4c_a_1_a_1 -> "G_se6_se4c_a_1_a_1"
      | G_se6_se5c_a_1_a_1 -> "G_se6_se5c_a_1_a_1"
      | G_se6_se6c_a_1_a_1 -> "G_se6_se6c_a_1_a_1"
      | G_se1_se1c_a_1_z_1 -> "G_se1_se1c_a_1_z_1"
      | G_se1_se2c_a_1_z_1 -> "G_se1_se2c_a_1_z_1"
      | G_se1_se3c_a_1_z_1 -> "G_se1_se3c_a_1_z_1"
      | G_se1_se4c_a_1_z_1 -> "G_se1_se4c_a_1_z_1"
      | G_se1_se5c_a_1_z_1 -> "G_se1_se5c_a_1_z_1"
      | G_se1_se6c_a_1_z_1 -> "G_se1_se6c_a_1_z_1"
      | G_se2_se1c_a_1_z_1 -> "G_se2_se1c_a_1_z_1"
      | G_se2_se2c_a_1_z_1 -> "G_se2_se2c_a_1_z_1"
      | G_se2_se3c_a_1_z_1 -> "G_se2_se3c_a_1_z_1"
      | G_se2_se4c_a_1_z_1 -> "G_se2_se4c_a_1_z_1"
      | G_se2_se5c_a_1_z_1 -> "G_se2_se5c_a_1_z_1"
      | G_se2_se6c_a_1_z_1 -> "G_se2_se6c_a_1_z_1"
      | G_se3_se1c_a_1_z_1 -> "G_se3_se1c_a_1_z_1"
      | G_se3_se2c_a_1_z_1 -> "G_se3_se2c_a_1_z_1"
      | G_se3_se3c_a_1_z_1 -> "G_se3_se3c_a_1_z_1"
      | G_se3_se4c_a_1_z_1 -> "G_se3_se4c_a_1_z_1"
      | G_se3_se5c_a_1_z_1 -> "G_se3_se5c_a_1_z_1"
      | G_se3_se6c_a_1_z_1 -> "G_se3_se6c_a_1_z_1"
      | G_se4_se1c_a_1_z_1 -> "G_se4_se1c_a_1_z_1"
      | G_se4_se2c_a_1_z_1 -> "G_se4_se2c_a_1_z_1"
      | G_se4_se3c_a_1_z_1 -> "G_se4_se3c_a_1_z_1"
      | G_se4_se4c_a_1_z_1 -> "G_se4_se4c_a_1_z_1"
      | G_se4_se5c_a_1_z_1 -> "G_se4_se5c_a_1_z_1"
      | G_se4_se6c_a_1_z_1 -> "G_se4_se6c_a_1_z_1"
      | G_se5_se1c_a_1_z_1 -> "G_se5_se1c_a_1_z_1"
      | G_se5_se2c_a_1_z_1 -> "G_se5_se2c_a_1_z_1"
      | G_se5_se3c_a_1_z_1 -> "G_se5_se3c_a_1_z_1"
      | G_se5_se4c_a_1_z_1 -> "G_se5_se4c_a_1_z_1"
      | G_se5_se5c_a_1_z_1 -> "G_se5_se5c_a_1_z_1"
      | G_se5_se6c_a_1_z_1 -> "G_se5_se6c_a_1_z_1"
      | G_se6_se1c_a_1_z_1 -> "G_se6_se1c_a_1_z_1"
      | G_se6_se2c_a_1_z_1 -> "G_se6_se2c_a_1_z_1"
      | G_se6_se3c_a_1_z_1 -> "G_se6_se3c_a_1_z_1"
      | G_se6_se4c_a_1_z_1 -> "G_se6_se4c_a_1_z_1"
      | G_se6_se5c_a_1_z_1 -> "G_se6_se5c_a_1_z_1"
      | G_se6_se6c_a_1_z_1 -> "G_se6_se6c_a_1_z_1"
      | G_se1_sv1c_wmc_a_1 -> "G_se1_sv1c_wmc_a_1"
      | G_se1_sv2c_wmc_a_1 -> "G_se1_sv2c_wmc_a_1"
      | G_se1_sv3c_wmc_a_1 -> "G_se1_sv3c_wmc_a_1"
      | G_se2_sv1c_wmc_a_1 -> "G_se2_sv1c_wmc_a_1"
      | G_se2_sv2c_wmc_a_1 -> "G_se2_sv2c_wmc_a_1"
      | G_se2_sv3c_wmc_a_1 -> "G_se2_sv3c_wmc_a_1"
      | G_se3_sv1c_wmc_a_1 -> "G_se3_sv1c_wmc_a_1"
      | G_se3_sv2c_wmc_a_1 -> "G_se3_sv2c_wmc_a_1"
      | G_se3_sv3c_wmc_a_1 -> "G_se3_sv3c_wmc_a_1"
      | G_se4_sv1c_wmc_a_1 -> "G_se4_sv1c_wmc_a_1"
      | G_se4_sv2c_wmc_a_1 -> "G_se4_sv2c_wmc_a_1"
      | G_se4_sv3c_wmc_a_1 -> "G_se4_sv3c_wmc_a_1"
      | G_se5_sv1c_wmc_a_1 -> "G_se5_sv1c_wmc_a_1"
      | G_se5_sv2c_wmc_a_1 -> "G_se5_sv2c_wmc_a_1"
      | G_se5_sv3c_wmc_a_1 -> "G_se5_sv3c_wmc_a_1"
      | G_se6_sv1c_wmc_a_1 -> "G_se6_sv1c_wmc_a_1"
      | G_se6_sv2c_wmc_a_1 -> "G_se6_sv2c_wmc_a_1"
      | G_se6_sv3c_wmc_a_1 -> "G_se6_sv3c_wmc_a_1"
      | G_se1_se1c_wmc_wm_1 -> "G_se1_se1c_wmc_wm_1"
      | G_se1_se2c_wmc_wm_1 -> "G_se1_se2c_wmc_wm_1"
      | G_se1_se3c_wmc_wm_1 -> "G_se1_se3c_wmc_wm_1"
      | G_se1_se4c_wmc_wm_1 -> "G_se1_se4c_wmc_wm_1"
      | G_se1_se5c_wmc_wm_1 -> "G_se1_se5c_wmc_wm_1"
      | G_se1_se6c_wmc_wm_1 -> "G_se1_se6c_wmc_wm_1"
      | G_se2_se1c_wmc_wm_1 -> "G_se2_se1c_wmc_wm_1"
      | G_se2_se2c_wmc_wm_1 -> "G_se2_se2c_wmc_wm_1"
      | G_se2_se3c_wmc_wm_1 -> "G_se2_se3c_wmc_wm_1"
      | G_se2_se4c_wmc_wm_1 -> "G_se2_se4c_wmc_wm_1"
      | G_se2_se5c_wmc_wm_1 -> "G_se2_se5c_wmc_wm_1"
      | G_se2_se6c_wmc_wm_1 -> "G_se2_se6c_wmc_wm_1"
      | G_se3_se1c_wmc_wm_1 -> "G_se3_se1c_wmc_wm_1"
      | G_se3_se2c_wmc_wm_1 -> "G_se3_se2c_wmc_wm_1"
      | G_se3_se3c_wmc_wm_1 -> "G_se3_se3c_wmc_wm_1"
      | G_se3_se4c_wmc_wm_1 -> "G_se3_se4c_wmc_wm_1"
      | G_se3_se5c_wmc_wm_1 -> "G_se3_se5c_wmc_wm_1"
      | G_se3_se6c_wmc_wm_1 -> "G_se3_se6c_wmc_wm_1"
      | G_se4_se1c_wmc_wm_1 -> "G_se4_se1c_wmc_wm_1"
      | G_se4_se2c_wmc_wm_1 -> "G_se4_se2c_wmc_wm_1"
      | G_se4_se3c_wmc_wm_1 -> "G_se4_se3c_wmc_wm_1"
      | G_se4_se4c_wmc_wm_1 -> "G_se4_se4c_wmc_wm_1"
      | G_se4_se5c_wmc_wm_1 -> "G_se4_se5c_wmc_wm_1"
      | G_se4_se6c_wmc_wm_1 -> "G_se4_se6c_wmc_wm_1"
      | G_se5_se1c_wmc_wm_1 -> "G_se5_se1c_wmc_wm_1"
      | G_se5_se2c_wmc_wm_1 -> "G_se5_se2c_wmc_wm_1"
      | G_se5_se3c_wmc_wm_1 -> "G_se5_se3c_wmc_wm_1"
      | G_se5_se4c_wmc_wm_1 -> "G_se5_se4c_wmc_wm_1"
      | G_se5_se5c_wmc_wm_1 -> "G_se5_se5c_wmc_wm_1"
      | G_se5_se6c_wmc_wm_1 -> "G_se5_se6c_wmc_wm_1"
      | G_se6_se1c_wmc_wm_1 -> "G_se6_se1c_wmc_wm_1"
      | G_se6_se2c_wmc_wm_1 -> "G_se6_se2c_wmc_wm_1"
      | G_se6_se3c_wmc_wm_1 -> "G_se6_se3c_wmc_wm_1"
      | G_se6_se4c_wmc_wm_1 -> "G_se6_se4c_wmc_wm_1"
      | G_se6_se5c_wmc_wm_1 -> "G_se6_se5c_wmc_wm_1"
      | G_se6_se6c_wmc_wm_1 -> "G_se6_se6c_wmc_wm_1"
      | G_se1_se1c_z_1_z_1 -> "G_se1_se1c_z_1_z_1"
      | G_se1_se2c_z_1_z_1 -> "G_se1_se2c_z_1_z_1"
      | G_se1_se3c_z_1_z_1 -> "G_se1_se3c_z_1_z_1"
      | G_se1_se4c_z_1_z_1 -> "G_se1_se4c_z_1_z_1"
      | G_se1_se5c_z_1_z_1 -> "G_se1_se5c_z_1_z_1"
      | G_se1_se6c_z_1_z_1 -> "G_se1_se6c_z_1_z_1"
      | G_se2_se1c_z_1_z_1 -> "G_se2_se1c_z_1_z_1"
      | G_se2_se2c_z_1_z_1 -> "G_se2_se2c_z_1_z_1"
      | G_se2_se3c_z_1_z_1 -> "G_se2_se3c_z_1_z_1"
      | G_se2_se4c_z_1_z_1 -> "G_se2_se4c_z_1_z_1"
      | G_se2_se5c_z_1_z_1 -> "G_se2_se5c_z_1_z_1"
      | G_se2_se6c_z_1_z_1 -> "G_se2_se6c_z_1_z_1"
      | G_se3_se1c_z_1_z_1 -> "G_se3_se1c_z_1_z_1"
      | G_se3_se2c_z_1_z_1 -> "G_se3_se2c_z_1_z_1"
      | G_se3_se3c_z_1_z_1 -> "G_se3_se3c_z_1_z_1"
      | G_se3_se4c_z_1_z_1 -> "G_se3_se4c_z_1_z_1"
      | G_se3_se5c_z_1_z_1 -> "G_se3_se5c_z_1_z_1"
      | G_se3_se6c_z_1_z_1 -> "G_se3_se6c_z_1_z_1"
      | G_se4_se1c_z_1_z_1 -> "G_se4_se1c_z_1_z_1"
      | G_se4_se2c_z_1_z_1 -> "G_se4_se2c_z_1_z_1"
      | G_se4_se3c_z_1_z_1 -> "G_se4_se3c_z_1_z_1"
      | G_se4_se4c_z_1_z_1 -> "G_se4_se4c_z_1_z_1"
      | G_se4_se5c_z_1_z_1 -> "G_se4_se5c_z_1_z_1"
      | G_se4_se6c_z_1_z_1 -> "G_se4_se6c_z_1_z_1"
      | G_se5_se1c_z_1_z_1 -> "G_se5_se1c_z_1_z_1"
      | G_se5_se2c_z_1_z_1 -> "G_se5_se2c_z_1_z_1"
      | G_se5_se3c_z_1_z_1 -> "G_se5_se3c_z_1_z_1"
      | G_se5_se4c_z_1_z_1 -> "G_se5_se4c_z_1_z_1"
      | G_se5_se5c_z_1_z_1 -> "G_se5_se5c_z_1_z_1"
      | G_se5_se6c_z_1_z_1 -> "G_se5_se6c_z_1_z_1"
      | G_se6_se1c_z_1_z_1 -> "G_se6_se1c_z_1_z_1"
      | G_se6_se2c_z_1_z_1 -> "G_se6_se2c_z_1_z_1"
      | G_se6_se3c_z_1_z_1 -> "G_se6_se3c_z_1_z_1"
      | G_se6_se4c_z_1_z_1 -> "G_se6_se4c_z_1_z_1"
      | G_se6_se5c_z_1_z_1 -> "G_se6_se5c_z_1_z_1"
      | G_se6_se6c_z_1_z_1 -> "G_se6_se6c_z_1_z_1"
      | G_se1_sv1c_wmc_z_1 -> "G_se1_sv1c_wmc_z_1"
      | G_se1_sv2c_wmc_z_1 -> "G_se1_sv2c_wmc_z_1"
      | G_se1_sv3c_wmc_z_1 -> "G_se1_sv3c_wmc_z_1"
      | G_se2_sv1c_wmc_z_1 -> "G_se2_sv1c_wmc_z_1"
      | G_se2_sv2c_wmc_z_1 -> "G_se2_sv2c_wmc_z_1"
      | G_se2_sv3c_wmc_z_1 -> "G_se2_sv3c_wmc_z_1"
      | G_se3_sv1c_wmc_z_1 -> "G_se3_sv1c_wmc_z_1"
      | G_se3_sv2c_wmc_z_1 -> "G_se3_sv2c_wmc_z_1"
      | G_se3_sv3c_wmc_z_1 -> "G_se3_sv3c_wmc_z_1"
      | G_se4_sv1c_wmc_z_1 -> "G_se4_sv1c_wmc_z_1"
      | G_se4_sv2c_wmc_z_1 -> "G_se4_sv2c_wmc_z_1"
      | G_se4_sv3c_wmc_z_1 -> "G_se4_sv3c_wmc_z_1"
      | G_se5_sv1c_wmc_z_1 -> "G_se5_sv1c_wmc_z_1"
      | G_se5_sv2c_wmc_z_1 -> "G_se5_sv2c_wmc_z_1"
      | G_se5_sv3c_wmc_z_1 -> "G_se5_sv3c_wmc_z_1"
      | G_se6_sv1c_wmc_z_1 -> "G_se6_sv1c_wmc_z_1"
      | G_se6_sv2c_wmc_z_1 -> "G_se6_sv2c_wmc_z_1"
      | G_se6_sv3c_wmc_z_1 -> "G_se6_sv3c_wmc_z_1"
      | G_su1_su1c_g_1_a_1 -> "G_su1_su1c_g_1_a_1"
      | G_su1_su2c_g_1_a_1 -> "G_su1_su2c_g_1_a_1"
      | G_su1_su3c_g_1_a_1 -> "G_su1_su3c_g_1_a_1"
      | G_su1_su4c_g_1_a_1 -> "G_su1_su4c_g_1_a_1"
      | G_su1_su5c_g_1_a_1 -> "G_su1_su5c_g_1_a_1"
      | G_su1_su6c_g_1_a_1 -> "G_su1_su6c_g_1_a_1"
      | G_su2_su1c_g_1_a_1 -> "G_su2_su1c_g_1_a_1"
      | G_su2_su2c_g_1_a_1 -> "G_su2_su2c_g_1_a_1"
      | G_su2_su3c_g_1_a_1 -> "G_su2_su3c_g_1_a_1"
      | G_su2_su4c_g_1_a_1 -> "G_su2_su4c_g_1_a_1"
      | G_su2_su5c_g_1_a_1 -> "G_su2_su5c_g_1_a_1"
      | G_su2_su6c_g_1_a_1 -> "G_su2_su6c_g_1_a_1"
      | G_su3_su1c_g_1_a_1 -> "G_su3_su1c_g_1_a_1"
      | G_su3_su2c_g_1_a_1 -> "G_su3_su2c_g_1_a_1"
      | G_su3_su3c_g_1_a_1 -> "G_su3_su3c_g_1_a_1"
      | G_su3_su4c_g_1_a_1 -> "G_su3_su4c_g_1_a_1"
      | G_su3_su5c_g_1_a_1 -> "G_su3_su5c_g_1_a_1"
      | G_su3_su6c_g_1_a_1 -> "G_su3_su6c_g_1_a_1"
      | G_su4_su1c_g_1_a_1 -> "G_su4_su1c_g_1_a_1"
      | G_su4_su2c_g_1_a_1 -> "G_su4_su2c_g_1_a_1"
      | G_su4_su3c_g_1_a_1 -> "G_su4_su3c_g_1_a_1"
      | G_su4_su4c_g_1_a_1 -> "G_su4_su4c_g_1_a_1"
      | G_su4_su5c_g_1_a_1 -> "G_su4_su5c_g_1_a_1"
      | G_su4_su6c_g_1_a_1 -> "G_su4_su6c_g_1_a_1"
      | G_su5_su1c_g_1_a_1 -> "G_su5_su1c_g_1_a_1"
      | G_su5_su2c_g_1_a_1 -> "G_su5_su2c_g_1_a_1"
      | G_su5_su3c_g_1_a_1 -> "G_su5_su3c_g_1_a_1"
      | G_su5_su4c_g_1_a_1 -> "G_su5_su4c_g_1_a_1"
      | G_su5_su5c_g_1_a_1 -> "G_su5_su5c_g_1_a_1"
      | G_su5_su6c_g_1_a_1 -> "G_su5_su6c_g_1_a_1"
      | G_su6_su1c_g_1_a_1 -> "G_su6_su1c_g_1_a_1"
      | G_su6_su2c_g_1_a_1 -> "G_su6_su2c_g_1_a_1"
      | G_su6_su3c_g_1_a_1 -> "G_su6_su3c_g_1_a_1"
      | G_su6_su4c_g_1_a_1 -> "G_su6_su4c_g_1_a_1"
      | G_su6_su5c_g_1_a_1 -> "G_su6_su5c_g_1_a_1"
      | G_su6_su6c_g_1_a_1 -> "G_su6_su6c_g_1_a_1"
      | G_su1_sd1c_g_1_wm_1 -> "G_su1_sd1c_g_1_wm_1"
      | G_su1_sd2c_g_1_wm_1 -> "G_su1_sd2c_g_1_wm_1"
      | G_su1_sd3c_g_1_wm_1 -> "G_su1_sd3c_g_1_wm_1"
      | G_su1_sd4c_g_1_wm_1 -> "G_su1_sd4c_g_1_wm_1"
      | G_su1_sd5c_g_1_wm_1 -> "G_su1_sd5c_g_1_wm_1"
      | G_su1_sd6c_g_1_wm_1 -> "G_su1_sd6c_g_1_wm_1"
      | G_su2_sd1c_g_1_wm_1 -> "G_su2_sd1c_g_1_wm_1"
      | G_su2_sd2c_g_1_wm_1 -> "G_su2_sd2c_g_1_wm_1"
      | G_su2_sd3c_g_1_wm_1 -> "G_su2_sd3c_g_1_wm_1"
      | G_su2_sd4c_g_1_wm_1 -> "G_su2_sd4c_g_1_wm_1"
      | G_su2_sd5c_g_1_wm_1 -> "G_su2_sd5c_g_1_wm_1"
      | G_su2_sd6c_g_1_wm_1 -> "G_su2_sd6c_g_1_wm_1"
      | G_su3_sd1c_g_1_wm_1 -> "G_su3_sd1c_g_1_wm_1"
      | G_su3_sd2c_g_1_wm_1 -> "G_su3_sd2c_g_1_wm_1"
      | G_su3_sd3c_g_1_wm_1 -> "G_su3_sd3c_g_1_wm_1"
      | G_su3_sd4c_g_1_wm_1 -> "G_su3_sd4c_g_1_wm_1"
      | G_su3_sd5c_g_1_wm_1 -> "G_su3_sd5c_g_1_wm_1"
      | G_su3_sd6c_g_1_wm_1 -> "G_su3_sd6c_g_1_wm_1"
      | G_su4_sd1c_g_1_wm_1 -> "G_su4_sd1c_g_1_wm_1"
      | G_su4_sd2c_g_1_wm_1 -> "G_su4_sd2c_g_1_wm_1"
      | G_su4_sd3c_g_1_wm_1 -> "G_su4_sd3c_g_1_wm_1"
      | G_su4_sd4c_g_1_wm_1 -> "G_su4_sd4c_g_1_wm_1"
      | G_su4_sd5c_g_1_wm_1 -> "G_su4_sd5c_g_1_wm_1"
      | G_su4_sd6c_g_1_wm_1 -> "G_su4_sd6c_g_1_wm_1"
      | G_su5_sd1c_g_1_wm_1 -> "G_su5_sd1c_g_1_wm_1"
      | G_su5_sd2c_g_1_wm_1 -> "G_su5_sd2c_g_1_wm_1"
      | G_su5_sd3c_g_1_wm_1 -> "G_su5_sd3c_g_1_wm_1"
      | G_su5_sd4c_g_1_wm_1 -> "G_su5_sd4c_g_1_wm_1"
      | G_su5_sd5c_g_1_wm_1 -> "G_su5_sd5c_g_1_wm_1"
      | G_su5_sd6c_g_1_wm_1 -> "G_su5_sd6c_g_1_wm_1"
      | G_su6_sd1c_g_1_wm_1 -> "G_su6_sd1c_g_1_wm_1"
      | G_su6_sd2c_g_1_wm_1 -> "G_su6_sd2c_g_1_wm_1"
      | G_su6_sd3c_g_1_wm_1 -> "G_su6_sd3c_g_1_wm_1"
      | G_su6_sd4c_g_1_wm_1 -> "G_su6_sd4c_g_1_wm_1"
      | G_su6_sd5c_g_1_wm_1 -> "G_su6_sd5c_g_1_wm_1"
      | G_su6_sd6c_g_1_wm_1 -> "G_su6_sd6c_g_1_wm_1"
      | G_su1_su1c_g_1_z_1 -> "G_su1_su1c_g_1_z_1"
      | G_su1_su2c_g_1_z_1 -> "G_su1_su2c_g_1_z_1"
      | G_su1_su3c_g_1_z_1 -> "G_su1_su3c_g_1_z_1"
      | G_su1_su4c_g_1_z_1 -> "G_su1_su4c_g_1_z_1"
      | G_su1_su5c_g_1_z_1 -> "G_su1_su5c_g_1_z_1"
      | G_su1_su6c_g_1_z_1 -> "G_su1_su6c_g_1_z_1"
      | G_su2_su1c_g_1_z_1 -> "G_su2_su1c_g_1_z_1"
      | G_su2_su2c_g_1_z_1 -> "G_su2_su2c_g_1_z_1"
      | G_su2_su3c_g_1_z_1 -> "G_su2_su3c_g_1_z_1"
      | G_su2_su4c_g_1_z_1 -> "G_su2_su4c_g_1_z_1"
      | G_su2_su5c_g_1_z_1 -> "G_su2_su5c_g_1_z_1"
      | G_su2_su6c_g_1_z_1 -> "G_su2_su6c_g_1_z_1"
      | G_su3_su1c_g_1_z_1 -> "G_su3_su1c_g_1_z_1"
      | G_su3_su2c_g_1_z_1 -> "G_su3_su2c_g_1_z_1"
      | G_su3_su3c_g_1_z_1 -> "G_su3_su3c_g_1_z_1"
      | G_su3_su4c_g_1_z_1 -> "G_su3_su4c_g_1_z_1"
      | G_su3_su5c_g_1_z_1 -> "G_su3_su5c_g_1_z_1"
      | G_su3_su6c_g_1_z_1 -> "G_su3_su6c_g_1_z_1"
      | G_su4_su1c_g_1_z_1 -> "G_su4_su1c_g_1_z_1"
      | G_su4_su2c_g_1_z_1 -> "G_su4_su2c_g_1_z_1"
      | G_su4_su3c_g_1_z_1 -> "G_su4_su3c_g_1_z_1"
      | G_su4_su4c_g_1_z_1 -> "G_su4_su4c_g_1_z_1"
      | G_su4_su5c_g_1_z_1 -> "G_su4_su5c_g_1_z_1"
      | G_su4_su6c_g_1_z_1 -> "G_su4_su6c_g_1_z_1"
      | G_su5_su1c_g_1_z_1 -> "G_su5_su1c_g_1_z_1"
      | G_su5_su2c_g_1_z_1 -> "G_su5_su2c_g_1_z_1"
      | G_su5_su3c_g_1_z_1 -> "G_su5_su3c_g_1_z_1"
      | G_su5_su4c_g_1_z_1 -> "G_su5_su4c_g_1_z_1"
      | G_su5_su5c_g_1_z_1 -> "G_su5_su5c_g_1_z_1"
      | G_su5_su6c_g_1_z_1 -> "G_su5_su6c_g_1_z_1"
      | G_su6_su1c_g_1_z_1 -> "G_su6_su1c_g_1_z_1"
      | G_su6_su2c_g_1_z_1 -> "G_su6_su2c_g_1_z_1"
      | G_su6_su3c_g_1_z_1 -> "G_su6_su3c_g_1_z_1"
      | G_su6_su4c_g_1_z_1 -> "G_su6_su4c_g_1_z_1"
      | G_su6_su5c_g_1_z_1 -> "G_su6_su5c_g_1_z_1"
      | G_su6_su6c_g_1_z_1 -> "G_su6_su6c_g_1_z_1"
      | G_su1_su1c_a_1_a_1 -> "G_su1_su1c_a_1_a_1"
      | G_su1_su2c_a_1_a_1 -> "G_su1_su2c_a_1_a_1"
      | G_su1_su3c_a_1_a_1 -> "G_su1_su3c_a_1_a_1"
      | G_su1_su4c_a_1_a_1 -> "G_su1_su4c_a_1_a_1"
      | G_su1_su5c_a_1_a_1 -> "G_su1_su5c_a_1_a_1"
      | G_su1_su6c_a_1_a_1 -> "G_su1_su6c_a_1_a_1"
      | G_su2_su1c_a_1_a_1 -> "G_su2_su1c_a_1_a_1"
      | G_su2_su2c_a_1_a_1 -> "G_su2_su2c_a_1_a_1"
      | G_su2_su3c_a_1_a_1 -> "G_su2_su3c_a_1_a_1"
      | G_su2_su4c_a_1_a_1 -> "G_su2_su4c_a_1_a_1"
      | G_su2_su5c_a_1_a_1 -> "G_su2_su5c_a_1_a_1"
      | G_su2_su6c_a_1_a_1 -> "G_su2_su6c_a_1_a_1"
      | G_su3_su1c_a_1_a_1 -> "G_su3_su1c_a_1_a_1"
      | G_su3_su2c_a_1_a_1 -> "G_su3_su2c_a_1_a_1"
      | G_su3_su3c_a_1_a_1 -> "G_su3_su3c_a_1_a_1"
      | G_su3_su4c_a_1_a_1 -> "G_su3_su4c_a_1_a_1"
      | G_su3_su5c_a_1_a_1 -> "G_su3_su5c_a_1_a_1"
      | G_su3_su6c_a_1_a_1 -> "G_su3_su6c_a_1_a_1"
      | G_su4_su1c_a_1_a_1 -> "G_su4_su1c_a_1_a_1"
      | G_su4_su2c_a_1_a_1 -> "G_su4_su2c_a_1_a_1"
      | G_su4_su3c_a_1_a_1 -> "G_su4_su3c_a_1_a_1"
      | G_su4_su4c_a_1_a_1 -> "G_su4_su4c_a_1_a_1"
      | G_su4_su5c_a_1_a_1 -> "G_su4_su5c_a_1_a_1"
      | G_su4_su6c_a_1_a_1 -> "G_su4_su6c_a_1_a_1"
      | G_su5_su1c_a_1_a_1 -> "G_su5_su1c_a_1_a_1"
      | G_su5_su2c_a_1_a_1 -> "G_su5_su2c_a_1_a_1"
      | G_su5_su3c_a_1_a_1 -> "G_su5_su3c_a_1_a_1"
      | G_su5_su4c_a_1_a_1 -> "G_su5_su4c_a_1_a_1"
      | G_su5_su5c_a_1_a_1 -> "G_su5_su5c_a_1_a_1"
      | G_su5_su6c_a_1_a_1 -> "G_su5_su6c_a_1_a_1"
      | G_su6_su1c_a_1_a_1 -> "G_su6_su1c_a_1_a_1"
      | G_su6_su2c_a_1_a_1 -> "G_su6_su2c_a_1_a_1"
      | G_su6_su3c_a_1_a_1 -> "G_su6_su3c_a_1_a_1"
      | G_su6_su4c_a_1_a_1 -> "G_su6_su4c_a_1_a_1"
      | G_su6_su5c_a_1_a_1 -> "G_su6_su5c_a_1_a_1"
      | G_su6_su6c_a_1_a_1 -> "G_su6_su6c_a_1_a_1"
      | G_su1_sd1c_a_1_wm_1 -> "G_su1_sd1c_a_1_wm_1"
      | G_su1_sd2c_a_1_wm_1 -> "G_su1_sd2c_a_1_wm_1"
      | G_su1_sd3c_a_1_wm_1 -> "G_su1_sd3c_a_1_wm_1"
      | G_su1_sd4c_a_1_wm_1 -> "G_su1_sd4c_a_1_wm_1"
      | G_su1_sd5c_a_1_wm_1 -> "G_su1_sd5c_a_1_wm_1"
      | G_su1_sd6c_a_1_wm_1 -> "G_su1_sd6c_a_1_wm_1"
      | G_su2_sd1c_a_1_wm_1 -> "G_su2_sd1c_a_1_wm_1"
      | G_su2_sd2c_a_1_wm_1 -> "G_su2_sd2c_a_1_wm_1"
      | G_su2_sd3c_a_1_wm_1 -> "G_su2_sd3c_a_1_wm_1"
      | G_su2_sd4c_a_1_wm_1 -> "G_su2_sd4c_a_1_wm_1"
      | G_su2_sd5c_a_1_wm_1 -> "G_su2_sd5c_a_1_wm_1"
      | G_su2_sd6c_a_1_wm_1 -> "G_su2_sd6c_a_1_wm_1"
      | G_su3_sd1c_a_1_wm_1 -> "G_su3_sd1c_a_1_wm_1"
      | G_su3_sd2c_a_1_wm_1 -> "G_su3_sd2c_a_1_wm_1"
      | G_su3_sd3c_a_1_wm_1 -> "G_su3_sd3c_a_1_wm_1"
      | G_su3_sd4c_a_1_wm_1 -> "G_su3_sd4c_a_1_wm_1"
      | G_su3_sd5c_a_1_wm_1 -> "G_su3_sd5c_a_1_wm_1"
      | G_su3_sd6c_a_1_wm_1 -> "G_su3_sd6c_a_1_wm_1"
      | G_su4_sd1c_a_1_wm_1 -> "G_su4_sd1c_a_1_wm_1"
      | G_su4_sd2c_a_1_wm_1 -> "G_su4_sd2c_a_1_wm_1"
      | G_su4_sd3c_a_1_wm_1 -> "G_su4_sd3c_a_1_wm_1"
      | G_su4_sd4c_a_1_wm_1 -> "G_su4_sd4c_a_1_wm_1"
      | G_su4_sd5c_a_1_wm_1 -> "G_su4_sd5c_a_1_wm_1"
      | G_su4_sd6c_a_1_wm_1 -> "G_su4_sd6c_a_1_wm_1"
      | G_su5_sd1c_a_1_wm_1 -> "G_su5_sd1c_a_1_wm_1"
      | G_su5_sd2c_a_1_wm_1 -> "G_su5_sd2c_a_1_wm_1"
      | G_su5_sd3c_a_1_wm_1 -> "G_su5_sd3c_a_1_wm_1"
      | G_su5_sd4c_a_1_wm_1 -> "G_su5_sd4c_a_1_wm_1"
      | G_su5_sd5c_a_1_wm_1 -> "G_su5_sd5c_a_1_wm_1"
      | G_su5_sd6c_a_1_wm_1 -> "G_su5_sd6c_a_1_wm_1"
      | G_su6_sd1c_a_1_wm_1 -> "G_su6_sd1c_a_1_wm_1"
      | G_su6_sd2c_a_1_wm_1 -> "G_su6_sd2c_a_1_wm_1"
      | G_su6_sd3c_a_1_wm_1 -> "G_su6_sd3c_a_1_wm_1"
      | G_su6_sd4c_a_1_wm_1 -> "G_su6_sd4c_a_1_wm_1"
      | G_su6_sd5c_a_1_wm_1 -> "G_su6_sd5c_a_1_wm_1"
      | G_su6_sd6c_a_1_wm_1 -> "G_su6_sd6c_a_1_wm_1"
      | G_su1_su1c_a_1_z_1 -> "G_su1_su1c_a_1_z_1"
      | G_su1_su2c_a_1_z_1 -> "G_su1_su2c_a_1_z_1"
      | G_su1_su3c_a_1_z_1 -> "G_su1_su3c_a_1_z_1"
      | G_su1_su4c_a_1_z_1 -> "G_su1_su4c_a_1_z_1"
      | G_su1_su5c_a_1_z_1 -> "G_su1_su5c_a_1_z_1"
      | G_su1_su6c_a_1_z_1 -> "G_su1_su6c_a_1_z_1"
      | G_su2_su1c_a_1_z_1 -> "G_su2_su1c_a_1_z_1"
      | G_su2_su2c_a_1_z_1 -> "G_su2_su2c_a_1_z_1"
      | G_su2_su3c_a_1_z_1 -> "G_su2_su3c_a_1_z_1"
      | G_su2_su4c_a_1_z_1 -> "G_su2_su4c_a_1_z_1"
      | G_su2_su5c_a_1_z_1 -> "G_su2_su5c_a_1_z_1"
      | G_su2_su6c_a_1_z_1 -> "G_su2_su6c_a_1_z_1"
      | G_su3_su1c_a_1_z_1 -> "G_su3_su1c_a_1_z_1"
      | G_su3_su2c_a_1_z_1 -> "G_su3_su2c_a_1_z_1"
      | G_su3_su3c_a_1_z_1 -> "G_su3_su3c_a_1_z_1"
      | G_su3_su4c_a_1_z_1 -> "G_su3_su4c_a_1_z_1"
      | G_su3_su5c_a_1_z_1 -> "G_su3_su5c_a_1_z_1"
      | G_su3_su6c_a_1_z_1 -> "G_su3_su6c_a_1_z_1"
      | G_su4_su1c_a_1_z_1 -> "G_su4_su1c_a_1_z_1"
      | G_su4_su2c_a_1_z_1 -> "G_su4_su2c_a_1_z_1"
      | G_su4_su3c_a_1_z_1 -> "G_su4_su3c_a_1_z_1"
      | G_su4_su4c_a_1_z_1 -> "G_su4_su4c_a_1_z_1"
      | G_su4_su5c_a_1_z_1 -> "G_su4_su5c_a_1_z_1"
      | G_su4_su6c_a_1_z_1 -> "G_su4_su6c_a_1_z_1"
      | G_su5_su1c_a_1_z_1 -> "G_su5_su1c_a_1_z_1"
      | G_su5_su2c_a_1_z_1 -> "G_su5_su2c_a_1_z_1"
      | G_su5_su3c_a_1_z_1 -> "G_su5_su3c_a_1_z_1"
      | G_su5_su4c_a_1_z_1 -> "G_su5_su4c_a_1_z_1"
      | G_su5_su5c_a_1_z_1 -> "G_su5_su5c_a_1_z_1"
      | G_su5_su6c_a_1_z_1 -> "G_su5_su6c_a_1_z_1"
      | G_su6_su1c_a_1_z_1 -> "G_su6_su1c_a_1_z_1"
      | G_su6_su2c_a_1_z_1 -> "G_su6_su2c_a_1_z_1"
      | G_su6_su3c_a_1_z_1 -> "G_su6_su3c_a_1_z_1"
      | G_su6_su4c_a_1_z_1 -> "G_su6_su4c_a_1_z_1"
      | G_su6_su5c_a_1_z_1 -> "G_su6_su5c_a_1_z_1"
      | G_su6_su6c_a_1_z_1 -> "G_su6_su6c_a_1_z_1"
      | G_su1_sd1c_wm_1_z_1 -> "G_su1_sd1c_wm_1_z_1"
      | G_su1_sd2c_wm_1_z_1 -> "G_su1_sd2c_wm_1_z_1"
      | G_su1_sd3c_wm_1_z_1 -> "G_su1_sd3c_wm_1_z_1"
      | G_su1_sd4c_wm_1_z_1 -> "G_su1_sd4c_wm_1_z_1"
      | G_su1_sd5c_wm_1_z_1 -> "G_su1_sd5c_wm_1_z_1"
      | G_su1_sd6c_wm_1_z_1 -> "G_su1_sd6c_wm_1_z_1"
      | G_su2_sd1c_wm_1_z_1 -> "G_su2_sd1c_wm_1_z_1"
      | G_su2_sd2c_wm_1_z_1 -> "G_su2_sd2c_wm_1_z_1"
      | G_su2_sd3c_wm_1_z_1 -> "G_su2_sd3c_wm_1_z_1"
      | G_su2_sd4c_wm_1_z_1 -> "G_su2_sd4c_wm_1_z_1"
      | G_su2_sd5c_wm_1_z_1 -> "G_su2_sd5c_wm_1_z_1"
      | G_su2_sd6c_wm_1_z_1 -> "G_su2_sd6c_wm_1_z_1"
      | G_su3_sd1c_wm_1_z_1 -> "G_su3_sd1c_wm_1_z_1"
      | G_su3_sd2c_wm_1_z_1 -> "G_su3_sd2c_wm_1_z_1"
      | G_su3_sd3c_wm_1_z_1 -> "G_su3_sd3c_wm_1_z_1"
      | G_su3_sd4c_wm_1_z_1 -> "G_su3_sd4c_wm_1_z_1"
      | G_su3_sd5c_wm_1_z_1 -> "G_su3_sd5c_wm_1_z_1"
      | G_su3_sd6c_wm_1_z_1 -> "G_su3_sd6c_wm_1_z_1"
      | G_su4_sd1c_wm_1_z_1 -> "G_su4_sd1c_wm_1_z_1"
      | G_su4_sd2c_wm_1_z_1 -> "G_su4_sd2c_wm_1_z_1"
      | G_su4_sd3c_wm_1_z_1 -> "G_su4_sd3c_wm_1_z_1"
      | G_su4_sd4c_wm_1_z_1 -> "G_su4_sd4c_wm_1_z_1"
      | G_su4_sd5c_wm_1_z_1 -> "G_su4_sd5c_wm_1_z_1"
      | G_su4_sd6c_wm_1_z_1 -> "G_su4_sd6c_wm_1_z_1"
      | G_su5_sd1c_wm_1_z_1 -> "G_su5_sd1c_wm_1_z_1"
      | G_su5_sd2c_wm_1_z_1 -> "G_su5_sd2c_wm_1_z_1"
      | G_su5_sd3c_wm_1_z_1 -> "G_su5_sd3c_wm_1_z_1"
      | G_su5_sd4c_wm_1_z_1 -> "G_su5_sd4c_wm_1_z_1"
      | G_su5_sd5c_wm_1_z_1 -> "G_su5_sd5c_wm_1_z_1"
      | G_su5_sd6c_wm_1_z_1 -> "G_su5_sd6c_wm_1_z_1"
      | G_su6_sd1c_wm_1_z_1 -> "G_su6_sd1c_wm_1_z_1"
      | G_su6_sd2c_wm_1_z_1 -> "G_su6_sd2c_wm_1_z_1"
      | G_su6_sd3c_wm_1_z_1 -> "G_su6_sd3c_wm_1_z_1"
      | G_su6_sd4c_wm_1_z_1 -> "G_su6_sd4c_wm_1_z_1"
      | G_su6_sd5c_wm_1_z_1 -> "G_su6_sd5c_wm_1_z_1"
      | G_su6_sd6c_wm_1_z_1 -> "G_su6_sd6c_wm_1_z_1"
      | G_su1_su1c_wmc_wm_1 -> "G_su1_su1c_wmc_wm_1"
      | G_su1_su2c_wmc_wm_1 -> "G_su1_su2c_wmc_wm_1"
      | G_su1_su3c_wmc_wm_1 -> "G_su1_su3c_wmc_wm_1"
      | G_su1_su4c_wmc_wm_1 -> "G_su1_su4c_wmc_wm_1"
      | G_su1_su5c_wmc_wm_1 -> "G_su1_su5c_wmc_wm_1"
      | G_su1_su6c_wmc_wm_1 -> "G_su1_su6c_wmc_wm_1"
      | G_su2_su1c_wmc_wm_1 -> "G_su2_su1c_wmc_wm_1"
      | G_su2_su2c_wmc_wm_1 -> "G_su2_su2c_wmc_wm_1"
      | G_su2_su3c_wmc_wm_1 -> "G_su2_su3c_wmc_wm_1"
      | G_su2_su4c_wmc_wm_1 -> "G_su2_su4c_wmc_wm_1"
      | G_su2_su5c_wmc_wm_1 -> "G_su2_su5c_wmc_wm_1"
      | G_su2_su6c_wmc_wm_1 -> "G_su2_su6c_wmc_wm_1"
      | G_su3_su1c_wmc_wm_1 -> "G_su3_su1c_wmc_wm_1"
      | G_su3_su2c_wmc_wm_1 -> "G_su3_su2c_wmc_wm_1"
      | G_su3_su3c_wmc_wm_1 -> "G_su3_su3c_wmc_wm_1"
      | G_su3_su4c_wmc_wm_1 -> "G_su3_su4c_wmc_wm_1"
      | G_su3_su5c_wmc_wm_1 -> "G_su3_su5c_wmc_wm_1"
      | G_su3_su6c_wmc_wm_1 -> "G_su3_su6c_wmc_wm_1"
      | G_su4_su1c_wmc_wm_1 -> "G_su4_su1c_wmc_wm_1"
      | G_su4_su2c_wmc_wm_1 -> "G_su4_su2c_wmc_wm_1"
      | G_su4_su3c_wmc_wm_1 -> "G_su4_su3c_wmc_wm_1"
      | G_su4_su4c_wmc_wm_1 -> "G_su4_su4c_wmc_wm_1"
      | G_su4_su5c_wmc_wm_1 -> "G_su4_su5c_wmc_wm_1"
      | G_su4_su6c_wmc_wm_1 -> "G_su4_su6c_wmc_wm_1"
      | G_su5_su1c_wmc_wm_1 -> "G_su5_su1c_wmc_wm_1"
      | G_su5_su2c_wmc_wm_1 -> "G_su5_su2c_wmc_wm_1"
      | G_su5_su3c_wmc_wm_1 -> "G_su5_su3c_wmc_wm_1"
      | G_su5_su4c_wmc_wm_1 -> "G_su5_su4c_wmc_wm_1"
      | G_su5_su5c_wmc_wm_1 -> "G_su5_su5c_wmc_wm_1"
      | G_su5_su6c_wmc_wm_1 -> "G_su5_su6c_wmc_wm_1"
      | G_su6_su1c_wmc_wm_1 -> "G_su6_su1c_wmc_wm_1"
      | G_su6_su2c_wmc_wm_1 -> "G_su6_su2c_wmc_wm_1"
      | G_su6_su3c_wmc_wm_1 -> "G_su6_su3c_wmc_wm_1"
      | G_su6_su4c_wmc_wm_1 -> "G_su6_su4c_wmc_wm_1"
      | G_su6_su5c_wmc_wm_1 -> "G_su6_su5c_wmc_wm_1"
      | G_su6_su6c_wmc_wm_1 -> "G_su6_su6c_wmc_wm_1"
      | G_su1_su1c_z_1_z_1 -> "G_su1_su1c_z_1_z_1"
      | G_su1_su2c_z_1_z_1 -> "G_su1_su2c_z_1_z_1"
      | G_su1_su3c_z_1_z_1 -> "G_su1_su3c_z_1_z_1"
      | G_su1_su4c_z_1_z_1 -> "G_su1_su4c_z_1_z_1"
      | G_su1_su5c_z_1_z_1 -> "G_su1_su5c_z_1_z_1"
      | G_su1_su6c_z_1_z_1 -> "G_su1_su6c_z_1_z_1"
      | G_su2_su1c_z_1_z_1 -> "G_su2_su1c_z_1_z_1"
      | G_su2_su2c_z_1_z_1 -> "G_su2_su2c_z_1_z_1"
      | G_su2_su3c_z_1_z_1 -> "G_su2_su3c_z_1_z_1"
      | G_su2_su4c_z_1_z_1 -> "G_su2_su4c_z_1_z_1"
      | G_su2_su5c_z_1_z_1 -> "G_su2_su5c_z_1_z_1"
      | G_su2_su6c_z_1_z_1 -> "G_su2_su6c_z_1_z_1"
      | G_su3_su1c_z_1_z_1 -> "G_su3_su1c_z_1_z_1"
      | G_su3_su2c_z_1_z_1 -> "G_su3_su2c_z_1_z_1"
      | G_su3_su3c_z_1_z_1 -> "G_su3_su3c_z_1_z_1"
      | G_su3_su4c_z_1_z_1 -> "G_su3_su4c_z_1_z_1"
      | G_su3_su5c_z_1_z_1 -> "G_su3_su5c_z_1_z_1"
      | G_su3_su6c_z_1_z_1 -> "G_su3_su6c_z_1_z_1"
      | G_su4_su1c_z_1_z_1 -> "G_su4_su1c_z_1_z_1"
      | G_su4_su2c_z_1_z_1 -> "G_su4_su2c_z_1_z_1"
      | G_su4_su3c_z_1_z_1 -> "G_su4_su3c_z_1_z_1"
      | G_su4_su4c_z_1_z_1 -> "G_su4_su4c_z_1_z_1"
      | G_su4_su5c_z_1_z_1 -> "G_su4_su5c_z_1_z_1"
      | G_su4_su6c_z_1_z_1 -> "G_su4_su6c_z_1_z_1"
      | G_su5_su1c_z_1_z_1 -> "G_su5_su1c_z_1_z_1"
      | G_su5_su2c_z_1_z_1 -> "G_su5_su2c_z_1_z_1"
      | G_su5_su3c_z_1_z_1 -> "G_su5_su3c_z_1_z_1"
      | G_su5_su4c_z_1_z_1 -> "G_su5_su4c_z_1_z_1"
      | G_su5_su5c_z_1_z_1 -> "G_su5_su5c_z_1_z_1"
      | G_su5_su6c_z_1_z_1 -> "G_su5_su6c_z_1_z_1"
      | G_su6_su1c_z_1_z_1 -> "G_su6_su1c_z_1_z_1"
      | G_su6_su2c_z_1_z_1 -> "G_su6_su2c_z_1_z_1"
      | G_su6_su3c_z_1_z_1 -> "G_su6_su3c_z_1_z_1"
      | G_su6_su4c_z_1_z_1 -> "G_su6_su4c_z_1_z_1"
      | G_su6_su5c_z_1_z_1 -> "G_su6_su5c_z_1_z_1"
      | G_su6_su6c_z_1_z_1 -> "G_su6_su6c_z_1_z_1"
      | G_sv1_se1c_a_1_wm_1 -> "G_sv1_se1c_a_1_wm_1"
      | G_sv1_se2c_a_1_wm_1 -> "G_sv1_se2c_a_1_wm_1"
      | G_sv1_se3c_a_1_wm_1 -> "G_sv1_se3c_a_1_wm_1"
      | G_sv1_se4c_a_1_wm_1 -> "G_sv1_se4c_a_1_wm_1"
      | G_sv1_se5c_a_1_wm_1 -> "G_sv1_se5c_a_1_wm_1"
      | G_sv1_se6c_a_1_wm_1 -> "G_sv1_se6c_a_1_wm_1"
      | G_sv2_se1c_a_1_wm_1 -> "G_sv2_se1c_a_1_wm_1"
      | G_sv2_se2c_a_1_wm_1 -> "G_sv2_se2c_a_1_wm_1"
      | G_sv2_se3c_a_1_wm_1 -> "G_sv2_se3c_a_1_wm_1"
      | G_sv2_se4c_a_1_wm_1 -> "G_sv2_se4c_a_1_wm_1"
      | G_sv2_se5c_a_1_wm_1 -> "G_sv2_se5c_a_1_wm_1"
      | G_sv2_se6c_a_1_wm_1 -> "G_sv2_se6c_a_1_wm_1"
      | G_sv3_se1c_a_1_wm_1 -> "G_sv3_se1c_a_1_wm_1"
      | G_sv3_se2c_a_1_wm_1 -> "G_sv3_se2c_a_1_wm_1"
      | G_sv3_se3c_a_1_wm_1 -> "G_sv3_se3c_a_1_wm_1"
      | G_sv3_se4c_a_1_wm_1 -> "G_sv3_se4c_a_1_wm_1"
      | G_sv3_se5c_a_1_wm_1 -> "G_sv3_se5c_a_1_wm_1"
      | G_sv3_se6c_a_1_wm_1 -> "G_sv3_se6c_a_1_wm_1"
      | G_sv1_se1c_wm_1_z_1 -> "G_sv1_se1c_wm_1_z_1"
      | G_sv1_se2c_wm_1_z_1 -> "G_sv1_se2c_wm_1_z_1"
      | G_sv1_se3c_wm_1_z_1 -> "G_sv1_se3c_wm_1_z_1"
      | G_sv1_se4c_wm_1_z_1 -> "G_sv1_se4c_wm_1_z_1"
      | G_sv1_se5c_wm_1_z_1 -> "G_sv1_se5c_wm_1_z_1"
      | G_sv1_se6c_wm_1_z_1 -> "G_sv1_se6c_wm_1_z_1"
      | G_sv2_se1c_wm_1_z_1 -> "G_sv2_se1c_wm_1_z_1"
      | G_sv2_se2c_wm_1_z_1 -> "G_sv2_se2c_wm_1_z_1"
      | G_sv2_se3c_wm_1_z_1 -> "G_sv2_se3c_wm_1_z_1"
      | G_sv2_se4c_wm_1_z_1 -> "G_sv2_se4c_wm_1_z_1"
      | G_sv2_se5c_wm_1_z_1 -> "G_sv2_se5c_wm_1_z_1"
      | G_sv2_se6c_wm_1_z_1 -> "G_sv2_se6c_wm_1_z_1"
      | G_sv3_se1c_wm_1_z_1 -> "G_sv3_se1c_wm_1_z_1"
      | G_sv3_se2c_wm_1_z_1 -> "G_sv3_se2c_wm_1_z_1"
      | G_sv3_se3c_wm_1_z_1 -> "G_sv3_se3c_wm_1_z_1"
      | G_sv3_se4c_wm_1_z_1 -> "G_sv3_se4c_wm_1_z_1"
      | G_sv3_se5c_wm_1_z_1 -> "G_sv3_se5c_wm_1_z_1"
      | G_sv3_se6c_wm_1_z_1 -> "G_sv3_se6c_wm_1_z_1"
      | G_sv1_sv1c_wmc_wm_1 -> "G_sv1_sv1c_wmc_wm_1"
      | G_sv1_sv1c_z_1_z_1 -> "G_sv1_sv1c_z_1_z_1" | G_z_1_ah2_h1 -> "G_z_1_ah2_h1"
      | G_z_1_ah2_h2 -> "G_z_1_ah2_h2" | G_wmc_ah2_hm2 -> "G_wmc_ah2_hm2"
      | G_wmc_h1_hm2 -> "G_wmc_h1_hm2" | G_wmc_h2_hm2 -> "G_wmc_h2_hm2"
      | G_wm_1_h1_hm2c -> "G_wm_1_h1_hm2c" | G_wm_1_h2_hm2c -> "G_wm_1_h2_hm2c"
      | G_a_1_hm2_hm2c -> "G_a_1_hm2_hm2c" | G_z_1_hm2_hm2c -> "G_z_1_hm2_hm2c"
      | G_g_1_sd1_sd1c -> "G_g_1_sd1_sd1c" | G_a_1_sd1_sd1c -> "G_a_1_sd1_sd1c"
      | G_a_1_sd1_sd2c -> "G_a_1_sd1_sd2c" | G_a_1_sd1_sd3c -> "G_a_1_sd1_sd3c"
      | G_a_1_sd1_sd4c -> "G_a_1_sd1_sd4c" | G_a_1_sd1_sd5c -> "G_a_1_sd1_sd5c"
      | G_a_1_sd1_sd6c -> "G_a_1_sd1_sd6c" | G_a_1_sd2_sd1c -> "G_a_1_sd2_sd1c"
      | G_a_1_sd2_sd2c -> "G_a_1_sd2_sd2c" | G_a_1_sd2_sd3c -> "G_a_1_sd2_sd3c"
      | G_a_1_sd2_sd4c -> "G_a_1_sd2_sd4c" | G_a_1_sd2_sd5c -> "G_a_1_sd2_sd5c"
      | G_a_1_sd2_sd6c -> "G_a_1_sd2_sd6c" | G_a_1_sd3_sd1c -> "G_a_1_sd3_sd1c"
      | G_a_1_sd3_sd2c -> "G_a_1_sd3_sd2c" | G_a_1_sd3_sd3c -> "G_a_1_sd3_sd3c"
      | G_a_1_sd3_sd4c -> "G_a_1_sd3_sd4c" | G_a_1_sd3_sd5c -> "G_a_1_sd3_sd5c"
      | G_a_1_sd3_sd6c -> "G_a_1_sd3_sd6c" | G_a_1_sd4_sd1c -> "G_a_1_sd4_sd1c"
      | G_a_1_sd4_sd2c -> "G_a_1_sd4_sd2c" | G_a_1_sd4_sd3c -> "G_a_1_sd4_sd3c"
      | G_a_1_sd4_sd4c -> "G_a_1_sd4_sd4c" | G_a_1_sd4_sd5c -> "G_a_1_sd4_sd5c"
      | G_a_1_sd4_sd6c -> "G_a_1_sd4_sd6c" | G_a_1_sd5_sd1c -> "G_a_1_sd5_sd1c"
      | G_a_1_sd5_sd2c -> "G_a_1_sd5_sd2c" | G_a_1_sd5_sd3c -> "G_a_1_sd5_sd3c"
      | G_a_1_sd5_sd4c -> "G_a_1_sd5_sd4c" | G_a_1_sd5_sd5c -> "G_a_1_sd5_sd5c"
      | G_a_1_sd5_sd6c -> "G_a_1_sd5_sd6c" | G_a_1_sd6_sd1c -> "G_a_1_sd6_sd1c"
      | G_a_1_sd6_sd2c -> "G_a_1_sd6_sd2c" | G_a_1_sd6_sd3c -> "G_a_1_sd6_sd3c"
      | G_a_1_sd6_sd4c -> "G_a_1_sd6_sd4c" | G_a_1_sd6_sd5c -> "G_a_1_sd6_sd5c"
      | G_a_1_sd6_sd6c -> "G_a_1_sd6_sd6c" | G_z_1_sd1_sd1c -> "G_z_1_sd1_sd1c"
      | G_z_1_sd1_sd2c -> "G_z_1_sd1_sd2c" | G_z_1_sd1_sd3c -> "G_z_1_sd1_sd3c"
      | G_z_1_sd1_sd4c -> "G_z_1_sd1_sd4c" | G_z_1_sd1_sd5c -> "G_z_1_sd1_sd5c"
      | G_z_1_sd1_sd6c -> "G_z_1_sd1_sd6c" | G_z_1_sd2_sd1c -> "G_z_1_sd2_sd1c"
      | G_z_1_sd2_sd2c -> "G_z_1_sd2_sd2c" | G_z_1_sd2_sd3c -> "G_z_1_sd2_sd3c"
      | G_z_1_sd2_sd4c -> "G_z_1_sd2_sd4c" | G_z_1_sd2_sd5c -> "G_z_1_sd2_sd5c"
      | G_z_1_sd2_sd6c -> "G_z_1_sd2_sd6c" | G_z_1_sd3_sd1c -> "G_z_1_sd3_sd1c"
      | G_z_1_sd3_sd2c -> "G_z_1_sd3_sd2c" | G_z_1_sd3_sd3c -> "G_z_1_sd3_sd3c"
      | G_z_1_sd3_sd4c -> "G_z_1_sd3_sd4c" | G_z_1_sd3_sd5c -> "G_z_1_sd3_sd5c"
      | G_z_1_sd3_sd6c -> "G_z_1_sd3_sd6c" | G_z_1_sd4_sd1c -> "G_z_1_sd4_sd1c"
      | G_z_1_sd4_sd2c -> "G_z_1_sd4_sd2c" | G_z_1_sd4_sd3c -> "G_z_1_sd4_sd3c"
      | G_z_1_sd4_sd4c -> "G_z_1_sd4_sd4c" | G_z_1_sd4_sd5c -> "G_z_1_sd4_sd5c"
      | G_z_1_sd4_sd6c -> "G_z_1_sd4_sd6c" | G_z_1_sd5_sd1c -> "G_z_1_sd5_sd1c"
      | G_z_1_sd5_sd2c -> "G_z_1_sd5_sd2c" | G_z_1_sd5_sd3c -> "G_z_1_sd5_sd3c"
      | G_z_1_sd5_sd4c -> "G_z_1_sd5_sd4c" | G_z_1_sd5_sd5c -> "G_z_1_sd5_sd5c"
      | G_z_1_sd5_sd6c -> "G_z_1_sd5_sd6c" | G_z_1_sd6_sd1c -> "G_z_1_sd6_sd1c"
      | G_z_1_sd6_sd2c -> "G_z_1_sd6_sd2c" | G_z_1_sd6_sd3c -> "G_z_1_sd6_sd3c"
      | G_z_1_sd6_sd4c -> "G_z_1_sd6_sd4c" | G_z_1_sd6_sd5c -> "G_z_1_sd6_sd5c"
      | G_z_1_sd6_sd6c -> "G_z_1_sd6_sd6c" | G_wmc_sd1_su1c -> "G_wmc_sd1_su1c"
      | G_wmc_sd1_su2c -> "G_wmc_sd1_su2c" | G_wmc_sd1_su3c -> "G_wmc_sd1_su3c"
      | G_wmc_sd1_su4c -> "G_wmc_sd1_su4c" | G_wmc_sd1_su5c -> "G_wmc_sd1_su5c"
      | G_wmc_sd1_su6c -> "G_wmc_sd1_su6c" | G_wmc_sd2_su1c -> "G_wmc_sd2_su1c"
      | G_wmc_sd2_su2c -> "G_wmc_sd2_su2c" | G_wmc_sd2_su3c -> "G_wmc_sd2_su3c"
      | G_wmc_sd2_su4c -> "G_wmc_sd2_su4c" | G_wmc_sd2_su5c -> "G_wmc_sd2_su5c"
      | G_wmc_sd2_su6c -> "G_wmc_sd2_su6c" | G_wmc_sd3_su1c -> "G_wmc_sd3_su1c"
      | G_wmc_sd3_su2c -> "G_wmc_sd3_su2c" | G_wmc_sd3_su3c -> "G_wmc_sd3_su3c"
      | G_wmc_sd3_su4c -> "G_wmc_sd3_su4c" | G_wmc_sd3_su5c -> "G_wmc_sd3_su5c"
      | G_wmc_sd3_su6c -> "G_wmc_sd3_su6c" | G_wmc_sd4_su1c -> "G_wmc_sd4_su1c"
      | G_wmc_sd4_su2c -> "G_wmc_sd4_su2c" | G_wmc_sd4_su3c -> "G_wmc_sd4_su3c"
      | G_wmc_sd4_su4c -> "G_wmc_sd4_su4c" | G_wmc_sd4_su5c -> "G_wmc_sd4_su5c"
      | G_wmc_sd4_su6c -> "G_wmc_sd4_su6c" | G_wmc_sd5_su1c -> "G_wmc_sd5_su1c"
      | G_wmc_sd5_su2c -> "G_wmc_sd5_su2c" | G_wmc_sd5_su3c -> "G_wmc_sd5_su3c"
      | G_wmc_sd5_su4c -> "G_wmc_sd5_su4c" | G_wmc_sd5_su5c -> "G_wmc_sd5_su5c"
      | G_wmc_sd5_su6c -> "G_wmc_sd5_su6c" | G_wmc_sd6_su1c -> "G_wmc_sd6_su1c"
      | G_wmc_sd6_su2c -> "G_wmc_sd6_su2c" | G_wmc_sd6_su3c -> "G_wmc_sd6_su3c"
      | G_wmc_sd6_su4c -> "G_wmc_sd6_su4c" | G_wmc_sd6_su5c -> "G_wmc_sd6_su5c"
      | G_wmc_sd6_su6c -> "G_wmc_sd6_su6c" | G_a_1_se1_se1c -> "G_a_1_se1_se1c"
      | G_a_1_se1_se2c -> "G_a_1_se1_se2c" | G_a_1_se1_se3c -> "G_a_1_se1_se3c"
      | G_a_1_se1_se4c -> "G_a_1_se1_se4c" | G_a_1_se1_se5c -> "G_a_1_se1_se5c"
      | G_a_1_se1_se6c -> "G_a_1_se1_se6c" | G_a_1_se2_se1c -> "G_a_1_se2_se1c"
      | G_a_1_se2_se2c -> "G_a_1_se2_se2c" | G_a_1_se2_se3c -> "G_a_1_se2_se3c"
      | G_a_1_se2_se4c -> "G_a_1_se2_se4c" | G_a_1_se2_se5c -> "G_a_1_se2_se5c"
      | G_a_1_se2_se6c -> "G_a_1_se2_se6c" | G_a_1_se3_se1c -> "G_a_1_se3_se1c"
      | G_a_1_se3_se2c -> "G_a_1_se3_se2c" | G_a_1_se3_se3c -> "G_a_1_se3_se3c"
      | G_a_1_se3_se4c -> "G_a_1_se3_se4c" | G_a_1_se3_se5c -> "G_a_1_se3_se5c"
      | G_a_1_se3_se6c -> "G_a_1_se3_se6c" | G_a_1_se4_se1c -> "G_a_1_se4_se1c"
      | G_a_1_se4_se2c -> "G_a_1_se4_se2c" | G_a_1_se4_se3c -> "G_a_1_se4_se3c"
      | G_a_1_se4_se4c -> "G_a_1_se4_se4c" | G_a_1_se4_se5c -> "G_a_1_se4_se5c"
      | G_a_1_se4_se6c -> "G_a_1_se4_se6c" | G_a_1_se5_se1c -> "G_a_1_se5_se1c"
      | G_a_1_se5_se2c -> "G_a_1_se5_se2c" | G_a_1_se5_se3c -> "G_a_1_se5_se3c"
      | G_a_1_se5_se4c -> "G_a_1_se5_se4c" | G_a_1_se5_se5c -> "G_a_1_se5_se5c"
      | G_a_1_se5_se6c -> "G_a_1_se5_se6c" | G_a_1_se6_se1c -> "G_a_1_se6_se1c"
      | G_a_1_se6_se2c -> "G_a_1_se6_se2c" | G_a_1_se6_se3c -> "G_a_1_se6_se3c"
      | G_a_1_se6_se4c -> "G_a_1_se6_se4c" | G_a_1_se6_se5c -> "G_a_1_se6_se5c"
      | G_a_1_se6_se6c -> "G_a_1_se6_se6c" | G_z_1_se1_se1c -> "G_z_1_se1_se1c"
      | G_z_1_se1_se2c -> "G_z_1_se1_se2c" | G_z_1_se1_se3c -> "G_z_1_se1_se3c"
      | G_z_1_se1_se4c -> "G_z_1_se1_se4c" | G_z_1_se1_se5c -> "G_z_1_se1_se5c"
      | G_z_1_se1_se6c -> "G_z_1_se1_se6c" | G_z_1_se2_se1c -> "G_z_1_se2_se1c"
      | G_z_1_se2_se2c -> "G_z_1_se2_se2c" | G_z_1_se2_se3c -> "G_z_1_se2_se3c"
      | G_z_1_se2_se4c -> "G_z_1_se2_se4c" | G_z_1_se2_se5c -> "G_z_1_se2_se5c"
      | G_z_1_se2_se6c -> "G_z_1_se2_se6c" | G_z_1_se3_se1c -> "G_z_1_se3_se1c"
      | G_z_1_se3_se2c -> "G_z_1_se3_se2c" | G_z_1_se3_se3c -> "G_z_1_se3_se3c"
      | G_z_1_se3_se4c -> "G_z_1_se3_se4c" | G_z_1_se3_se5c -> "G_z_1_se3_se5c"
      | G_z_1_se3_se6c -> "G_z_1_se3_se6c" | G_z_1_se4_se1c -> "G_z_1_se4_se1c"
      | G_z_1_se4_se2c -> "G_z_1_se4_se2c" | G_z_1_se4_se3c -> "G_z_1_se4_se3c"
      | G_z_1_se4_se4c -> "G_z_1_se4_se4c" | G_z_1_se4_se5c -> "G_z_1_se4_se5c"
      | G_z_1_se4_se6c -> "G_z_1_se4_se6c" | G_z_1_se5_se1c -> "G_z_1_se5_se1c"
      | G_z_1_se5_se2c -> "G_z_1_se5_se2c" | G_z_1_se5_se3c -> "G_z_1_se5_se3c"
      | G_z_1_se5_se4c -> "G_z_1_se5_se4c" | G_z_1_se5_se5c -> "G_z_1_se5_se5c"
      | G_z_1_se5_se6c -> "G_z_1_se5_se6c" | G_z_1_se6_se1c -> "G_z_1_se6_se1c"
      | G_z_1_se6_se2c -> "G_z_1_se6_se2c" | G_z_1_se6_se3c -> "G_z_1_se6_se3c"
      | G_z_1_se6_se4c -> "G_z_1_se6_se4c" | G_z_1_se6_se5c -> "G_z_1_se6_se5c"
      | G_z_1_se6_se6c -> "G_z_1_se6_se6c" | G_wmc_se1_sv1c -> "G_wmc_se1_sv1c"
      | G_wmc_se1_sv2c -> "G_wmc_se1_sv2c" | G_wmc_se1_sv3c -> "G_wmc_se1_sv3c"
      | G_wmc_se2_sv1c -> "G_wmc_se2_sv1c" | G_wmc_se2_sv2c -> "G_wmc_se2_sv2c"
      | G_wmc_se2_sv3c -> "G_wmc_se2_sv3c" | G_wmc_se3_sv1c -> "G_wmc_se3_sv1c"
      | G_wmc_se3_sv2c -> "G_wmc_se3_sv2c" | G_wmc_se3_sv3c -> "G_wmc_se3_sv3c"
      | G_wmc_se4_sv1c -> "G_wmc_se4_sv1c" | G_wmc_se4_sv2c -> "G_wmc_se4_sv2c"
      | G_wmc_se4_sv3c -> "G_wmc_se4_sv3c" | G_wmc_se5_sv1c -> "G_wmc_se5_sv1c"
      | G_wmc_se5_sv2c -> "G_wmc_se5_sv2c" | G_wmc_se5_sv3c -> "G_wmc_se5_sv3c"
      | G_wmc_se6_sv1c -> "G_wmc_se6_sv1c" | G_wmc_se6_sv2c -> "G_wmc_se6_sv2c"
      | G_wmc_se6_sv3c -> "G_wmc_se6_sv3c" | G_a_1_su1_su1c -> "G_a_1_su1_su1c"
      | G_a_1_su1_su2c -> "G_a_1_su1_su2c" | G_a_1_su1_su3c -> "G_a_1_su1_su3c"
      | G_a_1_su1_su4c -> "G_a_1_su1_su4c" | G_a_1_su1_su5c -> "G_a_1_su1_su5c"
      | G_a_1_su1_su6c -> "G_a_1_su1_su6c" | G_a_1_su2_su1c -> "G_a_1_su2_su1c"
      | G_a_1_su2_su2c -> "G_a_1_su2_su2c" | G_a_1_su2_su3c -> "G_a_1_su2_su3c"
      | G_a_1_su2_su4c -> "G_a_1_su2_su4c" | G_a_1_su2_su5c -> "G_a_1_su2_su5c"
      | G_a_1_su2_su6c -> "G_a_1_su2_su6c" | G_a_1_su3_su1c -> "G_a_1_su3_su1c"
      | G_a_1_su3_su2c -> "G_a_1_su3_su2c" | G_a_1_su3_su3c -> "G_a_1_su3_su3c"
      | G_a_1_su3_su4c -> "G_a_1_su3_su4c" | G_a_1_su3_su5c -> "G_a_1_su3_su5c"
      | G_a_1_su3_su6c -> "G_a_1_su3_su6c" | G_a_1_su4_su1c -> "G_a_1_su4_su1c"
      | G_a_1_su4_su2c -> "G_a_1_su4_su2c" | G_a_1_su4_su3c -> "G_a_1_su4_su3c"
      | G_a_1_su4_su4c -> "G_a_1_su4_su4c" | G_a_1_su4_su5c -> "G_a_1_su4_su5c"
      | G_a_1_su4_su6c -> "G_a_1_su4_su6c" | G_a_1_su5_su1c -> "G_a_1_su5_su1c"
      | G_a_1_su5_su2c -> "G_a_1_su5_su2c" | G_a_1_su5_su3c -> "G_a_1_su5_su3c"
      | G_a_1_su5_su4c -> "G_a_1_su5_su4c" | G_a_1_su5_su5c -> "G_a_1_su5_su5c"
      | G_a_1_su5_su6c -> "G_a_1_su5_su6c" | G_a_1_su6_su1c -> "G_a_1_su6_su1c"
      | G_a_1_su6_su2c -> "G_a_1_su6_su2c" | G_a_1_su6_su3c -> "G_a_1_su6_su3c"
      | G_a_1_su6_su4c -> "G_a_1_su6_su4c" | G_a_1_su6_su5c -> "G_a_1_su6_su5c"
      | G_a_1_su6_su6c -> "G_a_1_su6_su6c" | G_wm_1_su1_sd1c -> "G_wm_1_su1_sd1c"
      | G_wm_1_su1_sd2c -> "G_wm_1_su1_sd2c" | G_wm_1_su1_sd3c -> "G_wm_1_su1_sd3c"
      | G_wm_1_su1_sd4c -> "G_wm_1_su1_sd4c" | G_wm_1_su1_sd5c -> "G_wm_1_su1_sd5c"
      | G_wm_1_su1_sd6c -> "G_wm_1_su1_sd6c" | G_wm_1_su2_sd1c -> "G_wm_1_su2_sd1c"
      | G_wm_1_su2_sd2c -> "G_wm_1_su2_sd2c" | G_wm_1_su2_sd3c -> "G_wm_1_su2_sd3c"
      | G_wm_1_su2_sd4c -> "G_wm_1_su2_sd4c" | G_wm_1_su2_sd5c -> "G_wm_1_su2_sd5c"
      | G_wm_1_su2_sd6c -> "G_wm_1_su2_sd6c" | G_wm_1_su3_sd1c -> "G_wm_1_su3_sd1c"
      | G_wm_1_su3_sd2c -> "G_wm_1_su3_sd2c" | G_wm_1_su3_sd3c -> "G_wm_1_su3_sd3c"
      | G_wm_1_su3_sd4c -> "G_wm_1_su3_sd4c" | G_wm_1_su3_sd5c -> "G_wm_1_su3_sd5c"
      | G_wm_1_su3_sd6c -> "G_wm_1_su3_sd6c" | G_wm_1_su4_sd1c -> "G_wm_1_su4_sd1c"
      | G_wm_1_su4_sd2c -> "G_wm_1_su4_sd2c" | G_wm_1_su4_sd3c -> "G_wm_1_su4_sd3c"
      | G_wm_1_su4_sd4c -> "G_wm_1_su4_sd4c" | G_wm_1_su4_sd5c -> "G_wm_1_su4_sd5c"
      | G_wm_1_su4_sd6c -> "G_wm_1_su4_sd6c" | G_wm_1_su5_sd1c -> "G_wm_1_su5_sd1c"
      | G_wm_1_su5_sd2c -> "G_wm_1_su5_sd2c" | G_wm_1_su5_sd3c -> "G_wm_1_su5_sd3c"
      | G_wm_1_su5_sd4c -> "G_wm_1_su5_sd4c" | G_wm_1_su5_sd5c -> "G_wm_1_su5_sd5c"
      | G_wm_1_su5_sd6c -> "G_wm_1_su5_sd6c" | G_wm_1_su6_sd1c -> "G_wm_1_su6_sd1c"
      | G_wm_1_su6_sd2c -> "G_wm_1_su6_sd2c" | G_wm_1_su6_sd3c -> "G_wm_1_su6_sd3c"
      | G_wm_1_su6_sd4c -> "G_wm_1_su6_sd4c" | G_wm_1_su6_sd5c -> "G_wm_1_su6_sd5c"
      | G_wm_1_su6_sd6c -> "G_wm_1_su6_sd6c" | G_z_1_su1_su1c -> "G_z_1_su1_su1c"
      | G_z_1_su1_su2c -> "G_z_1_su1_su2c" | G_z_1_su1_su3c -> "G_z_1_su1_su3c"
      | G_z_1_su1_su4c -> "G_z_1_su1_su4c" | G_z_1_su1_su5c -> "G_z_1_su1_su5c"
      | G_z_1_su1_su6c -> "G_z_1_su1_su6c" | G_z_1_su2_su1c -> "G_z_1_su2_su1c"
      | G_z_1_su2_su2c -> "G_z_1_su2_su2c" | G_z_1_su2_su3c -> "G_z_1_su2_su3c"
      | G_z_1_su2_su4c -> "G_z_1_su2_su4c" | G_z_1_su2_su5c -> "G_z_1_su2_su5c"
      | G_z_1_su2_su6c -> "G_z_1_su2_su6c" | G_z_1_su3_su1c -> "G_z_1_su3_su1c"
      | G_z_1_su3_su2c -> "G_z_1_su3_su2c" | G_z_1_su3_su3c -> "G_z_1_su3_su3c"
      | G_z_1_su3_su4c -> "G_z_1_su3_su4c" | G_z_1_su3_su5c -> "G_z_1_su3_su5c"
      | G_z_1_su3_su6c -> "G_z_1_su3_su6c" | G_z_1_su4_su1c -> "G_z_1_su4_su1c"
      | G_z_1_su4_su2c -> "G_z_1_su4_su2c" | G_z_1_su4_su3c -> "G_z_1_su4_su3c"
      | G_z_1_su4_su4c -> "G_z_1_su4_su4c" | G_z_1_su4_su5c -> "G_z_1_su4_su5c"
      | G_z_1_su4_su6c -> "G_z_1_su4_su6c" | G_z_1_su5_su1c -> "G_z_1_su5_su1c"
      | G_z_1_su5_su2c -> "G_z_1_su5_su2c" | G_z_1_su5_su3c -> "G_z_1_su5_su3c"
      | G_z_1_su5_su4c -> "G_z_1_su5_su4c" | G_z_1_su5_su5c -> "G_z_1_su5_su5c"
      | G_z_1_su5_su6c -> "G_z_1_su5_su6c" | G_z_1_su6_su1c -> "G_z_1_su6_su1c"
      | G_z_1_su6_su2c -> "G_z_1_su6_su2c" | G_z_1_su6_su3c -> "G_z_1_su6_su3c"
      | G_z_1_su6_su4c -> "G_z_1_su6_su4c" | G_z_1_su6_su5c -> "G_z_1_su6_su5c"
      | G_z_1_su6_su6c -> "G_z_1_su6_su6c" | G_wm_1_sv1_se1c -> "G_wm_1_sv1_se1c"
      | G_wm_1_sv1_se2c -> "G_wm_1_sv1_se2c" | G_wm_1_sv1_se3c -> "G_wm_1_sv1_se3c"
      | G_wm_1_sv1_se4c -> "G_wm_1_sv1_se4c" | G_wm_1_sv1_se5c -> "G_wm_1_sv1_se5c"
      | G_wm_1_sv1_se6c -> "G_wm_1_sv1_se6c" | G_wm_1_sv2_se1c -> "G_wm_1_sv2_se1c"
      | G_wm_1_sv2_se2c -> "G_wm_1_sv2_se2c" | G_wm_1_sv2_se3c -> "G_wm_1_sv2_se3c"
      | G_wm_1_sv2_se4c -> "G_wm_1_sv2_se4c" | G_wm_1_sv2_se5c -> "G_wm_1_sv2_se5c"
      | G_wm_1_sv2_se6c -> "G_wm_1_sv2_se6c" | G_wm_1_sv3_se1c -> "G_wm_1_sv3_se1c"
      | G_wm_1_sv3_se2c -> "G_wm_1_sv3_se2c" | G_wm_1_sv3_se3c -> "G_wm_1_sv3_se3c"
      | G_wm_1_sv3_se4c -> "G_wm_1_sv3_se4c" | G_wm_1_sv3_se5c -> "G_wm_1_sv3_se5c"
      | G_wm_1_sv3_se6c -> "G_wm_1_sv3_se6c" | G_z_1_sv1_sv1c -> "G_z_1_sv1_sv1c"
      | G_h1_wmc_wm_1 -> "G_h1_wmc_wm_1" | G_h2_wmc_wm_1 -> "G_h2_wmc_wm_1"
      | G_h1_z_1_z_1 -> "G_h1_z_1_z_1" | G_h2_z_1_z_1 -> "G_h2_z_1_z_1"
      | G_hm2_wmc_a_1 -> "G_hm2_wmc_a_1" | G_hm2_wmc_z_1 -> "G_hm2_wmc_z_1"
      | G_c1bar_ah2_c1 -> "G_c1bar_ah2_c1" | G_c1bar_ah2_c2 -> "G_c1bar_ah2_c2"
      | G_c2bar_ah2_c1 -> "G_c2bar_ah2_c1" | G_c2bar_ah2_c2 -> "G_c2bar_ah2_c2"
      | G_n1_ah2_n1 -> "G_n1_ah2_n1" | G_n1_ah2_n2 -> "G_n1_ah2_n2"
      | G_n1_ah2_n3 -> "G_n1_ah2_n3" | G_n1_ah2_n4 -> "G_n1_ah2_n4"
      | G_n2_ah2_n2 -> "G_n2_ah2_n2" | G_n2_ah2_n3 -> "G_n2_ah2_n3"
      | G_n2_ah2_n4 -> "G_n2_ah2_n4" | G_n3_ah2_n3 -> "G_n3_ah2_n3"
      | G_n3_ah2_n4 -> "G_n3_ah2_n4" | G_n4_ah2_n4 -> "G_n4_ah2_n4"
      | G_d1bar_ah2_d1 -> "G_d1bar_ah2_d1" | G_d1bar_ah2_d2 -> "G_d1bar_ah2_d2"
      | G_d1bar_ah2_d3 -> "G_d1bar_ah2_d3" | G_d2bar_ah2_d1 -> "G_d2bar_ah2_d1"
      | G_d2bar_ah2_d2 -> "G_d2bar_ah2_d2" | G_d2bar_ah2_d3 -> "G_d2bar_ah2_d3"
      | G_d3bar_ah2_d1 -> "G_d3bar_ah2_d1" | G_d3bar_ah2_d2 -> "G_d3bar_ah2_d2"
      | G_d3bar_ah2_d3 -> "G_d3bar_ah2_d3" | G_e1bar_ah2_e1 -> "G_e1bar_ah2_e1"
      | G_e1bar_ah2_e2 -> "G_e1bar_ah2_e2" | G_e1bar_ah2_e3 -> "G_e1bar_ah2_e3"
      | G_e2bar_ah2_e1 -> "G_e2bar_ah2_e1" | G_e2bar_ah2_e2 -> "G_e2bar_ah2_e2"
      | G_e2bar_ah2_e3 -> "G_e2bar_ah2_e3" | G_e3bar_ah2_e1 -> "G_e3bar_ah2_e1"
      | G_e3bar_ah2_e2 -> "G_e3bar_ah2_e2" | G_e3bar_ah2_e3 -> "G_e3bar_ah2_e3"
      | G_u1bar_ah2_u1 -> "G_u1bar_ah2_u1" | G_u1bar_ah2_u2 -> "G_u1bar_ah2_u2"
      | G_u1bar_ah2_u3 -> "G_u1bar_ah2_u3" | G_u2bar_ah2_u1 -> "G_u2bar_ah2_u1"
      | G_u2bar_ah2_u2 -> "G_u2bar_ah2_u2" | G_u2bar_ah2_u3 -> "G_u2bar_ah2_u3"
      | G_u3bar_ah2_u1 -> "G_u3bar_ah2_u1" | G_u3bar_ah2_u2 -> "G_u3bar_ah2_u2"
      | G_u3bar_ah2_u3 -> "G_u3bar_ah2_u3" | G_n1_hm2c_c1 -> "G_n1_hm2c_c1"
      | G_n1_hm2c_c2 -> "G_n1_hm2c_c2" | G_n2_hm2c_c1 -> "G_n2_hm2c_c1"
      | G_n2_hm2c_c2 -> "G_n2_hm2c_c2" | G_n3_hm2c_c1 -> "G_n3_hm2c_c1"
      | G_n3_hm2c_c2 -> "G_n3_hm2c_c2" | G_n4_hm2c_c1 -> "G_n4_hm2c_c1"
      | G_n4_hm2c_c2 -> "G_n4_hm2c_c2" | G_c1_sd1c_u1 -> "G_c1_sd1c_u1"
      | G_c1_sd2c_u1 -> "G_c1_sd2c_u1" | G_c1_sd3c_u1 -> "G_c1_sd3c_u1"
      | G_c1_sd4c_u1 -> "G_c1_sd4c_u1" | G_c1_sd5c_u1 -> "G_c1_sd5c_u1"
      | G_c1_sd6c_u1 -> "G_c1_sd6c_u1" | G_c1_sd1c_u2 -> "G_c1_sd1c_u2"
      | G_c1_sd2c_u2 -> "G_c1_sd2c_u2" | G_c1_sd3c_u2 -> "G_c1_sd3c_u2"
      | G_c1_sd4c_u2 -> "G_c1_sd4c_u2" | G_c1_sd5c_u2 -> "G_c1_sd5c_u2"
      | G_c1_sd6c_u2 -> "G_c1_sd6c_u2" | G_c1_sd1c_u3 -> "G_c1_sd1c_u3"
      | G_c1_sd2c_u3 -> "G_c1_sd2c_u3" | G_c1_sd3c_u3 -> "G_c1_sd3c_u3"
      | G_c1_sd4c_u3 -> "G_c1_sd4c_u3" | G_c1_sd5c_u3 -> "G_c1_sd5c_u3"
      | G_c1_sd6c_u3 -> "G_c1_sd6c_u3" | G_c2_sd1c_u1 -> "G_c2_sd1c_u1"
      | G_c2_sd2c_u1 -> "G_c2_sd2c_u1" | G_c2_sd3c_u1 -> "G_c2_sd3c_u1"
      | G_c2_sd4c_u1 -> "G_c2_sd4c_u1" | G_c2_sd5c_u1 -> "G_c2_sd5c_u1"
      | G_c2_sd6c_u1 -> "G_c2_sd6c_u1" | G_c2_sd1c_u2 -> "G_c2_sd1c_u2"
      | G_c2_sd2c_u2 -> "G_c2_sd2c_u2" | G_c2_sd3c_u2 -> "G_c2_sd3c_u2"
      | G_c2_sd4c_u2 -> "G_c2_sd4c_u2" | G_c2_sd5c_u2 -> "G_c2_sd5c_u2"
      | G_c2_sd6c_u2 -> "G_c2_sd6c_u2" | G_c2_sd1c_u3 -> "G_c2_sd1c_u3"
      | G_c2_sd2c_u3 -> "G_c2_sd2c_u3" | G_c2_sd3c_u3 -> "G_c2_sd3c_u3"
      | G_c2_sd4c_u3 -> "G_c2_sd4c_u3" | G_c2_sd5c_u3 -> "G_c2_sd5c_u3"
      | G_c2_sd6c_u3 -> "G_c2_sd6c_u3" | G_c1_se1c_nu1 -> "G_c1_se1c_nu1"
      | G_c1_se2c_nu1 -> "G_c1_se2c_nu1" | G_c1_se3c_nu1 -> "G_c1_se3c_nu1"
      | G_c1_se4c_nu1 -> "G_c1_se4c_nu1" | G_c1_se5c_nu1 -> "G_c1_se5c_nu1"
      | G_c1_se6c_nu1 -> "G_c1_se6c_nu1" | G_c1_se1c_nu2 -> "G_c1_se1c_nu2"
      | G_c1_se2c_nu2 -> "G_c1_se2c_nu2" | G_c1_se3c_nu2 -> "G_c1_se3c_nu2"
      | G_c1_se4c_nu2 -> "G_c1_se4c_nu2" | G_c1_se5c_nu2 -> "G_c1_se5c_nu2"
      | G_c1_se6c_nu2 -> "G_c1_se6c_nu2" | G_c1_se1c_nu3 -> "G_c1_se1c_nu3"
      | G_c1_se2c_nu3 -> "G_c1_se2c_nu3" | G_c1_se3c_nu3 -> "G_c1_se3c_nu3"
      | G_c1_se4c_nu3 -> "G_c1_se4c_nu3" | G_c1_se5c_nu3 -> "G_c1_se5c_nu3"
      | G_c1_se6c_nu3 -> "G_c1_se6c_nu3" | G_c2_se1c_nu1 -> "G_c2_se1c_nu1"
      | G_c2_se2c_nu1 -> "G_c2_se2c_nu1" | G_c2_se3c_nu1 -> "G_c2_se3c_nu1"
      | G_c2_se4c_nu1 -> "G_c2_se4c_nu1" | G_c2_se5c_nu1 -> "G_c2_se5c_nu1"
      | G_c2_se6c_nu1 -> "G_c2_se6c_nu1" | G_c2_se1c_nu2 -> "G_c2_se1c_nu2"
      | G_c2_se2c_nu2 -> "G_c2_se2c_nu2" | G_c2_se3c_nu2 -> "G_c2_se3c_nu2"
      | G_c2_se4c_nu2 -> "G_c2_se4c_nu2" | G_c2_se5c_nu2 -> "G_c2_se5c_nu2"
      | G_c2_se6c_nu2 -> "G_c2_se6c_nu2" | G_c2_se1c_nu3 -> "G_c2_se1c_nu3"
      | G_c2_se2c_nu3 -> "G_c2_se2c_nu3" | G_c2_se3c_nu3 -> "G_c2_se3c_nu3"
      | G_c2_se4c_nu3 -> "G_c2_se4c_nu3" | G_c2_se5c_nu3 -> "G_c2_se5c_nu3"
      | G_c2_se6c_nu3 -> "G_c2_se6c_nu3" | G_c1bar_h1_c1 -> "G_c1bar_h1_c1"
      | G_c1bar_h2_c1 -> "G_c1bar_h2_c1" | G_c1bar_h1_c2 -> "G_c1bar_h1_c2"
      | G_c1bar_h2_c2 -> "G_c1bar_h2_c2" | G_c2bar_h1_c1 -> "G_c2bar_h1_c1"
      | G_c2bar_h2_c1 -> "G_c2bar_h2_c1" | G_c2bar_h1_c2 -> "G_c2bar_h1_c2"
      | G_c2bar_h2_c2 -> "G_c2bar_h2_c2" | G_d1bar_su1_c1 -> "G_d1bar_su1_c1"
      | G_d1bar_su2_c1 -> "G_d1bar_su2_c1" | G_d1bar_su3_c1 -> "G_d1bar_su3_c1"
      | G_d1bar_su4_c1 -> "G_d1bar_su4_c1" | G_d1bar_su5_c1 -> "G_d1bar_su5_c1"
      | G_d1bar_su6_c1 -> "G_d1bar_su6_c1" | G_d1bar_su1_c2 -> "G_d1bar_su1_c2"
      | G_d1bar_su2_c2 -> "G_d1bar_su2_c2" | G_d1bar_su3_c2 -> "G_d1bar_su3_c2"
      | G_d1bar_su4_c2 -> "G_d1bar_su4_c2" | G_d1bar_su5_c2 -> "G_d1bar_su5_c2"
      | G_d1bar_su6_c2 -> "G_d1bar_su6_c2" | G_d2bar_su1_c1 -> "G_d2bar_su1_c1"
      | G_d2bar_su2_c1 -> "G_d2bar_su2_c1" | G_d2bar_su3_c1 -> "G_d2bar_su3_c1"
      | G_d2bar_su4_c1 -> "G_d2bar_su4_c1" | G_d2bar_su5_c1 -> "G_d2bar_su5_c1"
      | G_d2bar_su6_c1 -> "G_d2bar_su6_c1" | G_d2bar_su1_c2 -> "G_d2bar_su1_c2"
      | G_d2bar_su2_c2 -> "G_d2bar_su2_c2" | G_d2bar_su3_c2 -> "G_d2bar_su3_c2"
      | G_d2bar_su4_c2 -> "G_d2bar_su4_c2" | G_d2bar_su5_c2 -> "G_d2bar_su5_c2"
      | G_d2bar_su6_c2 -> "G_d2bar_su6_c2" | G_d3bar_su1_c1 -> "G_d3bar_su1_c1"
      | G_d3bar_su2_c1 -> "G_d3bar_su2_c1" | G_d3bar_su3_c1 -> "G_d3bar_su3_c1"
      | G_d3bar_su4_c1 -> "G_d3bar_su4_c1" | G_d3bar_su5_c1 -> "G_d3bar_su5_c1"
      | G_d3bar_su6_c1 -> "G_d3bar_su6_c1" | G_d3bar_su1_c2 -> "G_d3bar_su1_c2"
      | G_d3bar_su2_c2 -> "G_d3bar_su2_c2" | G_d3bar_su3_c2 -> "G_d3bar_su3_c2"
      | G_d3bar_su4_c2 -> "G_d3bar_su4_c2" | G_d3bar_su5_c2 -> "G_d3bar_su5_c2"
      | G_d3bar_su6_c2 -> "G_d3bar_su6_c2" | G_e1bar_sv1_c1 -> "G_e1bar_sv1_c1"
      | G_e1bar_sv2_c1 -> "G_e1bar_sv2_c1" | G_e1bar_sv3_c1 -> "G_e1bar_sv3_c1"
      | G_e1bar_sv1_c2 -> "G_e1bar_sv1_c2" | G_e1bar_sv2_c2 -> "G_e1bar_sv2_c2"
      | G_e1bar_sv3_c2 -> "G_e1bar_sv3_c2" | G_e2bar_sv1_c1 -> "G_e2bar_sv1_c1"
      | G_e2bar_sv2_c1 -> "G_e2bar_sv2_c1" | G_e2bar_sv3_c1 -> "G_e2bar_sv3_c1"
      | G_e2bar_sv1_c2 -> "G_e2bar_sv1_c2" | G_e2bar_sv2_c2 -> "G_e2bar_sv2_c2"
      | G_e2bar_sv3_c2 -> "G_e2bar_sv3_c2" | G_e3bar_sv1_c1 -> "G_e3bar_sv1_c1"
      | G_e3bar_sv2_c1 -> "G_e3bar_sv2_c1" | G_e3bar_sv3_c1 -> "G_e3bar_sv3_c1"
      | G_e3bar_sv1_c2 -> "G_e3bar_sv1_c2" | G_e3bar_sv2_c2 -> "G_e3bar_sv2_c2"
      | G_e3bar_sv3_c2 -> "G_e3bar_sv3_c2" | G_n1_h1_n1 -> "G_n1_h1_n1"
      | G_n1_h2_n1 -> "G_n1_h2_n1" | G_n1_h1_n2 -> "G_n1_h1_n2"
      | G_n1_h2_n2 -> "G_n1_h2_n2" | G_n1_h1_n3 -> "G_n1_h1_n3"
      | G_n1_h2_n3 -> "G_n1_h2_n3" | G_n1_h1_n4 -> "G_n1_h1_n4"
      | G_n1_h2_n4 -> "G_n1_h2_n4" | G_n2_h1_n2 -> "G_n2_h1_n2"
      | G_n2_h2_n2 -> "G_n2_h2_n2" | G_n2_h1_n3 -> "G_n2_h1_n3"
      | G_n2_h2_n3 -> "G_n2_h2_n3" | G_n2_h1_n4 -> "G_n2_h1_n4"
      | G_n2_h2_n4 -> "G_n2_h2_n4" | G_n3_h1_n3 -> "G_n3_h1_n3"
      | G_n3_h2_n3 -> "G_n3_h2_n3" | G_n3_h1_n4 -> "G_n3_h1_n4"
      | G_n3_h2_n4 -> "G_n3_h2_n4" | G_n4_h1_n4 -> "G_n4_h1_n4"
      | G_n4_h2_n4 -> "G_n4_h2_n4" | G_n1_sd1c_d1 -> "G_n1_sd1c_d1"
      | G_n1_sd2c_d1 -> "G_n1_sd2c_d1" | G_n1_sd3c_d1 -> "G_n1_sd3c_d1"
      | G_n1_sd4c_d1 -> "G_n1_sd4c_d1" | G_n1_sd5c_d1 -> "G_n1_sd5c_d1"
      | G_n1_sd6c_d1 -> "G_n1_sd6c_d1" | G_n1_sd1c_d2 -> "G_n1_sd1c_d2"
      | G_n1_sd2c_d2 -> "G_n1_sd2c_d2" | G_n1_sd3c_d2 -> "G_n1_sd3c_d2"
      | G_n1_sd4c_d2 -> "G_n1_sd4c_d2" | G_n1_sd5c_d2 -> "G_n1_sd5c_d2"
      | G_n1_sd6c_d2 -> "G_n1_sd6c_d2" | G_n1_sd1c_d3 -> "G_n1_sd1c_d3"
      | G_n1_sd2c_d3 -> "G_n1_sd2c_d3" | G_n1_sd3c_d3 -> "G_n1_sd3c_d3"
      | G_n1_sd4c_d3 -> "G_n1_sd4c_d3" | G_n1_sd5c_d3 -> "G_n1_sd5c_d3"
      | G_n1_sd6c_d3 -> "G_n1_sd6c_d3" | G_n2_sd1c_d1 -> "G_n2_sd1c_d1"
      | G_n2_sd2c_d1 -> "G_n2_sd2c_d1" | G_n2_sd3c_d1 -> "G_n2_sd3c_d1"
      | G_n2_sd4c_d1 -> "G_n2_sd4c_d1" | G_n2_sd5c_d1 -> "G_n2_sd5c_d1"
      | G_n2_sd6c_d1 -> "G_n2_sd6c_d1" | G_n2_sd1c_d2 -> "G_n2_sd1c_d2"
      | G_n2_sd2c_d2 -> "G_n2_sd2c_d2" | G_n2_sd3c_d2 -> "G_n2_sd3c_d2"
      | G_n2_sd4c_d2 -> "G_n2_sd4c_d2" | G_n2_sd5c_d2 -> "G_n2_sd5c_d2"
      | G_n2_sd6c_d2 -> "G_n2_sd6c_d2" | G_n2_sd1c_d3 -> "G_n2_sd1c_d3"
      | G_n2_sd2c_d3 -> "G_n2_sd2c_d3" | G_n2_sd3c_d3 -> "G_n2_sd3c_d3"
      | G_n2_sd4c_d3 -> "G_n2_sd4c_d3" | G_n2_sd5c_d3 -> "G_n2_sd5c_d3"
      | G_n2_sd6c_d3 -> "G_n2_sd6c_d3" | G_n3_sd1c_d1 -> "G_n3_sd1c_d1"
      | G_n3_sd2c_d1 -> "G_n3_sd2c_d1" | G_n3_sd3c_d1 -> "G_n3_sd3c_d1"
      | G_n3_sd4c_d1 -> "G_n3_sd4c_d1" | G_n3_sd5c_d1 -> "G_n3_sd5c_d1"
      | G_n3_sd6c_d1 -> "G_n3_sd6c_d1" | G_n3_sd1c_d2 -> "G_n3_sd1c_d2"
      | G_n3_sd2c_d2 -> "G_n3_sd2c_d2" | G_n3_sd3c_d2 -> "G_n3_sd3c_d2"
      | G_n3_sd4c_d2 -> "G_n3_sd4c_d2" | G_n3_sd5c_d2 -> "G_n3_sd5c_d2"
      | G_n3_sd6c_d2 -> "G_n3_sd6c_d2" | G_n3_sd1c_d3 -> "G_n3_sd1c_d3"
      | G_n3_sd2c_d3 -> "G_n3_sd2c_d3" | G_n3_sd3c_d3 -> "G_n3_sd3c_d3"
      | G_n3_sd4c_d3 -> "G_n3_sd4c_d3" | G_n3_sd5c_d3 -> "G_n3_sd5c_d3"
      | G_n3_sd6c_d3 -> "G_n3_sd6c_d3" | G_n4_sd1c_d1 -> "G_n4_sd1c_d1"
      | G_n4_sd2c_d1 -> "G_n4_sd2c_d1" | G_n4_sd3c_d1 -> "G_n4_sd3c_d1"
      | G_n4_sd4c_d1 -> "G_n4_sd4c_d1" | G_n4_sd5c_d1 -> "G_n4_sd5c_d1"
      | G_n4_sd6c_d1 -> "G_n4_sd6c_d1" | G_n4_sd1c_d2 -> "G_n4_sd1c_d2"
      | G_n4_sd2c_d2 -> "G_n4_sd2c_d2" | G_n4_sd3c_d2 -> "G_n4_sd3c_d2"
      | G_n4_sd4c_d2 -> "G_n4_sd4c_d2" | G_n4_sd5c_d2 -> "G_n4_sd5c_d2"
      | G_n4_sd6c_d2 -> "G_n4_sd6c_d2" | G_n4_sd1c_d3 -> "G_n4_sd1c_d3"
      | G_n4_sd2c_d3 -> "G_n4_sd2c_d3" | G_n4_sd3c_d3 -> "G_n4_sd3c_d3"
      | G_n4_sd4c_d3 -> "G_n4_sd4c_d3" | G_n4_sd5c_d3 -> "G_n4_sd5c_d3"
      | G_n4_sd6c_d3 -> "G_n4_sd6c_d3" | G_n1_se1c_e1 -> "G_n1_se1c_e1"
      | G_n1_se2c_e1 -> "G_n1_se2c_e1" | G_n1_se3c_e1 -> "G_n1_se3c_e1"
      | G_n1_se4c_e1 -> "G_n1_se4c_e1" | G_n1_se5c_e1 -> "G_n1_se5c_e1"
      | G_n1_se6c_e1 -> "G_n1_se6c_e1" | G_n1_se1c_e2 -> "G_n1_se1c_e2"
      | G_n1_se2c_e2 -> "G_n1_se2c_e2" | G_n1_se3c_e2 -> "G_n1_se3c_e2"
      | G_n1_se4c_e2 -> "G_n1_se4c_e2" | G_n1_se5c_e2 -> "G_n1_se5c_e2"
      | G_n1_se6c_e2 -> "G_n1_se6c_e2" | G_n1_se1c_e3 -> "G_n1_se1c_e3"
      | G_n1_se2c_e3 -> "G_n1_se2c_e3" | G_n1_se3c_e3 -> "G_n1_se3c_e3"
      | G_n1_se4c_e3 -> "G_n1_se4c_e3" | G_n1_se5c_e3 -> "G_n1_se5c_e3"
      | G_n1_se6c_e3 -> "G_n1_se6c_e3" | G_n2_se1c_e1 -> "G_n2_se1c_e1"
      | G_n2_se2c_e1 -> "G_n2_se2c_e1" | G_n2_se3c_e1 -> "G_n2_se3c_e1"
      | G_n2_se4c_e1 -> "G_n2_se4c_e1" | G_n2_se5c_e1 -> "G_n2_se5c_e1"
      | G_n2_se6c_e1 -> "G_n2_se6c_e1" | G_n2_se1c_e2 -> "G_n2_se1c_e2"
      | G_n2_se2c_e2 -> "G_n2_se2c_e2" | G_n2_se3c_e2 -> "G_n2_se3c_e2"
      | G_n2_se4c_e2 -> "G_n2_se4c_e2" | G_n2_se5c_e2 -> "G_n2_se5c_e2"
      | G_n2_se6c_e2 -> "G_n2_se6c_e2" | G_n2_se1c_e3 -> "G_n2_se1c_e3"
      | G_n2_se2c_e3 -> "G_n2_se2c_e3" | G_n2_se3c_e3 -> "G_n2_se3c_e3"
      | G_n2_se4c_e3 -> "G_n2_se4c_e3" | G_n2_se5c_e3 -> "G_n2_se5c_e3"
      | G_n2_se6c_e3 -> "G_n2_se6c_e3" | G_n3_se1c_e1 -> "G_n3_se1c_e1"
      | G_n3_se2c_e1 -> "G_n3_se2c_e1" | G_n3_se3c_e1 -> "G_n3_se3c_e1"
      | G_n3_se4c_e1 -> "G_n3_se4c_e1" | G_n3_se5c_e1 -> "G_n3_se5c_e1"
      | G_n3_se6c_e1 -> "G_n3_se6c_e1" | G_n3_se1c_e2 -> "G_n3_se1c_e2"
      | G_n3_se2c_e2 -> "G_n3_se2c_e2" | G_n3_se3c_e2 -> "G_n3_se3c_e2"
      | G_n3_se4c_e2 -> "G_n3_se4c_e2" | G_n3_se5c_e2 -> "G_n3_se5c_e2"
      | G_n3_se6c_e2 -> "G_n3_se6c_e2" | G_n3_se1c_e3 -> "G_n3_se1c_e3"
      | G_n3_se2c_e3 -> "G_n3_se2c_e3" | G_n3_se3c_e3 -> "G_n3_se3c_e3"
      | G_n3_se4c_e3 -> "G_n3_se4c_e3" | G_n3_se5c_e3 -> "G_n3_se5c_e3"
      | G_n3_se6c_e3 -> "G_n3_se6c_e3" | G_n4_se1c_e1 -> "G_n4_se1c_e1"
      | G_n4_se2c_e1 -> "G_n4_se2c_e1" | G_n4_se3c_e1 -> "G_n4_se3c_e1"
      | G_n4_se4c_e1 -> "G_n4_se4c_e1" | G_n4_se5c_e1 -> "G_n4_se5c_e1"
      | G_n4_se6c_e1 -> "G_n4_se6c_e1" | G_n4_se1c_e2 -> "G_n4_se1c_e2"
      | G_n4_se2c_e2 -> "G_n4_se2c_e2" | G_n4_se3c_e2 -> "G_n4_se3c_e2"
      | G_n4_se4c_e2 -> "G_n4_se4c_e2" | G_n4_se5c_e2 -> "G_n4_se5c_e2"
      | G_n4_se6c_e2 -> "G_n4_se6c_e2" | G_n4_se1c_e3 -> "G_n4_se1c_e3"
      | G_n4_se2c_e3 -> "G_n4_se2c_e3" | G_n4_se3c_e3 -> "G_n4_se3c_e3"
      | G_n4_se4c_e3 -> "G_n4_se4c_e3" | G_n4_se5c_e3 -> "G_n4_se5c_e3"
      | G_n4_se6c_e3 -> "G_n4_se6c_e3" | G_n1_su1c_u1 -> "G_n1_su1c_u1"
      | G_n1_su2c_u1 -> "G_n1_su2c_u1" | G_n1_su3c_u1 -> "G_n1_su3c_u1"
      | G_n1_su4c_u1 -> "G_n1_su4c_u1" | G_n1_su5c_u1 -> "G_n1_su5c_u1"
      | G_n1_su6c_u1 -> "G_n1_su6c_u1" | G_n1_su1c_u2 -> "G_n1_su1c_u2"
      | G_n1_su2c_u2 -> "G_n1_su2c_u2" | G_n1_su3c_u2 -> "G_n1_su3c_u2"
      | G_n1_su4c_u2 -> "G_n1_su4c_u2" | G_n1_su5c_u2 -> "G_n1_su5c_u2"
      | G_n1_su6c_u2 -> "G_n1_su6c_u2" | G_n1_su1c_u3 -> "G_n1_su1c_u3"
      | G_n1_su2c_u3 -> "G_n1_su2c_u3" | G_n1_su3c_u3 -> "G_n1_su3c_u3"
      | G_n1_su4c_u3 -> "G_n1_su4c_u3" | G_n1_su5c_u3 -> "G_n1_su5c_u3"
      | G_n1_su6c_u3 -> "G_n1_su6c_u3" | G_n2_su1c_u1 -> "G_n2_su1c_u1"
      | G_n2_su2c_u1 -> "G_n2_su2c_u1" | G_n2_su3c_u1 -> "G_n2_su3c_u1"
      | G_n2_su4c_u1 -> "G_n2_su4c_u1" | G_n2_su5c_u1 -> "G_n2_su5c_u1"
      | G_n2_su6c_u1 -> "G_n2_su6c_u1" | G_n2_su1c_u2 -> "G_n2_su1c_u2"
      | G_n2_su2c_u2 -> "G_n2_su2c_u2" | G_n2_su3c_u2 -> "G_n2_su3c_u2"
      | G_n2_su4c_u2 -> "G_n2_su4c_u2" | G_n2_su5c_u2 -> "G_n2_su5c_u2"
      | G_n2_su6c_u2 -> "G_n2_su6c_u2" | G_n2_su1c_u3 -> "G_n2_su1c_u3"
      | G_n2_su2c_u3 -> "G_n2_su2c_u3" | G_n2_su3c_u3 -> "G_n2_su3c_u3"
      | G_n2_su4c_u3 -> "G_n2_su4c_u3" | G_n2_su5c_u3 -> "G_n2_su5c_u3"
      | G_n2_su6c_u3 -> "G_n2_su6c_u3" | G_n3_su1c_u1 -> "G_n3_su1c_u1"
      | G_n3_su2c_u1 -> "G_n3_su2c_u1" | G_n3_su3c_u1 -> "G_n3_su3c_u1"
      | G_n3_su4c_u1 -> "G_n3_su4c_u1" | G_n3_su5c_u1 -> "G_n3_su5c_u1"
      | G_n3_su6c_u1 -> "G_n3_su6c_u1" | G_n3_su1c_u2 -> "G_n3_su1c_u2"
      | G_n3_su2c_u2 -> "G_n3_su2c_u2" | G_n3_su3c_u2 -> "G_n3_su3c_u2"
      | G_n3_su4c_u2 -> "G_n3_su4c_u2" | G_n3_su5c_u2 -> "G_n3_su5c_u2"
      | G_n3_su6c_u2 -> "G_n3_su6c_u2" | G_n3_su1c_u3 -> "G_n3_su1c_u3"
      | G_n3_su2c_u3 -> "G_n3_su2c_u3" | G_n3_su3c_u3 -> "G_n3_su3c_u3"
      | G_n3_su4c_u3 -> "G_n3_su4c_u3" | G_n3_su5c_u3 -> "G_n3_su5c_u3"
      | G_n3_su6c_u3 -> "G_n3_su6c_u3" | G_n4_su1c_u1 -> "G_n4_su1c_u1"
      | G_n4_su2c_u1 -> "G_n4_su2c_u1" | G_n4_su3c_u1 -> "G_n4_su3c_u1"
      | G_n4_su4c_u1 -> "G_n4_su4c_u1" | G_n4_su5c_u1 -> "G_n4_su5c_u1"
      | G_n4_su6c_u1 -> "G_n4_su6c_u1" | G_n4_su1c_u2 -> "G_n4_su1c_u2"
      | G_n4_su2c_u2 -> "G_n4_su2c_u2" | G_n4_su3c_u2 -> "G_n4_su3c_u2"
      | G_n4_su4c_u2 -> "G_n4_su4c_u2" | G_n4_su5c_u2 -> "G_n4_su5c_u2"
      | G_n4_su6c_u2 -> "G_n4_su6c_u2" | G_n4_su1c_u3 -> "G_n4_su1c_u3"
      | G_n4_su2c_u3 -> "G_n4_su2c_u3" | G_n4_su3c_u3 -> "G_n4_su3c_u3"
      | G_n4_su4c_u3 -> "G_n4_su4c_u3" | G_n4_su5c_u3 -> "G_n4_su5c_u3"
      | G_n4_su6c_u3 -> "G_n4_su6c_u3" | G_n1_sv1c_nu1 -> "G_n1_sv1c_nu1"
      | G_n1_sv2c_nu1 -> "G_n1_sv2c_nu1" | G_n1_sv3c_nu1 -> "G_n1_sv3c_nu1"
      | G_n1_sv1c_nu2 -> "G_n1_sv1c_nu2" | G_n1_sv2c_nu2 -> "G_n1_sv2c_nu2"
      | G_n1_sv3c_nu2 -> "G_n1_sv3c_nu2" | G_n1_sv1c_nu3 -> "G_n1_sv1c_nu3"
      | G_n1_sv2c_nu3 -> "G_n1_sv2c_nu3" | G_n1_sv3c_nu3 -> "G_n1_sv3c_nu3"
      | G_n2_sv1c_nu1 -> "G_n2_sv1c_nu1" | G_n2_sv2c_nu1 -> "G_n2_sv2c_nu1"
      | G_n2_sv3c_nu1 -> "G_n2_sv3c_nu1" | G_n2_sv1c_nu2 -> "G_n2_sv1c_nu2"
      | G_n2_sv2c_nu2 -> "G_n2_sv2c_nu2" | G_n2_sv3c_nu2 -> "G_n2_sv3c_nu2"
      | G_n2_sv1c_nu3 -> "G_n2_sv1c_nu3" | G_n2_sv2c_nu3 -> "G_n2_sv2c_nu3"
      | G_n2_sv3c_nu3 -> "G_n2_sv3c_nu3" | G_n3_sv1c_nu1 -> "G_n3_sv1c_nu1"
      | G_n3_sv2c_nu1 -> "G_n3_sv2c_nu1" | G_n3_sv3c_nu1 -> "G_n3_sv3c_nu1"
      | G_n3_sv1c_nu2 -> "G_n3_sv1c_nu2" | G_n3_sv2c_nu2 -> "G_n3_sv2c_nu2"
      | G_n3_sv3c_nu2 -> "G_n3_sv3c_nu2" | G_n3_sv1c_nu3 -> "G_n3_sv1c_nu3"
      | G_n3_sv2c_nu3 -> "G_n3_sv2c_nu3" | G_n3_sv3c_nu3 -> "G_n3_sv3c_nu3"
      | G_n4_sv1c_nu1 -> "G_n4_sv1c_nu1" | G_n4_sv2c_nu1 -> "G_n4_sv2c_nu1"
      | G_n4_sv3c_nu1 -> "G_n4_sv3c_nu1" | G_n4_sv1c_nu2 -> "G_n4_sv1c_nu2"
      | G_n4_sv2c_nu2 -> "G_n4_sv2c_nu2" | G_n4_sv3c_nu2 -> "G_n4_sv3c_nu2"
      | G_n4_sv1c_nu3 -> "G_n4_sv1c_nu3" | G_n4_sv2c_nu3 -> "G_n4_sv2c_nu3"
      | G_n4_sv3c_nu3 -> "G_n4_sv3c_nu3" | G_c1bar_hm2_n1 -> "G_c1bar_hm2_n1"
      | G_c1bar_hm2_n2 -> "G_c1bar_hm2_n2" | G_c1bar_hm2_n3 -> "G_c1bar_hm2_n3"
      | G_c1bar_hm2_n4 -> "G_c1bar_hm2_n4" | G_c2bar_hm2_n1 -> "G_c2bar_hm2_n1"
      | G_c2bar_hm2_n2 -> "G_c2bar_hm2_n2" | G_c2bar_hm2_n3 -> "G_c2bar_hm2_n3"
      | G_c2bar_hm2_n4 -> "G_c2bar_hm2_n4" | G_d1bar_sd1_n1 -> "G_d1bar_sd1_n1"
      | G_d1bar_sd2_n1 -> "G_d1bar_sd2_n1" | G_d1bar_sd3_n1 -> "G_d1bar_sd3_n1"
      | G_d1bar_sd4_n1 -> "G_d1bar_sd4_n1" | G_d1bar_sd5_n1 -> "G_d1bar_sd5_n1"
      | G_d1bar_sd6_n1 -> "G_d1bar_sd6_n1" | G_d1bar_sd1_n2 -> "G_d1bar_sd1_n2"
      | G_d1bar_sd2_n2 -> "G_d1bar_sd2_n2" | G_d1bar_sd3_n2 -> "G_d1bar_sd3_n2"
      | G_d1bar_sd4_n2 -> "G_d1bar_sd4_n2" | G_d1bar_sd5_n2 -> "G_d1bar_sd5_n2"
      | G_d1bar_sd6_n2 -> "G_d1bar_sd6_n2" | G_d1bar_sd1_n3 -> "G_d1bar_sd1_n3"
      | G_d1bar_sd2_n3 -> "G_d1bar_sd2_n3" | G_d1bar_sd3_n3 -> "G_d1bar_sd3_n3"
      | G_d1bar_sd4_n3 -> "G_d1bar_sd4_n3" | G_d1bar_sd5_n3 -> "G_d1bar_sd5_n3"
      | G_d1bar_sd6_n3 -> "G_d1bar_sd6_n3" | G_d1bar_sd1_n4 -> "G_d1bar_sd1_n4"
      | G_d1bar_sd2_n4 -> "G_d1bar_sd2_n4" | G_d1bar_sd3_n4 -> "G_d1bar_sd3_n4"
      | G_d1bar_sd4_n4 -> "G_d1bar_sd4_n4" | G_d1bar_sd5_n4 -> "G_d1bar_sd5_n4"
      | G_d1bar_sd6_n4 -> "G_d1bar_sd6_n4" | G_d2bar_sd1_n1 -> "G_d2bar_sd1_n1"
      | G_d2bar_sd2_n1 -> "G_d2bar_sd2_n1" | G_d2bar_sd3_n1 -> "G_d2bar_sd3_n1"
      | G_d2bar_sd4_n1 -> "G_d2bar_sd4_n1" | G_d2bar_sd5_n1 -> "G_d2bar_sd5_n1"
      | G_d2bar_sd6_n1 -> "G_d2bar_sd6_n1" | G_d2bar_sd1_n2 -> "G_d2bar_sd1_n2"
      | G_d2bar_sd2_n2 -> "G_d2bar_sd2_n2" | G_d2bar_sd3_n2 -> "G_d2bar_sd3_n2"
      | G_d2bar_sd4_n2 -> "G_d2bar_sd4_n2" | G_d2bar_sd5_n2 -> "G_d2bar_sd5_n2"
      | G_d2bar_sd6_n2 -> "G_d2bar_sd6_n2" | G_d2bar_sd1_n3 -> "G_d2bar_sd1_n3"
      | G_d2bar_sd2_n3 -> "G_d2bar_sd2_n3" | G_d2bar_sd3_n3 -> "G_d2bar_sd3_n3"
      | G_d2bar_sd4_n3 -> "G_d2bar_sd4_n3" | G_d2bar_sd5_n3 -> "G_d2bar_sd5_n3"
      | G_d2bar_sd6_n3 -> "G_d2bar_sd6_n3" | G_d2bar_sd1_n4 -> "G_d2bar_sd1_n4"
      | G_d2bar_sd2_n4 -> "G_d2bar_sd2_n4" | G_d2bar_sd3_n4 -> "G_d2bar_sd3_n4"
      | G_d2bar_sd4_n4 -> "G_d2bar_sd4_n4" | G_d2bar_sd5_n4 -> "G_d2bar_sd5_n4"
      | G_d2bar_sd6_n4 -> "G_d2bar_sd6_n4" | G_d3bar_sd1_n1 -> "G_d3bar_sd1_n1"
      | G_d3bar_sd2_n1 -> "G_d3bar_sd2_n1" | G_d3bar_sd3_n1 -> "G_d3bar_sd3_n1"
      | G_d3bar_sd4_n1 -> "G_d3bar_sd4_n1" | G_d3bar_sd5_n1 -> "G_d3bar_sd5_n1"
      | G_d3bar_sd6_n1 -> "G_d3bar_sd6_n1" | G_d3bar_sd1_n2 -> "G_d3bar_sd1_n2"
      | G_d3bar_sd2_n2 -> "G_d3bar_sd2_n2" | G_d3bar_sd3_n2 -> "G_d3bar_sd3_n2"
      | G_d3bar_sd4_n2 -> "G_d3bar_sd4_n2" | G_d3bar_sd5_n2 -> "G_d3bar_sd5_n2"
      | G_d3bar_sd6_n2 -> "G_d3bar_sd6_n2" | G_d3bar_sd1_n3 -> "G_d3bar_sd1_n3"
      | G_d3bar_sd2_n3 -> "G_d3bar_sd2_n3" | G_d3bar_sd3_n3 -> "G_d3bar_sd3_n3"
      | G_d3bar_sd4_n3 -> "G_d3bar_sd4_n3" | G_d3bar_sd5_n3 -> "G_d3bar_sd5_n3"
      | G_d3bar_sd6_n3 -> "G_d3bar_sd6_n3" | G_d3bar_sd1_n4 -> "G_d3bar_sd1_n4"
      | G_d3bar_sd2_n4 -> "G_d3bar_sd2_n4" | G_d3bar_sd3_n4 -> "G_d3bar_sd3_n4"
      | G_d3bar_sd4_n4 -> "G_d3bar_sd4_n4" | G_d3bar_sd5_n4 -> "G_d3bar_sd5_n4"
      | G_d3bar_sd6_n4 -> "G_d3bar_sd6_n4" | G_e1bar_se1_n1 -> "G_e1bar_se1_n1"
      | G_e1bar_se2_n1 -> "G_e1bar_se2_n1" | G_e1bar_se3_n1 -> "G_e1bar_se3_n1"
      | G_e1bar_se4_n1 -> "G_e1bar_se4_n1" | G_e1bar_se5_n1 -> "G_e1bar_se5_n1"
      | G_e1bar_se6_n1 -> "G_e1bar_se6_n1" | G_e1bar_se1_n2 -> "G_e1bar_se1_n2"
      | G_e1bar_se2_n2 -> "G_e1bar_se2_n2" | G_e1bar_se3_n2 -> "G_e1bar_se3_n2"
      | G_e1bar_se4_n2 -> "G_e1bar_se4_n2" | G_e1bar_se5_n2 -> "G_e1bar_se5_n2"
      | G_e1bar_se6_n2 -> "G_e1bar_se6_n2" | G_e1bar_se1_n3 -> "G_e1bar_se1_n3"
      | G_e1bar_se2_n3 -> "G_e1bar_se2_n3" | G_e1bar_se3_n3 -> "G_e1bar_se3_n3"
      | G_e1bar_se4_n3 -> "G_e1bar_se4_n3" | G_e1bar_se5_n3 -> "G_e1bar_se5_n3"
      | G_e1bar_se6_n3 -> "G_e1bar_se6_n3" | G_e1bar_se1_n4 -> "G_e1bar_se1_n4"
      | G_e1bar_se2_n4 -> "G_e1bar_se2_n4" | G_e1bar_se3_n4 -> "G_e1bar_se3_n4"
      | G_e1bar_se4_n4 -> "G_e1bar_se4_n4" | G_e1bar_se5_n4 -> "G_e1bar_se5_n4"
      | G_e1bar_se6_n4 -> "G_e1bar_se6_n4" | G_e2bar_se1_n1 -> "G_e2bar_se1_n1"
      | G_e2bar_se2_n1 -> "G_e2bar_se2_n1" | G_e2bar_se3_n1 -> "G_e2bar_se3_n1"
      | G_e2bar_se4_n1 -> "G_e2bar_se4_n1" | G_e2bar_se5_n1 -> "G_e2bar_se5_n1"
      | G_e2bar_se6_n1 -> "G_e2bar_se6_n1" | G_e2bar_se1_n2 -> "G_e2bar_se1_n2"
      | G_e2bar_se2_n2 -> "G_e2bar_se2_n2" | G_e2bar_se3_n2 -> "G_e2bar_se3_n2"
      | G_e2bar_se4_n2 -> "G_e2bar_se4_n2" | G_e2bar_se5_n2 -> "G_e2bar_se5_n2"
      | G_e2bar_se6_n2 -> "G_e2bar_se6_n2" | G_e2bar_se1_n3 -> "G_e2bar_se1_n3"
      | G_e2bar_se2_n3 -> "G_e2bar_se2_n3" | G_e2bar_se3_n3 -> "G_e2bar_se3_n3"
      | G_e2bar_se4_n3 -> "G_e2bar_se4_n3" | G_e2bar_se5_n3 -> "G_e2bar_se5_n3"
      | G_e2bar_se6_n3 -> "G_e2bar_se6_n3" | G_e2bar_se1_n4 -> "G_e2bar_se1_n4"
      | G_e2bar_se2_n4 -> "G_e2bar_se2_n4" | G_e2bar_se3_n4 -> "G_e2bar_se3_n4"
      | G_e2bar_se4_n4 -> "G_e2bar_se4_n4" | G_e2bar_se5_n4 -> "G_e2bar_se5_n4"
      | G_e2bar_se6_n4 -> "G_e2bar_se6_n4" | G_e3bar_se1_n1 -> "G_e3bar_se1_n1"
      | G_e3bar_se2_n1 -> "G_e3bar_se2_n1" | G_e3bar_se3_n1 -> "G_e3bar_se3_n1"
      | G_e3bar_se4_n1 -> "G_e3bar_se4_n1" | G_e3bar_se5_n1 -> "G_e3bar_se5_n1"
      | G_e3bar_se6_n1 -> "G_e3bar_se6_n1" | G_e3bar_se1_n2 -> "G_e3bar_se1_n2"
      | G_e3bar_se2_n2 -> "G_e3bar_se2_n2" | G_e3bar_se3_n2 -> "G_e3bar_se3_n2"
      | G_e3bar_se4_n2 -> "G_e3bar_se4_n2" | G_e3bar_se5_n2 -> "G_e3bar_se5_n2"
      | G_e3bar_se6_n2 -> "G_e3bar_se6_n2" | G_e3bar_se1_n3 -> "G_e3bar_se1_n3"
      | G_e3bar_se2_n3 -> "G_e3bar_se2_n3" | G_e3bar_se3_n3 -> "G_e3bar_se3_n3"
      | G_e3bar_se4_n3 -> "G_e3bar_se4_n3" | G_e3bar_se5_n3 -> "G_e3bar_se5_n3"
      | G_e3bar_se6_n3 -> "G_e3bar_se6_n3" | G_e3bar_se1_n4 -> "G_e3bar_se1_n4"
      | G_e3bar_se2_n4 -> "G_e3bar_se2_n4" | G_e3bar_se3_n4 -> "G_e3bar_se3_n4"
      | G_e3bar_se4_n4 -> "G_e3bar_se4_n4" | G_e3bar_se5_n4 -> "G_e3bar_se5_n4"
      | G_e3bar_se6_n4 -> "G_e3bar_se6_n4" | G_u1bar_su1_n1 -> "G_u1bar_su1_n1"
      | G_u1bar_su2_n1 -> "G_u1bar_su2_n1" | G_u1bar_su3_n1 -> "G_u1bar_su3_n1"
      | G_u1bar_su4_n1 -> "G_u1bar_su4_n1" | G_u1bar_su5_n1 -> "G_u1bar_su5_n1"
      | G_u1bar_su6_n1 -> "G_u1bar_su6_n1" | G_u1bar_su1_n2 -> "G_u1bar_su1_n2"
      | G_u1bar_su2_n2 -> "G_u1bar_su2_n2" | G_u1bar_su3_n2 -> "G_u1bar_su3_n2"
      | G_u1bar_su4_n2 -> "G_u1bar_su4_n2" | G_u1bar_su5_n2 -> "G_u1bar_su5_n2"
      | G_u1bar_su6_n2 -> "G_u1bar_su6_n2" | G_u1bar_su1_n3 -> "G_u1bar_su1_n3"
      | G_u1bar_su2_n3 -> "G_u1bar_su2_n3" | G_u1bar_su3_n3 -> "G_u1bar_su3_n3"
      | G_u1bar_su4_n3 -> "G_u1bar_su4_n3" | G_u1bar_su5_n3 -> "G_u1bar_su5_n3"
      | G_u1bar_su6_n3 -> "G_u1bar_su6_n3" | G_u1bar_su1_n4 -> "G_u1bar_su1_n4"
      | G_u1bar_su2_n4 -> "G_u1bar_su2_n4" | G_u1bar_su3_n4 -> "G_u1bar_su3_n4"
      | G_u1bar_su4_n4 -> "G_u1bar_su4_n4" | G_u1bar_su5_n4 -> "G_u1bar_su5_n4"
      | G_u1bar_su6_n4 -> "G_u1bar_su6_n4" | G_u2bar_su1_n1 -> "G_u2bar_su1_n1"
      | G_u2bar_su2_n1 -> "G_u2bar_su2_n1" | G_u2bar_su3_n1 -> "G_u2bar_su3_n1"
      | G_u2bar_su4_n1 -> "G_u2bar_su4_n1" | G_u2bar_su5_n1 -> "G_u2bar_su5_n1"
      | G_u2bar_su6_n1 -> "G_u2bar_su6_n1" | G_u2bar_su1_n2 -> "G_u2bar_su1_n2"
      | G_u2bar_su2_n2 -> "G_u2bar_su2_n2" | G_u2bar_su3_n2 -> "G_u2bar_su3_n2"
      | G_u2bar_su4_n2 -> "G_u2bar_su4_n2" | G_u2bar_su5_n2 -> "G_u2bar_su5_n2"
      | G_u2bar_su6_n2 -> "G_u2bar_su6_n2" | G_u2bar_su1_n3 -> "G_u2bar_su1_n3"
      | G_u2bar_su2_n3 -> "G_u2bar_su2_n3" | G_u2bar_su3_n3 -> "G_u2bar_su3_n3"
      | G_u2bar_su4_n3 -> "G_u2bar_su4_n3" | G_u2bar_su5_n3 -> "G_u2bar_su5_n3"
      | G_u2bar_su6_n3 -> "G_u2bar_su6_n3" | G_u2bar_su1_n4 -> "G_u2bar_su1_n4"
      | G_u2bar_su2_n4 -> "G_u2bar_su2_n4" | G_u2bar_su3_n4 -> "G_u2bar_su3_n4"
      | G_u2bar_su4_n4 -> "G_u2bar_su4_n4" | G_u2bar_su5_n4 -> "G_u2bar_su5_n4"
      | G_u2bar_su6_n4 -> "G_u2bar_su6_n4" | G_u3bar_su1_n1 -> "G_u3bar_su1_n1"
      | G_u3bar_su2_n1 -> "G_u3bar_su2_n1" | G_u3bar_su3_n1 -> "G_u3bar_su3_n1"
      | G_u3bar_su4_n1 -> "G_u3bar_su4_n1" | G_u3bar_su5_n1 -> "G_u3bar_su5_n1"
      | G_u3bar_su6_n1 -> "G_u3bar_su6_n1" | G_u3bar_su1_n2 -> "G_u3bar_su1_n2"
      | G_u3bar_su2_n2 -> "G_u3bar_su2_n2" | G_u3bar_su3_n2 -> "G_u3bar_su3_n2"
      | G_u3bar_su4_n2 -> "G_u3bar_su4_n2" | G_u3bar_su5_n2 -> "G_u3bar_su5_n2"
      | G_u3bar_su6_n2 -> "G_u3bar_su6_n2" | G_u3bar_su1_n3 -> "G_u3bar_su1_n3"
      | G_u3bar_su2_n3 -> "G_u3bar_su2_n3" | G_u3bar_su3_n3 -> "G_u3bar_su3_n3"
      | G_u3bar_su4_n3 -> "G_u3bar_su4_n3" | G_u3bar_su5_n3 -> "G_u3bar_su5_n3"
      | G_u3bar_su6_n3 -> "G_u3bar_su6_n3" | G_u3bar_su1_n4 -> "G_u3bar_su1_n4"
      | G_u3bar_su2_n4 -> "G_u3bar_su2_n4" | G_u3bar_su3_n4 -> "G_u3bar_su3_n4"
      | G_u3bar_su4_n4 -> "G_u3bar_su4_n4" | G_u3bar_su5_n4 -> "G_u3bar_su5_n4"
      | G_u3bar_su6_n4 -> "G_u3bar_su6_n4" | G_nu1bar_sv1_n1 -> "G_nu1bar_sv1_n1"
      | G_nu1bar_sv2_n1 -> "G_nu1bar_sv2_n1" | G_nu1bar_sv3_n1 -> "G_nu1bar_sv3_n1"
      | G_nu1bar_sv1_n2 -> "G_nu1bar_sv1_n2" | G_nu1bar_sv2_n2 -> "G_nu1bar_sv2_n2"
      | G_nu1bar_sv3_n2 -> "G_nu1bar_sv3_n2" | G_nu1bar_sv1_n3 -> "G_nu1bar_sv1_n3"
      | G_nu1bar_sv2_n3 -> "G_nu1bar_sv2_n3" | G_nu1bar_sv3_n3 -> "G_nu1bar_sv3_n3"
      | G_nu1bar_sv1_n4 -> "G_nu1bar_sv1_n4" | G_nu1bar_sv2_n4 -> "G_nu1bar_sv2_n4"
      | G_nu1bar_sv3_n4 -> "G_nu1bar_sv3_n4" | G_nu2bar_sv1_n1 -> "G_nu2bar_sv1_n1"
      | G_nu2bar_sv2_n1 -> "G_nu2bar_sv2_n1" | G_nu2bar_sv3_n1 -> "G_nu2bar_sv3_n1"
      | G_nu2bar_sv1_n2 -> "G_nu2bar_sv1_n2" | G_nu2bar_sv2_n2 -> "G_nu2bar_sv2_n2"
      | G_nu2bar_sv3_n2 -> "G_nu2bar_sv3_n2" | G_nu2bar_sv1_n3 -> "G_nu2bar_sv1_n3"
      | G_nu2bar_sv2_n3 -> "G_nu2bar_sv2_n3" | G_nu2bar_sv3_n3 -> "G_nu2bar_sv3_n3"
      | G_nu2bar_sv1_n4 -> "G_nu2bar_sv1_n4" | G_nu2bar_sv2_n4 -> "G_nu2bar_sv2_n4"
      | G_nu2bar_sv3_n4 -> "G_nu2bar_sv3_n4" | G_nu3bar_sv1_n1 -> "G_nu3bar_sv1_n1"
      | G_nu3bar_sv2_n1 -> "G_nu3bar_sv2_n1" | G_nu3bar_sv3_n1 -> "G_nu3bar_sv3_n1"
      | G_nu3bar_sv1_n2 -> "G_nu3bar_sv1_n2" | G_nu3bar_sv2_n2 -> "G_nu3bar_sv2_n2"
      | G_nu3bar_sv3_n2 -> "G_nu3bar_sv3_n2" | G_nu3bar_sv1_n3 -> "G_nu3bar_sv1_n3"
      | G_nu3bar_sv2_n3 -> "G_nu3bar_sv2_n3" | G_nu3bar_sv3_n3 -> "G_nu3bar_sv3_n3"
      | G_nu3bar_sv1_n4 -> "G_nu3bar_sv1_n4" | G_nu3bar_sv2_n4 -> "G_nu3bar_sv2_n4"
      | G_nu3bar_sv3_n4 -> "G_nu3bar_sv3_n4" | G_go_1_sd1c_d1 -> "G_go_1_sd1c_d1"
      | G_go_1_sd2c_d1 -> "G_go_1_sd2c_d1" | G_go_1_sd3c_d1 -> "G_go_1_sd3c_d1"
      | G_go_1_sd4c_d1 -> "G_go_1_sd4c_d1" | G_go_1_sd5c_d1 -> "G_go_1_sd5c_d1"
      | G_go_1_sd6c_d1 -> "G_go_1_sd6c_d1" | G_go_1_sd1c_d2 -> "G_go_1_sd1c_d2"
      | G_go_1_sd2c_d2 -> "G_go_1_sd2c_d2" | G_go_1_sd3c_d2 -> "G_go_1_sd3c_d2"
      | G_go_1_sd4c_d2 -> "G_go_1_sd4c_d2" | G_go_1_sd5c_d2 -> "G_go_1_sd5c_d2"
      | G_go_1_sd6c_d2 -> "G_go_1_sd6c_d2" | G_go_1_sd1c_d3 -> "G_go_1_sd1c_d3"
      | G_go_1_sd2c_d3 -> "G_go_1_sd2c_d3" | G_go_1_sd3c_d3 -> "G_go_1_sd3c_d3"
      | G_go_1_sd4c_d3 -> "G_go_1_sd4c_d3" | G_go_1_sd5c_d3 -> "G_go_1_sd5c_d3"
      | G_go_1_sd6c_d3 -> "G_go_1_sd6c_d3" | G_d1bar_h1_d1 -> "G_d1bar_h1_d1"
      | G_d1bar_h2_d1 -> "G_d1bar_h2_d1" | G_d1bar_h1_d2 -> "G_d1bar_h1_d2"
      | G_d1bar_h2_d2 -> "G_d1bar_h2_d2" | G_d1bar_h1_d3 -> "G_d1bar_h1_d3"
      | G_d1bar_h2_d3 -> "G_d1bar_h2_d3" | G_d2bar_h1_d1 -> "G_d2bar_h1_d1"
      | G_d2bar_h2_d1 -> "G_d2bar_h2_d1" | G_d2bar_h1_d2 -> "G_d2bar_h1_d2"
      | G_d2bar_h2_d2 -> "G_d2bar_h2_d2" | G_d2bar_h1_d3 -> "G_d2bar_h1_d3"
      | G_d2bar_h2_d3 -> "G_d2bar_h2_d3" | G_d3bar_h1_d1 -> "G_d3bar_h1_d1"
      | G_d3bar_h2_d1 -> "G_d3bar_h2_d1" | G_d3bar_h1_d2 -> "G_d3bar_h1_d2"
      | G_d3bar_h2_d2 -> "G_d3bar_h2_d2" | G_d3bar_h1_d3 -> "G_d3bar_h1_d3"
      | G_d3bar_h2_d3 -> "G_d3bar_h2_d3" | G_c1bar_su1c_d1 -> "G_c1bar_su1c_d1"
      | G_c1bar_su2c_d1 -> "G_c1bar_su2c_d1" | G_c1bar_su3c_d1 -> "G_c1bar_su3c_d1"
      | G_c1bar_su4c_d1 -> "G_c1bar_su4c_d1" | G_c1bar_su5c_d1 -> "G_c1bar_su5c_d1"
      | G_c1bar_su6c_d1 -> "G_c1bar_su6c_d1" | G_c1bar_su1c_d2 -> "G_c1bar_su1c_d2"
      | G_c1bar_su2c_d2 -> "G_c1bar_su2c_d2" | G_c1bar_su3c_d2 -> "G_c1bar_su3c_d2"
      | G_c1bar_su4c_d2 -> "G_c1bar_su4c_d2" | G_c1bar_su5c_d2 -> "G_c1bar_su5c_d2"
      | G_c1bar_su6c_d2 -> "G_c1bar_su6c_d2" | G_c1bar_su1c_d3 -> "G_c1bar_su1c_d3"
      | G_c1bar_su2c_d3 -> "G_c1bar_su2c_d3" | G_c1bar_su3c_d3 -> "G_c1bar_su3c_d3"
      | G_c1bar_su4c_d3 -> "G_c1bar_su4c_d3" | G_c1bar_su5c_d3 -> "G_c1bar_su5c_d3"
      | G_c1bar_su6c_d3 -> "G_c1bar_su6c_d3" | G_c2bar_su1c_d1 -> "G_c2bar_su1c_d1"
      | G_c2bar_su2c_d1 -> "G_c2bar_su2c_d1" | G_c2bar_su3c_d1 -> "G_c2bar_su3c_d1"
      | G_c2bar_su4c_d1 -> "G_c2bar_su4c_d1" | G_c2bar_su5c_d1 -> "G_c2bar_su5c_d1"
      | G_c2bar_su6c_d1 -> "G_c2bar_su6c_d1" | G_c2bar_su1c_d2 -> "G_c2bar_su1c_d2"
      | G_c2bar_su2c_d2 -> "G_c2bar_su2c_d2" | G_c2bar_su3c_d2 -> "G_c2bar_su3c_d2"
      | G_c2bar_su4c_d2 -> "G_c2bar_su4c_d2" | G_c2bar_su5c_d2 -> "G_c2bar_su5c_d2"
      | G_c2bar_su6c_d2 -> "G_c2bar_su6c_d2" | G_c2bar_su1c_d3 -> "G_c2bar_su1c_d3"
      | G_c2bar_su2c_d3 -> "G_c2bar_su2c_d3" | G_c2bar_su3c_d3 -> "G_c2bar_su3c_d3"
      | G_c2bar_su4c_d3 -> "G_c2bar_su4c_d3" | G_c2bar_su5c_d3 -> "G_c2bar_su5c_d3"
      | G_c2bar_su6c_d3 -> "G_c2bar_su6c_d3" | G_u1bar_hm2c_d1 -> "G_u1bar_hm2c_d1"
      | G_u1bar_hm2c_d2 -> "G_u1bar_hm2c_d2" | G_u1bar_hm2c_d3 -> "G_u1bar_hm2c_d3"
      | G_u2bar_hm2c_d1 -> "G_u2bar_hm2c_d1" | G_u2bar_hm2c_d2 -> "G_u2bar_hm2c_d2"
      | G_u2bar_hm2c_d3 -> "G_u2bar_hm2c_d3" | G_u3bar_hm2c_d1 -> "G_u3bar_hm2c_d1"
      | G_u3bar_hm2c_d2 -> "G_u3bar_hm2c_d2" | G_u3bar_hm2c_d3 -> "G_u3bar_hm2c_d3"
      | G_e1bar_h1_e1 -> "G_e1bar_h1_e1" | G_e1bar_h2_e1 -> "G_e1bar_h2_e1"
      | G_e1bar_h1_e2 -> "G_e1bar_h1_e2" | G_e1bar_h2_e2 -> "G_e1bar_h2_e2"
      | G_e1bar_h1_e3 -> "G_e1bar_h1_e3" | G_e1bar_h2_e3 -> "G_e1bar_h2_e3"
      | G_e2bar_h1_e1 -> "G_e2bar_h1_e1" | G_e2bar_h2_e1 -> "G_e2bar_h2_e1"
      | G_e2bar_h1_e2 -> "G_e2bar_h1_e2" | G_e2bar_h2_e2 -> "G_e2bar_h2_e2"
      | G_e2bar_h1_e3 -> "G_e2bar_h1_e3" | G_e2bar_h2_e3 -> "G_e2bar_h2_e3"
      | G_e3bar_h1_e1 -> "G_e3bar_h1_e1" | G_e3bar_h2_e1 -> "G_e3bar_h2_e1"
      | G_e3bar_h1_e2 -> "G_e3bar_h1_e2" | G_e3bar_h2_e2 -> "G_e3bar_h2_e2"
      | G_e3bar_h1_e3 -> "G_e3bar_h1_e3" | G_e3bar_h2_e3 -> "G_e3bar_h2_e3"
      | G_c1bar_sv1c_e1 -> "G_c1bar_sv1c_e1" | G_c1bar_sv2c_e1 -> "G_c1bar_sv2c_e1"
      | G_c1bar_sv3c_e1 -> "G_c1bar_sv3c_e1" | G_c1bar_sv1c_e2 -> "G_c1bar_sv1c_e2"
      | G_c1bar_sv2c_e2 -> "G_c1bar_sv2c_e2" | G_c1bar_sv3c_e2 -> "G_c1bar_sv3c_e2"
      | G_c1bar_sv1c_e3 -> "G_c1bar_sv1c_e3" | G_c1bar_sv2c_e3 -> "G_c1bar_sv2c_e3"
      | G_c1bar_sv3c_e3 -> "G_c1bar_sv3c_e3" | G_c2bar_sv1c_e1 -> "G_c2bar_sv1c_e1"
      | G_c2bar_sv2c_e1 -> "G_c2bar_sv2c_e1" | G_c2bar_sv3c_e1 -> "G_c2bar_sv3c_e1"
      | G_c2bar_sv1c_e2 -> "G_c2bar_sv1c_e2" | G_c2bar_sv2c_e2 -> "G_c2bar_sv2c_e2"
      | G_c2bar_sv3c_e2 -> "G_c2bar_sv3c_e2" | G_c2bar_sv1c_e3 -> "G_c2bar_sv1c_e3"
      | G_c2bar_sv2c_e3 -> "G_c2bar_sv2c_e3" | G_c2bar_sv3c_e3 -> "G_c2bar_sv3c_e3"
      | G_nu1bar_hm2c_e1 -> "G_nu1bar_hm2c_e1"
      | G_nu1bar_hm2c_e2 -> "G_nu1bar_hm2c_e2"
      | G_nu1bar_hm2c_e3 -> "G_nu1bar_hm2c_e3"
      | G_nu2bar_hm2c_e1 -> "G_nu2bar_hm2c_e1"
      | G_nu2bar_hm2c_e2 -> "G_nu2bar_hm2c_e2"
      | G_nu2bar_hm2c_e3 -> "G_nu2bar_hm2c_e3"
      | G_nu3bar_hm2c_e1 -> "G_nu3bar_hm2c_e1"
      | G_nu3bar_hm2c_e2 -> "G_nu3bar_hm2c_e2"
      | G_nu3bar_hm2c_e3 -> "G_nu3bar_hm2c_e3" | G_go_1_su1c_u1 -> "G_go_1_su1c_u1"
      | G_go_1_su2c_u1 -> "G_go_1_su2c_u1" | G_go_1_su3c_u1 -> "G_go_1_su3c_u1"
      | G_go_1_su4c_u1 -> "G_go_1_su4c_u1" | G_go_1_su5c_u1 -> "G_go_1_su5c_u1"
      | G_go_1_su6c_u1 -> "G_go_1_su6c_u1" | G_go_1_su1c_u2 -> "G_go_1_su1c_u2"
      | G_go_1_su2c_u2 -> "G_go_1_su2c_u2" | G_go_1_su3c_u2 -> "G_go_1_su3c_u2"
      | G_go_1_su4c_u2 -> "G_go_1_su4c_u2" | G_go_1_su5c_u2 -> "G_go_1_su5c_u2"
      | G_go_1_su6c_u2 -> "G_go_1_su6c_u2" | G_go_1_su1c_u3 -> "G_go_1_su1c_u3"
      | G_go_1_su2c_u3 -> "G_go_1_su2c_u3" | G_go_1_su3c_u3 -> "G_go_1_su3c_u3"
      | G_go_1_su4c_u3 -> "G_go_1_su4c_u3" | G_go_1_su5c_u3 -> "G_go_1_su5c_u3"
      | G_go_1_su6c_u3 -> "G_go_1_su6c_u3" | G_u1bar_h1_u1 -> "G_u1bar_h1_u1"
      | G_u1bar_h2_u1 -> "G_u1bar_h2_u1" | G_u1bar_h1_u2 -> "G_u1bar_h1_u2"
      | G_u1bar_h2_u2 -> "G_u1bar_h2_u2" | G_u1bar_h1_u3 -> "G_u1bar_h1_u3"
      | G_u1bar_h2_u3 -> "G_u1bar_h2_u3" | G_u2bar_h1_u1 -> "G_u2bar_h1_u1"
      | G_u2bar_h2_u1 -> "G_u2bar_h2_u1" | G_u2bar_h1_u2 -> "G_u2bar_h1_u2"
      | G_u2bar_h2_u2 -> "G_u2bar_h2_u2" | G_u2bar_h1_u3 -> "G_u2bar_h1_u3"
      | G_u2bar_h2_u3 -> "G_u2bar_h2_u3" | G_u3bar_h1_u1 -> "G_u3bar_h1_u1"
      | G_u3bar_h2_u1 -> "G_u3bar_h2_u1" | G_u3bar_h1_u2 -> "G_u3bar_h1_u2"
      | G_u3bar_h2_u2 -> "G_u3bar_h2_u2" | G_u3bar_h1_u3 -> "G_u3bar_h1_u3"
      | G_u3bar_h2_u3 -> "G_u3bar_h2_u3" | G_d1bar_hm2_u1 -> "G_d1bar_hm2_u1"
      | G_d1bar_hm2_u2 -> "G_d1bar_hm2_u2" | G_d1bar_hm2_u3 -> "G_d1bar_hm2_u3"
      | G_d2bar_hm2_u1 -> "G_d2bar_hm2_u1" | G_d2bar_hm2_u2 -> "G_d2bar_hm2_u2"
      | G_d2bar_hm2_u3 -> "G_d2bar_hm2_u3" | G_d3bar_hm2_u1 -> "G_d3bar_hm2_u1"
      | G_d3bar_hm2_u2 -> "G_d3bar_hm2_u2" | G_d3bar_hm2_u3 -> "G_d3bar_hm2_u3"
      | G_e1bar_hm2_nu1 -> "G_e1bar_hm2_nu1" | G_e1bar_hm2_nu2 -> "G_e1bar_hm2_nu2"
      | G_e1bar_hm2_nu3 -> "G_e1bar_hm2_nu3" | G_e2bar_hm2_nu1 -> "G_e2bar_hm2_nu1"
      | G_e2bar_hm2_nu2 -> "G_e2bar_hm2_nu2" | G_e2bar_hm2_nu3 -> "G_e2bar_hm2_nu3"
      | G_e3bar_hm2_nu1 -> "G_e3bar_hm2_nu1" | G_e3bar_hm2_nu2 -> "G_e3bar_hm2_nu2"
      | G_e3bar_hm2_nu3 -> "G_e3bar_hm2_nu3" | G_d1bar_sd1_go_1 -> "G_d1bar_sd1_go_1"
      | G_d1bar_sd2_go_1 -> "G_d1bar_sd2_go_1"
      | G_d1bar_sd3_go_1 -> "G_d1bar_sd3_go_1"
      | G_d1bar_sd4_go_1 -> "G_d1bar_sd4_go_1"
      | G_d1bar_sd5_go_1 -> "G_d1bar_sd5_go_1"
      | G_d1bar_sd6_go_1 -> "G_d1bar_sd6_go_1"
      | G_d2bar_sd1_go_1 -> "G_d2bar_sd1_go_1"
      | G_d2bar_sd2_go_1 -> "G_d2bar_sd2_go_1"
      | G_d2bar_sd3_go_1 -> "G_d2bar_sd3_go_1"
      | G_d2bar_sd4_go_1 -> "G_d2bar_sd4_go_1"
      | G_d2bar_sd5_go_1 -> "G_d2bar_sd5_go_1"
      | G_d2bar_sd6_go_1 -> "G_d2bar_sd6_go_1"
      | G_d3bar_sd1_go_1 -> "G_d3bar_sd1_go_1"
      | G_d3bar_sd2_go_1 -> "G_d3bar_sd2_go_1"
      | G_d3bar_sd3_go_1 -> "G_d3bar_sd3_go_1"
      | G_d3bar_sd4_go_1 -> "G_d3bar_sd4_go_1"
      | G_d3bar_sd5_go_1 -> "G_d3bar_sd5_go_1"
      | G_d3bar_sd6_go_1 -> "G_d3bar_sd6_go_1"
      | G_u1bar_su1_go_1 -> "G_u1bar_su1_go_1"
      | G_u1bar_su2_go_1 -> "G_u1bar_su2_go_1"
      | G_u1bar_su3_go_1 -> "G_u1bar_su3_go_1"
      | G_u1bar_su4_go_1 -> "G_u1bar_su4_go_1"
      | G_u1bar_su5_go_1 -> "G_u1bar_su5_go_1"
      | G_u1bar_su6_go_1 -> "G_u1bar_su6_go_1"
      | G_u2bar_su1_go_1 -> "G_u2bar_su1_go_1"
      | G_u2bar_su2_go_1 -> "G_u2bar_su2_go_1"
      | G_u2bar_su3_go_1 -> "G_u2bar_su3_go_1"
      | G_u2bar_su4_go_1 -> "G_u2bar_su4_go_1"
      | G_u2bar_su5_go_1 -> "G_u2bar_su5_go_1"
      | G_u2bar_su6_go_1 -> "G_u2bar_su6_go_1"
      | G_u3bar_su1_go_1 -> "G_u3bar_su1_go_1"
      | G_u3bar_su2_go_1 -> "G_u3bar_su2_go_1"
      | G_u3bar_su3_go_1 -> "G_u3bar_su3_go_1"
      | G_u3bar_su4_go_1 -> "G_u3bar_su4_go_1"
      | G_u3bar_su5_go_1 -> "G_u3bar_su5_go_1"
      | G_u3bar_su6_go_1 -> "G_u3bar_su6_go_1"
      | G_c1bar_sd1_u1bar -> "G_c1bar_sd1_u1bar"
      | G_c1bar_sd2_u1bar -> "G_c1bar_sd2_u1bar"
      | G_c1bar_sd3_u1bar -> "G_c1bar_sd3_u1bar"
      | G_c1bar_sd4_u1bar -> "G_c1bar_sd4_u1bar"
      | G_c1bar_sd5_u1bar -> "G_c1bar_sd5_u1bar"
      | G_c1bar_sd6_u1bar -> "G_c1bar_sd6_u1bar"
      | G_c1bar_sd1_u2bar -> "G_c1bar_sd1_u2bar"
      | G_c1bar_sd2_u2bar -> "G_c1bar_sd2_u2bar"
      | G_c1bar_sd3_u2bar -> "G_c1bar_sd3_u2bar"
      | G_c1bar_sd4_u2bar -> "G_c1bar_sd4_u2bar"
      | G_c1bar_sd5_u2bar -> "G_c1bar_sd5_u2bar"
      | G_c1bar_sd6_u2bar -> "G_c1bar_sd6_u2bar"
      | G_c1bar_sd1_u3bar -> "G_c1bar_sd1_u3bar"
      | G_c1bar_sd2_u3bar -> "G_c1bar_sd2_u3bar"
      | G_c1bar_sd3_u3bar -> "G_c1bar_sd3_u3bar"
      | G_c1bar_sd4_u3bar -> "G_c1bar_sd4_u3bar"
      | G_c1bar_sd5_u3bar -> "G_c1bar_sd5_u3bar"
      | G_c1bar_sd6_u3bar -> "G_c1bar_sd6_u3bar"
      | G_c2bar_sd1_u1bar -> "G_c2bar_sd1_u1bar"
      | G_c2bar_sd2_u1bar -> "G_c2bar_sd2_u1bar"
      | G_c2bar_sd3_u1bar -> "G_c2bar_sd3_u1bar"
      | G_c2bar_sd4_u1bar -> "G_c2bar_sd4_u1bar"
      | G_c2bar_sd5_u1bar -> "G_c2bar_sd5_u1bar"
      | G_c2bar_sd6_u1bar -> "G_c2bar_sd6_u1bar"
      | G_c2bar_sd1_u2bar -> "G_c2bar_sd1_u2bar"
      | G_c2bar_sd2_u2bar -> "G_c2bar_sd2_u2bar"
      | G_c2bar_sd3_u2bar -> "G_c2bar_sd3_u2bar"
      | G_c2bar_sd4_u2bar -> "G_c2bar_sd4_u2bar"
      | G_c2bar_sd5_u2bar -> "G_c2bar_sd5_u2bar"
      | G_c2bar_sd6_u2bar -> "G_c2bar_sd6_u2bar"
      | G_c2bar_sd1_u3bar -> "G_c2bar_sd1_u3bar"
      | G_c2bar_sd2_u3bar -> "G_c2bar_sd2_u3bar"
      | G_c2bar_sd3_u3bar -> "G_c2bar_sd3_u3bar"
      | G_c2bar_sd4_u3bar -> "G_c2bar_sd4_u3bar"
      | G_c2bar_sd5_u3bar -> "G_c2bar_sd5_u3bar"
      | G_c2bar_sd6_u3bar -> "G_c2bar_sd6_u3bar"
      | G_c1bar_se1_nu1bar -> "G_c1bar_se1_nu1bar"
      | G_c1bar_se2_nu1bar -> "G_c1bar_se2_nu1bar"
      | G_c1bar_se3_nu1bar -> "G_c1bar_se3_nu1bar"
      | G_c1bar_se4_nu1bar -> "G_c1bar_se4_nu1bar"
      | G_c1bar_se5_nu1bar -> "G_c1bar_se5_nu1bar"
      | G_c1bar_se6_nu1bar -> "G_c1bar_se6_nu1bar"
      | G_c1bar_se1_nu2bar -> "G_c1bar_se1_nu2bar"
      | G_c1bar_se2_nu2bar -> "G_c1bar_se2_nu2bar"
      | G_c1bar_se3_nu2bar -> "G_c1bar_se3_nu2bar"
      | G_c1bar_se4_nu2bar -> "G_c1bar_se4_nu2bar"
      | G_c1bar_se5_nu2bar -> "G_c1bar_se5_nu2bar"
      | G_c1bar_se6_nu2bar -> "G_c1bar_se6_nu2bar"
      | G_c1bar_se1_nu3bar -> "G_c1bar_se1_nu3bar"
      | G_c1bar_se2_nu3bar -> "G_c1bar_se2_nu3bar"
      | G_c1bar_se3_nu3bar -> "G_c1bar_se3_nu3bar"
      | G_c1bar_se4_nu3bar -> "G_c1bar_se4_nu3bar"
      | G_c1bar_se5_nu3bar -> "G_c1bar_se5_nu3bar"
      | G_c1bar_se6_nu3bar -> "G_c1bar_se6_nu3bar"
      | G_c2bar_se1_nu1bar -> "G_c2bar_se1_nu1bar"
      | G_c2bar_se2_nu1bar -> "G_c2bar_se2_nu1bar"
      | G_c2bar_se3_nu1bar -> "G_c2bar_se3_nu1bar"
      | G_c2bar_se4_nu1bar -> "G_c2bar_se4_nu1bar"
      | G_c2bar_se5_nu1bar -> "G_c2bar_se5_nu1bar"
      | G_c2bar_se6_nu1bar -> "G_c2bar_se6_nu1bar"
      | G_c2bar_se1_nu2bar -> "G_c2bar_se1_nu2bar"
      | G_c2bar_se2_nu2bar -> "G_c2bar_se2_nu2bar"
      | G_c2bar_se3_nu2bar -> "G_c2bar_se3_nu2bar"
      | G_c2bar_se4_nu2bar -> "G_c2bar_se4_nu2bar"
      | G_c2bar_se5_nu2bar -> "G_c2bar_se5_nu2bar"
      | G_c2bar_se6_nu2bar -> "G_c2bar_se6_nu2bar"
      | G_c2bar_se1_nu3bar -> "G_c2bar_se1_nu3bar"
      | G_c2bar_se2_nu3bar -> "G_c2bar_se2_nu3bar"
      | G_c2bar_se3_nu3bar -> "G_c2bar_se3_nu3bar"
      | G_c2bar_se4_nu3bar -> "G_c2bar_se4_nu3bar"
      | G_c2bar_se5_nu3bar -> "G_c2bar_se5_nu3bar"
      | G_c2bar_se6_nu3bar -> "G_c2bar_se6_nu3bar" | G_n1_wmc_c1 -> "G_n1_wmc_c1"
      | G_n1_wmc_c2 -> "G_n1_wmc_c2" | G_n2_wmc_c1 -> "G_n2_wmc_c1"
      | G_n2_wmc_c2 -> "G_n2_wmc_c2" | G_n3_wmc_c1 -> "G_n3_wmc_c1"
      | G_n3_wmc_c2 -> "G_n3_wmc_c2" | G_n4_wmc_c1 -> "G_n4_wmc_c1"
      | G_n4_wmc_c2 -> "G_n4_wmc_c2" | G_c1bar_a_1_c1 -> "G_c1bar_a_1_c1"
      | G_c1bar_a_1_c2 -> "G_c1bar_a_1_c2" | G_c2bar_a_1_c1 -> "G_c2bar_a_1_c1"
      | G_c2bar_a_1_c2 -> "G_c2bar_a_1_c2" | G_c1bar_z_1_c1 -> "G_c1bar_z_1_c1"
      | G_c1bar_z_1_c2 -> "G_c1bar_z_1_c2" | G_c2bar_z_1_c1 -> "G_c2bar_z_1_c1"
      | G_c2bar_z_1_c2 -> "G_c2bar_z_1_c2" | G_n1_z_1_n1 -> "G_n1_z_1_n1"
      | G_n1_z_1_n2 -> "G_n1_z_1_n2" | G_n1_z_1_n3 -> "G_n1_z_1_n3"
      | G_n1_z_1_n4 -> "G_n1_z_1_n4" | G_n2_z_1_n2 -> "G_n2_z_1_n2"
      | G_n2_z_1_n3 -> "G_n2_z_1_n3" | G_n2_z_1_n4 -> "G_n2_z_1_n4"
      | G_n3_z_1_n3 -> "G_n3_z_1_n3" | G_n3_z_1_n4 -> "G_n3_z_1_n4"
      | G_n4_z_1_n4 -> "G_n4_z_1_n4" | G_c1bar_wm_1_n1 -> "G_c1bar_wm_1_n1"
      | G_c1bar_wm_1_n2 -> "G_c1bar_wm_1_n2" | G_c1bar_wm_1_n3 -> "G_c1bar_wm_1_n3"
      | G_c1bar_wm_1_n4 -> "G_c1bar_wm_1_n4" | G_c2bar_wm_1_n1 -> "G_c2bar_wm_1_n1"
      | G_c2bar_wm_1_n2 -> "G_c2bar_wm_1_n2" | G_c2bar_wm_1_n3 -> "G_c2bar_wm_1_n3"
      | G_c2bar_wm_1_n4 -> "G_c2bar_wm_1_n4" | G_d1bar_g_1_d1 -> "G_d1bar_g_1_d1"
      | G_d1bar_a_1_d1 -> "G_d1bar_a_1_d1" | G_d1bar_z_1_d1 -> "G_d1bar_z_1_d1"
      | G_u1bar_wmc_d1 -> "G_u1bar_wmc_d1" | G_u1bar_wmc_d2 -> "G_u1bar_wmc_d2"
      | G_u1bar_wmc_d3 -> "G_u1bar_wmc_d3" | G_u2bar_wmc_d1 -> "G_u2bar_wmc_d1"
      | G_u2bar_wmc_d2 -> "G_u2bar_wmc_d2" | G_u2bar_wmc_d3 -> "G_u2bar_wmc_d3"
      | G_u3bar_wmc_d1 -> "G_u3bar_wmc_d1" | G_u3bar_wmc_d2 -> "G_u3bar_wmc_d2"
      | G_u3bar_wmc_d3 -> "G_u3bar_wmc_d3" | G_e1bar_a_1_e1 -> "G_e1bar_a_1_e1"
      | G_e1bar_z_1_e1 -> "G_e1bar_z_1_e1" | G_nu1bar_wmc_e1 -> "G_nu1bar_wmc_e1"
      | G_nu1bar_wmc_e2 -> "G_nu1bar_wmc_e2" | G_nu1bar_wmc_e3 -> "G_nu1bar_wmc_e3"
      | G_nu2bar_wmc_e1 -> "G_nu2bar_wmc_e1" | G_nu2bar_wmc_e2 -> "G_nu2bar_wmc_e2"
      | G_nu2bar_wmc_e3 -> "G_nu2bar_wmc_e3" | G_nu3bar_wmc_e1 -> "G_nu3bar_wmc_e1"
      | G_nu3bar_wmc_e2 -> "G_nu3bar_wmc_e2" | G_nu3bar_wmc_e3 -> "G_nu3bar_wmc_e3"
      | G_u1bar_a_1_u1 -> "G_u1bar_a_1_u1" | G_d1bar_wm_1_u1 -> "G_d1bar_wm_1_u1"
      | G_d1bar_wm_1_u2 -> "G_d1bar_wm_1_u2" | G_d1bar_wm_1_u3 -> "G_d1bar_wm_1_u3"
      | G_d2bar_wm_1_u1 -> "G_d2bar_wm_1_u1" | G_d2bar_wm_1_u2 -> "G_d2bar_wm_1_u2"
      | G_d2bar_wm_1_u3 -> "G_d2bar_wm_1_u3" | G_d3bar_wm_1_u1 -> "G_d3bar_wm_1_u1"
      | G_d3bar_wm_1_u2 -> "G_d3bar_wm_1_u2" | G_d3bar_wm_1_u3 -> "G_d3bar_wm_1_u3"
      | G_u1bar_z_1_u1 -> "G_u1bar_z_1_u1" | G_e1bar_wm_1_nu1 -> "G_e1bar_wm_1_nu1"
      | G_e1bar_wm_1_nu2 -> "G_e1bar_wm_1_nu2"
      | G_e1bar_wm_1_nu3 -> "G_e1bar_wm_1_nu3"
      | G_e2bar_wm_1_nu1 -> "G_e2bar_wm_1_nu1"
      | G_e2bar_wm_1_nu2 -> "G_e2bar_wm_1_nu2"
      | G_e2bar_wm_1_nu3 -> "G_e2bar_wm_1_nu3"
      | G_e3bar_wm_1_nu1 -> "G_e3bar_wm_1_nu1"
      | G_e3bar_wm_1_nu2 -> "G_e3bar_wm_1_nu2"
      | G_e3bar_wm_1_nu3 -> "G_e3bar_wm_1_nu3"
      | G_nu1bar_z_1_nu1 -> "G_nu1bar_z_1_nu1" | G_go_1_g_1_go_1 -> "G_go_1_g_1_go_1"
      | G_g_1_g_1_g_1 -> "G_g_1_g_1_g_1" | G_wmc_a_1_wm_1 -> "G_wmc_a_1_wm_1"
      | G_wmc_wm_1_z_1 -> "G_wmc_wm_1_z_1" | G_g_1_g_1_g_1_g_1 -> "G_g_1_g_1_g_1_g_1"
      | G_wmc_a_1_a_1_wm_1 -> "G_wmc_a_1_a_1_wm_1"
      | G_wmc_a_1_wm_1_z_1 -> "G_wmc_a_1_wm_1_z_1"
      | G_wmc_a_1_wm_1_z_1_1 -> "G_wmc_a_1_wm_1_z_1_1"
      | G_wmc_wmc_wm_1_wm_1 -> "G_wmc_wmc_wm_1_wm_1"
      | G_wmc_wm_1_z_1_z_1 -> "G_wmc_wm_1_z_1_z_1"

   (* Vertices and fusions *)

   let max_degree () = 4

   let vertices_3 = [
      (FRS (S2_Ah Ah2), FRS (S2_Ah Ah2), FRS (S1_H H1)),
       Scalar_Scalar_Scalar 1,
       G_ah2_ah2_h1
      ;
      (FRS (S2_Ah Ah2), FRS (S2_Ah Ah2), FRS (S1_H H2)),
       Scalar_Scalar_Scalar 1,
       G_ah2_ah2_h2
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd1_sd1c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd1_sd2c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd1_sd3c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd1_sd4c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd1_sd5c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd1_sd6c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd2_sd1c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd2_sd2c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd2_sd3c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd2_sd4c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd2_sd5c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd2_sd6c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd3_sd1c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd3_sd2c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd3_sd3c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd3_sd4c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd3_sd5c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd3_sd6c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd4_sd1c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd4_sd2c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd4_sd3c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd4_sd4c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd4_sd5c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd4_sd6c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd5_sd1c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd5_sd2c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd5_sd3c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd5_sd4c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd5_sd5c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd5_sd6c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd6_sd1c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd6_sd2c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd6_sd3c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd6_sd4c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd6_sd5c
      ;
      (FRS (S2_Ah Ah2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_sd6_sd6c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se1), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se1_se1c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se1), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se1_se2c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se1), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se1_se3c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se1), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se1_se4c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se1), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se1_se5c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se1), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se1_se6c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se2), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se2_se1c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se2), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se2_se2c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se2), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se2_se3c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se2), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se2_se4c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se2), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se2_se5c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se2), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se2_se6c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se3), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se3_se1c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se3), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se3_se2c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se3), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se3_se3c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se3), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se3_se4c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se3), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se3_se5c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se3), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se3_se6c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se4), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se4_se1c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se4), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se4_se2c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se4), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se4_se3c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se4), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se4_se4c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se4), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se4_se5c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se4), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se4_se6c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se5), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se5_se1c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se5), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se5_se2c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se5), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se5_se3c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se5), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se5_se4c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se5), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se5_se5c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se5), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se5_se6c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se6), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se6_se1c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se6), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se6_se2c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se6), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se6_se3c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se6), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se6_se4c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se6), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se6_se5c
      ;
      (FRS (S2_Ah Ah2), FRS (S12_Se Se6), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_se6_se6c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su1), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su1_su1c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su1), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su1_su2c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su1), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su1_su3c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su1), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su1_su4c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su1), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su1_su5c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su1), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su1_su6c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su2), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su2_su1c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su2), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su2_su2c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su2), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su2_su3c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su2), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su2_su4c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su2), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su2_su5c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su2), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su2_su6c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su3), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su3_su1c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su3), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su3_su2c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su3), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su3_su3c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su3), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su3_su4c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su3), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su3_su5c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su3), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su3_su6c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su4), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su4_su1c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su4), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su4_su2c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su4), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su4_su3c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su4), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su4_su4c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su4), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su4_su5c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su4), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su4_su6c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su5), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su5_su1c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su5), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su5_su2c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su5), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su5_su3c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su5), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su5_su4c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su5), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su5_su5c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su5), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su5_su6c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su6), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su6_su1c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su6), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su6_su2c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su6), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su6_su3c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su6), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su6_su4c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su6), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su6_su5c
      ;
      (FRS (S2_Ah Ah2), FRS (S13_Su Su6), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_ah2_su6_su6c
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRS (S1_H H1)),
       Scalar_Scalar_Scalar 1,
       G_h1_h1_h1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRS (S1_H H2)),
       Scalar_Scalar_Scalar 1,
       G_h1_h1_h2
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRS (S1_H H2)),
       Scalar_Scalar_Scalar 1,
       G_h1_h2_h2
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRS (S1_H H2)),
       Scalar_Scalar_Scalar 1,
       G_h2_h2_h2
      ;
      (FRS (S1_H H1), FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_hm2_hm2c
      ;
      (FRS (S1_H H2), FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_hm2_hm2c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd1_sd1c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd1_sd2c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd1_sd3c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd1_sd4c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd1_sd5c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd1_sd6c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd2_sd1c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd2_sd2c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd2_sd3c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd2_sd4c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd2_sd5c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd2_sd6c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd3_sd1c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd3_sd2c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd3_sd3c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd3_sd4c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd3_sd5c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd3_sd6c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd4_sd1c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd4_sd2c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd4_sd3c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd4_sd4c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd4_sd5c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd4_sd6c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd5_sd1c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd5_sd2c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd5_sd3c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd5_sd4c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd5_sd5c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd5_sd6c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd6_sd1c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd6_sd2c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd6_sd3c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd6_sd4c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd6_sd5c
      ;
      (FRS (S1_H H1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sd6_sd6c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd1_sd1c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd1_sd2c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd1_sd3c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd1_sd4c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd1_sd5c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd1_sd6c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd2_sd1c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd2_sd2c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd2_sd3c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd2_sd4c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd2_sd5c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd2_sd6c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd3_sd1c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd3_sd2c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd3_sd3c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd3_sd4c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd3_sd5c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd3_sd6c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd4_sd1c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd4_sd2c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd4_sd3c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd4_sd4c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd4_sd5c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd4_sd6c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd5_sd1c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd5_sd2c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd5_sd3c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd5_sd4c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd5_sd5c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd5_sd6c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd6_sd1c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd6_sd2c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd6_sd3c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd6_sd4c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd6_sd5c
      ;
      (FRS (S1_H H2), FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sd6_sd6c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se1), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se1_se1c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se1), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se1_se2c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se1), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se1_se3c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se1), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se1_se4c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se1), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se1_se5c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se1), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se1_se6c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se2), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se2_se1c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se2), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se2_se2c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se2), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se2_se3c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se2), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se2_se4c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se2), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se2_se5c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se2), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se2_se6c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se3), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se3_se1c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se3), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se3_se2c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se3), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se3_se3c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se3), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se3_se4c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se3), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se3_se5c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se3), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se3_se6c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se4), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se4_se1c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se4), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se4_se2c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se4), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se4_se3c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se4), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se4_se4c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se4), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se4_se5c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se4), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se4_se6c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se5), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se5_se1c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se5), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se5_se2c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se5), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se5_se3c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se5), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se5_se4c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se5), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se5_se5c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se5), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se5_se6c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se6), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se6_se1c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se6), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se6_se2c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se6), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se6_se3c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se6), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se6_se4c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se6), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se6_se5c
      ;
      (FRS (S1_H H1), FRS (S12_Se Se6), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_se6_se6c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se1), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se1_se1c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se1), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se1_se2c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se1), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se1_se3c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se1), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se1_se4c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se1), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se1_se5c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se1), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se1_se6c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se2), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se2_se1c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se2), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se2_se2c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se2), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se2_se3c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se2), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se2_se4c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se2), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se2_se5c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se2), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se2_se6c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se3), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se3_se1c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se3), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se3_se2c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se3), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se3_se3c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se3), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se3_se4c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se3), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se3_se5c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se3), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se3_se6c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se4), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se4_se1c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se4), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se4_se2c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se4), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se4_se3c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se4), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se4_se4c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se4), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se4_se5c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se4), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se4_se6c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se5), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se5_se1c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se5), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se5_se2c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se5), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se5_se3c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se5), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se5_se4c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se5), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se5_se5c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se5), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se5_se6c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se6), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se6_se1c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se6), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se6_se2c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se6), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se6_se3c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se6), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se6_se4c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se6), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se6_se5c
      ;
      (FRS (S1_H H2), FRS (S12_Se Se6), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_se6_se6c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su1), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su1_su1c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su1), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su1_su2c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su1), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su1_su3c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su1), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su1_su4c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su1), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su1_su5c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su1), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su1_su6c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su2), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su2_su1c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su2), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su2_su2c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su2), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su2_su3c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su2), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su2_su4c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su2), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su2_su5c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su2), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su2_su6c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su3), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su3_su1c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su3), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su3_su2c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su3), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su3_su3c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su3), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su3_su4c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su3), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su3_su5c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su3), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su3_su6c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su4), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su4_su1c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su4), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su4_su2c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su4), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su4_su3c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su4), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su4_su4c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su4), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su4_su5c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su4), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su4_su6c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su5), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su5_su1c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su5), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su5_su2c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su5), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su5_su3c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su5), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su5_su4c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su5), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su5_su5c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su5), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su5_su6c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su6), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su6_su1c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su6), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su6_su2c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su6), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su6_su3c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su6), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su6_su4c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su6), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su6_su5c
      ;
      (FRS (S1_H H1), FRS (S13_Su Su6), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h1_su6_su6c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su1), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su1_su1c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su1), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su1_su2c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su1), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su1_su3c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su1), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su1_su4c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su1), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su1_su5c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su1), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su1_su6c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su2), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su2_su1c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su2), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su2_su2c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su2), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su2_su3c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su2), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su2_su4c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su2), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su2_su5c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su2), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su2_su6c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su3), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su3_su1c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su3), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su3_su2c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su3), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su3_su3c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su3), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su3_su4c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su3), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su3_su5c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su3), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su3_su6c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su4), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su4_su1c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su4), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su4_su2c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su4), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su4_su3c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su4), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su4_su4c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su4), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su4_su5c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su4), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su4_su6c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su5), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su5_su1c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su5), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su5_su2c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su5), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su5_su3c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su5), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su5_su4c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su5), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su5_su5c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su5), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su5_su6c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su6), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su6_su1c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su6), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su6_su2c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su6), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su6_su3c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su6), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su6_su4c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su6), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su6_su5c
      ;
      (FRS (S1_H H2), FRS (S13_Su Su6), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_h2_su6_su6c
      ;
      (FRS (S1_H H1), FRS (S11_Sv Sv1), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sv1_sv1c
      ;
      (FRS (S1_H H1), FRS (S11_Sv Sv2), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sv1_sv1c
      ;
      (FRS (S1_H H1), FRS (S11_Sv Sv3), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_h1_sv1_sv1c
      ;
      (FRS (S1_H H2), FRS (S11_Sv Sv1), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sv1_sv1c
      ;
      (FRS (S1_H H2), FRS (S11_Sv Sv2), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sv1_sv1c
      ;
      (FRS (S1_H H2), FRS (S11_Sv Sv3), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_h2_sv1_sv1c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su1), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su1_sd1c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su1), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su1_sd2c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su1), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su1_sd3c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su1), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su1_sd4c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su1), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su1_sd5c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su1), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su1_sd6c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su2), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su2_sd1c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su2), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su2_sd2c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su2), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su2_sd3c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su2), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su2_sd4c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su2), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su2_sd5c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su2), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su2_sd6c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su3), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su3_sd1c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su3), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su3_sd2c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su3), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su3_sd3c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su3), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su3_sd4c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su3), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su3_sd5c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su3), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su3_sd6c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su4), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su4_sd1c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su4), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su4_sd2c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su4), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su4_sd3c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su4), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su4_sd4c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su4), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su4_sd5c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su4), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su4_sd6c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su5), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su5_sd1c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su5), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su5_sd2c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su5), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su5_sd3c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su5), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su5_sd4c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su5), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su5_sd5c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su5), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su5_sd6c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su6), FRS (S14_Sd Sd1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su6_sd1c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su6), FRS (S14_Sd Sd2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su6_sd2c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su6), FRS (S14_Sd Sd3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su6_sd3c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su6), FRS (S14_Sd Sd4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su6_sd4c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su6), FRS (S14_Sd Sd5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su6_sd5c
      ;
      (FRS (S3_Hm Hm2), FRS (S13_Su Su6), FRS (S14_Sd Sd6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_su6_sd6c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv1), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv1_se1c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv1), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv1_se2c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv1), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv1_se3c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv1), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv1_se4c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv1), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv1_se5c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv1), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv1_se6c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv2), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv2_se1c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv2), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv2_se2c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv2), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv2_se3c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv2), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv2_se4c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv2), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv2_se5c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv2), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv2_se6c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv3), FRS (S12_Se Se1c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv3_se1c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv3), FRS (S12_Se Se2c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv3_se2c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv3), FRS (S12_Se Se3c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv3_se3c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv3), FRS (S12_Se Se4c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv3_se4c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv3), FRS (S12_Se Se5c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv3_se5c
      ;
      (FRS (S3_Hm Hm2), FRS (S11_Sv Sv3), FRS (S12_Se Se6c)),
       Scalar_Scalar_Scalar 1,
       G_hm2_sv3_se6c
      ;
      (FRS (S14_Sd Sd1), FRS (S3_Hm Hm2c), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_sd1_hm2c_su1c
      ;
      (FRS (S14_Sd Sd1), FRS (S3_Hm Hm2c), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_sd1_hm2c_su2c
      ;
      (FRS (S14_Sd Sd1), FRS (S3_Hm Hm2c), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_sd1_hm2c_su3c
      ;
      (FRS (S14_Sd Sd1), FRS (S3_Hm Hm2c), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_sd1_hm2c_su4c
      ;
      (FRS (S14_Sd Sd1), FRS (S3_Hm Hm2c), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_sd1_hm2c_su5c
      ;
      (FRS (S14_Sd Sd1), FRS (S3_Hm Hm2c), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_sd1_hm2c_su6c
      ;
      (FRS (S14_Sd Sd2), FRS (S3_Hm Hm2c), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_sd2_hm2c_su1c
      ;
      (FRS (S14_Sd Sd2), FRS (S3_Hm Hm2c), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_sd2_hm2c_su2c
      ;
      (FRS (S14_Sd Sd2), FRS (S3_Hm Hm2c), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_sd2_hm2c_su3c
      ;
      (FRS (S14_Sd Sd2), FRS (S3_Hm Hm2c), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_sd2_hm2c_su4c
      ;
      (FRS (S14_Sd Sd2), FRS (S3_Hm Hm2c), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_sd2_hm2c_su5c
      ;
      (FRS (S14_Sd Sd2), FRS (S3_Hm Hm2c), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_sd2_hm2c_su6c
      ;
      (FRS (S14_Sd Sd3), FRS (S3_Hm Hm2c), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_sd3_hm2c_su1c
      ;
      (FRS (S14_Sd Sd3), FRS (S3_Hm Hm2c), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_sd3_hm2c_su2c
      ;
      (FRS (S14_Sd Sd3), FRS (S3_Hm Hm2c), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_sd3_hm2c_su3c
      ;
      (FRS (S14_Sd Sd3), FRS (S3_Hm Hm2c), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_sd3_hm2c_su4c
      ;
      (FRS (S14_Sd Sd3), FRS (S3_Hm Hm2c), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_sd3_hm2c_su5c
      ;
      (FRS (S14_Sd Sd3), FRS (S3_Hm Hm2c), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_sd3_hm2c_su6c
      ;
      (FRS (S14_Sd Sd4), FRS (S3_Hm Hm2c), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_sd4_hm2c_su1c
      ;
      (FRS (S14_Sd Sd4), FRS (S3_Hm Hm2c), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_sd4_hm2c_su2c
      ;
      (FRS (S14_Sd Sd4), FRS (S3_Hm Hm2c), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_sd4_hm2c_su3c
      ;
      (FRS (S14_Sd Sd4), FRS (S3_Hm Hm2c), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_sd4_hm2c_su4c
      ;
      (FRS (S14_Sd Sd4), FRS (S3_Hm Hm2c), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_sd4_hm2c_su5c
      ;
      (FRS (S14_Sd Sd4), FRS (S3_Hm Hm2c), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_sd4_hm2c_su6c
      ;
      (FRS (S14_Sd Sd5), FRS (S3_Hm Hm2c), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_sd5_hm2c_su1c
      ;
      (FRS (S14_Sd Sd5), FRS (S3_Hm Hm2c), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_sd5_hm2c_su2c
      ;
      (FRS (S14_Sd Sd5), FRS (S3_Hm Hm2c), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_sd5_hm2c_su3c
      ;
      (FRS (S14_Sd Sd5), FRS (S3_Hm Hm2c), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_sd5_hm2c_su4c
      ;
      (FRS (S14_Sd Sd5), FRS (S3_Hm Hm2c), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_sd5_hm2c_su5c
      ;
      (FRS (S14_Sd Sd5), FRS (S3_Hm Hm2c), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_sd5_hm2c_su6c
      ;
      (FRS (S14_Sd Sd6), FRS (S3_Hm Hm2c), FRS (S13_Su Su1c)),
       Scalar_Scalar_Scalar 1,
       G_sd6_hm2c_su1c
      ;
      (FRS (S14_Sd Sd6), FRS (S3_Hm Hm2c), FRS (S13_Su Su2c)),
       Scalar_Scalar_Scalar 1,
       G_sd6_hm2c_su2c
      ;
      (FRS (S14_Sd Sd6), FRS (S3_Hm Hm2c), FRS (S13_Su Su3c)),
       Scalar_Scalar_Scalar 1,
       G_sd6_hm2c_su3c
      ;
      (FRS (S14_Sd Sd6), FRS (S3_Hm Hm2c), FRS (S13_Su Su4c)),
       Scalar_Scalar_Scalar 1,
       G_sd6_hm2c_su4c
      ;
      (FRS (S14_Sd Sd6), FRS (S3_Hm Hm2c), FRS (S13_Su Su5c)),
       Scalar_Scalar_Scalar 1,
       G_sd6_hm2c_su5c
      ;
      (FRS (S14_Sd Sd6), FRS (S3_Hm Hm2c), FRS (S13_Su Su6c)),
       Scalar_Scalar_Scalar 1,
       G_sd6_hm2c_su6c
      ;
      (FRS (S12_Se Se1), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_se1_hm2c_sv1c
      ;
      (FRS (S12_Se Se1), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_se1_hm2c_sv2c
      ;
      (FRS (S12_Se Se1), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_se1_hm2c_sv3c
      ;
      (FRS (S12_Se Se2), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_se2_hm2c_sv1c
      ;
      (FRS (S12_Se Se2), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_se2_hm2c_sv2c
      ;
      (FRS (S12_Se Se2), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_se2_hm2c_sv3c
      ;
      (FRS (S12_Se Se3), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_se3_hm2c_sv1c
      ;
      (FRS (S12_Se Se3), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_se3_hm2c_sv2c
      ;
      (FRS (S12_Se Se3), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_se3_hm2c_sv3c
      ;
      (FRS (S12_Se Se4), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_se4_hm2c_sv1c
      ;
      (FRS (S12_Se Se4), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_se4_hm2c_sv2c
      ;
      (FRS (S12_Se Se4), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_se4_hm2c_sv3c
      ;
      (FRS (S12_Se Se5), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_se5_hm2c_sv1c
      ;
      (FRS (S12_Se Se5), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_se5_hm2c_sv2c
      ;
      (FRS (S12_Se Se5), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_se5_hm2c_sv3c
      ;
      (FRS (S12_Se Se6), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv1c)),
       Scalar_Scalar_Scalar 1,
       G_se6_hm2c_sv1c
      ;
      (FRS (S12_Se Se6), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv2c)),
       Scalar_Scalar_Scalar 1,
       G_se6_hm2c_sv2c
      ;
      (FRS (S12_Se Se6), FRS (S3_Hm Hm2c), FRS (S11_Sv Sv3c)),
       Scalar_Scalar_Scalar 1,
       G_se6_hm2c_sv3c
      ;
      (FRV (V2_Z Z_1), FRS (S2_Ah Ah2), FRS (S1_H H1)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_ah2_h1
      ;
      (FRV (V2_Z Z_1), FRS (S2_Ah Ah2), FRS (S1_H H2)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_ah2_h2
      ;
      (FRV (V3_Wm Wmc), FRS (S2_Ah Ah2), FRS (S3_Hm Hm2)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_ah2_hm2
      ;
      (FRV (V3_Wm Wm_1), FRS (S2_Ah Ah2), FRS (S3_Hm Hm2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_ah2_hm2
      ;
      (FRV (V3_Wm Wmc), FRS (S1_H H1), FRS (S3_Hm Hm2)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_h1_hm2
      ;
      (FRV (V3_Wm Wmc), FRS (S1_H H2), FRS (S3_Hm Hm2)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_h2_hm2
      ;
      (FRV (V3_Wm Wm_1), FRS (S1_H H1), FRS (S3_Hm Hm2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_h1_hm2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S1_H H2), FRS (S3_Hm Hm2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_h2_hm2c
      ;
      (FRV (V1_A A_1), FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_hm2_hm2c
      ;
      (FRV (V2_Z Z_1), FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_hm2_hm2c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd1_sd1c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd1_sd2c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd1_sd3c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd1_sd4c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd1_sd5c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd1_sd6c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd2_sd1c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd2_sd2c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd2_sd3c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd2_sd4c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd2_sd5c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd2_sd6c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd1c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd2c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd3c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd4c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd5c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd6c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd4_sd1c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd4_sd2c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd4_sd3c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd4_sd4c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd4_sd5c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd4_sd6c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd5_sd1c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd5_sd2c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd5_sd3c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd5_sd4c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd5_sd5c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd5_sd6c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd6_sd1c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd6_sd2c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd6_sd3c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd6_sd4c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd6_sd5c
      ;
      (FRV (V1_A A_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd6_sd6c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd1_sd1c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd1_sd2c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd1_sd3c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd1_sd4c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd1_sd5c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd1_sd6c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd2_sd1c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd2_sd2c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd2_sd3c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd2_sd4c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd2_sd5c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd2_sd6c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd1c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd2c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd3c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd4c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd5c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd6c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd4_sd1c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd4_sd2c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd4_sd3c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd4_sd4c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd4_sd5c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd4_sd6c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd5_sd1c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd5_sd2c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd5_sd3c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd5_sd4c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd5_sd5c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd5_sd6c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd6_sd1c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd6_sd2c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd6_sd3c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd6_sd4c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd6_sd5c
      ;
      (FRV (V2_Z Z_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd6_sd6c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd1), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd1_su1c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd1), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd1_su2c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd1), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd1_su3c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd1), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd1_su4c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd1), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd1_su5c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd1), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd1_su6c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd2), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd2_su1c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd2), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd2_su2c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd2), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd2_su3c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd2), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd2_su4c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd2), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd2_su5c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd2), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd2_su6c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd3), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd3_su1c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd3), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd3_su2c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd3), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd3_su3c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd3), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd3_su4c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd3), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd3_su5c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd3), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd3_su6c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd4), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd4_su1c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd4), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd4_su2c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd4), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd4_su3c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd4), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd4_su4c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd4), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd4_su5c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd4), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd4_su6c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd5), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd5_su1c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd5), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd5_su2c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd5), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd5_su3c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd5), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd5_su4c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd5), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd5_su5c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd5), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd5_su6c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd6), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd6_su1c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd6), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd6_su2c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd6), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd6_su3c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd6), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd6_su4c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd6), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd6_su5c
      ;
      (FRV (V3_Wm Wmc), FRS (S14_Sd Sd6), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_sd6_su6c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se1), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se1_se1c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se1), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se1_se2c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se1), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se1_se3c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se1), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se1_se4c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se1), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se1_se5c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se1), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se1_se6c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se2), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se2_se1c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se2), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se2_se2c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se2), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se2_se3c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se2), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se2_se4c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se2), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se2_se5c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se2), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se2_se6c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se3), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se3_se1c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se3), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se3_se2c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se3), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se3_se3c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se3), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se3_se4c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se3), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se3_se5c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se3), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se3_se6c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se4), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se4_se1c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se4), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se4_se2c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se4), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se4_se3c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se4), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se4_se4c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se4), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se4_se5c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se4), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se4_se6c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se5), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se5_se1c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se5), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se5_se2c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se5), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se5_se3c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se5), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se5_se4c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se5), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se5_se5c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se5), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se5_se6c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se6), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se6_se1c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se6), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se6_se2c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se6), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se6_se3c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se6), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se6_se4c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se6), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se6_se5c
      ;
      (FRV (V1_A A_1), FRS (S12_Se Se6), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_se6_se6c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se1), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se1_se1c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se1), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se1_se2c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se1), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se1_se3c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se1), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se1_se4c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se1), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se1_se5c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se1), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se1_se6c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se2), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se2_se1c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se2), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se2_se2c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se2), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se2_se3c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se2), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se2_se4c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se2), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se2_se5c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se2), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se2_se6c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se3), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se3_se1c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se3), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se3_se2c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se3), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se3_se3c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se3), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se3_se4c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se3), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se3_se5c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se3), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se3_se6c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se4), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se4_se1c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se4), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se4_se2c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se4), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se4_se3c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se4), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se4_se4c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se4), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se4_se5c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se4), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se4_se6c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se5), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se5_se1c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se5), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se5_se2c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se5), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se5_se3c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se5), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se5_se4c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se5), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se5_se5c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se5), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se5_se6c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se6), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se6_se1c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se6), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se6_se2c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se6), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se6_se3c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se6), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se6_se4c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se6), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se6_se5c
      ;
      (FRV (V2_Z Z_1), FRS (S12_Se Se6), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_se6_se6c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se1), FRS (S11_Sv Sv1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se1_sv1c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se1), FRS (S11_Sv Sv2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se1_sv2c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se1), FRS (S11_Sv Sv3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se1_sv3c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se2), FRS (S11_Sv Sv1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se2_sv1c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se2), FRS (S11_Sv Sv2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se2_sv2c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se2), FRS (S11_Sv Sv3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se2_sv3c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se3), FRS (S11_Sv Sv1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se3_sv1c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se3), FRS (S11_Sv Sv2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se3_sv2c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se3), FRS (S11_Sv Sv3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se3_sv3c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se4), FRS (S11_Sv Sv1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se4_sv1c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se4), FRS (S11_Sv Sv2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se4_sv2c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se4), FRS (S11_Sv Sv3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se4_sv3c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se5), FRS (S11_Sv Sv1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se5_sv1c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se5), FRS (S11_Sv Sv2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se5_sv2c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se5), FRS (S11_Sv Sv3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se5_sv3c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se6), FRS (S11_Sv Sv1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se6_sv1c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se6), FRS (S11_Sv Sv2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se6_sv2c
      ;
      (FRV (V3_Wm Wmc), FRS (S12_Se Se6), FRS (S11_Sv Sv3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wmc_se6_sv3c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su1), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su1_su1c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su1), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su1_su2c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su1), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su1_su3c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su1), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su1_su4c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su1), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su1_su5c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su1), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su1_su6c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su2), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su2_su1c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su2), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su2_su2c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su2), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su2_su3c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su2), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su2_su4c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su2), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su2_su5c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su2), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su2_su6c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su3), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su1c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su3), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su2c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su3), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su3c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su3), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su4c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su3), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su5c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su3), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su6c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su4), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su4_su1c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su4), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su4_su2c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su4), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su4_su3c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su4), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su4_su4c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su4), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su4_su5c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su4), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su4_su6c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su5), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su5_su1c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su5), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su5_su2c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su5), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su5_su3c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su5), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su5_su4c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su5), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su5_su5c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su5), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su5_su6c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su6), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su6_su1c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su6), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su6_su2c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su6), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su6_su3c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su6), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su6_su4c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su6), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su6_su5c
      ;
      (FRV (V1_A A_1), FRS (S13_Su Su6), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su6_su6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su1), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su1_sd1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su1), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su1_sd2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su1), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su1_sd3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su1), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su1_sd4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su1), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su1_sd5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su1), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su1_sd6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su2), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su2_sd1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su2), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su2_sd2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su2), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su2_sd3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su2), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su2_sd4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su2), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su2_sd5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su2), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su2_sd6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su3), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su3_sd1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su3), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su3_sd2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su3), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su3_sd3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su3), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su3_sd4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su3), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su3_sd5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su3), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su3_sd6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su4), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su4_sd1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su4), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su4_sd2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su4), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su4_sd3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su4), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su4_sd4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su4), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su4_sd5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su4), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su4_sd6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su5), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su5_sd1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su5), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su5_sd2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su5), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su5_sd3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su5), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su5_sd4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su5), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su5_sd5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su5), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su5_sd6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su6), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su6_sd1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su6), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su6_sd2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su6), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su6_sd3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su6), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su6_sd4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su6), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su6_sd5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S13_Su Su6), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_su6_sd6c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su1), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su1_su1c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su1), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su1_su2c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su1), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su1_su3c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su1), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su1_su4c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su1), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su1_su5c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su1), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su1_su6c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su2), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su2_su1c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su2), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su2_su2c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su2), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su2_su3c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su2), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su2_su4c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su2), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su2_su5c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su2), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su2_su6c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su3), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su1c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su3), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su2c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su3), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su3c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su3), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su4c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su3), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su5c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su3), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su6c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su4), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su4_su1c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su4), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su4_su2c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su4), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su4_su3c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su4), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su4_su4c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su4), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su4_su5c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su4), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su4_su6c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su5), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su5_su1c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su5), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su5_su2c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su5), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su5_su3c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su5), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su5_su4c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su5), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su5_su5c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su5), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su5_su6c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su6), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su6_su1c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su6), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su6_su2c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su6), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su6_su3c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su6), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su6_su4c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su6), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su6_su5c
      ;
      (FRV (V2_Z Z_1), FRS (S13_Su Su6), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su6_su6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv1), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv1_se1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv1), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv1_se2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv1), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv1_se3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv1), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv1_se4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv1), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv1_se5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv1), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv1_se6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv2), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv2_se1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv2), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv2_se2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv2), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv2_se3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv2), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv2_se4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv2), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv2_se5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv2), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv2_se6c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv3), FRS (S12_Se Se1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv3_se1c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv3), FRS (S12_Se Se2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv3_se2c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv3), FRS (S12_Se Se3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv3_se3c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv3), FRS (S12_Se Se4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv3_se4c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv3), FRS (S12_Se Se5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv3_se5c
      ;
      (FRV (V3_Wm Wm_1), FRS (S11_Sv Sv3), FRS (S12_Se Se6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_wm_1_sv3_se6c
      ;
      (FRV (V2_Z Z_1), FRS (S11_Sv Sv1), FRS (S11_Sv Sv1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sv1_sv1c
      ;
      (FRV (V2_Z Z_1), FRS (S11_Sv Sv2), FRS (S11_Sv Sv2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sv1_sv1c
      ;
      (FRV (V2_Z Z_1), FRS (S11_Sv Sv3), FRS (S11_Sv Sv3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sv1_sv1c
      ;
      (FRS (S1_H H1), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar_Vector_Vector 1,
       G_h1_wmc_wm_1
      ;
      (FRS (S1_H H2), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar_Vector_Vector 1,
       G_h2_wmc_wm_1
      ;
      (FRS (S1_H H1), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h1_z_1_z_1
      ;
      (FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h2_z_1_z_1
      ;
      (FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar_Vector_Vector 1,
       G_hm2_wmc_a_1
      ;
      (FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_hm2_wmc_z_1
      ;
      (FRS (S3_Hm Hm2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar_Vector_Vector 1,
       G_hm2_wmc_a_1
      ;
      (FRS (S3_Hm Hm2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_hm2_wmc_z_1
      ;
      (FRF (F12_C C1bar), FRS (S2_Ah Ah2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_ah2_c1
      ;
      (FRF (F12_C C1bar), FRS (S2_Ah Ah2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_ah2_c2
      ;
      (FRF (F12_C C2bar), FRS (S2_Ah Ah2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_ah2_c1
      ;
      (FRF (F12_C C2bar), FRS (S2_Ah Ah2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_ah2_c2
      ;
      (FRF (F11_N N1), FRS (S2_Ah Ah2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_ah2_n1
      ;
      (FRF (F11_N N1), FRS (S2_Ah Ah2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_ah2_n2
      ;
      (FRF (F11_N N1), FRS (S2_Ah Ah2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_ah2_n3
      ;
      (FRF (F11_N N1), FRS (S2_Ah Ah2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_ah2_n4
      ;
      (FRF (F11_N N2), FRS (S2_Ah Ah2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_ah2_n2
      ;
      (FRF (F11_N N2), FRS (S2_Ah Ah2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_ah2_n3
      ;
      (FRF (F11_N N2), FRS (S2_Ah Ah2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_ah2_n4
      ;
      (FRF (F11_N N3), FRS (S2_Ah Ah2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_ah2_n3
      ;
      (FRF (F11_N N3), FRS (S2_Ah Ah2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_ah2_n4
      ;
      (FRF (F11_N N4), FRS (S2_Ah Ah2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_ah2_n4
      ;
      (FRF (F4_D D1bar), FRS (S2_Ah Ah2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_ah2_d1
      ;
      (FRF (F4_D D1bar), FRS (S2_Ah Ah2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_ah2_d2
      ;
      (FRF (F4_D D1bar), FRS (S2_Ah Ah2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_ah2_d3
      ;
      (FRF (F4_D D2bar), FRS (S2_Ah Ah2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_ah2_d1
      ;
      (FRF (F4_D D2bar), FRS (S2_Ah Ah2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_ah2_d2
      ;
      (FRF (F4_D D2bar), FRS (S2_Ah Ah2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_ah2_d3
      ;
      (FRF (F4_D D3bar), FRS (S2_Ah Ah2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_ah2_d1
      ;
      (FRF (F4_D D3bar), FRS (S2_Ah Ah2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_ah2_d2
      ;
      (FRF (F4_D D3bar), FRS (S2_Ah Ah2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_ah2_d3
      ;
      (FRF (F2_E E1bar), FRS (S2_Ah Ah2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_ah2_e1
      ;
      (FRF (F2_E E1bar), FRS (S2_Ah Ah2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_ah2_e2
      ;
      (FRF (F2_E E1bar), FRS (S2_Ah Ah2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_ah2_e3
      ;
      (FRF (F2_E E2bar), FRS (S2_Ah Ah2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_ah2_e1
      ;
      (FRF (F2_E E2bar), FRS (S2_Ah Ah2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_ah2_e2
      ;
      (FRF (F2_E E2bar), FRS (S2_Ah Ah2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_ah2_e3
      ;
      (FRF (F2_E E3bar), FRS (S2_Ah Ah2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_ah2_e1
      ;
      (FRF (F2_E E3bar), FRS (S2_Ah Ah2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_ah2_e2
      ;
      (FRF (F2_E E3bar), FRS (S2_Ah Ah2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_ah2_e3
      ;
      (FRF (F3_U U1bar), FRS (S2_Ah Ah2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_ah2_u1
      ;
      (FRF (F3_U U1bar), FRS (S2_Ah Ah2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_ah2_u2
      ;
      (FRF (F3_U U1bar), FRS (S2_Ah Ah2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_ah2_u3
      ;
      (FRF (F3_U U2bar), FRS (S2_Ah Ah2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_ah2_u1
      ;
      (FRF (F3_U U2bar), FRS (S2_Ah Ah2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_ah2_u2
      ;
      (FRF (F3_U U2bar), FRS (S2_Ah Ah2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_ah2_u3
      ;
      (FRF (F3_U U3bar), FRS (S2_Ah Ah2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_ah2_u1
      ;
      (FRF (F3_U U3bar), FRS (S2_Ah Ah2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_ah2_u2
      ;
      (FRF (F3_U U3bar), FRS (S2_Ah Ah2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_ah2_u3
      ;
      (FRF (F11_N N1), FRS (S3_Hm Hm2c), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_hm2c_c1
      ;
      (FRF (F11_N N1), FRS (S3_Hm Hm2c), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_hm2c_c2
      ;
      (FRF (F11_N N2), FRS (S3_Hm Hm2c), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_hm2c_c1
      ;
      (FRF (F11_N N2), FRS (S3_Hm Hm2c), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_hm2c_c2
      ;
      (FRF (F11_N N3), FRS (S3_Hm Hm2c), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_hm2c_c1
      ;
      (FRF (F11_N N3), FRS (S3_Hm Hm2c), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_hm2c_c2
      ;
      (FRF (F11_N N4), FRS (S3_Hm Hm2c), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_hm2c_c1
      ;
      (FRF (F11_N N4), FRS (S3_Hm Hm2c), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_hm2c_c2
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd1c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd1c_u1
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd2c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd2c_u1
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd3c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd3c_u1
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd4c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd4c_u1
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd5c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd5c_u1
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd6c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd6c_u1
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd1c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd1c_u2
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd2c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd2c_u2
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd3c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd3c_u2
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd4c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd4c_u2
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd5c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd5c_u2
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd6c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd6c_u2
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd1c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd1c_u3
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd2c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd2c_u3
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd3c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd3c_u3
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd4c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd4c_u3
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd5c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd5c_u3
      ;
      (FRF (F12_C C1), FRS (S14_Sd Sd6c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c1_sd6c_u3
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd1c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd1c_u1
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd2c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd2c_u1
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd3c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd3c_u1
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd4c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd4c_u1
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd5c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd5c_u1
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd6c), FRF (F3_U U1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd6c_u1
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd1c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd1c_u2
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd2c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd2c_u2
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd3c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd3c_u2
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd4c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd4c_u2
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd5c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd5c_u2
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd6c), FRF (F3_U U2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd6c_u2
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd1c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd1c_u3
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd2c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd2c_u3
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd3c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd3c_u3
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd4c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd4c_u3
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd5c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd5c_u3
      ;
      (FRF (F12_C C2), FRS (S14_Sd Sd6c), FRF (F3_U U3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_c2_sd6c_u3
      ;
      (FRF (F12_C C1), FRS (S12_Se Se1c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se1c_nu1
      ;
      (FRF (F12_C C1), FRS (S12_Se Se2c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se2c_nu1
      ;
      (FRF (F12_C C1), FRS (S12_Se Se3c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se3c_nu1
      ;
      (FRF (F12_C C1), FRS (S12_Se Se4c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se4c_nu1
      ;
      (FRF (F12_C C1), FRS (S12_Se Se5c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se5c_nu1
      ;
      (FRF (F12_C C1), FRS (S12_Se Se6c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se6c_nu1
      ;
      (FRF (F12_C C1), FRS (S12_Se Se1c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se1c_nu2
      ;
      (FRF (F12_C C1), FRS (S12_Se Se2c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se2c_nu2
      ;
      (FRF (F12_C C1), FRS (S12_Se Se3c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se3c_nu2
      ;
      (FRF (F12_C C1), FRS (S12_Se Se4c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se4c_nu2
      ;
      (FRF (F12_C C1), FRS (S12_Se Se5c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se5c_nu2
      ;
      (FRF (F12_C C1), FRS (S12_Se Se6c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se6c_nu2
      ;
      (FRF (F12_C C1), FRS (S12_Se Se1c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se1c_nu3
      ;
      (FRF (F12_C C1), FRS (S12_Se Se2c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se2c_nu3
      ;
      (FRF (F12_C C1), FRS (S12_Se Se3c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se3c_nu3
      ;
      (FRF (F12_C C1), FRS (S12_Se Se4c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se4c_nu3
      ;
      (FRF (F12_C C1), FRS (S12_Se Se5c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se5c_nu3
      ;
      (FRF (F12_C C1), FRS (S12_Se Se6c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c1_se6c_nu3
      ;
      (FRF (F12_C C2), FRS (S12_Se Se1c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se1c_nu1
      ;
      (FRF (F12_C C2), FRS (S12_Se Se2c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se2c_nu1
      ;
      (FRF (F12_C C2), FRS (S12_Se Se3c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se3c_nu1
      ;
      (FRF (F12_C C2), FRS (S12_Se Se4c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se4c_nu1
      ;
      (FRF (F12_C C2), FRS (S12_Se Se5c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se5c_nu1
      ;
      (FRF (F12_C C2), FRS (S12_Se Se6c), FRF (F1_Nu Nu1)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se6c_nu1
      ;
      (FRF (F12_C C2), FRS (S12_Se Se1c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se1c_nu2
      ;
      (FRF (F12_C C2), FRS (S12_Se Se2c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se2c_nu2
      ;
      (FRF (F12_C C2), FRS (S12_Se Se3c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se3c_nu2
      ;
      (FRF (F12_C C2), FRS (S12_Se Se4c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se4c_nu2
      ;
      (FRF (F12_C C2), FRS (S12_Se Se5c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se5c_nu2
      ;
      (FRF (F12_C C2), FRS (S12_Se Se6c), FRF (F1_Nu Nu2)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se6c_nu2
      ;
      (FRF (F12_C C2), FRS (S12_Se Se1c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se1c_nu3
      ;
      (FRF (F12_C C2), FRS (S12_Se Se2c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se2c_nu3
      ;
      (FRF (F12_C C2), FRS (S12_Se Se3c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se3c_nu3
      ;
      (FRF (F12_C C2), FRS (S12_Se Se4c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se4c_nu3
      ;
      (FRF (F12_C C2), FRS (S12_Se Se5c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se5c_nu3
      ;
      (FRF (F12_C C2), FRS (S12_Se Se6c), FRF (F1_Nu Nu3)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SR, Coupling.Psi),
       G_c2_se6c_nu3
      ;
      (FRF (F12_C C1bar), FRS (S1_H H1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_h1_c1
      ;
      (FRF (F12_C C1bar), FRS (S1_H H2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_h2_c1
      ;
      (FRF (F12_C C1bar), FRS (S1_H H1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_h1_c2
      ;
      (FRF (F12_C C1bar), FRS (S1_H H2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_h2_c2
      ;
      (FRF (F12_C C2bar), FRS (S1_H H1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_h1_c1
      ;
      (FRF (F12_C C2bar), FRS (S1_H H2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_h2_c1
      ;
      (FRF (F12_C C2bar), FRS (S1_H H1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_h1_c2
      ;
      (FRF (F12_C C2bar), FRS (S1_H H2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_h2_c2
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su1_c1
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su2_c1
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su3), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su3_c1
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su4), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su4_c1
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su5), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su5_c1
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su6), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su6_c1
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su1_c2
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su2_c2
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su3), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su3_c2
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su4), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su4_c2
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su5), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su5_c2
      ;
      (FRF (F4_D D1bar), FRS (S13_Su Su6), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_su6_c2
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su1_c1
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su2_c1
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su3), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su3_c1
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su4), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su4_c1
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su5), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su5_c1
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su6), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su6_c1
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su1_c2
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su2_c2
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su3), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su3_c2
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su4), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su4_c2
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su5), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su5_c2
      ;
      (FRF (F4_D D2bar), FRS (S13_Su Su6), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_su6_c2
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su1_c1
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su2_c1
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su3), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su3_c1
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su4), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su4_c1
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su5), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su5_c1
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su6), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su6_c1
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su1_c2
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su2_c2
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su3), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su3_c2
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su4), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su4_c2
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su5), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su5_c2
      ;
      (FRF (F4_D D3bar), FRS (S13_Su Su6), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_su6_c2
      ;
      (FRF (F2_E E1bar), FRS (S11_Sv Sv1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_sv1_c1
      ;
      (FRF (F2_E E1bar), FRS (S11_Sv Sv2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_sv2_c1
      ;
      (FRF (F2_E E1bar), FRS (S11_Sv Sv3), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_sv3_c1
      ;
      (FRF (F2_E E1bar), FRS (S11_Sv Sv1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_sv1_c2
      ;
      (FRF (F2_E E1bar), FRS (S11_Sv Sv2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_sv2_c2
      ;
      (FRF (F2_E E1bar), FRS (S11_Sv Sv3), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_sv3_c2
      ;
      (FRF (F2_E E2bar), FRS (S11_Sv Sv1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_sv1_c1
      ;
      (FRF (F2_E E2bar), FRS (S11_Sv Sv2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_sv2_c1
      ;
      (FRF (F2_E E2bar), FRS (S11_Sv Sv3), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_sv3_c1
      ;
      (FRF (F2_E E2bar), FRS (S11_Sv Sv1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_sv1_c2
      ;
      (FRF (F2_E E2bar), FRS (S11_Sv Sv2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_sv2_c2
      ;
      (FRF (F2_E E2bar), FRS (S11_Sv Sv3), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_sv3_c2
      ;
      (FRF (F2_E E3bar), FRS (S11_Sv Sv1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_sv1_c1
      ;
      (FRF (F2_E E3bar), FRS (S11_Sv Sv2), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_sv2_c1
      ;
      (FRF (F2_E E3bar), FRS (S11_Sv Sv3), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_sv3_c1
      ;
      (FRF (F2_E E3bar), FRS (S11_Sv Sv1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_sv1_c2
      ;
      (FRF (F2_E E3bar), FRS (S11_Sv Sv2), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_sv2_c2
      ;
      (FRF (F2_E E3bar), FRS (S11_Sv Sv3), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_sv3_c2
      ;
      (FRF (F11_N N1), FRS (S1_H H1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h1_n1
      ;
      (FRF (F11_N N1), FRS (S1_H H2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h2_n1
      ;
      (FRF (F11_N N1), FRS (S1_H H1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h1_n2
      ;
      (FRF (F11_N N1), FRS (S1_H H2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h2_n2
      ;
      (FRF (F11_N N1), FRS (S1_H H1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h1_n3
      ;
      (FRF (F11_N N1), FRS (S1_H H2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h2_n3
      ;
      (FRF (F11_N N1), FRS (S1_H H1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h1_n4
      ;
      (FRF (F11_N N1), FRS (S1_H H2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h2_n4
      ;
      (FRF (F11_N N2), FRS (S1_H H1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h1_n2
      ;
      (FRF (F11_N N2), FRS (S1_H H2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h2_n2
      ;
      (FRF (F11_N N2), FRS (S1_H H1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h1_n3
      ;
      (FRF (F11_N N2), FRS (S1_H H2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h2_n3
      ;
      (FRF (F11_N N2), FRS (S1_H H1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h1_n4
      ;
      (FRF (F11_N N2), FRS (S1_H H2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h2_n4
      ;
      (FRF (F11_N N3), FRS (S1_H H1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h1_n3
      ;
      (FRF (F11_N N3), FRS (S1_H H2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h2_n3
      ;
      (FRF (F11_N N3), FRS (S1_H H1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h1_n4
      ;
      (FRF (F11_N N3), FRS (S1_H H2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h2_n4
      ;
      (FRF (F11_N N4), FRS (S1_H H1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_h1_n4
      ;
      (FRF (F11_N N4), FRS (S1_H H2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_h2_n4
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd1c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd1c_d1
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd2c_d1
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd3c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd3c_d1
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd4c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd4c_d1
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd5c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd5c_d1
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd6c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd6c_d1
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd1c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd1c_d2
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd2c_d2
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd3c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd3c_d2
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd4c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd4c_d2
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd5c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd5c_d2
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd6c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd6c_d2
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd1c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd1c_d3
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd2c_d3
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd3c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd3c_d3
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd4c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd4c_d3
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd5c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd5c_d3
      ;
      (FRF (F11_N N1), FRS (S14_Sd Sd6c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd6c_d3
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd1c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd1c_d1
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd2c_d1
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd3c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd3c_d1
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd4c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd4c_d1
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd5c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd5c_d1
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd6c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd6c_d1
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd1c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd1c_d2
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd2c_d2
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd3c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd3c_d2
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd4c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd4c_d2
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd5c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd5c_d2
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd6c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd6c_d2
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd1c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd1c_d3
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd2c_d3
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd3c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd3c_d3
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd4c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd4c_d3
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd5c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd5c_d3
      ;
      (FRF (F11_N N2), FRS (S14_Sd Sd6c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd6c_d3
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd1c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd1c_d1
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd2c_d1
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd3c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd3c_d1
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd4c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd4c_d1
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd5c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd5c_d1
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd6c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd6c_d1
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd1c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd1c_d2
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd2c_d2
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd3c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd3c_d2
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd4c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd4c_d2
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd5c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd5c_d2
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd6c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd6c_d2
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd1c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd1c_d3
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd2c_d3
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd3c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd3c_d3
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd4c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd4c_d3
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd5c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd5c_d3
      ;
      (FRF (F11_N N3), FRS (S14_Sd Sd6c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd6c_d3
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd1c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd1c_d1
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd2c_d1
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd3c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd3c_d1
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd4c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd4c_d1
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd5c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd5c_d1
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd6c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd6c_d1
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd1c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd1c_d2
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd2c_d2
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd3c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd3c_d2
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd4c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd4c_d2
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd5c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd5c_d2
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd6c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd6c_d2
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd1c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd1c_d3
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd2c_d3
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd3c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd3c_d3
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd4c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd4c_d3
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd5c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd5c_d3
      ;
      (FRF (F11_N N4), FRS (S14_Sd Sd6c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd6c_d3
      ;
      (FRF (F11_N N1), FRS (S12_Se Se1c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se1c_e1
      ;
      (FRF (F11_N N1), FRS (S12_Se Se2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se2c_e1
      ;
      (FRF (F11_N N1), FRS (S12_Se Se3c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se3c_e1
      ;
      (FRF (F11_N N1), FRS (S12_Se Se4c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se4c_e1
      ;
      (FRF (F11_N N1), FRS (S12_Se Se5c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se5c_e1
      ;
      (FRF (F11_N N1), FRS (S12_Se Se6c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se6c_e1
      ;
      (FRF (F11_N N1), FRS (S12_Se Se1c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se1c_e2
      ;
      (FRF (F11_N N1), FRS (S12_Se Se2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se2c_e2
      ;
      (FRF (F11_N N1), FRS (S12_Se Se3c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se3c_e2
      ;
      (FRF (F11_N N1), FRS (S12_Se Se4c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se4c_e2
      ;
      (FRF (F11_N N1), FRS (S12_Se Se5c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se5c_e2
      ;
      (FRF (F11_N N1), FRS (S12_Se Se6c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se6c_e2
      ;
      (FRF (F11_N N1), FRS (S12_Se Se1c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se1c_e3
      ;
      (FRF (F11_N N1), FRS (S12_Se Se2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se2c_e3
      ;
      (FRF (F11_N N1), FRS (S12_Se Se3c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se3c_e3
      ;
      (FRF (F11_N N1), FRS (S12_Se Se4c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se4c_e3
      ;
      (FRF (F11_N N1), FRS (S12_Se Se5c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se5c_e3
      ;
      (FRF (F11_N N1), FRS (S12_Se Se6c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_se6c_e3
      ;
      (FRF (F11_N N2), FRS (S12_Se Se1c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se1c_e1
      ;
      (FRF (F11_N N2), FRS (S12_Se Se2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se2c_e1
      ;
      (FRF (F11_N N2), FRS (S12_Se Se3c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se3c_e1
      ;
      (FRF (F11_N N2), FRS (S12_Se Se4c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se4c_e1
      ;
      (FRF (F11_N N2), FRS (S12_Se Se5c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se5c_e1
      ;
      (FRF (F11_N N2), FRS (S12_Se Se6c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se6c_e1
      ;
      (FRF (F11_N N2), FRS (S12_Se Se1c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se1c_e2
      ;
      (FRF (F11_N N2), FRS (S12_Se Se2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se2c_e2
      ;
      (FRF (F11_N N2), FRS (S12_Se Se3c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se3c_e2
      ;
      (FRF (F11_N N2), FRS (S12_Se Se4c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se4c_e2
      ;
      (FRF (F11_N N2), FRS (S12_Se Se5c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se5c_e2
      ;
      (FRF (F11_N N2), FRS (S12_Se Se6c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se6c_e2
      ;
      (FRF (F11_N N2), FRS (S12_Se Se1c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se1c_e3
      ;
      (FRF (F11_N N2), FRS (S12_Se Se2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se2c_e3
      ;
      (FRF (F11_N N2), FRS (S12_Se Se3c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se3c_e3
      ;
      (FRF (F11_N N2), FRS (S12_Se Se4c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se4c_e3
      ;
      (FRF (F11_N N2), FRS (S12_Se Se5c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se5c_e3
      ;
      (FRF (F11_N N2), FRS (S12_Se Se6c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_se6c_e3
      ;
      (FRF (F11_N N3), FRS (S12_Se Se1c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se1c_e1
      ;
      (FRF (F11_N N3), FRS (S12_Se Se2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se2c_e1
      ;
      (FRF (F11_N N3), FRS (S12_Se Se3c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se3c_e1
      ;
      (FRF (F11_N N3), FRS (S12_Se Se4c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se4c_e1
      ;
      (FRF (F11_N N3), FRS (S12_Se Se5c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se5c_e1
      ;
      (FRF (F11_N N3), FRS (S12_Se Se6c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se6c_e1
      ;
      (FRF (F11_N N3), FRS (S12_Se Se1c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se1c_e2
      ;
      (FRF (F11_N N3), FRS (S12_Se Se2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se2c_e2
      ;
      (FRF (F11_N N3), FRS (S12_Se Se3c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se3c_e2
      ;
      (FRF (F11_N N3), FRS (S12_Se Se4c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se4c_e2
      ;
      (FRF (F11_N N3), FRS (S12_Se Se5c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se5c_e2
      ;
      (FRF (F11_N N3), FRS (S12_Se Se6c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se6c_e2
      ;
      (FRF (F11_N N3), FRS (S12_Se Se1c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se1c_e3
      ;
      (FRF (F11_N N3), FRS (S12_Se Se2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se2c_e3
      ;
      (FRF (F11_N N3), FRS (S12_Se Se3c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se3c_e3
      ;
      (FRF (F11_N N3), FRS (S12_Se Se4c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se4c_e3
      ;
      (FRF (F11_N N3), FRS (S12_Se Se5c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se5c_e3
      ;
      (FRF (F11_N N3), FRS (S12_Se Se6c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_se6c_e3
      ;
      (FRF (F11_N N4), FRS (S12_Se Se1c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se1c_e1
      ;
      (FRF (F11_N N4), FRS (S12_Se Se2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se2c_e1
      ;
      (FRF (F11_N N4), FRS (S12_Se Se3c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se3c_e1
      ;
      (FRF (F11_N N4), FRS (S12_Se Se4c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se4c_e1
      ;
      (FRF (F11_N N4), FRS (S12_Se Se5c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se5c_e1
      ;
      (FRF (F11_N N4), FRS (S12_Se Se6c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se6c_e1
      ;
      (FRF (F11_N N4), FRS (S12_Se Se1c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se1c_e2
      ;
      (FRF (F11_N N4), FRS (S12_Se Se2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se2c_e2
      ;
      (FRF (F11_N N4), FRS (S12_Se Se3c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se3c_e2
      ;
      (FRF (F11_N N4), FRS (S12_Se Se4c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se4c_e2
      ;
      (FRF (F11_N N4), FRS (S12_Se Se5c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se5c_e2
      ;
      (FRF (F11_N N4), FRS (S12_Se Se6c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se6c_e2
      ;
      (FRF (F11_N N4), FRS (S12_Se Se1c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se1c_e3
      ;
      (FRF (F11_N N4), FRS (S12_Se Se2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se2c_e3
      ;
      (FRF (F11_N N4), FRS (S12_Se Se3c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se3c_e3
      ;
      (FRF (F11_N N4), FRS (S12_Se Se4c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se4c_e3
      ;
      (FRF (F11_N N4), FRS (S12_Se Se5c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se5c_e3
      ;
      (FRF (F11_N N4), FRS (S12_Se Se6c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_se6c_e3
      ;
      (FRF (F11_N N1), FRS (S13_Su Su1c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su1c_u1
      ;
      (FRF (F11_N N1), FRS (S13_Su Su2c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su2c_u1
      ;
      (FRF (F11_N N1), FRS (S13_Su Su3c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su3c_u1
      ;
      (FRF (F11_N N1), FRS (S13_Su Su4c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su4c_u1
      ;
      (FRF (F11_N N1), FRS (S13_Su Su5c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su5c_u1
      ;
      (FRF (F11_N N1), FRS (S13_Su Su6c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su6c_u1
      ;
      (FRF (F11_N N1), FRS (S13_Su Su1c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su1c_u2
      ;
      (FRF (F11_N N1), FRS (S13_Su Su2c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su2c_u2
      ;
      (FRF (F11_N N1), FRS (S13_Su Su3c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su3c_u2
      ;
      (FRF (F11_N N1), FRS (S13_Su Su4c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su4c_u2
      ;
      (FRF (F11_N N1), FRS (S13_Su Su5c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su5c_u2
      ;
      (FRF (F11_N N1), FRS (S13_Su Su6c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su6c_u2
      ;
      (FRF (F11_N N1), FRS (S13_Su Su1c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su1c_u3
      ;
      (FRF (F11_N N1), FRS (S13_Su Su2c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su2c_u3
      ;
      (FRF (F11_N N1), FRS (S13_Su Su3c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su3c_u3
      ;
      (FRF (F11_N N1), FRS (S13_Su Su4c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su4c_u3
      ;
      (FRF (F11_N N1), FRS (S13_Su Su5c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su5c_u3
      ;
      (FRF (F11_N N1), FRS (S13_Su Su6c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su6c_u3
      ;
      (FRF (F11_N N2), FRS (S13_Su Su1c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su1c_u1
      ;
      (FRF (F11_N N2), FRS (S13_Su Su2c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su2c_u1
      ;
      (FRF (F11_N N2), FRS (S13_Su Su3c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su3c_u1
      ;
      (FRF (F11_N N2), FRS (S13_Su Su4c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su4c_u1
      ;
      (FRF (F11_N N2), FRS (S13_Su Su5c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su5c_u1
      ;
      (FRF (F11_N N2), FRS (S13_Su Su6c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su6c_u1
      ;
      (FRF (F11_N N2), FRS (S13_Su Su1c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su1c_u2
      ;
      (FRF (F11_N N2), FRS (S13_Su Su2c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su2c_u2
      ;
      (FRF (F11_N N2), FRS (S13_Su Su3c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su3c_u2
      ;
      (FRF (F11_N N2), FRS (S13_Su Su4c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su4c_u2
      ;
      (FRF (F11_N N2), FRS (S13_Su Su5c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su5c_u2
      ;
      (FRF (F11_N N2), FRS (S13_Su Su6c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su6c_u2
      ;
      (FRF (F11_N N2), FRS (S13_Su Su1c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su1c_u3
      ;
      (FRF (F11_N N2), FRS (S13_Su Su2c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su2c_u3
      ;
      (FRF (F11_N N2), FRS (S13_Su Su3c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su3c_u3
      ;
      (FRF (F11_N N2), FRS (S13_Su Su4c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su4c_u3
      ;
      (FRF (F11_N N2), FRS (S13_Su Su5c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su5c_u3
      ;
      (FRF (F11_N N2), FRS (S13_Su Su6c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su6c_u3
      ;
      (FRF (F11_N N3), FRS (S13_Su Su1c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su1c_u1
      ;
      (FRF (F11_N N3), FRS (S13_Su Su2c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su2c_u1
      ;
      (FRF (F11_N N3), FRS (S13_Su Su3c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su3c_u1
      ;
      (FRF (F11_N N3), FRS (S13_Su Su4c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su4c_u1
      ;
      (FRF (F11_N N3), FRS (S13_Su Su5c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su5c_u1
      ;
      (FRF (F11_N N3), FRS (S13_Su Su6c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su6c_u1
      ;
      (FRF (F11_N N3), FRS (S13_Su Su1c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su1c_u2
      ;
      (FRF (F11_N N3), FRS (S13_Su Su2c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su2c_u2
      ;
      (FRF (F11_N N3), FRS (S13_Su Su3c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su3c_u2
      ;
      (FRF (F11_N N3), FRS (S13_Su Su4c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su4c_u2
      ;
      (FRF (F11_N N3), FRS (S13_Su Su5c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su5c_u2
      ;
      (FRF (F11_N N3), FRS (S13_Su Su6c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su6c_u2
      ;
      (FRF (F11_N N3), FRS (S13_Su Su1c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su1c_u3
      ;
      (FRF (F11_N N3), FRS (S13_Su Su2c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su2c_u3
      ;
      (FRF (F11_N N3), FRS (S13_Su Su3c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su3c_u3
      ;
      (FRF (F11_N N3), FRS (S13_Su Su4c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su4c_u3
      ;
      (FRF (F11_N N3), FRS (S13_Su Su5c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su5c_u3
      ;
      (FRF (F11_N N3), FRS (S13_Su Su6c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su6c_u3
      ;
      (FRF (F11_N N4), FRS (S13_Su Su1c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su1c_u1
      ;
      (FRF (F11_N N4), FRS (S13_Su Su2c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su2c_u1
      ;
      (FRF (F11_N N4), FRS (S13_Su Su3c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su3c_u1
      ;
      (FRF (F11_N N4), FRS (S13_Su Su4c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su4c_u1
      ;
      (FRF (F11_N N4), FRS (S13_Su Su5c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su5c_u1
      ;
      (FRF (F11_N N4), FRS (S13_Su Su6c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su6c_u1
      ;
      (FRF (F11_N N4), FRS (S13_Su Su1c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su1c_u2
      ;
      (FRF (F11_N N4), FRS (S13_Su Su2c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su2c_u2
      ;
      (FRF (F11_N N4), FRS (S13_Su Su3c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su3c_u2
      ;
      (FRF (F11_N N4), FRS (S13_Su Su4c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su4c_u2
      ;
      (FRF (F11_N N4), FRS (S13_Su Su5c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su5c_u2
      ;
      (FRF (F11_N N4), FRS (S13_Su Su6c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su6c_u2
      ;
      (FRF (F11_N N4), FRS (S13_Su Su1c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su1c_u3
      ;
      (FRF (F11_N N4), FRS (S13_Su Su2c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su2c_u3
      ;
      (FRF (F11_N N4), FRS (S13_Su Su3c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su3c_u3
      ;
      (FRF (F11_N N4), FRS (S13_Su Su4c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su4c_u3
      ;
      (FRF (F11_N N4), FRS (S13_Su Su5c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su5c_u3
      ;
      (FRF (F11_N N4), FRS (S13_Su Su6c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su6c_u3
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv1c_nu1
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv2c_nu1
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv3c_nu1
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv1c_nu2
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv2c_nu2
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv3c_nu2
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv1c_nu3
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv2c_nu3
      ;
      (FRF (F11_N N1), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sv3c_nu3
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv1c_nu1
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv2c_nu1
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv3c_nu1
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv1c_nu2
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv2c_nu2
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv3c_nu2
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv1c_nu3
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv2c_nu3
      ;
      (FRF (F11_N N2), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sv3c_nu3
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv1c_nu1
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv2c_nu1
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv3c_nu1
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv1c_nu2
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv2c_nu2
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv3c_nu2
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv1c_nu3
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv2c_nu3
      ;
      (FRF (F11_N N3), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sv3c_nu3
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv1c_nu1
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv2c_nu1
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv3c_nu1
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv1c_nu2
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv2c_nu2
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv3c_nu2
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv1c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv1c_nu3
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv2c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv2c_nu3
      ;
      (FRF (F11_N N4), FRS (S11_Sv Sv3c), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sv3c_nu3
      ;
      (FRF (F12_C C1bar), FRS (S3_Hm Hm2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_hm2_n1
      ;
      (FRF (F12_C C1bar), FRS (S3_Hm Hm2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_hm2_n2
      ;
      (FRF (F12_C C1bar), FRS (S3_Hm Hm2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_hm2_n3
      ;
      (FRF (F12_C C1bar), FRS (S3_Hm Hm2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_hm2_n4
      ;
      (FRF (F12_C C2bar), FRS (S3_Hm Hm2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_hm2_n1
      ;
      (FRF (F12_C C2bar), FRS (S3_Hm Hm2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_hm2_n2
      ;
      (FRF (F12_C C2bar), FRS (S3_Hm Hm2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_hm2_n3
      ;
      (FRF (F12_C C2bar), FRS (S3_Hm Hm2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_hm2_n4
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd1_n1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd2_n1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd3_n1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd4_n1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd5_n1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd6_n1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd1_n2
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd2_n2
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd3_n2
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd4_n2
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd5_n2
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd6_n2
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd1_n3
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd2_n3
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd3_n3
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd4_n3
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd5_n3
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd6_n3
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd1_n4
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd2_n4
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd3_n4
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd4_n4
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd5_n4
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd6_n4
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd1_n1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd2_n1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd3_n1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd4_n1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd5_n1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd6_n1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd1_n2
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd2_n2
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd3_n2
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd4_n2
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd5_n2
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd6_n2
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd1_n3
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd2_n3
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd3_n3
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd4_n3
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd5_n3
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd6_n3
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd1_n4
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd2_n4
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd3_n4
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd4_n4
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd5_n4
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd6_n4
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd1_n1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd2_n1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd3_n1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd4_n1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd5_n1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd6_n1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd1_n2
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd2_n2
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd3_n2
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd4_n2
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd5_n2
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd6_n2
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd1_n3
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd2_n3
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd3_n3
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd4_n3
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd5_n3
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd6_n3
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd1_n4
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd2_n4
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd3_n4
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd4_n4
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd5_n4
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd6_n4
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se1_n1
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se2_n1
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se3_n1
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se4_n1
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se5_n1
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se6_n1
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se1_n2
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se2_n2
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se3_n2
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se4_n2
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se5_n2
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se6_n2
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se1_n3
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se2_n3
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se3_n3
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se4_n3
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se5_n3
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se6_n3
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se1_n4
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se2_n4
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se3_n4
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se4_n4
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se5_n4
      ;
      (FRF (F2_E E1bar), FRS (S12_Se Se6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_se6_n4
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se1_n1
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se2_n1
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se3_n1
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se4_n1
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se5_n1
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se6_n1
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se1_n2
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se2_n2
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se3_n2
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se4_n2
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se5_n2
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se6_n2
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se1_n3
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se2_n3
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se3_n3
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se4_n3
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se5_n3
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se6_n3
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se1_n4
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se2_n4
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se3_n4
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se4_n4
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se5_n4
      ;
      (FRF (F2_E E2bar), FRS (S12_Se Se6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_se6_n4
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se1_n1
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se2_n1
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se3_n1
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se4_n1
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se5_n1
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se6_n1
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se1_n2
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se2_n2
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se3_n2
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se4_n2
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se5_n2
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se6_n2
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se1_n3
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se2_n3
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se3_n3
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se4_n3
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se5_n3
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se6_n3
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se1_n4
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se2_n4
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se3_n4
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se4_n4
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se5_n4
      ;
      (FRF (F2_E E3bar), FRS (S12_Se Se6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_se6_n4
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su1_n1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su2_n1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su3_n1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su4_n1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su5_n1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su6_n1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su1_n2
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su2_n2
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su3_n2
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su4_n2
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su5_n2
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su6_n2
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su1_n3
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su2_n3
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su3_n3
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su4_n3
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su5_n3
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su6_n3
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su1_n4
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su2_n4
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su3_n4
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su4_n4
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su5_n4
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su6_n4
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su1_n1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su2_n1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su3_n1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su4_n1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su5_n1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su6_n1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su1_n2
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su2_n2
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su3_n2
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su4_n2
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su5_n2
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su6_n2
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su1_n3
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su2_n3
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su3_n3
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su4_n3
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su5_n3
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su6_n3
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su1_n4
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su2_n4
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su3_n4
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su4_n4
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su5_n4
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su6_n4
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su1_n1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su2_n1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su3_n1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su4), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su4_n1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su5), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su5_n1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su6), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su6_n1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su1_n2
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su2_n2
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su3_n2
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su4), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su4_n2
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su5), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su5_n2
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su6), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su6_n2
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su1_n3
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su2_n3
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su3_n3
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su4), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su4_n3
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su5), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su5_n3
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su6), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su6_n3
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su1_n4
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su2_n4
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su3_n4
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su4), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su4_n4
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su5), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su5_n4
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su6), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su6_n4
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv1_n1
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv2_n1
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv3_n1
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv1_n2
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv2_n2
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv3_n2
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv1_n3
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv2_n3
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv3_n3
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv1_n4
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv2_n4
      ;
      (FRF (F1_Nu Nu1bar), FRS (S11_Sv Sv3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_sv3_n4
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv1_n1
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv2_n1
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv3_n1
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv1_n2
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv2_n2
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv3_n2
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv1_n3
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv2_n3
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv3_n3
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv1_n4
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv2_n4
      ;
      (FRF (F1_Nu Nu2bar), FRS (S11_Sv Sv3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_sv3_n4
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv1_n1
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv2), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv2_n1
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv3), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv3_n1
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv1_n2
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv2), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv2_n2
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv3), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv3_n2
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv1_n3
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv2), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv2_n3
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv3), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv3_n3
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv1_n4
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv2), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv2_n4
      ;
      (FRF (F1_Nu Nu3bar), FRS (S11_Sv Sv3), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_sv3_n4
      ;
      (FRF (F4_D D1bar), FRS (S1_H H1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h1_d1
      ;
      (FRF (F4_D D1bar), FRS (S1_H H2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h2_d1
      ;
      (FRF (F4_D D1bar), FRS (S1_H H1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h1_d2
      ;
      (FRF (F4_D D1bar), FRS (S1_H H2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h2_d2
      ;
      (FRF (F4_D D1bar), FRS (S1_H H1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h1_d3
      ;
      (FRF (F4_D D1bar), FRS (S1_H H2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_h2_d3
      ;
      (FRF (F4_D D2bar), FRS (S1_H H1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h1_d1
      ;
      (FRF (F4_D D2bar), FRS (S1_H H2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h2_d1
      ;
      (FRF (F4_D D2bar), FRS (S1_H H1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h1_d2
      ;
      (FRF (F4_D D2bar), FRS (S1_H H2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h2_d2
      ;
      (FRF (F4_D D2bar), FRS (S1_H H1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h1_d3
      ;
      (FRF (F4_D D2bar), FRS (S1_H H2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_h2_d3
      ;
      (FRF (F4_D D3bar), FRS (S1_H H1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h1_d1
      ;
      (FRF (F4_D D3bar), FRS (S1_H H2), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h2_d1
      ;
      (FRF (F4_D D3bar), FRS (S1_H H1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h1_d2
      ;
      (FRF (F4_D D3bar), FRS (S1_H H2), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h2_d2
      ;
      (FRF (F4_D D3bar), FRS (S1_H H1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h1_d3
      ;
      (FRF (F4_D D3bar), FRS (S1_H H2), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_h2_d3
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su1c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su1c_d1
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su2c_d1
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su3c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su3c_d1
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su4c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su4c_d1
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su5c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su5c_d1
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su6c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su6c_d1
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su1c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su1c_d2
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su2c_d2
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su3c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su3c_d2
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su4c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su4c_d2
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su5c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su5c_d2
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su6c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su6c_d2
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su1c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su1c_d3
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su2c_d3
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su3c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su3c_d3
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su4c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su4c_d3
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su5c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su5c_d3
      ;
      (FRF (F12_C C1bar), FRS (S13_Su Su6c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_su6c_d3
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su1c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su1c_d1
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su2c_d1
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su3c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su3c_d1
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su4c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su4c_d1
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su5c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su5c_d1
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su6c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su6c_d1
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su1c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su1c_d2
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su2c_d2
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su3c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su3c_d2
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su4c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su4c_d2
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su5c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su5c_d2
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su6c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su6c_d2
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su1c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su1c_d3
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su2c_d3
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su3c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su3c_d3
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su4c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su4c_d3
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su5c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su5c_d3
      ;
      (FRF (F12_C C2bar), FRS (S13_Su Su6c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_su6c_d3
      ;
      (FRF (F3_U U1bar), FRS (S3_Hm Hm2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_hm2c_d1
      ;
      (FRF (F3_U U1bar), FRS (S3_Hm Hm2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_hm2c_d2
      ;
      (FRF (F3_U U1bar), FRS (S3_Hm Hm2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_hm2c_d3
      ;
      (FRF (F3_U U2bar), FRS (S3_Hm Hm2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_hm2c_d1
      ;
      (FRF (F3_U U2bar), FRS (S3_Hm Hm2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_hm2c_d2
      ;
      (FRF (F3_U U2bar), FRS (S3_Hm Hm2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_hm2c_d3
      ;
      (FRF (F3_U U3bar), FRS (S3_Hm Hm2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_hm2c_d1
      ;
      (FRF (F3_U U3bar), FRS (S3_Hm Hm2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_hm2c_d2
      ;
      (FRF (F3_U U3bar), FRS (S3_Hm Hm2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_hm2c_d3
      ;
      (FRF (F2_E E1bar), FRS (S1_H H1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h1_e1
      ;
      (FRF (F2_E E1bar), FRS (S1_H H2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h2_e1
      ;
      (FRF (F2_E E1bar), FRS (S1_H H1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h1_e2
      ;
      (FRF (F2_E E1bar), FRS (S1_H H2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h2_e2
      ;
      (FRF (F2_E E1bar), FRS (S1_H H1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h1_e3
      ;
      (FRF (F2_E E1bar), FRS (S1_H H2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e1bar_h2_e3
      ;
      (FRF (F2_E E2bar), FRS (S1_H H1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h1_e1
      ;
      (FRF (F2_E E2bar), FRS (S1_H H2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h2_e1
      ;
      (FRF (F2_E E2bar), FRS (S1_H H1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h1_e2
      ;
      (FRF (F2_E E2bar), FRS (S1_H H2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h2_e2
      ;
      (FRF (F2_E E2bar), FRS (S1_H H1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h1_e3
      ;
      (FRF (F2_E E2bar), FRS (S1_H H2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e2bar_h2_e3
      ;
      (FRF (F2_E E3bar), FRS (S1_H H1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h1_e1
      ;
      (FRF (F2_E E3bar), FRS (S1_H H2), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h2_e1
      ;
      (FRF (F2_E E3bar), FRS (S1_H H1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h1_e2
      ;
      (FRF (F2_E E3bar), FRS (S1_H H2), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h2_e2
      ;
      (FRF (F2_E E3bar), FRS (S1_H H1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h1_e3
      ;
      (FRF (F2_E E3bar), FRS (S1_H H2), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_e3bar_h2_e3
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv1c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv1c_e1
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv2c_e1
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv3c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv3c_e1
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv1c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv1c_e2
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv2c_e2
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv3c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv3c_e2
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv1c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv1c_e3
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv2c_e3
      ;
      (FRF (F12_C C1bar), FRS (S11_Sv Sv3c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c1bar_sv3c_e3
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv1c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv1c_e1
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv2c_e1
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv3c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv3c_e1
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv1c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv1c_e2
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv2c_e2
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv3c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv3c_e2
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv1c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv1c_e3
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv2c_e3
      ;
      (FRF (F12_C C2bar), FRS (S11_Sv Sv3c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_c2bar_sv3c_e3
      ;
      (FRF (F1_Nu Nu1bar), FRS (S3_Hm Hm2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_hm2c_e1
      ;
      (FRF (F1_Nu Nu1bar), FRS (S3_Hm Hm2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_hm2c_e2
      ;
      (FRF (F1_Nu Nu1bar), FRS (S3_Hm Hm2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu1bar_hm2c_e3
      ;
      (FRF (F1_Nu Nu2bar), FRS (S3_Hm Hm2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_hm2c_e1
      ;
      (FRF (F1_Nu Nu2bar), FRS (S3_Hm Hm2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_hm2c_e2
      ;
      (FRF (F1_Nu Nu2bar), FRS (S3_Hm Hm2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu2bar_hm2c_e3
      ;
      (FRF (F1_Nu Nu3bar), FRS (S3_Hm Hm2c), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_hm2c_e1
      ;
      (FRF (F1_Nu Nu3bar), FRS (S3_Hm Hm2c), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_hm2c_e2
      ;
      (FRF (F1_Nu Nu3bar), FRS (S3_Hm Hm2c), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_nu3bar_hm2c_e3
      ;
      (FRF (F3_U U1bar), FRS (S1_H H1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h1_u1
      ;
      (FRF (F3_U U1bar), FRS (S1_H H2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h2_u1
      ;
      (FRF (F3_U U1bar), FRS (S1_H H1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h1_u2
      ;
      (FRF (F3_U U1bar), FRS (S1_H H2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h2_u2
      ;
      (FRF (F3_U U1bar), FRS (S1_H H1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h1_u3
      ;
      (FRF (F3_U U1bar), FRS (S1_H H2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_h2_u3
      ;
      (FRF (F3_U U2bar), FRS (S1_H H1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h1_u1
      ;
      (FRF (F3_U U2bar), FRS (S1_H H2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h2_u1
      ;
      (FRF (F3_U U2bar), FRS (S1_H H1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h1_u2
      ;
      (FRF (F3_U U2bar), FRS (S1_H H2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h2_u2
      ;
      (FRF (F3_U U2bar), FRS (S1_H H1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h1_u3
      ;
      (FRF (F3_U U2bar), FRS (S1_H H2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_h2_u3
      ;
      (FRF (F3_U U3bar), FRS (S1_H H1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h1_u1
      ;
      (FRF (F3_U U3bar), FRS (S1_H H2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h2_u1
      ;
      (FRF (F3_U U3bar), FRS (S1_H H1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h1_u2
      ;
      (FRF (F3_U U3bar), FRS (S1_H H2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h2_u2
      ;
      (FRF (F3_U U3bar), FRS (S1_H H1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h1_u3
      ;
      (FRF (F3_U U3bar), FRS (S1_H H2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_h2_u3
      ;
      (FRF (F4_D D1bar), FRS (S3_Hm Hm2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_hm2_u1
      ;
      (FRF (F4_D D1bar), FRS (S3_Hm Hm2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_hm2_u2
      ;
      (FRF (F4_D D1bar), FRS (S3_Hm Hm2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_hm2_u3
      ;
      (FRF (F4_D D2bar), FRS (S3_Hm Hm2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_hm2_u1
      ;
      (FRF (F4_D D2bar), FRS (S3_Hm Hm2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_hm2_u2
      ;
      (FRF (F4_D D2bar), FRS (S3_Hm Hm2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_hm2_u3
      ;
      (FRF (F4_D D3bar), FRS (S3_Hm Hm2), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_hm2_u1
      ;
      (FRF (F4_D D3bar), FRS (S3_Hm Hm2), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_hm2_u2
      ;
      (FRF (F4_D D3bar), FRS (S3_Hm Hm2), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_hm2_u3
      ;
      (FRF (F2_E E1bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e1bar_hm2_nu1
      ;
      (FRF (F2_E E1bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e1bar_hm2_nu2
      ;
      (FRF (F2_E E1bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e1bar_hm2_nu3
      ;
      (FRF (F2_E E2bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e2bar_hm2_nu1
      ;
      (FRF (F2_E E2bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e2bar_hm2_nu2
      ;
      (FRF (F2_E E2bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e2bar_hm2_nu3
      ;
      (FRF (F2_E E3bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e3bar_hm2_nu1
      ;
      (FRF (F2_E E3bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e3bar_hm2_nu2
      ;
      (FRF (F2_E E3bar), FRS (S3_Hm Hm2), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e3bar_hm2_nu3
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd1), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd1_u1bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd2), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd2_u1bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd3), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd3_u1bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd4), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd4_u1bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd5), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd5_u1bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd6), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd6_u1bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd1), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd1_u2bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd2), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd2_u2bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd3), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd3_u2bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd4), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd4_u2bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd5), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd5_u2bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd6), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd6_u2bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd1), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd1_u3bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd2), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd2_u3bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd3), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd3_u3bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd4), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd4_u3bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd5), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd5_u3bar
      ;
      (FRF (F12_C C1bar), FRS (S14_Sd Sd6), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c1bar_sd6_u3bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd1), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd1_u1bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd2), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd2_u1bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd3), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd3_u1bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd4), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd4_u1bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd5), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd5_u1bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd6), FRF (F3_U U1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd6_u1bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd1), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd1_u2bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd2), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd2_u2bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd3), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd3_u2bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd4), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd4_u2bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd5), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd5_u2bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd6), FRF (F3_U U2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd6_u2bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd1), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd1_u3bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd2), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd2_u3bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd3), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd3_u3bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd4), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd4_u3bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd5), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd5_u3bar
      ;
      (FRF (F12_C C2bar), FRS (S14_Sd Sd6), FRF (F3_U U3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_c2bar_sd6_u3bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se1), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se1_nu1bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se2), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se2_nu1bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se3), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se3_nu1bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se4), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se4_nu1bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se5), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se5_nu1bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se6), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se6_nu1bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se1), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se1_nu2bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se2), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se2_nu2bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se3), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se3_nu2bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se4), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se4_nu2bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se5), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se5_nu2bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se6), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se6_nu2bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se1), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se1_nu3bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se2), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se2_nu3bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se3), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se3_nu3bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se4), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se4_nu3bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se5), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se5_nu3bar
      ;
      (FRF (F12_C C1bar), FRS (S12_Se Se6), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c1bar_se6_nu3bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se1), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se1_nu1bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se2), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se2_nu1bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se3), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se3_nu1bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se4), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se4_nu1bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se5), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se5_nu1bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se6), FRF (F1_Nu Nu1bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se6_nu1bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se1), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se1_nu2bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se2), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se2_nu2bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se3), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se3_nu2bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se4), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se4_nu2bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se5), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se5_nu2bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se6), FRF (F1_Nu Nu2bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se6_nu2bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se1), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se1_nu3bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se2), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se2_nu3bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se3), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se3_nu3bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se4), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se4_nu3bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se5), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se5_nu3bar
      ;
      (FRF (F12_C C2bar), FRS (S12_Se Se6), FRF (F1_Nu Nu3bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SL, Coupling.Psibar),
       G_c2bar_se6_nu3bar
      ;
      (FRF (F11_N N1), FRV (V3_Wm Wmc), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n1_wmc_c1
      ;
      (FRF (F11_N N1), FRV (V3_Wm Wmc), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n1_wmc_c2
      ;
      (FRF (F11_N N2), FRV (V3_Wm Wmc), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n2_wmc_c1
      ;
      (FRF (F11_N N2), FRV (V3_Wm Wmc), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n2_wmc_c2
      ;
      (FRF (F11_N N3), FRV (V3_Wm Wmc), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n3_wmc_c1
      ;
      (FRF (F11_N N3), FRV (V3_Wm Wmc), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n3_wmc_c2
      ;
      (FRF (F11_N N4), FRV (V3_Wm Wmc), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n4_wmc_c1
      ;
      (FRF (F11_N N4), FRV (V3_Wm Wmc), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n4_wmc_c2
      ;
      (FRF (F12_C C1bar), FRV (V1_A A_1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c1bar_a_1_c1
      ;
      (FRF (F12_C C1bar), FRV (V1_A A_1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c1bar_a_1_c2
      ;
      (FRF (F12_C C2bar), FRV (V1_A A_1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c2bar_a_1_c1
      ;
      (FRF (F12_C C2bar), FRV (V1_A A_1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c2bar_a_1_c2
      ;
      (FRF (F12_C C1bar), FRV (V2_Z Z_1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c1bar_z_1_c1
      ;
      (FRF (F12_C C1bar), FRV (V2_Z Z_1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c1bar_z_1_c2
      ;
      (FRF (F12_C C2bar), FRV (V2_Z Z_1), FRF (F12_C C1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c2bar_z_1_c1
      ;
      (FRF (F12_C C2bar), FRV (V2_Z Z_1), FRF (F12_C C2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_c2bar_z_1_c2
      ;
      (FRF (F11_N N1), FRV (V2_Z Z_1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n1
      ;
      (FRF (F11_N N1), FRV (V2_Z Z_1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n2
      ;
      (FRF (F11_N N1), FRV (V2_Z Z_1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n3
      ;
      (FRF (F11_N N1), FRV (V2_Z Z_1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n4
      ;
      (FRF (F11_N N2), FRV (V2_Z Z_1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n2_z_1_n2
      ;
      (FRF (F11_N N2), FRV (V2_Z Z_1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n2_z_1_n3
      ;
      (FRF (F11_N N2), FRV (V2_Z Z_1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n2_z_1_n4
      ;
      (FRF (F11_N N3), FRV (V2_Z Z_1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n3_z_1_n3
      ;
      (FRF (F11_N N3), FRV (V2_Z Z_1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n3_z_1_n4
      ;
      (FRF (F11_N N4), FRV (V2_Z Z_1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n4_z_1_n4
      ;
      (FRF (F12_C C1bar), FRV (V3_Wm Wm_1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c1bar_wm_1_n1
      ;
      (FRF (F12_C C1bar), FRV (V3_Wm Wm_1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c1bar_wm_1_n2
      ;
      (FRF (F12_C C1bar), FRV (V3_Wm Wm_1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c1bar_wm_1_n3
      ;
      (FRF (F12_C C1bar), FRV (V3_Wm Wm_1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c1bar_wm_1_n4
      ;
      (FRF (F12_C C2bar), FRV (V3_Wm Wm_1), FRF (F11_N N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c2bar_wm_1_n1
      ;
      (FRF (F12_C C2bar), FRV (V3_Wm Wm_1), FRF (F11_N N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c2bar_wm_1_n2
      ;
      (FRF (F12_C C2bar), FRV (V3_Wm Wm_1), FRF (F11_N N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c2bar_wm_1_n3
      ;
      (FRF (F12_C C2bar), FRV (V3_Wm Wm_1), FRF (F11_N N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_c2bar_wm_1_n4
      ;
      (FRF (F4_D D1bar), FRV (V1_A A_1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_a_1_d1
      ;
      (FRF (F4_D D2bar), FRV (V1_A A_1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_a_1_d1
      ;
      (FRF (F4_D D3bar), FRV (V1_A A_1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_a_1_d1
      ;
      (FRF (F4_D D1bar), FRV (V2_Z Z_1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_z_1_d1
      ;
      (FRF (F4_D D2bar), FRV (V2_Z Z_1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_z_1_d1
      ;
      (FRF (F4_D D3bar), FRV (V2_Z Z_1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_z_1_d1
      ;
      (FRF (F3_U U1bar), FRV (V3_Wm Wmc), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u1bar_wmc_d1
      ;
      (FRF (F3_U U1bar), FRV (V3_Wm Wmc), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u1bar_wmc_d2
      ;
      (FRF (F3_U U1bar), FRV (V3_Wm Wmc), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u1bar_wmc_d3
      ;
      (FRF (F3_U U2bar), FRV (V3_Wm Wmc), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u2bar_wmc_d1
      ;
      (FRF (F3_U U2bar), FRV (V3_Wm Wmc), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u2bar_wmc_d2
      ;
      (FRF (F3_U U2bar), FRV (V3_Wm Wmc), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u2bar_wmc_d3
      ;
      (FRF (F3_U U3bar), FRV (V3_Wm Wmc), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u3bar_wmc_d1
      ;
      (FRF (F3_U U3bar), FRV (V3_Wm Wmc), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u3bar_wmc_d2
      ;
      (FRF (F3_U U3bar), FRV (V3_Wm Wmc), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_u3bar_wmc_d3
      ;
      (FRF (F2_E E1bar), FRV (V1_A A_1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_a_1_e1
      ;
      (FRF (F2_E E2bar), FRV (V1_A A_1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_a_1_e1
      ;
      (FRF (F2_E E3bar), FRV (V1_A A_1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_a_1_e1
      ;
      (FRF (F2_E E1bar), FRV (V2_Z Z_1), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_z_1_e1
      ;
      (FRF (F2_E E2bar), FRV (V2_Z Z_1), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_z_1_e1
      ;
      (FRF (F2_E E3bar), FRV (V2_Z Z_1), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e1bar_z_1_e1
      ;
      (FRF (F1_Nu Nu1bar), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu1bar_wmc_e1
      ;
      (FRF (F1_Nu Nu1bar), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu1bar_wmc_e2
      ;
      (FRF (F1_Nu Nu1bar), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu1bar_wmc_e3
      ;
      (FRF (F1_Nu Nu2bar), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu2bar_wmc_e1
      ;
      (FRF (F1_Nu Nu2bar), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu2bar_wmc_e2
      ;
      (FRF (F1_Nu Nu2bar), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu2bar_wmc_e3
      ;
      (FRF (F1_Nu Nu3bar), FRV (V3_Wm Wmc), FRF (F2_E E1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu3bar_wmc_e1
      ;
      (FRF (F1_Nu Nu3bar), FRV (V3_Wm Wmc), FRF (F2_E E2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu3bar_wmc_e2
      ;
      (FRF (F1_Nu Nu3bar), FRV (V3_Wm Wmc), FRF (F2_E E3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu3bar_wmc_e3
      ;
      (FRF (F3_U U1bar), FRV (V1_A A_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_a_1_u1
      ;
      (FRF (F3_U U2bar), FRV (V1_A A_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_a_1_u1
      ;
      (FRF (F3_U U3bar), FRV (V1_A A_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_a_1_u1
      ;
      (FRF (F4_D D1bar), FRV (V3_Wm Wm_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d1bar_wm_1_u1
      ;
      (FRF (F4_D D1bar), FRV (V3_Wm Wm_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d1bar_wm_1_u2
      ;
      (FRF (F4_D D1bar), FRV (V3_Wm Wm_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d1bar_wm_1_u3
      ;
      (FRF (F4_D D2bar), FRV (V3_Wm Wm_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d2bar_wm_1_u1
      ;
      (FRF (F4_D D2bar), FRV (V3_Wm Wm_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d2bar_wm_1_u2
      ;
      (FRF (F4_D D2bar), FRV (V3_Wm Wm_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d2bar_wm_1_u3
      ;
      (FRF (F4_D D3bar), FRV (V3_Wm Wm_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d3bar_wm_1_u1
      ;
      (FRF (F4_D D3bar), FRV (V3_Wm Wm_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d3bar_wm_1_u2
      ;
      (FRF (F4_D D3bar), FRV (V3_Wm Wm_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_d3bar_wm_1_u3
      ;
      (FRF (F3_U U1bar), FRV (V2_Z Z_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_z_1_u1
      ;
      (FRF (F3_U U2bar), FRV (V2_Z Z_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_z_1_u1
      ;
      (FRF (F3_U U3bar), FRV (V2_Z Z_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u1bar_z_1_u1
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e1bar_wm_1_nu1
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e1bar_wm_1_nu2
      ;
      (FRF (F2_E E1bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e1bar_wm_1_nu3
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e2bar_wm_1_nu1
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e2bar_wm_1_nu2
      ;
      (FRF (F2_E E2bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e2bar_wm_1_nu3
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e3bar_wm_1_nu1
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e3bar_wm_1_nu2
      ;
      (FRF (F2_E E3bar), FRV (V3_Wm Wm_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_e3bar_wm_1_nu3
      ;
      (FRF (F1_Nu Nu1bar), FRV (V2_Z Z_1), FRF (F1_Nu Nu1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu1bar_z_1_nu1
      ;
      (FRF (F1_Nu Nu2bar), FRV (V2_Z Z_1), FRF (F1_Nu Nu2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu1bar_z_1_nu1
      ;
      (FRF (F1_Nu Nu3bar), FRV (V2_Z Z_1), FRF (F1_Nu Nu3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VR, Coupling.Psi),
       G_nu1bar_z_1_nu1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Gauge_Gauge_Gauge 1,
       G_wmc_a_1_wm_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Gauge_Gauge_Gauge 1,
       G_wmc_wm_1_z_1
   ]

   let vertices_3_qcd = [
      (FRV (V5_G G_1), FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S13_Su Su1), FRS (S13_Su Su1c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S13_Su Su2), FRS (S13_Su Su2c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S13_Su Su3), FRS (S13_Su Su3c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S13_Su Su4), FRS (S13_Su Su4c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S13_Su Su5), FRS (S13_Su Su5c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRV (V5_G G_1), FRS (S13_Su Su6), FRS (S13_Su Su6c)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1c
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd1c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd1c_d1
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd2c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd2c_d1
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd3c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd3c_d1
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd4c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd4c_d1
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd5c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd5c_d1
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd6c), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd6c_d1
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd1c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd1c_d2
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd2c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd2c_d2
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd3c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd3c_d2
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd4c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd4c_d2
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd5c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd5c_d2
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd6c), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd6c_d2
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd1c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd1c_d3
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd2c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd2c_d3
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd3c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd3c_d3
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd4c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd4c_d3
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd5c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd5c_d3
      ;
      (FRF (F15_Go Go_1), FRS (S14_Sd Sd6c), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd6c_d3
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su1c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su1c_u1
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su2c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su2c_u1
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su3c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su3c_u1
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su4c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su4c_u1
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su5c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su5c_u1
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su6c), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su6c_u1
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su1c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su1c_u2
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su2c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su2c_u2
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su3c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su3c_u2
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su4c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su4c_u2
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su5c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su5c_u2
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su6c), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su6c_u2
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su1c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su1c_u3
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su2c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su2c_u3
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su3c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su3c_u3
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su4c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su4c_u3
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su5c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su5c_u3
      ;
      (FRF (F15_Go Go_1), FRS (S13_Su Su6c), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su6c_u3
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd1), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd1_go_1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd2), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd2_go_1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd3), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd3_go_1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd4), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd4_go_1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd5), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd5_go_1
      ;
      (FRF (F4_D D1bar), FRS (S14_Sd Sd6), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d1bar_sd6_go_1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd1), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd1_go_1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd2), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd2_go_1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd3), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd3_go_1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd4), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd4_go_1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd5), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd5_go_1
      ;
      (FRF (F4_D D2bar), FRS (S14_Sd Sd6), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d2bar_sd6_go_1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd1), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd1_go_1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd2), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd2_go_1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd3), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd3_go_1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd4), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd4_go_1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd5), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd5_go_1
      ;
      (FRF (F4_D D3bar), FRS (S14_Sd Sd6), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_d3bar_sd6_go_1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su1), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su1_go_1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su2), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su2_go_1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su3), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su3_go_1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su4), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su4_go_1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su5), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su5_go_1
      ;
      (FRF (F3_U U1bar), FRS (S13_Su Su6), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u1bar_su6_go_1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su1), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su1_go_1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su2), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su2_go_1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su3), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su3_go_1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su4), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su4_go_1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su5), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su5_go_1
      ;
      (FRF (F3_U U2bar), FRS (S13_Su Su6), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u2bar_su6_go_1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su1), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su1_go_1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su2), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su2_go_1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su3), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su3_go_1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su4), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su4_go_1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su5), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su5_go_1
      ;
      (FRF (F3_U U3bar), FRS (S13_Su Su6), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_u3bar_su6_go_1
      ;
      (FRF (F4_D D1bar), FRV (V5_G G_1), FRF (F4_D D1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F4_D D2bar), FRV (V5_G G_1), FRF (F4_D D2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F4_D D3bar), FRV (V5_G G_1), FRF (F4_D D3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F3_U U1bar), FRV (V5_G G_1), FRF (F3_U U1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F3_U U2bar), FRV (V5_G G_1), FRF (F3_U U2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F3_U U3bar), FRV (V5_G G_1), FRF (F3_U U3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d1bar_g_1_d1
      ;
      (FRF (F15_Go Go_1), FRV (V5_G G_1), FRF (F15_Go Go_1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_go_1_g_1_go_1
      ;
      (FRV (V5_G G_1), FRV (V5_G G_1), FRV (V5_G G_1)),
       Gauge_Gauge_Gauge 1,
       G_g_1_g_1_g_1
   ]

   let vertices_4 = [
      (FRS (S2_Ah Ah2), FRS (S2_Ah Ah2), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_ah2_ah2_wmc_wm_1
      ;
      (FRS (S2_Ah Ah2), FRS (S2_Ah Ah2), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_ah2_ah2_z_1_z_1
      ;
      (FRS (S2_Ah Ah2), FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_ah2_hm2_wmc_a_1
      ;
      (FRS (S2_Ah Ah2), FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_ah2_hm2_wmc_z_1
      ;
      (FRS (S2_Ah Ah2), FRS (S3_Hm Hm2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_ah2_hm2c_a_1_wm_1
      ;
      (FRS (S2_Ah Ah2), FRS (S3_Hm Hm2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_ah2_hm2c_wm_1_z_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h1_h1_wmc_wm_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h1_h2_wmc_wm_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h2_h2_wmc_wm_1
      ;
      (FRS (S1_H H1), FRS (S1_H H1), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_h1_z_1_z_1
      ;
      (FRS (S1_H H1), FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_h2_z_1_z_1
      ;
      (FRS (S1_H H2), FRS (S1_H H2), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h2_h2_z_1_z_1
      ;
      (FRS (S1_H H1), FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_h1_hm2_wmc_a_1
      ;
      (FRS (S1_H H2), FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_h2_hm2_wmc_a_1
      ;
      (FRS (S1_H H1), FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_hm2_wmc_z_1
      ;
      (FRS (S1_H H2), FRS (S3_Hm Hm2), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h2_hm2_wmc_z_1
      ;
      (FRS (S1_H H1), FRS (S3_Hm Hm2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h1_hm2_wmc_a_1
      ;
      (FRS (S1_H H2), FRS (S3_Hm Hm2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_h2_hm2_wmc_a_1
      ;
      (FRS (S1_H H1), FRS (S3_Hm Hm2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h1_hm2_wmc_z_1
      ;
      (FRS (S1_H H2), FRS (S3_Hm Hm2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h2_hm2_wmc_z_1
      ;
      (FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_hm2_hm2c_a_1_a_1
      ;
      (FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_hm2_hm2c_a_1_z_1
      ;
      (FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_hm2_hm2c_wmc_wm_1
      ;
      (FRS (S3_Hm Hm2), FRS (S3_Hm Hm2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_hm2_hm2c_z_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_a_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd2c_a_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd3c_a_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd4c_a_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd5c_a_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd6c_a_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd1c_a_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2c_a_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd3c_a_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd4c_a_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd5c_a_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd6c_a_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd1c_a_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd2c_a_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3c_a_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd4c_a_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd5c_a_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6c_a_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd1c_a_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd2c_a_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd3c_a_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4c_a_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd5c_a_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd6c_a_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd1c_a_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd2c_a_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd3c_a_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd4c_a_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5c_a_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd6c_a_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd1c_a_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd2c_a_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd3c_a_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd4c_a_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd5c_a_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6c_a_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_a_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd2c_a_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd3c_a_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd4c_a_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd5c_a_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd6c_a_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd1c_a_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2c_a_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd3c_a_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd4c_a_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd5c_a_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd6c_a_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd1c_a_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd2c_a_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3c_a_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd4c_a_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd5c_a_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6c_a_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd1c_a_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd2c_a_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd3c_a_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4c_a_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd5c_a_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd6c_a_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd1c_a_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd2c_a_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd3c_a_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd4c_a_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5c_a_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd6c_a_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd1c_a_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd2c_a_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd3c_a_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd4c_a_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd5c_a_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6c_a_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_su1c_wmc_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_su2c_wmc_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_su3c_wmc_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_su4c_wmc_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_su5c_wmc_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_su6c_wmc_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_su1c_wmc_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_su2c_wmc_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_su3c_wmc_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_su4c_wmc_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_su5c_wmc_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_su6c_wmc_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_su1c_wmc_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_su2c_wmc_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_su3c_wmc_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_su4c_wmc_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_su5c_wmc_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_su6c_wmc_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_su1c_wmc_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_su2c_wmc_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_su3c_wmc_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_su4c_wmc_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_su5c_wmc_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_su6c_wmc_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_su1c_wmc_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_su2c_wmc_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_su3c_wmc_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_su4c_wmc_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_su5c_wmc_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_su6c_wmc_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_su1c_wmc_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_su2c_wmc_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_su3c_wmc_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_su4c_wmc_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_su5c_wmc_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_su6c_wmc_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd1_sd2c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd1_sd3c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd1_sd4c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd1_sd5c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd1_sd6c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd2_sd1c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd2_sd3c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd2_sd4c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd2_sd5c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd2_sd6c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd3_sd1c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd3_sd2c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd3_sd4c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd3_sd5c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd4_sd1c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd4_sd2c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd4_sd3c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd4_sd5c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd4_sd6c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd5_sd1c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd5_sd2c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd5_sd3c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd5_sd4c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd5_sd6c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd6_sd1c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd6_sd2c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd6_sd3c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd6_sd4c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd6_sd5c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6c_wmc_wm_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_z_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd2c_z_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd3c_z_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd4c_z_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd5c_z_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd6c_z_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd1c_z_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2c_z_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd3c_z_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd4c_z_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd5c_z_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd6c_z_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd1c_z_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd2c_z_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3c_z_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd4c_z_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd5c_z_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6c_z_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd1c_z_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd2c_z_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd3c_z_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4c_z_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd5c_z_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd6c_z_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd1c_z_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd2c_z_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd3c_z_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd4c_z_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5c_z_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd6c_z_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd1c_z_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd2c_z_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd3c_z_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd4c_z_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd5c_z_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6c_z_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_su1c_wmc_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_su2c_wmc_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_su3c_wmc_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_su4c_wmc_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_su5c_wmc_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_su6c_wmc_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_su1c_wmc_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_su2c_wmc_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_su3c_wmc_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_su4c_wmc_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_su5c_wmc_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_su6c_wmc_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su1c_wmc_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su2c_wmc_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su3c_wmc_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su4c_wmc_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su5c_wmc_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su6c_wmc_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_su1c_wmc_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_su2c_wmc_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_su3c_wmc_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_su4c_wmc_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_su5c_wmc_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_su6c_wmc_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_su1c_wmc_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_su2c_wmc_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_su3c_wmc_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_su4c_wmc_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_su5c_wmc_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_su6c_wmc_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su1c_wmc_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su2c_wmc_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su3c_wmc_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su4c_wmc_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su5c_wmc_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su6c_wmc_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_se1c_a_1_a_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_se2c_a_1_a_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_se3c_a_1_a_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_se4c_a_1_a_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_se5c_a_1_a_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_se6c_a_1_a_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_se1c_a_1_a_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_se2c_a_1_a_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_se3c_a_1_a_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_se4c_a_1_a_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_se5c_a_1_a_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_se6c_a_1_a_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_se1c_a_1_a_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_se2c_a_1_a_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_se3c_a_1_a_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_se4c_a_1_a_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_se5c_a_1_a_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_se6c_a_1_a_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_se1c_a_1_a_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_se2c_a_1_a_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_se3c_a_1_a_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_se4c_a_1_a_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_se5c_a_1_a_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_se6c_a_1_a_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_se1c_a_1_a_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_se2c_a_1_a_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_se3c_a_1_a_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_se4c_a_1_a_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_se5c_a_1_a_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_se6c_a_1_a_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_se1c_a_1_a_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_se2c_a_1_a_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_se3c_a_1_a_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_se4c_a_1_a_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_se5c_a_1_a_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_se6c_a_1_a_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se1c_a_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se2c_a_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se3c_a_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se4c_a_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se5c_a_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se6c_a_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se1c_a_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se2c_a_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se3c_a_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se4c_a_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se5c_a_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se6c_a_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se1c_a_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se2c_a_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se3c_a_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se4c_a_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se5c_a_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se6c_a_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se1c_a_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se2c_a_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se3c_a_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se4c_a_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se5c_a_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se6c_a_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se1c_a_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se2c_a_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se3c_a_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se4c_a_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se5c_a_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se6c_a_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se1c_a_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se2c_a_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se3c_a_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se4c_a_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se5c_a_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se6c_a_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_sv1c_wmc_a_1
      ;
      (FRS (S12_Se Se1), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_sv2c_wmc_a_1
      ;
      (FRS (S12_Se Se1), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se1_sv3c_wmc_a_1
      ;
      (FRS (S12_Se Se2), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_sv1c_wmc_a_1
      ;
      (FRS (S12_Se Se2), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_sv2c_wmc_a_1
      ;
      (FRS (S12_Se Se2), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se2_sv3c_wmc_a_1
      ;
      (FRS (S12_Se Se3), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_sv1c_wmc_a_1
      ;
      (FRS (S12_Se Se3), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_sv2c_wmc_a_1
      ;
      (FRS (S12_Se Se3), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se3_sv3c_wmc_a_1
      ;
      (FRS (S12_Se Se4), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_sv1c_wmc_a_1
      ;
      (FRS (S12_Se Se4), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_sv2c_wmc_a_1
      ;
      (FRS (S12_Se Se4), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se4_sv3c_wmc_a_1
      ;
      (FRS (S12_Se Se5), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_sv1c_wmc_a_1
      ;
      (FRS (S12_Se Se5), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_sv2c_wmc_a_1
      ;
      (FRS (S12_Se Se5), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se5_sv3c_wmc_a_1
      ;
      (FRS (S12_Se Se6), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_sv1c_wmc_a_1
      ;
      (FRS (S12_Se Se6), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_sv2c_wmc_a_1
      ;
      (FRS (S12_Se Se6), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_se6_sv3c_wmc_a_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se1_se1c_wmc_wm_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se1_se2c_wmc_wm_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se1_se3c_wmc_wm_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se1_se4c_wmc_wm_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se1_se5c_wmc_wm_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se1_se6c_wmc_wm_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se2_se1c_wmc_wm_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se2_se2c_wmc_wm_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se2_se3c_wmc_wm_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se2_se4c_wmc_wm_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se2_se5c_wmc_wm_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se2_se6c_wmc_wm_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se3_se1c_wmc_wm_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se3_se2c_wmc_wm_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se3_se3c_wmc_wm_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se3_se4c_wmc_wm_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se3_se5c_wmc_wm_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se3_se6c_wmc_wm_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se4_se1c_wmc_wm_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se4_se2c_wmc_wm_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se4_se3c_wmc_wm_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se4_se4c_wmc_wm_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se4_se5c_wmc_wm_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se4_se6c_wmc_wm_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se5_se1c_wmc_wm_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se5_se2c_wmc_wm_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se5_se3c_wmc_wm_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se5_se4c_wmc_wm_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se5_se5c_wmc_wm_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se5_se6c_wmc_wm_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se6_se1c_wmc_wm_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se6_se2c_wmc_wm_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se6_se3c_wmc_wm_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se6_se4c_wmc_wm_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se6_se5c_wmc_wm_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_se6_se6c_wmc_wm_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se1c_z_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se2c_z_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se3c_z_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se4c_z_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se5c_z_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S12_Se Se6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_se6c_z_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se1c_z_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se2c_z_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se3c_z_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se4c_z_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se5c_z_1_z_1
      ;
      (FRS (S12_Se Se2), FRS (S12_Se Se6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_se6c_z_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se1c_z_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se2c_z_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se3c_z_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se4c_z_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se5c_z_1_z_1
      ;
      (FRS (S12_Se Se3), FRS (S12_Se Se6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_se6c_z_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se1c_z_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se2c_z_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se3c_z_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se4c_z_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se5c_z_1_z_1
      ;
      (FRS (S12_Se Se4), FRS (S12_Se Se6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_se6c_z_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se1c_z_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se2c_z_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se3c_z_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se4c_z_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se5c_z_1_z_1
      ;
      (FRS (S12_Se Se5), FRS (S12_Se Se6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_se6c_z_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se1c_z_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se2c_z_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se3c_z_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se4c_z_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se5c_z_1_z_1
      ;
      (FRS (S12_Se Se6), FRS (S12_Se Se6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_se6c_z_1_z_1
      ;
      (FRS (S12_Se Se1), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_sv1c_wmc_z_1
      ;
      (FRS (S12_Se Se1), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_sv2c_wmc_z_1
      ;
      (FRS (S12_Se Se1), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se1_sv3c_wmc_z_1
      ;
      (FRS (S12_Se Se2), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_sv1c_wmc_z_1
      ;
      (FRS (S12_Se Se2), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_sv2c_wmc_z_1
      ;
      (FRS (S12_Se Se2), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se2_sv3c_wmc_z_1
      ;
      (FRS (S12_Se Se3), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_sv1c_wmc_z_1
      ;
      (FRS (S12_Se Se3), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_sv2c_wmc_z_1
      ;
      (FRS (S12_Se Se3), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se3_sv3c_wmc_z_1
      ;
      (FRS (S12_Se Se4), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_sv1c_wmc_z_1
      ;
      (FRS (S12_Se Se4), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_sv2c_wmc_z_1
      ;
      (FRS (S12_Se Se4), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se4_sv3c_wmc_z_1
      ;
      (FRS (S12_Se Se5), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_sv1c_wmc_z_1
      ;
      (FRS (S12_Se Se5), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_sv2c_wmc_z_1
      ;
      (FRS (S12_Se Se5), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se5_sv3c_wmc_z_1
      ;
      (FRS (S12_Se Se6), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_sv1c_wmc_z_1
      ;
      (FRS (S12_Se Se6), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_sv2c_wmc_z_1
      ;
      (FRS (S12_Se Se6), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_se6_sv3c_wmc_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su1c_a_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su2c_a_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su3c_a_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su4c_a_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su5c_a_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su6c_a_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su1c_a_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su2c_a_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su3c_a_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su4c_a_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su5c_a_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su6c_a_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su1c_a_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su2c_a_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su3c_a_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su4c_a_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su5c_a_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su6c_a_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su1c_a_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su2c_a_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su3c_a_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su4c_a_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su5c_a_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su6c_a_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su1c_a_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su2c_a_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su3c_a_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su4c_a_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su5c_a_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su6c_a_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su1c_a_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su2c_a_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su3c_a_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su4c_a_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su5c_a_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su6c_a_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd1c_a_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd2c_a_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd3c_a_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd4c_a_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd5c_a_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd6c_a_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd1c_a_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd2c_a_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd3c_a_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd4c_a_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd5c_a_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd6c_a_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd1c_a_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd2c_a_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd3c_a_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd4c_a_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd5c_a_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd6c_a_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd1c_a_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd2c_a_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd3c_a_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd4c_a_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd5c_a_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd6c_a_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd1c_a_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd2c_a_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd3c_a_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd4c_a_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd5c_a_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd6c_a_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd1c_a_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd2c_a_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd3c_a_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd4c_a_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd5c_a_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd6c_a_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su1c_a_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su2c_a_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su3c_a_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su4c_a_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su5c_a_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su6c_a_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su1c_a_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su2c_a_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su3c_a_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su4c_a_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su5c_a_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su6c_a_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su1c_a_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su2c_a_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su3c_a_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su4c_a_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su5c_a_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su6c_a_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su1c_a_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su2c_a_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su3c_a_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su4c_a_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su5c_a_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su6c_a_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su1c_a_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su2c_a_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su3c_a_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su4c_a_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su5c_a_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su6c_a_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su1c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su1c_a_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su2c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su2c_a_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su3c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su3c_a_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su4c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su4c_a_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su5c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su5c_a_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su6c), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su6c_a_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_sd1c_wm_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_sd2c_wm_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_sd3c_wm_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_sd4c_wm_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_sd5c_wm_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_sd6c_wm_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_sd1c_wm_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_sd2c_wm_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_sd3c_wm_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_sd4c_wm_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_sd5c_wm_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_sd6c_wm_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_sd1c_wm_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_sd2c_wm_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_sd3c_wm_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_sd4c_wm_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_sd5c_wm_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_sd6c_wm_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_sd1c_wm_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_sd2c_wm_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_sd3c_wm_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_sd4c_wm_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_sd5c_wm_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_sd6c_wm_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_sd1c_wm_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_sd2c_wm_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_sd3c_wm_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_sd4c_wm_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_sd5c_wm_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_sd6c_wm_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_sd1c_wm_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_sd2c_wm_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_sd3c_wm_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_sd4c_wm_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_sd5c_wm_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_sd6c_wm_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_su1c_wmc_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_su2c_wmc_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_su3c_wmc_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_su4c_wmc_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_su5c_wmc_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_su6c_wmc_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_su1c_wmc_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_su2c_wmc_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_su3c_wmc_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_su4c_wmc_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_su5c_wmc_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_su6c_wmc_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_su1c_wmc_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_su2c_wmc_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_su3c_wmc_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_su4c_wmc_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_su5c_wmc_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_su6c_wmc_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_su1c_wmc_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_su2c_wmc_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_su3c_wmc_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_su4c_wmc_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_su5c_wmc_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_su6c_wmc_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_su1c_wmc_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_su2c_wmc_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_su3c_wmc_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_su4c_wmc_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_su5c_wmc_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_su6c_wmc_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_su1c_wmc_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_su2c_wmc_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_su3c_wmc_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_su4c_wmc_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_su5c_wmc_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_su6c_wmc_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su1c_z_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su2c_z_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su3c_z_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su4c_z_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su5c_z_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su6c_z_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su1c_z_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su2c_z_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su3c_z_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su4c_z_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su5c_z_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su6c_z_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su1c_z_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su2c_z_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su3c_z_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su4c_z_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su5c_z_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su6c_z_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su1c_z_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su2c_z_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su3c_z_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su4c_z_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su5c_z_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su6c_z_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su1c_z_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su2c_z_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su3c_z_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su4c_z_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su5c_z_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su6c_z_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su1c_z_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su2c_z_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su3c_z_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su4c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su4c_z_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su5c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su5c_z_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su6c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su6c_z_1_z_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_se1c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_se2c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_se3c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_se4c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_se5c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_se6c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv2_se1c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv2_se2c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv2_se3c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv2_se4c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv2_se5c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv2_se6c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se1c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv3_se1c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se2c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv3_se2c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se3c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv3_se3c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se4c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv3_se4c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se5c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv3_se5c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se6c), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv3_se6c_a_1_wm_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_se1c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_se2c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_se3c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_se4c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_se5c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv1), FRS (S12_Se Se6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_se6c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv2_se1c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv2_se2c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv2_se3c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv2_se4c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv2_se5c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv2), FRS (S12_Se Se6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv2_se6c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se1c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv3_se1c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se2c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv3_se2c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se3c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv3_se3c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se4c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv3_se4c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se5c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv3_se5c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv3), FRS (S12_Se Se6c), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv3_se6c_wm_1_z_1
      ;
      (FRS (S11_Sv Sv1), FRS (S11_Sv Sv1c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1c_wmc_wm_1
      ;
      (FRS (S11_Sv Sv2), FRS (S11_Sv Sv2c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1c_wmc_wm_1
      ;
      (FRS (S11_Sv Sv3), FRS (S11_Sv Sv3c), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1c_wmc_wm_1
      ;
      (FRS (S11_Sv Sv1), FRS (S11_Sv Sv1c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1c_z_1_z_1
      ;
      (FRS (S11_Sv Sv2), FRS (S11_Sv Sv2c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1c_z_1_z_1
      ;
      (FRS (S11_Sv Sv3), FRS (S11_Sv Sv3c), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1c_z_1_z_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V1_A A_1), FRV (V3_Wm Wm_1)),
       Vector4 [1, Coupling.C_12_34; 1, Coupling.C_13_42; -2, Coupling.C_14_23],
       G_wmc_a_1_a_1_wm_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Vector4 [1, Coupling.C_12_34],
       G_wmc_a_1_wm_1_z_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Vector4 [1, Coupling.C_13_42],
       G_wmc_a_1_wm_1_z_1_1
      ;
      (FRV (V3_Wm Wmc), FRV (V1_A A_1), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1)),
       Vector4 [1, Coupling.C_14_23],
       G_wmc_a_1_wm_1_z_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V3_Wm Wm_1)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_wmc_wmc_wm_1_wm_1
      ;
      (FRV (V3_Wm Wmc), FRV (V3_Wm Wm_1), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_wmc_wm_1_z_1_z_1
   ]

   let vertices_4_qcd = [
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd2c_g_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd3c_g_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd4c_g_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd5c_g_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd6c_g_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd1c_g_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2c_g_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd3c_g_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd4c_g_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd5c_g_1_a_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd6c_g_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd1c_g_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd2c_g_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3c_g_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd4c_g_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd5c_g_1_a_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6c_g_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd1c_g_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd2c_g_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd3c_g_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4c_g_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd5c_g_1_a_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd6c_g_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd1c_g_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd2c_g_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd3c_g_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd4c_g_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5c_g_1_a_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd6c_g_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd1c_g_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd2c_g_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd3c_g_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd4c_g_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd5c_g_1_a_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6c_g_1_a_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd2c_g_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd3c_g_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd4c_g_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd5c_g_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd6c_g_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd1c_g_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2c_g_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd3c_g_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd4c_g_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd5c_g_1_z_1
      ;
      (FRS (S14_Sd Sd2), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd6c_g_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd1c_g_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd2c_g_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3c_g_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd4c_g_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd5c_g_1_z_1
      ;
      (FRS (S14_Sd Sd3), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6c_g_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd1c_g_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd2c_g_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd3c_g_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4c_g_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd5c_g_1_z_1
      ;
      (FRS (S14_Sd Sd4), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd6c_g_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd1c_g_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd2c_g_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd3c_g_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd4c_g_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5c_g_1_z_1
      ;
      (FRS (S14_Sd Sd5), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd6c_g_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd1c_g_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd2c_g_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd3c_g_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd4c_g_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd5c_g_1_z_1
      ;
      (FRS (S14_Sd Sd6), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6c_g_1_z_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_su1c_wmc_g_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_su2c_wmc_g_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_su3c_wmc_g_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_su4c_wmc_g_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_su5c_wmc_g_1
      ;
      (FRS (S14_Sd Sd1), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_su6c_wmc_g_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_su1c_wmc_g_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_su2c_wmc_g_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_su3c_wmc_g_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_su4c_wmc_g_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_su5c_wmc_g_1
      ;
      (FRS (S14_Sd Sd2), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_su6c_wmc_g_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_su1c_wmc_g_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_su2c_wmc_g_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_su3c_wmc_g_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_su4c_wmc_g_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_su5c_wmc_g_1
      ;
      (FRS (S14_Sd Sd3), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_su6c_wmc_g_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_su1c_wmc_g_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_su2c_wmc_g_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_su3c_wmc_g_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_su4c_wmc_g_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_su5c_wmc_g_1
      ;
      (FRS (S14_Sd Sd4), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_su6c_wmc_g_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_su1c_wmc_g_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_su2c_wmc_g_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_su3c_wmc_g_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_su4c_wmc_g_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_su5c_wmc_g_1
      ;
      (FRS (S14_Sd Sd5), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_su6c_wmc_g_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su1c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_su1c_wmc_g_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su2c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_su2c_wmc_g_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su3c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_su3c_wmc_g_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su4c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_su4c_wmc_g_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su5c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_su5c_wmc_g_1
      ;
      (FRS (S14_Sd Sd6), FRS (S13_Su Su6c), FRV (V3_Wm Wmc), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_su6c_wmc_g_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V5_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1c_g_1_g_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su1c_g_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su2c_g_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su3c_g_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su4c_g_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su5c_g_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su6c_g_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su1c_g_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su2c_g_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su3c_g_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su4c_g_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su5c_g_1_a_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su6c_g_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su1c_g_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su2c_g_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su3c_g_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su4c_g_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su5c_g_1_a_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su6c_g_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su1c_g_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su2c_g_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su3c_g_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su4c_g_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su5c_g_1_a_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su6c_g_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su1c_g_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su2c_g_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su3c_g_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su4c_g_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su5c_g_1_a_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su6c_g_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su1c_g_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su2c_g_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su3c_g_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su4c_g_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su5c_g_1_a_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su6c_g_1_a_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd1c_g_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd2c_g_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd3c_g_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd4c_g_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd5c_g_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su1_sd6c_g_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd1c_g_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd2c_g_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd3c_g_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd4c_g_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd5c_g_1_wm_1
      ;
      (FRS (S13_Su Su2), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su2_sd6c_g_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd1c_g_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd2c_g_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd3c_g_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd4c_g_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd5c_g_1_wm_1
      ;
      (FRS (S13_Su Su3), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su3_sd6c_g_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd1c_g_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd2c_g_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd3c_g_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd4c_g_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd5c_g_1_wm_1
      ;
      (FRS (S13_Su Su4), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su4_sd6c_g_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd1c_g_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd2c_g_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd3c_g_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd4c_g_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd5c_g_1_wm_1
      ;
      (FRS (S13_Su Su5), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su5_sd6c_g_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd1c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd1c_g_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd2c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd2c_g_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd3c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd3c_g_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd4c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd4c_g_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd5c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd5c_g_1_wm_1
      ;
      (FRS (S13_Su Su6), FRS (S14_Sd Sd6c), FRV (V5_G G_1), FRV (V3_Wm Wm_1)),
       Scalar2_Vector2 1,
       G_su6_sd6c_g_1_wm_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su1c_g_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su2c_g_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su3c_g_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su4c_g_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su5c_g_1_z_1
      ;
      (FRS (S13_Su Su1), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su6c_g_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su1c_g_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su2c_g_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su3c_g_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su4c_g_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su5c_g_1_z_1
      ;
      (FRS (S13_Su Su2), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su6c_g_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su1c_g_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su2c_g_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su3c_g_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su4c_g_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su5c_g_1_z_1
      ;
      (FRS (S13_Su Su3), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su6c_g_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su1c_g_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su2c_g_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su3c_g_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su4c_g_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su5c_g_1_z_1
      ;
      (FRS (S13_Su Su4), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su6c_g_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su1c_g_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su2c_g_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su3c_g_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su4c_g_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su5c_g_1_z_1
      ;
      (FRS (S13_Su Su5), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su6c_g_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su1c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su1c_g_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su2c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su2c_g_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su3c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su3c_g_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su4c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su4c_g_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su5c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su5c_g_1_z_1
      ;
      (FRS (S13_Su Su6), FRS (S13_Su Su6c), FRV (V5_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su6c_g_1_z_1
      ;
      (FRV (V5_G G_1), FRV (V5_G G_1), FRV (V5_G G_1), FRV (V5_G G_1)),
       Vector4 [1, Coupling.C_12_34; -2, Coupling.C_13_42; 1, Coupling.C_14_23],
       G_g_1_g_1_g_1_g_1
   ]

   let vertices_n = []

   let vertices_n_qcd = []

   let vertices () = (
      vertices_3 @ (match Opts.color with true -> vertices_3_qcd | false -> []),
      vertices_4 @ (match Opts.color with true -> vertices_4_qcd | false -> []),
      vertices_n @ (match Opts.color with true -> vertices_n_qcd | false -> [])
   )

   module F = Modeltools.Fusions (struct
      type f = flavor
      type c = constant
      let compare = compare
      let conjugate = conjugate
   end)

   let table = F.of_vertices (vertices ())
   let fuse2 = F.fuse2 table
   let fuse3 = F.fuse3 table
   let fuse = F.fuse table

   (* Charge (stubbed) *)

   module Ch = Charges.Null
   let charges _ = ()

   (* Misc. infrastructure *)

   let options = Options.empty

   let rcs = RCS.parse "mssm_sarah" ["automatically generated model"] {
      RCS.revision = "Revision: Noop";
      RCS.date = "Date: Noop";
      RCS.author = "Author: Mathematica automaton";
      RCS.source = "Source: Noop"
   }

   type flavor_sans_color = flavor
   let flavor_sans_color x = x
   let conjugate_sans_color = conjugate
   let flavor_sans_color_of_string = flavor_of_string
   let flavor_sans_color_to_string = flavor_to_string
   let flavor_sans_color_to_TeX = flavor_to_TeX
   let flavor_sans_color_symbol = flavor_symbol

end
